"use strict";
appControllers
  .controller('settingsPageCtrl', ['$rootScope', '$scope', 'AuthService', '$ionicPopup', '$state', '$ionicHistory', '$timeout', 'UserService', '$ionicPush', '$filter', 's3', 'md5', 'AWSServices', 'ChatFactory2', 'Utils', '$localForage', 'Personalized',
    function ($rootScope, $scope, AuthService, $ionicPopup, $state, $ionicHistory, $timeout, UserService, $ionicPush, $filter, s3, md5, AWSServices, ChatFactory2, Utils, $localForage, Personalized) {
      Utils.clearHistory();

      $scope.privateAccount = window.localStorage.getItem('ownPrivate') || false;

      //This method is going to be deprecated. when a user log in we have to save this data.
      /*UserService.getUserSubscriptionByinstanceId(UserService.get_USERSUBSCRIPTIONINSTANCE_ID()).$promise.then(function success(response) {
        $scope.privateAccount = response.members.privateAccount.value;
      }, function (response) {
      });*/

      $scope.changePrivateAccount = function () {
        UserService.changePrivateAccount(
          {"objectId": window.localStorage.getItem('userSubscriptionInstanceId')}
        ).save().$promise.then(function success(response) {
          $scope.privateAccount = response.result.members.privateAccount.value;
        }, function (response) {
        });
      };

      $scope.logOut = function () {
        var lastSubscriptionInstanceId = UserService.get_USERSUBSCRIPTIONINSTANCE_ID();

        var myPopup = $ionicPopup.alert({
          cssClass: 'alertPopUp',
          template: 'Logout successfully',
          okType: 'button-assertive'
        });
        myPopup.then(function () {
          facebookConnectPlugin.getLoginStatus(function (response) {
            if (response.status == 'connected') {
              facebookConnectPlugin.logout(function () {
                $scope.webUser = "";
              }, function (error) {
                console.error("facebookConnectPlugin.logout", error)
              });
            } else {
            }
          }, function (error) {
            console.error("facebookConnectPlugin.getLoginStatus", error)
          });

          var oldData = window.localStorage.getItem("EndpointArn");
          if (oldData !== null) {
            UserService.deleteDevice()
              .get({"string": oldData}).$promise.then(function success(data) {
            }, function (response) {
            });
          }
          AWSServices.deletePlatformEndpoint(1);
          AuthService.logout();

          ChatFactory2.logout().then(function () {
          }, function () {
          }).finally(function () {
            var tempPers = window.localStorage.getItem('AppsPerzonalized');
            window.localStorage.clear();
            window.localStorage.setItem("AppsPerzonalized", tempPers);
            window.localStorage.setItem("onboardingComplete", "yes");
            localStorage.setItem('lastSubscriptionInstanceId', lastSubscriptionInstanceId.toString());
            $localForage.clear().then( function (clean) {
              console.log("cleared Local Forage"); 
            })
            $rootScope.$broadcast('logout.success');
            $state.go('login', {}, {reload: true});
          });
        });
        $timeout(function () {
          myPopup.close();
        }, 500);
      };

      //check if user use FB for login to stop change password
      $scope.redirectToPassChange = function () {
        facebookConnectPlugin.getLoginStatus(function (response) {
          if (response.status == 'connected') {
            $ionicPopup.alert({
              cssClass: 'popupClass',
              title: $filter('translate')('MENU.FACEBOOK_USER_NO_PASSWORD.TITLE'),
              template: $filter('translate')('MENU.FACEBOOK_USER_NO_PASSWORD.MESSAGE'),
              okType: 'button-assertive',
              okText: $filter('translate')('GLOBAL.OK')
            });
          }
          else {
            $state.go('menu.updatePassword', {}, {reload: true});
          }
        }, function (error) {
          console.error("redirectToPassChange", error)
        });
      };

      //Zone Delete account
      $scope.deleteAccount = function () {
        //Prepare data if needed for s3 management
        var s3Service = new AWS.S3({
          apiVersion: '2006-03-01',
          params: {Bucket: s3.bucket}
        });
        var userSubscriptionInstanceId = md5.createHash(window.localStorage.getItem("userSubscriptionInstanceId"));
        //END Prepare data if needed for s3 management
        $ionicPopup.confirm({
          cssClass: 'alertPopUp',
          title: $filter('translate')('MENU.SETTINGS.DELETE_ACCOUNT.INFO_DELETE'),
          cancelText: $filter('translate')('GLOBAL.NO'),
          okText: $filter('translate')('GLOBAL.YES'),
          okType: 'button-assertive'
        }).then(function (responseConfirm) {
          if (responseConfirm) {
            $ionicPopup.confirm({
              cssClass: 'alertPopUp',
              title: $filter('translate')('MENU.SETTINGS.DELETE_ACCOUNT.CONFIRM_DELETE'),
              cancelText: $filter('translate')('GLOBAL.NO'),
              okText: $filter('translate')('GLOBAL.YES'),
              okType: 'button-assertive'
            }).then(function (responseConfirmInside) {
              if (responseConfirmInside) {
                UserService.deleteUserComplete({"objectId": window.localStorage.getItem("userSubscriptionInstanceId")}).save({},
                  function (deleteUserData) {
                    facebookConnectPlugin.getLoginStatus(function (response) {
                      if (response.status == 'connected') {
                        facebookConnectPlugin.logout(function () {
                          var oldData = window.localStorage.getItem("EndpointArn");
                          if (oldData !== null) {
                            UserService.deleteDevice()
                              .get({"string": oldData}).$promise.then(function success(data) {
                            }, function (response) {
                            });
                            AWSServices.deletePlatformEndpoint(1);
                          }
                          emptyBucket(s3Service, s3, userSubscriptionInstanceId, function () {
                          });
                          AuthService.logout();
                          var tempPers = window.localStorage.getItem('AppsPerzonalized');
                          window.localStorage.clear();
                          window.localStorage.setItem("AppsPerzonalized", tempPers);
                          $localForage.clear().then( function (clean) {
                            console.log("cleared Local Forage"); 
                          })
                          $rootScope.$broadcast('logout.success');
                          $state.go('login', {}, {reload: true});
                        });
                      } else {
                        var oldData = window.localStorage.getItem("EndpointArn");
                        if (oldData !== null) {
                          UserService.deleteDevice()
                            .get({"string": oldData}).$promise.then(function success(data) {
                          }, function (response) {
                          });
                          AWSServices.deletePlatformEndpoint(1);
                        }
                        emptyBucket(s3Service, s3, userSubscriptionInstanceId, function () {
                        });
                        AuthService.logout();
                        var tempPers = window.localStorage.getItem('AppsPerzonalized');
                        window.localStorage.clear();
                        window.localStorage.setItem("AppsPerzonalized", tempPers);
                        $localForage.clear().then( function (clean) {
                          console.log("cleared Local Forage"); 
                        })
                        $rootScope.$broadcast('logout.success');
                        $state.go('login', {}, {reload: true});
                      }
                    });
                  }
                );
              } else {
              }
            })
          } else {
          }
        });
      };

      //function to delete all media from user before delete localstorage but after delete account info
      function emptyBucket(service, bucketData, userId, callback) {
        var params = {
          Bucket: bucketData.bucket,
          Prefix: bucketData.prefix + '/' + userId + '/'
        };

        service.listObjectsV2(params, function (err, dataList) {
          if (err) return callback(err);

          if (dataList.Contents.length == 0) return callback();

          params = {Bucket: bucketData.bucket};
          params.Delete = {Objects: []};

          dataList.Contents.forEach(function (content) {
            params.Delete.Objects.push({Key: content.Key});
          });

          service.deleteObjects(params, function (err, dataDelete) {
            if (err) return callback(err);
            if (dataDelete.Deleted.length == 1000) emptyBucket(service, bucketData, userId, callback);
            else return callback();
          });
        })
      }

      //END function to delete all media from user before delete localstorage but after delete account info
      //End Zone Delete account

      $scope.data = {};
      $scope.data.showButtonsArea = false;
      //zone to show and quit button upload zone
      //todo: remove this function, is not used anymore
      $scope.showButtonArea = function () {
        if ($scope.data.showButtonsArea) {
          var area = document.getElementById("ButtonsAreaRedirect");
          area.className = "";
          $scope.data.showButtonsArea = false;
        } else {
          var area = document.getElementById("ButtonsAreaRedirect");
          area.className = "bounceInUp";
          $scope.data.showButtonsArea = true;
        }

      };
      //END zone to show and quit button upload zone
    }])


  .controller('menuCtrl', ['$rootScope', '$scope', '$ionicSideMenuDelegate', 'SignUpService', 'AuthService', '$state', '$ionicHistory', '$ionicPopup', '$timeout', 'UserServiceFb', '$ionicActionSheet', 'UserService', '$ionicPlatform', '$ionicPush', '$filter', 'permissionValidationService', 'AWSServices', 'ChatFactory2', 'Utils', 'SignInService','$q', '$localForage', 'Push_Notif_Variables', 'Personalized', 's3',
    function ($rootScope, $scope, $ionicSideMenuDelegate, SignUpService, AuthService, $state, $ionicHistory, $ionicPopup, $timeout, UserServiceFb, $ionicActionSheet, UserService, $ionicPlatform, $ionicPush, $filter, permissionValidationService, AWSServices, ChatFactory2, Utils, SignInService,$q, $localForage, Push_Notif_Variables, Personalized, s3) {

      function configWhenLoginSuccess() {
        $scope.menuUsername = UserService.get_USER_NAME();
        $scope.menuUserPhoto = UserService.get_USER_PHOTO();
      }

      configWhenLoginSuccess();

      $rootScope.$on('login.success', function (event) {
        configWhenLoginSuccess();
        setTimeout(function () {
          $scope.$apply();
        }, 10);
      });

      function getfaceBookDatta() {
        //need to know if the user is already logged with her FB account
        $scope.userFace = UserServiceFb.getUser();
      }

      getfaceBookDatta();

      //new menu área BALA
        $scope.showList = {
          first: false,
          second: false,
          third: false,
          fourth: false
        };
        $scope.msgList = {
          first: "NEWS AREA",
          second: "SAVE CLASS",
          third: "FUTURE FEATURE",
          fourth: "FUTURE FEATURE"
        }
        checkPersonalized();
      //new menu área END

      //watches when the side menu is open
      $scope.$watch(function () {
        return $ionicSideMenuDelegate.getOpenRatio();
      },
        function (ratio) {
          if (ratio == 1) {
            $scope.menuUsername = UserService.get_USER_NAME();
            $scope.menuUserPhoto = UserService.get_USER_PHOTO();
            setTimeout(function () {
              $scope.$apply();
            }, 10);
          }
        }
      );

      function configWhenRolePermissionsChange() {
        $scope.isSuperAdmin = UserService.USER_IS_SUPERADMIN();
        $scope.canShowGroupsItem = UserService.USER_IS_SUPERADMIN() || (permissionValidationService.canReadOwnGroups() && permissionValidationService.canReadOthersGroups());
        $scope.isAllowedStatusPost = permissionValidationService.canManageInReviewPosts();
        $scope.isAllowedScanQRCode = permissionValidationService.canScanQRCode();
        $scope.canShowStreamingChannel = permissionValidationService.canAccessToStreamingChannel(); //LuMa Live Streaming
        $scope.isAllowedCampaign = true
      }

      configWhenRolePermissionsChange();

      $rootScope.$on('rolePermissions-changed', function (event) {
        configWhenRolePermissionsChange();
      });


      $scope.typelogin = "";
      //Code to get the Facebook information from localstorage
      $scope.user = UserServiceFb.getUser();
      //console.log("data",window.localStorage.starter_facebook_user);
      /*$ionicPlatform.ready(function () {
        try {
          cordova.getAppVersion(function (version) {
            $scope.appVersion = version;
          });
        } catch (e) {
          console.error("Couldn't get app version");
        }
      });*/
      
      document.addEventListener("deviceready", function() {
          try {
            cordova.getAppVersion(function (version) {
              $scope.appVersion = version;
            });
          } catch (e) {
            console.error("Couldn't get app version");
          }
      });

      //Function to logout from server app
      $scope.logOut = function () {
        var lastSubscriptionInstanceId = UserService.get_USERSUBSCRIPTIONINSTANCE_ID();

        Utils.loading.show();
        /*facebookConnectPlugin.getLoginStatus(function (response) {
          if (response.status == 'connected') {
            facebookConnectPlugin.logout(function () {
              $scope.webUser = "";
            }, function (error) {
              console.error("facebookConnectPlugin.logout", error);
              Utils.loading.hide();
            });
          } else {
          }
        }, function (error) {
          console.error("facebookConnectPlugin.getLoginStatus", error)
        });*/

        var oldData = window.localStorage.getItem("EndpointArn");
        var tempPers = window.localStorage.getItem('AppsPerzonalized');
        window.localStorage.clear();
        window.localStorage.setItem("AppsPerzonalized", tempPers);
        window.localStorage.setItem("onboardingComplete", "yes");
        localStorage.setItem('lastSubscriptionInstanceId', lastSubscriptionInstanceId.toString());
        $localForage.clear().then( function (clean) {
          console.log("cleared Local Forage");
        })
        $rootScope.$broadcast('logout.success');
        $state.go('login', {}, {reload: true});
        /*if (oldData !== null) {
          //oldData=JSON.parse(oldData);
          UserService.deleteDevice().get({"string": oldData}).$promise.then(function success(data) {
            AuthService.logout();
            AWSServices.deletePlatformEndpoint(1);

            ChatFactory2.logout().then(function () {
            }, function () {
            }).finally(function () {
              var tempPers = window.localStorage.getItem('AppsPerzonalized');
              window.localStorage.clear();
              window.localStorage.setItem("AppsPerzonalized", tempPers);
              window.localStorage.setItem("onboardingComplete", "yes");
              localStorage.setItem('lastSubscriptionInstanceId', lastSubscriptionInstanceId.toString());
              $localForage.clear().then( function (clean) {
                console.log("cleared Local Forage"); 
              })
              $rootScope.$broadcast('logout.success');
              $state.go('login', {}, {reload: true});
            });
          }, function (response) {
          });
        } else {
          AuthService.logout();
          AWSServices.deletePlatformEndpoint(1);

          ChatFactory2.logout().then(function () {
          }, function () {
          }).finally(function () {
            var tempPers = window.localStorage.getItem('AppsPerzonalized');
            window.localStorage.clear();
            window.localStorage.setItem("AppsPerzonalized", tempPers);
            window.localStorage.setItem("onboardingComplete", "yes");
            localStorage.setItem('lastSubscriptionInstanceId', lastSubscriptionInstanceId.toString());
            $localForage.clear().then( function (clean) {
              console.log("cleared Local Forage"); 
            })
            $rootScope.$broadcast('logout.success');
            $state.go('login', {}, {reload: true});
          });
        }*/
      };

      $scope.facebookFriends = function () {
        facebookConnectPlugin.getLoginStatus(function (response) {
          if (response.status == 'connected') {
            $state.go('menu.friends', {}, {reload: true});
          } else {
            $ionicPopup.alert({
              cssClass: 'popupClass',
              title: $filter('translate')('MENU.FIND_FACEBOOK_FRIENDS.NO_FB_TITLE'),
              template: $filter('translate')('MENU.FIND_FACEBOOK_FRIENDS.NO_FB'),
              okType: 'button-assertive',
              okText: $filter('translate')('GLOBAL.OK')
            });
          }
        }, function (error) {
        });
      };

      $scope.userdecision = function () {
        var confirmPopUp = $ionicPopup.confirm({
          cssClass: 'popupClass',
          title: $filter('translate')('MENU.SETTINGS.DISABLE_ACCOUNT.DISABLE'),
          template: $filter('translate')('MENU.SETTINGS.DISABLE_ACCOUNT.TEXT'),
          cancelText: $filter('translate')('GLOBAL.CANCEL'),
          okType: 'button-assertive',
          okText: $filter('translate')('GLOBAL.OK')
        });
        confirmPopUp.then(function (res) {
          if (res) {
            facebookConnectPlugin.getLoginStatus(function (response) {
              if (response.status == 'connected') {
                $scope.cancelAccountFb();
              } else {
                $scope.cancelAccount();
              }
            });
          } else {
          }
        });
      };

      $scope.cancelAccountFb = function () {
        //console.log("Entramos a cancelar FB");
        UserService.cancelUserSubscription({"objectId": window.localStorage.getItem("userSubscriptionInstanceId")}).save({}, function (data) {
          $ionicPopup.alert({
            template: 'Your account has been cancelled',
            cssClass: 'alertPopUp',
            okType: 'button-assertive'
          });

          facebookConnectPlugin.logout(function () {
            var oldData = window.localStorage.getItem("EndpointArn");
            if (oldData !== null) {
              UserService.deleteDevice()
                .get({"string": oldData}).$promise.then(function success(data) {
              }, function (response) {
              });
            }
            AuthService.logout();
            AWSServices.deletePlatformEndpoint(1);
            var tempPers = window.localStorage.getItem('AppsPerzonalized');
            window.localStorage.clear();
            window.localStorage.setItem("AppsPerzonalized", tempPers);

            window.localStorage.setItem("onboardingComplete", "yes");
            $localForage.clear().then( function (clean) {
              console.log("cleared Local Forage"); 
            })
            $rootScope.$broadcast('logout.success');
            $state.go('login', {}, {reload: true});
          });
        }, function (error) {
        });
      };

      $scope.cancelAccount = function () {
        //console.log("Entramos a cancelar cuenta");
        UserService.cancelUserSubscription({"objectId": window.localStorage.getItem("userSubscriptionInstanceId")}).save({}, function (data) {
          $ionicPopup.alert({
            template: 'Your account has been cancelled',
            cssClass: 'alertPopUp',
            okType: 'button-assertive'
          });
          var oldData = window.localStorage.getItem("EndpointArn");
          if (oldData !== null) {
            UserService.deleteDevice()
              .get({"string": oldData}).$promise.then(function success(data) {
            }, function (response) {
            });
          }
          AuthService.logout();
          AWSServices.deletePlatformEndpoint(1);
          var tempPers = window.localStorage.getItem('AppsPerzonalized');
          window.localStorage.clear();
          window.localStorage.setItem("AppsPerzonalized", tempPers);

          window.localStorage.setItem("onboardingComplete", "yes");
          $localForage.clear().then( function (clean) {
            console.log("cleared Local Forage"); 
          })
          $rootScope.$broadcast('logout.success');
          $state.go('login', {}, {reload: true});
        }, function (error) {
        });
      };

      $scope.showOptions = function () {
        var buttons = [];
        var buttonsIds = [];

        buttons.push({text: Utils.translate('SHARE_LINK.APP_ONLY.METHOD.QRCODE') + '<i class="icon ion-android-create"></i>'});
        buttons.push({text: Utils.translate('SHARE_LINK.APP_ONLY.METHOD.LINK') + '<i class="icon ion-android-create"></i>'});
        buttonsIds.push("SHOWQR");
        buttonsIds.push("LINK");

        Utils.$ionicActionSheet.show({
          buttons: buttons,
          titleText: 'Options',
          buttonClicked: function (buttonIndex) {
            switch (buttonsIds[buttonIndex]) {
              case "SHOWQR":
                $scope.Appmessage(1);
                break;
              case "LINK":
                $scope.Appmessage(2);
                break;
            }
          }
        })
      }

      $scope.Appmessage = function (typeSharing) {
        //check type of sharing
        Utils.loading.show();
        var text = $filter('translate')('MENU.SETTINGS.SHARE_APP.MESSAGE');
        var text2 = $filter('translate')('MENU.SETTINGS.SHARE_APP.MESSAGE2');
        var message = text + ' \n' + text2 + '\n';
        if(typeSharing === 1) {
          Utils.loading.hide();
          var dialog = Utils.alert.getCtrl();
          var dataForQRCode = Personalized.shareApp;
          var typeName = "App Share";
          var nameAdded = Push_Notif_Variables.title;
          dialog.show({
            templateUrl: 'templates/QRList/QRCodeForPostTpl.html',
            controller: "showPostQRCodeCtrl",
            locals: {
              dataCode: dataForQRCode,
              type: typeName,
              nameAdd: nameAdded,
              dialog: dialog
            },
            clickOutsideToClose: false,
            fullscreen: true // Only for -xs, -sm breakpoints.
          }).then(function () {
          }, function () {
          });
        } else {
          window.plugins.socialsharing.share(
            text + ' \n' + text2 + '\n',
            null,
            null,
            Personalized.shareApp
          );
          Utils.loading.hide();
        }
      };

      $scope.runBlackList = function () {
        Utils.confirm.show("Blacklist", {
          title: "Run Blacklist?",
          cancelText: "No",
          okText: "Ok"
        }).then(function (res){
            if (res) {
                UserService.runBlackListWS().$promise.then(function () {
                  Utils.toast.success(Utils.translate('La revisión ha concluido'))
                }, function (error) {
                  console.error('Run Black List', error)
                  Utils.toast.error(Utils.translate('La revisión ha fallado, intenta nuevamente'))
                })
            }
        })
      }

      $scope.showRedeemCode = function () {
        $scope.data = {redeemCode: ''};
        Utils.prompt.show({
          template: '<input type="text" autofocus translate-attr="{placeholder:\'MENU.ENTER_CODE\'}" ng-model="data.redeemCode" >',
          title: Utils.translate("MENU.REDEEM_CODE"),
          scope: $scope,
          buttons: [
            {text: Utils.translate("GLOBAL.CANCEL")},
            {
              text: Utils.translate("GLOBAL.OK"),
              type: "button-assertive",
              onTap: function (ev) {
                if (!$scope.data.redeemCode) {
                  ev.preventDefault();
                }
                else
                  return $scope.data.redeemCode;
              }
            }
          ]
        }).then(function (redeemableCode) {
          if (redeemableCode) {
            Utils.loading.show();
            UserService.redeemCodeWS({
              userSubscriptionId: UserService.get_USERSUBSCRIPTIONINSTANCE_ID(),
              code: redeemableCode
            }).$promise.then(function (resp) {
              if (resp.result.value == 1) {
                $rootScope.$broadcast('groups.mine.reload');
                Utils.toast.success(Utils.translate("MENU.REDEEM_OK"));
              }
              else
                Utils.toast.warning(Utils.translate("MENU.REDEEM_ERROR"));
            }, function (error) {
              console.error("-- redeemCode", error);
              Utils.toast.error(Utils.translate("ERROR.UNKNOWN"));
            }).finally(function () {
              Utils.loading.hide();
            })
          }
        })
      }

      function getFacebookProfileInfo(authResponse) {
        var info = $q.defer();
        /*facebookConnectPlugin.api('/me?fields=id,email,name,first_name,last_name,friends,location,about,birthday,hometown&access_token=' + authResponse.accessToken, null,*/
        facebookConnectPlugin.api('/me?fields=id,email,name,first_name,last_name&access_token=' + authResponse.accessToken, null,
          function (response) {
            info.resolve(response);
          },
          function (response) {
            info.reject(response);
          }
        );
        return info.promise;
      }

      $scope.linkToFB = function () {
        Utils.loading.show();
        facebookConnectPlugin.getLoginStatus(function (response) {
          if(response.status === 'connected') {
            //The user is logged with Fb and has authorized the app
            //In response.authResponse we obtain the needed info about the connection
            /*
            var uid = response.authResponse.userID;
            var accessToken = response.authResponse.accessToken;
            */
            var user = UserServiceFb.getUser('facebook');
            if(!user.userID){
              getFacebookProfileInfo(response.authResponse).then(function (profileInfo) {
                var p = {
                  authResponse: response.authResponse,
                  userID: profileInfo.id,
                  name: profileInfo.name,
                  firstName: profileInfo.first_name,
                  lastName: profileInfo.last_name,
                  userWebLink: profileInfo.link,
                  email: profileInfo.email
                };

                UserServiceFb.setUser(p);
                //Se obtienen datos del usuario de Fb y con ello continuamos
                //Se transforma la cuenta
                verifyWebUserExists();

              }, function (fail) {
                // Fail get profile info
                showErrorAndClean(Utils.translate('ERROR.FACEBOOK_ERR01'), 0, 0);
                console.error('profile info fail', fail);
              });
            }
          } else if(response.status === 'authorization_expired'){
            //The user has previously logged into your application 
            //but your authorization to access their data has expired.
            facebookConnectPlugin.login(['public_profile', 'email'], fbLoginSuccess, fbLoginError);
          } else if(response.status === 'not_authorized'){
            //The user has previously logged into your application 
            //but hasn't authorized to access their data
            facebookConnectPlugin.login(['public_profile', 'email'], fbLoginSuccess, fbLoginError);
          } else if(response.status === 'unknown'){
            //The user is either not logged into Facebook or explicitly logged out of your application
            //but hasn't authorized to access their data
            facebookConnectPlugin.login(['public_profile', 'email'], fbLoginSuccess, fbLoginError);
          }
        })
      }

      //When login with FB is success
      function fbLoginSuccess(response) {
        //console.log("***fbLoginSuccess()", response)
        if (!response.authResponse) {
          fbLoginError("Cannot find the authResponse");
          return;
        }
        var authResponse = response.authResponse;
        getFacebookProfileInfo(authResponse).then(function (profileInfo) {
          var p = {
            authResponse: authResponse,
            userID: profileInfo.id,
            name: profileInfo.name,
            firstName: profileInfo.first_name,
            lastName: profileInfo.last_name,
            userWebLink: profileInfo.link,
            email: profileInfo.email
          };

          UserServiceFb.setUser(p);
          //Se obtienen datos del usuario de Fb y con ello continuamos
          //Se transforma la cuenta
          verifyWebUserExists();
          
        }, function (fail) {
          Utils.loading.hide();
          Utils.toast.error(Utils.translate("MENU.LINK_FB_ACCOUNT.CANNOT_GET_PROFILE_FB"));//
          console.error('profile info fail', fail);
        });
      }

      // This is the fail callback from the login method
      function fbLoginError(error) {
        //console.log('fbLoginError');
        //Show message with error
        Utils.loading.hide();
        Utils.toast.error(Utils.translate("MENU.LINK_FB_ACCOUNT.CANNOT_CONNECT_FB"));
      }

      function verifyWebUserExists() {
        //First we check if the WebuserId is already in use
        var userFace = UserServiceFb.getUser('facebook');
        SignInService.findByWebUserId().get({"webUserid": userFace.userID}, function (data) {
          if (data.length > 0) {
            //The webUserID is already in use
            //logout from FB and show message to the user
            Utils.loading.hide();
            Utils.toast.error(Utils.translate("MENU.LINK_FB_ACCOUNT.FB_ALREADY_REGISTED"));
            facebookConnectPlugin.logout(function () {
              $scope.webUser = "";
            }, function (error) {
              console.error("facebookConnectPlugin.logout", error)
            });
          }
          else {
            //The webUserId can be used
            //we add it first to the group
            accessToGroup();
            //transformAccountToFB();
          }
        }, function (err) {
          Utils.loading.hide();
          Utils.toast.error(Utils.translate("MENU.LINK_FB_ACCOUNT.CANNOT_CONNECT_SERVER"));
        });
      };

      function transformAccountToFB() {
        //First we check if the WebuserId is already in use
        var userFace = UserServiceFb.getUser('facebook');
        UserService.linkAccountWithFacebook({
          objectId: window.localStorage.getItem('simpleUserInstanceId')
        }).save({
          "userName": {
            "value": userFace.userID
          },
          "newPassword": {
            "value": userFace.userID
          }
        }, function (transformData) {
          var lastSubscriptionInstanceId = UserService.get_USERSUBSCRIPTIONINSTANCE_ID();

          //if everything go rigth after transform the account
          //we try to add the user to an existing group
          console.log("success!!", transformData);
          //accessToGroup();
          Utils.toast.success($scope.message);

          setTimeout(function () {
            
            //Deslogeamos FB
              facebookConnectPlugin.getLoginStatus(function (response) {
                if (response.status == 'connected') {
                  facebookConnectPlugin.logout(function () {
                    $scope.webUser = "";
                  }, function (error) {
                    console.error("facebookConnectPlugin.logout", error);
                    Utils.loading.hide();
                  });
                } else {
                }
              }, function (error) {
                console.error("facebookConnectPlugin.getLoginStatus", error)
              });
            //continua proceso de deslogeo
              AuthService.logout();


              Utils.loading.hide();
              ChatFactory2.logout().then(function () {
              }, function () {
              }).finally(function () {
                var tempPers = window.localStorage.getItem('AppsPerzonalized');
                window.localStorage.clear();
                window.localStorage.setItem("AppsPerzonalized", tempPers);
                window.localStorage.setItem("onboardingComplete", "yes");
                localStorage.setItem('lastSubscriptionInstanceId', lastSubscriptionInstanceId.toString());
                $localForage.clear().then( function (clean) {
                  console.log("cleared Local Forage"); 
                })
                $rootScope.$broadcast('logout.success');
                $state.go('login', {}, {reload: true});
              });

          }, 100);
          
        }, function (errorTransformData) {
          //if something fails we logout from FB and clear everything
          facebookConnectPlugin.logout(function () {
            $scope.webUser = "";
          }, function (error) {
            console.error("facebookConnectPlugin.logout", error)
          });
          Utils.loading.hide();
          Utils.toast.error(Utils.translate("MENU.LINK_FB_ACCOUNT.CANNOT_COMPLETE_LINK"));
        })
      }
      $scope.message = ""

      function accessToGroup() {
        //after transform the account we add it to the required group if have any
        var userFace = UserServiceFb.getUser('facebook');
        UserService.accessToLinkGroup({
          userSubscriptionId: UserService.get_USERSUBSCRIPTION_ID(),
          facebookUser: userFace.name
        }).$promise.then(
          /*
          *Data received
          *result.value
          *1 the user was added directly
          *2 Generated a request to the proper group
          *3 didn't find the user in the group
          */
          function (resp) {
            console.log('got it!!', resp);
            //var message = "";
            if (resp.result.value == 1)
              $scope.message = Utils.translate("MENU.LINK_FB_ACCOUNT.ADDED_TO_GROUP");
            else if (resp.result.value == 2)
              $scope.message = Utils.translate("MENU.LINK_FB_ACCOUNT.PETITION_TO_GROUP");
            else if (resp.result.value == 3)
              $scope.message = Utils.translate("MENU.LINK_FB_ACCOUNT.NO_GROUP_TOBE_ADDED");

            //Utils.loading.hide();
            //Utils.toast.success(message);
            transformAccountToFB();
          }, function (error) {
            console.log('not got it??', error);
            Utils.toast.error(Utils.translate("MENU.LINK_FB_ACCOUNT.CANNOT_COMPLETE_LINK"));
            Utils.loading.hide();
          }
        );
      }

      //VALIDATE PERSONALIZED BALA
        function checkPersonalized() {
          var pivot = JSON.parse(window.localStorage.getItem('AppsPerzonalized'));
          if(pivot != null) {
            if(pivot.personalMenu) {
              //SHOW AREA
              $scope.showList.first = pivot.personalMenu.first;
              $scope.showList.second = pivot.personalMenu.second;
              $scope.showList.third = pivot.personalMenu.third;
              $scope.showList.fourth = pivot.personalMenu.fourth;
              //MESSAGE AREA
              $scope.msgList.first = pivot.personalMessage.first;
              $scope.msgList.second = pivot.personalMessage.second;
              $scope.msgList.third = pivot.personalMessage.third;
              $scope.msgList.fourth = pivot.personalMessage.fourth;
            } else {
              return false;
            }
          } else {
            return false;
          }
        }

        $scope.openFirst = function () {
          var pivot = JSON.parse(window.localStorage.getItem('AppsPerzonalized'));
          var isIOS = ionic.Platform.isIOS();
          var zone = '_blank';
          var opt = '';
          if(isIOS){
            zone = '_blank';
            opt = 'clearsessioncache=yes,usewkwebview=yes,toolbar=yes,presentationstyle=fullscreen,hidespinner=yes,closebuttoncaption=Close,closebuttoncolor=#ffffff4,navigationbuttoncolor=#ffffff,lefttoright=yes,location=no';
          }
          else{
            zone ='_blank';
            opt = 'clearsessioncache=yes,usewkwebview=yes,toolbar=yes,presentationstyle=fullscreen,hidespinner=yes,closebuttoncaptionSet=Close,closeButtonColorSet=#ffffff4,navigationbuttoncolorSet=#ffffff,lefttoright=yes,location=no';
          }
          var ref = cordova.InAppBrowser.open(pivot.personalLinks.first, zone, opt);
        }

        $scope.openSecond = function () {
          var pivot = JSON.parse(window.localStorage.getItem('AppsPerzonalized'));
          var isIOS = ionic.Platform.isIOS();
          var zone = '_blank';
          var opt = '';
          if(isIOS){
            zone = '_blank';
            opt = 'clearsessioncache=yes,usewkwebview=yes,toolbar=yes,presentationstyle=fullscreen,hidespinner=yes,closebuttoncaption=Close,closebuttoncolor=#ffffff4,navigationbuttoncolor=#ffffff,lefttoright=yes,location=no';
          }
          else{
            zone ='_blank';
            opt = 'clearsessioncache=yes,usewkwebview=yes,toolbar=yes,presentationstyle=fullscreen,hidespinner=yes,closebuttoncaptionSet=Close,closeButtonColorSet=#ffffff4,navigationbuttoncolorSet=#ffffff,lefttoright=yes,location=no';
          }
          var ref = cordova.InAppBrowser.open(pivot.personalLinks.second, zone, opt);
        }

        $scope.openThird = function () {
          var pivot = JSON.parse(window.localStorage.getItem('AppsPerzonalized'));
          var isIOS = ionic.Platform.isIOS();
          var zone = '_blank';
          var opt = '';
          if(isIOS){
            zone = '_blank';
            opt = 'clearsessioncache=yes,usewkwebview=yes,toolbar=yes,presentationstyle=fullscreen,hidespinner=yes,closebuttoncaption=Close,closebuttoncolor=#ffffff4,navigationbuttoncolor=#ffffff,lefttoright=yes,location=no';
          }
          else{
            zone ='_blank';
            opt = 'clearsessioncache=yes,usewkwebview=yes,toolbar=yes,presentationstyle=fullscreen,hidespinner=yes,closebuttoncaptionSet=Close,closeButtonColorSet=#ffffff4,navigationbuttoncolorSet=#ffffff,lefttoright=yes,location=no';
          }
          var ref = cordova.InAppBrowser.open(pivot.personalLinks.third, zone, opt);
        }

        $scope.openFourth = function () {
          var pivot = JSON.parse(window.localStorage.getItem('AppsPerzonalized'));
          var isIOS = ionic.Platform.isIOS();
          var zone = '_blank';
          var opt = '';
          if(isIOS){
            zone = '_blank';
            opt = 'clearsessioncache=yes,usewkwebview=yes,toolbar=yes,presentationstyle=fullscreen,hidespinner=yes,closebuttoncaption=Close,closebuttoncolor=#ffffff4,navigationbuttoncolor=#ffffff,lefttoright=yes,location=no';
          }
          else{
            zone ='_blank';
            opt = 'clearsessioncache=yes,usewkwebview=yes,toolbar=yes,presentationstyle=fullscreen,hidespinner=yes,closebuttoncaptionSet=Close,closeButtonColorSet=#ffffff4,navigationbuttoncolorSet=#ffffff,lefttoright=yes,location=no';
          }
          var ref = cordova.InAppBrowser.open(pivot.personalLinks.fourth, zone, opt);
        }
      //VALIDATE PERSONALIZED END
      
    }])

  .controller('configNotificationsCtrl', ['$scope', '$state', 'UserService', 'Utils', '$filter',
    function ($scope, $state, UserService, Utils, $filter) {

      $scope.chkStatusConfiguration = function () {
        if (window.localStorage.getItem('pushNotificationsConfig') === null) {
          UserService.getPushNotificationsConfig({
            objectId: window.localStorage.getItem('userSubscriptionInstanceId')
          }).get().$promise.then(function (response) {
            var config = [];
            response.forEach(function(item){
              var textForShow = "";
              switch(item.notificationType) {
                case 1:
                  textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.NEW_FOLLOWERS");
                break;
                /*case 2:
                  textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.NEW_FOLLOWERS");
                break;*/
                /*case 3:
                  textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.NEW_FOLLOWERS");
                break;*/
                case 4:
                  textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.REACTS");
                break;
                case 5:
                  textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.LIKES");
                break;
                case 6:
                  textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.COMMENTS");
                break;
                case 7:
                  textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.TAGGING");
                break;
                /*case 8:
                  textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.NEW_FOLLOWERS");
                break;*/
                case 9:
                  textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.LIKE_COMMENT");
                break;
                case 10:
                  textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.DELETED_GROUP");
                break;
                case 11:
                  textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.JOIN_GROUP");
                break;
                case 12:
                  textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.ACCEPTED_GROUP");
                break;
                case 13:
                  textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.FRIEND_POST_NEW");
                break;
                case 14:
                  textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.NEW_POST_GROUP");
                break;
                case 15:
                  textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.NEW_PROFILE_PHOTO");
                break;
                case 16:
                  textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.NEW_GROUP_COVER");
                break;
                case 17:
                  textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.LIKED_POST_COMMENTED");
                break;
                case 18:
                  textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.COMMENTED_POST_COMMENTED");
                break;
                case 19:
                  textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.LIKED_POST_LIKED");
                break;
                case 20:
                  textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.STREAM_NOTIFICATIONS");
                break;
              }
              config.push({
                instanceId: +Utils.getLastUrlComponent(item.configureUserNotification.href),
                notificationType: item.notificationType,
                sendNotification: item.sendNotification,
                textForShow: textForShow
              });
            });

            window.localStorage.setItem('pushNotificationsConfig', JSON.stringify(config));
            $scope.configuration = JSON.parse(window.localStorage.getItem('pushNotificationsConfig')).sort(function (a, b) {
              return a.notificationType - b.notificationType;
            });
          }, function (error) {
            console.error("get PushNotificationsConfig", error)
          });
        }
        else {
          $scope.configuration = JSON.parse(window.localStorage.getItem('pushNotificationsConfig')).sort(function (a, b) {
            return a.notificationType - b.notificationType;
          });
        }
      }

      $scope.chkStatusConfiguration(); 

      $scope.updatePushNotificationConfig = function (option) {
        UserService.updatePushNotificationConfig(
          {objectId: option.instanceId}
        ).post({
          "boolean": {
            "value": option.sendNotification
          }
        }).$promise.then(function success() {
          window.localStorage.setItem('pushNotificationsConfig', JSON.stringify($scope.configuration));
        }, function (response) {
        });
      };
  }])
;
