"use strict";
appControllers
//list of friends linked to a user
.controller('followersFollowingCtrl', ['$scope', '$state', 'friendsData', '$ionicPopup', 'UserService', 'ApiEndPoint', 'usersData', 'ionicService', 'reDirectService', '$filter', 'AWSServices', 'notificationsService', 'Utils',
  function ($scope, $state, friendsData, $ionicPopup, UserService, ApiEndPoint, usersData, ionicService, reDirectService, $filter, AWSServices, notificationsService, Utils) {
  $scope.mySubscriptionHref = UserService.get_USER_INSTANCE_HREF();

  $scope.unfollowText = $filter('translate')('GLOBAL.UNFOLLOW');
  $scope.followText = $filter('translate')('GLOBAL.FOLLOW');
  $scope.pendingRequest = Utils.translate('GLOBAL.PENDING');
  $scope.listenInc = 0;
  $scope.isLoadingContent = true;

  //$state.params.subscriptionInstanceId
  $scope.init = function () {
    $scope.start = 0;
    $scope.count = 6;
    $scope.noMoreItemsAvailable = false;
    $scope.users = [];
    $scope.errorLoading = false;
  };
  $scope.init();

  function loadFollowing() {
    UserService.findFriendsByUserSubscriptionId({
      userId: $state.params.userInstanceId,
      start: $scope.start,
      count: $scope.count
    }).$promise.then(function (data) {
      data.forEach(function (item) {
        UserService.getStatusPrivateAccount({
          "objectId": Utils.getLastUrlComponent(item.userSubscription.href)
        }).get().$promise.then(function (privateData) {
          $scope.users.push({
            userSubscription: item.userSubscription,
            name: item.name,
            avatar: Utils.getUserImgUrl(item),
            isActive: null,
            msgShow: "",
            isPrivate: privateData.result.value,
            waitingAns: false
          })
        }, function (err) {
          console.log("get private data fail", err);
        });
        $scope.listenInc++;
      });

      //$scope.start = $scope.users.length;
      $scope.start = $scope.listenInc;

      if (!data.length)
        $scope.noMoreItemsAvailable = true;

      $scope.$broadcast('scroll.infiniteScrollComplete');
      $scope.isLoadingContent = false;
    }, function (error) {
      console.error("findFriendsByUserSubscriptionId", error);
      $scope.errorLoading = true;
      $scope.noMoreItemsAvailable = true;
      $scope.$broadcast('scroll.infiniteScrollComplete');
      $scope.isLoadingContent = false;
    });
  }

  function loadFollowers() {
    UserService.followersByUserId({
      objectId: $state.params.userInstanceId
    }).get({
      withStart: '"' + $scope.start + '"',
      withCount: '"' + $scope.count + '"'
    }, function (data) {
      data.forEach(function (item) {
        UserService.getStatusPrivateAccount({
          "objectId": Utils.getLastUrlComponent(item.userSubscription.href)
        }).get().$promise.then(function success(privateData) {
          $scope.users.push({
            userSubscription: item.userSubscription,
            name: item.name,
            avatar: Utils.getUserImgUrl(item),
            isActive: null,
            msgShow: "",
            isPrivate: privateData.result.value,
            waitingAns: false
          })
        }, function (err) {
          console.log("get private data fail", err);
        });
        $scope.listenInc++;
      });

      //$scope.start = $scope.users.length;
      $scope.start = $scope.listenInc;

      if (!data.length)
        $scope.noMoreItemsAvailable = true;

      $scope.$broadcast('scroll.infiniteScrollComplete');
      $scope.isLoadingContent = false;
    }, function (error) {
      console.error("followersByUserId", error);
      $scope.errorLoading = true;
      $scope.noMoreItemsAvailable = true;
      $scope.$broadcast('scroll.infiniteScrollComplete');
      $scope.isLoadingContent = false;
    });
  }

  $scope.loadMore = function () {
    if ($state.params.listType === 'followers')
      loadFollowers();
    else if ($state.params.listType === 'following')
      loadFollowing();
    //else
      //Utils.alert.show("The list type '" + $state.params.listType + "' doesn't match");
  };

  //Check if any of the list of Friend's friends are friend with the current user
  //function to check friend or not
  $scope.getFollowingIsActive = function (friend) {
    UserService.getFollowingIsActiveWS({
      userInstanceId: UserService.get_USERSUBSCRIPTIONINSTANCE_ID(),
      friendInstaceId: Utils.getLastUrlComponent(friend.userSubscription.href)
    }).$promise.then(function success(response) {
      friend.isActive = response.result.value;
    }, function error(response) {
      friend.isActive = false;
      console.log("getFollowingIsActive error");
    });
  };

  //check status request
  //friend, no friend, pending
  $scope.findStatusRequestFriend = function (friend) {
    UserService.getStatusPrivateRequest({
      userId: UserService.get_USERSUBSCRIPTIONINSTANCE_ID(),
      friendId: Utils.getLastUrlComponent(friend.userSubscription.href)
    }).$promise.then(function success(response) {
      console.log("success", response);
      if (response.friend) {
        friend.simpleIdFriend = Utils.getLastUrlComponent(response.friend.href);
      }
      if (response.status == 1) {
        //son amigos
        friend.msgShow = $scope.unfollowText;
        friend.isActive = true;
        friend.waitingAns = false;
        
      } else if (response.status == 2) {
        //waiting
        friend.msgShow = $scope.pendingRequest;
        friend.isActive = false;
        friend.waitingAns = true;
      } else if (response.status == 3) {
        //no son amigos
        friend.msgShow = $scope.followText;
        friend.isActive = false;
        friend.waitingAns = false;
      }
    }, function (err) {
      console.log("mistake when finding status request", err);
    })
  };

  //function to follow/unfollow users
  $scope.toggleFriendhipState = function (friend) {
    //friend.isActive = !friend.isActive;
    if (friend.isActive) {
      //visual changes
      friend.isActive = false;
      friend.msgShow = $scope.followText;

      UserService.cancelRequestToPrivate(
        {"objectId": friend.simpleIdFriend}
      ).save().$promise.then(function success(response) {
        friend.msgShow = $scope.followText;
        friend.simpleIdFriend = "";
        friend.waitingAns = false;
      }, function (err) {
      });
    } else {

      //visual changes
      if (friend.isPrivate) {
        if (friend.msgShow = $scope.pendingRequest) {
          friend.msgShow = $scope.followText;
        } else {
          friend.msgShow = $scope.pendingRequest;
        }
        friend.isActive = false;
      } else {
        friend.isActive = true;
        friend.msgShow = $scope.unfollowText;
      }

      if (friend.waitingAns) {
        UserService.cancelRequestToPrivate(
          {"objectId": friend.simpleIdFriend}
        ).save().$promise.then(function success(response) {
          friend.msgShow = $scope.followText;
          friend.simpleIdFriend = "";
          friend.waitingAns = false;
        }, function (err) {
        });
      } else {
        UserService.toggleFriendhipStateWS({
          userInstanceId: UserService.get_USERSUBSCRIPTIONINSTANCE_ID(),
          friendInstaceId: Utils.getLastUrlComponent(friend.userSubscription.href)
        }).$promise.then(function (response) {
          //se revisa valor, si es true se puede mandar notificacionea a ese usuario
          if (response.result.value) {
            var dialogSend = "";
            if (friend.isPrivate) {
              dialogSend = UserService.get_USER_NAME() + ' ' + Utils.translate('NOTIFICATIONS.DIALOG.SEND_REQUEST');
              $scope.findStatusRequestFriend(friend);
            } else {
              dialogSend = UserService.get_USER_NAME() + ' ' + Utils.translate('NOTIFICATIONS.DIALOG.IS_FOLLOWING_YOU');
            }
            //depende del WS anterior para saber si se manda o no
            UserService.getDevices(Utils.getLastUrlComponent(friend.userSubscription.href)).$promise.then( function (responseEndPoint) {
              responseEndPoint.result.value.forEach( function (endPointArn) {
                AWSServices.sendNotifaboutFollowAction(
                  dialogSend,
                  endpointArn.title,
                  UserService.get_USER_NAME(),
                  UserService.get_USERSUBSCRIPTIONINSTANCE_ID()
                )
              })
            })
          }
          friend.waitingAns = true;
        }, function (error) {
          friend.isActive = !friend.isActive;
          friend.waitingAns = false;
          console.error("toggleFriendhipStateWS", error);
          Utils.toast.error(Utils.translate('PROFILE.DIALOG.' + (friend.isActive ? 'UN' : '') + 'FOLLOW_USER_ERROR'))
        });
      }
    }
  };

  $scope.sendUserProfile = function (userChosen) {
    reDirectService.reDirectProfile(Utils.getLastUrlComponent(userChosen.href));
  };
}])

//list of likes linked to a post
.controller('listLikesCtrl', ['$scope', 'ApiEndPoint', 'likeUsersData', 'SequenceService', 'UserService', 'usersData', '$state', 'reDirectService','Utils', 'AWSServices',
  function ($scope, ApiEndPoint, likeUsersData, SequenceService, UserService, usersData, $state, reDirectService, Utils, AWSServices) {
    $scope.likeUsersData = likeUsersData;
    $scope.userLikeList = [];
    $scope.noMoreItemsAvailable = false;
    $scope.start = 0;
    $scope.count = 10;
    $scope.errorLoading = false;
    $scope.totalLikes = $state.params.number;

     /*TEXT ZONE FOR MESSAGES*/
    $scope.followText = Utils.translate('GLOBAL.FOLLOW'); //Follow
    $scope.followingText = Utils.translate('GLOBAL.FOLLOWING'); //Following
    $scope.unfollowText = Utils.translate('GLOBAL.UNFOLLOW'); //UnFollow
    $scope.pendingRequest = Utils.translate('GLOBAL.PENDING'); //Pending request
    $scope.acceptPendingRequest = Utils.translate('GLOBAL.ACCEPT'); //Accept
    $scope.acceptedPendingRequest = Utils.translate('GLOBAL.ACCEPTED'); //Accepted
    $scope.friendsNow = Utils.translate('GLOBAL.FRIENDS'); //Friends
    $scope.waitingNow = Utils.translate('GLOBAL.WAITING'); //Waiting
    /*END TEXT ZONE FOR MESSAGES*/
    var mySubscriptionId = UserService.get_USERSUBSCRIPTIONINSTANCE_ID();
    $scope.compareID = UserService.get_USERSUBSCRIPTIONINSTANCE_ID();
    //function to load al the data needed
    $scope.loadMore = function () {
      SequenceService.findSequenceCountByType({
        sequence: $scope.likeUsersData.data,
        type: 'Like',
        start: $scope.start,
        count: $scope.count
      }).$promise.then(function success(response) {
        if (response.length > 1) {
          response.length--;
          $scope.start += response.length;
          response.forEach( function (data) {
            $scope.userLikeList.push(data);
          })
          $scope.userLikeList.forEach( function (usersData) {
            $scope.getFollowStatus(usersData);
            $scope.getPrivateStatus(usersData);
          })
          //$scope.userLikeList.push.apply($scope.userLikeList, response);
        } else {
          $scope.noMoreItemsAvailable = true;
        }
        $scope.$broadcast('scroll.infiniteScrollComplete');
      }, function error(err) {
        console.log("mistake", err);
        $scope.errorLoading = true;
        $scope.noMoreItemsAvailable = true;
        $scope.$broadcast('scroll.infiniteScrollComplete');
        console.log("sequenceCounts error");
      })
    };

    $scope.retry = function () {
      $scope.errorLoading = false;
      $scope.userLikeList = [];
      $scope.noMoreItemsAvailable = false;
      $scope.start = 0;
      $scope.count = 10;
    };

    $scope.getFollowStatus = function (data) {
      //obtener status del otro usuario a mi
      var otherMe = UserService.getStatusPrivateRequest({
        userId: Utils.getLastUrlComponent(data.userSubscriptionId.href),
        friendId: UserService.get_USERSUBSCRIPTIONINSTANCE_ID()
      }).$promise;
      //obtener status de  mi al otro usuario
      var meOther = UserService.getStatusPrivateRequest({
        userId: UserService.get_USERSUBSCRIPTIONINSTANCE_ID(),
        friendId: Utils.getLastUrlComponent(data.userSubscriptionId.href)
      }).$promise;

      //work with both
      Utils.$q.all({
        OthersToMe: otherMe,
        meToOthers: meOther
      }).then(function (currentStatus) {
        if(currentStatus.OthersToMe.status == 1) {
          if(currentStatus.meToOthers.status == 1) {
            data.msgShow = $scope.followingText;
            data.itFollows = 1;
            data.meFollow = 1;
            data.isActive = true;
            data.waitingAns = false;
            data.shutdownButton = false;
          } else if(currentStatus.meToOthers.status == 2) {
            data.msgShow = $scope.waitingNow;
            data.itFollows = 1;
            data.meFollow = 2;
            data.isActive = true;
            data.waitingAns = true;
            data.shutdownButton = false;
          } else if(currentStatus.meToOthers.status == 3) {
            data.msgShow = $scope.followText;
            data.itFollows = 1;
            data.meFollow = 3;
            data.isActive = true;
            data.waitingAns = false;
            data.shutdownButton = false;
          }
        } else if(currentStatus.OthersToMe.status == 2) {
          if(currentStatus.meToOthers.status == 1) {
            data.msgShow = $scope.acceptPendingRequest;
            data.itFollows = 2;
            data.meFollow = 1;
            data.isActive = true;
            data.waitingAns = false;
            data.shutdownButton = false;
          } else if(currentStatus.meToOthers.status == 2) {
            data.msgShow = $scope.acceptPendingRequest;
            data.itFollows = 2;
            data.meFollow = 2;
            data.isActive = true;
            data.waitingAns = true;
            data.shutdownButton = false;
          } else if(currentStatus.meToOthers.status == 3) {
            data.msgShow = $scope.acceptPendingRequest;
            data.itFollows = 2;
            data.meFollow = 3;
            data.isActive = true;
            data.waitingAns = false;
            data.shutdownButton = false;
          }
        } else if(currentStatus.OthersToMe.status == 3) {
          if(currentStatus.meToOthers.status == 1) {
            data.msgShow = $scope.followingText;
            data.itFollows = 3;
            data.meFollow = 1;
            data.isActive = true;
            data.waitingAns = false;
            data.shutdownButton = false;
          } else if(currentStatus.meToOthers.status == 2) {
            data.msgShow = $scope.waitingNow;
            data.itFollows = 3;
            data.meFollow = 2;
            data.isActive = true;
            data.waitingAns = true;
            data.shutdownButton = false;
          } else if(currentStatus.meToOthers.status == 3) {
            data.msgShow = $scope.followText;
            data.itFollows = 3;
            data.meFollow = 3;
            data.isActive = true;
            data.waitingAns = false;
            data.shutdownButton = false;
          }
        }
      });
    }

    $scope.getPrivateStatus = function (data) {
      data.privateAccount = UserService.getStatusPrivateAccount({
        "objectId": Utils.getLastUrlComponent(data.userSubscriptionId.href)
      }).get();
    }

    $scope.changeStatusFriend = function(notif) {
      if(notif.shutdownButton || notif.togglingFollow)
        return false;

      notif.togglingFollow = true;
      var prevText = notif.msgShow;
      notif.isActive = false;
      notif.msgShow = "-----------";
      if(notif.itFollows == 1) {
          if(notif.meFollow == 1) {
            ceaseFollowStatus(notif, $scope.followText, prevText, 3, 1);
          } else if(notif.meFollow == 2) {
            ceaseFollowStatus(notif, $scope.followText, prevText, 3, 2);
          } else if(notif.meFollow == 3) {
            if(notif.privateAccount.result) {
              if(notif.privateAccount.result.value)
                askFollowPermission(notif, $scope.waitingNow, prevText, 2, 3);
              else
                askFollowPermission(notif, $scope.followingText, prevText, 1, 3);
            } else
                askFollowPermission(notif, $scope.followingText, prevText, 1, 3);
          }
      } else if(notif.itFollows == 2) {
          if(notif.meFollow == 1) {
            acceptRequestFollow(notif, $scope.followingText, prevText, 1, 2);
          } else if(notif.meFollow == 2) {
            acceptRequestFollow(notif, $scope.waitingNow, prevText, 1, 2);
          } else if(notif.meFollow == 3) {
            acceptRequestFollow(notif, $scope.followText, prevText, 1, 2);
          }
      } else if(notif.itFollows == 3) {
          if(notif.meFollow == 1) {
            ceaseFollowStatus(notif, $scope.followText, prevText, 3, 1);
          } else if(notif.meFollow == 2) {
            ceaseFollowStatus(notif, $scope.followText, prevText, 3, 2);
          } else if(notif.meFollow == 3) {
            if(notif.privateAccount.result) {
              if(notif.privateAccount.result.value)
                askFollowPermission(notif, $scope.waitingNow, prevText, 2, 3);
              else
                askFollowPermission(notif, $scope.followingText, prevText, 1, 3);
            } else
              askFollowPermission(notif, $scope.followingText, prevText, 1, 3);
          }
      }
    }

    function ceaseFollowStatus(notif, newText, oldText, newState, oldState) {
      //WAIT FOR CHANGE AT WS TO GET FRIEND.ID TO UPDATE STATUS
      UserService.cancelRequestToPrivate({
        objectId: Utils.getLastUrlComponent(notif.userSubscriptionId.href) 
      }).save().$promise.then(function success(response) {
        notif.msgShow = newText;
        notif.simpleIdFriend = "";
        notif.waitingAns = false;
        notif.meFollow = newState;
      }, function (err) {
        
        notif.msgShow = oldText;
        notif.meFollow = oldState;
        console.error("cancel Request ToPrivate", err);
        Utils.toast.error(Utils.translate("ERROR.UNKNOWN"));
      }).finally(function () {
        notif.togglingFollow = false;
      });
    }

    function askFollowPermission(notif, newText, oldText, newState, oldState) {
      //WAIT FOR CHANGE AT WS TO GET FRIEND.ID TO UPDATE STATUS
      UserService.toggleFriendhipStateWS({
        userInstanceId: UserService.get_USERSUBSCRIPTIONINSTANCE_ID(),
        friendInstaceId: Utils.getLastUrlComponent(notif.userSubscriptionId.href)
      }).$promise.then(function (response) {
        //Send push notification Follower Follower
        if (response.result.value) {
          var dialogSend = "";
          notif.msgShow = newText;
          notif.meFollow = newState;
          if(newState == 2) {
            notif.waitingAns = true;
          }
          if (notif.privateAccount.result) {
            if (notif.privateAccount.result.value)
              dialogSend = UserService.get_USER_NAME() + ' ' + Utils.translate('NOTIFICATIONS.DIALOG.SEND_REQUEST');
            else 
              dialogSend = UserService.get_USER_NAME() + ' ' + Utils.translate('NOTIFICATIONS.DIALOG.IS_FOLLOWING_YOU');
          } else
            dialogSend = UserService.get_USER_NAME() + ' ' + Utils.translate('NOTIFICATIONS.DIALOG.IS_FOLLOWING_YOU');
            

          UserService.getDevices(Utils.getLastUrlComponent(notif.userSubscriptionId.href)).$promise.then( function (responseEndPoint) {
            //CHECK T/F TO SEND
            responseEndPoint.result.value.forEach( function (endPointArn) {
              AWSServices.sendNotifaboutFollowAction(
                dialogSend,
                endpointArn.title,
                UserService.get_USER_NAME(),
                UserService.get_USERSUBSCRIPTIONINSTANCE_ID()
              )
            })
          })
        }
        else {
          console.warn("toggleFriendhipState", response)
        }
      }, function (error) {
        notif.msgShow = oldText;
        notif.meFollow = oldState;
        console.error("addFriends error", error);
      }).finally(function () {
        notif.togglingFollow = false;
      });
    }

    function acceptRequestFollow(notif, newText, oldText, newState, oldState) {
      //WAIT FOR CHANGE AT WS TO GET FRIEND.ID TO UPDATE STATUS
      UserService.acceptFriend({
        objectId: Utils.getLastUrlComponent(notif.userSubscriptionId.href)
      }).save(function () {
        notif.msgShow = newText;
        notif.itFollows = newState; //al aceptar no cambia mi status hacia ella sino al reves
        notif.togglingFollow = false;
      }, function (error) {
        notif.msgShow = oldText;
        notif.itFollows = oldState; //al aceptar no cambia mi status hacia ella sino al reves
        notif.togglingFollow = false;
        console.error("acceptFriend error", error);
      });
    }

    $scope.sendUserProfile = function (userChosen) {
      reDirectService.reDirectProfile(userChosen);
    };

    $scope.data = {};
}])

//Controller for the list favorites page
.controller('listFavoritesCtrl', ['$scope', '$state', 'TimeLineService', 'ApiEndPoint', 'reDirectService', 'UserService',
  function ($scope, $state, TimeLineService, ApiEndPoint, reDirectService, UserService) {
    //declaration
    $scope.data = {};
    $scope.userSubscriptionInstanceId = window.localStorage.getItem('userSubscriptionInstanceId');
    $scope.start = 0;
    $scope.count = 10;
    $scope.errorLoading = false;
    $scope.noMoreItemsAvailable = false;
    $scope.userFavoritesList = [];

    //function to initialize all data
    $scope.getListOfFavorites = function () {
      TimeLineService.findMyFavoriteFriendsByUserSubscriptionId({"objectId": $scope.userSubscriptionInstanceId}).get(
      {
        "withStart": '"' + $scope.start + '"',
        "withCount": '"' + $scope.count + '"',
      }
        ).$promise.then(function (response) {
          if (response.length > 0) {
            $scope.start += response.length;
            $scope.userFavoritesList.push.apply($scope.userFavoritesList, response);
          } else {
            $scope.noMoreItemsAvailable = true;
          }
          $scope.$broadcast('scroll.infiniteScrollComplete');
        }, function (error) {
          $scope.errorLoading = true;
          $scope.noMoreItemsAvailable = true;
          $scope.$broadcast('scroll.infiniteScrollComplete');
          console.log("sequenceCounts error");
        })
    };

    $scope.retry = function () {
      $scope.errorLoading = false;
      $scope.userFavoritesList = [];
      $scope.noMoreItemsAvailable = false;
      $scope.start = 0;
      $scope.count = 10;
    };

    //Code needed to redirect user to friend's profile
    $scope.sendFriendProfile = function (user) {
      var friendSubscriptionIntanceId = user.href.split('/')[6];
      reDirectService.reDirectProfile(friendSubscriptionIntanceId);
    };

    $scope.addFavorite = function (user) {
      var friendSubscriptionIntanceId = user.userSubscription.href.split('/')[6];
      user.favorite = user.favorite === 0 ? 5 : 0;
      //Find id from "friendship"
      UserService.findFriendInstanceId({
        userId: window.localStorage.getItem("userSubscriptionInstanceId"),
        friendId: friendSubscriptionIntanceId
      }).then(function success(response) {
        if (response.result.value.length > 0) {
          console.log("friend id");
          UserService.favorite({"objectId": response.result.value[0].href.split('/')[6]}).post({
            "int": {
              "value": user.favorite
            }
          }).$promise.then(function success(response) {
            console.log("favorite level");
          }, function error(response) {
            console.log("addFavorite error");
          });
        }
      }, function error(response) {
        console.log("findFriend");
      });
    };
}])

//Controller to comments web page
.controller('commentsCqnzCtrl', ['$rootScope', '$scope', '$state', 'UserService', 'SequenceService', 'cqnzService', 'TagsService', 'GroupFactory', 'CommentFactory', 'permissionValidationService', 'notificationsService', 'Utils',
  function ($rootScope, $scope, $state, UserService, SequenceService, cqnzService, TagsService, GroupFactory, CommentFactory, permissionValidationService, notificationsService, Utils) {
    $scope._controllerName = "commentsCqnzCtrl";
    var params = $state.params.data;
    console.log("params", params);

    //append here the child functions
    //that need tobe executed from this control
    $scope.commentListSharedCtrl = {};

    //$scope.showCommentAvatar = true;

    var pagination = {
      start: 0,
      count: 10
    };

    $scope.noMoreItemsAvailable = false;
    /**@type {SequenceType[]}*/
    $scope._sequenceList = [{
      comments: {
        enabled: true,
        counter: params.totalComments,
        items: []
      }
    }];
    $scope.isFirstTime = true;
    $scope.errorLoading = false;
    $scope.isCreatingComment = false;
    $scope.isRefreshing = false;
    $scope.isLoadingComments = false;

    var totalCommentsInList = 0;

    $scope.findTheCommentsOfASequence = function () {
      $scope.isLoadingComments = true;

      var commentsCountPromises = {};
      var isForSpecificGroup = [undefined, 'undefined', null].indexOf(params.groupId) === -1;

      //todo: perform this task only once??? (not after loading more comments...)
      if (isForSpecificGroup) {
        console.log("Searching for comments in group " + params.groupId + "...");
        commentsCountPromises[params.groupId] = cqnzService.countSequenceCommentsByGroupWS({
          sequenceId: params.sequenceMetadata.id,
          groupId: params.groupId
        }).$promise;
      }
      else if(params.allowedGroups){
        console.log("Searching for comments of post in all of your %d available groups...", params.allowedGroups.length);

        params.allowedGroups.forEach(function (groupId) {
          //console.log("Counting comments for ("+cqnzId+", "+group.id+")");
          commentsCountPromises[groupId] = cqnzService.countSequenceCommentsByGroupWS({
            sequenceId: params.sequenceMetadata.id,
            groupId: groupId
          }).$promise;
        });
      }
      console.log("commentsCountPromises", commentsCountPromises);


      Utils.$q.all(commentsCountPromises).then(function (commentsCounts) {
        console.log('Resolved commentsCounts', commentsCounts);

        var totalComments = 0;
        var commentsPromises = {};
        Object.keys(commentsCounts).forEach(function (groupId) {
          var numOfComments = commentsCounts[groupId].result.value;
          totalComments += numOfComments;

          //console.log("Total comments in group " + groupId + " = "+ totalComments);

          if (numOfComments) {
            console.log("getting comments of (" + params.sequenceMetadata.id + ", " + groupId + ")");
            commentsPromises[groupId] = cqnzService.getCommentsOfSequenceWS({
              sequenceId: params.sequenceMetadata.id,
              start: pagination.start,
              count: pagination.count,
              groupId: groupId
            }).$promise
          }
        });
        console.log("Total comments for post " + params.sequenceMetadata.id + " = " + totalComments);

        console.log("commentsPromises", commentsPromises);
        Utils.$q.all(commentsPromises).then(function (resolvedComments) {
          console.log("resolvedComments", resolvedComments);
          /**@type {CommentRecordType[]}*/
          var parentComments = [];
          //Utils.removeLastItemIfHasNoAttribute(parentComments, 'sequenceComments');
          Object.keys(resolvedComments).forEach(function (groupId) {
            Utils.removeLastItemIfHasNoAttribute(resolvedComments[groupId], 'commentId');
            if (resolvedComments[groupId].length) {
              resolvedComments[groupId].groupId = groupId;
              parentComments = parentComments.concat(resolvedComments[groupId]);
            }
          });

          if (!$scope.isFirstTime) {
            notificationsService.countPendingRegularNotifications(UserService.get_USER_INSTANCE_HREF());
            notificationsService.countPendingFollowersNotifications(UserService.get_USER_INSTANCE_HREF());
          }

          $scope.isFirstTime = false;
          var totalParentsFetched = parentComments.length;
          if (!totalParentsFetched) {
            $scope.isRefreshing = false;
            $scope.noMoreItemsAvailable = true;
            $scope.isLoadingComments = false;
            $scope.$broadcast('scroll.refreshComplete');
            $scope.$broadcast('scroll.infiniteScrollComplete');
            return;
          }

          var totalChildResolved = 0;
          parentComments.forEach(/**@param comment {CommentRecordType}*/function (comment) {
            var parentComment = CommentFactory.buildCommentObject({
              comment: comment,
              sequenceMetadata: params.sequenceMetadata,
              sequenceOwnerMetadata: params.sequenceOwnerMetadata
            });

            if (comment.answerCount) {
              CommentFactory.getCommentReplies({
                commentId: comment.commentId,
                sequenceMetadata: params.sequenceMetadata,
                sequenceOwnerMetadata: params.sequenceOwnerMetadata,
                start: 0,//todo: update this value dynamically
                count: 50//todo: update this value dynamically
              }).then(function (childComments) {
                parentComment.responses = childComments;
                //console.log("Parent comment", parentComment);
                if (!$scope._sequenceList[0].comments.items.length)
                  totalCommentsInList = $scope._sequenceList[0].comments.items.push(parentComment);
                else if (+$scope._sequenceList[0].comments.items[totalCommentsInList - 1].metadata.id !== +parentComment.metadata.id)
                  totalCommentsInList = $scope._sequenceList[0].comments.items.push(parentComment);
              }, function (error) {
                parentComment.responses = [];
                //console.log("Parent comment", parentComment);
                if (!$scope._sequenceList[0].comments.items.length)
                  totalCommentsInList = $scope._sequenceList[0].comments.items.push(parentComment);
                else if (+$scope._sequenceList[0].comments.items[totalCommentsInList - 1].metadata.id !== +parentComment.metadata.id)
                  totalCommentsInList = $scope._sequenceList[0].comments.items.push(parentComment);
              }).finally(function () {
                totalChildResolved++;
                if (totalParentsFetched === totalChildResolved) {
                  //console.log("totalParentsFetched OK");
                  pagination.start = $scope._sequenceList[0].comments.items.length;
                  pagination.count = 15;

                  $scope.isRefreshing = false;
                  $scope.isLoadingComments = false;
                  $scope.$broadcast('scroll.refreshComplete');
                  $scope.$broadcast('scroll.infiniteScrollComplete');
                }
              });//<-- getChildComments.finally()
            }
            else {
              parentComment.responses = [];
              if (!$scope._sequenceList[0].comments.items.length)
                totalCommentsInList = $scope._sequenceList[0].comments.items.push(parentComment);
              else if (+$scope._sequenceList[0].comments.items[totalCommentsInList - 1].metadata.id !== +parentComment.metadata.id)
                totalCommentsInList = $scope._sequenceList[0].comments.items.push(parentComment);

              totalChildResolved++;
              if (totalParentsFetched === totalChildResolved) {
                //console.log("totalParentsFetched OK");
                pagination.start = $scope._sequenceList[0].comments.items.length;
                pagination.count = 15;

                $scope.isRefreshing = false;
                $scope.isLoadingComments = false;
                $scope.$broadcast('scroll.refreshComplete');
                $scope.$broadcast('scroll.infiniteScrollComplete');
              }
            }
          });//<--parent comments.forEach()
        }, function (error) {
          $scope.errorLoading = true;
          $scope.isRefreshing = false;
          $scope.noMoreItemsAvailable = true;
          $scope.isLoadingComments = false;
          $scope.$broadcast('scroll.refreshComplete');
          $scope.$broadcast('scroll.infiniteScrollComplete');
          console.log("getCommentsOfSequenceWS", error);
        });//<--findTheCommentsOfASequencev157 onError()
      }, function (errors) {
        console.error("$q.all(commentsCountPromises)", errors)
      });
    };

    $scope.reloadComments = function () {
      $scope.isFirstTime = true;
      $scope.errorLoading = false;
      pagination.start = 0;
      pagination.count = 10;
      $scope.noMoreItemsAvailable = false;
      $scope._sequenceList[0].comments.items = [];
      $scope.isRefreshing = true;

      $scope.findTheCommentsOfASequence();

      notificationsService.countPendingRegularNotifications(UserService.get_USER_INSTANCE_HREF());
      notificationsService.countPendingFollowersNotifications(UserService.get_USER_INSTANCE_HREF());
    };

    //if cancels the groups dialog, we need to go back to edith the comment
    //and keep the selected @tags if any
    var previousSelectedTags = [];
    /**
    * @param comment? {*}
    */
    $scope.showCommentComposer = function (comment) {
      $scope.commentListSharedCtrl.openTextEditorWithTags(comment).then(function (form) {
        if (["hashtagTimeLineCtrl", "showUserLockerCtrl"].includes(params.controllerName)) {
          var groupsListToShow = GroupFactory.getCurrentAvailableUserGroupsList().filter(function (group) {
            return params.allowedGroups.indexOf(group.id) > -1;
          });

          //insert the default timeline
          if (params.allowedGroups.indexOf(0) > -1) {
            groupsListToShow.unshift({
              id: 0,
              name: "Default timeline",
              backgroundImage: './img/postBg.png',
              image: UserService.get_USER_PHOTO(),
              privacy: Utils.translate('GROUPS.MAIN_PAGE.PUBLIC'),
              imMember: true
            })
          }

          GroupFactory.showGroupsListModal(
            groupsListToShow,
            {
              selectSingleMode: true,
              headerText: Utils.translate('GROUPS.MAIN_PAGE.SELECT_A_GROUP'),
              mainMessage: Utils.translate('GROUPS.MAIN_PAGE.POST_COMMENT_IN_GROUPS_MSG')
            }
          ).then(function (selectedGroupList) {
            console.log("selectedGroupList", selectedGroupList);
            addComments(form, (typeof selectedGroupList[0] === 'number' ? selectedGroupList[0]: selectedGroupList[0].id))
            //addComments(form, the.selected.groupId);
          }, function (/*on cancel dialog...*/) {
            previousSelectedTags = form.savedTags;
            $scope.showCommentComposer({
              editableDescription: form.description,
              imageUrl: form.imagePath
            })
          });
        }
        else
          addComments(form, params.groupId || 0)
      }, function (/*on cancel dialog...*/) {
        if (!params.totalComments && !$scope._sequenceList[0].comments.items.length)
          $rootScope.$ionicGoBack();
      })
    };

    /**
    * @param toGroupId {number}
    * @param form {messageComposerFormType}
    */
    function addComments(form, toGroupId) {
      Utils.loading.show();
      $scope.isCreatingComment = true;

      CommentFactory.createComment({
        sequenceMetadata: params.sequenceMetadata,
        sequenceOwnerMetadata: params.sequenceOwnerMetadata,
        description: form.description,
        tagsList: form.savedTags,
        imageData: form.imagePath,
        groupId: toGroupId
      }).then(/**@param newComment {CommentStructureType}*/function (newComment) {
        if ($scope._sequenceList[0].comments.items.length) {
          if (+$scope._sequenceList[0].comments.items[totalCommentsInList - 1].metadata.id !== +newComment.metadata.id) {
            totalCommentsInList = $scope._sequenceList[0].comments.items.push(newComment);

            Utils.$timeout(function () {
              Utils.$ionicScrollDelegate.resize();
              Utils.$ionicScrollDelegate.scrollBottom();
            }, 800);
          }
        }
        else {
          $scope.$broadcast('scroll.refreshComplete');
          $scope.$broadcast('scroll.infiniteScrollComplete');
          setTimeout(function () {
            Utils.$ionicScrollDelegate.resize();
            Utils.$ionicScrollDelegate.scrollBottom();
          }, 800);
        }
      }, function (error) {
        //the errors are printed inside the function
        Utils.toast.error(Utils.translate("SEQUENCE.DIALOG.CREATE_POST_COMMENT_ERROR"))
      }).finally(function () {
        $scope.isCreatingComment = false;
        Utils.loading.hide();
      });
    }

    if (!params.totalComments)
      Utils.$timeout(function () {//because the function is in the child scope, we need to wait for it
        $scope.showCommentComposer();
      });
    else
      $scope.findTheCommentsOfASequence();
      //---------------------------------
    $rootScope.$on("reply:new", function () {
      if($state.current.name=='commentsCqnz')
      {
        $scope.reloadComments();
      }
    });
}])

.controller('listSharesCtrl', ['$scope', 'ApiEndPoint', 'likeUsersData', 'SequenceService', 'UserService', 'usersData', '$state', 'reDirectService', 'Utils', 'AWSServices',
  function ($scope, ApiEndPoint, likeUsersData, SequenceService, UserService, usersData, $state, reDirectService, Utils, AWSServices) {

    $scope.likeUsersData = likeUsersData;
    $scope.userLikeList = [];
    $scope.noMoreItemsAvailable = false;
    $scope.start = 0;
    $scope.count = 10;
    $scope.errorLoading = false;
    $scope.totalShares = $state.params.number;
    //function to load al the data needed
    /*TEXT ZONE FOR MESSAGES*/
      $scope.followText = Utils.translate('GLOBAL.FOLLOW'); //Follow
      $scope.followingText = Utils.translate('GLOBAL.FOLLOWING'); //Following
      $scope.unfollowText = Utils.translate('GLOBAL.UNFOLLOW'); //UnFollow
      $scope.pendingRequest = Utils.translate('GLOBAL.PENDING'); //Pending request
      $scope.acceptPendingRequest = Utils.translate('GLOBAL.ACCEPT'); //Accept
      $scope.acceptedPendingRequest = Utils.translate('GLOBAL.ACCEPTED'); //Accepted
      $scope.friendsNow = Utils.translate('GLOBAL.FRIENDS'); //Friends
      $scope.waitingNow = Utils.translate('GLOBAL.WAITING'); //Waiting
    /*END TEXT ZONE FOR MESSAGES*/
    var mySubscriptionId = UserService.get_USERSUBSCRIPTIONINSTANCE_ID();
    $scope.compareID = UserService.get_USERSUBSCRIPTIONINSTANCE_ID();
    $scope.loadMore = function () {
      SequenceService.findSequenceCountByType({
        sequence: $scope.likeUsersData.data,
        type: 'Share',
        start: $scope.start,
        count: $scope.count
      }).$promise.then(function success(response) {
        if (response.length > 1) {
          response.length--;
          $scope.start += response.length;
          response.forEach( function (data) {
            $scope.userLikeList.push(data);
          })
          $scope.userLikeList.forEach( function (usersData) {
            $scope.getFollowStatus(usersData);
            $scope.getPrivateStatus(usersData);
          })
          //$scope.userLikeList.push.apply($scope.userLikeList, response);
        } else {
          $scope.noMoreItemsAvailable = true;
        }
        $scope.$broadcast('scroll.infiniteScrollComplete');
      }, function error(err) {
        console.log("mistake", err);
        $scope.errorLoading = true;
        $scope.noMoreItemsAvailable = true;
        $scope.$broadcast('scroll.infiniteScrollComplete');
        console.log("sequenceCounts error");
      })
    };

    $scope.retry = function () {
      $scope.errorLoading = false;
      $scope.userLikeList = [];
      $scope.noMoreItemsAvailable = false;
      $scope.start = 0;
      $scope.count = 10;
    };

    $scope.getFollowStatus = function (data) {
      //obtener status del otro usuario a mi
      var otherMe = UserService.getStatusPrivateRequest({
        userId: Utils.getLastUrlComponent(data.userSubscriptionId.href),
        friendId: UserService.get_USERSUBSCRIPTIONINSTANCE_ID()
      }).$promise;
      //obtener status de  mi al otro usuario
      var meOther = UserService.getStatusPrivateRequest({
        userId: UserService.get_USERSUBSCRIPTIONINSTANCE_ID(),
        friendId: Utils.getLastUrlComponent(data.userSubscriptionId.href)
      }).$promise;

      //work with both
      Utils.$q.all({
        OthersToMe: otherMe,
        meToOthers: meOther
      }).then(function (currentStatus) {
        if(currentStatus.OthersToMe.status == 1) {
          if(currentStatus.meToOthers.status == 1) {
            data.msgShow = $scope.followingText;
            data.itFollows = 1;
            data.meFollow = 1;
            data.isActive = true;
            data.waitingAns = false;
            data.shutdownButton = false;
          } else if(currentStatus.meToOthers.status == 2) {
            data.msgShow = $scope.waitingNow;
            data.itFollows = 1;
            data.meFollow = 2;
            data.isActive = true;
            data.waitingAns = true;
            data.shutdownButton = false;
          } else if(currentStatus.meToOthers.status == 3) {
            data.msgShow = $scope.followText;
            data.itFollows = 1;
            data.meFollow = 3;
            data.isActive = true;
            data.waitingAns = false;
            data.shutdownButton = false;
          }
        } else if(currentStatus.OthersToMe.status == 2) {
          if(currentStatus.meToOthers.status == 1) {
            data.msgShow = $scope.acceptPendingRequest;
            data.itFollows = 2;
            data.meFollow = 1;
            data.isActive = true;
            data.waitingAns = false;
            data.shutdownButton = false;
          } else if(currentStatus.meToOthers.status == 2) {
            data.msgShow = $scope.acceptPendingRequest;
            data.itFollows = 2;
            data.meFollow = 2;
            data.isActive = true;
            data.waitingAns = true;
            data.shutdownButton = false;
          } else if(currentStatus.meToOthers.status == 3) {
            data.msgShow = $scope.acceptPendingRequest;
            data.itFollows = 2;
            data.meFollow = 3;
            data.isActive = true;
            data.waitingAns = false;
            data.shutdownButton = false;
          }
        } else if(currentStatus.OthersToMe.status == 3) {
          if(currentStatus.meToOthers.status == 1) {
            data.msgShow = $scope.followingText;
            data.itFollows = 3;
            data.meFollow = 1;
            data.isActive = true;
            data.waitingAns = false;
            data.shutdownButton = false;
          } else if(currentStatus.meToOthers.status == 2) {
            data.msgShow = $scope.waitingNow;
            data.itFollows = 3;
            data.meFollow = 2;
            data.isActive = true;
            data.waitingAns = true;
            data.shutdownButton = false;
          } else if(currentStatus.meToOthers.status == 3) {
            data.msgShow = $scope.followText;
            data.itFollows = 3;
            data.meFollow = 3;
            data.isActive = true;
            data.waitingAns = false;
            data.shutdownButton = false;
          }
        }
        console.log("checking", $scope.userLikeList);
      })
    }

    $scope.getPrivateStatus = function (data) {
      data.privateAccount = UserService.getStatusPrivateAccount({
        "objectId": Utils.getLastUrlComponent(data.userSubscriptionId.href)
      }).get();
    }

    $scope.changeStatusFriend = function(notif) {
      if(notif.shutdownButton || notif.togglingFollow)
        return false;

      notif.togglingFollow = true;
      var prevText = notif.msgShow;
      notif.isActive = false;
      notif.msgShow = "-----------";
      if(notif.itFollows == 1) {
          if(notif.meFollow == 1) {
            ceaseFollowStatus(notif, $scope.followText, prevText, 3, 1);
          } else if(notif.meFollow == 2) {
            ceaseFollowStatus(notif, $scope.followText, prevText, 3, 2);
          } else if(notif.meFollow == 3) {
            if(notif.privateAccount.result) {
              if(notif.privateAccount.result.value)
                askFollowPermission(notif, $scope.waitingNow, prevText, 2, 3);
              else
                askFollowPermission(notif, $scope.followingText, prevText, 1, 3);
            } else
                askFollowPermission(notif, $scope.followingText, prevText, 1, 3);
          }
      } else if(notif.itFollows == 2) {
          if(notif.meFollow == 1) {
            acceptRequestFollow(notif, $scope.followingText, prevText, 1, 2);
          } else if(notif.meFollow == 2) {
            acceptRequestFollow(notif, $scope.waitingNow, prevText, 1, 2);
          } else if(notif.meFollow == 3) {
            acceptRequestFollow(notif, $scope.followText, prevText, 1, 2);
          }
      } else if(notif.itFollows == 3) {
          if(notif.meFollow == 1) {
            ceaseFollowStatus(notif, $scope.followText, prevText, 3, 1);
          } else if(notif.meFollow == 2) {
            ceaseFollowStatus(notif, $scope.followText, prevText, 3, 2);
          } else if(notif.meFollow == 3) {
            if(notif.privateAccount.result) {
              if(notif.privateAccount.result.value)
                askFollowPermission(notif, $scope.waitingNow, prevText, 2, 3);
              else
                askFollowPermission(notif, $scope.followingText, prevText, 1, 3);
            } else
              askFollowPermission(notif, $scope.followingText, prevText, 1, 3);
          }
      }
    }

    function ceaseFollowStatus(notif, newText, oldText, newState, oldState) {
      //WAIT FOR CHANGE AT WS TO GET FRIEND.ID TO UPDATE STATUS
      UserService.cancelRequestToPrivate({
        objectId: Utils.getLastUrlComponent(notif.userSubscriptionId.href) 
      }).save().$promise.then(function success(response) {
        notif.msgShow = newText;
        notif.simpleIdFriend = "";
        notif.waitingAns = false;
        notif.meFollow = newState;
      }, function (err) {
        
        notif.msgShow = oldText;
        notif.meFollow = oldState;
        console.error("cancel Request ToPrivate", err);
        Utils.toast.error(Utils.translate("ERROR.UNKNOWN"));
      }).finally(function () {
        notif.togglingFollow = false;
      });
    }

    function askFollowPermission(notif, newText, oldText, newState, oldState) {
      //WAIT FOR CHANGE AT WS TO GET FRIEND.ID TO UPDATE STATUS
      UserService.toggleFriendhipStateWS({
        userInstanceId: UserService.get_USERSUBSCRIPTIONINSTANCE_ID(),
        friendInstaceId: Utils.getLastUrlComponent(notif.userSubscriptionId.href)
      }).$promise.then(function (response) {
        //Send push notification Follower Follower
        if (response.result.value) {
          var dialogSend = "";
          notif.msgShow = newText;
          notif.meFollow = newState;
          if(newState == 2) {
            notif.waitingAns = true;
          }
          if (notif.privateAccount.result) {
            if (notif.privateAccount.result.value)
              dialogSend = UserService.get_USER_NAME() + ' ' + Utils.translate('NOTIFICATIONS.DIALOG.SEND_REQUEST');
            else 
              dialogSend = UserService.get_USER_NAME() + ' ' + Utils.translate('NOTIFICATIONS.DIALOG.IS_FOLLOWING_YOU');
          } else
            dialogSend = UserService.get_USER_NAME() + ' ' + Utils.translate('NOTIFICATIONS.DIALOG.IS_FOLLOWING_YOU');
            

          UserService.getDevices(Utils.getLastUrlComponent(notif.userSubscriptionId.href)).$promise.then( function (responseEndPoint) {
            //CHECK T/F TO SEND
            responseEndPoint.result.value.forEach( function (endPointArn) {
              AWSServices.sendNotifaboutFollowAction(
                dialogSend,
                endpointArn.title,
                UserService.get_USER_NAME(),
                UserService.get_USERSUBSCRIPTIONINSTANCE_ID()
              )
            })
          })
        }
        else {
          console.warn("toggleFriendhipState", response)
        }
      }, function (error) {
        notif.msgShow = oldText;
        notif.meFollow = oldState;
        console.error("addFriends error", error);
      }).finally(function () {
        notif.togglingFollow = false;
      });
    }

    function acceptRequestFollow(notif, newText, oldText, newState, oldState) {
      //WAIT FOR CHANGE AT WS TO GET FRIEND.ID TO UPDATE STATUS
      UserService.acceptFriend({
        objectId: Utils.getLastUrlComponent(notif.userSubscriptionId.href)
      }).save(function () {
        notif.msgShow = newText;
        notif.itFollows = newState; //al aceptar no cambia mi status hacia ella sino al reves
        notif.togglingFollow = false;
      }, function (error) {
        notif.msgShow = oldText;
        notif.itFollows = oldState; //al aceptar no cambia mi status hacia ella sino al reves
        notif.togglingFollow = false;
        console.error("acceptFriend error", error);
      });
    }

    $scope.sendUserProfile = function (userChosen) {
      reDirectService.reDirectProfile(userChosen);
    };

    $scope.data = {};
}])

.controller('listBlockUsers', ['$scope', 'ApiEndPoint', 'SequenceService', 'UserService', 'usersData', '$state', 'reDirectService', 'Utils',
  function ($scope, ApiEndPoint, SequenceService, UserService, usersData, $state, reDirectService, Utils) {

    $scope.start = 0;
    $scope.count = 10;
    $scope.errorLoading = false;
    $scope.noMoreItemsAvailable = false;
    $scope.blackListUsers = [];
    var myUserId = UserService.get_USERSUBSCRIPTIONINSTANCE_ID();

    $scope.loadList = function () {
      UserService.findBlackListbyOwnerId(
        window.localStorage.getItem("userSubscriptionInstanceId"),
        $scope.start,
        $scope.count
      ).then(
        function (listData) {
          console.log(listData);
          if (listData.length > 1) {
            listData.length--;
            $scope.start += listData.length;
            //$scope.blackListUsers.push.apply($scope.blackListUsers, listData);

            listData.forEach(function (user) {
              //var userBlocked = UserService.getUserSubscriptionByinstanceId(Utils.getLastUrlComponent(user.userBlocked.href));
              var userBlocked = UserService.getUserSubscriptionByinstanceIdProfileData(Utils.getLastUrlComponent(user.userBlocked.href));
              $scope.blackListUsers.push({
                userBlockedInfo: userBlocked,
              })
            });
          } else {
            $scope.noMoreItemsAvailable = true;
          }
          $scope.$broadcast('scroll.infiniteScrollComplete');
        }, function (err) {
          console.log("mistake", err);
          $scope.errorLoading = true;
          $scope.noMoreItemsAvailable = true;
          $scope.$broadcast('scroll.infiniteScrollComplete');
          console.log("sequenceCounts error");
        })
    };
    //$scope.loadList();

    $scope.retry = function () {
      $scope.errorLoading = false;
      $scope.blackListUsers = [];
      $scope.noMoreItemsAvailable = false;
      $scope.start = 0;
      $scope.count = 10;
    };

    $scope.unblock = function (user) {
      var msg = Utils.translate('GLOBAL.ASK_USERUNBLOCK');
      Utils.confirm.show(msg).then(function (boolResp) {
        if (!boolResp) return;
        unblockToUser(user);
      })
    }

    function unblockToUser(user) {
      Utils.loading.show();
      UserService.unblockUser(
        myUserId,
        user.userSubscriptionId.href.split('/')[6]
      ).then(function () {
        Utils.loading.hide();
        $scope.retry();
      }, function (response) {
        console.log("unblockUser error");
      }).finally(function () {
        Utils.loading.hide();
      });
    }

    $scope.sendUserProfile = function (user) {
      reDirectService.reDirectProfile(user);
    };
}])
;
