"use strict";
appControllers
  .controller('GalleryCtrl',
    function ($scope, $timeout, $ionicBackdrop, $ionicPopup, $ionicModal, $cordovaCamera, $cordovaImagePicker, $cordovaFile, $cordovaCapture, $ionicSlideBoxDelegate, $ionicScrollDelegate, $ionicPlatform, UserService, ionicService, SequenceService, ApiEndPoint, AWSServices, permissionValidationService, notificationsService, Utils, adsService) {

      $scope.showReactPicture = function (sequencePicture, reactPicture, index, description) {
        $scope.loadingInit = 1;
        $scope.activeSlide = index;
        var myVarPicture = $ionicPopup.show({
          scope: $scope,
          animation: 'zoom-from-center',
          templateUrl: 'templates/reactZoomView.html'
        });
        $timeout(function () {
          $scope.reactPictures = {
            "sequencePicture": sequencePicture,
            "reactPicture": reactPicture,
            "description": description
          };
        }, 200);

        $scope.myReactPicture = function () {
          $scope.reactPictures = {};
          myVarPicture.close();
        };
      };

      $scope.showImages = function (sequenceId, pictures, index, userSubscriptionInstanceId, extra, url) {

        //NEW VALIDATION, IF THE POST HAVE URL: IGNORE IMAGES and open url
        if(url.have && url.url != " ") {
          //forget any gallery, send to url
          var isIOS = ionic.Platform.isIOS();
          var zone = '_blank';
          var opt = '';
          if(isIOS){
            zone = '_blank';
            opt = 'clearsessioncache=yes,usewkwebview=yes,toolbar=yes,presentationstyle=fullscreen,hidespinner=yes,closebuttoncaption=Close,closebuttoncolor=#ffffff4,navigationbuttoncolor=#ffffff,lefttoright=yes,location=no';
          }
          else{
            zone ='_blank';
            opt = 'clearsessioncache=yes,usewkwebview=yes,toolbar=yes,presentationstyle=fullscreen,hidespinner=yes,closebuttoncaptionSet=Close,closeButtonColorSet=#ffffff4,navigationbuttoncolorSet=#ffffff,lefttoright=yes,location=no';
          }
          if( (url.url.startsWith("Https://") || url.url.startsWith("https://")) || (url.url.startsWith("Http://") || url.url.startsWith("http://")) ){
            var ref = cordova.InAppBrowser.open( url.url, zone, opt);
          }
          else{
            var ref = cordova.InAppBrowser.open( "Https://"+url.url, zone, opt);
          }
        } else {
          $scope.picturesItem = [];
          $scope.loadingInit = 1;
          $scope.activeSlide = index;

          if(!extra.belongsMe) {
            if(extra.isAdvertisement) {
              //if the sequence isn't mine and its an advertisement
              //add one click to the count before send it to gallery
              adsService.increaseClicksCount(extra.instanceId).then( function () {
                console.log("added one click count")
              }, function (error) {
                console.error("can't increase click count")
              })
            }
          }

          console.log("pictures", pictures);
          pictures.forEach(function (picture) {
            if(!picture.itemId) return;//continues in this context

            var item = {
              src: '',
              sequenceItemId: picture.sequenceItem.href.split('/')[6],
              likeCount: picture.likeCount,
              likeActive: likeItemIsActive(picture.sequenceItem.href.split('/')[6]),
              userSubscriptionInstanceId: userSubscriptionInstanceId,
              itemId: picture.itemId,
              key: index
            };

            if (picture.url != null) {
              item.src = picture.url;
              $scope.picturesItem.push(item);
            }
            else{
              Utils.toast.error("Sorry, we couldn't find the image URL")
            }
          });

          $scope.showModal('templates/gallery-zoomview2.html');
          $scope.loadingInit = 0;
        }
          
      };

      $scope.showProfileImage = function () {
        $scope.showModal('templates/Profiles/friendProfilePicture.html');
      };

      function likeItemIsActive(sequenceItem) {
        return SequenceService.findSmileysItemCount().get(
          {
            "x-isis-querystring":
              {
                "sequenceItem": {
                  "value": {
                    "href": ApiEndPoint.url + "restful/objects/simple.SequenceItem/" + sequenceItem
                  }
                },
                "userSubs": {
                  "value": {
                    "href": ApiEndPoint.url + "restful/objects/simple.UserSubscription/" + window.localStorage.getItem('userSubscriptionInstanceId')
                  }
                }

              }
          }, function () {
          }, function (response) {
            console.log("findSmileysItemCount error");
          });
      }


      $scope.setLikeToItem = function (item, index) {
        if (!permissionValidationService.amISuperAdmin() && $scope.previewTimeline) {
          Utils.toast.warning(Utils.translate('PERMISSIONS.CANNOT.PERFORM_ACTION_ON_PREVIEW'));
          return;
        }

        item.likeActive.result.value = !item.likeActive.result.value;

        if (item.likeActive.result.value) {
          item.likeCount++;
          happyonItem(item.sequenceItemId);
        }
        else {
          item.likeCount--;
          happyoffItem(item.sequenceItemId);
        }

        SequenceService.setLikeToItem({"objectId": item.sequenceItemId}).save(
          {
            "userSubscription": {
              "value": {
                "href": ApiEndPoint.url + "restful/objects/simple.UserSubscription/" + window.localStorage.getItem('userSubscriptionInstanceId')
              }
            }
          }, function (response) {
            //Send Push Notification Like SequenceItem
            if (response.result.value && item.userSubscriptionInstanceId != window.localStorage.getItem('userSubscriptionInstanceId')) {
              var message = UserService.get_USER_NAME()+ " " + Utils.translate('ALERTS.LIKE_PHOTO');
              /*notificationsService.sendNotificationToUserDevices(
                item.userSubscriptionInstanceId, message
              ).then(function () {
              }, function (error) {
              });*/
              notificationsService.sendDeepNotificationToUserDevices(
                item.userSubscriptionInstanceId,
                message,
                'LIKE',
                item.sequenceItemId
              ).then(function () {
              }, function (error) {
                console.error("sendNotificationToUserDevices", error)
              });
            }
          }, function (error) {
            console.log("setLikeToItem error");
            item.likeActive.result.value = !item.likeActive.result.value;

            if (item.likeActive.result.value) {
              item.likeCount++;
              happyonItem(item.sequenceItemId);
            }
            else {
              item.likeCount--;
              happyoffItem(item.sequenceItemId);
            }
          });
      };

      $scope.ready = false;
      $scope.images = [];

      $scope.selectImages = function () {
        var options = {
          limit: 10
        };

        $cordovaCapture.captureImage(options).then(function (results) {
          for (var i = 0; i < results.length; i++) {
            $scope.images.push(results[i].fullPath);
          }
          if (!$scope.$$phase) {
            $scope.$apply();
          }
        }, function (error) {
          console.log("captureImage error");
        });
      };

      $scope.likeMinusOrAddOneItem = function (add, likeCount) {

        if (add == -1) {
          $scope.likeCountItem = likeCount - 1;
          $scope.sequenceLikeCountItem = $scope.likeCountItem;
        }
        else {
          $scope.likeCountItem = likeCount + 1;
          $scope.likeCountAddOneItem = $scope.likeCountItem;
        }
      };

      $scope.likeCountAddOneItem = function (likeAddOne) {
        return likeAddOne;
      };

      $scope.sequenceLikeCountItem = function (likeCount) {
        return likeCount;
      };

      function happyonItem(itemId) {
        document.getElementById('happyonItem' + itemId).style.display = 'block';
        document.getElementById('happyoffItem' + itemId).style.display = 'none';
        document.getElementById('happyNumberonItem' + itemId).style.display = 'block';
        document.getElementById('happyNumberoffItem' + itemId).style.display = 'none';
        document.getElementById('happyNumberoffItem' + itemId).className = "off1";
      };

      function happyoffItem(itemId) {
        document.getElementById('happyonItem' + itemId).style.display = 'none';
        document.getElementById('happyoffItem' + itemId).style.display = 'block';
        document.getElementById('happyNumberonItem' + itemId).style.display = 'none';
        document.getElementById('happyNumberoffItem' + itemId).style.display = 'block';
        document.getElementById('happyNumberoffItem' + itemId).className = "on1";
      };

      $scope.setImagesGalery = function () {
      };

      $scope.zoomMin = 1;

      $scope.showImages2 = function () {
        $scope.showModal('templates/gallery-zoomview2.html');
      };

      $scope.showImages3 = function (index3) {
        $scope.activeSlide = index3;
        $scope.showModal('templates/gallery-zoomview3.html');
      };

      $scope.showModal = function (templateUrl) {
        $ionicModal.fromTemplateUrl(templateUrl, {
          scope: $scope,
          animation: 'zoom-from-center'
        }).then(function (modal) {
          $scope.modal = modal;
          $scope.modal.show();
        });
      };

      $scope.zoomStatus = 0;

      $scope.closeModal = function () {
        $scope.modal.hide();
        $scope.modal.remove();
      };

      $scope.zoomMin = 1;

      $scope.doubleTapped = function (slide) {
        if ($scope.zoomStatus === 0) {
          $ionicScrollDelegate.$getByHandle('scrollHandle' + slide).zoomBy(2, true);
          $scope.zoomStatus++;
        } else {
          $ionicScrollDelegate.$getByHandle('scrollHandle' + slide).zoomBy(0, true);
          $scope.zoomStatus--;
        }
      };

      $scope.updateSlideStatus = function (slide) {
        var zoomFactor = $ionicScrollDelegate.$getByHandle('scrollHandle' + slide).getScrollPosition().zoom;
        if (zoomFactor == $scope.zoomMin) {
          $ionicSlideBoxDelegate.enableSlide(true);
        } else {
          $ionicSlideBoxDelegate.enableSlide(false);
        }
      };
    })

  .controller('UserCtrl', ['$scope', '$state', '$timeout', '$ionicActionSheet', '$cordovaDevice', '$cordovaFile', '$ionicPlatform', '$ionicPopup', 'UserService', 'ApiEndPoint', 'AuthService', 'ImageService2', 'FileService2', 'usersData', 'followersData', 'friendsData', 'pendingNotificationData', '$interval', 'changeProfilePictureService', '$ionicPush', 'ionicService', 'reDirectService', '$filter', 's3', 'md5', 'Utils', 'AWSServices', 'chatService', '$rootScope', '$jrCrop', 'GroupsService', '$ionicHistory',
    function ($scope, $state, $timeout, $ionicActionSheet, $cordovaDevice, $cordovaFile, $ionicPlatform, $ionicPopup, UserService, ApiEndPoint, AuthService, ImageService2, FileService2, usersData, followersData, friendsData, pendingNotificationData, $interval, changeProfilePictureService, $ionicPush, ionicService, reDirectService, $filter, s3, md5, Utils, AWSServices, chatService, $rootScope, $jrCrop, GroupsService, $ionicHistory) {

      console.log("UserCtrl created!!!")
      $scope.newReactImage = [];
      $scope.newProfileImage = [];
      $scope.newBackImage = [];
      var isIOS = ionic.Platform.isIOS();
      $scope.followers = {
        countFollowers: 0,
        followersName: []
      };

      $scope.friends = {
        countFriends: 0,
        friendsName: []
      };

      $scope.pictureProfile = window.localStorage.getItem("photoProfileBlob") !== null ? window.localStorage.getItem("photoProfileBlob") + '?decache=' + Math.random() : "img/ProfilePhoto.svg";
      $scope.nameProfile = window.localStorage.getItem("userName");
      $scope.pictureBackground = window.localStorage.getItem("bkgMyProfile") !== null ? window.localStorage.getItem("bkgMyProfile") + '?decache=' + Math.random() : "./img/postBg.png";

      $scope.$on('cloud:push:notification', function () {
        //TODO add push notification handler function
        //var msg = data.message;
        //alert(msg.title + ': ' + msg.text);
      });

      $scope.verifiedUser = function () {
        UserService.findUserSubscriptionById().get({
          "userSubscriptionId": '"' + window.localStorage.getItem("userSubscriptionId") + '"'
        }, function (response) {
          $scope.verifyUser = response[0].verifyUser;
        }, function (error) {
          console.log("findUserSubscriptionById error");
        });
      };

      $scope.addFriends = function (userSubscriptionId, isFriend) {
        console.log("isFriend");
        UserService.toggleFriendhipStateWS({
          userInstanceId: UserService.get_USERSUBSCRIPTIONINSTANCE_ID(),
          friendInstaceId: userSubscriptionId
        }).$promise.then(function () {
        }, function (response) {
          console.log("addFriends error");
        });
      };

      $scope.getFollowingIsActive = function (friendId) {
        return UserService.getFollowingIsActiveWS({
          userInstanceId:UserService.get_USERSUBSCRIPTIONINSTANCE_ID(),
          friendInstaceId: friendId
        }).$promise.then(function (data) {
            //console.log(data);
          }, function (error) {
            console.error("getFollowingIsActive ", error);
          });
      };

      $scope.blockToUser = function (friendId) {
        $scope.blockUserById = UserService.blockToUser({"objectId": window.localStorage.getItem("userSubscriptionInstanceId")}).save({
          "userSubscription":
            {
              "value":
                {
                  "href": ApiEndPoint.url + 'restful/objects/simple.UserSubscription/' + friendId
                }
            }
        }, function () {
          $scope.findBlockUserById(friendId);
        }, function (response) {
          console.log("blockToUser error");
        });

        return $scope.blockUserById;
      };

      $scope.unblockToUser = function (friendId) {
        $scope.unblockUserById = UserService.unblockUser({"objectId": window.localStorage.getItem("userSubscriptionInstanceId")}).save({
          "userSubscription":
            {
              "value":
                {
                  "href": ApiEndPoint.url + 'restful/objects/simple.UserSubscription/' + friendId
                }
            }
        }, function () {
          $scope.findBlockUserById(friendId);
        }, function (response) {
          console.log("unblockUser error");
        });

        return $scope.unblockUserById;
      };

      $scope.updatePassword = function (oldPassword, newPassword, retypePassword) {
        Utils.loading.show();
        var oldData = window.localStorage.getItem("EndpointArn");
        if (oldData !== null) {
          UserService.deleteDevice()
            .get({"string": oldData}).$promise.then(function (data) {
            //after delete userDevice change password
            UserService.updatePassword({objectId: window.localStorage.getItem("applicationUser").split('/')[6]}).put({
              existingPassword: {
                value: oldPassword
              },
              newPassword: {
                value: newPassword
              },
              "re-enterPassword": {
                value: retypePassword
              }
            }).$promise.then(function (response) {
              AWSServices.deletePlatformEndpoint(1);
              Utils.toast.success(Utils.translate('MENU.SETTINGS.UPDATE_PASSWORD.SUCCESS'));
              AuthService.logout();
              $state.go('login', {}, {reload: true});
            }, function (error) {
              console.log("updatePassword error");
            }).finally(function () {
              Utils.loading.hide();
            });
          }, function error(err) {
            console.log("delete Device error:", err);
            Utils.loading.hide();
          });
        } else{
          if(window.localStorage.getItem("applicationUser")) {
            UserService.updatePassword({
              objectId: window.localStorage.getItem("applicationUser").split('/')[6]
            }).put({
              existingPassword: {
                value: oldPassword
              },
              newPassword: {
                value: newPassword
              },
              "re-enterPassword": {
                value: retypePassword
              }
            }).$promise.then(function (response) {
              Utils.toast.success(Utils.translate('MENU.SETTINGS.UPDATE_PASSWORD.SUCCESS'));
              AuthService.logout();
              $state.go('login', {}, {reload: true});
            }, function (error) {
              console.log("updatePassword error");
            }).finally(function () {
              Utils.loading.hide();
            })
          } else {
            console.warn("updatePassword: No oldData found!");
            Utils.loading.hide();
          }
        }
      };

      $scope.sendEmail = function () {
        UserService.sendEmail({"objectId": window.localStorage.getItem("simpleUserId")}).save({
          "string1": {"value": "support@mycqnz.zohosupport.com"},
          "string2": {"value": "Password Update"},
          "string3": {"value": "Your password has been succesfully updated!!!"}
        }, function () {
          $ionicPopup.alert({
            //template: 'A confirmation message will be sent to your email',
            template: $filter('translate')('MENU.UPDATE_PASSWORD.CONFIRM_PASS_UPDATE'),
            cssClass: 'alertPopUp',
            okType: 'button-assertive'
          });
        }, function (response) {
          console.log("sendEmail error");
        });
      };

      $scope.sendEmailReset = function (email) {
        $scope.AuthLog($scope, AuthService, "sven", 'm<}WU6ZEFvKqks-"');
        UserService.sendEmail({"objectId": 1}).save({
          "string1": {"value": email},
          "string2": {"value": "Password Update"},
          "string3": {"value": "Your password has been succesfully updated!!!"}
        }, function () {
          $ionicPopup.alert({
            //template: 'A confirmation message will be sent to your email',
            template: $filter('translate')('MENU.UPDATE_PASSWORD.CONFIRM_PASS_UPDATE'),
            cssClass: 'alertPopUp',
            okType: 'button-assertive'
          });
          AuthService.logout();
        }, function (response) {
          console.log("sendEmail error");
        });
      };

      $scope.findBlockUserById = function (friendId) {
        return UserService.findBlockUserById().get({
          "x-isis-querystring":
            {
              "userSubscriptionId":
                {
                  "value":
                    {
                      "href": ApiEndPoint.url + 'restful/objects/simple.UserSubscription/' + window.localStorage.getItem("userSubscriptionInstanceId")
                    }
                },
              "userBlockedId":
                {
                  "value":
                    {
                      "href": ApiEndPoint.url + 'restful/objects/simple.UserSubscription/' + friendId
                    }
                }
            }
        }, function () {
        }, function (response) {
          console.log("findBlockUserById error");
        });
      };

      $scope.sendNewPassword = function (userName, securityAnswer) {
        AuthService.login("sven", 'm<}WU6ZEFvKqks-"').then(
          function () {
            UserService.sendNewPassword().post(
              {
                "userName": {"value": userName},
                "passwordRecoveryAnswer": {"value": securityAnswer}
              }, function () {
                $ionicPopup.alert({
                  //template: 'A confirmation message will be sent to your email',
                  template: $filter('translate')('MENU.UPDATE_PASSWORD.SEND_PASSWORD_EMAIL'),
                  cssClass: 'alertPopUp',
                  okType: 'button-assertive'
                });
                AuthService.logout();
                var oldData = JSON.parse(window.localStorage.getItem("AWSToken"));
                if (oldData !== null) {
                  UserService.deleteDevice()
                    .get({"string": oldData}).$promise.then(function (data) {
                    //console.log(data);
                  }, function errro(error) {
                    console.log("deleteSequence error:");
                  });
                }
                //window.localStorage.clear();
                AWSServices.deletePlatformEndpoint(1);
                $state.go('login', {}, {reload: true});
              }, function () {
                $ionicPopup.alert({
                  //template: 'The secret answer is incorrect',
                  template: $filter('translate')('MENU.UPDATE_PASSWORD.SECRET_ANSWER_INCORRECT'),
                  cssClass: 'alertPopUp',
                  okType: 'button-assertive'
                });
                AuthService.logout();
              });
          }, function (response) {
            console.log("sendNewPassword error");
            $scope.error = "Wrong user or pass";
          }
        );
      };

      $scope.checkUserName = function (userName) {
        AuthService.login("sven", 'm<}WU6ZEFvKqks-"').then(
          function () {
            $scope.userByUsername = UserService.findUserByUserName().get(
              {"userName": userName}, function () {
                AuthService.logout();
              }, function (response) {
                console.log("findUserByUserName error");
                AuthService.logout();
              });
          }, function (response) {
            console.log("login error");
            $scope.error = "Wrong user or pass";
          }
        );
      };

      $scope.Auth = function ($scope, AuthService) {
        var username = 'sven';
        var password = 'm<}WU6ZEFvKqks-"';
        AuthService.login(username, password).then(
          function () {
            console.log("Access with sven");
            //$scope.findByWebUserId($scope);
          }, function () {
            console.log("Error login with sven");
            $scope.error = "Wrong user or pass";
          }
        );
      };

      /*$scope.showPopUpNotificationsByUserSubscription = function (){
        $state.go('menu.notifications', {}, {reload: true});
      };*/

      $scope.acceptFriend = function (friend) {
        UserService.acceptFriend({"objectId": friend.split('/')[6]}).save(
          function () {
            document.getElementById("accept").style.display = "none";
            document.getElementById("accepted").style.display = "block";
          }, function (response) {
            console.log("acceptFriend error");
          });
      };

      FileService2.cleanImages();
      $scope.newProfileImage = FileService2.images();
      $scope.newBackImage = FileService2.images();
      $scope.newReactImage = FileService2.images();

      $scope.checkBefore = function (type) {
        if(isIOS === true) {
          //getPermission(0);
          if(type === 'p'){ //profile main photo
            $scope.addMedia();
          } else if(type === 'b'){ //profile background photo
            $scope.addMediaBack();
          } else if(type === 'rBegin' || type === 'rOpt') {
            $scope.addMediaReact(type);
          }
        } else {
          getMultiplePermissions(type);
        }
      };

      /**
       *function to get multiple permission for camera
       */
      function getMultiplePermissions(type) {
        cordova.plugins.diagnostic.getPermissionsAuthorizationStatus(function(statuses) {
          var havePerm = 0;
          var deniedPerm = false;
          for (var permission in statuses){
            switch(statuses[permission]){
              case cordova.plugins.diagnostic.permissionStatus.GRANTED:
                console.log("Permission granted to use "+permission);
                havePerm++;
                break;
              case cordova.plugins.diagnostic.permissionStatus.NOT_REQUESTED:
                console.log("Permission to use "+permission+" has not been requested yet");
                havePerm--;
                break;
              case cordova.plugins.diagnostic.permissionStatus.DENIED:
                console.log("Permission denied to use "+permission+" - ask again?");
                havePerm--;
                break;
              case cordova.plugins.diagnostic.permissionStatus.DENIED_ALWAYS:
                console.log("Permission permanently denied to use "+permission+" - guess we won't be using it then!");
                deniedPerm = true;
                break;
            }
          }
          if(!deniedPerm){
            if(havePerm == 2){
              //have both permissions granted
              if(type === 'p'){ //profile main photo
                $scope.addMedia();
              } else if(type === 'b'){ //profile background photo
                $scope.addMediaBack();
              } else if(type === 'rBegin' || type === 'rOpt') {
                $scope.addMediaReact(type);
              }
            } else if(havePerm <2){
              //both or one permission hasn't granted
              askMultiplePermissions(type);
            }
          } else {
            Utils.toast.error(Utils.translate('PLUGINS.PERMISSIONS.DENIED_PERMISSION') +
              Utils.translate('PLUGINS.PERMISSIONS.TYPE.CAMERA') + ' ' +
              Utils.translate('PLUGINS.PERMISSIONS.AND') + ' ' +
              Utils.translate('PLUGINS.PERMISSIONS.TYPE.GALLERY') + '. \n' +
              Utils.translate('PLUGINS.PERMISSIONS.ALWAYS_DENIED_PERMISSION'));
          }
        }, function(error){
          console.error("The following error occurred: "+error);
        }, [
          cordova.plugins.diagnostic.permission.CAMERA,
          cordova.plugins.diagnostic.permission.READ_EXTERNAL_STORAGE
        ])
      }

      /**
       *function to get multiple permission for camera
       */
      function askMultiplePermissions(type) {
        cordova.plugins.diagnostic.requestRuntimePermissions(function(statuses) {
          var havePerm = 0;
          var deniedPerm = false;
          for (var permission in statuses){
            switch(statuses[permission]){
              case cordova.plugins.diagnostic.permissionStatus.GRANTED:
                console.log("Permission granted to use "+permission);
                havePerm++;
                break;
              case cordova.plugins.diagnostic.permissionStatus.NOT_REQUESTED:
                console.log("Permission to use "+permission+" has not been requested yet");
                havePerm--;
                break;
              case cordova.plugins.diagnostic.permissionStatus.DENIED:
                console.log("Permission denied to use "+permission+" - ask again?");
                havePerm--;
                break;
              case cordova.plugins.diagnostic.permissionStatus.DENIED_ALWAYS:
                console.log("Permission permanently denied to use "+permission+" - guess we won't be using it then!");
                deniedPerm = true;
                break;
            }
          }
          if(!deniedPerm){
            if(havePerm == 2){
              //have both permissions granted
              if(type === 'p'){ //profile main photo
                $scope.addMedia();
              } else if(type === 'b'){ //profile background photo
                $scope.addMediaBack();
              } else if(type === 'rBegin' || type === 'rOpt') {
                $scope.addMediaReact(type);
              }
            } else if(havePerm <2){
              //both or one permission hasn't granted
              Utils.toast.error(Utils.translate('PLUGINS.PERMISSIONS.DENIED_PERMISSION') +
              Utils.translate('PLUGINS.PERMISSIONS.TYPE.CAMERA') + ' ' +
              Utils.translate('PLUGINS.PERMISSIONS.AND') + ' ' +
              Utils.translate('PLUGINS.PERMISSIONS.TYPE.GALLERY') + '.');
            }
          } else {
            Utils.toast.error(Utils.translate('PLUGINS.PERMISSIONS.DENIED_PERMISSION') +
              Utils.translate('PLUGINS.PERMISSIONS.TYPE.CAMERA') + ' ' +
              Utils.translate('PLUGINS.PERMISSIONS.AND') + ' ' +
              Utils.translate('PLUGINS.PERMISSIONS.TYPE.GALLERY') + '. \n' +
              Utils.translate('PLUGINS.PERMISSIONS.ALWAYS_DENIED_PERMISSION'));
          }
        }, function(error){
          console.error("The following error occurred: "+error);
        }, [
          cordova.plugins.diagnostic.permission.CAMERA,
          cordova.plugins.diagnostic.permission.READ_EXTERNAL_STORAGE
        ])
      }

      $scope.uploadingPhoto = false;
      $scope.openCrop = false;
      // BEGIN PROCESS TO UPDATE PROFILE PHOTO
        $scope.addMedia = function () {
          $scope.hideSheet = $ionicActionSheet.show({
            buttons: [
              {text: 'Take photo'},
              {text: 'Photo from library'}
            ],
            titleText: 'Add images',
            cancelText: 'Cancel',
            buttonClicked: function (index) {
              $scope.addImage(index);
            }
          });
        };

        $scope.addImage = function (type) {
          $scope.hideSheet(); //USING NEW PLUGIN MediaPicker
          $scope.newProfileImage = [];
          if(type === 0) { // camera
            ImageService2.saveCameraMediaProfilePhoto(type).then(function () {
            });
          } else { // library
            ImageService2.saveAlbumMediaProfilePhoto(type).then(function () {
            });
          }
        };

        $rootScope.$on("addedImageB", function () { // LISTENER FOR IMAGE LOADED
          showImageUser();
        });

        function showImageUser() {
          console.log("CALLED FUNCTION");
          if($scope.openCrop) {
            return true;
          }
          $scope.openCrop = true;
          var img = FileService2.images();
          var exifTemp = FileService2.exifImage();
          if(img.length === 0) { //ask again in 1 sec
            $timeout(function () {
              showImageUser();
            }, 1000);
          } else {
            if($scope.newProfileImage === null || $scope.newProfileImage === undefined || $scope.newProfileImage.length === 0) {
              var opt = {};
              if(isIOS === true) {
                //prepare IOS
                opt = {
                  url: img[0],
                  width: 200,
                  height: 200,
                  circle: true,
                  allowRotation: true,
                  title: 'Usa tus dedos para ajustar la imagen'
                }
                $jrCrop.crop(opt).then(function(canvas) {
                  // success!
                  console.log("INIT CUT IOS");
                  $scope.newProfileImage[0] = canvas.toDataURL();
                  $timeout(function() {
                    $scope.openCrop = false;
                    $scope.changeProfilePicture();
                    $scope.$apply();
                  }, 0);
                }, function(err) {
                  console.error(err);
                  $scope.newProfileImage[0] = img[0];
                  $scope.openCrop = false;
                  $scope.changeProfilePicture();
                  $scope.$apply();
                });
              } else {
                var urlToUse = null;
                //urlToUse = img[0].src;
                if(img[0].src) {
                  urlToUse = img[0].src;
                } else {
                  urlToUse = img[0];
                }
                opt = {
                  url: urlToUse,
                  width: 150,
                  height: 150,
                  circle: true,
                  allowRotation: true,
                  title: 'Usa tus dedos para ajustar la imagen'
                }
                $jrCrop.crop(opt).then(function(canvas) {
                  console.log("INIT CUT ANDROID");
                  $scope.newProfileImage[0] = canvas.toDataURL();
                  $timeout(function() {
                    $scope.openCrop = false;
                    $scope.changeProfilePicture();
                    $scope.$apply();
                  }, 0);
                }, function(err) {
                  console.error(err);
                  $scope.newProfileImage[0] = img[0];
                  $scope.openCrop = false;
                  $scope.changeProfilePicture();
                  $scope.$apply();
                });
              }
            } else {
              $scope.openCrop = false;
              console.log("finish loading");
            }
          }
        }

        $scope.changeProfilePicture = function () {
          console.log("CALLED FUNCTION UPDATE");
          $scope.uploadingPhoto = true;
          var pictureName = window.localStorage.getItem("userSubscriptionInstanceId") + window.localStorage.getItem("userName");
          window.localStorage.setItem("photoProfileBlob", "nothing");
          $scope.pictureProfile = "nothing";
          //Steps to upload
          var s3Service = new AWS.S3({
            apiVersion: '2006-03-01',
            params: {Bucket: s3.bucket}
          });
          //encrypt subscriptioninstanceID and folder name
          var userSubscriptionInstanceId = md5.createHash(UserService.get_USERSUBSCRIPTIONINSTANCE_ID().toString());
          var folder = md5.createHash("profilePicture");

          //Create random number for image index
          var indexRandom = Math.floor(Math.random() * 1000);
          //create key for each picture
          var photoSmallKey = s3.prefix + '/' + userSubscriptionInstanceId + '/' + folder + '/' + 'small' + indexRandom + '.jpg';
          /*var photoNormalKey = s3.prefix + '/' + userSubscriptionInstanceId + '/' + folder + '/' + 'normal' + indexRandom + '.jpg';
          var photoLargeKey = s3.prefix + '/' + userSubscriptionInstanceId + '/' + folder + '/' + 'large' + indexRandom + '.jpg';*/

          //photo to blob
          var fileSmall = Utils.dataURLtoBlob($scope.newProfileImage[0]);
          /*var fileNormal = Utils.dataURLtoBlob($scope.newProfileImage[0]);
          var fileLarge = Utils.dataURLtoBlob($scope.newProfileImage[0]);*/

          // begin process to upload
          s3Service.upload({
            Key: photoSmallKey,
            Body: fileSmall,
            ACL: 'public-read',
            ContentType: fileSmall.type
          }, function (err, data) {
            if (err) {
              return console.log('There was an error uploading the main jpg:'); // cancel all
            }
            if (data) {
              console.log('Successfully uploaded main image.');
              // call the WS
              changeProfilePictureService.changeProfPictv181(
                {"userSubscriptionId": window.localStorage.getItem("userSubscriptionInstanceId")}
              ).save({
                "profilePictureSmallUrl":
                  {
                    "value": "http://s3-us-west-2.amazonaws.com/" + s3.bucket + "/" + photoSmallKey
                  },
                "profilePictureMedUrl":
                  {
                    "value": "http://s3-us-west-2.amazonaws.com/" + s3.bucket + "/" + photoSmallKey
                  },
                "profilePictureLargeUrl":
                  {
                    "value": "http://s3-us-west-2.amazonaws.com/" + s3.bucket + "/" + photoSmallKey
                  }
              }, function success() {
                console.log("all good");
                //sendNotifToFollowers();
              }, function (response) {
                if (response && (response.status === 504 || response.status === -1)) {
                  console.log("We don't care");
                  //sendNotifToFollowers();
                } else {
                  console.log("changeProfilePicture error");
                }
              });
              // redirect
              $timeout(function () {
                $rootScope.$broadcast("photo.upload");
                $scope.uploadingPhoto = false;
                window.localStorage.setItem("photoProfileBlob", "http://s3-us-west-2.amazonaws.com/" + s3.bucket + "/" + photoSmallKey + '?decache=' + Math.random());
                $scope.pictureProfile = "http://s3-us-west-2.amazonaws.com/" + s3.bucket + "/" + photoSmallKey;
                FileService2.cleanImages;
                $ionicHistory.nextViewOptions({disableBack: true});
                $state.go('menu.myProfile', {}, {reload: false});
                //window.history.back();
              }, 1000);
            }
          })
        };

        function sendNotifToFollowers() {
          var wsData = {
            groupId: 0,
            userSubscriptionId: UserService.get_USERSUBSCRIPTION_ID(),
            notification: 15 //AGREGAR TIPO DE NOTIF 15
          };
          //SE OCUPA WS QUE MANDA TIPO DE NOTIFICACIÓN
          GroupsService.getEndPointsFollowerswithNotif(wsData).then( function (dataWS) {
            //GroupsService.getEndPointsFollowers(wsData).then( function (dataWS) {
            var messageForShow = Utils.translate('ALERTS.NEW_PROFILE_PICTURE_01') + 
              UserService.get_USER_NAME() +
              Utils.translate('ALERTS.NEW_PROFILE_PICTURE_02');

            dataWS.forEach( function (dataDevices) {

              //console.log("for each", dataDevices);
              AWSServices.sendNewProfilePhotoNotification(
                messageForShow, 
                dataDevices.userDeviceId,
                0,
                UserService.get_USERSUBSCRIPTION_ID()
              )

            })
          }, function (errorWS) {
            console.log("complete error", errorWS);
          })
        }
      // END PROCESS TO UPDATE PROFILE PHOTO

      // BEGIN PROCESS TO UPDATE BACKGROUND PHOTO
        $scope.addMediaBack = function () {
          $scope.hideSheet = $ionicActionSheet.show({
            buttons: [
              {text: 'Take photo'},
              {text: 'Photo from library'}
            ],
            titleText: 'Add images',
            cancelText: 'Cancel',
            buttonClicked: function (index) {
              $scope.addImageBack(index);
            }
          });
        };

        $scope.addImageBack = function (type) {
          $scope.hideSheet();//USING NEW PLUGIN MediaPicker
          $scope.newBackImage = [];
          if(type === 0) { // camera
            ImageService2.saveCameraMediaBackgroundPhoto(type).then(function () {
            });
          } else { // library
            ImageService2.saveAlbumMediaBackgroundPhoto(type).then(function () {
            });
          }
        };

        $rootScope.$on("addedImageC", function () {
          showBackImageUser();
        })

        function showBackImageUser() {
          if($scope.openCrop) {
            return true;
          }
          $scope.openCrop = true;
          var img = FileService2.images();
          var exifTemp = FileService2.exifImage();
          if(img.length === 0) {
            $timeout(function() {
              showBackImageUser();
            }, 1000);
          } else {
            if($scope.newBackImage === null || $scope.newBackImage === undefined || $scope.newBackImage.length === 0) {
              var opt = {};
              if(isIOS === true) {
                //prepare IOS
                opt = {
                  url: img[0],
                  width: 393,
                  height: 230,
                  circle: true,
                  allowRotation: true,
                  title: 'Usa tus dedos para ajustar la imagen'
                }
                $jrCrop.crop(opt).then(function(canvas) {
                  // success!
                  //$scope.$apply();
                  $scope.newBackImage[0] = canvas.toDataURL();
                  $timeout(function() {
                    $scope.openCrop = false;
                    $scope.changeBackPicture();
                    $scope.$apply();
                  }, 0);
                }, function(err) {
                  console.error(err);
                  $scope.newBackImage[0] = img[0];
                  $scope.openCrop = false;
                  $scope.changeBackPicture();
                  $scope.$apply();
                });
              } else {
                var urlToUse = null;
                if(img[0].uri) {
                  urlToUse = img[0].uri;
                } else {
                  urlToUse = img[0];
                }
                opt = {
                  url: urlToUse,
                  width: 393,
                  height: 230,
                  circle: true,
                  allowRotation: true,
                  title: 'Usa tus dedos para ajustar la imagen'
                }
                $jrCrop.crop(opt).then(function(canvas) {
                  // success!
                  //$scope.$apply();
                  $scope.newBackImage[0] = canvas.toDataURL();
                  $timeout(function() {
                    $scope.openCrop = false;
                    $scope.changeBackPicture();
                    $scope.$apply();
                  }, 0);
                }, function(err) {
                  console.error(err);
                  $scope.newBackImage[0] = img[0];
                  $scope.openCrop = false;
                  $scope.changeBackPicture();
                  $scope.$apply();
                });
              }
            } else {
              $scope.openCrop = false;
              console.log("finish loading background")
            }
          }
        }

        $scope.changeBackPicture = function () {
          $scope.uploadingPhoto = true;
          var pictureName = window.localStorage.getItem("userSubscriptionInstanceId") + "_back_" + window.localStorage.getItem("userName");
          window.localStorage.setItem("bkgMyProfile", "nothing");
          $scope.pictureBackground = "nothing";
          //Steps to upload
          var s3Service = new AWS.S3({
            apiVersion: '2006-03-01',
            params: {Bucket: s3.bucket}
          });
          //encrypt subscriptioninstanceID and folder name
          var userSubscriptionInstanceId = md5.createHash(UserService.get_USERSUBSCRIPTIONINSTANCE_ID().toString());
          var folder = md5.createHash("profileBackgroundPicture");

          //Create random number for image index
          var indexRandom = Math.floor(Math.random() * 1000);

          //create key for each picture
          var photoKey = s3.prefix + '/' + userSubscriptionInstanceId + '/' + folder + '/' + 'background' + indexRandom + '.jpg';

          //photo to blob
          var file = Utils.dataURLtoBlob($scope.newBackImage[0]);

          //upload to s3
          //small
          s3Service.upload({
            Key: photoKey,
            Body: file,
            ACL: 'public-read',
            ContentType: file.type
          }, function (err, data) {
            if (err) {
              return console.log('There was an error uploading the background jpg:');
            }
            if (data) {
              console.log('Successfully uploaded large image.');
              //updating the background photo
              changeProfilePictureService.changeBackPict(
                {"userSubscriptionId": window.localStorage.getItem("userSubscriptionInstanceId")}
              ).save({
                "string":
                  {
                    "value": "http://s3-us-west-2.amazonaws.com/" + s3.bucket + "/" + photoKey
                  }
              }, function succes() {
                //nothing more
              }, function (response) {
                if (response && (response.status === 504 || response.status === -1)) {
                  console.log("We don't care");
                  $scope.uploadingPhoto = false;
                  window.localStorage.setItem("bkgMyProfile", "http://s3-us-west-2.amazonaws.com/" + s3.bucket + "/" + photoKey + '?decache=' + Math.random());
                  $scope.pictureProfile = "http://s3-us-west-2.amazonaws.com/" + s3.bucket + "/" + photoKey;
                  $ionicHistory.nextViewOptions({disableBack: true});
                  $state.go('menu.myProfile', {}, {reload: false});
                } else {
                  console.log("changeProfilePicture error");
                }
              });
              //freeing the user from the process
              $timeout(function () {
                $scope.uploadingPhoto = false;
                window.localStorage.setItem("bkgMyProfile", "http://s3-us-west-2.amazonaws.com/" + s3.bucket + "/" + photoKey + '?decache=' + Math.random());
                $scope.pictureProfile = "http://s3-us-west-2.amazonaws.com/" + s3.bucket + "/" + photoKey;
                FileService2.cleanImages;
                $ionicHistory.nextViewOptions({disableBack: true});
                $state.go('menu.myProfile', {}, {reload: false});
              }, 1000);
            }
          });
        };
      // END PROCESS TO UPDATE BACKGROUND PHOTO

      //ASK AWS TO RETRY UPLOAD UPDATING TIMESTAMP
        AWS.events.on('retry', function(response) {  
          if (response.error.name === 'RequestTimeTooSkewed') {
            console.error('User time is not correct. Handling error!');
            console.log('AWS systemClockOffset:', AWS.config.systemClockOffset);
            var serverTime = Date.parse(response.httpResponse.headers['date']);
            var timeNow = new Date().getTime();
            console.log('AWS timestamp:', new Date(serverTime));
            console.log('Browser timestamp:', new Date(timeNow));
            AWS.config.systemClockOffset = Math.abs(timeNow - serverTime);
            response.error.retryable = true;
            console.log('Setting systemClockOffset to:', AWS.config.systemClockOffset);
            console.log('Retrying uploading to S3 once more...');
          }
        });
      //ASK AWS TO RETRY UPLOAD UPDATING TIMESTAMP

      $scope.sendingReact = false;
      $scope.autoPhoto = false
      // BEGIN PROCESS TO SEND REACT
        $scope.addMediaReact = function (type) {
          if(type === 'rBegin') {
            $scope.autoPhoto = true;
            $scope.addImageReact(1,0);
          } else {
            $scope.autoPhoto = false;
            $scope.hideSheet = $ionicActionSheet.show({
              buttons: [
                {text: 'Take photo'},
                {text: 'Photo from library'}
              ],
              titleText: 'Add images',
              cancelText: 'Cancel',
              buttonClicked: function (index) {
                $scope.addImageReact(0,index);
              }
            });
          }
        }

        $scope.addImageReact = function (direct,type) {//USING NEW PLUGIN MediaPicker
          if(direct != 1){
            $scope.hideSheet();
          }
          $scope.newReactImage = [];
          if(type === 0) { // camera
            ImageService2.saveCameraMediaReactPhoto(type, 500, 500, false).then(function () {
            });
          } else { // library
            ImageService2.saveAlbumMediaReactPhoto(type).then(function () {
            });
          }
        };

        $rootScope.$on("addedImageR", function () {
          showReactImageUser();
        })

        function showReactImageUser() {
          if($scope.openCrop) {
            return true;
          }
          $scope.openCrop = true;
          var img = FileService2.images();
          var exifTemp = FileService2.exifImage();
          if(img.length === 0) {
            $timeout(function() {
              showReactImageUser();
            }, 1000);
          } else {
            if($scope.newReactImage === null || $scope.newReactImage === undefined || $scope.newReactImage.length === 0) {
              var opt = {};
              if(isIOS === true) {
                //prepare IOS
                var urlToUse = null;
                if(img[0].uri) {
                  urlToUse = img[0].uri;
                } else {
                  urlToUse = img[0];
                }
                $scope.newReactImage[0] = urlToUse;
                $scope.sendReaction($scope.newReactImage[0]);
              } else {
                var urlToUse = null;
                if(img[0].uri) {
                  urlToUse = img[0].uri;
                } else {
                  urlToUse = img[0];
                }
                $scope.newReactImage[0] = urlToUse;
                $scope.sendReaction($scope.newReactImage[0]);
              }
              $scope.newReactImage[0] = urlToUse;
              $scope.sendReaction($scope.newReactImage[0]);
            } else {
              $scope.openCrop = false;
              console.log("finish loading background")
            }
          }
        }

        $scope.sendReaction = function (reactionImage) {
          $scope.sendingReact = true;
          $state.params.sequence.reactMe(reactionImage).then(function (/*alwaysTrue*/) {
            $scope.newProfileImage = [];
            FileService2.cleanImages();
            $state.go('menu.timeline', {prepareStatement: 0}, {reload: true});
          }, function (error) {

          }).finally(function () {
            $scope.sendingReact = false;
          });
        };
      // END PROCESS TO SEND REACT newReactImage

      // code to send user to selected profile
      $scope.sendUserProfile = function (userChosen) {
        reDirectService.reDirectProfile(userChosen.userSubscriptionId);
      };

      //redirect simple to timeline
      $scope.redirectTimeLine = function () {
        $state.go('menu.timeline', {"prepareStatement": 0}, {reload: true});
      };

      //codigo para redirigir ha followers
      $scope.reDirectFollowersPage = function () {
        followersData.anadir(window.localStorage.getItem("userSubscriptionInstanceId"));
        $state.go('followers', {}, {reload: true});
      };

      //CODE TO REDIRECT TO LIST OF FRIENDS
      $scope.reDirectFriendsPage = function () {
        friendsData.anadir(window.localStorage.getItem("userSubscriptionInstanceId"));
        $state.go('listFriends', {}, {reload: true});
      };

      $scope.data = {};


      /*$scope.findIfHadPendingMessages = function () {
        var userInstanceId = window.localStorage.getItem("userSubscriptionInstanceId");
        $scope.noMsgs = chatService.chkHowManyPendingMsgWS().get({
          "x-isis-querystring":
            {
              "userSubscriptionRec":
                {
                  "value":
                    {
                      "href": ApiEndPoint.url + 'restful/objects/simple.UserSubscription/' + userInstanceId
                    }
                }
            }
        }, function (data) {
          console.log("got cantity");
          if (data.result.value > 99) {
            data.result.value = "+99";
          }
        }, function (error) {

        });
      };*/

      $scope.showInbox = function () {
        $state.go('menu.messagesInbox', {}, {reload: true});
      };
    }])
;
