"use strict";
appControllers
//controllers for functions in notifications.html for redirect and show count of messages
  .controller('messagesInboxCtrl', ['$rootScope', '$scope', '$state', 'UserService', 'Utils', 'chatService',
    function ($rootScope, $scope, $state, UserService, Utils, chatService) {
      var myUserId = UserService.get_USER_ID();
      //console.log('messagesInboxCtrl', $state.params.subscriptionInstanceId);

      $scope.data = {};
      $scope.data.inboxData = [];
      $scope.searching = false;
      $scope.errorLoading = false;
      $scope.noMoreItemsAvailable = false;
      //code for chats

      $scope.data.pictureProfile = UserService.get_USER_PHOTO();


      //ZONE for init page
      $scope.init = function () {
        $scope.start = 0;
        $scope.count = 6;
        $scope.noMoreItemsAvailable = false;
        $scope.friends = [];
        $scope.errorLoading = false;
        window.localStorage.setItem('pendingMessagesForUser', '0');
      };
      $scope.init();
      //END ZONE for init page

      //Zone to fill page with list of chats
      $scope.tempoFillList = function () {
        var data = [];
        chatService.findChatByUserSubscription({
          "objectId": myUserId
        }).get({
          "withStart": '"' + $scope.start + '"',
          "withCount": '"' + $scope.count + '"'
        }, function (friendList) {
          //console.log("friendList",friendList)
          if (friendList.length > 1) {
            friendList.length--;
            for (var a = 0; a < friendList.length; a++) {
              var userForSearchData = "";
              //Verificamos que el invitado al chat somos nosotros
              if (friendList[a].friendId.href.split('/')[6] == myUserId) {
                userForSearchData = friendList[a].userSubscription.href.split('/')[6];
              } else {
                userForSearchData = friendList[a].friendId.href.split('/')[6];
              }
              var userSend = UserService.getUserSubscriptionByinstanceId().get({
                "userInstanceId": userForSearchData
              });
              var mineMsg = false;
              if (friendList[a].lastUserSubscriptionMessage.href.split('/')[6] == window.localStorage.getItem("userSubscriptionInstanceId")) {
                mineMsg = true;
              }
              $scope.data.inboxData.push(
                {
                  chat_id: friendList[a].chat.href.split('/')[6],
                  chat_name: friendList[a].chatName,
                  friendMessage: userSend,
                  read: friendList[a].chatMessageRead,
                  message: friendList[a].lastChatMessage,
                  date: friendList[a].lastDateMessage,
                  mine: mineMsg,
                  idPush: friendList[a].friendId.href.split('/')[6]
                }
              );
            }
            $scope.start = $scope.data.inboxData.length;
          } else {
            $scope.noMoreItemsAvailable = true;
          }
          $scope.$broadcast('scroll.infiniteScrollComplete');
        }, function (error) {
          console.log("Doesn't have any friends")
          $scope.errorLoading = true;
          $scope.noMoreItemsAvailable = true;
          $scope.$broadcast('scroll.infiniteScrollComplete');
        })
      };
      //END Zone to fill page with list of chats

      //ZONE to redirect chat
      $scope.openSelectedChat = function (data) {
        //console.log("openSelectedChat",data)
        /*chatService.deletePendingMessage(
              {'objectId': data.chat_id}
            ).save(
            {}, function(dataErased){
            }, function(error){
              console.log("can't delete pending message");
            });*/
        var nameFriend = (data.mine) ? window.localStorage.getItem("name") : data.friendMessage.members.name.value;
        $state.go('chatPage', {
          "chatID": data.chat_id, //Add chat ID
          "chatName": data.chat_name,
          "lastMsg": data.message,
          "mine": data.mine,
          "dateMsg": data.date,
          "nameFriend": nameFriend,
          "friendID": data.friendMessage.members.userId.value,
          "read": data.read,
          "inbox": true,
          "friendTitle": data.friendMessage.members.name.value
        }, {reload: true});
      }
      //END ZONE to redirect chat

      //ZONE to redirect to search for user without a chat
      $scope.openNewChat = function () {
        console.log("Open search for new chat");
        $state.go('searchNewChats', {}, {reload: true});
      };
      //END ZONE to redirect to search for user without a chat

      //zone to show and quit button upload zone
      $scope.data.showButtonsArea = false;
      $scope.showButtonArea = function () {
        console.log("in");
        if ($scope.data.showButtonsArea) {
          var area = document.getElementById("ButtonsAreaRedirect");
          area.className = "";
          $scope.data.showButtonsArea = false;
        } else {
          var area = document.getElementById("ButtonsAreaRedirect");
          area.className = "bounceInUp";
          $scope.data.showButtonsArea = true;
        }
      };
      //END zone to show and quit button upload zone
    }])

  .controller('searchNewChatCtrl', ['$rootScope', '$scope', '$state', 'UserService', 'Utils', 'AsyncSearch', 'GroupsService', 'chatService', 'ApiEndPoint', 'AWSServices',
    function ($rootScope, $scope, $state, UserService, Utils, AsyncSearch, GroupsService, chatService, ApiEndPoint, AWSServices) {
      var myUserId = UserService.get_USER_ID();

      $scope.connectedSocket = false;

      if ($scope.connectedSocket == false) {
        //old dns
        //var socket = io.connect('http://ec2-34-212-194-26.us-west-2.compute.amazonaws.com:3000/');
        //dns for development
        var socket = io.connect('http://ec2-54-69-184-92.us-west-2.compute.amazonaws.com:3000/');
        //dns for production
        //var socket = io.connect('http://ec2-54-212-245-106.us-west-2.compute.amazonaws.com:3000/');
        $scope.connectedSocket = true;
      }

      $scope.data = {};
      $scope.data.maxLength = 0;
      $scope.connectedSocket = false;
      $scope.me = {
        name: UserService.get_USER_NAME(),
        id: myUserId
      };

      socket.on('connect', function (data) {
        $scope.connectedSocket = true;
        console.log("obtain data from socket");
      });
      //ZONE to get suggested friends
      $scope.loadMembers = function () {
        $scope.sugestedFriends = [];
        $scope.isLoadingMembers = true;
        UserService.findFriendsByUserSubscriptionId({
          "objectId": window.localStorage.getItem("userSubscriptionInstanceId")
        }).get({
          "withStart": '"0"',
          "withCount": '"10"'
        }).$promise.then(function (getResponse) {
          if (getResponse.length > 0) {
            getResponse.forEach(function (user) {
              var promise = UserService.getDevices(user.userSubscription.href.split('/')[6]);

              $scope.sugestedFriends.push({
                avatar: user.profilePictureUrl || (
                  user.profilePicture ?
                    "data:image/jpeg;base64," + user.profilePicture.split(':')[2] :
                    "img/ProfilePhoto.svg"
                ),
                userSubscription: user.userSubscription.href.split('/')[6],
                name: user.name,
                dataForPush: promise
              });
            })
          }
          $scope.isLoadingMembers = false;
        }, function (getError) {
          console.error(getError);
          //ToDo: Mostrar mensaje de error...
          $scope.isLoadingMembers = false;
        })
      };
      $scope.loadMembers();
      //

      //Zone for searchs specific users
      $scope.asyncContacts = [];
      $scope.filterSelected = true;

      $scope.delayedQuerySearch = function (username) {
        var deferred = Utils.$q.defer();
        AsyncSearch.findFriendUserSubscriptionsByUserName({
          'userName': username,
          'withStart': 0,
          'withCount': 15
        }).then(function (userList) {
          var foundUsers = [];
          userList.forEach(function (user) {
            if (user.name) {
              var promise = UserService.getDevices(user.userSubscription.href.split('/')[6]);
              foundUsers.push({
                avatar: user.profilePictureUrl || (user.profilePicture ? "data:image/jpeg;base64," + user.profilePicture.split(':')[2] : "img/ProfilePhoto.svg"),
                userSubscription: user.userSubscription.href.split('/')[6],
                verified: user.verifyUser,
                name: user.name,
                _lowername: user.name.toLowerCase(),
                dataForPush: promise
              });
            }
          });
          deferred.resolve(foundUsers)
        }, function (emptyArray) {
          deferred.resolve(emptyArray)
        });
        return deferred.promise;
      };

      $scope.addContact = function (index, contact) {
        var found = false;
        if ($scope.asyncContacts.length > 0) {
          $scope.asyncContacts.some(function (member) {
            if (member.userSubscription == contact.userSubscription)
              return found = true;
          });
        } else {
          found = false;
        }
        if (found) {
          Utils.alert.show(Utils.translate('PRIVATEMESSAGE.ADDED') + contact.name);
          return;
        }
        $scope.asyncContacts.push(contact);
      };
      //Zone for searchs of users without a chat

      //Zone for the process to create new chat or send message to old one
      $scope.data.friendsIdList = [];
      $scope.data.friendsIdListclean = [];
      $scope.data.listDataSendMessage = [];
      $scope.data.listMessagesData = {};
      $scope.data.sentMessageChat = "";

      $scope.checkBeforeChats = function (text) {
        Utils.loading.show(Utils.translate('PRIVATEMESSAGE.SENDINGMSG'));
        $scope.data.sentMessageChat = text;
        //if we selected more than one user after send message or create new chat
        //the user must be redirect to inbox and upload it
        if ($scope.asyncContacts.length > 1) {
          var checkPromises = {};
          var checkPromisesReverse = {};
          $scope.asyncContacts.forEach(function (user) {
            console.log("Friend selected: ", user);
            //Use WS to verify if between both users already have historic chat

            //Check if i created a chat with the user
            var promise = chatService.findChatByMembers().get({
              'objectId': myUserId,
              "x-isis-querystring":
                {
                  "friend":
                    {
                      "value":
                        {
                          "href": ApiEndPoint.url + "restful/objects/simple.UserSubscription/" + user.userSubscription
                        }
                    }
                }
            }).$promise;
            checkPromises[user.userSubscription] = promise;
            $scope.data.friendsIdList.push(user.userSubscription);

            //Check if the user created a chat with me
            var promiseReverse = chatService.findChatByMembers().get({
              'objectId': user.userSubscription,
              "x-isis-querystring":
                {
                  "friend":
                    {
                      "value":
                        {
                          "href": ApiEndPoint.url + "restful/objects/simple.UserSubscription/" + window.localStorage.getItem('userSubscriptionInstanceId')
                        }
                    }
                }
            }).$promise;
            checkPromisesReverse[user.userSubscription] = promiseReverse;
            //$scope.data.friendsIdList.push(user.userSubscription);
          });//End forEach()

          var promiseAll = Utils.$q.all(checkPromises);
          var promiseAllReverse = Utils.$q.all(checkPromisesReverse);
          var sendingMsg = {};
          Utils.$q.all({
            promiseAll:promiseAll,
            promiseAllReverse:promiseAllReverse
          }).then(function (responseCheck) {
            console.log("responseCheck.promiseAll",responseCheck.promiseAll);
            console.log("responseCheck.promiseAllReverse",responseCheck.promiseAllReverse);

            $scope.data.friendsIdList.forEach(function (friendId) {
              console.log("compossing message for friend: "+friendId);
              if (responseCheck.promiseAll[friendId].length > responseCheck.promiseAllReverse[friendId].length) {
                //Have chat created by me
                //prepare data
                var dataToSend = {
                  nameChat: responseCheck.promiseAll[friendId][0].chatName,
                  idChat: responseCheck.promiseAll[friendId][0].chat.href.split('/')[6],
                  newLS: false,
                  text: text,
                  friendID: responseCheck.promiseAll[friendId][0].friendId.href.split('/')[6]
                };
                var nameForChat = responseCheck.promiseAll[friendId][0].chatName;
                $scope.data.listMessagesData[nameForChat] = dataToSend;
                //Update data
                var msgPromise = chatService.updateLastMessage({
                  idChat: responseCheck.promiseAll[friendId][0].chat.href.split('/')[6],
                  msg: text,
                  lastUser: ApiEndPoint.url + "restful/objects/simple.UserSubscription/" + myUserId
                }).$promise;
                sendingMsg[nameForChat] = msgPromise;
              }
              else if (responseCheck.promiseAll[friendId].length < responseCheck.promiseAllReverse[friendId].length) {
                //Have chat created by the friend
                //prepare data
                var dataToSend = {
                  nameChat: responseCheck.promiseAllReverse[friendId][0].chatName,
                  idChat: responseCheck.promiseAllReverse[friendId][0].chat.href.split('/')[6],
                  newLS: false,
                  text: text,
                  friendID: responseCheck.promiseAllReverse[friendId][0].userSubscription.href.split('/')[6],
                };
                var nameForChat = responseCheck.promiseAllReverse[friendId][0].chatName;
                $scope.data.listMessagesData[nameForChat] = dataToSend;
                //Update data
                var msgPromise = chatService.updateLastMessage({
                  idChat: responseCheck.promiseAllReverse[friendId][0].chat.href.split('/')[6],
                  msg: text,
                  lastUser: ApiEndPoint.url + "restful/objects/simple.UserSubscription/" + myUserId
                }).$promise;
                sendingMsg[nameForChat] = msgPromise;
              }
              else {
                //doesn't have chat
                //prepare data
                var nameForChat = myUserId + "_" + friendId;
                var dataToSend = {
                  nameChat: nameForChat,
                  idChat: '',
                  newLS: true,
                  text: text,
                  friendID: friendId
                };
                $scope.data.listMessagesData[nameForChat] = dataToSend;
                //Save data
                var msgPromise = chatService.addChat().get({
                  'objectId': myUserId,
                  "x-isis-querystring": {
                    "friend": {
                      "value": {
                        "href": ApiEndPoint.url + "restful/objects/simple.UserSubscription/" + friendId
                      }
                    },
                    "chatName": {
                      "value": nameForChat
                    },
                    "lastChatMessage": {
                      "value": text
                    },
                    "lastUsersubscription": {
                      "value": {
                        "href": ApiEndPoint.url + "restful/objects/simple.UserSubscription/" + myUserId
                      }
                    },
                    "read": {
                      "value": false
                    },
                  }
                }).$promise;
                sendingMsg[nameForChat] = msgPromise;
              }
            });

            Utils.$q.all(sendingMsg).then(function (responseChats) {
              console.log("done add chat or update last message");
              document.getElementById('comment').value = "";
              var referenceD = Object.keys($scope.data.listMessagesData);
              var referenceL = Object.keys($scope.data.listMessagesData).length;
              for (var i = 0; i < referenceL; i++) {
                if ($scope.data.listMessagesData[referenceD[i]].idChat == '') {
                  $scope.data.listMessagesData[referenceD[i]].idChat = responseChats[referenceD[i]].result.value;
                }
              }
              $scope.asyncContacts.forEach(function (users, index) {
                var name = $scope.me.name;
                var message = name + Utils.translate('PUSHNOTIFICATION.PRIVATEMSG');
                for (var i = 0; i < users.dataForPush.value.length; i++) {
                  var endpointArn = users.dataForPush.value[i].title;
                  AWSServices.sendNotification(message, endpointArn);
                }
              });
              $scope.prepareMessageSending();
              //Redirect to inbox page
              //$state.go('menu.messagesInbox', {"subscriptionInstanceId": window.localStorage.getItem('userSubscriptionInstanceId')}, {reload: true});
            });
          });
        }
        else {
          //Use WS to verify if between both users already have historic chat
          var checkPromises = {};
          var checkPromisesReverse = {};
          $scope.data.newChatName = "";
          $scope.data.newChatID = "";
          $scope.data.newChatDate = "";
          $scope.data.newChatFriend = "";
          $scope.data.new = false;
          var promise = chatService.findChatByMembers().get({
            'objectId': window.localStorage.getItem('userSubscriptionInstanceId'),
            "x-isis-querystring":
              {
                "friend":
                  {
                    "value":
                      {
                        "href": ApiEndPoint.url + "restful/objects/simple.UserSubscription/" + $scope.asyncContacts[0].userSubscription
                      }
                  }
              }
          }).$promise;
          checkPromises[$scope.asyncContacts[0].userSubscription] = promise;

          var promiseReverse = chatService.findChatByMembers().get({
            'objectId': $scope.asyncContacts[0].userSubscription,
            "x-isis-querystring":
              {
                "friend":
                  {
                    "value":
                      {
                        "href": ApiEndPoint.url + "restful/objects/simple.UserSubscription/" + window.localStorage.getItem('userSubscriptionInstanceId')
                      }
                  }
              }
          }).$promise;
          checkPromisesReverse[$scope.asyncContacts[0].userSubscription] = promiseReverse;

          var promiseAll = Utils.$q.all(checkPromises);
          var promiseAllReverse = Utils.$q.all(checkPromisesReverse);
          var sendingMsg = {};
          Utils.$q.all({
            promiseAll:promiseAll,
            promiseAllReverse:promiseAllReverse
          }).then(function (responseCheck) {
            console.log("responseCheck.promiseAll",responseCheck.promiseAll);
            console.log("responseCheck.promiseAllReverse",responseCheck.promiseAllReverse);

            if (responseCheck.promiseAll[$scope.asyncContacts[0].userSubscription].length > responseCheck.promiseAllReverse[$scope.asyncContacts[0].userSubscription].length) {
              //Have chat created by me
              //gather data before switch to chatroom
              var nameForChat = responseCheck.promiseAll[$scope.asyncContacts[0].userSubscription][0].chatName;
              $scope.data.newChatName = nameForChat;
              $scope.data.newChatID = responseCheck.promiseAll[$scope.asyncContacts[0].userSubscription][0].chat.href.split('/')[6];
              $scope.data.newChatDate = responseCheck.promiseAll[$scope.asyncContacts[0].userSubscription][0].lastDateMessage;
              $scope.data.newChatFriend = $scope.asyncContacts[0].name;
            }
            else if (responseCheck.promiseAll[$scope.asyncContacts[0].userSubscription].length < responseCheck.promiseAllReverse[$scope.asyncContacts[0].userSubscription].length) {
              //Have chat created by the friend
              //prepare data
              var nameForChat = responseCheck.promiseAllReverse[$scope.asyncContacts[0].userSubscription][0].chatName;
              $scope.data.newChatName = nameForChat;
              $scope.data.newChatID = responseCheck.promiseAllReverse[$scope.asyncContacts[0].userSubscription][0].chat.href.split('/')[6];
              $scope.data.newChatDate = responseCheck.promiseAllReverse[$scope.asyncContacts[0].userSubscription][0].lastDateMessage;
              $scope.data.newChatFriend = $scope.asyncContacts[0].name;
            }
            else {
              //doesn't have chat
              //prepare data
              var nameForChat = myUserId + "_" + $scope.asyncContacts[0].userSubscription;
              $scope.data.newChatName = nameForChat;
              //prepare chat
              //Save data
              var msgPromise = chatService.addChat().get({
                'objectId': myUserId,
                "x-isis-querystring": {
                  "friend": {
                    "value": {
                      "href": ApiEndPoint.url + "restful/objects/simple.UserSubscription/" + $scope.asyncContacts[0].userSubscription
                    }
                  },
                  "chatName": {
                    "value": nameForChat
                  },
                  "lastChatMessage": {
                    "value": text
                  },
                  "lastUsersubscription": {
                    "value": {
                      "href": ApiEndPoint.url + "restful/objects/simple.UserSubscription/" + myUserId
                    }
                  },
                  "read": {
                    "value": false
                  },
                }
              }).$promise;
              sendingMsg[nameForChat] = msgPromise;
              console.log("sendingMsg", sendingMsg)
            }

            Utils.$q.all(sendingMsg).then(function (responseChats) {
              //console.log("done", responseChats);
              var msg = $scope.data.sentMessageChat;
              document.getElementById('comment').value = "";
              if ($scope.data.newChatID == "") {
                $scope.data.newChatID = responseChats[$scope.data.newChatName].result.value;
                var d = new Date();
                $scope.data.newChatDate = d.getTime();
              }
              //Redirect to inbox page
              Utils.loading.hide();
              $state.go('chatPage', {
                "chatID": $scope.data.newChatID,
                "chatName": $scope.data.newChatName,
                "lastMsg": msg,
                "mine": true,
                "dateMsg": $scope.data.newChatDate,
                "nameFriend": $scope.asyncContacts[0].name,
                "friendID": $scope.asyncContacts[0].userSubscription,
                "read": false,
                "inbox": false,
                "friendTitle": $scope.asyncContacts[0].name
              }, {reload: true});
            });
          });
        }

      };
      //END Zone for the process to create new chat or send message to old one

      //Zone for the process to save in LS all the historic generated from chat
      $scope.addCreateHistorial = function (newer, room, msg, name, idSend) {
        var today = new Date();
        var newChatDate = today.getTime();
        var historic = [];
        var msgMine = true;
        if (idSend == $scope.me.id) {
          msgMine = 3;
        } else {
          msgMine = 2;
        }
        if (!newer) {
          historic = JSON.parse(window.localStorage.getItem(room));
          var historicLength = Object.keys(historic).length;
          historicLength++;
          var lastMessageSent = {
            message: msg,
            name: name,
            date: newChatDate,
            sender: idSend,
            type: msgMine
          }
          historic[historicLength] = lastMessageSent;
          console.log("savin Room data LS",historic);
          window.localStorage.setItem(room, JSON.stringify(historic));
        } else {
          var lastMessageSent = {
            1: {
              message: msg,
              name: name,
              date: newChatDate,
              sender: idSend,
              type: msgMine
            }
          }
          historic = lastMessageSent;
          console.log("savin Room data LS",historic);
          window.localStorage.setItem(room, JSON.stringify(historic));
        }
      };

      $scope.prepareMessageSending = function () {
        var referenceD = Object.keys($scope.data.listMessagesData);
        var referenceL = Object.keys($scope.data.listMessagesData).length;
        $scope.data.maxLength = referenceL;
        for (var i = 0; i < referenceL; i++) {
          //First access the chat
          var data = {
            room: $scope.data.listMessagesData[referenceD[i]].nameChat,
            roomId: $scope.data.listMessagesData[referenceD[i]].idChat,
            roomText: $scope.data.listMessagesData[referenceD[i]].text,
            friendToSend: $scope.data.listMessagesData[referenceD[i]].friendID,
            user: $scope.me.name,
            idSend: $scope.me.id,
            resumeServer: false,
            noPosition: 1
          };
          if (window.localStorage.getItem($scope.data.listMessagesData[referenceD[i]].nameChat)) {
            $scope.addCreateHistorial(
              false,
              $scope.data.listMessagesData[referenceD[i]].nameChat,
              $scope.data.listMessagesData[referenceD[i]].text,
              $scope.me.name,
              $scope.me.id
            );
          } else {
            $scope.addCreateHistorial(
              true,
              $scope.data.listMessagesData[referenceD[i]].nameChat,
              $scope.data.listMessagesData[referenceD[i]].text,
              $scope.me.name,
              $scope.me.id
            );
          }
          socket.emit('enterRoomOutside', data);
        }
      }
      //END Zone for the process to save in LS all the historic generated from chat

      //ZONE for listen when "visit" the chatroom to see if there's somebody
      socket.on('userJoinedExtra', function (data) {
        if (data.list > 0) {
          socket.emit("chatMessage", {
            room: data.room,
            message: data.roomText,
            user: $scope.me.name,
            idSend: $scope.me.id
          });
          if (data.list == "1") {
            $scope.pendingMsg = chatService.addPendingMessage().get({
              "x-isis-querystring":
                {
                  "userSubscriptionSend": {
                    "value": {
                      "href": ApiEndPoint.url + 'restful/objects/simple.UserSubscription/' + $scope.me.id
                    }
                  },
                  "userSubscriptionRec": {
                    "value": {
                      "href": ApiEndPoint.url + 'restful/objects/simple.UserSubscription/' + data.friendToSend
                    }
                  },
                  "chatMessage": {
                    "value": data.roomText
                  }
                }
            }, function (data) {
              console.log("Added new messages");
            }, function (error) {
              console.log("can't add to pending messages list");
            })
          } else {
            console.log("Sent");
          }
          $scope.data.maxLength = $scope.data.maxLength - data.noPosition;
          if ($scope.data.maxLength == 0) {
            socket.emit('ForceLeave');
            Utils.loading.hide();
            $state.go('menu.messagesInbox', {"subscriptionInstanceId": window.localStorage.getItem('userSubscriptionInstanceId')}, {reload: true});
          }
        } else {
          console.log("Can't connect");
        }
      });
      //END ZONE for listen when "visit" the chatroom to see if there's somebody
    }])

  .controller('chatPageCtrl', ['$scope', '$state', 'UserService', '$timeout', '$ionicScrollDelegate', 'AWSServices', 'chatService', 'ApiEndPoint', 'Utils',
    function ($scope, $state, UserService, $timeout, $ionicScrollDelegate, AWSServices, chatService, ApiEndPoint, Utils) {
      var myUserId = UserService.get_USER_ID();

      //init data
      //connect socket
      //console.log("chatPageCtrl", $state.params);

      var getHistoricChat = function(){
        return window.localStorage.getItem($state.params.chatName);
      };

      var isFirstMessage = false;

      $scope.connectedSocket = false;
      if ($scope.connectedSocket == false) {
         //old dns
        //var socket = io.connect('http://ec2-34-212-194-26.us-west-2.compute.amazonaws.com:3000/');
        //dns for development
        var socket = io.connect('http://ec2-54-69-184-92.us-west-2.compute.amazonaws.com:3000/');
        //dns for production
        //var socket = io.connect('http://ec2-54-212-245-106.us-west-2.compute.amazonaws.com:3000/');
        $scope.connectedSocket = true;
      }
      $scope.chatMessage = "";
      $scope.data = {};
      $scope.data.chatData = [];
      $scope.me = {
        name: UserService.get_USER_NAME(),
        id: myUserId
      };
      $scope.connected = false;
      $scope.errorLoading = false;
      $scope.typing = false;
      var lastTypingTime;
      $scope.data.usersOnline = 1;
      $scope.data.sizeChanged = false;
      $scope.data.visualTitle = $state.params.friendTitle;
      $scope.data.chatTitle = $state.params.chatName;
      $scope.data.IdenChat = $state.params.chatID;
      $scope.data.myName = $scope.me.name;
      $scope.data.realLength = 0;
      //

      //Zone local function
      //Add all messages local/server to the list
      $scope.addChatMessage = function (data) {
        $scope.data.usersOnline = data.list;
        //check if the message was get by the other user
        //console.log("users online:", $scope.data.usersOnline);

        //Get current length of temporal historic and add the message
        //to it
        if (data.type == "3" || data.type == "2") {
          $scope.data.realLength++;
          var d = new Date();
          var newChatDate = d.getTime();
          var newMessage = {
            message: data.message,
            name: data.name,
            date: newChatDate,
            sender: data.idUser,
            type: data.type
          };

          $scope.data.sizeChanged = true;

          var tempoLSHistoric = JSON.parse(getHistoricChat()) || {};
          var LSLength = Object.keys(tempoLSHistoric).length + 1;
          tempoLSHistoric[LSLength] = newMessage;

          if(!isFirstMessage){
            //console.log("addChatMessage: saving data LS",tempoLSHistoric);
            window.localStorage.setItem($state.params.chatName, JSON.stringify(tempoLSHistoric));
            if(data.type == "2")
              $scope.data.chatData[$scope.data.realLength] = newMessage;
          }

          isFirstMessage = false;
        }

        //Zone to apply visual changes if the message isn't ours
        //if(data.type == 2){
        $scope.$apply();
        //}
        $ionicScrollDelegate.scrollBottom();
        //
      };
      //
      //

      //Zone for functions local to chat server
      //Enter chat New/Old // Called when enter page
      $scope.tryConnection = function (resume) {
        //console.log("tryConnection...");
        var historic;
        if (resume == false) {
          historic = JSON.parse(getHistoricChat());
          if (historic) {
            //console.log("there is a previous historic with "+$state.params.chatName);
            var histEachOne = Object.keys(historic);
            $scope.data.realLength = histEachOne.length;
            if (histEachOne.length > 10) {
              var tope = histEachOne.length;
              for (var i = 1; i <= 10; i++) {
                var currentStep = tope - (10 - i);
                $scope.data.chatData[currentStep] = historic[currentStep];
              }
            } else {
              $scope.data.chatData = historic;
            }
            $ionicScrollDelegate.scrollBottom();
            if ($state.params.read == "false" && $state.params.mine != "true") {
              chatService.updateLastMsgStatus({
                idChat: $state.params.chatID
              }).$promise.then(function (getResponse) {
                console.log("going out");
              }, function (getError) {
                console.error("can't add last message", getError);
              });
            }
          }
          else { // if not, first create the room in Ls for this room's historic
            isFirstMessage = true;
            //console.log("There was no previous historic between "+$state.params.chatName);
            var newType = "2";
            var lastMsgOwner = $state.params.nameFriend;
            var lastMsgOwnerId = $state.params.friendID;
            if ($state.params.mine == "true") {
              newType = "3";
              lastMsgOwner = $scope.me.name;
              lastMsgOwnerId = $scope.me.id
            }
            else {
              chatService.updateLastMsgStatus({
                idChat: $state.params.chatID
              }).$promise.then(function (getResponse) {
                console.log("going out");
              }, function (getError) {
                console.error("can't add last message", getError);
              });
            }

            $scope.data.realLength = 1;
            historic = {
              1: {
                message: $state.params.lastMsg,
                name: lastMsgOwner,
                date: $state.params.dateMsg,
                sender: lastMsgOwnerId,
                type: newType
              }
            };

            //console.log("tryConnection: savin data LS",historic);
            window.localStorage.setItem($state.params.chatName, JSON.stringify(historic));

            $scope.data.chatData = historic;
          }
        }

        if ($scope.connectedSocket == true) {
          //var lastType = 2;
          //var historicLength = 0;
          historic = null;
          //var d = new Date();
          //var newChatDate = d.getTime();
          //Also prepare all the devices that the friend has
          if ($state.params.friendID) {
            var promise = UserService.getDevices($state.params.friendID);
          }
          $scope.devicePromise = promise;

          //when change to this page we try to connect
          socket.emit('enterRoom', {
            room: $state.params.chatName,
            user: $scope.me.name,
            idSend: $scope.me.id,
            resumeServer: resume
          });
        }
        $ionicScrollDelegate.scrollBottom();
      };
      $scope.tryConnection(false);

      //ZONE for mantain keyboard open
      $scope.$on('$ionicView.afterEnter', function(){
        $timeout(function(){
          initListeners();
        },1000);
      });

      var buttonListening = document.getElementById("sendMessageBtn");

      function initListeners(){
        buttonListening.addEventListener("click", function(event){
          stopBubble(event);
        });

        buttonListening.addEventListener("mousedown", function(event){
          stopBubble(event);
        });

        buttonListening.addEventListener("touchdown", function(event){
          stopBubble(event);
        });

        buttonListening.addEventListener("touchmove", function(event){
          stopBubble(event);
        });

        buttonListening.addEventListener("touchend", function(event){
          stopBubble(event);
          $scope.sendMessage($scope.chatMessage);
        });

        buttonListening.addEventListener("mouseup", function(event){
          $scope.sendMessage($scope.chatMessage);
        });
      }

      function stopBubble(event){
        event.preventDefault();
        event.stopPropagation();
      }

      function terminateListeners(){
        buttonListening.removeEventListener("click",function(){});
        buttonListening.removeEventListener("mousedown",function(){});
        buttonListening.removeEventListener("touchdown",function(){});
        buttonListening.removeEventListener("touchmove",function(){});
        buttonListening.removeEventListener("touchend",function(){});
      }
      //END ZONE

      //When user writes a message
      $scope.sendMessage = function (text) {
        //show it first in the view
        if(text != null){
          if(text.trim()){
            $scope.data.realLength++;
            var d = new Date();
            var newChatDate = d.getTime();
            var newMessage = {
              message: text,
              name: $scope.me.name,
              date: newChatDate,
              sender: $scope.me.id,
              type: "3"
            };

            $scope.data.sizeChanged = true;
            $scope.data.chatData[$scope.data.realLength] = newMessage;

        //Send it to server
        if ($scope.connected) {
          socket.emit("chatMessage", {
            room: $state.params.chatName,
            message: text,
            user: $scope.me.name,
            idSend: $scope.me.id
          });

              $scope.chatMessage = null;
            } else {
              console.error("Can't connect to chat service");
            }
          }
        }
      };

      //When user is typing
      $scope.isTyping = function () {
        if ($scope.connected) {
          if (!$scope.typing) {
            $scope.typing = true;
            socket.emit('chatTyping', {room: $state.params.chatName, user: $scope.me.name});
          }
          lastTypingTime = (new Date()).getTime();

          $timeout(function () {
            var typingTimer = (new Date()).getTime();
            var timeDiff = typingTimer - lastTypingTime;
            if (timeDiff >= 400 && $scope.typing) {
              socket.emit('chatStopTyping', {room: $state.params.chatName, user: $scope.me.name});
              $scope.typing = false;
            }
          }, 400);
        } else {
          console.error("Can't connect to chat service");
        }
      };

      //When user wants to see Historial
      $scope.fillHistorial = function () {
        //console.log("fillHistorial...")
        var LSRealLS = JSON.parse(getHistoricChat())||{};
        var LSRealLSLength = Object.keys(LSRealLS).length;
        var chatData = Object.keys($scope.data.chatData);
        var chatDataLength = chatData.length;
        var temporalFillList = [];
        if (LSRealLSLength > chatDataLength) {
          var rest = LSRealLSLength - chatDataLength;
          if (rest >= 10) {
            for (var i = 1; i <= 10; i++) {
              var currentStep = rest - (10 - i);
              $scope.data.chatData[currentStep] = LSRealLS[currentStep];
            }

          } else {
            for (var i = 1; i <= rest; i++) {
              var currentStep = rest - (rest - i);
              $scope.data.chatData[currentStep] = LSRealLS[currentStep];
            }
          }
          $scope.$broadcast('scroll.refreshComplete');
        } else {
          $scope.$broadcast('scroll.refreshComplete');
        }
      };

      //Leave chatroom
      $scope.$on("$ionicView.beforeLeave", function () {
        terminateListeners();
        var data = {};
        if ($scope.connected) {
          //console.log("disconnect chatroom");
          $scope.data.chatData = [];
          //before disconnect we take the last message locate in the LS
          //save it in the server
          //only if we have at least one new message user to user
          if ($scope.data.sizeChanged) {
            var tempoLSHistorial = JSON.parse(window.localStorage.getItem($scope.data.chatTitle));
            var LSLength = Object.keys(tempoLSHistorial).length;
            var text = tempoLSHistorial[LSLength].message;
            var idSender = tempoLSHistorial[LSLength].sender;
            chatService.updateLastMessage({
              idChat: $scope.data.IdenChat,
              msg: text,
              lastUser: ApiEndPoint.url + "restful/objects/simple.UserSubscription/" + idSender
            }).$promise.then(function (getResponse) {
              console.log("going out");
            }, function (getError) {
              console.error("can't add last message", getError);
            });
          }
          //

          //Send request to server
          //leave room
          //console.log(socket.adapter.rooms);
          data = {room: $scope.data.chatTitle, user: $scope.data.myName};
          socket.emit('leaveRoom', data);
          socket.emit('ForceLeave');
          //
        } else {
          console.error("Doesn't have info of chat");
        }
      });

      //END for functions local to chat server


      //Zone LISTEN TO server
      //Trigger when a user joins an chatroom
      socket.on('userJoined', function (data) {
        console.log("socket.on.userJoined", data);
        //var historic = "";
        if (data.list > 0) { //after somebody joins the chat need to check if was made the connection
          if (data.idUser != $scope.me.id) { //check if the joined user it's me or friend
            data.type = 0;
            data.message = data.name + Utils.translate('PRIVATEMESSAGE.JOINED_USER');
            //data.message = data.name + " enter the chat";
            $scope.addChatMessage(data);
          }
          else {
            $scope.connected = true;
            if (!data.resumeServer) { //if the connection isn't resumed to avoid duplicate historic
              if ($state.params.inbox == 'false') { //if we came from newMsgPage we send any message
                socket.emit("chatMessage", {
                  room: $state.params.chatName,
                  message: $state.params.lastMsg,
                  user: $scope.me.name,
                  idSend: $scope.me.id
                });
              }
            }
            $ionicScrollDelegate.scrollBottom();
          }
        } else {
          console.error("Can't connect");
        }
      }, function (error) {
        console.error("socket.on.userJoined", error);
      });

      //Called when other user send new message // count mine's - USED
      socket.on('chatMessage', function (data) {
        console.log("data", data)
        if (data.idUser == $scope.me.id) {
          data.type = "3";
          //the number of users in the room...
          if (data.list == "1") {
            //if the server return the last message (mine)
            //but at the moment only me was present
            //first save the msg in server to pending messages
            $scope.pendingMsg = chatService.addPendingMessage().get({
              "x-isis-querystring":
                {
                  "userSubscriptionSend": {
                    "value": {
                      "href": ApiEndPoint.url + 'restful/objects/simple.UserSubscription/' + $scope.me.id
                    }
                  },
                  "userSubscriptionRec": {
                    "value": {
                      "href": ApiEndPoint.url + 'restful/objects/simple.UserSubscription/' + $state.params.friendID
                    }
                  },
                  "chatMessage": {
                    "value": data.message
                  }
                }
            }, function (data) {
              var message = $scope.me.name + Utils.translate('PUSHNOTIFICATION.PRIVATEMSG');
              for (var i = 0; i < $scope.devicePromise.value.length; i++) {
                var endpointArn = $scope.devicePromise.value[i].title;
                AWSServices.sendNotification(message, endpointArn, true, $scope.me.name);
              }
            }, function (error) {
              console.error("can't add to pending messages list", error);
            })
          }
          chatService.updateLastMessage({
            idChat: $scope.data.IdenChat,
            msg: data.message,
            lastUser: ApiEndPoint.url + "restful/objects/simple.UserSubscription/" + data.idUser
          }).$promise.then(function (getResponse) {
            console.log("going out");
          }, function (getError) {
            console.error("can't add last message", getError);
          });
        } else {
          data.type = "2";
        }
        $scope.addChatMessage(data);
      });

      //Called when other user lefts the chat - USED
      socket.on('userLeaved', function (data) {
        data.type = "0";
        data.message = data.name + " left";
        $scope.addChatMessage(data);
      });

      //Called when other user is typing - USED
      socket.on('chatTyping', function (data) {
        data.type = "1";
        data.message = data.name + " is typing";
        $scope.addChatMessage(data);
      });

      //Called when other user stop Typing - IMPLEMENTADA NO USADA
      socket.on('chatStopTyping', function (data) {
        //data.type = 4;
        //$scope.addChatMessage(data);
      });

      //Called when user disconnect//server shutdown - AUTOMATICO DEL SERVER
      socket.on('disconnect', function () {
        $scope.connected = false;
        console.log("got out of chat");
      });

      //Called when user reconnect - AUTOMATICO DEL SERVER
      socket.on('reconnect', function () {
        console.log("reconnect server");
      });

      //Called when can't get a connection - AUTOMATICO DEL SERVER
      socket.on('reconnect_error', function () {
        $scope.connected = false;
        console.log("Can't connect with user");
      });

      //Called when the user connect with socket - AUTOMATICA DEL SERVER
      //triggers if the server reopen
      socket.on('connect', function (data) {
        $scope.connected = true;
        //$scope.tryConnection(true);
        //console.log("Conectado a server");
      });


      //Called when an user enters chat - NO USADA YA
      socket.on('login', function (data) {
        $scope.connected = true;
        data.type = "0";
        data.message = "Logged in";
        $scope.addChatMessage(data);
      });
      //
      //END LISTEN to server

    }])
;
