"use strict";
appControllers
  .controller('SequenceCtrl', ['$rootScope', '$scope', '$state', '$ionicActionSheet', 'timelinesService', 'SequenceService', 'UserService', 'GroupsService', 'GroupFactory', 'cqnzData', 'likeUsersData', 'cqnzService', 'TimeLineService', 'permissionValidationService', 's3', 'TagsService', 'adsService', 'notificationsService', 'userLockerService', 'Utils', 'AWSServices', 'Push_Notif_Variables', 'Personalized', '$http', 'AppAdminMembersService', 'StreamingService', 'ApiEndPoint',
    function ($rootScope, $scope, $state, $ionicActionSheet, timelinesService, SequenceService, UserService, GroupsService, GroupFactory, cqnzData, likeUsersData, cqnzService, TimeLineService, permissionValidationService, s3, TagsService, adsService, notificationsService, userLockerService, Utils, AWSServices, Push_Notif_Variables, Personalized, $http, AppAdminMembersService, StreamingService, ApiEndPoint) {
      //console.log("SequenceCtrl created!!!");
      //just a short name :)
      var permissions = permissionValidationService;
      var isIOS = ionic.Platform.isIOS();
      var mySubscriptionHref = UserService.get_USER_INSTANCE_HREF();
      var myUserId = UserService.get_USERSUBSCRIPTIONINSTANCE_ID();
      var ImSuperAdmin = permissions.amISuperAdmin();

      //-------------------- HADER FUNCTIONS ---------------
      $scope.sendFriendProfile = function (userInstanceId) {
        if (!userInstanceId) return;

        if (userInstanceId == myUserId)
          $state.go('menu.myProfile', {}, {reload: true});
        else
          $state.go('friendProfile', {instanceId: userInstanceId}, {reload: true});
      };

      $scope.canShow3DotsSequenceMenu = function (sequence) {
        //if (!sequence.scheluded.show3Dots) return false;
        return canSaveToLocker() || canUpdateCqnzTitle() || canUpdateCqnz(sequence.content.type) ||
          canTogglePinGeneralCqnz() || canTogglePinGroupCqnz() ||
          canEnableDisableCqnzComments(sequence.metadata.belongsMe) || canReportCqnz() || canDeleteCqnz(sequence.metadata.belongsMe) /*||
          canGetQRCodeFromPost(sequence)*/;
      };

      $scope.canShow3DotsAdsSequenceMenu = function (sequence) {
        if (ImSuperAdmin) return true;
        if ($scope.previewTimeline) return false;
        return canUpdateCqnzTitle() || canUpdateCqnz() || canEnableDisableCqnzComments(sequence.metadata.belongsMe) ||
          canReportCqnz() || canDeleteCqnz(sequence.metadata.belongsMe) /*|| canGetQRCodeFromPost(sequence)*/;
      };

      /**
       * @param sequence {SequenceType}
       * @param listIndex {number}
       */
      $scope.open3DotsSequenceMenu = function (sequence, listIndex) {
        var buttons = [];
        var buttonsIds = [];
        console.log("Sequence list idx: %d", listIndex)

        if (!sequence.locker && canSaveToLocker() && !sequence.scheluded.inScheduledPage) {
          buttons.push({text: Utils.translate('SEQUENCE.SAVE_IN_LOCKER') + ' <i class="icon ion-archive balanced"></i>'});
          buttonsIds.push('SAVE_IN_LOCKER');
        }
        if (sequence.locker) {
          buttons.push({text: Utils.translate('SEQUENCE.REMOVE_FROM_LOCKER') + ' <i class="icon ion-ios-undo assertive"></i>'});
          buttonsIds.push('REMOVE_FROM_LOCKER');
        }
        if (canUpdateCqnzTitle() && sequence.metadata.belongsMe && sequence.content.type !== 1) {
          buttons.push({text: Utils.translate('PROFILE.EDIT_TITLE') + '<i class="icon ion-android-create"></i>'});
          buttonsIds.push("EDIT_TITLE");
        }
        if (canUpdateCqnz(sequence.content.type) && sequence.metadata.belongsMe) {//not available for  video nor statement, only photos
          buttons.push({text: Utils.translate('PROFILE.MODIFY') + '<i class="icon ion-android-create"></i>'});
          buttonsIds.push("MODIFY_CQNZ");
        }
        if (canChangeAdConfig(sequence.metadata.belongsMe) && sequence.metadata.isAdvertisement) {
          buttons.push({text: Utils.translate('PROFILE.CHANGE_CONFIG') + '<i class="icon ion-android-settings"></i>'});
          buttonsIds.push("EDIT_CONFIG");
        }
        if (canUpdateCqnzDescriptionInGralTimeline() && sequence.metadata.belongsMe && sequence.content.type !== 1) {
          buttons.push({text: Utils.translate('PROFILE.EDIT_DESCRIPTION') + '<i class="icon ion-android-create"></i>'});
          buttonsIds.push("EDIT_DESCRIPTION");
        }
        if (canUpdateCqnzUrlInGralTimeline() && sequence.metadata.belongsMe && sequence.content.type === 1) {
          buttons.push({text: Utils.translate('PROFILE.EDIT_URL') + '<i class="icon ion-android-create"></i>'});
          buttonsIds.push("EDIT_URL");
        }
        if (!sequence.metadata.isAdvertisement && !sequence.scheluded.inScheduledPage) {
          if (canTogglePinGeneralCqnz() || canTogglePinGroupCqnz()) {
            if (sequence.metadata.isPinned)
              buttons.push({text: Utils.translate('SEQUENCE.UNPIN_CQNZ_TXT') + '<i class="icon ion-pin"></i>'});
            else if ($scope._totalPinnedSequences < $scope._maxSequencesToPin)
              buttons.push({text: Utils.translate('SEQUENCE.PIN_CQNZ_TXT') + ' <i class="icon ion-pin"></i>'});

            if(sequence.metadata.isPinned || $scope._totalPinnedSequences < $scope._maxSequencesToPin)
              buttonsIds.push('TOGGLE_PIN');
          }
        }
        if (canToggleShareable(sequence.metadata.isAdvertisement) ) {
          if (!sequence.share.enabled)
            buttons.push({text: Utils.translate('SEQUENCE.SHAREABLE_ON') + '<i class="icon ion-android-share"></i>'});
          else
            buttons.push({text: Utils.translate('SEQUENCE.SHAREABLE_OFF') + '<i class="icon ion-android-share"></i>'});

          buttonsIds.push('TOGGLE_SHAREABLE');
        }
        if (canEnableDisableCqnzComments(sequence.metadata.belongsMe)) {
          buttons.push({text: Utils.translate('UPLOAD.' + (sequence.comments.enabled ? 'DIS' : 'EN') + 'ABLE_COMMENTS') + ' <i class="icon ion-quote"></i>'});
          buttonsIds.push('COMMENTS_TOGGLE_ENABLE');
        }
        if (canReportCqnz() && !sequence.scheluded.inScheduledPage) {
          buttons.push({text: Utils.translate('SEQUENCE.REPORT') + ' <i class="icon ion-alert-circled"></i>'});
          buttonsIds.push('REPORT');
        }
        if(sequence.scheluded.inScheduledPage) {
          buttons.push({text: Utils.translate('SCHEDULED_MAINPAGE.EDIT_BUTTONS.TIME')  + '<i class="icon ion-android-create"></i>'});
          buttonsIds.push("EDIT_TIME");
          buttons.push({text: Utils.translate('SCHEDULED_MAINPAGE.EDIT_BUTTONS.DATE')  + '<i class="icon ion-android-create"></i>'});
          buttonsIds.push("EDIT_DATE");
        }
        if(ImSuperAdmin && !sequence.metadata.belongsMe) {
          buttons.push({ text: Utils.translate('MENU.ADMIN_TOOLS.BLOCK_USER') + '<i class="icon ion-alert-circled"></i>' });
          buttonsIds.push('MENU.ADMIN_TOOLS.BLOCK_USER');
        }
        //CHECK IF QRCODE CAN BE CREATED
        //Aqui puedes usar la misma funcion canGetQRCodeFromPost(sequence) y si vas a meter mas de 1 boton
        //dependiendo del tipo (1 0 2) pues tendrias que poner 2 if
        /*if(canGetQRCodeFromPost(sequence) && sequence.QRCode.type != 0) { //en sequenceFactory le etí el atributo QRCode, no lo deje en metadata
            buttons.push({text: 'Create QRCode' + '<i class="icon ion-android-settings"></i>'})
            buttonsIds.push('CREATE_QRCODE');
            //Meter boton tipo 1
        }*/

        Utils.$ionicActionSheet.show({
          buttons: buttons,
          titleText: Utils.translate('SEQUENCE.OPTIONS'),
          buttonClicked: function (buttonIndex) {
            switch (buttonsIds[buttonIndex]) {
              case 'SAVE_IN_LOCKER':
                saveCqnzInLocker(sequence, listIndex);
                break;
              case "REMOVE_FROM_LOCKER":
                Utils.confirm.show(Utils.translate('LOCKER.DIALOG.REMOVE_ITEM_CONFIRM')).then(function (confirmed){
                  if (!confirmed) return;
                  removeCqnzFromLocker(sequence, listIndex);
                });
                break;
              case "EDIT_TITLE": // NEW FUNCTION
                //this function must be implemented inside the father controller
                $scope.openComposerScreen(
                  sequence.title.titleEditable,
                  {tagsList: sequence.title.tagsList, hashList: sequence.title.hashesList, needSearch: false, extra: false, title: true}
                ).then(function (form) {
                  //First check if the new text is the same as the old one
                  if (form.title === sequence.title.titleBackup) return;

                  sequence.title.isUpdating = true;//for showing the spinner
                  //CHECK FOR NEW HASH ADDED
                  var createHashTagPromises = {};
                  var index = 0;
                  form.savedHashes.forEach(function (hashTag) {
                    var id = hashTag.id;
                    if(id != null) {
                      //nothing to do here
                    } else {
                      createHashTagPromises[index] = TagsService.createHashTagWS(hashTag.hash).$promise.then(function(newHashTag) {
                        hashTag.id = newHashTag.result.instanceId;
                        //hashTag.new = false;
                      }, function(createHashTagError) {
                        console.log('createHashTagError', createHashTagError);
                      });
                      index++;
                    }
                  })
                  //AFTER ADD NEW HASH PROCEED NORMALLY
                  Utils.$q.all(createHashTagPromises).then( function (respAddHash) {
                    sequence.updateMyTitle(form).then(function (newDescription) {
                      sequence.title = newDescription;//<-- here the spinner should hide
                      setTimeout(function () {
                        $scope.$apply()
                      }, 10)
                    }, function (error) {
                      console.error("something happen");
                      sequence.title = sequence.title.titleBackup;
                      sequence.title.isUpdating = false;
                    });
                  }, function (errAddHash) {
                    sequence.updateMyTitle(form).then(function (newDescription) {
                      sequence.title = newDescription;//<-- here the spinner should hide
                      setTimeout(function () {
                        $scope.$apply()
                      }, 10)
                    }, function (error) {
                      console.error("something happen");
                      sequence.title = sequence.title.titleBackup;
                      sequence.title.isUpdating = false;
                    });
                  })
                });
                break;
              case "EDIT_DESCRIPTION": //OLD FUNCTION NEED NEW TEXT
                $scope.openComposerScreen(
                  sequence.description.titleEditable,
                  {tagsList: sequence.description.tagsList, hashList: sequence.description.hashesList, needSearch: true, extra: true, title: false}
                ).then(function (form) {
                  //First check if the new text is the same as the old one
                  if (form.description === sequence.description.titleBackup) return;

                  sequence.description.isUpdating = true;//for showing the spinner

                  //CHECK FOR NEW HASH ADDED
                  var createHashTagPromises = {};
                  var index = 0;
                  form.savedHashes.forEach(function (hashTag) {
                    var id = hashTag.id;
                    if(id != null) {
                      //nothing to do here
                    } else {
                      createHashTagPromises[index] = TagsService.createHashTagWS(hashTag.hash).$promise.then(function(newHashTag) {
                        hashTag.id = newHashTag.result.instanceId;
                        //hashTag.new = false;
                      }, function(createHashTagError) {
                        console.log('createHashTagError', createHashTagError);
                      });
                      index++;
                    }
                  })
                  //AFTER ADD NEW HASH PROCEED NORMALLY
                  Utils.$q.all(createHashTagPromises).then( function (respAddHash) {
                    sequence.updateMyDescription(form).then(function (newDescription) {
                      sequence.description = newDescription;//<-- here the spinner should hide
                      setTimeout(function () {
                        $scope.$apply()
                      }, 10)
                    }, function (error) {
                      console.error("something happen");
                      sequence.description = sequence.description.titleBackup;
                      sequence.description.isUpdating = false;
                    });
                  }, function (errAddHash) {
                    sequence.updateMyDescription(form).then(function (newDescription) {
                      sequence.description = newDescription;//<-- here the spinner should hide
                      setTimeout(function () {
                        $scope.$apply()
                      }, 10)
                    }, function (error) {
                      console.error("something happen");
                      sequence.description = sequence.description.titleBackup;
                      sequence.description.isUpdating = false;
                    });
                  })
                });
                break;
              case "EDIT_URL": //NEW FUNCION
                $scope.openComposerScreen(
                  sequence.url.url,
                  {tagsList: [], hashList: [], needSearch: false, extra: false, title: false}
                ).then(function (form) {
                  //First check if the new text is the same as the old one
                  if (form.description === sequence.url.urlBackup) return;
                  var newForm = {
                    have: sequence.url.have,
                    url: form.description,
                    urlBackup: form.description,
                    isUpdating: false
                  }
                  sequence.url.isUpdating = true;//for showing the spinner
                  sequence.updateMyUrl(newForm).then(function (newDescription) {
                    sequence.url = newDescription;//<-- here the spinner should hide
                    setTimeout(function () {
                      $scope.$apply()
                    }, 10)
                  }, function () {
                    /*the error is printed/shown inside the function*/
                  });
                });
                break;
              case 'EDIT_CONFIG':
                sequence.updateMyAdConfig().then(function (newSequenceData) {
                  //if(newSequenceData !== -1)//-1 == the modal was cancelled, nothing to do.
                  //do anything you want
                });
                break;
              case "MODIFY_CQNZ":
                //$state.go('modifySequence', {sequenceInstanceId: sequence.metadata.instanceId}, {reload: true});
                $state.go('modifySequence', {sequence: sequence}, {reload: true});
                break;
              case 'TOGGLE_PIN':
                var groupHrefId = $scope._controllerName === 'GroupTimeLineCtrl' ? $scope._groupHrefId : 0;
                sequence.togglePinMe(!sequence.metadata.isPinned, groupHrefId).then(function (isPinnedNow) {
                  if (isPinnedNow) {
                    $scope._totalPinnedSequences++;

                    var myPinnedSequence = $scope._sequenceList.slice(listIndex, listIndex + 1)[0];

                    //we insert the sequence in the first place
                    $scope._sequenceList.unshift(myPinnedSequence);
                  }
                  else {
                    $scope._totalPinnedSequences--;

                    //todo: if we will have more than 1 pinned post, we'll need to locate it before remove it
                    //we remove the first sequence
                    $scope._sequenceList.shift();

                    //now we find the 'hidden' sequence and show it by changing its pinned state
                    $scope._sequenceList.some(function (seq) {
                      if (seq.metadata.instanceId === sequence.metadata.instanceId) {
                        seq.metadata.isPinned = false;
                        return true;
                      }
                    });
                  }
                }, function () {
                  /*the error is printed/shown inside the function*/
                });
                break;
              case 'TOGGLE_SHAREABLE':
                Utils.loading.show();
                sequence.toggleEnableShareMe().then(function () {
                  //nothing to do
                }, function (error) {
                  //the error is printed/shown inside the function
                }).finally(function () {
                  Utils.loading.hide();
                });
                break;
              case 'REPORT':
                sequence.reportMe();
                break;
              case 'COMMENTS_TOGGLE_ENABLE':
                Utils.loading.show();
                sequence.toggleEnableMyComments(!sequence.comments.enabled).then(function (resp) {
                  //sequence.comments.enabled = resp;
                }, function (error) {
                  //the error is printed/shown inside the function
                }).finally(function () {
                  Utils.loading.hide();
                });
                break;
              /*case 'CREATE_QRCODE':
                var postId = sequence.metadata.id;
                var postInstanceId = sequence.metadata.instanceId;
                var nameAddWS = sequence.content.type == 3 ? 'video' : 'image';
                var typeName = sequence.QRCode.type == 1 ? "Promo" : "EasterEgg";
                var dataForQRCode = "niido"+typeName+"_List_" + postId + "_" + postInstanceId;
                typeName = typeName + postId + postInstanceId;
                var dialog = Utils.alert.getCtrl();
                dialog.show({
                  templateUrl: 'templates/QRList/QRCodeForPostTpl.html',
                  controller: "showPostQRCodeCtrl",
                  locals: {
                    dataCode: dataForQRCode,
                    type: typeName,
                    nameAdd: nameAddWS,
                    dialog: dialog
                  },
                  clickOutsideToClose: false,
                    fullscreen: true // Only for -xs, -sm breakpoints.
                }).then(function () {
                  
                }, function () {
                  
                });
                break;*/
                case 'EDIT_TIME':
                $scope.openScreenScheduled(
                  sequence.scheluded.time,
                  "TIME",
                  sequence
                ).then(function (form) {
                  if(form.newDate === sequence.scheluded.time) return;

                  sequence.scheluded.time = form.newDate;
                  setTimeout(function () {
                    $scope.$apply()
                  }, 10)
                }, function () {

                })
                break;
              case 'EDIT_DATE':
                $scope.openScreenScheduled(
                  sequence.scheluded.date,
                  "DATE",
                  sequence
                ).then(function (form) {
                  if(form.newDate === sequence.scheluded.date) return;

                  sequence.scheluded.date = form.newDate;
                  setTimeout(function () {
                    $scope.$apply()
                  }, 10)
                }, function () {

                })
                break;
              case 'MENU.ADMIN_TOOLS.BLOCK_USER':
                var idUser = parseInt(sequence.ownerMetadata.instID);
                confirmLockUser(idUser);
                break;
              default:
                Utils.toast.warning("Invalid option '" + buttonsIds[buttonIndex] + "'");
            }
            return true;
          },
          destructiveText: canDeleteCqnz(sequence.metadata.belongsMe) ? Utils.translate('SEQUENCE.DELETE') + ' <i class="icon ion-close-round"></i>' : null,
          destructiveButtonClicked: canDeleteCqnz(sequence.metadata.belongsMe) ? function () {
            confirmDeleteCqnz(sequence, listIndex);
            return true;
          } : null
        })
      };

      /*$scope.testClick = function () {
        console.error("CLICKED");
      };*/

      $scope.whatCliked = function (evt, sequence) {
        var realText = [];
        if (evt.target.id || evt.target.id != '') {
          if (evt.target.id == myUserId)
            $state.go('menu.myProfile', {}, {reload: true});
          else
            $state.go('friendProfile', {instanceId: evt.target.id}, {reload: true});
        } else if(evt.target.innerText.split('#').length > 1) {
          if (sequence.description.hashesList && sequence.description.hashesList.length) {
            realText = evt.target.innerText.split(' ');
            if (realText.length === 1) {
              $state.go('hashTimeLine', {"hashName": evt.target.innerText}, {reload: true});
            }
          } else if (evt.target.innerText.match("(https|ftp|www|file).*")) {
            if(!sequence.metadata.belongsMe) {
              if(sequence.metadata.isAdvertisement) {
                adsService.increaseURLClicksCount(sequence.metadata.instanceId).then ( function () {
                  console.log("added one link count");
                }, function (error) {
                  console.error("can't add link count");
                })
              }
            }
          }
        }
        else {
          if(!sequence.metadata.belongsMe) {
            if(sequence.metadata.isAdvertisement) {
              adsService.increaseURLClicksCount(sequence.metadata.instanceId).then ( function () {
                console.log("added one link count");
              }, function (error) {
                console.error("can't add link count");
              })
            }
          }
          console.log("an url");
        }
      };

      $scope.titleClick = function (evt, sequence) {
        var realText = [];
        if (evt.target.id || evt.target.id != '') {
          if (evt.target.id == myUserId)
            $state.go('menu.myProfile', {}, {reload: true});
          else
            $state.go('friendProfile', {instanceId: evt.target.id}, {reload: true});
        } else if(evt.target.innerText.split('#').length > 1) {
          if (sequence.title.hashesList && sequence.title.hashesList.length) {
            realText = evt.target.innerText.split(' ');
            if (realText.length === 1) {
              $state.go('hashTimeLine', {"hashName": evt.target.innerText}, {reload: true});
            }
          } else if (evt.target.innerText.match("(https|ftp|www|file).*")) {
            if(!sequence.metadata.belongsMe) {
              if(sequence.metadata.isAdvertisement) {
                adsService.increaseURLClicksCount(sequence.metadata.instanceId).then ( function () {
                  console.log("added one link count");
                }, function (error) {
                  console.error("can't add link count");
                })
              }
            }
          }
        }
        else {
          if(!sequence.metadata.belongsMe) {
            if(sequence.metadata.isAdvertisement) {
              adsService.increaseURLClicksCount(sequence.metadata.instanceId).then ( function () {
                console.log("added one link count");
              }, function (error) {
                console.error("can't add link count");
              })
            }
          }
          console.log("an url");
        }
      }
      //---------------- END OF HADER FUNCTIONS ------------


      //---------------- CONTENT FUNCTIONS -----------------
      $scope.sendToFullPost = function (notif) {
        var indexGroupActive = 0;
        if(notif.content.items[0].url.endsWith('m3u8')) {
          var indexGroupActive = 0;
          if($scope.groupData) {
            if(notif.metadata.groupId != null) {
              indexGroupActive = $scope.groupData.groupIndex;
            }
          }
          $state.go('showStreaming', {
            sequenceId: notif.metadata.id,
            groupId: notif.metadata.groupId,
            fromWhere: $state.current.name,
            groupIndex: indexGroupActive
          }, {reload: true});
        } else {
          if($scope.groupData) {
            if(notif.metadata.groupId != null) {
              indexGroupActive = $scope.groupData.groupIndex;
            }
          }
          $state.go('showNotification', {
            sequenceId: notif.metadata.id,
            groupId: notif.metadata.groupId,
            fromWhere: $state.current.name,
            groupIndex: indexGroupActive}, {reload: true});  
        }
      }

      $scope.play = function ($inview, sequence) {
        if (!sequence.content)
          console.log("$scope.play", sequence);
        sequence.content.templateIdBackup = $inview || sequence.content.templateId.substr(0, 17) !== 'templateAutomate0' ? sequence.content.templateId : 'templateAutomate01';
      };

      //the call was set inside Utils.generateAnchors() function
      $scope.openInappBrowser = function (url) {
        $rootScope.$broadcast('openBrowser');
        var isIOS = ionic.Platform.isIOS();
        var zone = '_blank';
        var opt = '';
        if(isIOS){
          zone = '_blank';
          opt = 'clearsessioncache=yes,usewkwebview=yes,toolbar=yes,presentationstyle=fullscreen,hidespinner=yes,closebuttoncaption=Close,closebuttoncolor=#ffffff4,navigationbuttoncolor=#ffffff,lefttoright=yes,location=no';
        }
        else{
          zone ='_blank';
          opt = 'clearsessioncache=yes,usewkwebview=yes,toolbar=yes,presentationstyle=fullscreen,hidespinner=yes,closebuttoncaptionSet=Close,closeButtonColorSet=#ffffff4,navigationbuttoncolorSet=#ffffff,lefttoright=yes,location=no';
        }
        var ref = cordova.InAppBrowser.open(url, zone, opt);

      };

      function confirmLockUser(userID) {
        Utils.confirm.show(Utils.translate('ADMIN_TOOLS.ADMIN_MEMBERS.DIALOG.LOCK_ACCOUNT_CONF')).then(function(boolResp) {
          if (!boolResp) return;

          Utils.loading.show();
          AppAdminMembersService.lockUser(
            userID
          ).then(function(value) {
            Utils.toast.success(Utils.translate('ADMIN_TOOLS.ADMIN_MEMBERS.DIALOG.LOCK_ACCOUNT_OK'))
          }, function(error) {
            console.error(error);
            Utils.toast.error(Utils.translate('ADMIN_TOOLS.ADMIN_MEMBERS.DIALOG.LOCK_ACCOUNT_ERROR'))
          }).finally(function() {
            Utils.loading.hide();
          })
        })
      }

      //todo: send broadcast
      $scope.playVideoOwn = function (index, sequence, nameCtrl) {
        //PREPARE DATA FOR VIDEO
          var urlToUse = sequence.content.items[0].url;
          console.log("VIDEO CALLED: ", urlToUse);
          sequence.content.videoPlayedCounter++;
          if(!sequence.metadata.belongsMe) {
            if(sequence.metadata.isAdvertisement) {
              adsService.increaseClicksCount(sequence.metadata.instanceId).then(function () {
                console.log("Ad clicks increased")
              }, function (error) {
                console.error("increaseClicksCount", error);
              });
            }
          }
          TimeLineService.setPostVideoCount({
            objectId: sequence.metadata.instanceId
          }).save({}, function (response) {
            console.log("ok");
          }, function (err) {
            console.log("error");
          });
          var urls = { "1": null };
          var pivot = JSON.parse(window.localStorage.getItem('AppsPerzonalized'));
        //PREPARE DATA FOR VIDEO END

        //CHECK IF VIDEO IS STREAM
          if(urlToUse.endsWith('m3u8')){
            //IF STREAM WE SHOW BANNERS
              StreamingService.getBannersForVideoOrStream().$promise.then(function (response) {
                console.log("GOT: ", response)
                //ADD ALL THE RESPONSES TO ARRAY
                  var urls = {};
                  response.forEach( function(url) {
                    urls[url.pictureId] = url.url;
                  })
                //ADD ALL THE RESPONSES TO ARRAY END
                //CALL PLUGIN TO SHOW VIDEO
                  var options = {
                    successCallback: function() {
                    },
                    errorCallback: function(errMsg) {
                      Utils.toast.error(Utils.translate('SEQUENCE.DIALOG.STREAM_NOT_FOUND'));
                      console.log('error:' + errMsg);
                    },
                    timeBetween: ""+pivot.timeForBanners,            
                    orientation: 'portrait',
                    shouldAutoClose: true, // true(default)/false
                    controls: true // true(default)/false. Used to hide controls on fullscreen
                  };
                  window.plugins.streamingMedia.playVideo(urlToUse, options, urls);
                //CALL PLUGIN TO SHOW VIDEO END
              }, function (error) {
                console.error("fail findAllAdPictures");
                //NOT GOT ANY BANNER, SHOW VIDEO ONLY
                  var options = {
                    successCallback: function() {
                    },
                    errorCallback: function(errMsg) {
                      if(urlToUse.endsWith('m3u8')) {
                        Utils.toast.error(Utils.translate('SEQUENCE.DIALOG.STREAM_NOT_FOUND'));
                      } else {
                        Utils.toast.error(Utils.translate('SEQUENCE.DIALOG.VIDEO_NOT_FOUND'));
                      }
                      console.log('error:' + errMsg);
                    },
                    timeBetween: "0",
                    orientation: 'portrait',
                    shouldAutoClose: true, // true(default)/false
                    controls: true // true(default)/false. Used to hide controls on fullscreen
                    //chatON: "true"
                  };
                  /*var chatURLs = [];
                  chatURLs[0] = ApiEndPoint.url + 'restful/services/SequenceCommentsRepository/actions/findTheCommentsOfASequencev1711/invoke';
                  chatURLs[1] = ApiEndPoint.url + 'restful/services/SequenceCommentsRepository/actions/addSequenceCommentsv166/invoke';
                  chatURLs[2] = ApiEndPoint.url + 'restful/objects/simple.Sequence/' + sequence.sequenceId;
                  chatURLs[3] = ApiEndPoint.url + 'restful/objects/simple.UserSubscription/' + sequence.userId;*/
                  window.plugins.streamingMedia.playVideo(urlToUse, options, null); //, chatURLs
                //NOT GOT ANY BANNER, SHOW VIDEO ONLY
              });
            //
          } else {
            //IF NOT, ONLY VIDEO
              var options = {
                successCallback: function() {
                },
                errorCallback: function(errMsg) {
                  Utils.toast.error(Utils.translate('SEQUENCE.DIALOG.VIDEO_NOT_FOUND'));
                  console.log('error:' + errMsg);
                },
                timeBetween: "0",            
                orientation: 'portrait',
                shouldAutoClose: true, // true(default)/false
                controls: true // true(default)/false. Used to hide controls on fullscreen
                //chatON: "true"
              };
              /*var chatURLs = {};
              chatURLs[0] = ApiEndPoint.url + 'restful/services/SequenceCommentsRepository/actions/findTheCommentsOfASequencev1711/invoke';
              chatURLs[1] = ApiEndPoint.url + 'restful/services/SequenceCommentsRepository/actions/addSequenceCommentsv166/invoke';
              chatURLs[2] = ApiEndPoint.url + 'restful/objects/simple.Sequence/' + sequence.sequenceId;
              chatURLs[3] = ApiEndPoint.url + 'restful/objects/simple.UserSubscription/' + sequence.userId;*/
              window.plugins.streamingMedia.playVideo(urlToUse, options, urls);
            //IF NOT, ONLY VIDEO
          }
        //CHECK IF VIDEO IS STREAM END
      };

      $scope.sendStreamView = function (sequence) {
        var indexGroupActive = 0;
        if($scope.groupData) {
          if(sequence.metadata.groupId != null) {
            indexGroupActive = $scope.groupData.groupIndex;
          }
        }
        $state.go('showStreaming', {
          sequenceId: sequence.metadata.id,
          groupId: sequence.metadata.groupId,
          fromWhere: $state.current.name,
          groupIndex: indexGroupActive
        }, {reload: true});
      }

      $scope.chkPlace = function (index, sequence, nameCtrl) {
        var chkPage = $state.current.name
        //console.log("we're", chkPage);
        if(chkPage === "showNotification") {
          setTimeout(function() {
            //$scope.playVideoOwn(index, sequence, nameCtrl);
          }, 1000);
          
        } else {
          console.log("not autoplay");
        }
      }

      function finished(e) {
        console.log(e);
        e.target.controls = false;
        var getID = e.target.id.split('VideoArea')[1];
        var getIDCtrl = e.target.id.split('VideoArea')[0];
        var buttonPlay = document.getElementById(getIDCtrl + 'ButtonPlay' + getID);
        buttonPlay.hidden = false;
      }

      //------------ END OF CONTENT FUNCTIONS --------------

      /* FUNCTION TO FOLLOW USER IN TIMELINE BALA*/
        $scope.unfollowText = Utils.translate('GLOBAL.UNFOLLOW');
        $scope.followText = Utils.translate('GLOBAL.FOLLOW');
        $scope.pendingRequest = Utils.translate('GLOBAL.PENDING');
        $scope.addFriends = function (data) {
          data.suggestedPost.msgShow = "------";
          if(data.suggestedPost.waiting)
            return true
          data.suggestedPost.waiting = true;

          switch (data.suggestedPost.isFriend) {
            case 3: //NO FOLLOW -> FOLLOW PROCESS
              data.suggestedPost.msgShow = $scope.unfollowText;
              data.suggestedPost.isFriend = 1;
              data.suggestedPost.show = false;
              UserService.toggleFriendhipStateWS({
                userInstanceId: UserService.get_USERSUBSCRIPTIONINSTANCE_ID(),
                friendInstaceId: data.ownerMetadata.id
              }).$promise.then(function (response) {
                //get userInstanceID
                if(!data.suggestedPost.friendInstanceID)
                  findFriendInstanceId(data);
              }, function (error) {
                data.suggestedPost.msgShow = $scope.followText;
                data.suggestedPost.isFriend = 3;
              })
            break;
            /*case 2: // PENDING
              if(data.suggestedPost.friendID) {
                UserService.cancelRequestToPrivate({
                  "objectId": $scope.simpleIdFriend }).save().$promise.then(function success(response) {
                  $scope.msgShowRequest = $scope.followText;
                  $scope.simpleIdFriend = "";
                  $scope.waitingAnswer = false;
                }, function(err) {});
              }
            break;*/
            case 1: // FOLLOW -> NO FOLLOW PROCESS
              data.suggestedPost.msgShow = $scope.followText;
              data.suggestedPost.isFriend = 3;
              if(data.suggestedPost.friendID) {
                UserService.cancelRequestToPrivate({
                  "objectId": data.suggestedPost.friendID
                }).save().$promise.then(function success(response) {
                  data.suggestedPost.friendInstanceID = null;
                  data.suggestedPost.friendID = null;
                  data.suggestedPost.waiting = false;
                }, function(err) {
                  data.suggestedPost.msgShow = $scope.unfollowText;
                  data.suggestedPost.isFriend = 1;
                });
              }
            break;
          }
        }

        function findFriendInstanceId(data) {
          UserService.findFriendInstanceId({
            userId: UserService.get_USERSUBSCRIPTIONINSTANCE_ID(),
            friendId: data.ownerMetadata.id
          }).then(function success(response) {
            if (response.result.value.length > 0) 
              data.suggestedPost.friendInstanceID = response.result.value[0].href.split('/')[6];
            findStatusRequestFriend(data);
          }, function(response) {
            console.log("findFriend", response);
          });
        }

        function findStatusRequestFriend(data) {
          UserService.getStatusPrivateRequest({
            userId: UserService.get_USERSUBSCRIPTIONINSTANCE_ID(),
            friendId: data.ownerMetadata.id
          }).$promise.then(function success(response) {
            console.log("success", response);
            if (response.friend)
              data.suggestedPost.friendID = Utils.getLastUrlComponent(response.friend.href);
            data.suggestedPost.waiting = false;
          }, function(err) {
            console.log("mistake when finding status request", err);
          })
        }
      /* FUNCTION TO FOLLOW USER IN TIMELINE END*/

      // ------------------ CQNZ BOTTOM strip FUNCTIONS ----------------------
      function happyon(sequenceId) {
        try {
          document.getElementById('happyNumberon' + sequenceId).style.display = 'block';
          document.getElementById('happyNumberoff' + sequenceId).style.display = 'none';
          document.getElementById('happyNumberoff' + sequenceId).className = "off1";
        } catch (e) {
          console.error("happyon", e)
        }
      }

      function happyoff(sequenceId) {
        try {
          document.getElementById('happyNumberon' + sequenceId).style.display = 'none';
          document.getElementById('happyNumberoff' + sequenceId).style.display = 'block';
          document.getElementById('happyNumberoff' + sequenceId).className = "on1";
        }
        catch (e) {
          console.error("happyoff", e)
        }
      }

      /**
       * @param sequence {SequenceType}
       * @param listIndex
       */
      $scope.setLikeToSequence = function (sequence, listIndex) {
        if (!ImSuperAdmin && $scope.previewTimeline) {
          Utils.toast.warning(Utils.translate('PERMISSIONS.CANNOT.PERFORM_ACTION_ON_PREVIEW'));
          return;
        }
        if (!canLikeToSequence()) {
          Utils.toast.warning(Utils.translate('PERMISSIONS.CANNOT.GRAL_TLINE_CQNZ_LIKE'));
          return;
        }
        //console.log(sequence);

        var newActiveLike = !sequence.like.active.result.value;

        //optimistic updates
        sequence.like.active.result.value = newActiveLike;
        newActiveLike ? sequence.like.counter++ : sequence.like.counter--;
        newActiveLike ? happyon(sequence.metadata.id) : happyoff(sequence.metadata.id);

        var animatedIcon = document.getElementById('animation' + listIndex);
        if (animatedIcon) animatedIcon.style.display = newActiveLike ? 'block' : 'none';

        sequence.likeMe().then(function (newValues) {

        }, function (responseError) {
          console.error("sequence.likeMe()", responseError);
          //rollback to previous state
          sequence.like.active.result.value = responseError.active;
          sequence.like.counter = responseError.counter;
          responseError.active ? happyon(sequence.metadata.id) : happyoff(sequence.metadata.id);
          //if (animatedIcon) animatedIcon.style.display = responseError.active ? 'block' : 'none';
        })
      };

      $scope.showUsersWhoLiked = function (sequence) {
        /*if (ImSuperAdmin ||
         (sequence.metadata.belongsMe && sequence.like.counter && !$scope.peviewTimeline)) {*/
        likeUsersData.anadir(sequence.like.counter, sequence.metadata.instanceId);
        $state.go('listLikes', {number: sequence.like.counter}, {reload: true});
        //}
      };

      $scope.showUsersSharePost = function (sequence) {
        /*if (ImSuperAdmin ||
         (sequence.metadata.belongsMe && sequence.like.counter && !$scope.peviewTimeline)) {*/
        likeUsersData.anadir(sequence.share.counter, sequence.metadata.instanceId);
        $state.go('listShares', {number: sequence.like.counter}, {reload: true});
        //}
      }

      $scope.redirectSendReaction = function (sequence) {
        if (!ImSuperAdmin && $scope.previewTimeline) {
          Utils.toast.warning(Utils.translate('PERMISSIONS.CANNOT.PERFORM_ACTION_ON_PREVIEW'));
          return;
        }
        if (!$scope.canReactToSequence()) {
          Utils.toast.warning(Utils.translate('PERMISSIONS.CANNOT.GRAL_TLINE_CQNZ_REACT'));
          return
        }

        $state.go('sendReaction', {sequence: sequence}, {reload: true});
      };

      /**
       * @param sequence {SequenceType}
       * @param listIndex
       */
      $scope.openSharingOptions = function (sequence, listIndex) {
        if (!ImSuperAdmin && $scope.previewTimeline) {
          Utils.toast.warning(Utils.translate('PERMISSIONS.CANNOT.PERFORM_ACTION_ON_PREVIEW'));
          return;
        }

        if (!$scope.canOpenSharingOptions(sequence)) {
          Utils.toast.warning(Utils.translate('PERMISSIONS.CANNOT.GRAL_TLINE_CQNZ_SHARE'));
          return;
        }

        var buttons = [], buttonsIds = [];
        console.log("canShareInGroupsTimeline: " + canShareInGroupsTimeline());

        if (canShareInGroupsTimeline()) {
          buttons.push({text: Utils.translate('SEQUENCE.SHARE_IN_GROUPS_TIMELINE') + ' <i class="icon myIcon-line-weight"></i>'});
          buttonsIds.push("IN_GROUPS");
        }
        if (canShareInGeneralTimeline()) {
          buttons.push({text: Utils.translate('SEQUENCE.SHARE_IN_TIMELINE') + ' <i class="icon myIcon-line-weight"></i>'});
          buttonsIds.push("IN_USER_TIMELINE");
        }
        if (canShareExternally(sequence.content.type)) {//not available for statements
          /*buttons.push({text: Utils.translate('SEQUENCE.SHARE_EXTERNALLY') + ' <i class="icon ion-android-share-alt"></i>'});
          buttonsIds.push("EXTERNALLY");*/
          //BEGIN SHARE URL
          buttons.push({text: Utils.translate('SHARE_LINK.MENU_TEXT') + ' <i class="icon ion-android-share-alt"></i>'});
          buttonsIds.push("LINK");
        }

        Utils.$ionicActionSheet.show({
          buttons: buttons,
          titleText: Utils.translate('TIMELINE.SHARE_UI.SHARE_CQNZ'),
          buttonClicked: function (buttonIndex) {
            switch (buttonsIds[buttonIndex]) {
              case 'IN_USER_TIMELINE':
                doShareInUserTimeline(sequence.metadata, listIndex);
                break;
              case "IN_GROUPS":
                showAllGroupsModal(sequence, listIndex);
                break;
              case "EXTERNALLY": { //NOT USED ANYMORE
                Utils.loading.show();
                try {
                  sequence.shareMe('imageBox' + sequence.content.templateId + listIndex).then(function () {
                    increaseSharesCount(sequence.metadata, listIndex);
                  }, function (error) {
                    //the errors are printed/shown in the function
                  }).finally(function () {
                    Utils.loading.hide();
                  });
                }
                catch (e) {
                  sequence.share.isSharing = false;
                  Utils.loading.hide();
                  console.error(e);
                  Utils.toast.error(Utils.translate('SEQUENCE.DIALOG.SHARE_CQNZ_IN_TIMELINE_ERR'));
                }
                break;
              }
              case "LINK": {
                Utils.loading.show();
                beginsharingMedia(sequence, 'imageBox' + sequence.content.templateId + listIndex, listIndex);
                break;
              }
              default:
                Utils.toast.warning("Invalid option '" + buttonsIds[buttonIndex] + "'");
            }

            return true;
          }
        })
      };

      /**
       * @param sequenceMetadata {SequenceMetadataType}
       * @param listIndex
       */
      function increaseSharesCount(sequenceMetadata, listIndex) {

        SequenceService.increaseSharesCountv1711({
          postId: sequenceMetadata.instanceId ? sequenceMetadata.instanceId: sequenceMetadata.id,
          senderInstanceId: myUserId
        }).then(function () {
          $scope._sequenceList[listIndex].share.counter++;
          $rootScope.$broadcast('sequence.counters.updated', {
            type: 'sequence.share',
            sequenceMetadata: sequenceMetadata,
            counter: $scope._sequenceList[listIndex].share.counter
          });
        }, function (error) {
          console.error("increaseSharesCount", error)
        });
      }

      /**
       * @param sequence  {SequenceType}
       * @param listIndex
       */
      $scope.reDirectCommentsPage = function (sequence, listIndex) {
        if (!canGoToCommentsPage(sequence.comments.enabled)) return;

        var dataToSend = {
          controllerName: $scope._controllerName,
          sequenceMetadata: sequence.metadata,
          sequenceOwnerMetadata: sequence.ownerMetadata,
          totalComments: sequence.comments.counter,
          groupId: $scope._groupHrefId,
          allowedGroups: sequence.allowedGroups
        };
        console.log("dataToSend", dataToSend)

        $state.go('commentsCqnz', {data: dataToSend}, {reload: true});
      };
      // --------------- END OF CQNZ BOTTOM STRIP FUNCTIONS -------------------


      // ----------------- PERMISSIONS VALIDATION FUNCTIONS ------------------

      function canSaveToLocker() {
        return $scope._controllerName !== 'showUserLockerCtrl' && permissions.canLockerStoreSequences();
      }

      function canUpdateCqnzTitle() {
        //if ($scope._controllerName !== 'myProfileTimelineCtrl') return false;
        if (ImSuperAdmin) return true;
        return permissions.canUpdateCqnzTitleInGralTimeline();
      }

      function canUpdateCqnz(sequenceType) {//not available for  video nor statement, only photos
        //if ($scope._controllerName !== 'myProfileTimelineCtrl') return false;
        if (+sequenceType !== 1) return false;
        if (ImSuperAdmin) return true;
        return permissions.canUpdateCqnzInGroupTimeline() || permissions.canUpdateCqnzInGralTimeline();
      }

      function canChangeAdConfig(isOwner) {
        //return isOwner && /*$scope._controllerName === 'myProfileTimelineCtrl' &&*/ UserService.USER_IS_ADVERTISER();
        return isOwner && /*$scope._controllerName === 'myProfileTimelineCtrl' &&*/ permissions.canAdvertisementPermit();
      }

      function canTogglePinGeneralCqnz() {
        return ImSuperAdmin && $scope._controllerName === 'TimeLineCtrl';
      }

      function canTogglePinGroupCqnz() {
        if ($scope._controllerName !== 'GroupTimeLineCtrl') return false;
        return ImSuperAdmin || (
          $scope.groupData.imAdministrator && permissions.canTogglePinCqnzInGroupTimeline()
        );
      }

      function canToggleShareable(isAdvertisement) {
        //if (isAdvertisement) return false;

        return ImSuperAdmin || permissions.canToggleShareableInGralTimeline() || permissions.canToggleShareableInGroupTimeline();
      }

      function canEnableDisableCqnzComments(isOwner) {
        if (ImSuperAdmin) return true;
        if (!isOwner) return false;
        return permissions.canEnableDisableCommentsInGralTimeline() || permissions.canEnableDisableCommentsInGroupTimeline();
      }

      function canReportCqnz() {
        if (ImSuperAdmin) return true;
        return permissions.canReportCqnzInGralTimeline() && !$scope.previewTimeline;
      }

      function canDeleteCqnz(isOwner) {
        /*console.log("canDeleteOthersCqnzFromGralTimeline: ", permissions.canDeleteOthersCqnzFromGralTimeline())
         console.log("canDeleteOthersCqnzFromGroupTimeline: ", permissions.canDeleteOthersCqnzFromGroupTimeline())
         console.log("canDeleteOwnCqnzFromGralTimeline: ", permissions.canDeleteOwnCqnzFromGralTimeline())
         console.log("canDeleteOwnCqnzFromGroupTimeline: ", permissions.canDeleteOwnCqnzFromGroupTimeline())
         console.log("isOwner: "+isOwner);*/
        if (ImSuperAdmin) return true;
        /*  if ($scope._controllerName === 'TimeLineCtrl') {
         return (isOwner && permissions.canDeleteOwnCqnzFromGralTimeline()) ||
         (!isOwner && permissions.canDeleteOthersCqnzFromGralTimeline())
         }
         if ($scope._controllerName === 'GroupTimeLineCtrl') {
         return (isOwner && permissions.canDeleteOwnCqnzFromGroupTimeline()) ||
         (!isOwner && permissions.canDeleteOthersCqnzFromGroupTimeline());
         }*/

        return (isOwner && permissions.canDeleteOwnCqnzFromGralTimeline()) ||
          (!isOwner && permissions.canDeleteOthersCqnzFromGralTimeline())
      }

      function canLikeToSequence() {
        if (ImSuperAdmin) return true;
        return permissions.canLikeCqnzInGralTimeline() || permissions.canLikeCqnzInGroupTimeline();
      }

      $scope.canReactToSequence = function () {
        if (ImSuperAdmin) return true;
        return permissions.canReactCqnzInGralTimeline() || permissions.canReactCqnzInGroupTimeline();
      };

      $scope.canOpenSharingOptions = function (sequence) {
        //console.log(sequence);
        if ($scope.iAmAdvertiser && sequence.isAdvertisement && sequence.metadata.belongsMe) {
          //console.log("Advertiser");
          return true;
        }

        var canShareInGroups = canShareInGroupsTimeline();

        if (!canShareExternally(sequence.content.type) && !canShareInGroups) {
          //console.log("not suitable for sharing");
          return false;
        }

        if (ImSuperAdmin) {//canShareInGeneralTimeline()
          //console.log("ImSuperAdmin")
          return true;
        }

        if (!sequence.share.enabled) {
          //console.log("disabled")
          return false;
        }

        //console.log("All")
        return canShareInGeneralTimeline() || canShareInGroups || canShareExternally(sequence.content.type);
      };

      function canShareInGroupsTimeline() {
        var totalGroups = window.localStorage.getItem("totalGroups") || 0;
        if ($scope._controllerName === 'TimeLineCtrl' || $scope._controllerName === 'myProfileTimelineCtrl' || $scope._controllerName === 'vodCtrl') /*LuMa Live Streaming*/ {
          if (!totalGroups) return false;
          if (permissions.canShareGralCqnzInGroupTimeline()) {
            return true;
          }
        }
        else if ($scope._controllerName === 'GroupTimeLineCtrl') {
          //todo: we need a specific permission to deal with this case (canShareBetweenroups... maybe)
          return (+totalGroups) > 0 && permissions.canShareGroupCqnzInGeneralTimeline();
        }

        return false;
      }

      function canShareInGeneralTimeline() {
        return $scope._controllerName === 'GroupTimeLineCtrl' && permissions.canShareGroupCqnzInGeneralTimeline();
      }

      function canShareExternally(sequenceType) {
        return (ImSuperAdmin || permissions.canShareGralCqnzInExternalNetworks());
      }

      /**
       * @param commentsAreEnabled {boolean}
       * @return {boolean}
       */
      function canGoToCommentsPage(commentsAreEnabled) {
        if (ImSuperAdmin) return true;
        if ($scope.previewTimeline) {
          Utils.toast.warning(Utils.translate('PERMISSIONS.CANNOT.PERFORM_ACTION_ON_PREVIEW'));
          return false;
        }
        if (!commentsAreEnabled) {
          Utils.toast.warning(Utils.translate('UPLOAD.COMMENTS_ARE_DISABLED'));
          return false;
        }

        if ($scope._controllerName === "GroupTimeLineCtrl" && !permissions.canCreateCommentInGroupTimeline()) {
          Utils.toast.warning(Utils.translate('PERMISSIONS.CANNOT.COMMENT_CREATE'));
          return false
        }
        else if (!permissions.canCreateCommentInGralTimeline()) {
          Utils.toast.warning(Utils.translate('PERMISSIONS.CANNOT.COMMENT_CREATE'));
          return false
        }

        return true;
      }

      /*
       * FUNCTION TO CHECK IF POST IS PROMO
       * AND THE USER CAN OBTAIN THE QRCODE
      */
      /*function canGetQRCodeFromPost (sequence) {
        //Aqui ya puedes validar tambien si es de tipo 0, 1 o 2
        if (ImSuperAdmin) return true;
        return (sequence.metadata.belongsMe && permissions.canCreateQRCode());
      }*/

      function canUpdateCqnzDescriptionInGralTimeline() {
        return permissions.canUpdateCqnzDescriptionInGralTimeline();
      }

      function canUpdateCqnzUrlInGralTimeline() {
        return permissions.canUpdateCqnzUrlInGralTimeline();
      }
      // -------------- END OF PERMISSIONS VALIDATION FUNCTIONS ----------------


      //------------------ MISCELANEOUS FUNCTIONS SECTION ------------------------
      $scope.trustAsHtml = function (text) {
        return Utils.$sce.trustAsHtml(text);
      };

      //for autosizing editable inputs (bio, sequence descr, comments)
      $scope.autosize = function (event) {
        //console.log(event);
        event.target.style.cssText = 'height:' + event.target.scrollHeight + 'px; width: 100%';
      };

      var bannedGroupsList = [],
        lockedGroupsList = [];

      //todo: set current group as disabled
      /**
       * shares a sequence with a group's timeline
       * @param sequence {SequenceType}
       * @param listIndex {number}
       */
      function showAllGroupsModal(sequence, listIndex) {
        Utils.loading.show();

        //if (UserService.USER_IS_ADVERTISER()) {
        if (permissions.canAdvertisementPermit()) {
          getAllGroups().then(function (groupList) {
            Utils.loading.hide();
            //console.log(groupList)
            GroupFactory.showGroupsListModal(groupList, {
              headerText: Utils.translate("TIMELINE.SHARE_UI.SHARE_CQNZ"),
              okButtonText: Utils.translate("TIMELINE.SHARE_UI.SHARE"),
              mainMessage: Utils.translate('TIMELINE.SHARE_UI.SHARE_MAIN_MSG')
            }).then(function (selectedGroupList) {
              //console.log(sequenceId, selectedGroupList);
              doShareInGroups(sequence.metadata, selectedGroupList, listIndex);
            });
          }, function (error) {
            Utils.loading.hide();
            console.error("get all groups", error);
          });
        }
        else {
          Utils.loading.hide();
          GroupFactory.showGroupsListModal(
            GroupFactory.getCurrentAvailableUserGroupsList(),
            {
              headerText: Utils.translate("TIMELINE.SHARE_UI.SHARE_CQNZ"),
              okButtonText: Utils.translate("TIMELINE.SHARE_UI.SHARE"),
              mainMessage: Utils.translate('TIMELINE.SHARE_UI.SHARE_MAIN_MSG')
            }
          ).then(function (selectedGroupList) {
            //console.log(sequenceId, selectedGroupList);
            doShareInGroups(sequence.metadata, selectedGroupList, listIndex);
          });
        }
      }

      /**
      * function excluive for the process when an advertisement is created
      */
      function showAllGroupsModalNewAd(sequence, listIndex) {
        Utils.loading.show();

        //if (UserService.USER_IS_ADVERTISER()) {
        if (permissions.canAdvertisementPermit()) {
          getAllGroupsNewAd().then(function (groupList) {
            Utils.loading.hide();
            //console.log(groupList)
            GroupFactory.showGroupsListModal(groupList, {
              headerText: Utils.translate("TIMELINE.SHARE_UI.SHARE_CQNZ"),
              okButtonText: Utils.translate("TIMELINE.SHARE_UI.SHARE"),
              mainMessage: Utils.translate('TIMELINE.SHARE_UI.SHARE_MAIN_MSG')
            }).then(function (selectedGroupList) {
              //console.log(sequenceId, selectedGroupList);
              doShareInGroupsnewAd(sequence.metadata, selectedGroupList, listIndex);
            });
          }, function (error) {
            Utils.loading.hide();
            console.error("get all groups", error);
          });
        }
      }

      /**
       * @param sequenceMetadata {SequenceMetadataType}
       * @param selectedGroupList {Object[]} - array of selected groups
       * @param listIndex
       */
      function doShareInGroups(sequenceMetadata, selectedGroupList, listIndex) {
        /**
         * @type {GroupWithErrors[]}
         */
        var groupsWithErrors = [];
        var numReqsFinished = 0;
        var totalGroups = selectedGroupList.length;

        Utils.loading.show();
        selectedGroupList.forEach(function (group) {
          if (!group.imLocked) {//<--because the list can contain banned groups
            var shareQry = $scope._controllerName === 'GroupTimeLineCtrl' ?
              GroupsService.shareGroupCqnzToGroup(sequenceMetadata.id, group.hrefId) :
              //TimeLineService.shareTimelineCqnzToGroup(sequenceMetadata.id, group.hrefId);
              TimeLineService.shareTimelineCqnzToGroupv200(sequenceMetadata.id, group.hrefId, UserService.get_USERSUBSCRIPTION_ID());

            shareQry.then(function () {
              numReqsFinished++;
              if (numReqsFinished == totalGroups) {
                Utils.loading.hide();
                onShareCqnzFinished(groupsWithErrors);
              }
              increaseSharesCount(sequenceMetadata, listIndex);
            }, function (shareError) {
              console.error(shareError);

              numReqsFinished++;
              groupsWithErrors.push({
                groupName: group.name,
                error: {
                  status: shareError.status,
                  statusText: shareError.statusText,
                  message: shareError.data.causedBy.message
                }
              });

              if (numReqsFinished == totalGroups) {
                Utils.loading.hide();
                onShareCqnzFinished(groupsWithErrors);
              }
            });
          }
          else {
            numReqsFinished++;//<-- because of the banned groups
            if (numReqsFinished == totalGroups) {
              Utils.loading.hide();
              onShareCqnzFinished(groupsWithErrors);
            }
          }
        })
      }

      function doShareInGroupsnewAd(sequenceMetadata, selectedGroupList, listIndex) {
        /**
         * @type {GroupWithErrors[]}
         */
        var groupsWithErrors = [];
        var numReqsFinished = 0;
        var totalGroups = selectedGroupList.length;

        Utils.loading.show();
        selectedGroupList.forEach(function (group) {
          if( group.id === 'TL') {
            //the user wants to show it normally
            SequenceService.addPostToPendingLogv200({
              sequenceId: sequenceMetadata.id,
              userSubs: myUserId //null
            }).$promise.then(function (responseAddPending) {
              console.log("all normal");
              numReqsFinished++;
              if (numReqsFinished == totalGroups) {
                Utils.loading.hide();
                onShareCqnzFinished(groupsWithErrors);
              }
            }, function (error) {
              if (error && (error.status === 504 || error.status === -1)) {
                console.log("We don't care");
                numReqsFinished++;
                if (numReqsFinished == totalGroups) {
                  Utils.loading.hide();
                  onShareCqnzFinished(groupsWithErrors);
                }
              } else {
                console.log("fallo en cliente");
                numReqsFinished++;
                groupsWithErrors.push({
                  groupName: group.name,
                  error: {
                    status: error.status,
                    statusText: error.statusText,
                    message: error.data.causedBy.message
                  }
                });
                if (numReqsFinished == totalGroups) {
                  Utils.loading.hide();
                  onShareCqnzFinished(groupsWithErrors);
                }
              }
              console.error("something is wrong");
            })
          } else {
            if (!group.imLocked) {//<--because the list can contain banned groups
              var shareQry = $scope._controllerName === 'GroupTimeLineCtrl' ?
                GroupsService.shareGroupCqnzToGroup(sequenceMetadata.postId, group.hrefId) :
                //TimeLineService.shareTimelineCqnzToGroup(sequenceMetadata.postId, group.hrefId);
                TimeLineService.shareTimelineCqnzToGroupv200(sequenceMetadata.postId, group.hrefId, UserService.get_USERSUBSCRIPTION_ID());

              shareQry.then(function () {
                numReqsFinished++;
                if (numReqsFinished == totalGroups) {
                  Utils.loading.hide();
                  onShareCqnzFinished(groupsWithErrors);
                }
                increaseSharesCount(sequenceMetadata, listIndex);
              }, function (shareError) {
                console.error(shareError);

                numReqsFinished++;
                groupsWithErrors.push({
                  groupName: group.name,
                  error: {
                    status: shareError.status,
                    statusText: shareError.statusText,
                    message: shareError.data.causedBy.message
                  }
                });

                if (numReqsFinished == totalGroups) {
                  Utils.loading.hide();
                  onShareCqnzFinished(groupsWithErrors);
                }
              });
            }
            else {
              numReqsFinished++;//<-- because of the banned groups
              if (numReqsFinished == totalGroups) {
                Utils.loading.hide();
                onShareCqnzFinished(groupsWithErrors);
              }
            }
          }
            
        })
      }

      /**
       * @param sequence {SequenceMetadataType}
       * @param listIndex
       */
      function doShareInUserTimeline(sequence, listIndex) {
        Utils.loading.show();
        GroupsService.shareGroupCqnzToTimeline(sequence.id, mySubscriptionHref).then(function () {
          Utils.loading.hide();
          Utils.toast.success(Utils.translate('GROUPS.TIMELINE_WRAPPER.DIALOG.SHARE_CQNZ_OK'));
          increaseSharesCount(sequence, listIndex);
        }, function (shareError) {
          Utils.loading.hide();
          Utils.toast.error(Utils.translate('SEQUENCE.DIALOG.SHARE_CQNZ_IN_TIMELINE_ERR'));
          console.error(shareError);
        })
      }

      /**
       * @description Verifies if errors occurred after sharing sequence and displays the group names and reasons
       * @param {GroupWithErrors[]} groupsWithErrorsList - group name and error object array
       */
      function onShareCqnzFinished(groupsWithErrorsList) {
        if (groupsWithErrorsList.length) {
          var shareErrorMsg = Utils.translate("GROUPS.TIMELINE_WRAPPER.DIALOG.SHARE_CQNZ_IN_GROUPS_ERR") + ":<br>";

          var nonDuplicatedCqnzs = 0;
          groupsWithErrorsList.forEach(
            /** @param {GroupWithErrors} groupErr*/
            function (groupErr) {
              if (groupErr.error.message.indexOf('duplicate key value') === -1) {
                shareErrorMsg += "<b>" + groupErr.groupName + "</b><br/>";
                nonDuplicatedCqnzs++;
              }
              /*shareErrorMsg += "<b>" + groupErr.groupName + "</b> " +
               (groupErr.error.message.indexOf('duplicate key value') > -1 ?
               Utils.translate("GROUPS.TIMELINE_WRAPPER.DIALOG.DUPLICATE_CQNZ_ERR") :
               groupErr.error.statusText) +
               "<br>";*/
            });
          //already existent sequences shouldn't mean a share error
          if (nonDuplicatedCqnzs)
            Utils.alert.show(shareErrorMsg);
        }
        else
          Utils.toast.success(Utils.translate("GROUPS.TIMELINE_WRAPPER.DIALOG.SHARE_CQNZ_OK"));
      }

      /**
       * @return Promise
       */
      function getAllGroups() {
        return Utils.$q(function (resolve, reject) {
          GroupsService.gelAllGroups().then(function (groups) {
            Utils.removeLastItemIfHasNoAttribute(groups, 'groupId');

            var groupList = [];

            if (!groups.length) return resolve(groupList);

            //console.log(groups)

            groups.forEach(function (resource) {
              groupList.push({
                id: resource.groupId,
                //creationDate:resource.creationDate,
                //href: resource.group.href,
                //hrefId: Utils.getLastUrlComponent(resource.group.href),
                hrefId: resource.groupId,
                name: resource.groupName,
                description: resource.description,
                image: resource.url || 'img/photoFrame.svg',
                //privacy: resource.privacy,
                imAdministrator: false,
                imModerator: false,
                imLocked: false,
                imBanned: false
              })
            });

            resolve(groupList);
          }, function (error) {
            console.error("get all groups", error);
            reject(error);
          })
        })
      }

      /**
       * @return Promise
       */
      function getAllGroupsNewAd() {
        return Utils.$q(function (resolve, reject) {
          GroupsService.gelAllGroups().then(function (groups) {
            Utils.removeLastItemIfHasNoAttribute(groups, 'groupId');

            var groupList = [];

            if (!groups.length) return resolve(groupList);

            //console.log(groups)
            //before add the groups we add timeline as an option
            //because advertisements aren't added to it
            groupList.push({
              id: 'TL',
              hrefId: null,
              name: "TimeLine",
              description: null,
              image: 'img/photoFrame.svg',
              imAdministrator: false,
              imModerator: false,
              imLocked: false,
              imBanned: false
            })

            groups.forEach(function (resource) {
              groupList.push({
                id: resource.groupId,
                //creationDate:resource.creationDate,
                //href: resource.group.href,
                //hrefId: Utils.getLastUrlComponent(resource.group.href),
                hrefId: resource.groupId,
                name: resource.groupName,
                description: resource.description,
                image: resource.url || 'img/photoFrame.svg',
                //privacy: resource.privacy,
                imAdministrator: false,
                imModerator: false,
                imLocked: false,
                imBanned: false
              })
            });

            resolve(groupList);
          }, function (error) {
            console.error("get all groups", error);
            reject(error);
          })
        })
      }

      /**
       * @param sequence {SequenceType}
       * @param listIndex
       */
      function confirmDeleteCqnz(sequence, listIndex) {
        //console.log('listIndex', listIndex)
        Utils.confirm.show(Utils.translate('SEQUENCE.DIALOG.DELETE_CQNZ_CONF')).then(function (boolResp) {
          if (!boolResp) return;

          Utils.loading.show();
          sequence.deleteMe().then(function () {
            Utils.loading.hide();
          }, function (error) {
            Utils.loading.hide();
          })
        })
      }

      $scope.increaseAdClicks = function (sequence) {
        if (sequence.metadata.belongsMe) return;

        adsService.increaseClicksCount(sequence.metadata.instanceId).then(function () {
          //console.log($scope._sequenceList[listIndex].clicksCount);
          /*sequence.advertisement.counters.clicks ?
           sequence.advertisement.counters.clicks.result.value++ :
           sequence.advertisement.counters.clicks = {result: {value: 1}};*/
          console.log("Ad clicks increased")
        }, function (error) {
          console.error("increaseClicksCount", error);
        });
      };

      /**
       *
       * @param sequence {SequenceType}
       * @param listIndex
       */
      function saveCqnzInLocker(sequence, listIndex) {
        Utils.loading.show();
        userLockerService.addItemToLocker({
          sequenceHref: sequence.metadata.href,
          userSubscriptionId: UserService.get_USERSUBSCRIPTION_ID()
        }).$promise.then(function () {
          Utils.toast.success(Utils.translate("SEQUENCE.DIALOG.SAVE_IN_LOCKER_OK"));
        }, function (error) {
          console.error("Cant add sequence to locker", error);
          Utils.toast.success(Utils.translate("SEQUENCE.DIALOG.SAVE_IN_LOCKER_ERROR"));
        }).finally(function () {
          Utils.loading.hide();
        })
      }

      /**
       * @param sequence {SequenceType}
       * @param listIndex {number}
       */
      function removeCqnzFromLocker(sequence, listIndex){
        Utils.loading.show();
        userLockerService.removeItemFromLocker(
          Utils.getLastUrlComponent(sequence.locker.sequenceLocker.href)
        ).$promise.then(function () {
          $scope.lockerItemList.splice(listIndex, 1);
          Utils.$timeout(function () {
            Utils.$ionicScrollDelegate.resize();
          }, 300);
          Utils.toast.success(Utils.translate("LOCKER.DIALOG.REMOVE_ITEM_OK"))
        }, function (error) {
          console.error("removePromoFromLocker", error);
          Utils.toast.error(Utils.translate("LOCKER.DIALOG.REMOVE_ITEM_ERROR"))
        }).finally(function () {
          Utils.loading.hide();
        })
      }

      /**
       *
       *
      **/
      function beginMakingLink(sequence, listIndex, part){
        //check if BRANCH  is installed
        if (!Branch) {
          Utils.loading.hide();
          Utils.toast.error(Utils.translate("PLUGINS.BRANCH.PLUGIN_NOT_INSTALLED"));
          return;
        }

        //STEPS FOR AMAZON  USE
        var s3Service = new AWS.S3({
          apiVersion: '2006-03-01',
          params: {Bucket: s3.bucket}
        });

        //GENERAL STEṔ FOR TEXT TITLE OR DESCRIPTION
        var textForShow = "";
        if(sequence.title.titleBackup === "" || sequence.title.titleBackup === null || sequence.title.titleBackup === undefined) {
          if(sequence.description.titleBackup === "" || sequence.description.titleBackup === null || sequence.description.titleBackup === undefined) {
            textForShow = Utils.translate("SHARE_LINK.POST_ONLY.DESCRIPTION_EMPTY") + sequence.ownerMetadata.name;
          } else {
            textForShow = sequence.description.titleBackup;
            }
          } else {
          textForShow = sequence.title.titleBackup;
        }

        //GENERAL STEP FOR USER
        var nameOwner = sequence.ownerMetadata.name + Utils.translate("SHARE_LINK.TEXT_APP.USER_SHARED");

        //SPECIFIC STEP DEPENDS OF THE POST'S TYPE
        var imageForShow = "";
        /*if(sequence.content.type == 1) {
          var isIOS = ionic.Platform.isIOS();
          var isAndroid = ionic.Platform.isAndroid();
          var node = document.getElementById(part);
          var nodeX = node.clientWidth;
          var nodeY = node.clientHeight;
          window.nodeY = nodeY;
          window.scale = isIOS && nodeX > 400 ? 3 : 4.5;

          if (part.substr(0, 25) == 'imageBoxtemplateAutomate0') {
            var photoKey = 'Gifs/' + 
                          Utils.md5.createHash(UserService.get_USERSUBSCRIPTIONINSTANCE_ID().toString()) +
                          '/shared/' + 
                          Utils.md5.createHash(sequence.metadata.id.toString()) + 
                          '.gif';
            s3Service.headObject({Key: photoKey}, function (err, data) {

            }
          } else {

          }
        }*/
        //check what kind of post we'll share
        if(sequence.content.type == 1) {
          //images
          imageForShow = sequence.content.items[0].url;
        } else if(sequence.content.type == 3) {
          //video
          imageForShow = sequence.content.items[0].urlVideoImage;
        } else if(sequence.content.type == 2) {
          //Statement
          imageForShow = "http://s3-us-west-2.amazonaws.com/media.ladymultitaskdevelopment.cloud/splash.png";
        }

        //Link Data: Universal Object Properties
        //first create an universalObj for this share
        var branchShareApp = null;

        //properties for APP share
        var deepProperties = {
          canonicalIdentifier: Personalized.nameApp + '/share',//OmRo  //BALA QRCODE FIX
          //title: Utils.translate("SHARE_LINK.POST_ONLY.TITLE"),//'Sharing post',
          title: nameOwner,
          contentDescription: textForShow,
          contentImageUrl: imageForShow,
          contentIndexingMode: 'private',
          contentMetadata: { //works
            typeShare: 'Post',
            id: sequence.metadata.id,
            instanceId: sequence.metadata.instanceId
          }
        };

        Branch.createBranchUniversalObject(deepProperties)
          .then( function (res) {
            console.log("created universal branch" + JSON.stringify(res));
            //asign res
            branchShareApp = res;

            //Link Data: Deep Link Properties
            var analyticsDeepLink = {
              feature: Utils.translate("SHARE_LINK.POST_ONLY.TITLE"),//"Share Post",
              campaign: "sharing",
              //deeplink_path: "#/side-menu21/MyProfile",
              stage: "post"
            };

            //extra info
            var propertiesDeepLink = { //"http://niido.cloud/"
              $desktop_url: Personalized.deepLinkPathUrl,
              //$deeplink_path: "#/side-menu21/MyProfile",
              $match_duration: 100,
              $og_image_url: imageForShow,
              $og_title: Push_Notif_Variables.title + " by niido",

              $og_description: textForShow,
              $uri_redirect_mode: 1,
              $og_app_id: "519599746650755173"
            };

            branchShareApp.generateShortUrl(analyticsDeepLink, propertiesDeepLink)
              .then(function (res) {
                console.log("generated", res);
                window.plugins.socialsharing.share(
                  textForShow,
                  null,
                  null,
                  res.url
                );
                Utils.loading.hide();
                increaseSharesCount(sequence.metadata, listIndex);
              })
              .catch( function (err) {
                console.log("Faild in create short link" + JSON.stringify(err));
                Utils.loading.hide();
              })
          })
          .catch( function (err) {
            console.log("Faild in create universal branch" + JSON.stringify(err));
            Utils.loading.hide();
          })
      }

      function beginsharingMedia(sequence, areaHTML, listIndex) {

        //PREPARE PLUGINS-LIBRARY
          //BRANCH
          if (!Branch) {
            Utils.loading.hide();
            Utils.toast.error(Utils.translate("PLUGINS.BRANCH.PLUGIN_NOT_INSTALLED"));
            return;
          }

          //STEPS FOR AMAZON  USE
          var s3Service = new AWS.S3({
            apiVersion: '2006-03-01',
            params: {Bucket: s3.bucket}
          });
        //

        //PREPARE DATA
          //GETTING TEXT TO SHARE
          var textForShow = "";
          if(sequence.title.titleBackup === "" || sequence.title.titleBackup === null || sequence.title.titleBackup === undefined) {
            if(sequence.description.titleBackup === "" || sequence.description.titleBackup === null || sequence.description.titleBackup === undefined) {
              textForShow = Utils.translate("SHARE_LINK.POST_ONLY.DESCRIPTION_EMPTY") + sequence.ownerMetadata.name;
            } else {
              textForShow = sequence.description.titleBackup;
              }
            } else {
            textForShow = sequence.title.titleBackup;
          }

          //PREVIEW IMAGE FOR DEEPLINK
          var imageForShow = "";
          if(sequence.content.type == 1) {
            //ṔOST WITH IMAGES
            imageForShow = sequence.content.items[0].url;
          } else if(sequence.content.type == 3) {
            //POST WITH VIDEO
            imageForShow = sequence.content.items[0].urlVideoImage;
          } else if(sequence.content.type == 2) {
            //STATEMENT
            imageForShow = "http://"+s3.bucket+".s3-us-west-2.amazonaws.com/splash.png";
          }

          //GENERAL STEP FOR USER
          var nameOwner = sequence.ownerMetadata.name + Utils.translate("SHARE_LINK.TEXT_APP.USER_SHARED");

          //EXTRA
          var isIOS = ionic.Platform.isIOS();
          var isAndroid = ionic.Platform.isAndroid();
        //

        //INIT STEPS
          var branchShareApp = null;
          var deepProperties = {
            canonicalIdentifier: Push_Notif_Variables.title +'/share',
            title: nameOwner,
            contentDescription: textForShow,
            contentImageUrl: imageForShow,
            contentIndexingMode: 'private',
            contentMetadata: { //works
              typeShare: 'Post',
              id: sequence.metadata.id,
              groupId: sequence.metadata.groupId? sequence.metadata.groupId : "0",
              instanceId: sequence.metadata.instanceId
            }
          };

          //PREPARE BRANCH CONFIG
          Branch.createBranchUniversalObject(deepProperties)
          .then( function (res) {
            branchShareApp = res;
            var analyticsDeepLink = {
              feature: Utils.translate("SHARE_LINK.POST_ONLY.TITLE"),
              campaign: "sharing",
              stage: "post"
            };
            var propertiesDeepLink = {
              $desktop_url: Personalized.deepLinkPathUrl,
              $match_duration: 100,
              $og_image_url: imageForShow,
              $og_title: Push_Notif_Variables.title + " by niido",
              $og_description: textForShow,
              $uri_redirect_mode: 1,
              $og_app_id: "787315640208740371" // made into app.js
            };
            branchShareApp.generateShortUrl(analyticsDeepLink, propertiesDeepLink)
              .then(function (restData) {
                window.plugins.socialsharing.shareWithOptions({
                  message: textForShow,
                  url: restData.url
                });
                Utils.loading.hide();
                increaseSharesCount(sequence.metadata, listIndex);
              })
              .catch(function (errorData) {
                Utils.loading.hide();
                console.error("can't generate shortURL", errorData);
              })
          })
          .catch( function (err) {
            sequence.share.isSharing = false;
            console.log("Faild in create universal branch" + JSON.stringify(err));
            Utils.loading.hide();
          })
        //
      }

      //UNIVERSAL LINKS 
      function beginsharingMedianew(sequence, areaHTML, listIndex) {
        //PREPARE DATA
          //GETTING TEXT TO SHARE
          var textForShow = "";
          if(sequence.title.titleBackup === "" || sequence.title.titleBackup === null || sequence.title.titleBackup === undefined) {
            if(sequence.description.titleBackup === "" || sequence.description.titleBackup === null || sequence.description.titleBackup === undefined) {
              textForShow = Utils.translate("SHARE_LINK.POST_ONLY.DESCRIPTION_EMPTY") + sequence.ownerMetadata.name;
            } else {
              textForShow = sequence.description.titleBackup;
              }
            } else {
            textForShow = sequence.title.titleBackup;
          }

          //PREVIEW IMAGE FOR DEEPLINK
          var imageForShow = "";
          if(sequence.content.type == 1) {
            //ṔOST WITH IMAGES
            imageForShow = sequence.content.items[0].url;
          } else if(sequence.content.type == 3) {
            //POST WITH VIDEO
            imageForShow = sequence.content.items[0].urlVideoImage;
          } else if(sequence.content.type == 2) {
            //STATEMENT
            imageForShow = "http://"+s3.bucket+".s3-us-west-2.amazonaws.com/splash.png";
          }

          //GENERAL STEP FOR USER
          var nameOwner = sequence.ownerMetadata.name + Utils.translate("SHARE_LINK.TEXT_APP.USER_SHARED");

          //EXTRA
          var isIOS = ionic.Platform.isIOS();
          var isAndroid = ionic.Platform.isAndroid();
        //

        //FORM URL - EXAMPLE: http://niido.cloud/deepLinkLandingPage/niido?typeDL=Post_I=45676_II=342423
        var baseURL = 'https://niido.cloud' + Personalized.deepLinkPathUrl
        //ADD DATA
        var typeDL = 'typeDL=Post'
        var I = 'I='+sequence.metadata.id;
        var II = 'II='+sequence.metadata.instanceId;
        //change to not conflict with shortened url
        //url?typeDL=Post_I=1234_II=5678
        var finalUrl = baseURL + '?' + typeDL + '_' + I + '_' + II;

        //FireBase make shortUrl
        var servData = 'https://firebasedynamiclinks.googleapis.com/v1/shortLinks';
        var appData = Personalized.UniversalLinks.webApiKey;
        var dataLFBS = {
          "longDynamicLink": Personalized.UniversalLinks.domainPrefix+
                            '/?link=' + encodeURI(finalUrl) + 
                            //Android zone
                            '&apn=' + Personalized.UniversalLinks.apn +
                            '&afl=' + Personalized.UniversalLinks.afl +
                            //IOS zone
                            '&ibi=' + Personalized.UniversalLinks.ibi +
                            '&ifl=' + Personalized.UniversalLinks.ifl +
                            '&ius=' + Personalized.UniversalLinks.ius +
                            //SOCIALMEDIA zone
                            '&st=SocialSharing' +
                            '&sd=' + encodeURI(textForShow) +
                            '&si=' + imageForShow
        }

        var dataFBS = {
          "dynamicLinkInfo": {
            "domainUriPrefix": Personalized.UniversalLinks.domainPrefix+'/'+sequence.metadata.id+sequence.metadata.instanceId,
            "link": finalUrl,
            "androidInfo": {
              "androidPackageName": 'com.ionicframework.niido232869', 
              "androidFallbackLink": 'https://niido.cloud/deepLinkLandingPage/niido'
            },
            "iosInfo": {
              "iosBundleId": 'NIIDO2.niido2',
              "iosFallbackLink": 'https://niido.cloud/deepLinkLandingPage/niido',
              "iosCustomScheme": 'niido'
            },
            "enableForcedRedirect": {
              "enableForcedRedirect": false
            },
            "socialMetaTagInfo": {
              "socialTitle": 'NIIDO SHARING',
              "socialDescription": textForShow,
              "socialImageLink": imageForShow
            }
          },
          "suffix": {
            "option": 'UNGUESSABLE'
          }
        }

        $.ajax({
          url: 'https://firebasedynamiclinks.googleapis.com/v1/shortLinks?key=' + Personalized.UniversalLinks.webApiKey,
          type: 'POST',
          data: jQuery.param(dataLFBS),
          ContentType: 'application/json',
          success: function (response) {
            console.log(response);
            window.plugins.socialsharing.shareWithOptions({
              url: response.shortLink
            });
            Utils.loading.hide();
            increaseSharesCount(sequence.metadata, listIndex);
          },
          error: function(err) {
            console.error(err)
            Utils.loading.hide();
          }
        })

        /*$http(dataLFBS).then(function (response) {
          console.log('got: ', response);
        }, function (error) {
          console.error('fail: ', error);
        })*/

        /*window.plugins.socialsharing.shareWithOptions({
          message: textForShow,
          url: finalUrl
        });
        Utils.loading.hide();
        increaseSharesCount(sequence.metadata, listIndex);*/

      }

      //--------------- END OF MISCELANEOUS FUNCTIONS SECTION ----------------------


      //----------------------- LISTENERS SECTION -------------------------
      setTimeout(function () {
        if (timelinesService.eventsAttached) return;

        $rootScope.$on("sequence.created", function (event, data) {
          //console.log("on sequence.created", data)
          //check if 
          if(!data.isAd) {
            //the post is not AD
            if(data.from === 'TimeLineCtrl') {
              //the post is created in TL
              //Refresh TL
              timelinesService.defaultTimeline.events.timeline.refresh(true);
              //GET all endpoints to send notification
              var wsData = {
                groupId: 0,
                userSubscriptionId: UserService.get_USERSUBSCRIPTION_ID(),
                notification: 13 //AGREGAR TIPO DE NOTIF 13
              }
              GroupsService.getEndPointsFollowers(wsData).then(function (dataWS) {
                //prepare message to send
                Utils.removeLastItemIfHasNoAttribute(dataWS, 'status');
                //console.log("complete", dataWS);
                var messageForShow = Utils.translate('ALERTS.NEW_POST_IN_TL_01') + UserService.get_USER_NAME();
                //send to each one endpoint
                dataWS.forEach( function (dataDevices) {

                  //console.log("for each", dataDevices);
                  AWSServices.sendPostFollowersNotification(
                    messageForShow, 
                    dataDevices.userDeviceId,
                    0,
                    data.sequenceId
                  )

                })
              }, function (errorWS) {
                console.log("complete error", errorWS);
              })


            } else if(data.from === 'GroupTimeLineCtrl') {
              //the post is created in Group
              //Refresh Group TL
              timelinesService.groupTimeline.events.timeline.refresh(true);
              //GET DATA TO NOTIFY MEMBERS ABOUT A NEW POST
              var wsNotif = {
                sequence: ApiEndPoint.url + 'restful/objects/simple.Sequence/' + data.sequenceId,//data.sequenceId, "http://niido-dev.niido.cloud/restful/objects/simple.Sequence/159"
                groupId: data.groupId
              }
              GroupsService.notifyMembersNewPost(wsNotif).then(function (dataWS) {
                console.log("NOTIF INSIDE APP SENT");
              }, function (errorWS) {
                console.log("complete error", errorWS);
                if (errorWS && (errorWS.status === 504 || errorWS.status === -1)) {
                  console.log("We don't care");
                }
              })

              //GET all endpoints to send notification
              var wsData = {
                groupId: data.groupId,
                userSubscriptionId: UserService.get_USERSUBSCRIPTION_ID()
              }
              GroupsService.getEndPointMembers(wsData).then(function (dataWS) {
                //prepare message to send
                //console.log("complete", dataWS);
                var messageForShow = Utils.translate('ALERTS.NEW_POST_IN_GROUP_01') + 
                                    data.groupName + 
                                    Utils.translate('ALERTS.NEW_POST_IN_GROUP_02') + 
                                    UserService.get_USER_NAME();
                //send to each one endpoint
                dataWS.forEach( function (dataDevices) {

                  //console.log("for each", dataDevices);
                  AWSServices.sendPostGroupNotification(
                    messageForShow,
                    dataDevices.userDeviceId,
                    data.groupId,
                    data.sequenceId
                  )

                })
              }, function (errorWS) {
                console.log("complete error", errorWS);
              })
            } else {
              //other option or we don't know
            }
          } else {
            //the post is AD
            showAllGroupsModalNewAd({
              metadata: {
                id: data.sequenceId,
                postId: data.sequencePostId //for ads
              }
            })
          }


          /*if (data.from === 'TimeLineCtrl') {
            timelinesService.defaultTimeline.events.timeline.refresh(true);
            if (data.isAd) {
              showAllGroupsModalNewAd({metadata: {
                id: data.sequenceId,
                postId: data.sequencePostId //for ads
              }}, 0);
            }
          }
          else if (data.from === 'GroupTimeLineCtrl') {
            timelinesService.groupTimeline.events.timeline.refresh(true);
          }*/
        });

        $rootScope.$on('sequence.deleted', function (event, data) {
          if (timelinesService.defaultTimeline.events.sequence.onDelete)
            timelinesService.defaultTimeline.events.sequence.onDelete(data);
          if (timelinesService.groupTimeline.events.sequence.onDelete)
            timelinesService.groupTimeline.events.sequence.onDelete(data);
          if (timelinesService.myProfileTimeline.events.sequence.onDelete)
            timelinesService.myProfileTimeline.events.sequence.onDelete(data);
        });

        $rootScope.$on('sequence.title.edited', function (event, data) {
          data.updaterFn = editeTitleByEvent;
          if (timelinesService.defaultTimeline.events.sequence.onTitleEdited)
            timelinesService.defaultTimeline.events.sequence.onTitleEdited(data);
          if (timelinesService.groupTimeline.events.sequence.onTitleEdited)
            timelinesService.groupTimeline.events.sequence.onTitleEdited(data);
          if (timelinesService.myProfileTimeline.events.sequence.onTitleEdited)
            timelinesService.myProfileTimeline.events.sequence.onTitleEdited(data);
        });

        $rootScope.$on('sequence.description.edited', function (event, data) {
          data.updaterFn = editeDescriptionByEvent;
          if (timelinesService.defaultTimeline.events.sequence.onDescriptionEdited)
            timelinesService.defaultTimeline.events.sequence.onDescriptionEdited(data);
          if (timelinesService.groupTimeline.events.sequence.onDescriptionEdited)
            timelinesService.groupTimeline.events.sequence.onDescriptionEdited(data);
          if (timelinesService.myProfileTimeline.events.sequence.onDescriptionEdited)
            timelinesService.myProfileTimeline.events.sequence.onDescriptionEdited(data);
        });

        $rootScope.$on('sequence.url.edited', function (event, data) {
          data.updaterFn = editeUrlByEvent;
          if (timelinesService.defaultTimeline.events.sequence.onUrlEdited)
            timelinesService.defaultTimeline.events.sequence.onUrlEdited(data);
          if (timelinesService.groupTimeline.events.sequence.onUrlEdited)
            timelinesService.groupTimeline.events.sequence.onUrlEdited(data);
          if (timelinesService.myProfileTimeline.events.sequence.onUrlEdited)
            timelinesService.myProfileTimeline.events.sequence.onUrlEdited(data);
        });

        $rootScope.$on('sequence.content.updated', function (event, data) {
          if (timelinesService.defaultTimeline.events.sequence.onContentEdited)
            timelinesService.defaultTimeline.events.sequence.onContentEdited(data);
          if (timelinesService.groupTimeline.events.sequence.onContentEdited)
            timelinesService.groupTimeline.events.sequence.onContentEdited(data);
          if (timelinesService.myProfileTimeline.events.sequence.onContentEdited)
            timelinesService.myProfileTimeline.events.sequence.onContentEdited(data);
        });

        $rootScope.$on('sequence.shareable.updated', function (event, data) {
          if (timelinesService.defaultTimeline.events.sequence.onShareableUpdated)
            timelinesService.defaultTimeline.events.sequence.onShareableUpdated(data);
          if (timelinesService.groupTimeline.events.sequence.onShareableUpdated)
            timelinesService.groupTimeline.events.sequence.onShareableUpdated(data);
          if (timelinesService.myProfileTimeline.events.sequence.onShareableUpdated)
            timelinesService.myProfileTimeline.events.sequence.onShareableUpdated(data);
        });

        $rootScope.$on('sequence.counters.updated', function (event, data) {
          //sequence.comment.like
          //sequence.like
          //sequence.share
          //sequence.react this doesn't return the counter

          data.updaterFn = updateCountersByEvent;

          if (timelinesService.defaultTimeline.events.sequence.onCountersUpdated)
            timelinesService.defaultTimeline.events.sequence.onCountersUpdated(data);
          if (timelinesService.groupTimeline.events.sequence.onCountersUpdated)
            timelinesService.groupTimeline.events.sequence.onCountersUpdated(data);
          if (timelinesService.myProfileTimeline.events.sequence.onCountersUpdated)
            timelinesService.myProfileTimeline.events.sequence.onCountersUpdated(data);
        });

        $rootScope.$on('sequence.comment.enabled.updated', function (event, data) {
          if (timelinesService.defaultTimeline.events.comment.onEnabledUpdated)
            timelinesService.defaultTimeline.events.comment.onEnabledUpdated(data);
          if (timelinesService.groupTimeline.events.comment.onEnabledUpdated)
            timelinesService.groupTimeline.events.comment.onEnabledUpdated(data);
          if (timelinesService.myProfileTimeline.events.comment.onEnabledUpdated)
            timelinesService.myProfileTimeline.events.comment.onEnabledUpdated(data);
        });

        $rootScope.$on('sequence.comment.created', function (event, data) {
          if (timelinesService.defaultTimeline.events.comment.onCreate)
            timelinesService.defaultTimeline.events.comment.onCreate(data);
          if (timelinesService.groupTimeline.events.comment.onCreate)
            timelinesService.groupTimeline.events.comment.onCreate(data);
          if (timelinesService.hashTimeline.events.comment.onCreate)
            timelinesService.hashTimeline.events.comment.onCreate(data);
          if (timelinesService.myProfileTimeline.events.comment.onCreate)
            timelinesService.myProfileTimeline.events.comment.onCreate(data);
        });

        $rootScope.$on('sequence.comment.edited', function (event, data) {
          if (timelinesService.defaultTimeline.events.comment.onUpdate)
            timelinesService.defaultTimeline.events.comment.onUpdate(data);
          if (timelinesService.groupTimeline.events.comment.onUpdate)
            timelinesService.groupTimeline.events.comment.onUpdate(data);
          if (timelinesService.myProfileTimeline.events.comment.onUpdate)
            timelinesService.myProfileTimeline.events.comment.onUpdate(data);
        });

        $rootScope.$on('sequence.comment.deleted', function (event, data) {
          if (timelinesService.defaultTimeline.events.comment.onDelete)
            timelinesService.defaultTimeline.events.comment.onDelete(data);
          if (timelinesService.groupTimeline.events.comment.onDelete)
            timelinesService.groupTimeline.events.comment.onDelete(data);
          if (timelinesService.hashTimeline.events.comment.onDelete)
            timelinesService.hashTimeline.events.comment.onDelete(data);
          if (timelinesService.myProfileTimeline.events.comment.onDelete)
            timelinesService.myProfileTimeline.events.comment.onDelete(data);
        });

        $rootScope.$on('sequence.comment.like.updated', function (event, data) {
          if (timelinesService.defaultTimeline.events.comment.onLikeUpdated)
            timelinesService.defaultTimeline.events.comment.onLikeUpdated(data);
          if (timelinesService.groupTimeline.events.comment.onLikeUpdated)
            timelinesService.groupTimeline.events.comment.onLikeUpdated(data);
          if (timelinesService.myProfileTimeline.events.comment.onLikeUpdated)
            timelinesService.myProfileTimeline.events.comment.onLikeUpdated(data);
        });

        $rootScope.$on('advertisement.settings.updated', function (event, data) {
          if (timelinesService.defaultTimeline.events.advertisement.onSettingsUpdated)
            timelinesService.defaultTimeline.events.advertisement.onSettingsUpdated(data);
        });

        timelinesService.eventsAttached = true;
      }, 1500);

      function editeTitleByEvent(sequence, data) {
        sequence.title = {};
        setTimeout(function () {
          sequence.title = data.description;

          setTimeout(function () {
            $scope.$apply()
          }, 10)
        }, 2000);
      }

      function editeDescriptionByEvent(sequence, data) {
        sequence.description = {};
        setTimeout(function () {
          sequence.description = data.description;

          setTimeout(function () {
            $scope.$apply()
          }, 10)
        }, 2000);
      }

      function editeUrlByEvent(sequence, data) {
        sequence.url = {};
        setTimeout(function () {
          sequence.url = data.description;

          setTimeout(function () {
            $scope.$apply()
          }, 10)
        }, 2000);
      }

      function updateCountersByEvent(sequence, data) {
        switch (data.type) {
          case 'sequence.like':
            sequence.like.active.result.value = data.active;
            sequence.like.counter = data.counter;
            break;
          case 'sequence.react':
            sequence.react.counter = data.counter;
            break;
          case 'sequence.share':
            sequence.share.counter = data.counter;
            break;
        }
      }

      //----------------------- END OF LISTENERS SECTION -------------------------

      /**
       * @param description {string}
       * @return Promise {boolean}
       */
      $scope.openComposerScreen = function (description, extraData) {
        return Utils.$q(function (resolve, reject) {
          var dialog = Utils.alert.getCtrl();
          dialog.show({
            templateUrl: 'templates/partials/tags-modal.html',
            controller: 'tagsModalCtrl',
            fullscreen: true,
            locals: {
              description: description,
              tagsList: extraData.tagsList || [],
              hash: extraData.hashList || [],
              plusLength: extraData.extra,
              isTitle: extraData.title,
              dialog: dialog,
              needSearch: extraData.needSearch
            },
            clickOutsideToClose: false,
            multiple: true
          }).then(function (form) {
            resolve(form)
          }, function () {
            //when the modal is cancelled
            reject()
          });
        })
      };
      $scope.openScreenScheduled = function (data, type, sequence) {
        return Utils.$q(function (resolve, reject) {
          var dialog = Utils.alert.getCtrl();
          dialog.show({
            templateUrl: 'templates/partials/date_hour-modal.html',
            controller: 'updateSceduledCtrl',
            fullscreen: true,
            locals: {
              dataforChange: data,
              whatChange: type,
              fromWhatPost: sequence,
              dialog: dialog
            },
            clickOutsideToClose: false,
            multiple: true
          }).then(function (form) {
            resolve(form)
          }, function () {
            reject()
          });
        })
      }
    }])

  .controller('CommentsCtrl', ['$rootScope', '$scope', '$state', 'UserService', 'SequenceService', 'cqnzService', 'permissionValidationService', 'notificationsService', 'Utils',
    function ($rootScope, $scope, $state, UserService, SequenceService, cqnzService, permissionValidationService, notificationsService, Utils) {

      $scope.commentListSharedCtrl = $scope.commentListSharedCtrl || {};

      //just a short name :)
      var permissions = permissionValidationService;

      var myUserId = UserService.get_USERSUBSCRIPTIONINSTANCE_ID();
      var amISuperAdmin = permissions.amISuperAdmin();

      $scope.sendFriendProfile = function (userInstanceId) {
        if (!userInstanceId) return;

        if (userInstanceId == myUserId)
          $state.go('menu.myProfile', {}, {reload: true});
        else
          $state.go('friendProfile', {instanceId: userInstanceId}, {reload: true});
      };

      $scope.whatClikedComment = function (evt, comment) {
        var realText = [];
        if (evt.target.id) {
          if (evt.target.id == myUserId)
            $state.go('menu.myProfile', {}, {reload: true});
          else
            $state.go('friendProfile', {instanceId: evt.target.id}, {reload: true});
        } else if(evt.target.innerText.split('#').length > 1) { //LuMa HashTags in comments
          if (comment.hashTagsList && comment.hashTagsList.length) {
            realText = evt.target.innerText.split(' ');
            if (realText.length === 1) {
              $state.go('hashTimeLine', {"hashName": evt.target.innerText}, {reload: true});
            }
          }
        }
      };

      $scope.trustAsHtml = function (text) {
        return Utils.$sce.trustAsHtml(text);
      };

      $scope.showCommentImage = function (pictureURL) {
        $scope.zoomStatus = 0;
        $scope.activeSlide = 0;
        $scope.zoomMin = 1;
        $scope.hideLikeButton = true;

        $scope.closeModal = function () {
          $scope.modal.hide();
          $scope.modal.remove();
        };

        $scope.doubleTapped = function (slide) {
          if ($scope.zoomStatus === 0) {
            Utils.$ionicScrollDelegate.$getByHandle('scrollHandle' + slide).zoomBy(2, true);
            $scope.zoomStatus++;
          } else {
            Utils.$ionicScrollDelegate.$getByHandle('scrollHandle' + slide).zoomBy(0, true);
            $scope.zoomStatus--;
          }
        };

        $scope.updateSlideStatus = function (slide) {
          var zoomFactor = Utils.$ionicScrollDelegate.$getByHandle('scrollHandle' + slide).getScrollPosition().zoom;
          Utils.$ionicSlideBoxDelegate.enableSlide(zoomFactor == $scope.zoomMin);
        };

        $scope.picturesItem = [{
          key: 0,
          itemId: 0,
          src: pictureURL
        }];

        Utils.$ionicModal.fromTemplateUrl('templates/gallery-zoomview2.html', {
          scope: $scope,
          animation: 'zoom-from-center'
        }).then(function (modal) {
          $scope.modal = modal;
          $scope.modal.show();
        });
      };

      /**
       * @param comment {CommentStructureType}
       * @param sequenceListIndex {number}
       * @param commentIndex {number}
       * @param commentReplyIndex {number}
       */
      $scope.showEditCommentActionsMenu = function (comment, sequenceListIndex, commentIndex, commentReplyIndex) {
        //console.log('isReply? ' + comment.isReply + ', sequenceListIndex: ' + sequenceListIndex + ' commentIndex ' + commentIndex + ', commentReplyIndex: ', commentReplyIndex);
        console.log("comment", comment);
        var buttons = [];
        var buttonsIds = [];

        if (comment.canEdit) {
          buttons.push({text: Utils.translate('GLOBAL.UPDATE') + ' <i class="icon ion-android-create"></i>'});
          buttonsIds.push('EDIT_COMMENT');
        }
        /*if (!comment.isReply) {
         buttons.push({text: Utils.translate('COMMENT.REPLY') + ' <i class="icon ion-android-add"></i>'});
         buttonsIds.push('REPLY_COMMENT');
         }*/


        Utils.$ionicActionSheet.show({
          buttons: buttons,
          titleText: Utils.translate('SEQUENCE.OPTIONS'),
          buttonClicked: function (buttonIndex) {
            switch (buttonsIds[buttonIndex]) {
              case "EDIT_COMMENT":
                $scope.openEditableComment(comment);
                break;
              /*case "REPLY_COMMENT":
               $scope.openEditableComment(comment, true);
               break;*/
              default:
                Utils.toast.warning("Invalid option '" + buttonsIds[buttonIndex] + "'");
            }
            return true;
          },
          destructiveText: comment.canDelete ? Utils.translate('GLOBAL.DELETE') + ' <i class="icon ion-close-round"></i>' : null,
          destructiveButtonClicked: comment.canDelete ? function () {
            var wasReply = comment.isReply;
            Utils.confirm.show(Utils.translate(
              'COMMENT.DIALOG.' + (wasReply || !comment.responses.length ? 'DELETE_SINGLE_CONF' : 'DELETE_PARENT_CONF')), {}).then(function (respBool) {
              if (!respBool) return;

              Utils.loading.show();
              var sendBroadcast = ['TimeLineCtrl', 'GroupTimeLineCtrl'].indexOf($scope._controllerName) === -1;
              comment.deleteMe(sendBroadcast).then(function (totalDeleted) {
                if (!sendBroadcast)
                  $scope._sequenceList[sequenceListIndex].comments.counter -= totalDeleted;

                if (!wasReply)
                  $scope._sequenceList[sequenceListIndex].comments.items.splice(commentIndex, 1);
                else
                  $scope._sequenceList[sequenceListIndex].comments.items[commentIndex].responses.splice(commentReplyIndex, 1);
              }, function (error) {
                Utils.toast.error(Utils.translate("COMMENT.DIALOG.DELETE_COMMENT_ERROR"));
              }).finally(function () {
                Utils.loading.hide();
              });
            });
            return true;
          } : null
        });
      };

      /**
       * @param comment {CommentStructureType}
       */
      $scope.openEditableComment = function (comment) {
        openTextEditorWithTags(comment, true).then(/**@param form {messageComposerFormType}*/function (form) {
          //No changes in comment, nothing to do
          form.description = form.description || ' ';
          if (!form.description ||
            (comment.backupDescription === form.description && comment.imageUrl === form.imagePath)) return;

          comment.updateMe(form).then(function (/*theNewCommentObject*/) {
            //nothing to do...
          }, function (error) {
            //the messages/toasts are shown and printed inside updateMe
          }).finally(function () {
            comment.isUpdating = false;
          });
        });
      };

      /**
       * @param comment {CommentStructureType}
       */
      $scope.openReplyToComment = function (comment) {
        comment.tagsList.push(comment.ownerMetadata);
        openTextEditorWithTags({
          editableDescription: "@" + comment.ownerMetadata.name.replace(/\s\s+/g, ' '),
          tagsList: comment.tagsList,
          hashTagsList: comment.hashTagsList //LuMa HashTags in comments
        }).then(/**@param form {messageComposerFormType}*/function (form) {
          //No changes in comment, nothing to do
          form.description = form.description || ' ';
          if (!form.description ||
            (comment.backupDescription === form.description && comment.imageUrl === form.imagePath)) return;
          Utils.loading.show();
          comment.isReplying = true;
          comment.addReply(form).then(function (theNewCommentObject) {
            if (['commentsCqnzCtrl', 'showNotificationCtrl', 'showStreamingCtrl'].indexOf($scope._controllerName) > -1)
              comment.responses.push(theNewCommentObject);
          }, function (/*error*/) {
            Utils.toast.error(Utils.translate("SEQUENCE.DIALOG.CREATE_POST_COMMENT_ERROR"));
            //the error is printed inside updateMe
          }).finally(function () {
            Utils.$timeout(function () {
              comment.isReplying = false;
            })
            Utils.loading.hide();
          });
        });
      };

      /**
       *
       * @param comment? {CommentStructureType|*}
       * @param editMode? {boolean}
       * @return {Promise}
       */
      function openTextEditorWithTags(comment, editMode) {
        comment = comment || {};//<-- if user wants to create a new comment
        return Utils.$q(function (resolve, reject) {
          var dialog = Utils.alert.getCtrl();
          dialog.show({
            templateUrl: 'templates/partials/tags-modal.html',
            controller: 'tagsModalCtrl',
            fullscreen: true,
            locals: {
              description: comment.editableDescription || '',
              imagePath: comment.imageUrl || '',
              tagsList: comment.tagsList || [],
              hash: comment.hashTagsList || [], //LuMa HashTag in comment
              disableHashSearching: false, // LuMa HashTag in comment
              showAddimageButton: true,
              editMode: editMode || false,
              plusLength: true,
              dialog: dialog,
              needSearch: true
            },
            clickOutsideToClose: false,
            multiple: true
          }).then(function (form) {
            resolve(form)
          }, function () {
            reject();
          });
        })
      }

      /**
       * @param comment {CommentStructureType}
       * @param listIndex
       */
      $scope.setLikeToComment = function (comment, listIndex) {
        if (!amISuperAdmin && $scope.previewTimeline) {
          Utils.toast.warning(Utils.translate('PERMISSIONS.CANNOT.PERFORM_ACTION_ON_PREVIEW'));
          return;
        }
        if (!canLikeToComment()) {
          Utils.toast.warning(Utils.translate('PERMISSIONS.CANNOT.COMMENT_LIKE'));
          return;
        }

        comment.likeMe().then(function () {
          //console.log("sequeceCtrl.setLikeToComment!!!")
        }, function (error) {
          console.error("sequeceCtrl.setLikeToComment!!!", error)
        })
      };

      $scope.commentListSharedCtrl.openTextEditorWithTags = openTextEditorWithTags;

      //---------------------- PERMISSIONS SECTION --------------------------

      function canLikeToComment() {
        return amISuperAdmin || permissions.canLikeCommentInGralTimeline();
      }

      /**
       * @param comment {CommentStructureType}
       * @return {boolean}
       */
      $scope.canShowCommentEditActionsMenu = function (comment) {
        if (amISuperAdmin) return true;
        return comment.canModify
      };
    }])
;
