"use strict";

appServices
  .factory('AWSServices', ["$resource", "ApiEndPoint", "s3", "UserService", "Push_Notif_Variables", function($resource, ApiEndPoint, s3, UserService, Push_Notif_Variables) {

    var sns = new AWS.SNS({
      apiVersion: '2010-03-31'
    });

    /*
        Function to send notification
        */
    function sendNotification(msg, arn, extra, name) {
      //if(ionic.Platform.isAndroid())
      var payload = "";
      if (extra != null) {
        payload = {
          default: msg,
          GCM: {
            notification: {
              text: msg,
              sound: 'sonido.wav'
            },
            data: {
              title: 'Message',
              name: name
            }
          },
          APNS: {
            aps: {
              alert: msg,
              badge: 1,
              sound: 'sonido.wav'
            },
            data: {
              title: 'Message',
              name: name
            }
          },
          APNS_SANDBOX: {
            aps: {
              alert: msg,
              badge: 1,
              sound: 'sonido.wav'
            },
            data: {
              title: 'Message',
              name: name
            }
          }
        }
      } else {
        payload = {
          default: msg,
          GCM: {
            notification: {
              text: msg,
              sound: 'sonido.wav'
            }
            /*,
                                    data: {
                                        testdata: 'eleven',
                                        testDataNumb: 11
                                    }*/
            //"time_to_live": 3600,
          },
          APNS: {
            aps: {
              alert: msg,
              badge: 1,
              sound: 'sonido.wav'
            }
            /*,
                                    data: {
                                        testdata: 'eleven',
                                        testDataNumb: 11
                                    }*/
          },
          APNS_SANDBOX: {
            aps: {
              alert: msg,
              badge: 1,
              sound: 'sonido.wav'
            }
            /*,
                                    data: {
                                        testdata: 'eleven',
                                        testDataNumb: 11
                                    }*/
          }
        }
      }
      payload.GCM = JSON.stringify(payload.GCM);
      payload.APNS = JSON.stringify(payload.APNS);
      payload.APNS_SANDBOX = JSON.stringify(payload.APNS_SANDBOX);
      payload = JSON.stringify(payload);
      sns.publish({
        TargetArn: arn,
        Message: payload,
        MessageStructure: 'json'
      }, function(err, data) {
        if (err) {
          //console.log(err.stack);
          return;
        }
        //console.log("push send simple", JSON.stringify(data));
      })
    }

    /*
    Function to send notification for chat
    */
    function sendNotificationChats(msg, arn, extra, name) {
      //if(ionic.Platform.isAndroid())
      var payload = "";
      if (extra != null) {
        payload = {
          default: msg,
          GCM: {
            notification: {
              text: msg,
              sound: 'sonido.wav'
            },
            data: {
              title: 'Message',
              name: name
            }
          },
          APNS: {
            aps: {
              alert: msg,
              badge: 1,
              sound: 'sonido.wav'
            },
            data: {
              title: 'Message',
              name: name
            }
          },
          APNS_SANDBOX: {
            aps: {
              alert: msg,
              badge: 1,
              sound: 'sonido.wav'
            },
            data: {
              title: 'Message',
              name: name
            }
          }
        }
      } else {
        payload = {
          default: msg,
          GCM: {
            notification: {
              text: msg,
              sound: 'sonido.wav'
            }
            /*,
                                    data: {
                                        testdata: 'eleven',
                                        testDataNumb: 11
                                    }*/
            //"time_to_live": 3600,
          },
          APNS: {
            aps: {
              alert: msg,
              badge: 1,
              sound: 'sonido.wav'
            }
            /*,
                                    data: {
                                        testdata: 'eleven',
                                        testDataNumb: 11
                                    }*/
          },
          APNS_SANDBOX: {
            aps: {
              alert: msg,
              badge: 1,
              sound: 'sonido.wav'
            }
            /*,
                                    data: {
                                        testdata: 'eleven',
                                        testDataNumb: 11
                                    }*/
          }
        }
      }
      payload.GCM = JSON.stringify(payload.GCM);
      payload.APNS = JSON.stringify(payload.APNS);
      payload.APNS_SANDBOX = JSON.stringify(payload.APNS_SANDBOX);
      payload = JSON.stringify(payload);
      sns.publish({
        TargetArn: arn,
        Message: payload,
        MessageStructure: 'json'
      }, function(err, data) {
        if (err) {
          //console.log(err.stack);
          return;
        }
        //console.log("push send chat", JSON.stringify(data));
      })
    }

    /*
     *New function to make notifications with deeplink
     */
    function sendNotificationDeepLink(msg, arn, extra, type, id) {
      var payload = "";
      if (extra != null) {
        payload = {
          default: msg,
          GCM: {
            notification: {
              title: Push_Notif_Variables.title,
              body: msg,
              badge: 1,
              sound: 'sonido.wav',
              click_action: 'FCM_PLUGIN_ACTIVITY'
              /*,
                                          color: '#E9004B'*/
            },
            data: {
              title: 'Notification',
              body: type,
              param1: id
              /*,
                                          color: '#E9004B'*/
            }
          },
          APNS: {
            aps: {
              alert: {
                title: Push_Notif_Variables.title,
                body: msg,
              },
              //alert: msg,
              badge: 1,
              sound: 'sonido.wav',
              click_action: 'FCM_PLUGIN_ACTIVITY'
            },
            data: {
              title: 'Notification',
              body: type,
              param1: id
            }
          },
          APNS_SANDBOX: {
            aps: {
              //alert: msg,
              alert: {
                title: Push_Notif_Variables.title,
                body: msg,
              },
              badge: 1,
              sound: 'sonido.wav',
              click_action: 'FCM_PLUGIN_ACTIVITY'
            },
            data: {
              title: 'Notification',
              body: type,
              param1: id
            }
          },
          priority: 'high'
        }
      } else {
        payload = {
          default: msg,
          GCM: {
            notification: {
              text: msg,
              sound: 'sonido.wav'
            }
          },
          APNS: {
            aps: {
              alert: msg,
              badge: 1,
              sound: 'sonido.wav'
            }
          },
          APNS_SANDBOX: {
            aps: {
              alert: msg,
              badge: 1,
              sound: 'sonido.wav'
            }
          },
          priority: 'high'
        }
      }
      payload.GCM = JSON.stringify(payload.GCM);
      payload.APNS = JSON.stringify(payload.APNS);
      payload.APNS_SANDBOX = JSON.stringify(payload.APNS_SANDBOX);
      payload = JSON.stringify(payload);
      sns.publish({
        TargetArn: arn,
        Message: payload,
        MessageStructure: 'json'
      }, function(err, data) {
        if (err) {
          //console.log(err.stack);
          return;
        }
        //console.log("push send deeplink", JSON.stringify(data));
      })
    }

    /*
     *New function to make notification for contact expocitor
     */
    function sendNotificationexhibitor(msg, name, arn, extra, type, id) {
      var payload = "";
      var realTitle = Push_Notif_Variables.abbreviation + name;
      if (extra != null) {
        payload = {
          default: msg,
          GCM: {
            notification: {
              title: realTitle,
              body: msg,
              badge: 1,
              sound: 'sonido.wav',
              click_action: 'FCM_PLUGIN_ACTIVITY'
              /*,
                                          color: '#E9004B'*/
            },
            data: {
              title: 'Exhibitor',
              body: type,
              param1: id,
              param2: name
              /*,
                                          color: '#E9004B'*/
            }
          },
          APNS: {
            aps: {
              alert: {
                title: realTitle,
                body: msg,
              },
              badge: 1,
              sound: 'sonido.wav',
              click_action: 'FCM_PLUGIN_ACTIVITY'
            },
            data: {
              title: 'Exhibitor',
              body: type,
              param1: id,
              param2: name
            }
          },
          APNS_SANDBOX: {
            aps: {
              alert: {
                title: realTitle,
                body: msg,
              },
              badge: 1,
              sound: 'sonido.wav',
              click_action: 'FCM_PLUGIN_ACTIVITY'
            },
            data: {
              title: 'Exhibitor',
              body: type,
              param1: id,
              param2: name
            }
          },
          priority: 'high'
        }
      } else {
        payload = {
          default: msg,
          GCM: {
            notification: {
              text: msg,
              sound: 'sonido.wav'
            }
          },
          APNS: {
            aps: {
              alert: msg,
              badge: 1,
              sound: 'sonido.wav'
            }
          },
          APNS_SANDBOX: {
            aps: {
              alert: msg,
              badge: 1,
              sound: 'sonido.wav'
            }
          },
          priority: 'high'
        }
      }
      payload.GCM = JSON.stringify(payload.GCM);
      payload.APNS = JSON.stringify(payload.APNS);
      payload.APNS_SANDBOX = JSON.stringify(payload.APNS_SANDBOX);
      payload = JSON.stringify(payload);
      sns.publish({
        TargetArn: arn,
        Message: payload,
        MessageStructure: 'json'
      }, function(err, data) {
        if (err) {
          //console.log(err.stack);
          return;
        }
        //console.log("push send Exhibitor", JSON.stringify(data));
      })
    }

    /*
     *New function to make notification for group members
     */
    function sendNotificationGroupMembers(msg, name, arn, extra, type, id) {
      var payload = "";
      var realTitle = name;
      if (extra != null) {
        payload = {
          default: msg,
          GCM: {
            notification: {
              title: realTitle,
              body: msg,
              badge: 1,
              sound: 'sonido.wav',
              click_action: 'FCM_PLUGIN_ACTIVITY'
              /*,
                                          color: '#E9004B'*/
            },
            data: {
              title: 'Group',
              body: type,
              param1: id,
              param2: name
              /*,
                                          color: '#E9004B'*/
            }
          },
          APNS: {
            aps: {
              alert: {
                title: realTitle,
                body: msg,
              },
              badge: 1,
              sound: 'sonido.wav',
              click_action: 'FCM_PLUGIN_ACTIVITY'
            },
            data: {
              title: 'Group',
              body: type,
              param1: id,
              param2: name
            }
          },
          APNS_SANDBOX: {
            aps: {
              alert: {
                title: realTitle,
                body: msg,
              },
              badge: 1,
              sound: 'sonido.wav',
              click_action: 'FCM_PLUGIN_ACTIVITY'
            },
            data: {
              title: 'Group',
              body: type,
              param1: id,
              param2: name
            }
          },
          priority: 'high'
        }
      } else {
        payload = {
          default: msg,
          GCM: {
            notification: {
              text: msg,
              sound: 'sonido.wav'
            }
          },
          APNS: {
            aps: {
              alert: msg,
              badge: 1,
              sound: 'sonido.wav'
            }
          },
          APNS_SANDBOX: {
            aps: {
              alert: msg,
              badge: 1,
              sound: 'sonido.wav'
            }
          },
          priority: 'high'
        }
      }
      payload.GCM = JSON.stringify(payload.GCM);
      payload.APNS = JSON.stringify(payload.APNS);
      payload.APNS_SANDBOX = JSON.stringify(payload.APNS_SANDBOX);
      payload = JSON.stringify(payload);
      sns.publish({
        TargetArn: arn,
        Message: payload,
        MessageStructure: 'json'
      }, function(err, data) {
        if (err) {
          //console.log(err.stack);
          return;
        }
        //console.log("push send Notif Group", JSON.stringify(data));
      })
    }

    /*
     * New function to make notification global 
     */
    function sendGlobalNotification(msg, arn) {
      var payload = "";
      var realTitle = Push_Notif_Variables.title;
      payload = {
        default: msg,
        GCM: {
          notification: {
            title: realTitle,
            body: msg,
            badge: 1,
            sound: 'sonido.wav',
            click_action: 'FCM_PLUGIN_ACTIVITY'
          },
          data: {
            title: 'Global',
            param1: msg
          }
        },
        APNS: {
          aps: {
            alert: {
              title: realTitle,
              body: msg,
            },
            badge: 1,
            sound: 'sonido.wav',
            click_action: 'FCM_PLUGIN_ACTIVITY'
          },
          data: {
            title: 'Global',
            param1: msg
          }
        },
        APNS_SANDBOX: {
          aps: {
            alert: {
              title: realTitle,
              body: msg,
            },
            badge: 1,
            sound: 'sonido.wav',
            click_action: 'FCM_PLUGIN_ACTIVITY'
          },
          data: {
            title: 'Global',
            param1: msg
          }
        },
        priority: 'high'
      }
      payload.GCM = JSON.stringify(payload.GCM);
      payload.APNS = JSON.stringify(payload.APNS);
      payload.APNS_SANDBOX = JSON.stringify(payload.APNS_SANDBOX);
      payload = JSON.stringify(payload);
      sns.publish({
        TargetArn: arn,
        Message: payload,
        MessageStructure: 'json'
      }, function(err, data) {
        if (err) {
          //console.log(err.stack);
          return;
        }
        //console.log("push send global", JSON.stringify(data));
      })
    }

    /*
     * New function to notify your's followers when a user post something in your TL
     */
    function sendPostFollowersNotification(msg, arn, groupID, sequenceID) {
      var payload = "";
      var appName = Push_Notif_Variables.title;
      payload = {
        default: msg,
        GCM: {
          notification: {
            title: appName,
            body: msg,
            badge: 1,
            sound: 'sonido.wav',
            click_action: 'FCM_PLUGIN_ACTIVITY'
          },
          data: {
            title: 'To_Followers_Notification',
            body: "FOLLOWERS_PUSH",
            param1: groupID,
            param2: sequenceID
          }
        },
        APNS: {
          aps: {
            alert: {
              title: appName,
              body: msg
            },
            badge: 1,
            sound: 'sonido.wav',
            click_action: 'FCM_PLUGIN_ACTIVITY'
          },
          data: {
            title: 'To_Followers_Notification',
            body: "FOLLOWERS_PUSH",
            param1: groupID,
            param2: sequenceID
          }
        },
        APNS_SANDBOX: {
          aps: {
            alert: {
              title: appName,
              body: msg
            },
            badge: 1,
            sound: 'sonido.wav',
            click_action: 'FCM_PLUGIN_ACTIVITY'
          },
          data: {
            title: 'To_Followers_Notification',
            body: "FOLLOWERS_PUSH",
            param1: groupID,
            param2: sequenceID
          }
        },
        priority: 'high'
      }
      payload.GCM = JSON.stringify(payload.GCM);
      payload.APNS = JSON.stringify(payload.APNS);
      payload.APNS_SANDBOX = JSON.stringify(payload.APNS_SANDBOX);
      payload = JSON.stringify(payload);
      sns.publish({
        TargetArn: arn,
        Message: payload,
        MessageStructure: 'json'
      }, function(err, data) {
        if (err) {
          //console.log(err.stack);
          return;
        }
        //console.log("push send", JSON.stringify(data));
      })
    }

    /*
     * New function to notify group's memebers when a user post something in that group
     */
    function sendPostGroupNotification(msg, arn, groupID, sequenceID) {
      var payload = "";
      var appName = Push_Notif_Variables.title;
      payload = {
        default: msg,
        GCM: {
          notification: {
            title: appName,
            body: msg,
            badge: 1,
            sound: 'sonido.wav',
            click_action: 'FCM_PLUGIN_ACTIVITY'
          },
          data: {
            title: 'Group_Notification',
            body: "GROUP_PUSH",
            param1: groupID,
            param2: sequenceID
          }
        },
        APNS: {
          aps: {
            alert: {
              title: appName,
              body: msg
            },
            badge: 1,
            sound: 'sonido.wav',
            click_action: 'FCM_PLUGIN_ACTIVITY'
          },
          data: {
            title: 'Group_Notification',
            body: "GROUP_PUSH",
            param1: groupID,
            param2: sequenceID
          }
        },
        APNS_SANDBOX: {
          aps: {
            alert: {
              title: appName,
              body: msg
            },
            badge: 1,
            sound: 'sonido.wav',
            click_action: 'FCM_PLUGIN_ACTIVITY'
          },
          data: {
            title: 'Group_Notification',
            body: "GROUP_PUSH",
            param1: groupID,
            param2: sequenceID
          }
        },
        priority: 'high'
      }
      payload.GCM = JSON.stringify(payload.GCM);
      payload.APNS = JSON.stringify(payload.APNS);
      payload.APNS_SANDBOX = JSON.stringify(payload.APNS_SANDBOX);
      payload = JSON.stringify(payload);
      sns.publish({
        TargetArn: arn,
        Message: payload,
        MessageStructure: 'json'
      }, function(err, data) {
        if (err) {
          //console.log(err.stack);
          return;
        }
        //console.log("push send Post in group", JSON.stringify(data));
      })
    }

    //LuMa Live Streaming
    function sendLiveStreamingNotification(msg, arn, extra, type, userStreamingId) {
      var payload = "";
      if (extra != null) {
        payload = {
          default: msg,
          GCM: {
            notification: {
              //title: 'LadyMultitask',
              title: Push_Notif_Variables.title,
              body: msg,
              badge: 1,
              sound: 'sonido.wav',
              click_action: 'FCM_PLUGIN_ACTIVITY'
              /*,
                                          color: '#E9004B'*/
            },
            data: {
              title: 'LiveStreaming',
              body: type,
              param1: msg,
              param2: userStreamingId
              /*,
                                          color: '#E9004B'*/
            }
          },
          APNS: {
            aps: {
              alert: {
                //title: 'LadyMultitask',
                title: Push_Notif_Variables.title,
                body: msg,
              },
              //alert: msg,
              badge: 1,
              sound: 'sonido.wav',
              click_action: 'FCM_PLUGIN_ACTIVITY'
            },
            data: {
              title: 'LiveStreaming',
              body: type,
              param1: msg,
              param2: userStreamingId
            }
          },
          APNS_SANDBOX: {
            aps: {
              //alert: msg,
              alert: {
                //title: 'LadyMultitask',
                title: Push_Notif_Variables.title,
                body: msg,
              },
              badge: 1,
              sound: 'sonido.wav',
              click_action: 'FCM_PLUGIN_ACTIVITY'
            },
            data: {
              title: 'LiveStreaming',
              body: type,
              param1: msg,
              param2: userStreamingId
            }
          },
          priority: 'high'
        }
      } else {
        payload = {
          default: msg,
          GCM: {
            notification: {
              text: msg,
              sound: 'sonido.wav'
            }
          },
          APNS: {
            aps: {
              alert: msg,
              badge: 1,
              sound: 'sonido.wav'
            }
          },
          APNS_SANDBOX: {
            aps: {
              alert: msg,
              badge: 1,
              sound: 'sonido.wav'
            }
          },
          priority: 'high'
        }
      }
      payload.GCM = JSON.stringify(payload.GCM);
      payload.APNS = JSON.stringify(payload.APNS);
      payload.APNS_SANDBOX = JSON.stringify(payload.APNS_SANDBOX);
      payload = JSON.stringify(payload);
      sns.publish({
        TargetArn: arn,
        Message: payload,
        MessageStructure: 'json'
      }, function(err, data) {
        if (err) {
          //console.log(err.stack);
          return;
        }
        //console.log("push send", JSON.stringify(data));
      })
    }

    function sendGlobalNotificationStream(msg, arn, extra, type, userStreamingId, postStream) {
      var payload = "";
      payload = {
        default: msg,
        GCM: {
          notification: {
            title: Push_Notif_Variables.title,
            body: msg,
            badge: 1,
            sound: 'sonido.wav',
            click_action: 'FCM_PLUGIN_ACTIVITY'
          },
          data: {
            title: 'LiveStreaming',
            body: type,
            param1: msg,
            param2: userStreamingId,
            param3: postStream
          }
        },
        APNS: {
          aps: {
            alert: {
              title: Push_Notif_Variables.title,
              body: msg,
            },
            badge: 1,
            sound: 'sonido.wav',
            click_action: 'FCM_PLUGIN_ACTIVITY'
          },
          data: {
            title: 'LiveStreaming',
            body: type,
            param1: msg,
            param2: userStreamingId,
            param3: postStream
          }
        },
        APNS_SANDBOX: {
          aps: {
            alert: {
              title: Push_Notif_Variables.title,
              body: msg,
            },
            badge: 1,
            sound: 'sonido.wav',
            click_action: 'FCM_PLUGIN_ACTIVITY'
          },
          data: {
            title: 'LiveStreaming',
            body: type,
            param1: msg,
            param2: userStreamingId,
            param3: postStream
          }
        },
        priority: 'high'
      }
      payload.GCM = JSON.stringify(payload.GCM);
      payload.APNS = JSON.stringify(payload.APNS);
      payload.APNS_SANDBOX = JSON.stringify(payload.APNS_SANDBOX);
      payload = JSON.stringify(payload);
      sns.publish({
        TargetArn: arn,
        Message: payload,
        MessageStructure: 'json'
      }, function(err, data) {
        if (err) {
          //console.log(err.stack);
          return;
        }
        //console.log("push send global", JSON.stringify(data));
      })
    }

    /*
     * New function to notify your's followers about your new profile picture
     */
    function sendNewProfilePhotoNotification(msg, arn, groupID, userId) {
      var payload = "";
      var appName = Push_Notif_Variables.title;
      payload = {
        default: msg,
        GCM: {
          notification: {
            title: appName,
            body: msg,
            badge: 1,
            sound: 'sonido.wav',
            click_action: 'FCM_PLUGIN_ACTIVITY'
          },
          data: {
            title: 'Profile_Picture_Notification',
            body: "PROFILE_PICTURE_PUSH",
            param1: userId
          }
        },
        APNS: {
          aps: {
            alert: {
              title: appName,
              body: msg
            },
            badge: 1,
            sound: 'sonido.wav',
            click_action: 'FCM_PLUGIN_ACTIVITY'
          },
          data: {
            title: 'Profile_Picture_Notification',
            body: "PROFILE_PICTURE_PUSH",
            param1: userId
          }
        },
        APNS_SANDBOX: {
          aps: {
            alert: {
              title: appName,
              body: msg
            },
            badge: 1,
            sound: 'sonido.wav',
            click_action: 'FCM_PLUGIN_ACTIVITY'
          },
          data: {
            title: 'Profile_Picture_Notification',
            body: "PROFILE_PICTURE_PUSH",
            param1: userId
          }
        },
        priority: 'high'
      }
      payload.GCM = JSON.stringify(payload.GCM);
      payload.APNS = JSON.stringify(payload.APNS);
      payload.APNS_SANDBOX = JSON.stringify(payload.APNS_SANDBOX);
      payload = JSON.stringify(payload);
      sns.publish({
        TargetArn: arn,
        Message: payload,
        MessageStructure: 'json'
      }, function(err, data) {
        if (err) {
          //console.log(err.stack);
          return;
        }
        //console.log("push send profile photo new", JSON.stringify(data));
      })
    }

    /*
     * New function to notify group's memnber when the cover photo is updated
     */
    function sendNewGroupCoverNotification(msg, arn, groupID, groupName) {
      var payload = "";
      var appName = Push_Notif_Variables.title;
      payload = {
        default: msg,
        GCM: {
          notification: {
            title: appName,
            body: msg,
            badge: 1,
            sound: 'sonido.wav',
            click_action: 'FCM_PLUGIN_ACTIVITY'
          },
          data: {
            title: 'Group_Cover_Notification',
            body: "GROUP_COVER_PUSH",
            param1: groupID,
            param2: groupName
          }
        },
        APNS: {
          aps: {
            alert: {
              title: appName,
              body: msg
            },
            badge: 1,
            sound: 'sonido.wav',
            click_action: 'FCM_PLUGIN_ACTIVITY'
          },
          data: {
            title: 'Group_Cover_Notification',
            body: "GROUP_COVER_PUSH",
            param1: groupID,
            param2: groupName
          }
        },
        APNS_SANDBOX: {
          aps: {
            alert: {
              title: appName,
              body: msg
            },
            badge: 1,
            sound: 'sonido.wav',
            click_action: 'FCM_PLUGIN_ACTIVITY'
          },
          data: {
            title: 'Group_Cover_Notification',
            body: "GROUP_COVER_PUSH",
            param1: groupID,
            param2: groupName
          }
        },
        priority: 'high'
      }
      payload.GCM = JSON.stringify(payload.GCM);
      payload.APNS = JSON.stringify(payload.APNS);
      payload.APNS_SANDBOX = JSON.stringify(payload.APNS_SANDBOX);
      payload = JSON.stringify(payload);
      sns.publish({
        TargetArn: arn,
        Message: payload,
        MessageStructure: 'json'
      }, function(err, data) {
        if (err) {
          //console.log(err.stack);
          return;
        }
        //console.log("push send new cover group", JSON.stringify(data));
      })
    }

    /*
     * New function to notify user that has been accepted into a group
     */
    function sendNotifAcceptedGroup(msg, arn, groupID, groupName) {
      var payload = "";
      var appName = Push_Notif_Variables.title;
      payload = {
        default: msg,
        GCM: {
          notification: {
            title: appName,
            body: msg,
            badge: 1,
            sound: 'sonido.wav',
            click_action: 'FCM_PLUGIN_ACTIVITY'
          },
          data: {
            title: 'Accepted_Group_Notification',
            body: "GROUP_ACCEPTED_PUSH",
            param1: groupID,
            param2: groupName
          }
        },
        APNS: {
          aps: {
            alert: {
              title: appName,
              body: msg
            },
            badge: 1,
            sound: 'sonido.wav',
            click_action: 'FCM_PLUGIN_ACTIVITY'
          },
          data: {
            title: 'Accepted_Group_Notification',
            body: "GROUP_ACCEPTED_PUSH",
            param1: groupID,
            param2: groupName
          }
        },
        APNS_SANDBOX: {
          aps: {
            alert: {
              title: appName,
              body: msg
            },
            badge: 1,
            sound: 'sonido.wav',
            click_action: 'FCM_PLUGIN_ACTIVITY'
          },
          data: {
            title: 'Accepted_Group_Notification',
            body: "GROUP_ACCEPTED_PUSH",
            param1: groupID,
            param2: groupName
          }
        },
        priority: 'high'
      }
      payload.GCM = JSON.stringify(payload.GCM);
      payload.APNS = JSON.stringify(payload.APNS);
      payload.APNS_SANDBOX = JSON.stringify(payload.APNS_SANDBOX);
      payload = JSON.stringify(payload);
      sns.publish({
        TargetArn: arn,
        Message: payload,
        MessageStructure: 'json'
      }, function(err, data) {
        if (err) {
          //console.log(err.stack);
          return;
        }
        //console.log("push send accepted in group", JSON.stringify(data));
      })
    }

    /*
     * New function to notify user that someone have liked a post that she have commented
     */
    function sendNotifaboutPostCommented(msg, arn, groupID, sequenceID) {
      var payload = "";
      var appName = Push_Notif_Variables.title;
      payload = {
        default: msg,
        GCM: {
          notification: {
            title: appName,
            body: msg,
            badge: 1,
            sound: 'sonido.wav',
            click_action: 'FCM_PLUGIN_ACTIVITY'
          },
          data: {
            title: 'Liked_Commented_Post_Notification',
            body: "LIKED_POST_COMMENT_PUSH",
            param1: groupID,
            param2: sequenceID
          }
        },
        APNS: {
          aps: {
            alert: {
              title: appName,
              body: msg
            },
            badge: 1,
            sound: 'sonido.wav',
            click_action: 'FCM_PLUGIN_ACTIVITY'
          },
          data: {
            title: 'Liked_Commented_Post_Notification',
            body: "LIKED_POST_COMMENT_PUSH",
            param1: groupID,
            param2: sequenceID
          }
        },
        APNS_SANDBOX: {
          aps: {
            alert: {
              title: appName,
              body: msg
            },
            badge: 1,
            sound: 'sonido.wav',
            click_action: 'FCM_PLUGIN_ACTIVITY'
          },
          data: {
            title: 'Liked_Commented_Post_Notification',
            body: "LIKED_POST_COMMENT_PUSH",
            param1: groupID,
            param2: sequenceID
          }
        },
        priority: 'high'
      }
      payload.GCM = JSON.stringify(payload.GCM);
      payload.APNS = JSON.stringify(payload.APNS);
      payload.APNS_SANDBOX = JSON.stringify(payload.APNS_SANDBOX);
      payload = JSON.stringify(payload);
      sns.publish({
        TargetArn: arn,
        Message: payload,
        MessageStructure: 'json'
      }, function(err, data) {
        if (err) {
          //console.log(err.stack);
          return;
        }
        //console.log("push send postComented", JSON.stringify(data));
      })
    }

    /*
     * New function to notify user that someone have liked a post that she have liked
     */
    function sendNotifaboutPostLiked(msg, arn, groupID, sequenceID) {
      var payload = "";
      var appName = Push_Notif_Variables.title;
      payload = {
        default: msg,
        GCM: {
          notification: {
            title: appName,
            body: msg,
            badge: 1,
            sound: 'sonido.wav',
            click_action: 'FCM_PLUGIN_ACTIVITY'
          },
          data: {
            title: 'Liked_Liked_Post_Notification',
            body: "LIKED_POST_LIKE_PUSH",
            param1: groupID,
            param2: sequenceID
          }
        },
        APNS: {
          aps: {
            alert: {
              title: appName,
              body: msg
            },
            badge: 1,
            sound: 'sonido.wav',
            click_action: 'FCM_PLUGIN_ACTIVITY'
          },
          data: {
            title: 'Liked_Liked_Post_Notification',
            body: "LIKED_POST_LIKE_PUSH",
            param1: groupID,
            param2: sequenceID
          }
        },
        APNS_SANDBOX: {
          aps: {
            alert: {
              title: appName,
              body: msg
            },
            badge: 1,
            sound: 'sonido.wav',
            click_action: 'FCM_PLUGIN_ACTIVITY'
          },
          data: {
            title: 'Liked_Liked_Post_Notification',
            body: "LIKED_POST_LIKE_PUSH",
            param1: groupID,
            param2: sequenceID
          }
        },
        priority: 'high'
      }
      payload.GCM = JSON.stringify(payload.GCM);
      payload.APNS = JSON.stringify(payload.APNS);
      payload.APNS_SANDBOX = JSON.stringify(payload.APNS_SANDBOX);
      payload = JSON.stringify(payload);
      sns.publish({
        TargetArn: arn,
        Message: payload,
        MessageStructure: 'json'
      }, function(err, data) {
        if (err) {
          //console.log(err.stack);
          return;
        }
        //console.log("push send postliked", JSON.stringify(data));
      })
    }

    /*
     * New function to notify user that someone now follow him
     */
    function sendNotifaboutFollowAction(msg, arn, name, userId) {
      var payload = "";
      var appName = Push_Notif_Variables.title;
      payload = {
        default: msg,
        GCM: {
          notification: {
            title: appName,
            body: msg,
            badge: 1,
            sound: 'sonido.wav',
            click_action: 'FCM_PLUGIN_ACTIVITY'
          },
          data: {
            title: 'follow_user_Notification',
            body: "FOLLOW_USER_PUSH",
            param1: name,
            param2: userId
          }
        },
        APNS: {
          aps: {
            alert: {
              title: appName,
              body: msg
            },
            badge: 1,
            sound: 'sonido.wav',
            click_action: 'FCM_PLUGIN_ACTIVITY'
          },
          data: {
            title: 'follow_user_Notification',
            body: "FOLLOW_USER_PUSH",
            param1: name,
            param2: userId
          }
        },
        APNS_SANDBOX: {
          aps: {
            alert: {
              title: appName,
              body: msg
            },
            badge: 1,
            sound: 'sonido.wav',
            click_action: 'FCM_PLUGIN_ACTIVITY'
          },
          data: {
            title: 'follow_user_Notification',
            body: "FOLLOW_USER_PUSH",
            param1: name,
            param2: userId
          }
        },
        priority: 'high'
      }
      payload.GCM = JSON.stringify(payload.GCM);
      payload.APNS = JSON.stringify(payload.APNS);
      payload.APNS_SANDBOX = JSON.stringify(payload.APNS_SANDBOX);
      payload = JSON.stringify(payload);
      sns.publish({
        TargetArn: arn,
        Message: payload,
        MessageStructure: 'json'
      }, function(err, data) {
        if (err) {
          //console.log(err.stack);
          return;
        }
        //console.log("push send follow user", JSON.stringify(data));
      })
    }

    /*
     *arn:aws:sns:us-west-2:207318764510:endpoint/GCM/ladyMultitask_Android_2018/5ab85570-c6c4-38f4-bed6-b168f2a61bd8
     */
    function sendNotifRegionalAction(msg, arn) {
      var payload = "";
      var appName = Push_Notif_Variables.title;
      payload = {
        default: msg,
        GCM: {
          notification: {
            title: appName,
            body: msg,
            badge: 1,
            sound: 'sonido.wav',
            click_action: 'FCM_PLUGIN_ACTIVITY'
          },
          data: {
            title: 'Regional_Notification',
            body: "REGIONAL_PUSH"
          }
        },
        APNS: {
          aps: {
            alert: {
              title: appName,
              body: msg
            },
            badge: 1,
            sound: 'sonido.wav',
            click_action: 'FCM_PLUGIN_ACTIVITY'
          },
          data: {
            title: 'Regional_Notification',
            body: "REGIONAL_PUSH"
          }
        },
        APNS_SANDBOX: {
          aps: {
            alert: {
              title: appName,
              body: msg
            },
            badge: 1,
            sound: 'sonido.wav',
            click_action: 'FCM_PLUGIN_ACTIVITY'
          },
          data: {
            title: 'Regional_Notification',
            body: "REGIONAL_PUSH"
          }
        },
        priority: 'high'
      }
      payload.GCM = JSON.stringify(payload.GCM);
      payload.APNS = JSON.stringify(payload.APNS);
      payload.APNS_SANDBOX = JSON.stringify(payload.APNS_SANDBOX);
      payload = JSON.stringify(payload);
      sns.publish({
        TargetArn: arn,
        Message: payload,
        MessageStructure: 'json'
      }, function(err, data) {
        if (err) {
          //console.log(err.stack);
          return;
        }
        //console.log("push send REGIONAL PUSH", JSON.stringify(data));
      })
    }

    function sendNotifAcceptedUser(msg, arn) {
      var payload = "";
      var appName = Push_Notif_Variables.title;
      payload = {
        default: msg,
        GCM: {
          notification: {
            title: appName,
            body: msg,
            badge: 1,
            sound: 'sonido.wav',
            click_action: 'FCM_PLUGIN_ACTIVITY'
          },
          data: {
            title: 'Accepted_User',
            body: "ACCEPTED_USER"
          }
        },
        APNS: {
          aps: {
            alert: {
              title: appName,
              body: msg
            },
            badge: 1,
            sound: 'sonido.wav',
            click_action: 'FCM_PLUGIN_ACTIVITY'
          },
          data: {
            title: 'Accepted_User',
            body: "ACCEPTED_USER"
          }
        },
        APNS_SANDBOX: {
          aps: {
            alert: {
              title: appName,
              body: msg
            },
            badge: 1,
            sound: 'sonido.wav',
            click_action: 'FCM_PLUGIN_ACTIVITY'
          },
          data: {
            title: 'Accepted_User',
            body: "ACCEPTED_USER"
          }
        },
        priority: 'high'
      }
      payload.GCM = JSON.stringify(payload.GCM);
      payload.APNS = JSON.stringify(payload.APNS);
      payload.APNS_SANDBOX = JSON.stringify(payload.APNS_SANDBOX);
      payload = JSON.stringify(payload);
      sns.publish({
        TargetArn: arn,
        Message: payload,
        MessageStructure: 'json'
      }, function(err, data) {
        if (err) {
          //console.log(err.stack);
          return;
        }
        //console.log("push send REGIONAL PUSH", JSON.stringify(data));
      })
    }

    /*
        Function to obtain platformEndpoint
        needed to send notifications device to device or server to device
        */
    function awsInit() {
      var isIOS = ionic.Platform.isIOS();
      var isAndroid = ionic.Platform.isAndroid();
      var ARN = null;
      if (isAndroid === true) {
        ARN = s3.platformARN_ANDROID;
      } else {
        //ARN = s3.platformARN_IOSDEV; //Para development
        ARN = s3.platformARN_IOS; //Para producción
      }
      sns.createPlatformEndpoint({
        //PlatformApplicationArn: 'arn:aws:sns:us-west-2:924430439314:app/GCM/niidoApp',
        PlatformApplicationArn: ARN,
        Token: window.localStorage.getItem('AWSToken')
      }, function(err, data) {
        if (err) {
          //console.log(err, err.stack);
        } else {
          //console.log(data);
          window.localStorage.setItem('EndpointArn', data.EndpointArn);
          UserService.getDevices(
            window.localStorage.getItem('userSubscriptionInstanceId')
          ).$promise.then(function success(response) {
            var counter = 0;
            for (var i = 0; i < response.result.value.length; i++) {
              if (window.localStorage.getItem('EndpointArn') == response.result.value[i].title) {
                counter++;
              }
            }
            if (counter == 0) {
              UserService.addDevice({
                objectId: window.localStorage.getItem('userSubscriptionInstanceId')
              }).save({
                "userDeviceId": {
                  "value": window.localStorage.getItem('EndpointArn')
                },
                "status": {
                  "value": "valid"
                }
              }).$promise.then(function success() {
                //console.log("nice addDevice");
              }, function(response) {
                //console.log("error addDevice");
              })
            }
          });
          suscribeAWS();
        }
      })
    }

    /*
        Function to obtain platformEndpoint
        needed to send notifications device to device or server to device
        */
    function suscribeAWS() {
      sns.subscribe({
        Protocol: 'application',
        //TopicArn: s3.topicARN, //Para development
        TopicArn: s3.topicARNProduction, //Para producción
        Endpoint: window.localStorage.getItem('EndpointArn')
      }, function(err, data) {
        if (err) {
          //console.log(err, err.stack);
        } else {
          window.localStorage.setItem('suscriptionIdAWS', data.SubscriptionArn);
          //console.log(data);
        }
      });
    }

    /*
    Function to delete platformendpoint
    when user log out or when user delete account
    */
    function deletePlatformEndpoint(logout) {
      sns.deleteEndpoint({
        EndpointArn: window.localStorage.getItem("EndpointArn")
      }, function(err, data) {
        if (err) {
          //console.log(err, err.stack);
        } else {
          //window.localStorage.removeItem('EndpointArn');
          //window.localStorage.removeItem('suscriptionIdAWS');
        }
      });
      if (logout == 1) {
        var tempPers = window.localStorage.getItem('AppsPerzonalized');
        window.localStorage.clear();
        window.localStorage.setItem("AppsPerzonalized", tempPers);
        window.localStorage.setItem("onboardingComplete", "yes");
      }
    }

    /*
    NEW ZONE FOR SMS MESSAGES //BALA SMS MESSAGE
    */
    function sendSMSToUser(phone, msg) {
      var payload = "";
      var appName = Push_Notif_Variables.title;
      var params = {
        Message: msg + " send by: \n" + Push_Notif_Variables.title,
        PhoneNumber: phone
      };
      sns.publish(params, function(err, data) {
        if (err) {
          //console.log(err.stack);
          return;
        }
        //console.log("SMS send with data:", JSON.stringify(data));
      })
    }
    /*
    ENDNEW ZONE FOR SMS MESSAGES
    */

    return {
      sendNotification: sendNotification,
      sendNotificationDeepLink: sendNotificationDeepLink,
      awsInit: awsInit,
      suscribeAWS: suscribeAWS,
      deletePlatformEndpoint: deletePlatformEndpoint,
      sendNotificationexhibitor: sendNotificationexhibitor,
      sendNotificationGroupMembers: sendNotificationGroupMembers,
      sendGlobalNotification: sendGlobalNotification,
      sendPostFollowersNotification: sendPostFollowersNotification,
      sendPostGroupNotification: sendPostGroupNotification,
      sendNewProfilePhotoNotification: sendNewProfilePhotoNotification,
      sendNotifAcceptedGroup: sendNotifAcceptedGroup,
      sendNotifaboutPostCommented: sendNotifaboutPostCommented,
      sendNotifaboutPostLiked: sendNotifaboutPostLiked,
      sendNotifaboutFollowAction: sendNotifaboutFollowAction,
      sendNotifRegionalAction: sendNotifRegionalAction,
      sendNotifAcceptedUser: sendNotifAcceptedUser,
      sendLiveStreamingNotification: sendLiveStreamingNotification, //LuMa Live Streaming
      sendGlobalNotificationStream: sendGlobalNotificationStream,
      sendSMSToUser: sendSMSToUser, //BALA SMS MESSAGE
      sendNewGroupCoverNotification: sendNewGroupCoverNotification
    }
  }])
