"use strict";
appServices
  .factory('EventsServices', ['$rootScope', '$resource', "s3", "ApiEndPoint", 'UserService', 'notificationsService', 'permissionValidationService', 'Utils',
    function($rootScope, $resource, s3, ApiEndPoint, UserService, notificationsService, permissionValidationService, Utils) {

      function addEvent(data) {
        return $resource(
          ApiEndPoint.url + 'restful/services/EventRepository/actions/addEvent/invoke', {}, {
            post: {
              method: 'POST',
              headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1" }
            }
          }
        ).save({
          userSubscriptionId: { value: data.userId },
          /*UserSubscriptionId: {
          	value: {
          		href: ApiEndPoint.url + "restful/objects/simple.UserSubscription/" + data.userId
          	}
          },*/
          eventName: { value: data.eventName }
        });
      }

      function addRegistration(data) {
        return $resource(
          ApiEndPoint.url + 'restful/services/EventRegistrationRepository/actions/addEventRegistration/invoke', {}, {
            post: {
              method: 'POST',
              headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1" }
            }
          }
        ).save({
          //Event: {value: data.eventID},
          event: {
            value: {
              href: ApiEndPoint.url + "restful/objects/simple.Event/" + data.eventID
            }
          },
          name: { value: data.userName },
          email: { value: data.userMail },
          birthDate: { value: data.userBirth },
          phone: { value: data.userPhone },
          userSubscriptionId: { value: data.userSubscriptionId },
          comment: { value: data.comment }
        });
      }

      function findEventByUserSubscriptionID(userId) {
        return $resource(
          ApiEndPoint.url + 'restful/services/EventRepository/actions/findEventByUserSubscriptionId/invoke', {}, {
            get: {
              method: 'GET',
              isArray: true,
              headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1" }
            }
          }
        )
      }

      function existEventByUserSubscriptionIdAndEventName(userId) {
        return $resource(
          ApiEndPoint.url + 'restful/services/EventRepository/actions/existEventByUserSubscriptionIdAndEventName/invoke', {}, {
            get: {
              method: 'GET',
              headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1" }
            }
          }
        )
      }

      function findEventRegistrationByEventId(eventId) {
        return $resource(
          ApiEndPoint.url + 'restful/services/EventRegistrationRepository/actions/findEventRegistrationByEventId/invoke', {}, {
            get: {
              method: 'GET',
              isArray: true,
              headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1" }
            }
          }
        );
        /*.get({
        					"eventId	": '"' + eventId + '"'
        				})*/
      }

      //BALA SMS MESSAGE
      function getListWithPhoneNumbers(promoData) {
        return $resource(
          ApiEndPoint.url + 'restful/services/EventRegistrationRepository/actions/findAllEventRegistrationByEventId/invoke', {}, {
            get: {
              method: 'GET',
              isArray: true,
              headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1" }
            }
          }
        );
      }

      return {
        addEvent: addEvent,
        addRegistration: addRegistration,
        findEventByUserSubscriptionID: findEventByUserSubscriptionID,
        existEventByUserSubscriptionIdAndEventName: existEventByUserSubscriptionIdAndEventName,
        findEventRegistrationByEventId: findEventRegistrationByEventId,
        //BALA SMS MESSAGE
        getListWithPhoneNumbers: getListWithPhoneNumbers
      }
    }
  ]);
