"use strict";
appServices
  .factory('promosService', ['$rootScope', '$resource', "s3", "ApiEndPoint", 'UserService', 'notificationsService', 'permissionValidationService', 'Utils',
    function ($rootScope, $resource, s3, ApiEndPoint, UserService, notificationsService, permissionValidationService, Utils) {

      /**
       *
       *
       **/
      function addPromotion(data) {
        return $resource(
          ApiEndPoint.url + 'restful/services/PromotionRepository/actions/addPromotion/invoke',
          {},
          {
            post: {
              method: 'POST',
              headers: {"Accept": "application/json;profile=urn:org.apache.isis/v1"}
            }
          }).save({
          userSubscriptionId: {value: data.userId},
          promotionType: {value: data.typePromo},
          description: {value: data.descriptionPromo}
        });
      }

      //OmRo Token
      function addPromotionv200(data) {
        return $resource(
          ApiEndPoint.url + 'restful/services/PromotionRepository/actions/addPromotionv200/invoke',
          {},
          {
            post: {
              method: 'POST',
              headers: {"Accept": "application/json;profile=urn:org.apache.isis/v1"}
            }
          }).save({
          userSubscriptionId: {value: data.userId},
          promotionType: {value: data.typePromo},
          description: {value: data.descriptionPromo},
          tokens: {value: data.tokens}
        });
      }
      
      function redimTokens(data) {//OmRoToken
        return $resource(
          ApiEndPoint.url + 'restful/services/UserTransactionPromLogRepository/actions/redimTokens/invoke',
          {},
          {
            get: {
              method: 'GET',
              //isArray: true,
              headers: {"Accept": "application/json;profile=urn:org.apache.isis/v1"}
            }
          }
        ).get({
          userSubscriptionId: '"' + data.userSubscriptionId + '"',
          tokens: '"' + data.tokens + '"',
          userSubscriptionRedim: '"' + data.userSubscriptionRedim + '"'
        })
      }

      function addPromotionItems() {
        return $resource(
          ApiEndPoint.url + 'restful/services/PromotionItemRepository/actions/addPromotionItem/invoke',
          {},
          {
            post: {
              method: 'POST',
              headers: {'Accept': "application/json;profile=urn:org.apache.isis/v1"}
            }
          }
        );
      }

      function deletePromotion(objectId) {
        return $resource(
          ApiEndPoint.url + 'restful//objects/simple.Promotion/:objectId/actions/delete/invoke',
          objectId,
          {
            post: {
              method: 'POST',
              headers: {"Accept": "application/json;profile=urn:org.apache.isis/v1"}
            }
          }
        );
      }

      function deletePromotionItem(objectId) {
        return $resource(
          ApiEndPoint.url + 'restful//objects/simple.PromotionItem/:objectId/actions/delete/invoke',
          objectId,
          {
            post: {
              method: 'POST',
              headers: {"Accept": "application/json;profile=urn:org.apache.isis/v1"}
            }
          }
        );
      }

      function getPromotionsOfUser(userId) {
        return $resource(
          ApiEndPoint.url + 'restful/services/PromotionRepository/actions/findPromotionByUserSubscriptionId/invoke',
          {},
          {
            get: {
              method: 'GET',
              isArray: true,
              headers: {"Accept": "application/json;profile=urn:org.apache.isis/v1"}
            }
          }
        ).get({
          "userSubscriptionId": '"' + userId + '"'
        })
      }

      function getNumberScans(promoId) {
        return $resource(
          ApiEndPoint.url + 'restful/services/ScanPromotionRepository/actions/countScanPromotionByPromotionId/invoke',
          {},
          {
            get: {
              method: 'GET',
              headers: {"Accept": "application/json;profile=urn:org.apache.isis/v1"}
            }
          }
        ).get({
          "promotionId": '"' + promoId + '"'
        })
      }

      function getMediaAsignedPromo(promoData) {
        return $resource(
          ApiEndPoint.url + 'restful/services/PromotionItemRepository/actions/findPromotionItemByPromotionId/invoke',
          {},
          {
            get: {
              method: 'GET',
              isArray: true,
              headers: {"Accept": "application/json;profile=urn:org.apache.isis/v1"}
            }
          }
        ).get({
          "promotionId": '"' + promoData.id + '"',
          "withStart": '"' + promoData.start + '"',
          "withCount": '"' + promoData.count + '"'
        })
      }

			function getInfoUsersScans() {
				return $resource(
					ApiEndPoint.url + 'restful/services/ScanPromotionRepository/actions/findScanPromotionByPromotionId/invoke',
					{},
					{
						get: {
							method: 'GET',
              				isArray: true,
              				headers: {"Accept": "application/json;profile=urn:org.apache.isis/v1"}
						}
					}
				);
			}

      /**
       *
       * @param promoData {{promoInstanceId: number|string, userSubscriptionId:number|string}}
       * @return {*}
       */
      function increaseScannedPromotion(promoData) {
        return $resource(
          ApiEndPoint.url + 'restful/services/ScanPromotionRepository/actions/addScanPromotion/invoke',
          {},
          {
            get: {
              method: 'POST',
              headers: {"Accept": "application/json;profile=urn:org.apache.isis/v1"}
            }
          }
        ).get({
          promotion: {value: {href: ApiEndPoint.url + "restful/objects/simple.Promotion/" + promoData.promoInstanceId}},
          userSubscriptionId: {value: promoData.userSubscriptionId.toString()}
        })
      }

      /**
       *
       * @param promoId {number|string}
       * @return {*}
       */
      function getPromotionByPromotionId(promoId) {
        return $resource(
          ApiEndPoint.url + 'restful/services/PromotionRepository/actions/findPromotionByPromotionId/invoke',
          {},
          {
            get: {
              method: 'GET',
              isArray: true,
              headers: {"Accept": "application/json;profile=urn:org.apache.isis/v1"}
            }
          }
        ).get({
          promotionId: '"' + promoId + '"',
        })
      }

      /**
       *
       * @param promoData {{promoId: number|string, start?: number, count?: number}}
       * @return {*}
       */
      function getPromotionItemByPromotionId(promoData) {
        return $resource(
          ApiEndPoint.url + 'restful/services/PromotionItemRepository/actions/findPromotionItemByPromotionId/invoke',
          {},
          {
            get: {
              method: 'GET',
              isArray: true,
              headers: {"Accept": "application/json;profile=urn:org.apache.isis/v1"}
            }
          }
        ).get({
          promotionId: '"' + promoData.promoId + '"',
          withStart: '"' + (promoData.start ? promoData.start : 0) + '"',
          withCount: '"' + (promoData.count ? promoData.count : 0) + '"'
        })
      }

			return {
				addPromotion: addPromotion,
        addPromotionv200: addPromotionv200,//Token
        redimTokens: redimTokens,//Token
				addPromotionItems: addPromotionItems,
				deletePromotion: deletePromotion,
				deletePromotionItem: deletePromotionItem,
				getPromotionsOfUser: getPromotionsOfUser,
				getNumberScans: getNumberScans,
				getMediaAsignedPromo: getMediaAsignedPromo,
				getInfoUsersScans: getInfoUsersScans,
        increaseScannedPromotion: increaseScannedPromotion,
        getPromotionByPromotionId: getPromotionByPromotionId,
        getPromotionItemByPromotionId: getPromotionItemByPromotionId
			}
		}
	])
;
