// Ionic Starter App
// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js
"use strict";

var
  appServices = angular.module('Services', []),
  appControllers = angular.module('Controllers', []);

var appMainModule = angular.module('app', [
    'ionic',
    'app.controllers',
    'Controllers',
    'Services',
    'app.routes',
    'app.services',
    'app.filters',
    'app.directives',
    'ngOpenFB',
    'as.sortable',
    'ngCordova',
    //'angular-svg-round-progressbar',
    'ab-base64',
    'ionic.cloud',
    'ngSanitize',
    'angular-click-outside',
    'pascalprecht.translate',
    'angular-inview',
    'angular-md5',
    'ngMaterial',
    'ngMessages',
    'btford.socket-io',
    'toastr',
    'ngjsColorPicker', //source: http://prplv.me/ngjs-color-picker
    'ion-datetime-picker', //https://github.com/katemihalikova/ion-datetime-picker (NOTE: I modified the js to include callback to ok and cancel events)
    'jrCrop',
    'LocalForageModule' // new storage for data
  ])
  //agregar
  //constant for database use
  .value('userProfileData', { dataBaseUser: null })

  .config(function($ionicCloudProvider, $translateProvider, s3) {
    $ionicCloudProvider.init({
      "core": {
        "app_id": "a3e5d115"
      },
      "push": {
        "sender_id": 612637551458,
        "pluginConfig": {
          "ios": {
            "alert": true,
            "badge": true,
            "clearBadge": true,
            "sound": true
          },
          "android": {
            "icon": "push",
            "iconColor": "#E9004B",
            "clearBadge": true
          }
        }
      }
    });
    $translateProvider
      .useStaticFilesLoader({
        prefix: 'lang/locale-',
        suffix: '.json'
      })
      .registerAvailableLanguageKeys(['en', 'es'], {
        'en_*': 'en',
        'es_*': 'es'
      })
      .determinePreferredLanguage()
      .fallbackLanguage('en')
      .useSanitizeValueStrategy('escape');

    AWS.config.update({
      region: s3.region,
      accessKeyId: s3.accessKey,
      secretAccessKey: s3.secretKey,
      correctClockSkew: true,
    });
  })

  //For preventing elements (buttons, links) fire twice by using ngMaterial
  .config(function($mdGestureProvider) {
    $mdGestureProvider.skipClickHijack();
  })


  .config(function(toastrConfig) {
    //SOURCE: https://github.com/Foxandxss/angular-toastr#toastr-customization
    angular.extend(toastrConfig, {
      newestOnTop: true,
      positionClass: 'toast-bottom-center',
      preventDuplicates: false,
      preventOpenDuplicates: true,
      tapToDismiss: true
    });
  })

  .run(function($ionicPlatform, $rootScope, $state, $ionicPopup, $http, UserService, userProfileData, adsService, AWSServices, DBServices, GroupFactory, AppAdminRolesService, notificationsService, ChatFactory2, networkService, Utils, UserInterestService, ApiEndPoint, $location, Personalized, StreamingService, $anchorScroll, Push_Notif_Variables, legalURl) { //, GooglePersonalized
    //console.info("open App");
    //PRESERVAR LINEA SIGUIENTE DE ACUERDO A CADA RED
    $rootScope.HEADER_LOGO = '<div class="header-logo" align="center"><img class="title-image deviceMargin" src="img/LogoHeader.png" style="width: auto; height:37px; padding-top: 0px;"/> </div>';
    //DANGER DANGER DANGER DANGERDANGER DANGER DANGER DANGERDANGER DANGER DANGER DANGER
    $rootScope.IS_ONLINE = true; //we assume that user is online, later we'll get/set it's real state
      
    var firstTime = true;

    console.log("FUNCTION .RUN")
    $anchorScroll = angular.noop;

    GroupFactory.setCurrentGroupIndex(0); //default timeline :)

    //check JSON in external Web using temporal solution
    //https://my-json-server.typicode.com/
    checkPersonalizedFunctions("http://cqnz.rocks/personalized.json",
      function(err, data) {
        if (err != null) {
          console.error("FAIL CHECK JSON ", err);
        } else {
          console.log("CHECK JSON ", data);
          if (data.Apps[Personalized.nameApp]) {
            //The App is configured in server's side
            //first delete any remmants
            localStorage.removeItem('AppsPerzonalized'); //BALA ZONE TO SHOW/HIDE ACCESS TO APP
            var options = JSON.stringify(data.Apps[Personalized.nameApp]);
            localStorage.setItem('AppsPerzonalized', options);
            console.log(data.Apps[Personalized.nameApp]);
            //cordova.getAppVersion FOR FUTURE FUNCTION WITH VERSION
          } else {
            //The App is not configured in server's side
            console.error("DATA DOESN'T MATCH ", data.Apps[Personalized.nameApp]);
          }
        }
      }
    );
      
    setTimeout(function() {
        console.log("INSIDE TIMEOUT");
        configureFCM();
        $rootScope.PLATFORM_NAME = Utils.platformName();
        $rootScope.REFRESH_TEXT = Utils.translate('GLOBAL.REFRESH');
        $rootScope.IS_ONLINE = networkService.isOnline();
        $rootScope.NETWORK = {};
        $rootScope.MEDIA_PICKER = MediaPicker;
        $rootScope.branchUniversalObj = null;
        branchInit(4600);
        
        document.addEventListener("deviceready", function() {
            chkConnection();

            document.addEventListener("offline", gotOffLine, false);
            document.addEventListener("online", gotOnLine, false);
            document.addEventListener("resume", onResume);
            document.addEventListener("pause", onPause);
            initDatabase();
        });
        
        checkTextZoom();
        
        if (window.cordova && window.cordova.plugins.Keyboard) {
          cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false);
          cordova.plugins.Keyboard.disableScroll(false);
        } else {
          console.warn("keyboard plugin is not installed")
        }
        $ionicPlatform.registerBackButtonAction(function() {
          if ($state.current.name == "menu.timeline" || $state.current.name == "login" || $state.current.name == "standbyPage") {
            navigator.app.exitApp();
          } else if ($state.current.name == "menu.upload" || $state.current.name == "menu.discovery") {
            if (window.localStorage.getItem("openTutorial")) {
              var inTutorial = window.localStorage.getItem("openTutorial");
              if (inTutorial === "false") {
                window.history.go(-1);
              }
            }
          } else {
            window.history.go(-1);
          }
        }, 100);
        
        if (window.StatusBar) {
          StatusBar.styleDefault();
        }

        setTimeout(function() {
            console.log("timeout");
            //configureFCM();
          if (UserService.get_USER_INSTANCE_HREF()) {
            notificationsService.countPendingRegularNotifications(UserService.get_USER_INSTANCE_HREF());
            notificationsService.countPendingFollowersNotifications(UserService.get_USER_INSTANCE_HREF());
          }
        }, 3500);

        $rootScope.$on('$stateChangeStart', function(event, toState, toParams, fromState, fromParams, options) {

          if (UserService.get_USER_INSTANCE_HREF()) {
            if (!firstTime) {
              AppAdminRolesService.updateLocalUserPermissions();
              //avoid count new notifications before entering to notifications view
              if (toState.name.indexOf('menu.notificationTabs') === -1) {
                //I don't care for the Promise/number, just to broadcast it from inside the service
                notificationsService.countPendingRegularNotifications(UserService.get_USER_INSTANCE_HREF()).then(function(value) {}, function(error) {
                  firstTime = true
                });
                notificationsService.countPendingFollowersNotifications(UserService.get_USER_INSTANCE_HREF());
              }
            } else
              firstTime = false;
          }
        });
    }, 3000);

    $ionicPlatform.ready(function() {
        console.log("IONIC PLATFORM READY");
        configureFCM();
    });


    $rootScope.$on('logout.success', function() {
      Utils.clearCache();
      Utils.clearHistory();

      if (navigator.splashscreen) {
        navigator.splashscreen.show();
        Utils.$timeout(function() {
          location.reload();
        })
      } else {
        console.warn("no splashscreen plugin found")
      }
    });

    $rootScope.$on('login.success', function(ev, data) {
      Utils.clearCache();
      Utils.clearHistory();
      adsService.configure();

      //function to check for birthday
      var pivot = JSON.parse(window.localStorage.getItem('AppsPerzonalized'));
      if(!pivot.bypassApple) {
        checkUpdatedLegal();
      }
      Utils.$timeout(function() {
        $rootScope.$on('message.pending:loaded', function(ev, total) {
          console.log("----- Se han obtenido %s mensajes pendientes", total);
        });

        $rootScope.$on('message.historic:loaded', function(ev, total) {
          console.log("----- Se han obtenido %s mensajes del histórico", total);
        });

        var lastSubscriptionInstanceId = localStorage.getItem('lastSubscriptionInstanceId');
        var isSameUser = lastSubscriptionInstanceId && lastSubscriptionInstanceId === UserService.get_USERSUBSCRIPTIONINSTANCE_ID().toString();

        ChatFactory2.socket.connect(
          isSameUser,
          UserService.get_USERSUBSCRIPTIONINSTANCE_ID(),
          UserService.get_USER_NAME(),
          UserService.get_USER_PHOTO()
        ).then(function() {
          console.log("The chat is now connected");

          if (!isSameUser) {
            //console.log("--- Limpiando chats anteriores ya que es diferente user id (%d vs %d)", +lastSubscriptionInstanceId, UserService.get_USERSUBSCRIPTIONINSTANCE_ID())
            $rootScope.$broadcast('chat.messages.unread', { total: 0 });
            ChatFactory2.DB.cleanDB().then(function( /*booleanResp*/ ) {
              console.log("--- Obteniendo los mensajes anteriores ya que tienes diferente user id");
              ChatFactory2.socket.getHistoricMessages().then();
            }, function(error) {
              console.error("Couldn't clean Chat tables after login verification", error);
              //todo make something (better) with the error
              Utils.alert.show("No fue posible limpiar los mensajes anteriores en el chat", { title: "Error" })
            })
          } else {
            console.log("Chat: tienes el mismo id que el user anterior... nothing to do!");
          }

          //clean from remote DB the pending messages (sent by me) already delivered to receiver
          ChatFactory2.socket.cleanPendingMsgsRcvd(
            UserService.get_USERSUBSCRIPTIONINSTANCE_ID()
          ).then(function(readMsgList) {
            //console.log("readMsgList", readMsgList)
          }, function() {
            //Error printed out in factory
          });

          localStorage.setItem('lastSubscriptionInstanceId', UserService.get_USERSUBSCRIPTIONINSTANCE_ID().toString());
        }, function( /*error*/ ) {
          //Error printed out in factory
        });
      }, 800);
    });

    $rootScope.$on('cacheAndHistory.clear', function(event, group) {
      Utils.clearCache();
      Utils.clearHistory();
    });

    $rootScope.$on("$cordovaNetwork:online", function(ev, data) {
      $rootScope.IS_ONLINE = true;
      Utils.$timeout(function() {
        $rootScope.$apply();
      })
    });

    $rootScope.$on("$cordovaNetwork:offline", function(ev, data) {
      $rootScope.IS_ONLINE = false;
      Utils.$timeout(function() {
        $rootScope.$apply();
      })
    });

    var tries = 0;
    function configureFCM() {
      console.log("GOT INTO FCMPLUGINS")
      var isIOS = ionic.Platform.isIOS();
      if (typeof FCMPlugin == 'undefined') {
          Utils.$timeout(function() {
              tries++;
              console.error("TRY NO: ", tries);
              configureFCM();
          })
        /*Utils.toast.show(Utils.$filter('translate')('PLUGINS.FCM.PLUGIN_NOT_INSTALLED'), 5000);
        return;*/
      }

      if (isIOS === true) {
          if(FCMPlugin) {
              FCMPlugin.requestPushPermissionIOS(function(response) {
                  console.log("RES:", response);
                  if (window.ApnsToken) {
                    ApnsToken.getToken(function(token) {
                        if(token != 'null' || token != null)
                            window.localStorage.setItem('AWSToken', token);
                    }, function(error) {
                      console.log("can't get ios token");
                    })
                  }
              }, function (error) {
                  console.error("ERR: ", error);
              })
          } else {
              Utils.$timeout(function() {
                  configureFCM();
              }, 1000);
          }
      } else {
        FCMPlugin.getToken(function(token) {
          //console.log("firebaseToken => " + token);
          window.localStorage.setItem('AWSToken', token);
        }, function(error) {
          //alert("Couldn't get FCM token because: " +JSON.stringify(error));
          console.error("Couldn't get FCM token because: ", error);
        });
      }

      //code for handle PUSH NOTIFICATION
      FCMPlugin.onNotification(function(data) {
        console.log("Obtain something")
        var isIOS = ionic.Platform.isIOS();
        if (isIOS) {
          //IOS
          if (data.wasTapped) {
            //Notification was received on device tray and tapped by the user.
            console.log("El usuario hizo tap en la notificación (la app estaba cerrada/segundo plano)", data);
            if (data.data.title == 'Message') {
              //Zone to show notification about message
              var showMsg = data.data.name + Utils.$filter('translate')('PRIVATEMESSAGE.APPALERT_NEWMSG');
              Utils.toast.info(showMsg, 5000, "top");
            } else if (data.data.title == 'Notification') {
              console.log("Debo redirigir");
              Utils.$timeout(function() {
                if (data.data.param1) {
                  //temporaly we send the groupId empty because currently we don't use it in showNotification Page
                  console.log("id got: ", data.data.param1)
                  $state.go('showNotification', {
                    sequenceId: data.data.param1,
                    groupId: "",
                    fromWhere: $state.current.name,
                    groupIndex: 0
                  }, { reload: true });
                } else {
                  //when the sequence id is empty we redirect to notifications
                  //but if the type is about 
                  if (data.type == 'FOLLOW') {
                    $state.go('menu.notificationTabs.follwers', {}, { reload: true });
                  } else {
                    $state.go('menu.notificationTabs.regular', {}, { reload: true });
                  }
                }

              }, 10000);
            } else if (data.data.title == 'Exhibitor') {
              console.log("mandar a perfil de exhibidor")
              Utils.$timeout(function() {
                if (data.data.param1) {
                  //temporaly we send the groupId empty because currently we don't use it in showNotification Page
                  console.log("id got: ", data.data.param1)
                  if (UserService.get_USERSUBSCRIPTION_ID() && UserService.get_USERSUBSCRIPTIONINSTANCE_ID()) {
                    $state.go('friendProfile', { instanceId: data.data.param1 }, { reload: true });
                  } else {
                    var text = "The user " + data.data.param2 + " wants to contact you."
                    Utils.toast.info(text, 5000, "top");
                  }

                } else {

                }
              }, 10000);
              //Utils.toast.info(data., 5000, "top");
            } else if (data.data.title == 'Group') {
              console.log("checked wait for it");
              Utils.$timeout(function() {
                console.log("GO!!");
                $state.go('menu.groupsTabs.myGroups', {}, { reload: true });
              }, 10000);
            } else if (data.data.title == 'Global') {
              var text = data.data.param1;
              Utils.toast.info(text, 5000, "top");
            } else if (data.data.title == "LiveStreaming") {
              //LuMa 10-09-19 Live Streaming
              Utils.$timeout(function() {
                StreamingService.findStreamingByUserStreamingId(data.data.param2).$promise.then(function(response) {
                  var url;
                  var pivot = JSON.parse(window.localStorage.getItem('AppsPerzonalized'));
                  var isLiveStreaming = false; // LuMa Live Streaming Statistics
                  if (response != null && response.length > 0) {
                    var userStreaming = response[0];
                    if (userStreaming.status == 'Finished')
                      url = userStreaming.mp4Url;
                    else{
                      url = userStreaming.rmtpUrl;
                      isLiveStreaming = true; // LuMa Live Streaming Statistics
                    }
                    //IF HAVE URL WE SHOW IT
                      if (url != null) {
                        //IF STREAM WE SHOW BANNERS
                          $state.go('showStreaming', {
                            sequenceId: data.data.param3,
                            groupId: null,
                            fromWhere: $state.current.name,
                            groupIndex: 0
                          }, {reload: true});
                          /*StreamingService.getBannersForVideoOrStream().$promise.then(function(response) {
                            console.log("GOT: ", response)
                            //ADD ALL THE RESPONSES TO ARRAY
                              var urls = {};
                              response.forEach( function(url) {
                                urls[url.pictureId] = url.url;
                              })
                            //ADD ALL THE RESPONSES TO ARRAY END
                            //CALL PLUGIN TO SHOW VIDEO
                              var options = {
                                successCallback: function() {
                                  Utils.toast.info(Utils.translate('LIVE_STREAMING.END_STREAMING'));
                                  if(isLiveStreaming) { // LuMa Live Streaming Statistics
                                    StreamingService.incrementUserStreamingViewCount(Utils.getLastUrlComponent(data.data.param2)).$promise.then(
                                      function(resp) {
                                        console.log('Increment UserStreamingViewCount');
                                      }
                                    );
                                  }
                                },
                                errorCallback: function(errMsg) {
                                  Utils.toast.error(Utils.translate('SEQUENCE.DIALOG.STREAM_NOT_FOUND'));
                                  console.log('error:' + errMsg);
                                },
                                timeBetween: ""+pivot.timeForBanners,            
                                orientation: 'portrait',
                                shouldAutoClose: true, // true(default)/false
                                controls: true // true(default)/false. Used to hide controls on fullscreen
                              };
                              window.plugins.streamingMedia.playVideo(url, options, urls);
                            //CALL PLUGIN TO SHOW VIDEO END
                          }, function (error) {
                            console.error("fail findAllAdPictures");
                            //NOT GOT ANY BANNER, SHOW VIDEO ONLY
                              var options = {
                                successCallback: function() {
                                },
                                errorCallback: function(errMsg) {
                                  if(urlToUse.endsWith('m3u8')) {
                                    Utils.toast.error(Utils.translate('SEQUENCE.DIALOG.STREAM_NOT_FOUND'));
                                  } else {
                                    Utils.toast.error(Utils.translate('SEQUENCE.DIALOG.VIDEO_NOT_FOUND'));
                                  }
                                  console.log('error:' + errMsg);
                                },
                                timeBetween: "0",
                                orientation: 'portrait',
                                shouldAutoClose: true, // true(default)/false
                                controls: true // true(default)/false. Used to hide controls on fullscreen
                              };
                              window.plugins.streamingMedia.playVideo(url, options, null);
                            //NOT GOT ANY BANNER, SHOW VIDEO ONLY
                          });*/
                        //IF STREAM WE SHOW BANNERS END
                      }
                    //IF HAVE URL WE SHOW IT END
                  }
                });
              }, 10000);
            } else if (data.data.title === "To_Followers_Notification") {
              //notificacion a seguidores por posteo de X usuario
              console.log("Debo redirigir");
              Utils.$timeout(function() {
                if (data.data.param2) {
                  console.log("id got: ", data.data.param1)
                  $state.go('showNotification', {
                    sequenceId: data.data.param2,
                    groupId: data.data.param1,
                    fromWhere: $state.current.name,
                    groupIndex: 0
                  }, { reload: true });
                } else {
                  $state.go('menu.notificationTabs.regular', {}, { reload: true });
                }

              }, 10000);
            } else if (data.data.title === 'Group_Notification') {
              //notificacion a miembros de grupo por posteo de X usuario miembro
              console.log("Debo redirigir");
              Utils.$timeout(function() {
                if (data.data.param2 && data.data.param1 != 0) {
                  console.log("id got: ", data.data.param1)
                  $state.go('showNotification', {
                    sequenceId: data.data.param2,
                    groupId: data.data.param1,
                    fromWhere: $state.current.name,
                    groupIndex: 0
                  }, { reload: true });
                } else {
                  $state.go('menu.notificationTabs.regular', {}, { reload: true });
                }

              }, 10000);
            } else if (data.data.title === "Profile_Picture_Notification") {
              console.log("mandar al perfil del usuario para ver nueva foto");
              Utils.$timeout(function() {
                if (data.data.param1) {
                  //temporaly we send the groupId empty because currently we don't use it in showNotification Page
                  console.log("id got: ", data.data.param1)
                  if (UserService.get_USERSUBSCRIPTION_ID() && UserService.get_USERSUBSCRIPTIONINSTANCE_ID()) {
                    $state.go('friendProfile', { instanceId: data.data.param1 }, { reload: true });
                  }
                  /* else {
                    var text = "The user " + data.data.param2 + " wants to contact you."
                    Utils.toast.info(text, 5000, "top");    
                  }*/

                } else {
                  $state.go('menu.notificationTabs.regular', {}, { reload: true });
                }
              }, 10000);
            } else if (data.data.title === "Group_Cover_Notification") {
              Utils.$timeout(function() {
                if (data.data.param1) {
                  $state.go('menu.groupsTabs.myGroups', {}, { reload: true });
                } else {
                  $state.go('menu.notificationTabs.regular', {}, { reload: true });
                }

              }, 10000);
            } else if (data.data.title === "Accepted_Group_Notification") {
              Utils.$timeout(function() {
                if (data.data.param1) {
                  $state.go('menu.groupsTabs.myGroups', {}, { reload: true });
                } else {
                  $state.go('menu.notificationTabs.regular', {}, { reload: true });
                }

              }, 10000);
            } else if (data.data.title === "Liked_Commented_Post_Notification") {
              Utils.$timeout(function() {
                if (data.data.param2) {
                  console.log("id got: ", data.data.param1)
                  $state.go('showNotification', {
                    sequenceId: data.data.param2,
                    groupId: data.data.param1,
                    fromWhere: $state.current.name,
                    groupIndex: 0
                  }, { reload: true });
                } else {
                  $state.go('menu.notificationTabs.regular', {}, { reload: true });
                }

              }, 10000);
            } else if (data.data.title === "Liked_Liked_Post_Notification") {
              Utils.$timeout(function() {
                if (data.data.param2) {
                  console.log("id got: ", data.data.param1)
                  $state.go('showNotification', {
                    sequenceId: data.data.param2,
                    groupId: data.data.param1,
                    fromWhere: $state.current.name,
                    groupIndex: 0
                  }, { reload: true });
                } else {
                  $state.go('menu.notificationTabs.regular', {}, { reload: true });
                }

              }, 10000);
            } else if (data.data.title === "follow_user_Notification") {
              console.log("mandar al perfil del usuario para ver quien es el que dió follow");
              if (data.data.param2) {
                console.log("id got: ", data.data.param2)
                if (UserService.get_USERSUBSCRIPTION_ID() && UserService.get_USERSUBSCRIPTIONINSTANCE_ID()) {
                  $state.go('friendProfile', { instanceId: data.data.param2 }, { reload: true });
                }
              } else {
                $state.go('menu.notificationTabs.regular', {}, { reload: true });
              }
            } else if (data.data.title === "Accepted_User") {
              //check if the user is in the new page
              if ($state.current.name == "standbyPage") {
                Utils.$timeout(function() {
                  $state.go('menu.discovery', {}, { reload: true });
                }, 10000)
              }
            }
          } else {
            //Notification was received in foreground. Maybe the user needs to be notified.
            console.log("Got push while in App");
            if (data.data.title == 'Message') {
              var showMsg = data.name + Utils.$filter('translate')('PRIVATEMESSAGE.APPALERT_NEWMSG');
              Utils.toast.info(showMsg, 5000, "top");
            } else if (data.data.title == 'DeepLink') {
              $state.go('menu.notificationTabs.regular', {}, { reload: true });
            } else if (data.data.title == 'Global') {
              var text = data.data.param1;
              Utils.toast.info(text, 5000, "top");
            }
            //LuMa 10-09-19 Live Streaming 
            else if (data.data.title == "LiveStreaming") {
              Utils.toast.info(data.data.msg, 5000, "top");
            } else if (data.data.title === "Accepted_User") {
              //check if the user is in the new page
              if ($state.current.name == "standbyPage") {
                var showMsg = data.name + Utils.$filter('translate')('PRIVATEMESSAGE.APPALERT_NEWMSG');
                Utils.toast.info(showMsg, 5000, "top");
              }
            }
            //console.log("El usuario recibió la notificación con la app abierta", data);
          }
        } else {
          //ANDROID
          if (data.wasTapped) {
            //Notification was received on device tray and tapped by the user.
            console.log("El usuario hizo tap en la notificación (la app estaba cerrada/segundo plano)", data);
            if (data.title == 'Message') {
              //Zone to show notification about message
              var showMsg = data.name + Utils.$filter('translate')('PRIVATEMESSAGE.APPALERT_NEWMSG');
              Utils.toast.info(showMsg, 5000, "top");
            } else if (data.title === 'Notification') {
              console.log("Debo redirigir");
              Utils.$timeout(function() {
                if (data.param1) {
                  //temporaly we send the groupId empty because currently we don't use it in showNotification Page
                  console.log("id got: ", data.param1)
                  $state.go('showNotification', {
                    sequenceId: data.param1,
                    groupId: "",
                    fromWhere: $state.current.name,
                    groupIndex: 0
                  }, { reload: true });
                } else {
                  //when the sequence id is empty we redirect to notifications
                  //but if the type is about 
                  if (data.type == 'FOLLOW') {
                    $state.go('menu.notificationTabs.follwers', {}, { reload: true });
                  } else {
                    $state.go('menu.notificationTabs.regular', {}, { reload: true });
                  }
                }

              }, 5000);
            } else if (data.title === 'Exhibitor') {
              console.log("mandar a perfil de exhibidor")
              Utils.$timeout(function() {
                if (data.param1) {
                  //temporaly we send the groupId empty because currently we don't use it in showNotification Page
                  console.log("id got: ", data.param1)
                  if (UserService.get_USERSUBSCRIPTION_ID() && UserService.get_USERSUBSCRIPTIONINSTANCE_ID()) {
                    $state.go('friendProfile', { instanceId: data.param1 }, { reload: true });
                  } else {
                    var text = "The user " + data.param2 + " wants to contact you."
                    Utils.toast.info(text, 5000, "top");
                  }

                } else {

                }
              }, 5000);
              //Utils.toast.info(data., 5000, "top");
            } else if (data.title === 'Group') {
              console.log("checked wait for it");
              Utils.$timeout(function() {
                console.log("GO!!");
                $state.go('menu.groupsTabs.myGroups', {}, { reload: true });
              }, 5000);
            } else if (data.title === 'Global') {
              var text = data.param1;
              Utils.toast.info(text, 5000, "top");
            } else if (data.title === "To_Followers_Notification") {
              //notificacion a seguidores por posteo de X usuario
              console.log("Debo redirigir");
              Utils.$timeout(function() {
                if (data.param2) {
                  console.log("id got: ", data.param1)
                  $state.go('showNotification', {
                    sequenceId: data.param2,
                    groupId: data.param1,
                    fromWhere: $state.current.name,
                    groupIndex: 0
                  }, { reload: true });
                } else {
                  $state.go('menu.notificationTabs.regular', {}, { reload: true });
                }

              }, 5000);
            } else if (data.title === 'Group_Notification') {
              //notificacion a miembros de grupo por posteo de X usuario miembro
              console.log("Debo redirigir");
              Utils.$timeout(function() {
                if (data.param2 && data.param1 != 0) {
                  console.log("id got: ", data.param1)
                  $state.go('showNotification', {
                    sequenceId: data.param2,
                    groupId: data.param1,
                    fromWhere: $state.current.name,
                    groupIndex: 0
                  }, { reload: true });
                } else {
                  $state.go('menu.notificationTabs.regular', {}, { reload: true });
                }

              }, 5000);
            } else if (data.title === "Profile_Picture_Notification") {
              console.log("mandar al perfil del usuario para ver nueva foto");
              Utils.$timeout(function() {
                if (data.param1) {
                  //temporaly we send the groupId empty because currently we don't use it in showNotification Page
                  console.log("id got: ", data.param1)
                  if (UserService.get_USERSUBSCRIPTION_ID() && UserService.get_USERSUBSCRIPTIONINSTANCE_ID()) {
                    $state.go('friendProfile', { instanceId: data.param1 }, { reload: true });
                  }
                } else {
                  $state.go('menu.notificationTabs.regular', {}, { reload: true });
                }
              }, 5000);
            } else if (data.title === "Group_Cover_Notification") {
              Utils.$timeout(function() {
                if (data.param1) {
                  $state.go('menu.groupsTabs.myGroups', {}, { reload: true });
                } else {
                  $state.go('menu.notificationTabs.regular', {}, { reload: true });
                }

              }, 5000);
            } else if (data.title === "Accepted_Group_Notification") {
              Utils.$timeout(function() {
                if (data.param1) {
                  $state.go('menu.groupsTabs.myGroups', {}, { reload: true });
                } else {
                  $state.go('menu.notificationTabs.regular', {}, { reload: true });
                }

              }, 5000);
            } else if (data.title === "Liked_Commented_Post_Notification") {
              Utils.$timeout(function() {
                if (data.param2) {
                  console.log("id got: ", data.param1)
                  $state.go('showNotification', {
                    sequenceId: data.param2,
                    groupId: data.param1,
                    fromWhere: $state.current.name,
                    groupIndex: 0
                  }, { reload: true });
                } else {
                  $state.go('menu.notificationTabs.regular', {}, { reload: true });
                }

              }, 5000);
            } else if (data.title === "Liked_Liked_Post_Notification") {
              Utils.$timeout(function() {
                if (data.param2) {
                  console.log("id got: ", data.param1)
                  $state.go('showNotification', {
                    sequenceId: data.param2,
                    groupId: data.param1,
                    fromWhere: $state.current.name,
                    groupIndex: 0
                  }, { reload: true });
                } else {
                  $state.go('menu.notificationTabs.regular', {}, { reload: true });
                }

              }, 5000);
            } else if (data.title === "follow_user_Notification") {
              console.log("mandar al perfil del usuario para ver quien es el que dió follow");
              if (data.param2) {
                console.log("id got: ", data.param2)
                if (UserService.get_USERSUBSCRIPTION_ID() && UserService.get_USERSUBSCRIPTIONINSTANCE_ID()) {
                  $state.go('friendProfile', { instanceId: data.param2 }, { reload: true });
                }
              } else {
                $state.go('menu.notificationTabs.regular', {}, { reload: true });
              }
            } else if (data.title === "LiveStreaming") {
              //LuMa 10-09-19 Live Streaming
              Utils.$timeout(function() {
                StreamingService.findStreamingByUserStreamingId(data.param2).$promise.then(function(response) {
                  var url;
                  var pivot = JSON.parse(window.localStorage.getItem('AppsPerzonalized'));
                  var isLiveStreaming = false; // LuMa Live Streaming Statistics
                  if (response != null && response.length > 0) {
                    var userStreaming = response[0];
                    if (userStreaming.status == 'Finished')
                      url = userStreaming.mp4Url;
                    else{
                      url = userStreaming.rmtpUrl;
                      isLiveStreaming = true; // LuMa Live Streaming Statistics
                    }
                    //IF HAVE URL WE SHOW IT
                      if (url != null) {
                        //IF STREAM WE SHOW BANNERS
                          $state.go('showStreaming', {
                            sequenceId: data.param3,
                            groupId: null,
                            fromWhere: $state.current.name,
                            groupIndex: 0
                          }, {reload: true});
                          /*StreamingService.getBannersForVideoOrStream().$promise.then(function(response) {
                            console.log("GOT: ", response)
                            //ADD ALL THE RESPONSES TO ARRAY
                              var urls = {};
                              response.forEach( function(url) {
                                urls[url.pictureId] = url.url;
                              })
                            //ADD ALL THE RESPONSES TO ARRAY END
                            //CALL PLUGIN TO SHOW VIDEO
                              var options = {
                                successCallback: function() {
                                  Utils.toast.info(Utils.translate('LIVE_STREAMING.END_STREAMING'));
                                  if(isLiveStreaming) { // LuMa Live Streaming Statistics
                                    StreamingService.incrementUserStreamingViewCount(Utils.getLastUrlComponent(data.data.param2)).$promise.then(
                                      function(resp) {
                                        console.log('Increment UserStreamingViewCount');
                                      }
                                    );
                                  }
                                },
                                errorCallback: function(errMsg) {
                                  Utils.toast.error(Utils.translate('SEQUENCE.DIALOG.STREAM_NOT_FOUND'));
                                  console.log('error:' + errMsg);
                                },
                                timeBetween: ""+pivot.timeForBanners,            
                                orientation: 'portrait',
                                shouldAutoClose: true, // true(default)/false
                                controls: true // true(default)/false. Used to hide controls on fullscreen
                              };
                              window.plugins.streamingMedia.playVideo(url, options, urls);
                            //CALL PLUGIN TO SHOW VIDEO END
                          }, function (error) {
                            console.error("fail findAllAdPictures");
                            //NOT GOT ANY BANNER, SHOW VIDEO ONLY
                              var options = {
                                successCallback: function() {
                                },
                                errorCallback: function(errMsg) {
                                  if(urlToUse.endsWith('m3u8')) {
                                    Utils.toast.error(Utils.translate('SEQUENCE.DIALOG.STREAM_NOT_FOUND'));
                                  } else {
                                    Utils.toast.error(Utils.translate('SEQUENCE.DIALOG.VIDEO_NOT_FOUND'));
                                  }
                                  console.log('error:' + errMsg);
                                },
                                timeBetween: "0",
                                orientation: 'portrait',
                                shouldAutoClose: true, // true(default)/false
                                controls: true // true(default)/false. Used to hide controls on fullscreen
                              };
                              window.plugins.streamingMedia.playVideo(url, options, null);
                            //NOT GOT ANY BANNER, SHOW VIDEO ONLY
                          });*/
                        //IF STREAM WE SHOW BANNERS END
                      }
                    //IF HAVE URL WE SHOW IT END
                  }
                });
              }, 10000);
            } else if (data.title === "Accepted_User") {
              //check if the user is in the new page
              if ($state.current.name == "standbyPage") {
                Utils.$timeout(function() {
                  $state.go('menu.discovery', {}, { reload: true });
                }, 10000)
              }
            }
          } else {
            //Notification was received in foreground. Maybe the user needs to be notified.
            console.log("Got push while in App");
            if (data.title == 'Message') {
              var showMsg = data.name + Utils.$filter('translate')('PRIVATEMESSAGE.APPALERT_NEWMSG');
              Utils.toast.info(showMsg, 5000, "top");
            } else if (data.title == 'DeepLink') {
              $state.go('menu.notificationTabs.regular', {}, { reload: true });
            } else if (data.title == 'Global') {
              var text = data.param1;
              Utils.toast.info(text, 5000, "top");
            }
            //LuMa 10-09-19 Live Streaming 
            else if (data.title == "LiveStreaming") {
              Utils.toast.info(data.msg, 5000, "top");
            } else if (data.title === "Accepted_User") {
              //check if the user is in the new page
              if ($state.current.name == "standbyPage") {
                var showMsg = data.name + Utils.$filter('translate')('PRIVATEMESSAGE.APPALERT_NEWMSG');
                Utils.toast.info(showMsg, 5000, "top");
              }
            }
            //console.log("El usuario recibió la notificación con la app abierta", data);
          }
        }
      }, function(data) {
        //parece que no se activa esta función...
      }, function(error) {
        //alert("On notification error" + JSON.stringify(error));
        console.log("On notification error")
      });

      FCMPlugin.onNotificationReceived(function(data) {
        console.log("onNotificationReceived")
      });
    }

    function parseVersionNumber(version) {
      var versionArray = version.split('.');

      for (var i = 0; i < 3; i++) {
        versionArray[i] = addZeros(versionArray[i], 3);
      }

      return parseInt(versionArray.join(''));
    }

    function addZeros(str, max) {
      str = str.toString();
      return str.length < max ? addZeros("0" + str, max) : str;
    }

    function onPause() {
      console.log("app in background");
    }

    function onResume() {
      setTimeout(function() {
        console.log("resume app");
        branchInit(1000);
        //ULsuscribe(5000,'RESUME');
      }, 0);

    }

    function branchInit(timer) {
      if (!window.Branch) {
        Utils.toast.error(Utils.translate("PLUGINS.BRANCH.PLUGIN_NOT_INSTALLED"));
        return;
      }
      //debug use
      //Branch.setDebug(true);
      // Branch initialization $rootScope.branchUniversalObj
      if (ionic.Platform.isIOS()) {
        Branch.initSession().then(function(data) {

          console.log("get initSession" + JSON.stringify(data));

          if (data['+clicked_branch_link']) {
            console.log("clicked on deeplink");
            if (data.typeShare === "App") {
              //share the app
              //do nothing for the moment
            } else if (data.typeShare === "Post") {
              //share a post
              Utils.$timeout(function() {
                if (data.id) {
                  //temporaly we send the groupId empty because currently we don't use it in showNotification Page
                  console.log("id got: ", data.id)
                  $state.go('showNotification', {
                    sequenceId: data.id,
                    groupId: data.groupId,
                    fromWhere: $state.current.name,
                    groupIndex: 0
                  }, { reload: true });
                } else {
                  //when the sequence id is empty we redirect to notifications
                  $state.go('menu.notificationTabs.regular', {}, { reload: true });
                }

              }, timer);
            }
          } else {
            console.log("other access");
          }

        }, function(err) {

        })
      } else {
        Branch.initSession().then(function(data) {

          console.log("get initSession" + JSON.stringify(data));

          if (data['+clicked_branch_link']) {
            console.log("clicked on deeplink");
            if (data.typeShare === "App") {
              //share the app
              //do nothing for the moment
            } else if (data.typeShare === "Post") {
              //share a post
              Utils.$timeout(function() {
                if (data.id) {
                  //temporaly we send the groupId empty because currently we don't use it in showNotification Page
                  console.log("id got: ", data.id)
                  $state.go('showNotification', {
                    sequenceId: data.id,
                    groupId: data.groupId,
                    fromWhere: $state.current.name
                  }, { reload: true });
                } else {
                  //when the sequence id is empty we redirect to notifications
                  $state.go('menu.notificationTabs.regular', {}, { reload: true });
                }

              }, timer);
            }
          } else {
            console.log("other access");
          }

        }, function(err) {

        })
      }
    }

    if (window.localStorage.getItem > 3) {
      if (window.localStorage.getItem('AWSToken') && (window.localStorage.getItem('AWSToken') != '(null)')) {
        AWSServices.awsInit();
      } else {
        //$ionicPlatform.ready(function() {
          var isIOS = ionic.Platform.isIOS();
          if (isIOS === true) {
            /*FCMPlugin.requestPushPermissionIOS(function(response) {
                console.log("RES:", response);
                if (window.ApnsToken) {
                  ApnsToken.getToken(function(token) {
                    window.localStorage.setItem('AWSToken', token);
                    if (typeof FCMPlugin != 'undefined') {
                      AWSServices.awsInit();
                    }
                  }, function(error) {
                    console.log("can't get ios token");
                  })
                }
            }, function (error) {
                console.error("ERR: ", error);
            })*/
          } else {
            if (typeof FCMPlugin != 'undefined') {
              FCMPlugin.getToken(function(token) {
                window.localStorage.setItem('AWSToken', token);
                AWSServices.awsInit();
              }, function error(response) {
                console.error("couldn't get FCM token because: ", response);
              })
            }
          }
        //})
      }

      //Load push configuration if needed
      if (window.localStorage.getItem('pushNotificationsConfig') === null) {
        UserService.getPushNotificationsConfig({
          objectId: window.localStorage.getItem('userSubscriptionInstanceId')
        }).get().$promise.then(function success(response) {
          var config = [];
          response.forEach(function(item) {
            var textForShow = "";
            switch (item.notificationType) {
              case 1:
                textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.NEW_FOLLOWERS");
                break;
                /*case 2:
                  textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.NEW_FOLLOWERS");
                break;*/
                /*case 3:
                  textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.NEW_FOLLOWERS");
                break;*/
              case 4:
                textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.REACTS");
                break;
              case 5:
                textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.LIKES");
                break;
              case 6:
                textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.COMMENTS");
                break;
              case 7:
                textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.TAGGING");
                break;
                /*case 8:
                  textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.NEW_FOLLOWERS");
                break;*/
              case 9:
                textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.LIKE_COMMENT");
                break;
              case 10:
                textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.DELETED_GROUP");
                break;
              case 11:
                textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.JOIN_GROUP");
                break;
              case 12:
                textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.ACCEPTED_GROUP");
                break;
              case 13:
                textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.FRIEND_POST_NEW");
                break;
              case 14:
                textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.NEW_POST_GROUP");
                break;
              case 15:
                textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.NEW_PROFILE_PHOTO");
                break;
              case 16:
                textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.NEW_GROUP_COVER");
                break;
              case 17:
                textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.LIKED_POST_COMMENTED");
                break;
              case 18:
                textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.COMMENTED_POST_COMMENTED");
                break;
              case 19:
                textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.LIKED_POST_LIKED");
                break;
              case 20:
                textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.STREAM_NOTIFICATIONS");
                break;
            }
            config.push({
              instanceId: +Utils.getLastUrlComponent(item.configureUserNotification.href),
              notificationType: item.notificationType,
              sendNotification: item.sendNotification,
              textForShow: textForShow
            });
          });

          window.localStorage.setItem('pushNotificationsConfig', JSON.stringify(config));
        }, function error(response) {
          console.error("UserService.addDevice error: ", response);
        });
      }

      $state.go('menu.timeline', {}, { reload: true });
    }

    function initDatabase() {
      console.log("init DB");
      DBServices.init().then(function(dbInstance) {
        $rootScope.$broadcast('DatabaseReady');
        console.log("DBready");
        ChatFactory2.DB.countAllUnreadMessages().then();

        Utils.$timeout(function() {
          if (navigator.splashscreen) {
            //console.log("Hidding splash");
            navigator.splashscreen.hide();
          } else
            console.log("Can't hide splash :(");
        }, 1000);

        var myUsername = window.localStorage.getItem("name");
        if (myUsername) {
          //when created or check if exits, check if have any data inside with the user stored in LS
          var querySelect = "SELECT * FROM userLogCount WHERE name = ?";
          DBServices.execute(querySelect, [myUsername]).then(
            /**@param {dbResponseType} dbResponse*/
            function(dbResponse) {
              //send to get tutorial status
              if (dbResponse.rows.length > 0) {
                addLoginCount(dbResponse.rows.item(0).count, myUsername);
              } else {
                firstLogin();
              }
            },
            function(error) {
              console.error("User login's count error:", error);
            });
        } else {
          console.log("No username found in LS");
          checkTutorialStatus();
        }
      }, function(error) {
        Utils.alert.show("Chat DB not loaded due to<br/>" + error);
        firstLogin();
      });
    }

    function addLoginCount(countLogs, nameUser) {
      countLogs++;

      var querySelect = "UPDATE userLogCount SET count = ? WHERE name = ?";
      DBServices.execute(querySelect, [countLogs, nameUser]).then(function(value) {
        checkTutorialStatus();
      }, function(error) {
        console.error("Update user login's count error:", error);
      })
    }

    function firstLogin() {
      var querySelect = "INSERT INTO userLogCount (name, count) VALUES (?,?)";
      DBServices.execute(querySelect, [window.localStorage.getItem("name"), 1]).then(function(value) {
        checkTutorialStatus();
      }, function(error) {
        console.error("INSERT error: " + error);
      })
    }

    function checkTutorialStatus() {
      var listOfTutorials = ["discovery", "upload", "timelineOrganize", "favorites"];
      if (window.localStorage.getItem("name")) {
        for (var x = 0; x < listOfTutorials.length; x++) {
          checkBaseData(listOfTutorials[x]);
        }
      }
    }

    function checkBaseData(name) {
      var querySelect = "SELECT name, visited FROM tutorials WHERE name = ?";
      DBServices.execute(querySelect, [name]).then(function(resultSet) {
        //var visitedJson = JSON.parse(resultSet.rows.item(0).visited);
        if (resultSet.rows.length > 0) {
          //console.log("Tutorial "+resultSet.rows.item(0).name+" visto: "+ visitedJson);
        } else {
          addBaseData(name);
        }
      }, function(error) {
        console.error('SELECT error in: ' + error.message);
      })
    }

    function addBaseData(name) {
      var statusJson = [];
      if (name === "timelineOrganize") {
        statusJson = {
          first: true
        }
      } else {
        statusJson = {
          first: true,
          second: true
        }
      }
      if (window.localStorage.getItem("firstTimeUser")) {
        var x = JSON.parse(window.localStorage.getItem("firstTimeUser"));
        if (name in x) {
          statusJson = x[name];
        }
      }

      var querySelect = "INSERT INTO tutorials (name, visited) VALUES (?,?)";
      DBServices.execute(querySelect, [name, JSON.stringify(statusJson)]).then(function(value) {

      }, function(error) {
        console.error("INSERT error: " + error.message);
      })
    }

    function checkTextZoom() {
      var isIOS = ionic.Platform.isIOS();
      if (isIOS) {
        console.log("ios doesn't need this")
      } else {
        if (MobileAccessibility) {
          console.log("plugin detected");
          MobileAccessibility.usePreferredTextZoom(false);
        } else {
          console.log("not plugin for zoom detected");
        }
      }
    }

    //ZONE FOR ASKING USER INFO
      //ASK TO VIEW LEGALS AGAIN CONTROLLED BY PERSONALIZED JSON
      function checkUpdatedLegal() {
        var pivot = JSON.parse(window.localStorage.getItem('AppsPerzonalized'));
        var actualLegal = JSON.parse(window.localStorage.getItem('legalVer'));
        if (pivot.updatedTermsCondi) {
          //CHECK WITH WS IF THE VERSION OF THE USER IS EQUAL
          if (pivot.legalVer > actualLegal) {
            //show again terms/condition page
            Utils.modal.show({
              templateUrl: 'templates/partials/updatedLegals.html',
              locals: {
                verLegal: pivot.legalVer
              },
              controller: function($scope, $mdDialog, locals, Utils, $window) {
                $scope.data = {
                  Accepted: false,
                  verLegal: locals.verLegal
                };
                var lang = $window.navigator.languages ?
                  $window.navigator.languages[0] :
                  ($window.navigator.language || $window.navigator.userLanguage);

                $scope.english= false;
                if(lang.includes("es-")) {
                  $scope.english= false;
                } else {
                  $scope.english= true;
                }
                $scope.AppName = Push_Notif_Variables.title;
                $scope.okButton = Utils.translate('GLOBAL.OK');
                $scope.ok = function() {
                  $mdDialog.hide($scope.data)
                };

                $scope.redirectPolitics = function() {
                  var isIOS = ionic.Platform.isIOS();
                  var zone = '_blank';
                  var opt = '';
                  if(isIOS){
                    zone = '_blank';
                    opt = 'clearsessioncache=yes,usewkwebview=yes,toolbar=yes,presentationstyle=fullscreen,hidespinner=yes,closebuttoncaption=Close,closebuttoncolor=#ffffff4,navigationbuttoncolor=#ffffff,lefttoright=yes,location=no';
                  }
                  else{
                    zone ='_blank';
                    opt = 'clearsessioncache=yes,usewkwebview=yes,toolbar=yes,presentationstyle=fullscreen,hidespinner=yes,closebuttoncaptionSet=Close,closeButtonColorSet=#ffffff4,navigationbuttoncolorSet=#ffffff,lefttoright=yes,location=no';
                  }
                  if (lang.includes("es")) {
                    var ref = cordova.InAppBrowser.open( 'https://niido.cloud/'+ legalURl.app +'/politicaprivacidad.html', zone, opt);
                  } else if (lang.includes("en")) {
                    var ref = cordova.InAppBrowser.open( 'https://niido.cloud/'+ legalURl.app +'/privacypolicy.html', zone, opt);
                  }
                }

                $scope.redirectTerms = function() {
                  var isIOS = ionic.Platform.isIOS();
                  var zone = '_blank';
                  var opt = '';
                  if(isIOS){
                    zone = '_blank';
                    opt = 'clearsessioncache=yes,usewkwebview=yes,toolbar=yes,presentationstyle=fullscreen,hidespinner=yes,closebuttoncaption=Close,closebuttoncolor=#ffffff4,navigationbuttoncolor=#ffffff,lefttoright=yes,location=no';
                  }
                  else{
                    zone ='_blank';
                    opt = 'clearsessioncache=yes,usewkwebview=yes,toolbar=yes,presentationstyle=fullscreen,hidespinner=yes,closebuttoncaptionSet=Close,closeButtonColorSet=#ffffff4,navigationbuttoncolorSet=#ffffff,lefttoright=yes,location=no';
                  }
                  if (lang.includes("es")) {
                      var ref = cordova.InAppBrowser.open( 'https://niido.cloud/'+ legalURl.app +'/terminosycondiciones.html', zone, opt);
                  } else if (lang.includes("en")) {
                    var ref = cordova.InAppBrowser.open( 'https://niido.cloud/'+ legalURl.app +'/termsandconditions.html', zone, opt);
                  }
                }
              }
            }).then(function(data) {
              //window.localStorage.setItem('legalVer', pivot.legalVer);
              //call new WS to update user legal Version
              UserService.updateLegalUserVersion({
                objectId: window.localStorage.getItem("userSubscriptionInstanceId")
              }).save({
                int: { value: data.verLegal }
              }, function(ret) {
                window.localStorage.setItem('legalVer', pivot.legalVer);
              }, function(err) {
                console.error("can't save legal");
              })
              askBirthday();
            })
          } else {
            //call the Birthday
            askBirthday();
          }
        } else {
          //call the Birthday
          askBirthday();
        }
      }

      //ASK IF BIRTHDAY // IF NEEDED 
      function askBirthday() {
        var haveBirthday = false;
        var haveInterests = false;
        UserService.findUsersBirthDate({
          objectId: window.localStorage.getItem('simpleUserId')
        }).$promise.then(
          function(response) {
            //after get the data we'll check if the user have any date saved if not we'll show a calendar to force it
            console.log("got", response);
            if (response.result != null) {
              var realDate = new Date(response.result.value).toISOString();
              console.log(realDate);
              var realBirthday = realDate.split('T')[0];
              window.localStorage.setItem('birthDate', realBirthday);
              haveBirthday = true;
            } else {
              //here we show the modal
              haveBirthday = false;
              var userData = {};
              Utils.modal.show({
                templateUrl: 'templates/askBirthDateForm.html',
                locals: {
                  userData: userData
                },
                controller: function($scope, $mdDialog, locals) {
                  $scope.data = {
                    selectedDay: 0,
                    selectedMonth: 0,
                    selectedYear: 0,
                    showDay: false,
                    showYear: false,
                    dayList: [],
                    monthList: [],
                    yearList: [],
                    addedBirth: false,
                    errorBirthday: false,
                    finalDate: null
                  };

                  //$scope.data.birthday = new Date();

                  $scope.initDates = function() {
                    //PREPARE MONTH
                    $scope.data.monthList.push({
                      id: 1,
                      text: Utils.translate("BIRTHDAY_INFO.MONTH_LIST.01")
                    })

                    for (var i = 2010; i >= 1920; i--) {
                      $scope.data.yearList.push({
                        id: i,
                        text: "" + i
                      })
                    }
                    $scope.data.selectedMonth = $scope.data.monthList[0];
                    $scope.data.selectedYear = $scope.data.yearList[0];
                    $scope.data.selectedDay = $scope.data.dayList[0];
                  }
                  $scope.initDates();

                  $scope.selectMonth = function(month) {
                    console.log("month", month);
                    if (month.id === 0) {
                      //not 
                      $scope.data.showDay = false;
                      $scope.data.dayList = [];
                    } else {
                      $scope.data.showDay = true;
                      if (month.id === 2) {
                        $scope.data.dayList = [];
                        $scope.prepareDays(28);
                      } else if (month.id === 1 || month.id === 3 || month.id === 5 || month.id === 7 || month.id === 8 || month.id === 10 || month.id === 12) {
                        //31
                        $scope.data.dayList = [];
                        $scope.prepareDays(31);
                      } else {
                        //30
                        $scope.data.dayList = [];
                        $scope.prepareDays(30);
                      }
                    }
                  }

                  $scope.prepareDays = function(days) {
                    $scope.data.dayList.push({
                      id: 0,
                      text: Utils.translate("BIRTHDAY_INFO.DAY_LIST.00")
                    })
                    for (var i = 1; i <= days; i++) {
                      $scope.data.dayList.push({
                        id: i,
                        text: "" + i
                      })
                    }
                    $scope.data.selectedDay = $scope.data.dayList[0];
                  }

                  $scope.selectDay = function(day) {
                    console.log("day", day);
                  }

                  $scope.getDate = function(date) {
                    $scope.data.addedBirth = true;
                  }

                  $scope.ok = function() {
                    var realYear = $scope.data.selectedYear.text;

                    //CLOSE MODAL
                    $scope.data.finalDate = realYear + "-01-01";
                    $mdDialog.hide($scope.data);
                  };

                  $scope.cancel = function() {
                    $mdDialog.cancel();
                    setTimeout(function() {
                      askInterests();
                    }, 1000);
                  };
                }
              }).then(function(data) {
                if (data.finalDate) {
                  UserService.updateBirthDay({
                    objectId: UserService.get_SIMPLEUSERINSTANCE_ID()
                  }).post({
                    "birthDate": {
                      "value": data.finalDate
                    }
                  }).$promise.then(function(response) {
                    window.localStorage.setItem('birthDate', data.finalDate);
                  }, function(error) {
                  })
                }
                askInterests();
              })
            }
          },
          function(err) {
            console.error("nothing to show")
          }).finally(function() {
          if (haveBirthday) {
            console.log("AFTER BIRTHDAY ask for INTERESTS");
            askInterests();
          } else {
            console.log("THE BIRTHDAY POP UP IS SHOW, WAIT")
          }
        })
      }

      //ASK INTERESTS // IF NEEDED
      function askInterests() {
        UserInterestService.findInterestByUserSubscriptionId({
          userSubscriptionid: UserService.get_USERSUBSCRIPTION_ID()
        }).$promise.then(
          function(response) {
            console.log("got", response);
            if (response.length === 1) {
              var InteData = {};
              Utils.modal.show({
                templateUrl: 'templates/askInterests.html',
                locals: {
                  InteData: InteData
                },
                controller: function($scope, $mdDialog, locals, Utils) {
                  $scope.data = {};
                  $scope.data.interestsListed = [];
                  $scope.data.selectedInterest = [];
                  $scope.data.showNewInterest = false;
                  $scope.data.interest = "";
                  $scope.data.errorInterest = false;

                  $scope.getInterestsList = function() {
                    UserInterestService.findAllInterests().$promise.then(function(respInt) {
                      console.log("got", respInt);
                      for (var i = 0; i < 10; i++) {
                        var realId = respInt.result.value[i].href.split('/')[6];
                        var realHref = respInt.result.value[i].href;
                        var optText = "";
                        if (realId === "10")
                          optText = "INTERESTS_INFO.LIST.INT_10";
                        else
                          optText = "INTERESTS_INFO.LIST.INT_0" + realId;

                        $scope.data.interestsListed.push({
                          id: realId,
                          texts: Utils.translate(optText),
                          href: realHref,
                          selected: false
                        })
                      }
                      $scope.data.interestsListed.push({
                        id: "0",
                        texts: Utils.translate('INTERESTS_INFO.LIST.INT_EXTRA'),
                        href: null,
                        selected: false
                      })
                      console.log("maked", $scope.data.interestsListed);
                    });
                  }
                  $scope.getInterestsList();

                  $scope.toggleInterest = function(item) {
                    console.log("clicked", item);
                    //check previous state
                    if (!item.selected) {
                      $scope.data.selectedInterest.push(item);
                      if (item.id === "0") {
                        $scope.data.showNewInterest = true;
                      }
                      item.selected = true;
                    } else {
                      var index = $scope.data.selectedInterest.indexOf(item);
                      $scope.data.selectedInterest.splice(index, 1);
                      if (item.id === "0") {
                        $scope.data.showNewInterest = false;
                      }
                      item.selected = false;
                    }
                  }

                  $scope.ok = function() {
                    if ($scope.data.showNewInterest) {
                      if ($scope.data.interest === '' || $scope.data.interest === ' ' || $scope.data.interest === null) {
                        $scope.data.errorInterest = true;
                      } else {
                        $mdDialog.hide($scope.data);
                      }
                    } else {
                      if ($scope.data.selectedInterest.length === 0) {
                        $scope.data.errorInterest = true;
                      } else {
                        $mdDialog.hide($scope.data);
                      }
                    }
                  };

                  $scope.cancel = function() {
                    $mdDialog.cancel();
                  };
                }
              }).then(function(data) {
                var finalList = [];
                if (data.showNewInterest) {
                  UserInterestService.addNewInteresttoList().save({
                    interest: {
                      value: data.interest
                    }
                  }).$promise.then(function(ansResponse) {
                    var addPromises = {};
                    for (var i = 0; i < data.selectedInterest.length; i++) {
                      var realVal = data.selectedInterest[i];

                      if (realVal.id === "0") {
                        addPromises[i] = UserInterestService.addInterestToUser().save({
                          userSubscriptionId: {
                            value: "" + UserService.get_USERSUBSCRIPTION_ID()
                          },
                          interest: {
                            value: { //"http://ladymultitask-env-des.niido.cloud/restful/objects/simple.Interest/15"
                              href: ApiEndPoint.url + "restful/objects/simple.Interest/" + ansResponse.result.instanceId
                            }
                          }
                        }).$promise;
                        finalList.push(data.interest);
                      } else {
                        addPromises[i] = UserInterestService.addInterestToUser().save({
                          userSubscriptionId: {
                            value: "" + UserService.get_USERSUBSCRIPTION_ID()
                          },
                          interest: {
                            value: { //"http://ladymultitask-env-des.niido.cloud/restful/objects/simple.Interest/15"
                              href: realVal.href
                            }
                          }
                        }).$promise;
                        finalList.push(realVal.texts);
                      }

                    }

                    Utils.$q.all(addPromises).then(function(allAddGood) {
                      console.log("yes", allAddGood);
                      window.localStorage.setItem('userInterest', finalList);
                    }, function(allAddFail) {
                      console.log("yes", allAddFail);
                    })
                  })
                } else {
                  var addPromises = {};
                  for (var i = 0; i < data.selectedInterest.length; i++) {
                    var realVal = data.selectedInterest[i];

                    addPromises[i] = UserInterestService.addInterestToUser().save({
                      userSubscriptionId: {
                        value: "" + UserService.get_USERSUBSCRIPTION_ID()
                      },
                      interest: {
                        value: { //"http://ladymultitask-env-des.niido.cloud/restful/objects/simple.Interest/15"
                          href: realVal.href
                        }
                      }
                    }).$promise;
                    finalList.push(realVal.texts);
                  }

                  Utils.$q.all(addPromises).then(function(allAddGood) {
                    console.log("yes", allAddGood);
                    window.localStorage.setItem('userInterest', finalList);
                  }, function(allAddFail) {
                    console.log("yes", allAddFail);
                  })
                }
              })
            } else {
              var finalList = [];
              console.log("gotten:", response);
              Utils.removeLastItemIfHasNoAttribute(response, 'interest');
              for (var i = 0; i < response.length; i++) {
                finalList.push(response[i].interest.title);
              }
              window.localStorage.setItem('userInterest', finalList);
              console.log("already asked and gotten");
            }
          }
        )
      }
    ///

    function ULsuscribe(timer, typeOpen) {
      console.log("open by", typeOpen);
      setTimeout(function() {
        console.log("launch after " + timer + 'sec');
        universalLinks.subscribe(null, function (eventData) {
          // do some work
          console.error('open app from blank link: ', eventData);
          //step to get Data
          if(eventData.params) {
            // got data, check all needed to redirect
            var listParams = eventData.params.typeDL.split('_');
            var typeDL;
            var I = null;
            var II = null;
            if (listParams.length >= 3) {
              typeDL = listParams[0];
              I = listParams[1].split('=')[1];
              II = listParams[2].split('=')[1];
            } else if (listParams.length === 1) {
              typeDL = listParams[0];
            }
            console.log("got", eventData);
            switch (typeDL) {
              case 'App':
                if($state.current.name == "login" || $state.current.name == "standbyPage") {
                  // SAY SOMETHING TO NEW USER??
                } else {
                  // SAY SOMETHING TO OLD USER??
                }
                break;
              case 'Post':
                if(I && II) {
                  //try to redirect
                  if($state.current.name == "login" || $state.current.name == "standbyPage") {
                    //IF IN LOGIN OR STANDBY PAGE THE USER ISN'T LOGGED
                    //NEED UPDATE TO CARRY DATA FOR AFTER LOGIN
                  } else {
                    //THE USER IS LOGGED SO WE CAN RELOCATE TO SHOWNOFITICATION
                    $state.go('showNotification', {
                      sequenceId: I,
                      groupId: "",
                      fromWhere: $state.current.name
                    }, { reload: true });
                  }
                } else {
                  $state.go('menu.notificationTabs.regular', {}, { reload: true });
                }
                break;
              case 'Invite': 
                //STILL NOTHING TO DO, PREPARE FOR UPDATE
                break;
              default:
                //ONLY OPEN THE APP
                console.error('default option');
                break;
            }
          } else {
            //didn't get data don't move it
            //if($state.current.name === ) {}
            console.error("got", eventData);
          }
        });
      }, timer);
    }

    //function for check perzonalized options in external web
    function checkPersonalizedFunctions(url, callback) {
      console.log("asking server nicely")
      var xhr = new XMLHttpRequest();
      //process to bypass cache Math.floor(Math.random() * 1000);
      var tiempo = Math.floor(Math.random() * 1000);
      var newUrl = url + '?' + tiempo;
      //
      xhr.open('GET', newUrl, true);
      xhr.responseType = 'json';
      xhr.onload = function() {
        var status = xhr.status;
        if (status == 200) {
          callback(null, xhr.response);
        } else {
          callback(status);
        }
      };

      xhr.send();
    }

    //document.addEventListener('deviceready', setupOpenwith, false);

    function setupOpenwith() {

      // Increase verbosity if you need more logs
      cordova.openwith.setVerbosity(cordova.openwith.DEBUG);

      // Initialize the plugin
      cordova.openwith.init(initSuccess, initError);

      function initSuccess() { console.log('init success!'); }

      function initError(err) { console.log('init failed: ' + err); }

      // Define your file handler
      cordova.openwith.addHandler(myHandler);

      function myHandler(intent) {
        console.log('intent received');

        console.log('  action: ' + intent.action); // type of action requested by the user
        console.log('  exit: ' + intent.exit); // if true, you should exit the
        // app after processing

        for (var i = 0; i < intent.items.length; ++i) {
          var item = intent.items[i];
          console.log('  type: ', item.type); // mime type
          console.log('  uri:  ', item.uri); // uri to the file, probably NOT a web uri

          // some optional additional info
          console.log('  text: ', item.text); // text to share alongside the item, iOS only
          console.log('  name: ', item.name); // suggested name of the image, iOS 11+ only
          console.log('  utis: ', item.utis);
          console.log('  path: ', item.path);
          // path on the device, generally undefined
        }

        // ...
        // Here, you probably want to do something useful with the data
        // ...
        // An example...
        // For simplicity, only handle sharing a single file.
        if (intent.items.length === 1 && item.type == "video/mp4" || item.type == "video/3gpp" || item.type == "video/3gpp2" || item.type == "video/avi" || item.type == "video/quicktime") {
          cordova.openwith.load(intent.items[0], function(data, item) {
            // data is a long base64 string with the content of the file
            //console.log("item loaded, it weights " + item.length + " bytes");
            $rootScope.dataVideo = item;
            setTimeout(function() { $state.go('uploadVideo'); }, 5000);


            //cordova.openwith.exit();
            // upload to your server, confirm to the user.
            // uploadToServer(item, function() {
            //   if (intent.exit) { cordova.openwith.exit(); }
            // });
          })


        } else if (intent.items.length > 0) {

          $rootScope.imagenDataList = [];
          intent.items.forEach(function(data) {
            if (data.type === "image/jpeg" || data.type === "image/gif" || data.type === "image/png") {
              console.log("hhhh", data.path);
              cordova.openwith.load(data, function(data1, item) {
                var semi2 = item;
                // data is a long base64 string with the content of the file
                console.log("item loaded, it weights " + item.length + " bytes");
                //var semi = "data:image/jpeg;base64," + data1;
                //$rootScope.imagenDataList.push(semi);
                $rootScope.prueba2.push(semi2);
                console.log($rootScope.prueba2);
                setTimeout(function() { $state.go('upload'); }, 5000);
                // Utils.removeLastItemIfHasNoAttribute($rootScope.imagenDataList, data1, item.type == "video/mp4");
                //cordova.openwith.exit();
                // upload to your server, confirm to the user.
                // uploadToServer(item, function() {
                //   if (intent.exit) { cordova.openwith.exit(); }
                // });
              });

            } else {

            }


          })

        }
      }
    }

    function chkConnection() {
      var networkState = navigator.connection.type;
      
      $rootScope.NETWORK[Connection.UNKNOWN]  = 'Unknown connection';
      $rootScope.NETWORK[Connection.ETHERNET] = 'Ethernet connection';
      $rootScope.NETWORK[Connection.WIFI]     = 'WiFi connection';
      $rootScope.NETWORK[Connection.CELL_2G]  = 'Cell 2G connection';
      $rootScope.NETWORK[Connection.CELL_3G]  = 'Cell 3G connection';
      $rootScope.NETWORK[Connection.CELL_4G]  = 'Cell 4G connection';
      $rootScope.NETWORK[Connection.CELL]     = 'Cell generic connection';
      $rootScope.NETWORK[Connection.NONE]     = 'No network connection';

      console.error("Type connection", $rootScope.NETWORK[networkState]);
    }

    function gotOffLine() {
      var networkState = navigator.connection.type;
      console.log("Type connection OFF", $rootScope.NETWORK[networkState]);
      if($rootScope.NETWORK[networkState] !== 'No network connection') 
        $rootScope.IS_ONLINE = true;
      else
        $rootScope.IS_ONLINE = false;
      Utils.$timeout(function() {
        $rootScope.$apply();
      })
    }

    function gotOnLine() {
      var networkState = navigator.connection.type;
      console.log("Type connection ON", $rootScope.NETWORK[networkState]);
      if($rootScope.NETWORK[networkState] !== 'No network connection') 
        $rootScope.IS_ONLINE = true;
      else
        $rootScope.IS_ONLINE = false
      Utils.$timeout(function() {
        $rootScope.$apply();
      })
    }

  });
