"use strict";
appServices
	.factory('searchFactory', ['$rootScope', 'UserService', 'AsyncSearch', 'Utils', 'SequenceService', 'cqnzService', 'SequenceFactory', '$q',
		function($rootScope, UserService, AsyncSearch, Utils, SequenceService, cqnzService, SequenceFactory, $q){

			var 
				lastSearch,
				pendingSearch,
				searchMinResult,
				searchPostResult,
				searchMaxResult,
				cancelSearch = angular.noop;

			/*
			 *	USE OF WS WIT MIN DATA
			 * @name
			 * @privateAccount
			 * @profilePicture
			 * @profilePictureUrl
			 * @role - href
			 * @role - title
			 * @user - href
			 * @user - title <same01>
			 * @username <same01>
			 * @userSubscription - href
			 * @userSubscription - title
			 * @userSubscriptionId
			 * @verifyUser
			*/
			function madeMaxSearch(criteria) {
				if (!pendingSearch || !debounceSearch()) {
					cancelSearch();

					return searchMaxResult = $q(function (resolve, reject) {
						cancelSearch = reject;

						UserService.findFriendUserSubscriptionsByUserNamev157().get(criteria).$promise
						.then(function (userList) {
							var totalUsersRetrieved = userList.length;
							console.log("------ totalUsersRetrieved", totalUsersRetrieved)
            				resolve(userList);
            				refreshDebounce();
          				}, function (error) {
            				console.error("[AsyncSearch.findFriendUserSubscriptionsByUserNamev157] error:", error);
            				resolve([]);
            				refreshDebounce();
          				});
					});
				}

				return pendingSearch;
			}

			/*
			 *	USE OF WS WIT MIN DATA
			 * @href
			 * @id
			 * @name
			 * @photo
			 * with pendingSearch
			*/
			function madeMinSearch(term, start, count) {
				var cancelUsersSearch = angular.noop;
				if (!pendingSearch || !debounceSearch()) {
					cancelSearch();

					return searchMinResult = Utils.$q(function (resolve, reject) {
						cancelUsersSearch = reject;
						UserService.searchUsersByPartialNameOrIncludingSpaces({
							term: term,
	            			start: start,
	            			count: count
						}).then(function (results) {
								var totalUsersRetrieved = results.length;
					            console.log("------ totalUsersRetrieved", totalUsersRetrieved)
					            if (!totalUsersRetrieved) {
					            	return resolve(results);
					            }
					            resolve(results);
							}, function (error) {
								console.error("couldn't get user list", error);
	              				reject(error);
							}
						);
					})
				}
					
			}

			/*
			 *	USE OF WS SEARCH TEXT IN POSTS
			*/
			function madePostSearch(term, id, start, count) {
				return searchPostResult = Utils.$q( function (resolve, reject) {
					SequenceService.findSequenceByDescriptionWS({
            			description: term,
            			userSubscriptionId: id,
            			start: start,
            			count: count
          			}).$promise.then( function (sequenceResults) {
						Utils.removeLastItemIfHasNoAttribute(sequenceResults, 'sequence');
						var totalPostsRetrieved = sequenceResults.length;

						var sequenceList = [];

						if (!totalPostsRetrieved) {
	            			return resolve(sequenceList);
	            		}

	            		sequenceResults.forEach( function (sequence) {

	            			var listTags = SequenceService.obtainTagwithIdandType({
				                sequenceId: sequence.sequenceId,
				                notificationType: 7
				            });

	            			//LuMa HashTags in sequence
				            //var hashesList = SequenceService.getHashFromSequence(sequence.sequenceId);
				            var hashesList = SequenceService.findSequenceHashTagComment({
				            	sequenceId: sequence.sequenceId,
				            	notificationType: 7,
				            	commentId: 0
				          	});

				            Utils.$q.all({
	                			tagsList: listTags,
	                			hashesList: hashesList
	              			}).then(function (userCqnz) {
	                			userCqnz.basicData = sequence;
	                			userCqnz.comments = [];
	                			userCqnz.sequenceOwnerId = Utils.getLastUrlComponent(userCqnz.basicData.userSubscriptionId.href);
	                			userCqnz.sequenceItems = cqnzService.getItemsToSequenceV165WS(userCqnz.basicData.sequenceId);

				                var totalSeqs = sequenceList.push(SequenceFactory.buildSequenceObject(userCqnz));

	            			    if (totalSeqs === totalPostsRetrieved) {
	                  				resolve(sequenceList);
	                			}
	              			}, function (error) {
	                			console.error(error);
	                			reject(error);
	              			})
	            		})
					}, function (error) {
						console.error("couldn't get sequence list", error);
	            		reject(error);
					})
				});
			}

			function refreshDebounce() {
      			lastSearch = 0;
      			pendingSearch = null;
      			cancelSearch = angular.noop;
    		}

			/**
     		 * Debounce if querying faster than 300ms
        	*/
		    function debounceSearch() {
		      var now = new Date().getMilliseconds();
		      lastSearch = lastSearch || now;
		      return ((now - lastSearch) < 300);
		    } 

			//<ng-include style="width: 100%;" src="'templates/partials/searchAreaTpl.html'"></ng-include>

		return {
			madeMinSearch: madeMinSearch,
			madeMaxSearch: madeMaxSearch,
			madePostSearch: madePostSearch
		}

	}])
