"use strict";
angular.module('app.routes', [])

  .config(function ($stateProvider, $urlRouterProvider) {

    // Ionic uses AngularUI Router which uses the concept of states
    // Learn more here: https://github.com/angular-ui/ui-router
    // Set up the various states which the app can be in.
    // Each state's controller can be found in controllers.js
    $stateProvider

      .state('login', {
        url: '/login',
        cache: false,
        templateUrl: 'templates/Login/login.html',
        controller: 'loginCtrl'
      })

      //LuMa Live Streaming
      .state('vod',{
        url: '/VoD',
        cache: false,
        templateUrl: 'templates/StreamingVoD/VoD.html',
        controller: 'vodCtrl'
      })

      /* Redirect for comments inside cqnz
      .state('comments', {
        url: '/comments',
        templateUrl: 'templates/commentsH1.html',
        controller: 'PopupCtrl'
      })*/

      .state('acceptTerms', {
        url: '/acceptTerms',
        templateUrl: 'templates/acceptTerms.html'
      })

      .state('signup', {
        url: '/singup',
        templateUrl: 'templates/Login/signup.html',
        controller: 'signupCtrl'
      })

      .state('signup2', {
        url: '/singup2',
        templateUrl: 'templates/Login/signup2.html',
        controller: 'signup2Ctrl'
      })

      .state('standbyPage', {
        url: '/standbyPage',
        templateUrl: 'templates/Login/standbyPage.html'/*,
        controller: 'standbyPageCtrl'*/
      })

      .state('menu', {
        url: '/side-menu21',
        abstract: true,
        templateUrl: 'templates/menu.html',
        controller: 'menuCtrl'
      })

      .state('forgotPassword', {
        url: '/forgotPassword',
        templateUrl: 'templates/Login/forgotPassword.html',
        controller: 'forgotPasswordCtrl'
      })

      .state('menu.search', {
        url: '/search',
        views: {
          'side-menu21': {
            templateUrl: 'templates/search.html',
            controller: 'searchCtrl'
          }
        }
      })

      .state('menu.discovery', {
        url: '/discovery',
        views: {
          'side-menu21': {
            templateUrl: 'templates/Discovery/discovery.html',
            controller: 'discoveryCtrl'
          }
        }
      })

      /*.state('showNotification', {
        params: {sequenceBasicData: null},
        url: '/showNotification',
        templateUrl: 'templates/Notifications/showNotifications.html',
        controller: 'showNotificationCtrl'
      })*/
      .state('showNotification', {
        params: {sequenceId: null, groupId: null, fromWhere: null, groupIndex: null},
        url: '/showNotification',
        templateUrl: 'templates/Notifications/showNotifications.html',
        controller: 'showNotificationCtrl'
      })

      .state('showStreaming', {
        params: {sequenceId: null, groupId: null, fromWhere: null, groupIndex: null},
        url: '/showStreaming',
        templateUrl: 'templates/Notifications/showStreaming.html',
        controller: 'showStreamingCtrl'
      })

      .state('menu.myProfile', {
        cache: false,
        url: '/MyProfile',
        views: {
          'side-menu21': {
            templateUrl: 'templates/Profiles/myProfile.html',
            controller: 'MyProfileCtrl'
          }
        }
      })

      .state('menu.changeProfilePicture', {
        cache: false,
        url: '/changeProfilePicture',
        views: {
          'side-menu21': {
            templateUrl: 'templates/Profiles/changeProfilePicture.html',
            controller: 'MyProfileCtrl'
          }
        }
      })

      .state('menu.changeBackgroundPicture', {
        cache: false,
        url: '/changeBackgroundPicture',
        views: {
          'side-menu21': {
            templateUrl: 'templates/Profiles/changeBackgroundPicture.html',
            controller: 'MyProfileCtrl'
          }
        }
      })

      .state('sendReaction', {
        cache: false,
        params: {sequence: null},
        url: '/sendReaction',
        templateUrl: 'templates/sendReaction.html',
        controller: 'MyProfileCtrl'
      })

      .state('menu.timeline', {
        params: {groupIndex: null, newGroupId: null},
        cache: true,
        url: '/Timeline/:prepareStatement',
        views: {
          'side-menu21': {
            templateUrl: 'templates/Timelines/timelines-container.html',
            controller: 'TimelinesContainerCtrl' 
          }
        }
      })

      .state('upload', {
        cache: false,
        params: {isGroupTimeline: null, groupData: null},
        url: '/Upload',
        templateUrl: 'templates/Uploads/upload.html',
        controller: 'uploadCtrl'
      })

      .state('uploadVideo', {
        cache: false,
        params: {isGroupTimeline: null, groupData: null},
        url: '/UploadVideo',
        templateUrl: 'templates/Uploads/uploadVideo.html',
        controller: 'uploadVideoCtrl'
      })
      //Luma OmRo Streaming
      .state('streamingOnLive',{
        cache: false,
        url:'/Livestreaming',
        templateUrl: 'templates/partials/liveStreaming.html',
        controller: 'StreamingOnLiveCtrl'
      })

      .state('menu.updatePassword', {
        url: '/updatePassword',
        views: {
          'side-menu21': {
            templateUrl: 'templates/updatePassword.html',
            controller: 'UserCtrl'
          }
        }
      })

      .state('menu.configNotifications', {
        url: '/configNotifications',
        views: {
          'side-menu21': {
            templateUrl: 'templates/configNotifications.html',
            controller: 'configNotificationsCtrl'
          }
        }
      })

      .state('menu.sets', {
        url: '/sets',
        views: {
          'side-menu21': {
            templateUrl: 'templates/sets.html',
            controller: 'settingsPageCtrl'
          }
        }
      })

      .state('menu.friends', {
        url: '/friends',
        views: {
          'side-menu21': {
            templateUrl: 'templates/friends.html',
            controller: 'friendsCtrl'
          }
        }
      })

      .state('menu.msgSupport', {
        url: '/msgSupport',
        views: {
          'side-menu21': {
            templateUrl: 'templates/msgSupport.html',
            controller: 'msgSupportCtrl'
          }
        }
      })

      .state('menu.contacts', {
        url: '/contacts',
        views: {
          'side-menu21': {
            templateUrl: 'templates/contacts.html',
            controller: 'phoneContactsCtrl'
          }
        }
      })

      .state('menu.terms', {
        url: '/terms',
        views: {
          'side-menu21': {
            templateUrl: 'templates/terms.html',
            controller: 'policyCtrl'
          }
        }
      })

      .state('menu.policy', {
        url: '/policy',
        views: {
          'side-menu21': {
            templateUrl: 'templates/policy.html',
            controller: 'policyCtrl'
          }
        }
      })

      .state('menu.help1', {
        url: '/help1',
        views: {
          'side-menu21': {
            templateUrl: 'templates/help1.html'
          }
        }
      })

      .state('menu.help2', {
        url: '/help2',
        views: {
          'side-menu21': {
            templateUrl: 'templates/help2.html'
          }
        }
      })

      .state('menu.help3', {
        url: '/help3',
        views: {
          'side-menu21': {
            templateUrl: 'templates/help3.html'
          }
        }
      })

      .state('menu.help4', {
        url: '/help4',
        views: {
          'side-menu21': {
            templateUrl: 'templates/help4.html'
          }
        }
      })

      .state('menu.help5', {
        url: '/help5',
        views: {
          'side-menu21': {
            templateUrl: 'templates/help5.html'
          }
        }
      })

      .state('menu.help6', {
        url: '/help6',
        views: {
          'side-menu21': {
            templateUrl: 'templates/help6.html'
          }
        }
      })

      .state('menu.help7', {
        url: '/help7',
        views: {
          'side-menu21': {
            templateUrl: 'templates/help7.html'
          }
        }
      })

      .state('menu.help8', {
        url: '/help8',
        views: {
          'side-menu21': {
            templateUrl: 'templates/help8.html'
          }
        }
      })

      .state('menu.legal', {
        url: '/legal',
        views: {
          'side-menu21': {
            templateUrl: 'templates/legal.html',
            controller: 'legalsCttrl'
          }
        }
      })

      .state('menu.help', {
        url: '/help',
        views: {
          'side-menu21': {
            templateUrl: 'templates/help.html'
          }
        }
      })

      .state('menu.statusPost', {
        url: '/statusPost',
        views: {
          'side-menu21': {
            templateUrl: 'templates/statusPosts/statusPostList.html',
            controller: 'inReviewCtrl'
          }
        }
      })

      .state('signUpTerms', {
        url: '/signUpTerms',
        templateUrl: 'templates/Login/signUpTerms.html'
      })

      .state('signUpPolicy', {
        url: '/signUpPolicy',
        templateUrl: 'templates/Login/signUpPolicy.html'
      })

      .state('menu.about', {
        url: '/about',
        views: {
          'side-menu21': {
            templateUrl: 'templates/about.html',
            controller: 'aboutCtrl'
          }
        }
      })

      .state('friendProfile', {
        url: '/friendProfile/:instanceId',
        templateUrl: 'templates/Profiles/friendProfile.html',
        controller: 'friendProfileCtrl'
      })

      .state('menu.notificationTabs', {
        cache: true,
        url: '/notifications',
        views: {
          'side-menu21': {
            templateUrl: 'templates/Notifications/notifications-tabs.html',
            controller: 'notificationsTabsCtrl'//'SequenceCtrl'
          }
        }
      })
      .state('menu.notificationTabs.regular', {
        url: '/regular',
        cache: false,
        views: {
          'regular-tab': {
            templateUrl: 'templates/Notifications/regularNotifications.html',
            controller: 'notificationsRegularCtrl'
          }
        }
      })
      .state('menu.notificationTabs.follwers', {
        url: '/followers',
        cache: false,
        views: {
          'followers-tab': {
            templateUrl: 'templates/Notifications/followersNotifications.html',
            controller: 'notificationsFollowersCtrl'
          }
        }
      })


      .state('commentsCqnz', {
        params: {data: null},//<--Them controller name where the comment must go
        url: '/commentsCqnz',
        templateUrl: 'templates/commentsSequence.html',
        controller: 'commentsCqnzCtrl'
      })

      .state('followersFollowing', {
        params: {userInstanceId: null, listType: null},
        url: '/followersFollowing',
        templateUrl: 'templates/Profiles/followersFollowing.html',
        controller: 'followersFollowingCtrl'
      })

      .state('scheduledPostsPage', {
        cache: 'false',
        params: {userInstanceId: null},
        url: '/scheduledPosts',
        templateUrl: 'templates/Profiles/scheduledPostsPage.html',
        controller: 'scheduledTimelineCtrl'
      })

      .state('listLikes', {
        params: {number: null},
        url: '/listLikes',
        templateUrl: 'templates/listLikes.html',
        controller: 'listLikesCtrl'
      })

      .state('listShares', {
        url: '/listShares',
        templateUrl: 'templates/listShares.html',
        controller: 'listSharesCtrl'
      })

      .state('firstFBFriends', {
        url: '/friends',
        templateUrl: 'templates/firstFBFriends.html',
        controller: 'firstFBFriendsCtrl'
      })

      .state('menu.configureMyProfile', {
        cache: 'false',
        url: '/configureMyProfile',
        views: {
          'side-menu21': {
            templateUrl: 'templates/Profiles/configureMyProfile.html',
            controller: 'configureMyProfileCtrl'
          }
        }
      })
      .state('menu.tokens', {//OmRo Token
        cache: 'false',
        url: '/historyToken',
        views: {
          'side-menu21': {
            templateUrl: 'templates/tokens.html',
            controller: 'historyToken'
          }
        }
      })
      .state('menu.configureMetadata', {
        cache: 'false',
        url: '/configureMetadata',
        views: {
          'side-menu21': {
            templateUrl: 'templates/Profiles/configureMetadata.html',
            controller: 'configureMetadataCtrl'
          }
        }
      })
      /*NEW tabs for myconfigure profile*/
      
      .state('menu.configProfileTabs', {
        cache: true,
        url: '/configProfile',
        views: {
          'side-menu21': {
            templateUrl: 'templates/Profiles/configureProfile-tabs.html',
            controller: 'configureMyProfileTabsCtrl'
          }
        }
      })

      .state('menu.configProfileTabs.configureMyProfile', {
        cache: 'false',
        url: '/configureMyProfile',
        views: {
          'configureMyProfile-tab': {
            templateUrl: 'templates/Profiles/configureMyProfile.html',
            controller: 'configureMyProfileCtrl'
          }
        }
      })

      .state('menu.configProfileTabs.configureMetadata', {
        cache: 'false',
        url: '/configureMetaData',
        views: {
          'configureMetadata-tab': {
            templateUrl: 'templates/Profiles/configureMetadata.html',
            controller: 'configureMetadataCtrl'
          }
        }
      })

      /**/
      .state('menu.listFavorites', {
        cache: 'false',
        url: '/listFavorites',
        views: {
          'side-menu21': {
            templateUrl: 'templates/listFavorites.html',
            controller: 'listFavoritesCtrl'
          }
        }
      })

      .state('modifySequence', {
        params: {sequence: null},
        cache: false,
        //url: '/modifySequence/:sequenceInstanceId',
        url: '/modifySequence',
        templateUrl: 'templates/modifySequence.html',
        controller: 'editMySequenceCtrl'
      })

      .state('hashTimeLine', {
        url: '/hashTimeLine/:hashName',
        templateUrl: 'templates/Timelines/hashTimeLine.html',
        controller: 'hashtagTimeLineCtrl'
      })


      .state('menu.groupsTabs', {
        cache: true,
        url: '/groups',
        views: {
          'side-menu21': {
            templateUrl: 'templates/groups/groups-tabs.html',
            controller: 'groupsTabsCtrl'
          }
        }
      })
      .state('menu.groupsTabs.myGroups', {
        cache: true,
        url: '/myGroups',
        views: {
          'myGroups-tab': {
            templateUrl: 'templates/groups/myGroups-tab.html',
            controller: 'myGroupsTabCtrl'
          }
        }
      })
      .state('menu.groupsTabs.otherGroups', {
        cache: true,
        url: '/otherGroups',
        views: {
          'otherGroups-tab': {
            templateUrl: 'templates/groups/otherGroups-tab.html',
            controller: 'otherGroupsTabCtrl'
          }
        }
      })
      .state('groupsCreateStep1', {
        cache: true,
        url: '/groups/create/step1',
        templateUrl: 'templates/groups/group-create-step1.html',
        controller: 'groupCreateStep1Ctrl'
      })
      .state('groupsCreateStep2', {
        cache: false,
        url: '/groups/create/step2',
        templateUrl: 'templates/groups/group-create-step2.html',
        controller: 'groupCreateStep2Ctrl'
      })
      .state('groupsManagement', {
        params: {rawGroupList: null},
        url: '/groups/management',
        templateUrl: 'templates/groups/groups-management.html',
        controller: 'groupsManagementCtrl'
      })
      .state('groupMembersManagement', {
        cache: false,
        params: {group: null},
        url: '/group/manageMembers',
        templateUrl: 'templates/groups/group-members-management.html',
        controller: 'groupMembersManagementCtrl'
      })
      .state('groupSettings', {
        cache: false,
        params: {group: null, groupIndex: null},
        url: '/group/settings',
        templateUrl: 'templates/groups/group-settings.html',
        controller: 'groupSettingsCtrl'
      })
      .state('groupTimelinePreview', {
        cache: false,
        params: {statementBtnAction: null, groupData: null},
        url: '/group/timelinePreview',
        templateUrl: 'templates/Timelines/group-timeline-preview.html',
        controller: function ($scope, $state, Utils) {
          $scope.groupData = $state.params.groupData;
        }
      })
      .state('groupSentRequests', {
        cache: false,
        url: '/group/requests/sent',
        templateUrl: 'templates/groups/group-sent-requests.html',
        controller: 'GroupSentRequests'
      })
      .state('groupReceivedRequests', {
        params: {groupId: null, totalRequest:0},
        cache: false,
        url: '/group/requests/received',
        templateUrl: 'templates/groups/group-received-requests.html',
        controller: 'GroupReceivedRequests'
      })
      .state('groupImageUpdater', {
        params: {groupId: null},
        cache: false,
        url: '/group/imageUpdater',
        templateUrl: 'templates/groups/imageUpdater.html',
        controller: 'groupImageUpdaterCtrl'
      })


      .state('menu.adminTools', {
        url: '/adminTools',
        views: {
          'side-menu21': {
            templateUrl: 'templates/AdminTools/adminTools-mainpage.html',
            controller: 'adminToolsMainpageCtrl'
          }
        }
      })
      .state('adminMembers', {
        url: '/adminTools/adminMembers',
        templateUrl: 'templates/AdminTools/admin-members.html',
        controller: 'adminMembersCtrl'
      })
      .state('adminRoles', {
        url: '/adminTools/adminRoles',
        templateUrl: 'templates/AdminTools/admin-roles.html',
        controller: 'adminRolesCtrl'
      })
      .state('adminCreateEditRole', {
        params: {role: null},
        url: '/adminTools/adminRole/create-edit',
        templateUrl: 'templates/AdminTools/admin-create-edit-role.html',
        controller: 'adminCreateEditRoleCtrl'
      })
      .state('adminViewRole', {
        params: {role: null},
        url: '/adminTools/adminRole/view',
        templateUrl: 'templates/AdminTools/admin-view-rolePermissions.html',
        controller: 'adminViewRoleCtrl'
      })
      .state('adminPermissions', {
        url: '/adminTools/adminPermissions',
        templateUrl: 'templates/AdminTools/admin-permissions.html',
        controller: 'adminPermissionsCtrl'
      })
      .state('adminPendingUsers', {
        url: '/adminTools/adminPendingUsers',
        templateUrl: 'templates/AdminTools/admin-PendingUsers.html',
        controller: 'pendingAuthUsersListCtrl'
      })


      .state('menu.messagesInbox', {
        cache:true,
        url: '/Messages/Inbox/:subscriptionInstanceId',
        views: {
          'side-menu21': {
            /*templateUrl: 'templates/Messages/messagesInbox.html',
            controller: 'messagesInboxCtrl'*/
            templateUrl: 'templates/Chat/chat-inbox.html',
            controller: 'chatInboxCtrl2'
          }
        }
      })

      .state('chatSelectUsers', {
        url: '/chat/Search',
        templateUrl: 'templates/Chat/chatSelectUsers.html',
        controller: 'chatSearchUsersCtrl2'
      })

      .state('chatPrivate',{
        params:{friend:null, addToContacts:false},
        url: '/Messages/chatPrivate',
        templateUrl: 'templates/Chat/chat-private.html',
        controller: 'chatPrivateCtrl2'
      })

      .state('menu.blackListMembers',{
        url: '/blackListMembers',
        views: {
          'side-menu21': {
            templateUrl: 'templates/BlockArea/blackListMembers.html',
            controller: 'listBlockUsers'
          }
        }
      })

      .state('menu.QRMain', {
        url: '/QRMain',
        views: {
          'side-menu21': {
            templateUrl: 'templates/QRList/QRMainPage.html',
            controller: 'QRMainPageCtrl'
          }
        }
      })

      .state('QRListUsers', {
        url: '/QRListUsers',
        templateUrl: 'templates/QRList/QRListUsers.html',
        controller: 'ListAttendantCtrl'
      })

      .state('menu.QRUserContact', {
        params: {idInstanceUser:null, idUser:null, promoText:null, dateAdded:null},
        cache: false,
        url: '/QRInfoUsers',
        views: {
          'side-menu21': {
            templateUrl: 'templates/QRList/QRUserContact.html',
            controller: 'AttendantInfoCtrl'
          }
        }
      })

      .state('QRCreatePromoMainPage', {
        /*params: {idInstanceUser:null, idUser:null},*/
        cache: false,
        url: '/QRCreatePromos',
        templateUrl: 'templates/QRList/QRCreatePromoMainPage.html',
        controller: 'createPromosCtrl'
      })

      .state('showPromotionsList', {
        /*params: {idInstanceUser:null, idUser:null},*/
        url: '/showPromotionsList',
        templateUrl: 'templates/QRList/ShowUsersPromotionList.html',
        controller: 'PromosListPageCtrl'
      })

      .state('menu.showScannersInfoList', {
        params: {idPromo:null, idInstancePromo:null},
        cache: false,
        url: '/showScannersInfoList',
        views: {
          'side-menu21': {
            templateUrl: 'templates/QRList/showScannersInfoList.html',
            controller: 'scannersInfoCtrl'
          }
        }
      })

      .state('menu.EventsMainPage', {
        url: '/EventsMainPage',
        views: {
          'side-menu21': {
            templateUrl: 'templates/QRList/EventsMainPage.html',
            controller: 'EventMainPageCtrl'
          }
        }
      })

      .state('menu.ExhiEventList', {
        url: '/ExhiEventList',
        views: {
          'side-menu21': {
            templateUrl: 'templates/QRList/ExhiEventList.html',
            controller: 'CheckEventListCtrl'
          }
        }
      })

      .state('menu.CheckRegisterEvent', {
        params: {idInstanceEvent:null, idEvent:null},
        cache: false,
        url: '/checkRegisterEvent',
        views: {
          'side-menu21': {
            templateUrl: 'templates/QRList/ExhiRegisterEventList.html',
            controller: 'CheckRegisterEventListCtrl'
          }
        }
      })

      .state('myLockerPage', {
        /*params: {idPromo:null, idInstancePromo:null},*/
        cache: false,
        url: '/myLockerPage',
        templateUrl: 'templates/Profiles/myLockerPage.html',
        controller: 'showUserLockerCtrl'
      })

      //Campaign views
      .state('menu.campaignMMenu', {
        url: '/CampaignMMenu',
        views: {
          'side-menu21': {
            templateUrl: 'templates/Campaign/campaignMMenu.html',
            controller: 'CampaignMMCtrl'
          }
        }
      })

      .state('menu.seeAllCampaigns', {
        url: '/allCampaigns',
        views: {
          'side-menu21': {
            templateUrl: 'templates/Campaign/allCampaigns.html',
            controller: 'allCampaignsCtrl'
          }
        }
      })

      .state('menu.seeOwnCampaigns', {
        url: '/ownCampaigns',
        views: {
          'side-menu21': {
            templateUrl: 'templates/Campaign/ownCampaigns.html',
            controller: 'ownCampaignsCtrl'
          }
        }
      })
      //

      //showScannersInfoList.html
    ;
    // if none of the above states are matched, use this as the fallback
    $urlRouterProvider.otherwise('/login');
    //$urlRouterProvider.otherwise('/side-menu21/Timeline/1');
  });
