"use strict";
angular.module('app.services', ['ngResource'])

  .factory('FileService', function() {
    var images = [];
    var thumbImages = [];
    var Blobimages = [];
    var BlobthumbImages = [];

    //var IMAGE_STORAGE_KEY = 'dav-images';

    function getImages() {

      //images = [];

      return images;
    }

    function getThumbImages() {
      //thumbImages = [];

      return thumbImages;
    }

    function addImage(img) {
      images.push('data:image/jpeg;base64,' + img);
      //images.push(img);
      //window.localStorage.setItem(IMAGE_STORAGE_KEY, JSON.stringify(images));
      //console.log(window.localStorage.getItem('IMAGE_STORAGE_KEY'));
      //test
    }

    function addThumb(img) {
      thumbImages.push(img);
      //window.localStorage.setItem(IMAGE_STORAGE_KEY, JSON.stringify(images));
      //console.log(img);
    }

    function cleanImages() {
      images = [];
      thumbImages = [];
      Blobimages = [];
      BlobthumbImages = [];
    }

    function getBlob() {
      return Blobimages;
    }

    function getThumbBlob() {
      return BlobthumbImages;
    }

    function addBlob(img) {
      Blobimages.push(img);
    }

    function addThumbBlob(img) {
      BlobthumbImages.push(img);
    }

    function addUri(uri) {
      images.push(uri);
    }

    function addUriThumb(uri) {
      thumbImages.push(uri);
    }

    return {
      storeImage: addImage,
      images: getImages,
      storeThumb: addThumb,
      thumbImages: getThumbImages,
      cleanImages: cleanImages,
      //new Functions
      storeBlobImage: addBlob,
      storeBlobThumbNew: addThumbBlob,
      storeUriImage: addUri,
      storeUriThumbImage: addUriThumb,
      getBlob: getBlob,
      getThumbBlob: getThumbBlob
    };
  })

  .factory('ImageService', function($cordovaCamera, FileService, $q, $cordovaFile, $cordovaImagePicker, $rootScope) {

    function optionsForType(type) {
      var source;
      switch (type) {
        case 0:
          source = Camera.PictureSourceType.CAMERA;
          break;
        case 1:
          source = Camera.PictureSourceType.PHOTOLIBRARY;
          break;
      }
      return {
        quality: 100,
        targetWidth: 648,
        targetHeight: 648,
        destinationType: Camera.DestinationType.FILE_URI,
        sourceType: source,
        allowEdit: true,
        encodingType: Camera.EncodingType.JPEG,
        popoverOptions: CameraPopoverOptions,
        saveToPhotoAlbum: false,
        correctOrientation: true
      };
    }
    /*NEW PLUGIN SECTION*/
    function saveCameraMedia(type) {
      return $q(function(resolve) {
        var options = optionsForType(type);
        MediaPicker.takePhoto(function(media) {
          media.index = 0;
          console.log('Image URI: ' + media);
          var promise1 = imageUriToImage64(media.path);
          var promise2 = imageUriToImage64Thumb(media.path);
          $q.all([promise1, promise2]).then(function success() {
            resolve(FileService);
          });
        }, function(error) {
          console.error("fail: ", error);
        }, options);
      });
    }

    function saveAction(){
      return $q(function(resolve) {

        console.log("success: ", $rootScope.prueba2);
        var promises =[];

      });
    }

    function saveAlbumMedia(opts) {
      return $q(function(resolve) {

        var resultMedias = [];
        var args = {
          'selectMode': 100,
          'maxSelectCount': 6
        }
        console.log("here", $rootScope.MEDIA_PICKER);
        MediaPicker.getMedias(args, function(medias) { //photoLibrary
          console.log("success: ", medias);
          var promises = [];
          for (var i = 0; i < medias.length; i++) {
            medias[i].quality = 55;
            $rootScope.moment = 0;
            var mediaSel = medias[i];
            var isIOS = ionic.Platform.isIOS();
            if (isIOS) {
              MediaPicker.compressImage(medias[i], function(compressData) {
                MediaPicker.getExifForKey(compressData.path, "Orientation", function(oriExif) {
                  console.log("data", oriExif);
                  promises.push(imageUriToImage64Fix(compressData.path, medias.length, oriExif));
                  promises.push(imageUriToImage64ThumbFix(compressData.path, oriExif));
                })
              })
            } else {
              MediaPicker.compressImage(mediaSel, function(compressData) {
                promises.push(imageUriToImage64(compressData.path, medias.length));
                promises.push(imageUriToImage64Thumb(compressData.path));
              })
            }
            /*promises.push(imageUriToImage64(medias[i].path));
            promises.push(imageUriToImage64Thumb(medias[i].path));*/
          }
          $q.all(promises).then(function success() {
            console.log("resolved");
            resolve(FileService);
          });
        }, function(error) {
          console.error("fail: ", error);
        });

      });
    }
    /*END NEW PLUGIN SECTION*/
    function saveAlbumMediaFix(preExisted) {
      var picsAllowed = 6 - preExisted;
      return $q(function(resolve) {
        var options = {
          width: 648,
          height: 648,
          quality: 100,
          maximumImagesCount: picsAllowed
        };

        $cordovaImagePicker.getPictures(options)
          .then(function(results) {
            var promises = [];
            for (var i = 0; i < results.length; i++) {
              console.log('Image URI: ' + results[i]);
              promises.push(imageUriToImage64(results[i]));
              promises.push(imageUriToImage64Thumb(results[i]));
              //imageUriToImage64Thumb(results[i], callback);
            }
            $q.all(promises).then(function success() {
              resolve(FileService);
            });
          }, function error() {
            console.log(' error getting photos');
          });

      });
    }

    function imageUriToImage64(imageUri, final) {
      return $q(function(resolve) {
        //FileService.storeImage(imageUri);
        //resolve();
        var c = document.createElement('canvas');
        var ctx = c.getContext("2d");
        var img = new Image();
        img.onload = function() {
          c.width = this.width;
          c.height = this.height;
          ctx.drawImage(img, 0, 0);
          var dataURL = c.toDataURL("image/jpeg");
          FileService.storeImage(dataURL.replace("data:image/jpeg;base64,", ""));
          console.log("image is loaded");
          if ($rootScope.moment === (final - 1))
            $rootScope.$broadcast('addedImage');
          $rootScope.moment++;
          resolve();
        };
        img.src = imageUri;
      });
    }

    function imageUriToImage64Fix(imageUri, final, exif) {
      return $q(function(resolve) {
        var newUri = window.Ionic.WebView.convertFileSrc(imageUri);
        loadImage(newUri, function(img) {
          //return CANVAS
          var dataURL = img.toDataURL("image/jpeg");
          FileService.storeImage(dataURL.replace("data:image/jpeg;base64,", ""));
          console.log("image Fixed is loaded");
          if ($rootScope.moment === (final - 1))
            $rootScope.$broadcast('addedImage');
          $rootScope.moment++;
          resolve();
        }, {
          canvas: true,
          orientation: exif
        })
      })
    }

    function imageUriToImage64Thumb(imageUri) {
      return $q(function(resolve) {
        //FileService.storeThumb(imageUri);
        //resolve();
        var c = document.createElement('canvas');
        var ctx = c.getContext("2d");
        var img = new Image();
        img.onload = function() {
          c.width = Math.floor(this.width * 0.5);
          c.height = Math.floor(this.height * 0.5);
          ctx.drawImage(img, 0, 0, c.width, c.height);
          var dataURL = c.toDataURL("image/jpeg");
          FileService.storeThumb(dataURL);
          console.log("image is loaded");
          resolve();
        };
        img.src = imageUri;
      });
    }

    function imageUriToImage64ThumbFix(imageUri, exif) {
      return $q(function(resolve) {
        var newUri = window.Ionic.WebView.convertFileSrc(imageUri);
        loadImage(newUri, function(img) {
          //return CANVAS
          var dataURL = img.toDataURL("image/jpeg");
          FileService.storeThumb(dataURL);
          console.log("image Fixed is loaded");
          resolve();
        }, {
          canvas: true,
          orientation: exif
        })
      })
    }

    return {
      saveCameraMedia: saveCameraMedia,
      saveAlbumMedia: saveAlbumMedia,
      saveAlbumMediaFix: saveAlbumMediaFix
    };
  })

  .factory('FileService3', function() {
    var images = [];
    var thumbImages = [];

    function getImages() {
      return images;
    }

    function getThumbImages() {
      return thumbImages;
    }

    function storeImage(img) {
      //images.push(img);
      images.push(img);
    }

    function storeThumb(img) {
      thumbImages.push(img);
    }

    function cleanImages() {
      images = [];
      thumbImages = [];
    }

    return {
      storeImage: storeImage,
      images: getImages,
      storeThumb: storeThumb,
      thumbImages: getThumbImages,
      cleanImages: cleanImages
    };
  })

  .factory('ImageService3', function($cordovaCamera, $cordovaImagePicker, Utils, s3) {
    /**
     * @param opts {{
     *   sourceType?: number,
     *   quality?:number,
     *   destinationType?: number,
     *   allowEdit?:boolean,
     *   targetWidth?:number,
     *   targetHeight?:number,
     *   encodingType: number,
     *   cameraDirection?: number,
     *   popoverOptions: function(*),
     *   saveToPhotoAlbum?: boolean,
     *   correctOrientation?:boolean
     * }?}
     * @return {*}
     */
    function createCameraOptions(opts) {
      opts = opts || {};
      var source;
      switch (opts.sourceType) {
        case 1:
          source = Camera.PictureSourceType.PHOTOLIBRARY;
          break;
        case 2:
          source = Camera.PictureSourceType.SAVEDPHOTOALBUM;
          break;
        default:
          source = Camera.PictureSourceType.CAMERA;
      }

      var cameraDirection = Camera.Direction.FRONT; //default, {FRONT=1|BACK=0}
      if (opts.cameraDirection && opts.cameraDirection === 0) { //BACK?
        cameraDirection = Camera.Direction.BACK;
      }

      var outputType = Camera.DestinationType.FILE_URI; //default
      if (opts.destinationType) {
        switch (opts.destinationType) { //{DATA_URL = 0 | FILE_URI = 1 | NATIVE_URI = 2 (for ios)}
          case 0: //DATA_URL
            outputType = Camera.DestinationType.DATA_URL;
            break;
          case 2: //NATIVE_URI
            outputType = Camera.DestinationType.NATIVE_URI;
            break;
        }
      }

      return {
        //Set the source of the picture
        sourceType: source,
        //Quality of the saved image, range of 0 - 100
        quality: opts.quality || 100,
        //Format of the return value
        destinationType: outputType,
        //Allow simple editing of image before selection
        allowEdit: opts.allowEdit || false,
        //Height to scale image (pixels)
        targetWidth: opts.targetWidth || 480,
        //Width to scale image (pixels)
        targetHeight: opts.targetHeight || 648,
        //JPEG = 0, PNG = 1
        encodingType: Camera.EncodingType.JPEG, //{JPEG|PNG}
        //Set the type of media to select from
        //mediaType:string
        //Back = 0, Front-facing = 1
        cameraDirection: cameraDirection,
        //iOS-only options that specify popover location in iPad
        popoverOptions: opts.popoverOptions || CameraPopoverOptions,
        //Save image to photo album on the device
        saveToPhotoAlbum: opts.saveToPhotoAlbum || false,
        //correct camera captured images in case wrong orientation
        correctOrientation: opts.correctOrientation || false
      };
    }

    /**
     * @param opts {{
     *   width?:number,
     *   height?:number,
     *   quality?:number,
     *   maximumImagesCount?:number
     * }?}
     * @return {{width: number, height: number, quality: number, maximumImagesCount: number}}
     */
    function createImagePickerOptions(opts) {
      opts = opts || {};
      return {
        //Quality of resized image, defaults to 100
        quality: opts.quality || 100,
        //Width to resize image to (if one of height/width is 0,
        //will resize to fit the other while keeping aspect ratio,
        //if both height and width are 0, the full size image will be returned)
        width: opts.width || 0,
        height: opts.height || 0,
        //Max images to be selected
        maximumImagesCount: opts.maximumImagesCount || 1
      };
    }

    /**
     * Opens the camera, albums or gallery allowing to pick just 1 photo
     * @param opts {*?}
     * @return {Promise} - string (uri | base64) |*
     */
    function openCameraOrAlbumOrGallery(opts) {
      return Utils.$q(function(resolve, reject) {
        var cameraOptions = createCameraOptions(opts); //defaults: sourceType = 1 = CAMERA

        $cordovaCamera.getPicture(cameraOptions).then(function(uriOrBase64) {
          resolve(uriOrBase64)
        }, function(error) {
          reject(error)
        })
      })
    }

    /**
     * Opens Photo Album (camera roll, allowing to pick 1 or more images)
     * @param imagePickerOptions
     * @return {Promise} - string[] | *
     */
    function openImagePicker(imagePickerOptions) {
      imagePickerOptions = imagePickerOptions || createImagePickerOptions(); //get default options
      return Utils.$q(function(resolve, reject) {
        $cordovaImagePicker.getPictures(imagePickerOptions).then( /**@param stringArray {Array}*/ function(stringArray) {
          resolve(stringArray);
        }, function(error) {
          reject(error)
        });
      })
    }

    /**
     * @param imageUri
     * @param width {number?}
     * @param height {number?}
     */
    function convertUriToImage64(imageUri, width, height) {
      return Utils.$q(function(resolve, reject) {
        convertUriToCanvas(imageUri, width, height).then(function(canvas) {
          resolve(canvas.toDataURL("image/jpeg"));
        }, function(error) {
          reject(error);
        })
      })
    }

    /**
     * @param imageUri
     * @param width {number?}
     * @param height {number?}
     */
    function convertUriToBlob(imageUri, width, height) {
      return Utils.$q(function(resolve, reject) {
        convertUriToCanvas(imageUri, width, height).then(function(canvas) {
          canvas.toBlob(function(blob) {
            blob ? resolve(blob) : reject('blob is empty');
          }, "image/jpg");
        }, function(error) {
          reject(error);
        })
      })
    }


    /**
     * @param imageUri {string}
     * @param width {number?}
     * @param height {number?}
     * @return {Promise} - string
     */
    function convertUriToCanvas(imageUri, width, height) {
      return Utils.$q(function(resolve, reject) {
        var myCanvas = document.createElement('canvas');
        var ctx = myCanvas.getContext("2d");
        var img = new Image();

        img.onerror = function(err) {
          reject(err)
        };

        img.onload = function() {
          var finalWidht = width || img.naturalWidth || this.width;
          var finalHeight = height || img.naturalHeight || this.height;

          if (!(finalWidht && finalHeight)) {
            var error = 'File is not an image or is empty';
            return reject(error);
          }
          myCanvas.width = finalWidht;
          myCanvas.height = finalHeight;
          ctx.drawImage(img, 0, 0, finalWidht, finalHeight);
          resolve(myCanvas);
        };

        img.src = imageUri;
      });
    }

    /**
     * @return {Promise}
     */
    function showImageSelectionOptions() {
      return Utils.$q(function(resolve) {
        Utils.$ionicActionSheet.show({
          buttons: [
            { text: Utils.translate('UPLOAD.TAKE') + ' <i class="icon ion-camera"></i>' },
            //(camera) just 1 can be picked
            { text: Utils.translate('UPLOAD.FROM_ALBUM') + ' <i class="icon ion-images"></i>' },
            //(camera) just 1 can be picked
            //{ text: Utils.translate('UPLOAD.FROM_GALLERY') + ' <i class="icon ion-grid"></i>' }
            //(image picker) 1 or more can be picked depending on config options
            //,{text: Utils.translate('UPLOAD.FROM_GALLERY') + ' <i class="icon ion-grid"></i>'}
          ],
          titleText: Utils.translate('UPLOAD.ADD'),
          cancelText: Utils.translate('GLOBAL.CANCEL'),
          cancel: function() {
            resolve(-1);
            return true;
          },
          buttonClicked: function(index) {
            resolve(index);
            return true
          }
        });
      })
    }

    /**
     * @param photoKey
     * @param imageB64
     * @return {Promise}
     */
    function uploadImageToS3(photoKey, imageB64) {
      return Utils.$q(function(resolve, reject) {
        var s3Service = new AWS.S3({
          apiVersion: '2006-03-01',
          params: { Bucket: s3.bucket }
        });

        var file = Utils.dataURLtoBlob(imageB64);

        s3Service.upload({
          Key: s3.prefix + photoKey,
          Body: file,
          ACL: 'public-read',
          ContentType: file.type
        }, function(uploadError, data) {
          if (uploadError) {
            console.log("Can't upload the image to S3: ", uploadError);
            return reject(uploadError);
          }

          resolve(data);
        });
      });
    }

    return {
      createCameraOptions: createCameraOptions,
      createImagePickerOptions: createImagePickerOptions,
      openCameraOrAlbumOrGallery: openCameraOrAlbumOrGallery,
      openImagePicker: openImagePicker,
      convertUriToImage64: convertUriToImage64,
      convertUriToBlob: convertUriToBlob,
      showImageSelectionOptions: showImageSelectionOptions,
      uploadImageToS3: uploadImageToS3
    }
  })

  .factory('FileService2', function() {
    var images = [];
    var exifImage = [];
    //var IMAGE_STORAGE_KEY = 'dav-images';

    function getImages() {

      //images = [];

      return images;
    }

    function getExif() {
      return exifImage;
    }

    function addImage(img) {
      //images.push('data:image/jpeg;base64,' + img);
      images.push(img);
      //window.localStorage.setItem(IMAGE_STORAGE_KEY, JSON.stringify(images));
      //console.log(window.localStorage.getItem('IMAGE_STORAGE_KEY'));
    }

    function addImageFix(img, exif) {
      //images.push('data:image/jpeg;base64,' + img);
      images.push(img);
      exifImage.push(exif);
      //window.localStorage.setItem(IMAGE_STORAGE_KEY, JSON.stringify(images));
      //console.log(window.localStorage.getItem('IMAGE_STORAGE_KEY'));
    }

    function cleanImages() {
      images = [];
      exifImage = [];
    }

    return {
      storeImage: addImage,
      storeImageFix: addImageFix,
      images: getImages,
      exifImage: getExif,
      cleanImages: cleanImages
    };
  })

  .factory('ImageService2', function($cordovaCamera, FileService2, $q, FileService3, $rootScope) {

    function optionsForType(type, height, width, edit) { // NO USED ANYMORE
      var source;
      switch (type) {
        case 0:
          source = Camera.PictureSourceType.CAMERA;
          break;
        case 1:
          source = Camera.PictureSourceType.PHOTOLIBRARY;
          break;
      }
      return {
        quality: 100,
        cameraDirection: Camera.Direction.FRONT,
        //destinationType: Camera.DestinationType.DATA_URL,
        destinationType: Camera.DestinationType.FILE_URI,
        sourceType: source,
        allowEdit: false,
        targetHeight: height,
        targetWidth: width,
        encodingType: Camera.EncodingType.JPEG,
        popoverOptions: CameraPopoverOptions,
        saveToPhotoAlbum: false,
        correctOrientation: true
      };
    }

    function optionsProfilePhoto(type) {
      var source;
      switch (type) {
        case 0:
          source = Camera.PictureSourceType.CAMERA;
          break;
        case 1:
          source = Camera.PictureSourceType.PHOTOLIBRARY;
          break;
      }
      return {
        quality: 90,
        targetWidth: 850,
        targetHeight: 850,
        cameraDirection: Camera.Direction.FRONT,
        destinationType: Camera.DestinationType.FILE_URI,
        sourceType: source,
        allowEdit: false,
        encodingType: Camera.EncodingType.JPEG,
        popoverOptions: CameraPopoverOptions,
        saveToPhotoAlbum: false,
        correctOrientation: true
      };
    }

    function optionsBackPhoto(type) {
      var source;
      switch (type) {
        case 0:
          source = Camera.PictureSourceType.CAMERA;
          break;
        case 1:
          source = Camera.PictureSourceType.PHOTOLIBRARY;
          break;
      }
      return {
        quality: 90,
        targetWidth: 850,
        targetHeight: 850,
        cameraDirection: Camera.Direction.FRONT,
        destinationType: Camera.DestinationType.FILE_URI,
        sourceType: source,
        allowEdit: false,
        encodingType: Camera.EncodingType.JPEG,
        popoverOptions: CameraPopoverOptions,
        saveToPhotoAlbum: false,
        correctOrientation: true
      };
    }

    function optionsForPost(type) {
      var source;
      switch (type) {
        case 0:
          source = Camera.PictureSourceType.CAMERA;
          break;
        case 1:
          source = Camera.PictureSourceType.PHOTOLIBRARY;
          break;
      }
      return {
        quality: 90,
        targetWidth: 850,
        targetHeight: 850,
        cameraDirection: Camera.Direction.FRONT,
        destinationType: Camera.DestinationType.FILE_URI,
        sourceType: source,
        allowEdit: false,
        encodingType: Camera.EncodingType.JPEG,
        popoverOptions: CameraPopoverOptions,
        saveToPhotoAlbum: false,
        correctOrientation: true
      };
    }

    function optionsForStream(type) {
      var source;
      switch (type) {
        case 0:
          source = Camera.PictureSourceType.CAMERA;
          break;
        case 1:
          source = Camera.PictureSourceType.PHOTOLIBRARY;
          break;
      }
      return {
        quality: 90,
        targetWidth: 850,
        targetHeight: 850,
        cameraDirection: Camera.Direction.FRONT,
        destinationType: Camera.DestinationType.FILE_URI,
        sourceType: source,
        allowEdit: false,
        encodingType: Camera.EncodingType.JPEG,
        popoverOptions: CameraPopoverOptions,
        saveToPhotoAlbum: false,
        correctOrientation: true
      };
    }

    function saveMedia(type, height, width, edit) {
      return $q(function() {

        console.log(height + " - " + width);

        var options = optionsForType(type, height, width, edit);

        $cordovaCamera.getPicture(options).then(function(imageBase64) {
          FileService2.storeImage(imageBase64);
        });
      });
    }

    function saveUserProfilePhoto(type) { // NO USED ANYMORE
      return $q(function(resolve) {

        var options = optionsProfilePhoto(type);

        $cordovaCamera.getPicture(options).then(function(imageUri) {
          FileService2.cleanImages();
          var promise1 = imageUriToImage64(imageUri);
          var promise2 = imageUriToImage64(imageUri);
          var promise3 = imageUriToImage64(imageUri);
          $q.all([promise1, promise2, promise3]).then(function success() {
            resolve(FileService2);
          });
        });
      });
    }

    /*NEW PLUGIN SECTION*/
    function saveCameraMediaProfilePhoto(type) {                              // DIRECT CAMERA PROFILE MAIN PHOTO
      console.log("CALLED services");
      return $q(function(resolve) {
        var options = optionsProfilePhoto(type);
        MediaPicker.takePhoto(function(media) {
          media.index = 0;
          FileService2.cleanImages();
          media.quality = 55;
          $rootScope.moment = 0;
          var isIOS = ionic.Platform.isIOS();
          var promise1 = "";
          var promise2 = "";
          var promise3 = "";
          if (isIOS) {
            MediaPicker.compressImage(media, function(compressData) {
              MediaPicker.getExifForKey(compressData.path, "Orientation", function(oriExif) {
                console.log("data", oriExif);
                promise1 = imageUriToImage64Fix(compressData.uri, 2, oriExif);
              })
            })
          } else {
            MediaPicker.compressImage(media, function(compressData) {
              promise1 = imageUriToImage64(compressData.path, 2);
            })
          }
          $q.all([promise1, promise2, promise3]).then(function success() {
            resolve(FileService2);
          });
        }, function(error) {
          console.error("fail: ", error);
        }, options);
      });
    }

    function saveCameraMediaBackgroundPhoto(type) {                           // DIRECT CAMERA PROFILE BACKGROUND PHOTO
      return $q(function(resolve) {
        var options = optionsBackPhoto(type);
        MediaPicker.takePhoto(function(media) {
          media.index = 0;
          FileService2.cleanImages();
          media.quality = 55;
          var isIOS = ionic.Platform.isIOS();
          var promise1 = "";
          if (isIOS) {
            MediaPicker.compressImage(media, function(compressData) {
              MediaPicker.getExifForKey(compressData.path, "Orientation", function(oriExif) {
                console.log("data", oriExif);
                promise1 = backimageUriToImage64Fix(compressData.uri, 2, oriExif);
              })
            })
          } else {
            MediaPicker.compressImage(media, function(compressData) {
              promise1 = backimageUriToImage64(compressData.path, 2);
            })
          }
          $q.all([promise1]).then(function success() {
            resolve(FileService2);
          });
        }, function(error) {
          console.error("fail: ", error);
        }, options);
      });
    }

    function saveCameraMediaReactPhoto(type, height, width, edit) {           // DIRECT CAMERA REACT PHOTO
      return $q(function(resolve) {
        var options = optionsForType(type, height, width, edit);
        MediaPicker.takePhoto(function(media) {
          media.index = 0;
          FileService2.cleanImages();
          media.quality = 100;
          $rootScope.moment = 0;
          var isIOS = ionic.Platform.isIOS();
          var promise1 = "";
          if (isIOS) {
            MediaPicker.compressImage(media, function(compressData) {
              MediaPicker.getExifForKey(compressData.path, "Orientation", function(oriExif) {
                console.log("data", oriExif);
                promise1 = reactUriToImage64Fix(compressData.uri, 2, oriExif);
              })
            })
          } else {
            MediaPicker.compressImage(media, function(compressData) {
              promise1 = reactUriToImage64(compressData.path, 2);
            }) 
          }
          $q.all([promise1]).then(function success() {
            resolve(FileService2);
          });
        }, function(error) {
          console.error("fail: ", error);
        }, options);
      });
    }

    function saveCameraMediaPostPhoto(type) {                                 // DIRECT CAMERA POST PHOTO
      console.log("CALLED services");
      return $q( function (resolve) {
        var options = optionsForPost(type);
        MediaPicker.takePhoto(function(media) {
          media.index = 0;
          FileService2.cleanImages();
          media.quality = 55;
          $rootScope.moment = 0;
          var isIOS = ionic.Platform.isIOS();
          var promise1 = "";
          var promise2 = "";
          if (isIOS) {
            //media.uri = media.uri.replace('file://', '');
            MediaPicker.compressImage(media, function(compressData) {
              MediaPicker.getExifForKey(compressData.path, "Orientation", function(oriExif) {
                console.log("data", oriExif);
                promise1 = postUriToImage64Fix(compressData.uri, 0, oriExif);
              })
            })
          } else {
            MediaPicker.compressImage(media, function(compressData) {
              promise1 = postUriToImage64(compressData.path, 0);
            })
          }
          $q.all([promise1, promise2]).then(function success() {
            resolve(FileService2);
          });
        }, function(error) {
          console.error("fail: ", error);
        }, options)
      })
    }

    function saveCameraMediaStreamPhoto(type) {                               // DIRECT CAMERA STREAM PHOTO
      console.log("CALLED services");
      return $q( function (resolve) {
        var options = optionsForPost(type);
        MediaPicker.takePhoto(function(media) {
          media.index = 0;
          FileService2.cleanImages();
          media.quality = 55;
          $rootScope.moment = 0;
          var isIOS = ionic.Platform.isIOS();
          var promise1 = "";
          var promise2 = "";
          if (isIOS) {
            //media.uri = media.uri.replace('file://', '');
            MediaPicker.compressImage(media, function(compressData) {
              MediaPicker.getExifForKey(compressData.path, "Orientation", function(oriExif) {
                console.log("data", oriExif);
                promise1 = streamUriToImage64Fix(compressData.uri, 0, oriExif);
              })
            })
          } else {
            MediaPicker.compressImage(media, function(compressData) {
              promise1 = streamUriToImage64(compressData.path, 0);
            })
          }
          $q.all([promise1, promise2]).then(function success() {
            resolve(FileService2);
          });
        }, function(error) {
          console.error("fail: ", error);
        }, options)
      })
    }

    function saveCameraMediaMessagePhoto(type) {                              // DIRECT CAMERA MESSAGE PHOTO
      console.log("CALLED services");
      return $q(function(resolve) {
        var options = optionsForPost(type);
        MediaPicker.takePhoto(function(media) {
          media.index = 0;
          FileService2.cleanImages();
          media.quality = 55;
          $rootScope.moment = 0;
          var isIOS = ionic.Platform.isIOS();
          var promise1 = "";
          var promise2 = "";
          if(isIOS) {
            MediaPicker.compressImage(media, function(compressData) {
              MediaPicker.getExifForKey(compressData.path, "Orientation", function(oriExif) {
                console.log("data", oriExif);
                promise1 = messageUriToImage64Fix(compressData.uri, 0, oriExif);
              })
            })
          } else {
            MediaPicker.compressImage(media, function(compressData) {
              promise1 = messageUriToImage64(compressData.path, 0);
            })
          }
          $q.all([promise1, promise2]).then(function success() {
            resolve(FileService2);
          });
        }, function(error) {
          console.error("fail: ", error);
        }, options);
      });
    }

    function saveCameraMediaPromoPhoto(type) {                                 // DIRECT CAMERA PROMO PHOTO
      console.log("CALLED services");
      return $q( function (resolve) {
        var options = optionsForPost(type);
        MediaPicker.takePhoto(function(media) {
          media.index = 0;
          FileService2.cleanImages();
          media.quality = 55;
          $rootScope.moment = 0;
          var isIOS = ionic.Platform.isIOS();
          var promise1 = "";
          var promise2 = "";
          if (isIOS) {
            //media.uri = media.uri.replace('file://', '');
            MediaPicker.compressImage(media, function(compressData) {
              MediaPicker.getExifForKey(compressData.path, "Orientation", function(oriExif) {
                console.log("data", oriExif);
                promise1 = promoUriToImage64Fix(compressData.uri, 0, oriExif);
              })
            })
          } else {
            MediaPicker.compressImage(media, function(compressData) {
              promise1 = promoUriToImage64(compressData.path, 0);
            })
          }
          $q.all([promise1, promise2]).then(function success() {
            resolve(FileService2);
          });
        }, function(error) {
          console.error("fail: ", error);
        }, options)
      })
    }

    function saveAlbumMediaProfilePhoto(opts) {                               // GALLERY DEVICE PROFILE PHOTO
      return $q(function(resolve) {

        var resultMedias = [];
        var args = {
          'selectMode': 100,
          'maxSelectCount': 1
        }
        MediaPicker.getMedias(args, function(medias) { //photoLibrary
          console.log("success: ", medias);
          medias.index = 0;
          FileService2.cleanImages();
          $rootScope.moment = 0;
          var promise1 = "";
          var promise2 = "";
          var promise3 = "";
          var isIOS = ionic.Platform.isIOS();
          if (isIOS) {
            var newMedia = medias[0];
            medias[0].quality = 55;
            MediaPicker.compressImage(medias[0], function(compressData) {
              MediaPicker.getExifForKey(compressData.path, "Orientation", function(oriExif) {
                console.log("data", oriExif);
                promise1 = imageUriToImage64Fix(compressData.uri, 2, oriExif);
              })
            })
          } else {
            medias[0].quality = 55;
            MediaPicker.compressImage(medias[0], function(compressData) {
              promise1 = imageUriToImage64(compressData.uri, 2);
            })
          }
          $q.all([promise1, promise2, promise3]).then(function success() {
            resolve(FileService2);
          });
        }, function(error) {
          console.error("fail: ", error);
        });
      });
    }

    function saveAlbumMediaBackgroundPhoto(opts) {                            // GALLERY DEVICE BACKGROUND PHOTO
      return $q(function(resolve) {

        var resultMedias = [];
        var args = {
          'selectMode': 100,
          'maxSelectCount': 1
        }
        MediaPicker.getMedias(args, function(medias) { //photoLibrary
          console.log("success: ", medias);
          medias.index = 0;
          FileService2.cleanImages();
          medias[0].quality = 55;
          $rootScope.moment = 0;
          var promise1 = "";
          var isIOS = ionic.Platform.isIOS();
          if (isIOS) {
            MediaPicker.compressImage(medias[0], function(compressData) {
              MediaPicker.getExifForKey(compressData.path, "Orientation", function(oriExif) {
                console.log("data", oriExif);
                promise1 = backimageUriToImage64Fix(compressData.uri, 1, oriExif);
              })
            })
          } else {
            MediaPicker.compressImage(medias[0], function(compressData) {
              promise1 = backimageUriToImage64(compressData.uri, 0);
            })
          }
          $q.all([promise1]).then(function success() {
            resolve(FileService2);
          });
        }, function(error) {
          console.error("fail: ", error);
        })
      });
    }

    function saveAlbumMediaReactPhoto(opts) {                                 // GALLERY DEVICE REACT PHOTO
      return $q(function(resolve) {

        var resultMedias = [];
        var args = {
          'selectMode': 100,
          'maxSelectCount': 1
        }
        MediaPicker.getMedias(args, function(medias) { //photoLibrary
          console.log("success: ", medias);
          medias.index = 0;
          FileService2.cleanImages();
          medias[0].quality = 55;
          $rootScope.moment = 0;
          var promise1 = "";
          var isIOS = ionic.Platform.isIOS();
          if (isIOS) {
            MediaPicker.compressImage(medias[0], function(compressData) {
              MediaPicker.getExifForKey(compressData.path, "Orientation", function(oriExif) {
                console.log("data", oriExif);
                promise1 = reactUriToImage64Fix(compressData.uri, 0, oriExif);
              })
            })
          } else {
            MediaPicker.compressImage(medias[0], function(compressData) {
              promise1 = reactUriToImage64(compressData.uri, 0);
            })
          }
          //var promise1 = backimageUriToImage64(medias[0].path);
          $q.all([promise1]).then(function success() {
            resolve(FileService2);
          });
        }, function(error) {
          console.error("fail: ", error);
        });

      });
    }

    function saveAlbumMediaPostPhoto(opts) {                                  // GALLERY DEVICE POST PHOTO
      return $q(function(resolve) {
        var resultMedias = [];
        var args = {
          'selectMode': 100,
          'maxSelectCount': 30
        }
        MediaPicker.getMedias(args, function(medias) {
          console.log("success: ", medias);
          FileService2.cleanImages();
          var promises = [];
          $rootScope.moment = 1;
          for (var i = 0; i < medias.length; i++) {
            medias[i].quality = 55;            
            var mediaSel = medias[i];
            var isIOS = ionic.Platform.isIOS();
            if (isIOS) {
              MediaPicker.compressImage(medias[i], function(compressData) {
                MediaPicker.getExifForKey(compressData.path, "Orientation", function(oriExif) {
                  console.log("data", oriExif);
                  promises.push(postUriToImage64Fix(compressData.uri, medias.length, oriExif));
                })
              })
            } else {
              MediaPicker.compressImage(mediaSel, function(compressData) {
                promises.push(postUriToImage64(compressData.path, medias.length));
              })
            }
          }
          $q.all(promises).then(function success() {
            console.log("resolved");
            resolve(FileService2);
          });
        }, function(error) {
          console.error("fail: ", error);
        })
      })
    }

    function saveAlbumMediaStreamPhoto(opts) {                                // GALLERY DEVICE STREAM PHOTO
      return $q(function(resolve) {
        var resultMedias = [];
        var args = {
          'selectMode': 100,
          'maxSelectCount': 1
        }
        MediaPicker.getMedias(args, function(medias) {
          console.log("success: ", medias);
          FileService2.cleanImages();
          var promises = [];
          $rootScope.moment = 1;
          for (var i = 0; i < medias.length; i++) {
            medias[i].quality = 55;            
            var mediaSel = medias[i];
            var isIOS = ionic.Platform.isIOS();
            if (isIOS) {
              MediaPicker.compressImage(medias[i], function(compressData) {
                MediaPicker.getExifForKey(compressData.path, "Orientation", function(oriExif) {
                  console.log("data", oriExif);
                  promises.push(streamUriToImage64Fix(compressData.uri, medias.length, oriExif));
                })
              })
            } else {
              MediaPicker.compressImage(mediaSel, function(compressData) {
                promises.push(streamUriToImage64(compressData.path, medias.length));
              })
            }
          }
          $q.all(promises).then(function success() {
            console.log("resolved");
            resolve(FileService2);
          });
        }, function(error) {
          console.error("fail: ", error);
        })
      })
    }

    function saveAlbumMediaMessagePhoto(opts) {                               // GALLERY DEVICE MESSAGE PHOTO
      return $q(function(resolve) {
        var resultMedias = [];
        var args = {
          'selectMode': 100,
          'maxSelectCount': 1
        }
        MediaPicker.getMedias(args, function(medias) {
          console.log("success: ", medias);
          FileService2.cleanImages();
          var promises = [];
          $rootScope.moment = 1;
          for (var i = 0; i < medias.length; i++) {
            medias[i].quality = 55;            
            var mediaSel = medias[i];
            var isIOS = ionic.Platform.isIOS();
            if (isIOS) {
              MediaPicker.compressImage(medias[i], function(compressData) {
                MediaPicker.getExifForKey(compressData.path, "Orientation", function(oriExif) {
                  console.log("data", oriExif);
                  promises.push(messageUriToImage64Fix(compressData.uri, medias.length, oriExif));
                })
              })
            } else {
              MediaPicker.compressImage(mediaSel, function(compressData) {
                promises.push(messageUriToImage64(compressData.path, medias.length));
              })
            }
          }
          $q.all(promises).then(function success() {
            console.log("resolved");
            resolve(FileService2);
          });
        }, function(error) {
          console.error("fail: ", error);
        });

      });
    }

    function saveAlbumMediaPromoPhoto(opts) {                                  // GALLERY DEVICE PROMO PHOTO
      return $q(function(resolve) {
        var resultMedias = [];
        var args = {
          'selectMode': 100,
          'maxSelectCount': 30
        }
        MediaPicker.getMedias(args, function(medias) {
          console.log("success: ", medias);
          FileService2.cleanImages();
          var promises = [];
          $rootScope.moment = 1;
          for (var i = 0; i < medias.length; i++) {
            medias[i].quality = 55;            
            var mediaSel = medias[i];
            var isIOS = ionic.Platform.isIOS();
            if (isIOS) {
              MediaPicker.compressImage(medias[i], function(compressData) {
                MediaPicker.getExifForKey(compressData.path, "Orientation", function(oriExif) {
                  console.log("data", oriExif);
                  promises.push(promoUriToImage64Fix(compressData.uri, medias.length, oriExif));
                })
              })
            } else {
              MediaPicker.compressImage(mediaSel, function(compressData) {
                promises.push(promoUriToImage64(compressData.path, medias.length));
              })
            }
          }
          $q.all(promises).then(function success() {
            console.log("resolved");
            resolve(FileService2);
          });
        }, function(error) {
          console.error("fail: ", error);
        })
      })
    }
    /*END NEW PLUGIN SECTION*/
    function saveGroupMainPhoto(type) { //NOT USED ANYMORE
      return $q(function(resolve) {

        var options = optionsProfilePhoto(type);

        $cordovaCamera.getPicture(options).then(function(imageUri) {
          FileService2.cleanImages();
          var promise1 = imageUriToImage64(imageUri);
          $q.all([promise1]).then(function success() {
            resolve(FileService2);
          });
        });
      });
    }

    function saveBackPhoto(type) { //NOT USED ANYMORE
      return $q(function(resolve) {

        var options = optionsBackPhoto(type);

        $cordovaCamera.getPicture(options).then(function(imageUri) {
          FileService2.cleanImages();
          var promise1 = backimageUriToImage64(imageUri);
          $q.all([promise1]).then(function success() {
            resolve(FileService2);
          });
        });
      });
    }

    function saveCommentImage(type) { //NOT USED ANYMORE
      return $q(function(resolve) {

        var options = optionsProfilePhoto(type);

        $cordovaCamera.getPicture(options).then(function(imageUri) {
          FileService2.cleanImages();
          imageUriToImage64(imageUri, 400, 396).then(function success() {
            resolve(FileService2);
          });
        });
      });
    }

    function imageUriToImage64(imageUri, final) {                             // RETURN IMAGE
      return $q(function(resolve) {
        var newUri = window.Ionic.WebView.convertFileSrc(imageUri);
        FileService2.storeImage(newUri);
        $rootScope.$broadcast('addedImageB');
        resolve();
        /*loadImage(imageUri, function(img) {
          var dataURL = img.toDataURL("image/jpeg");
          FileService2.storeImage(dataURL);
          $rootScope.$broadcast('addedImageB');
          resolve();
        }, {
          canvas: true,
          maxWidth: 400,
          maxHeight: 400
        })*/
      });
    }

    function imageUriToImage64Fix(imageUri, final, exif) {                    // RETURN IMAGE AND EXIF
      return $q(function(resolve) {
        var newUri = window.Ionic.WebView.convertFileSrc(imageUri);
        loadImage(newUri, function(img) {
          var dataURL = img.toDataURL("image/jpeg");
          FileService2.storeImageFix(dataURL, exif);
          $rootScope.$broadcast('addedImageB');
          resolve();
        }, {
          canvas: true,
          //orientation: exif,
          maxWidth: 400,
          maxHeight: 400
        })
      })
    }

    function backimageUriToImage64(imageUri, final) {                         // RETURN IMAGE
      return $q(function(resolve) {
        var newUri = window.Ionic.WebView.convertFileSrc(imageUri);
        FileService2.storeImage(newUri);
        $rootScope.$broadcast('addedImageC');
        resolve();
        /*loadImage(imageUri, function(img) {
          var dataURL = img.toDataURL("image/jpeg");
          FileService2.storeImage(dataURL);
          $rootScope.$broadcast('addedImageC');
          resolve();
        }, {
          canvas: true,
          maxWidth: 650,
          maxHeight: 650
        })*/
      });
    }

    function backimageUriToImage64Fix(imageUri, final, exif) {                // RETURN IMAGE AND EXIF
      return $q(function(resolve) {
        var newUri = window.Ionic.WebView.convertFileSrc(imageUri);
        loadImage(newUri, function(img) {
          var dataURL = img.toDataURL("image/jpeg");
          FileService2.storeImageFix(dataURL, exif);
          $rootScope.$broadcast('addedImageC');
          resolve();
        }, {
          canvas: true,
          //orientation: exif,
          maxWidth: 650,
          maxHeight: 650
        })
      })
    }

    function reactUriToImage64(imageUri, final) {                             // RETURN IMAGE
      return $q(function(resolve) {
        var newUri = window.Ionic.WebView.convertFileSrc(imageUri);
        FileService2.storeImage(newUri);
        $rootScope.$broadcast('addedImageR');
        resolve();
        /*loadImage(imageUri, function(img) {
          var dataURL = img.toDataURL("image/jpeg");
          FileService2.storeImage(dataURL);
          $rootScope.$broadcast('addedImageR');
          resolve();
        }, {
          canvas: true,
          maxWidth: 1200,
          maxHeight: 1200
        })*/
      });
    }

    function reactUriToImage64Fix(imageUri, final, exif) {                    // RETURN IMAGE AND EXIF
      return $q(function(resolve) {
        var newUri = window.Ionic.WebView.convertFileSrc(imageUri);
        loadImage(newUri, function(img) {
          var dataURL = img.toDataURL("image/jpeg");
          FileService2.storeImageFix(dataURL, exif);
          $rootScope.$broadcast('addedImageR');
          resolve();
        }, {
          canvas: true,
          //orientation: exif,
          maxWidth: 1200,
          maxHeight: 1200
        })
      })
    }

    function postUriToImage64(imageUri, final) {                              // RETURN IMAGE
      return $q(function(resolve) {
        var newUri = window.Ionic.WebView.convertFileSrc(imageUri);
        FileService2.storeImage(newUri);
        if ($rootScope.moment === final)
          $rootScope.$broadcast('addedImagePost');
        $rootScope.moment++;
        resolve();
        /*loadImage(imageUri, function(img) {
          var dataURL = img.toDataURL("image/jpeg");
          //var blobSent = dataURL.replace("data:image/jpeg;base64",  "");
          FileService2.storeImage(dataURL);
          if ($rootScope.moment === final)
            $rootScope.$broadcast('addedImagePost');
          $rootScope.moment++;
          resolve();
        }, {
          canvas: true,
          maxWidth: 750,
          maxHeight: 750
        })*/
      })
    }

    function postUriToImage64Fix(imageUri, final, exif) {                     // RETURN IMAGE AND EXIF
      return $q(function(resolve) {
        var newUri = window.Ionic.WebView.convertFileSrc(imageUri);
        loadImage(newUri, function(img) {
          var dataURL = img.toDataURL("image/jpeg");
          FileService2.storeImageFix(dataURL, exif);
          if ($rootScope.moment === final)
            $rootScope.$broadcast('addedImagePost');
          $rootScope.moment++;
          resolve();
        }, {
          canvas: true,
          //orientation: exif,
          maxWidth: 750,
          maxHeight: 750
        })
      })
    }

    function promoUriToImage64(imageUri, final) {                              // RETURN IMAGE
      return $q(function(resolve) {
        var newUri = window.Ionic.WebView.convertFileSrc(imageUri);
        FileService2.storeImage(newUri);
        if ($rootScope.moment === final)
          $rootScope.$broadcast('addedImagePromo');
        $rootScope.moment++;
        resolve();
        /*loadImage(imageUri, function(img) {
          var dataURL = img.toDataURL("image/jpeg");
          //var blobSent = dataURL.replace("data:image/jpeg;base64",  "");
          FileService2.storeImage(dataURL);
          if ($rootScope.moment === final)
            $rootScope.$broadcast('addedImagePost');
          $rootScope.moment++;
          resolve();
        }, {
          canvas: true,
          maxWidth: 750,
          maxHeight: 750
        })*/
      })
    }

    function promoUriToImage64Fix(imageUri, final, exif) {                     // RETURN IMAGE AND EXIF
      return $q(function(resolve) {
        var newUri = window.Ionic.WebView.convertFileSrc(imageUri);
        loadImage(newUri, function(img) {
          var dataURL = img.toDataURL("image/jpeg");
          FileService2.storeImageFix(dataURL, exif);
          if ($rootScope.moment === final)
            $rootScope.$broadcast('addedImagePromo');
          $rootScope.moment++;
          resolve();
        }, {
          canvas: true,
          //orientation: exif,
          maxWidth: 750,
          maxHeight: 750
        })
      })
    }

    function streamUriToImage64(imageUri, final) {                            // RETURN IMAGE
      return $q(function(resolve) {
        var newUri = window.Ionic.WebView.convertFileSrc(imageUri);
        FileService2.storeImage(newUri);
        if ($rootScope.moment === final)
          $rootScope.$broadcast('addedImageStream');
        $rootScope.moment++;
        resolve();
        /*loadImage(imageUri, function(img) {
          var dataURL = img.toDataURL("image/jpeg");
          //var blobSent = dataURL.replace("data:image/jpeg;base64",  "");
          FileService2.storeImage(dataURL);
          if ($rootScope.moment === final)
            $rootScope.$broadcast('addedImageStream');
          $rootScope.moment++;
          resolve();
        }, {
          canvas: true,
          maxWidth: 750,
          maxHeight: 750
        })*/
      })
    }

    function streamUriToImage64Fix(imageUri, final, exif) {                   // RETURN IMAGE AND EXIF
      return $q(function(resolve) {
        var newUri = window.Ionic.WebView.convertFileSrc(imageUri);
        loadImage(newUri, function(img) {
          var dataURL = img.toDataURL("image/jpeg");
          FileService2.storeImageFix(dataURL, exif);
          if ($rootScope.moment === final)
            $rootScope.$broadcast('addedImageStream');
          $rootScope.moment++;
          resolve();
        }, {
          canvas: true,
          //orientation: exif,
          maxWidth: 750,
          maxHeight: 750
        })
      })
    }

    function messageUriToImage64(imageUri, final) {                           // RETURN IMAGE
      return $q(function(resolve) {
        var newUri = window.Ionic.WebView.convertFileSrc(imageUri);
        FileService2.storeImage(newUri);
        if ($rootScope.moment === final)
          $rootScope.$broadcast('addedImageMsg');
        $rootScope.moment++;
        resolve();
        /*loadImage(imageUri, function(img) {
          var dataURL = img.toDataURL("image/jpeg");
          FileService2.storeImage(dataURL);
          if ($rootScope.moment === final)
            $rootScope.$broadcast('addedImageMsg');
          $rootScope.moment++;
          resolve();
        }, {
          canvas: true,
          maxWidth: 550,
          maxHeight: 550
        })*/
      })
    }

    function messageUriToImage64Fix(imageUri, final, exif) {                  // RETURN IMAGE AND EXIF
      return $q(function(resolve) {
        var newUri = window.Ionic.WebView.convertFileSrc(imageUri);
        loadImage(newUri, function(img) {
          var dataURL = img.toDataURL("image/jpeg");
          FileService2.storeImageFix(dataURL, exif);
          if ($rootScope.moment === final)
            $rootScope.$broadcast('addedImageMsg');
          $rootScope.moment++;
          resolve();
        }, {
          canvas: true,
          //orientation: exif,
          maxWidth: 550,
          maxHeight: 550
        })
      })
    }

    function imageUriToImage64ThumbFix(imageUri, exif) { //NO USED
      return $q(function(resolve) {
        loadImage(imageUri, function(img) {
          //return CANVAS
          var dataURL = img.toDataURL("image/jpeg");
          FileService.storeThumb(dataURL);
          console.log("image Fixed is loaded");
          resolve();
        }, {
          canvas: true,
          orientation: exif
        })
      })
    }

    return {
      saveMedia: saveMedia,
      //saveProfilePhoto: saveProfilePhoto,
      saveUserProfilePhoto: saveUserProfilePhoto,
      saveCameraMediaProfilePhoto: saveCameraMediaProfilePhoto,
      saveCameraMediaBackgroundPhoto: saveCameraMediaBackgroundPhoto,
      saveCameraMediaReactPhoto: saveCameraMediaReactPhoto,
      saveCameraMediaPostPhoto: saveCameraMediaPostPhoto,
      saveCameraMediaStreamPhoto: saveCameraMediaStreamPhoto,
      saveCameraMediaMessagePhoto: saveCameraMediaMessagePhoto,
      saveCameraMediaPromoPhoto: saveCameraMediaPromoPhoto,
      saveAlbumMediaProfilePhoto: saveAlbumMediaProfilePhoto,
      saveAlbumMediaBackgroundPhoto: saveAlbumMediaBackgroundPhoto,
      saveAlbumMediaReactPhoto: saveAlbumMediaReactPhoto,
      saveAlbumMediaPostPhoto: saveAlbumMediaPostPhoto,
      saveAlbumMediaStreamPhoto: saveAlbumMediaStreamPhoto,
      saveAlbumMediaMessagePhoto: saveAlbumMediaMessagePhoto,
      saveAlbumMediaPromoPhoto: saveAlbumMediaPromoPhoto,
      saveGroupMainPhoto: saveGroupMainPhoto,
      saveBackPhoto: saveBackPhoto,
      saveCommentImage: saveCommentImage,
      imageUriToImage64: imageUriToImage64,
      backimageUriToImage64: backimageUriToImage64
    };
  })

  .factory('FileVideoService', function() {
    var video = null;
    var videoThumb = null;

    function addVideo(data) {
      video = data;
    }

    function getVideo() {
      return video;
    }

    function cleanVideo() {
      video = null;
    }

    return {
      storeVideo: addVideo,
      video: getVideo,
      cleanVideo: cleanVideo
    };
  })

  .factory('VideoService', function($cordovaCamera, $q, FileVideoService) {
    function optionsForType() {
      return {
        destinationType: Camera.DestinationType.FILE_URI,
        sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
        allowEdit: true,
        mediaType: Camera.MediaType.VIDEO
      };
    }

    function saveVideoMedia() {
      var options = optionsForType();
      return $q(function(resolve) {
        var promise = [];
        $cordovaCamera.getPicture(options).then(function(videoData) {
          console.log("video URI= " + videoData);
          promise.push(FileVideoService.storeVideo(videoData));
          $q.all(promise).then(function success() {
            resolve(FileVideoService);
          });
        });
      });
    }

    function saveVideoMediaNew(opts) {
      return $q(function(resolve) {

        var resultMedias = [];
        var args = {
          'selectMode': 102,
          'maxSelectCount': 1,
          'maxSelectSize': "2048MB" 
        }
        MediaPicker.getMedias(args, function(medias) {
          console.log("success: ", medias);
          //tryCompresss(medias[0]);
          var promises = [];
          promises.push(FileVideoService.storeVideo(medias[0]));
          $q.all(promises).then(function success() {
            console.log("resolved");
            resolve(FileVideoService);
          });
        }, function(error) {
          console.error("fail: ", error);
        });
      });
    }

    function tryCompresss(video) {
      if (video.size > 1048576) {
        video.quality = 50;
      } else {
        video.quality = 100;
      }
      MediaPicker.compressImage(video, function(videoCompress) {
        var promises = [];
        promises.push(FileVideoService.storeVideo(videoCompress));
        $q.all(promises).then(function success() {
          console.log("resolved");
          resolve(FileVideoService);
        });
      }, function(error) {
        console.error("error with compress", error)
      })
    }

    return {
      saveVideoMedia: saveVideoMedia,
      saveVideoMediaNew: saveVideoMediaNew
    };
  })

  .factory("QRScannerService", function($q) {
    var defaultOptions = {
      preferFrontCamera: false, // iOS and Android
      showFlipCameraButton: true, // iOS and Android
      showTorchButton: true, // iOS and Android
      torchOn: false, // Android, launch with the torch switched on (if available)
      saveHistory: false, // Android, save scan history (default false)
      prompt: "Place a barcode inside the scan area", // Android
      resultDisplayDuration: 0, // Android, display scanned text for X ms. 0 suppresses it entirely, default 1500
      formats: "QR_CODE,PDF_417", // default: all but PDF_417 and RSS_EXPANDED
      //orientation : "landscape", // Android only (portrait|landscape), default unset so it rotates with the device
      disableAnimations: false, // iOS
      disableSuccessBeep: true // iOS and Android
    };

    /**
     * @param options
     * @return {Promise<{cancelled:boolean, format: string, text: string}>}
     */
    function scan(options) {
      var deferred = $q.defer();
      cordova.plugins.barcodeScanner.scan(function(result) {
          deferred.resolve(result);
        }, function(error) {
          console.error("Couldn't scan the QR code", error);
          deferred.reject(error)
        },
        options || defaultOptions
      );

      return deferred.promise;
    }

    return {
      scan: scan
    }
  })

  //service to pass selected data between pages
  .factory('networkService', function($rootScope, $cordovaNetwork) {
    /**
     * @type {'unknown',|
     *     'ethernet',|
     *     'wifi',|
     *     Connection.CELL_2G,|
     *     Connection.CELL_3G,|
     *     Connection.CELL_4G,|
     *     'cell',|
     *     'none'}
     */
    var status = 'none';

    document.addEventListener("deviceready", function() {
      var isOnline = $cordovaNetwork.isOnline();
      //console.log("***isOnline: ", isOnline);
      if (isOnline === false) {
        status = 'none';
      } else {
        status = $cordovaNetwork.getNetwork();
        //console.log("***$cordovaNetwork.getNetwork()", status);
      }

      // listen when the internet comeback
      $rootScope.$on('$cordovaNetwork:online', function(event, networkState) {
        status = networkState;
        //console.log("***Network online", status)
      });

      // listen when the internet go out
      $rootScope.$on('$cordovaNetwork:offline', function(event, networkState) {
        status = networkState;
        //console.warn("***Network offline", status)
      });
    }, false);

    function isOnline() {
      return $cordovaNetwork ? $cordovaNetwork.isOnline() : false;
    }

    function isOffline() {
      return $cordovaNetwork ? $cordovaNetwork.isOffline() : true;
    }

    return {
      status: status,
      isOnline: isOnline,
      isOffline: isOffline
    };
  })

  //service to pass selected data between pages
  .factory('usersData', function() {
    var ret = function() {};
    ret.userChosen = "";
    ret.anadir = function(nuevoElemento) {
      ret.userChosen = nuevoElemento;
    };
    ret.limpiar = function() {
      ret.userChosen = "";
    };
    return ret;
  })

  //service to pass cqnz data between pages
  .factory('cqnzData', function() {
    var ret = function() {};
    ret.keycomment = "";
    ret.sequenceSelected = "";
    ret.subscriptionInstanceId = "";
    ret.owns = "";
    ret.listIndex = null;
    ret.anadir = function(keycomment, sequenceSelected, subscriptionInstanceId, owns) {
      ret.keycomment = keycomment;
      ret.sequenceSelected = sequenceSelected;
      ret.subscriptionInstanceId = subscriptionInstanceId;
      ret.owns = owns;
    };
    ret.limpiar = function() {
      ret.keycomment = "";
      ret.sequenceSelected = "";
      ret.subscriptionInstanceId = "";
      ret.owns = "";
    };
    return ret;
  })

  //service to pass friends data between pages
  .factory('friendsData', function() {
    var ret = function() {};
    ret.friends = [];
    ret.anadir = function(nuevoElemento) {
      ret.friends = nuevoElemento;
    };
    ret.limpiar = function() {
      ret.followers = "";
    };
    return ret;
  })

  //service to pass followers data between pages
  .factory('followersData', function() {
    var ret = function() {};
    ret.followers = "";
    ret.anadir = function(nuevoElemento) {
      ret.followers = nuevoElemento;
    };
    ret.limpiar = function() {
      ret.followers = "";
    };
    return ret;
  })

  //Service to pass likes/users data between pages
  .factory('likeUsersData', function() {
    var like = function() {};
    like.count = "";
    like.data = "";
    //like.count = [];
    like.anadir = function(nuevoElemento, nuevoElemento2) {
      like.count = nuevoElemento;
      like.data = nuevoElemento2;
    };
    like.limpiar = function() {
      like.count = "";
      like.count = "";
    };
    return like;
  })

  .factory('visitedFriendData', function() {
    var num = function() {};
    num.idVisited = "";
    //like.count = [];
    num.anadir = function(nuevoElemento) {
      num.idVisited = nuevoElemento;
    };
    num.limpiar = function() {
      num.idVisited = "";
    };
    return num;
  })

  .factory('selectedSequenceData', function() {
    var cqnz = function() {};
    cqnz.idSelected = "";
    cqnz.idInstanceSelected = "";
    cqnz.ownerSelected = "";
    cqnz.anadir = function(newElement, newElement2, newElement3) {
      cqnz.idSelected = newElement;
      cqnz.idInstanceSelected = newElement2;
      cqnz.ownerSelected = newElement3;
    };
    cqnz.limpiar = function() {
      cqnz.idSelected = "";
    };
    return cqnz;
  })

  //Service to pass data for Number of pending notifications
  .factory('pendingNotificationData', function() {
    var num = function() {};
    num.pending = "";
    //like.count = [];
    num.anadir = function(nuevoElemento) {
      num.pending = nuevoElemento;
    };
    num.limpiar = function() {
      num.pending = "";
    };
    return num;
  })

  .factory('MultiImageService', function(FileService, $q) {
    function saveMedia(imageMulti) {
      return $q(function(resolve) {

        FileService.storeImage(imageMulti);
        FileService.storeThumb('data:image/jpeg;base64,' + imageMulti);
        FileService.storeBlobImage('data:image/jpeg;base64,' + imageMulti);
        FileService.storeBlobThumbNew('data:image/jpeg;base64,' + imageMulti);
        resolve(FileService);
      });
    }

    return {
      //
      handleMediaDialog: saveMedia
    };
  })

  //Service for socket
  .factory('socket', function(socketFactory) {
    //var myIoSocket = io.connect('https://socket-io-chat.now.sh/');
    //var myIoSocket = io.connect('http://ec2-34-212-194-26.us-west-2.compute.amazonaws.com:3000/');
    //var myIoSocket = io.connect('http://ec2-54-69-184-92.us-west-2.compute.amazonaws.com:3000/');

    var mySocket = socketFactory({
      ioSocket: myIoSocket
    });

    return mySocket;
  })

  .factory('SequenceService', ['$resource', '$q', 'ApiEndPoint', function($resource, $q, ApiEndPoint) {
    return {
      addNewSequence: function(userSubscriptionInstanceId) {
        return $resource(
          ApiEndPoint.url + 'restful/objects/simple.UserSubscription/:userSubscriptionInstanceId/actions/addSequence/invoke', userSubscriptionInstanceId, {
            post: {
              method: 'POST',
              headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1' }
            }
          }
        );
      },
      addNewSequencev181: function(userSubscriptionInstanceId) {
        return $resource(
          ApiEndPoint.url + 'restful/objects/simple.UserSubscription/:userSubscriptionInstanceId/actions/addSequencev181/invoke', userSubscriptionInstanceId, {
            post: {
              method: 'POST',
              headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1' }
            }
          }
        );
      },
      /**
       * @param data {{
       *   userId:number,
       *   description:string,
       *   templateId:string,
       *   itemCount:number,
       *   sequenceType:number,
       *   commentsEnabled:boolean,
       *   temporary:number,
       *   shareable:boolean,
       *   sharelife:number,
       *   isAdvertisement:boolean,
       *   headerBgColor:string,
       *   headerFontColor:string,
       *   finalDate:string
       * }}
       */
      addNewSequencev100: function(data) {
        //comment the next lines if you want to send the time in the UTC time
        //it means, without consider your local time offset
        // e.g. in mexico is located at GMT-6 so when the local time is 17:00:00 you'll get 23:00:00
        if (data.finalDate && data.finalDate instanceof Date) {
          var timeOffsetInMS = data.finalDate.getTimezoneOffset() * 60000;
          data.finalDate.setTime(data.finalDate.getTime() - timeOffsetInMS);
        }

        return $resource(
          ApiEndPoint.url + 'restful/services/SequenceRepository/actions/addSequencev100/invoke', {},
          //ApiEndPoint.url + 'restful/objects/simple.UserSubscription/:userSubscriptionInstanceId/actions/addSequencev100/invoke',
          //{userSubscriptionInstanceId: data.userId},
          {
            post: {
              method: 'POST',
              headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1' }
            }
          }
        ).save({
          userSub: { value: { href: ApiEndPoint.url + "restful/objects/simple.UserSubscription/" + data.userId } }, //<-- for use with restful/services/...
          description: { value: data.description },
          templateId: { value: data.templateId },
          itemCount: { value: data.itemCount },
          sequenceType: { value: data.sequenceType },
          commentEnable: { value: data.commentsEnabled },
          temporary: { value: data.temporary },
          shareable: { value: data.shareable },
          sharelife: { value: data.sharelife },
          isAdvertisement: { value: data.isAdvertisement },
          headerBgColor: { value: data.headerBgColor || '' },
          headerFontColor: { value: data.headerFontColor || '' },
          finalDate: { value: data.finalDate || '' }
        });
      },
      /** NEW WS FOR UPLOAD - ADDED PARAMETER FOR PROMO/EASTEREGG
       * @param data {{
       *   userId:number,
       *   description:string,
       *   templateId:string,
       *   itemCount:number,
       *   sequenceType:number,
       *   commentsEnabled:boolean,
       *   temporary:number,
       *   shareable:boolean,
       *   sharelife:number,
       *   isAdvertisement:boolean,
       *   headerBgColor:string,
       *   headerFontColor:string,
       *   finalDate:string
       * }}
       */
      addNewSequencev101: function(data) {
        //comment the next lines if you want to send the time in the UTC time
        //it means, without consider your local time offset
        // e.g. in mexico is located at GMT-6 so when the local time is 17:00:00 you'll get 23:00:00
        if (data.finalDate && data.finalDate instanceof Date) {
          var timeOffsetInMS = data.finalDate.getTimezoneOffset() * 60000;
          data.finalDate.setTime(data.finalDate.getTime() - timeOffsetInMS);
        }

        return $resource(
          ApiEndPoint.url + 'restful/objects/simple.UserSubscription/:userSubscriptionInstanceId/actions/addSequencev101/invoke', { userSubscriptionInstanceId: data.userId }, {
            post: {
              method: 'POST',
              headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1' }
            }
          }
        ).save({
          description: { value: data.description },
          templateId: { value: data.templateId },
          itemCount: { value: data.itemCount },
          sequenceType: { value: data.sequenceType },
          commentEnable: { value: data.commentsEnabled },
          temporary: { value: data.temporary },
          shareable: { value: data.shareable },
          sharelife: { value: data.sharelife },
          isAdvertisement: { value: data.isAdvertisement },
          headerBgColor: { value: data.headerBgColor || '' },
          headerFontColor: { value: data.headerFontColor || '' },
          finalDate: { value: data.finalDate || '' },
          promotion: { value: data.promo || 0 }
        });
      },
      /** NEW WS FOR UPLOAD - DON'T ADD POST TO PENDING IN AUTOMATIC
       * @param data {{
       *   userId:number,
       *   description:string,
       *   templateId:string,
       *   itemCount:number,
       *   sequenceType:number,
       *   commentsEnabled:boolean,
       *   temporary:number,
       *   shareable:boolean,
       *   sharelife:number,
       *   isAdvertisement:boolean,
       *   headerBgColor:string,
       *   headerFontColor:string,
       *   finalDate:string
       * }}
       */
      addSequencev200: function(data) {
        //comment the next lines if you want to send the time in the UTC time
        //it means, without consider your local time offset
        // e.g. in mexico is located at GMT-6 so when the local time is 17:00:00 you'll get 23:00:00
        if (data.finalDate && data.finalDate instanceof Date) {
          var timeOffsetInMS = data.finalDate.getTimezoneOffset() * 60000;
          data.finalDate.setTime(data.finalDate.getTime() - timeOffsetInMS);
        }

        return $resource(
          ApiEndPoint.url + 'restful/objects/simple.UserSubscription/:userSubscriptionInstanceId/actions/addSequencev200/invoke', { userSubscriptionInstanceId: data.userId }, {
            post: {
              method: 'POST',
              headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1' }
            }
          }
        ).save({
          description: { value: data.description },
          templateId: { value: data.templateId },
          itemCount: { value: data.itemCount },
          sequenceType: { value: data.sequenceType },
          commentEnable: { value: data.commentsEnabled },
          temporary: { value: data.temporary },
          shareable: { value: data.shareable },
          sharelife: { value: data.sharelife },
          isAdvertisement: { value: data.isAdvertisement },
          headerBgColor: { value: data.headerBgColor || '' },
          headerFontColor: { value: data.headerFontColor || '' },
          finalDate: { value: data.finalDate || '' }
        });
      },
      /**NEW WS ADDING TITLE/DESCRIPCTION/URL TO POST **/
      addSequenceV201: function(data) {
        if (data.finalDate && data.finalDate instanceof Date) {
          var timeOffsetInMS = data.finalDate.getTimezoneOffset() * 60000;
          data.finalDate.setTime(data.finalDate.getTime() - timeOffsetInMS);
        }

        return $resource(
          ApiEndPoint.url + 'restful/services/SequenceRepository/actions/addSequencev201/invoke', {}, {
            post: {
              method: 'POST',
              headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1' }
            }
          }
        ).save({
          userSuscriptionId: { value: "" + data.userId },
          description: { value: data.description },
          templateId: { value: data.templateId },
          itemCount: { value: data.itemCount },
          sequenceType: { value: data.sequenceType },
          commentEnable: { value: data.commentsEnabled },
          temporary: { value: data.temporary },
          shareable: { value: data.shareable },
          sharelife: { value: data.sharelife },
          isAdvertisement: { value: data.isAdvertisement },
          headerBgColor: { value: data.headerBgColor || '' },
          headerFontColor: { value: data.headerFontColor || '' },
          finalDate: { value: data.finalDate || '' },
          title: { value: data.title || '' },
          url: { value: data.url || '' }
        })
      },
      /**NEW WS ADDING SCHEDULED TO POST **/
      addSequenceV202: function(data) { //LuMa
        if (data.finalDate && data.finalDate instanceof Date) {
          var timeOffsetInMS = data.finalDate.getTimezoneOffset() * 60000;
          data.finalDate.setTime(data.finalDate.getTime() - timeOffsetInMS);
        }

        return $resource(
          ApiEndPoint.url + 'restful/services/SequenceRepository/actions/addSequencev202/invoke', {}, {
            post: {
              method: 'POST',
              headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1' }
            }
          }
        ).save({
          userSuscriptionId: { value: "" + data.userId },
          description: { value: data.description },
          templateId: { value: data.templateId },
          itemCount: { value: data.itemCount },
          sequenceType: { value: data.sequenceType },
          commentEnable: { value: data.commentsEnabled },
          temporary: { value: data.temporary },
          shareable: { value: data.shareable },
          sharelife: { value: data.sharelife },
          isAdvertisement: { value: data.isAdvertisement },
          headerBgColor: { value: data.headerBgColor || '' },
          headerFontColor: { value: data.headerFontColor || '' },
          finalDate: { value: data.finalDate || '' },
          title: { value: data.title || '' },
          url: { value: data.url || '' },
          initialDate: { value: data.initialDate || null },
          initialTime: { value: data.initialTime || null }
        })
      },
      /**
       * WS FOR ADD POST GENERATED WITH addsequencev200 TO THE PENDINGLOG
       * 
       * 
       **/
      addPostToPendingLogv200: function(data) {
        return $resource(
          ApiEndPoint.url + 'restful/services/SequenceRepository/actions/addPendingLogv200/invoke', {}, {
            post: {
              method: 'GET',
              headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1' }
            }
          }
        ).get({
          "x-isis-querystring": {
            sequence: {
              value: {
                href: ApiEndPoint.url + "restful/objects/simple.Sequence/" + data.sequenceId
              }
            },
            userSubscription: {
              value: {
                href: ApiEndPoint.url + "restful/objects/simple.UserSubscription/" + data.userSubs
              }
            }
          }
        })
      },
      /**
       * @param cqnzData {{
       *   userId:number,
       *   description:string,
       *   templateId:string,
       *   itemCount:number,
       *   sequenceType:number,
       *   groupId:number,
       *   commentEnable:boolean,
       *   temporary:number,
       *   shareable:boolean,
       *   sharelife:number,
       *   isAdvertisement:boolean,
       *   headerBgColor:string,
       *   headerFontColor:string
       * }}
       * @return {Promise}
       */
      addNewGroupSequence: function(cqnzData) {
        return $resource(
          ApiEndPoint.url + 'restful/objects/simple.UserSubscription/:groupSubscriptionInstanceId/actions/addSequenceGroup/invoke', { groupSubscriptionInstanceId: cqnzData.userId }, {
            post: {
              method: 'POST',
              headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1' }
            }
          }
        ).save({
          description: { value: cqnzData.description },
          templateId: { value: cqnzData.templateId },
          itemCount: { value: cqnzData.itemCount },
          sequenceType: { value: cqnzData.sequenceType },
          groupId: { value: cqnzData.groupId },
          commentEnable: { value: cqnzData.commentEnable },
          temporary: { value: cqnzData.temporary },
          shareable: { value: cqnzData.shareable },
          sharelife: { value: cqnzData.sharelife },
          isAdvertisement: { value: cqnzData.isAdvertisement },
          headerBgColor: { value: cqnzData.headerBgColor || '' },
          headerFontColor: { value: cqnzData.headerFontColor || '' }
        }).$promise;
      },
      /** NEW WS FOR UPLOAD - ADDED PARAMETER FOR PROMO/EASTEREGG
       * @param cqnzData {{
       *   userId:number,
       *   description:string,
       *   templateId:string,
       *   itemCount:number,
       *   sequenceType:number,
       *   groupId:number,
       *   commentEnable:boolean,
       *   temporary:number,
       *   shareable:boolean,
       *   sharelife:number,
       *   isAdvertisement:boolean,
       *   headerBgColor:string,
       *   headerFontColor:string
       * }}
       * @return {Promise}
       */
      addNewGroupSequencev101: function(cqnzData) {
        return $resource(
          ApiEndPoint.url + 'restful/objects/simple.UserSubscription/:groupSubscriptionInstanceId/actions/addSequenceGroupv101/invoke', { groupSubscriptionInstanceId: cqnzData.userId }, {
            post: {
              method: 'POST',
              headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1' }
            }
          }
        ).save({
          description: { value: cqnzData.description },
          templateId: { value: cqnzData.templateId },
          itemCount: { value: cqnzData.itemCount },
          sequenceType: { value: cqnzData.sequenceType },
          groupId: { value: cqnzData.groupId },
          commentEnable: { value: cqnzData.commentEnable },
          temporary: { value: cqnzData.temporary },
          shareable: { value: cqnzData.shareable },
          sharelife: { value: cqnzData.sharelife },
          isAdvertisement: { value: cqnzData.isAdvertisement },
          headerBgColor: { value: cqnzData.headerBgColor || '' },
          headerFontColor: { value: cqnzData.headerFontColor || '' },
          promotion: { value: cqnzData.promo || 0 }
        }).$promise;
      },

      addNewGroupSequencev201: function(cqnzData) {
        return $resource(
          ApiEndPoint.url + 'restful/services/SequenceRepository/actions/addSequenceGroupv201/invoke', {}, {
            post: {
              method: 'POST',
              headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1' }
            }
          }
        ).save({
          userSuscriptionId: { value: "" + cqnzData.userId },
          description: { value: cqnzData.description },
          templateId: { value: cqnzData.templateId },
          itemCount: { value: cqnzData.itemCount },
          sequenceType: { value: cqnzData.sequenceType },
          groupId: { value: cqnzData.groupId },
          commentEnable: { value: cqnzData.commentEnable },
          temporary: { value: cqnzData.temporary },
          shareable: { value: cqnzData.shareable },
          sharelife: { value: cqnzData.sharelife },
          isAdvertisement: { value: cqnzData.isAdvertisement },
          headerBgColor: { value: cqnzData.headerBgColor || '' },
          headerFontColor: { value: cqnzData.headerFontColor || '' },
          title: { value: data.title || '' },
          url: { value: data.url || '' }
        }).$promise;
      },

      addNewGroupSequencev202: function(cqnzData) {
        return $resource(
          ApiEndPoint.url + 'restful/services/SequenceRepository/actions/addSequenceGroupv202/invoke', {}, {
            post: {
              method: 'POST',
              headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1' }
            }
          }
        ).save({
          userSuscriptionId: { value: "" + cqnzData.userId },
          description: { value: cqnzData.description },
          templateId: { value: cqnzData.templateId },
          itemCount: { value: cqnzData.itemCount },
          sequenceType: { value: cqnzData.sequenceType },
          groupId: { value: cqnzData.groupId },
          commentEnable: { value: cqnzData.commentsEnabled },
          temporary: { value: cqnzData.temporary },
          shareable: { value: cqnzData.shareable },
          sharelife: { value: cqnzData.sharelife },
          isAdvertisement: { value: cqnzData.isAdvertisement },
          headerBgColor: { value: cqnzData.headerBgColor || '' },
          headerFontColor: { value: cqnzData.headerFontColor || '' },
          title: { value: cqnzData.title || '' },
          url: { value: cqnzData.url || '' },
          initialDate: { value: cqnzData.initialDate || null },
          initialTime: { value: cqnzData.initialTime || null }
        }).$promise;
      },
    
      addNewGroupSequencev203: function(cqnzData) {
        return $resource(
          ApiEndPoint.url + 'restful/services/SequenceRepository/actions/addSequenceGroupv203/invoke', {}, {
            post: {
              method: 'POST',
              headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1' }
            }
          }
        ).save({
          userSuscriptionId: { value: "" + cqnzData.userId },
          description: { value: cqnzData.description },
          templateId: { value: cqnzData.templateId },
          itemCount: { value: cqnzData.itemCount },
          sequenceType: { value: cqnzData.sequenceType },
          groupId: { value: cqnzData.groupId },
          commentEnable: { value: cqnzData.commentsEnabled },
          temporary: { value: cqnzData.temporary },
          shareable: { value: cqnzData.shareable },
          sharelife: { value: cqnzData.sharelife },
          isAdvertisement: { value: cqnzData.isAdvertisement },
          headerBgColor: { value: cqnzData.headerBgColor || '' },
          headerFontColor: { value: cqnzData.headerFontColor || '' },
          title: { value: cqnzData.title || '' },
          url: { value: cqnzData.url || '' },
          initialDate: { value: cqnzData.initialDate || null },
          initialTime: { value: cqnzData.initialTime || null },
          finalDate: { value: cqnzData.finalDate || '' }
        }).$promise;
      },
      
      findSequenceBySequenceIdV2: function() {
        return $resource(
          ApiEndPoint.url + 'restful/services/SequenceRepository/actions/findSequenceBySequenceId/invoke', {}, {
            get: {
              method: 'GET',
              headers: { "Accept": "application/json" }
            }
          }
        );
      },

      /**
       * @param sequenceId {string|number}
       * @return {*}
       */
      findSequenceBySequenceIdV181: function(sequenceId) {
        return $resource(
          ApiEndPoint.url + 'restful/services/SequenceRepository/actions/findSequenceBySequenceIdv181/invoke', {}, {
            get: {
              method: 'GET',
              isArray: true,
              headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1" }
            }
          }
        ).get({
          "secuenceId": '"' + sequenceId + '"'
        });
      },

      addItemToSequence: function() {
        return $resource(
          ApiEndPoint.url + 'restful/services/SequenceItemRepository/actions/addSequenceItem/invoke', {}, {
            post: {
              method: 'POST',
              headers: { 'Accept': "application/json;profile=urn:org.apache.isis/v1" }
            }
          }
        );
      },

      addItemToSequencev181: function() {
        return $resource(
          ApiEndPoint.url + 'restful/services/SequenceItemRepository/actions/addSequenceItemv181/invoke', {}, {
            post: {
              method: 'POST',
              headers: { 'Accept': "application/json;profile=urn:org.apache.isis/v1" }
            }
          }
        );
      },

      addSequenceItemComment: function(objectId) {
        return $resource(
          ApiEndPoint.url + 'restful/objects/simple.UserSubscription/:objectId/actions/addSequenceItemComment/invoke',
          objectId, {
            post: {
              method: 'POST',
              headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1" }
            }
          });
      },

      addSequenceComment: function() {
        return $resource(
          ApiEndPoint.url + 'restful/services/SequenceCommentsRepository/actions/addSequenceComments/invoke', {}, {
            post: {
              method: 'POST',
              headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1" }
            }
          });
      },

      /**
       * @param data {{sequenceId:number|string, userId:number|string, comment: string}}
       * @return {Promise}
       */
      addSequenceCommentv166: function(data) {
        return $resource(
          ApiEndPoint.url + 'restful/services/SequenceCommentsRepository/actions/addSequenceCommentsv166/invoke', {}, {
            post: {
              method: 'POST',
              headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1" }
            }
          }).post({
          sequence: {
            value: { href: ApiEndPoint.url + 'restful/objects/simple.Sequence/' + data.sequenceId }
          },
          userSubscriptionId: {
            value: { href: ApiEndPoint.url + 'restful/objects/simple.UserSubscription/' + data.userId }
          },
          comment: { value: data.comment }
        }).$promise;
      },

      /**
       * @param data {{sequenceId:number|string, commentId:number|string, start:number, count:number}}
       * @return {*}
       */
      findTheAnswersOfAComment: function(data) {
        return $resource(
          ApiEndPoint.url + 'restful/services/SequenceCommentsRepository/actions/findTheAnswerOfACommentId/invoke', {}, {
            get: {
              method: 'GET',
              isArray: true,
              headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1" }
            }
          }).get({
          sequenceId: '"' + data.sequenceId + '"',
          commentId: '"' + data.commentId + '"',
          withStart: '"' + data.start + '"',
          withCount: '"' + data.count + '"'
        });
      },

      setLikeToItem: function(objectId) {
        return $resource(
          ApiEndPoint.url + 'restful/objects/simple.SequenceItem/:objectId/actions/like/invoke', objectId, {
            post: {
              method: 'POST',
              headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1" }
            }
          }
        );
      },

      /**
       * @param cqnzId {number}
       * @return Promise{{*}}
       */
      increaseSharesCount: function(cqnzId) {
        return $resource(
          ApiEndPoint.url + 'restful/objects/simple.Sequence/:objectId/actions/shareCount/invoke', { objectId: cqnzId }, {
            post: {
              method: 'POST',
              headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1" }
            }
          }
        ).save().$promise
      },

      increaseSharesCountv1711: function(data) {
        return $resource(
          ApiEndPoint.url + 'restful/objects/simple.Sequence/:objectId/actions/shareCountv1711/invoke', { objectId: data.postId }, {
            post: {
              method: 'POST',
              headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1" }
            }
          }
        ).save({
          userSubscription: {
            value: {
              href: ApiEndPoint.url + "restful/objects/simple.UserSubscription/" + data.senderInstanceId
            }
          }
        }).$promise
      },


      findTheCommentsOfASequenceItem: function() {
        return $resource(
          ApiEndPoint.url + 'restful/objects/simple.SequenceItem/:objectId/actions/findTheCommentsOfASequenceItem/invoke', { objectId: '@objectId' }, {
            get: {
              method: 'GET',
              isArray: true,
              headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1;repr-type=object" }
            }
          }
        );
      },

      /**
       * @param data{{sequenceId: number|string, userId: number|string}}
       * @return {Promise}
       */
      findSmileysCount: function(data) {
        return $resource(
          ApiEndPoint.url + 'restful/services/SequenceRepository/actions/findSmileysCount/invoke', {}, {
            get: {
              method: 'GET',
              headers: { "Content-Type": "application/json;profile=urn:org.apache.isis/v1;repr-type=object" }
            }
          }
        ).get({
          "x-isis-querystring": {
            sequence: {
              value: { href: ApiEndPoint.url + "restful/objects/simple.Sequence/" + data.sequenceId }
            },
            userSubs: {
              value: { href: ApiEndPoint.url + "restful/objects/simple.UserSubscription/" + data.userId }
            }
          }
        });
      },

      findSmileysItemCount: function() {
        return $resource(
          ApiEndPoint.url + 'restful/services/SequenceItemRepository/actions/findSmileysCountbyUserItems/invoke', {}, {
            get: {
              method: 'GET',
              headers: { "Content-Type": "application/json;profile=urn:org.apache.isis/v1;repr-type=object" }
            }
          }
        );
      },


      deleteSequence: function(objectId) {
        return $resource(
          ApiEndPoint.url + 'restful/objects/simple.Sequence/:objectId/actions/delete/invoke', objectId, {
            post: {
              method: 'POST',
              headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1" }
            }
          });
      },

      /**
       * @param data:{{userId: number|string, friendId: number|string}}
       * @return {Promise}
       */
      followEachOther: function(data) {
        return $resource(ApiEndPoint.url + 'restful/services/FriendRepository/actions/followEachOther/invoke', {}, {
          get: {
            method: 'GET',
            headers: { "Accept": "application/json" }
          }
        }).get({
          "x-isis-querystring": {
            userSubscriptionId: { value: { href: ApiEndPoint.url + "restful/objects/simple.UserSubscription/" + data.userId } },
            friendId: { value: { href: ApiEndPoint.url + "restful/objects/simple.UserSubscription/" + data.friendId } }
          }
        });
      },

      sequenceCounts: function(objectId) {
        return $resource(
          ApiEndPoint.url + 'restful/objects/simple.Sequence/:objectId/actions/sequencesCounts/invoke',
          objectId, {
            get: {
              method: 'GET',
              isArray: true,
              headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1" }
            }
          }
        );
      },

      findSequenceCountByType: function(data) {
        return $resource(
          ApiEndPoint.url + 'restful/services/SequenceCountRepository/actions/findSequenceCountByType/invoke', {}, {
            get: {
              method: 'GET',
              isArray: true,
              headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1" }
            }
          }
        ).get({
          "x-isis-querystring": {
            sequence: {
              value: {
                href: ApiEndPoint.url + "restful/objects/simple.Sequence/" + data.sequence
              }
            },
            type: {
              value: data.type
            },
            withStart: {
              value: data.start
            },
            withCount: {
              value: data.count
            }
          }
        });
      },

      obtainSequence: function(objectId) {
        return $resource(
          ApiEndPoint.url + 'restful/objects/simple.Sequence/:objectId', { objectId: objectId }, {
            get: {
              method: 'GET',
              headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1;suppress=true" }
            }
          }).get({});
      },

      findSequenceBySequencev200: function(sequenceId) {
        return $resource(
          ApiEndPoint.url + 'restful/services/SequenceRepository/actions/findSequenceBySequencev200/invoke', {}, {
            get: {
              method: 'GET',
              isArray: true,
              headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1;suppress=true" }
            }
          }
          ).get({
          "x-isis-querystring": {
            sequence: {
              value: {
                href: ApiEndPoint.url + "restful/objects/simple.Sequence/" + sequenceId
              }
            }
          }
        });
      },

         sequenceItems: function(objectId) {
        return $resource(
          ApiEndPoint.url + 'restful/objects/simple.Sequence/:objectId/collections/sequenceItems', { objectId: objectId }, {
            get: {
              method: 'GET',
              isArray: true,
              headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1;suppress=true" }
            }
          }).get({});
      },



      /**
       * @param data {{sequenceId:number|string, userId: number|string}}
       */
      sendTagNotificationUpload: function(data) {
        //console.log(objectId);
        return $resource(
          ApiEndPoint.url + 'restful/objects/simple.Sequence/:objectId/actions/tag/invoke', { objectId: data.sequenceId }, {
            post: {
              method: 'POST',
              headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1" }
            }
          }).save({
          userSubscription: {
            value: {
              href: ApiEndPoint.url + "restful/objects/simple.UserSubscription/" + data.userId
            }
          }
        });
      },

      /**
       * @param data {{sequenceId: number, notificationType: number}}
       * @return {Promise}
       */
      obtainTagwithIdandType: function(data) {
        return $resource(
          ApiEndPoint.url + 'restful/services/SequenceTagRepository/actions/findTagSequence/invoke', {}, {
            get: {
              method: 'GET',
              isArray: true,
              headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1;suppress=true" }
            }
          }
        ).get({
          sequenceId: '"' + data.sequenceId + '"',
          notificationType: '"' + data.notificationType + '"'
        }).$promise;
      },

      /**
       * @param data {{sequenceId:number, notificationType:number}}
       */
      obtainTagwithIdandTypev166: function(data) {
        return $resource(
          ApiEndPoint.url + 'restful/services/SequenceTagRepository/actions/findTagSequencev166/invoke', {}, {
            get: {
              method: 'GET',
              isArray: true,
              headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1;suppress=true" }
            }
          }
        ).get({
          sequenceId: '"' + data.sequenceId + '"',
          notificationType: '"' + data.notificationType + '"'
        }).$promise;
      },

      obtainTagFromComments: function() {
        return $resource(
          ApiEndPoint.url + 'restful/services/SequenceTagRepository/actions/findTagSequenceComment/invoke', {}, {
            get: {
              method: 'GET',
              isArray: true,
              headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1;suppress=true" }
            }
          }
        );
      },

      uploadError: function(objectId) {
        return $resource(
          ApiEndPoint.url + 'restful/objects/simple.Sequence/:objectId/actions/uploadError/invoke', objectId, {
            post: {
              method: 'POST',
              headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1;suppress=true" }
            }
          }
        );
      },


      updateOrder: function(objectId) {
        return $resource(
          ApiEndPoint.url + 'restful/objects/simple.SequenceItem/:objectId/actions/changeItemOrder/invoke', objectId, {
            post: {
              method: 'POST',
              headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1;suppress=true" }
            }
          }
        );
      },

      updateTemplate: function(objectId) {
        return $resource(
          ApiEndPoint.url + 'restful/objects/simple.Sequence/:objectId/actions/changeTemplateId/invoke', objectId, {
            post: {
              method: 'POST',
              headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1" }
            }
          }
        );
      },


      createHashTag: function() {
        return $resource(
          ApiEndPoint.url + 'restful/services/HashTagRepository/actions/addHashTag/invoke', {}, {
            post: {
              method: 'POST',
              headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1;" }
            }
          }
        );
      },
      modifyHashCount: function(objectId) {
        return $resource(
          ApiEndPoint.url + 'restful/objects/simple.HashTag/:objectId/actions/hashTagCount/invoke', objectId, {
            post: {
              method: 'POST',
              headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1;" }
            }
          }
        )
      },
      addHashtoSequence: function() {
        return $resource(
          ApiEndPoint.url + 'restful/services/SequenceHashTagRepository/actions/addSequenceHashTag/invoke', {}, {
            post: {
              method: 'POST',
              headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1;" }
            }
          }
        )
      },
      /**
       * @param sequenceId {number}
       * @return {Promise}
       */
      getHashFromSequence: function(sequenceId) {
        return $resource(
          ApiEndPoint.url + 'restful/services/SequenceHashTagRepository/actions/findHashTagSequence/invoke', {}, {
            get: {
              method: 'GET',
              isArray: true,
              headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1;" }
            }
          }
        ).get({
          "sequenceId": '"' + sequenceId + '"'
        }).$promise;
      },

      /**
      LuMa HashTags in comments
      HashTags for Sequence (notificationType = 7, commentId = 0)
      HashTags for Comment (notificationType = 8, commentId = Id)
      **/
      findSequenceHashTagComment: function(data) {
        return $resource(
          ApiEndPoint.url + 'restful/services/SequenceHashTagRepository/actions/findSequenceHashTagComment/invoke', {}, {
            get: {
              method: 'GET',
              isArray: true,
              headers: {"Accept": "application/json;profile=urn:org.apache.isis/v1;"}
            }
          }).get({
            sequenceId: '"' + data.sequenceId + '"',
            notificationType: '"' + data.notificationType + '"' || "7",
            commentId: '"' + data.commentId + '"' || "0"
          }).$promise;
      },

      /**
       * @param hashName {string}
       */
      findHashDataFromHash: function(hashName) {
        return $resource(
          ApiEndPoint.url + 'restful/services/HashTagRepository/actions/findHashTag/invoke', {}, {
            get: {
              method: 'GET',
              isArray: true,
              headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1;" }
            }
          }
        ).get({
          "hashTag": '"' + hashName + '"'
        })
      },
      /**
       * @param data {{hashtagId:number, start:string, count:string}}
       */
      getSequenceFromHashtags: function(data) {
        return $resource(
          ApiEndPoint.url + 'restful/services/SequenceHashTagRepository/actions/findSequenceByHashTag/invoke', {}, {
            get: {
              method: 'GET',
              isArray: true,
              headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1;" }
            }
          }
        ).get({
          "x-isis-querystring": {
            "hashTag": {
              "value": {
                "href": ApiEndPoint.url + "restful/objects/simple.HashTag/" + data.hashtagId
              }
            },
            "withStart": {
              "value": data.start.toString()
            },
            "withCount": {
              "value": data.count.toString()
            }
          }
        })
      },
      getTrending: function() {
        return $resource(
          ApiEndPoint.url + 'restful/services/HashTagRepository/actions/findAllHashTag/invoke', {}, {
            get: {
              method: 'GET',
              isArray: true,
              headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1;" }
            }
          }
        )
      },
      //end zone Webservices for hashtags

      findSequenceByDescription: function(description) {
        return $resource(
          ApiEndPoint.url + 'restful/services/SequenceRepository/actions/findSequenceByDescription/invoke', {}, {
            get: {
              method: 'GET',
              isArray: true,
              headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1;" }
            }
          }
        ).get({
          description: description
        })
      },

      /**
       * @param data {{description: string, userSubscriptionId:number, start?: number, count?: number}}
       * @return {*}
       */
      findSequenceByDescriptionWS: function(data) {
        return $resource(
          //ApiEndPoint.url + 'restful/services/SequenceRepository/actions/findSequenceByDescriptionv1711/invoke',
          ApiEndPoint.url + 'restful/services/SequenceRepository/actions/findSequenceByDescriptionv1714/invoke', {}, {
            get: {
              method: 'GET',
              isArray: true,
              headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1;" }
            }
          }
        ).get({
          "x-isis-querystring": {
            description: { value: data.description },
            /*userSubscription: { //For version findSequenceByDescriptionv1711
              value: {
                href: ApiEndPoint.url + "restful/objects/simple.UserSubscription/" + data.userInstanceId
              }
            }*/
            userSubscriptionId: { value: data.userSubscriptionId },
            withStart: { value: data.start || 0 },
            withCount: { value: data.count || 0 }
          }
        })
      },

      findPostsWithInReviewStatus: function(data) {
        return $resource(
          ApiEndPoint.url + 'restful/services/SequenceRepository/actions/findSequenceInReviewStatus/invoke', {}, {
            get: {
              method: 'GET',
              isArray: true,
              headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1;" }
            }
          }
        ).get({
          "x-isis-querystring": {
            "withStart": {
              "value": data.start.toString()
            },
            "withCount": {
              "value": data.count.toString()
            }
          }
        })
      },

      changePostStatusToActive: function(objectId) {
        return $resource(
          ApiEndPoint.url + 'restful/objects/simple.Sequence/:objectId/actions/Active/invoke', { objectId: objectId }, {
            post: {
              method: 'POST',
              headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1" }
            }
          }).save().$promise;
      },

      changePostStatusToInReview: function(objectId) {
        return $resource(
          ApiEndPoint.url + 'restful/objects/simple.Sequence/:objectId/actions/inReview/invoke', { objectId: objectId }, {
            post: {
              method: 'POST',
              headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1" }
            }
          }).save().$promise;
      },

      isValidSequenceBySequenceId: function(objectId) {
        return $resource(
          ApiEndPoint.url + 'restful/services/SequenceRepository/actions/isValidSequenceBySequenceId/invoke', {}, {
            get: {
              method: 'GET',
              headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1;" }
            }
          }
        ).get({
          secuenceId: '"' + objectId + '"'
        })
      }

    };
  }])

  .factory('TimeLineService', ['$resource', 'ApiEndPoint', function($resource, ApiEndPoint) {
    return {

      findLatestSequencesBelongingToAUser: function(data) {
        return $resource(
          ApiEndPoint.url + 'restful/objects/simple.UserSubscription/:itemId/actions/findLatestSequencesBelongingToAUser/invoke', { itemId: data.userId }, {
            get: {
              method: 'GET',
              isArray: true,
              headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1" }
            }
          }
        ).get({
          "withStart": '"' + data.start + '"',
          "withCount": '"' + data.count + '"'
        }).$promise;
      },

      findLatestSequencesBelongingToAGroup: function() {
        return $resource(
          ApiEndPoint.url + 'restful/services/SequenceRepository/actions/findLatestSequencesBelongingToAGroupId/invoke', {}, {
            get: {
              method: 'GET',
              isArray: true,
              headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1" }
            }
          }
        );
      },

      /**
       *
       * @param objectId {number|string}
       * @param pagination {{start:number, count:number, order:number}}
       * @return {Promise}
       */
      findPendingLogByUserSubscription: function(objectId, pagination) {
        return $resource(
          ApiEndPoint.url + 'restful/objects/simple.UserSubscription/:objectId/actions/findPendingLogByUserSubscription/invoke', { objectId: objectId }, {
            get: {
              method: 'GET',
              isArray: true,
              headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1;suppress=true" }
            }
          }
        ).get({
          "withStart": '"' + pagination.start + '"',
          "withCount": '"' + pagination.count + '"',
          "order": pagination.order
        }).$promise
      },

      createSmileyCount: function() {
        return $resource(
          ApiEndPoint.url + '/services/SequenceRepository/actions/createSmileysCount/invoke', {}, {
            get: {
              method: 'GET',
              headers: { 'Content-Type': 'application/json' }
            }
          });
      },

      findMyFavoriteFriendsByUserSubscriptionId: function(objectId) {
        return $resource(
          ApiEndPoint.url + 'restful/objects/simple.UserSubscription/:objectId/actions/findMyFavoriteFriendsByUserSubscriptionId/invoke',
          objectId, {
            get: {
              method: 'GET',
              isArray: true,
              headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1;suppress=true" }
            }
          }
        );
      },

      /**
       * Shares a cqnz to a group's timeline
       * @param cqnzId {string|number}
       * @param groupHrefId {string|number}
       * @returns {Promise}
       */
      shareTimelineCqnzToGroup: function(cqnzId, groupHrefId) {
        return $resource(
          ApiEndPoint.url + 'restful/services/SequenceRepository/actions/shareTimeLineToGroup/invoke', {}, {
            get: {
              method: 'GET',
              headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1" }
            }
          }
        ).get({
          "x-isis-querystring": {
            sequenceId: { value: cqnzId.toString() },
            groupId: { value: groupHrefId.toString() }
          }
        }).$promise;
      },

      shareTimelineCqnzToGroupv200: function(cqnzId, groupHrefId, userSubsId) {
        return $resource(
          ApiEndPoint.url + 'restful/services/SequenceRepository/actions/shareTimeLineToGroupv200/invoke', {}, {
            get: {
              method: 'GET',
              headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1" }
            }
          }
        ).get({
          "x-isis-querystring": {
            sequenceId: { value: cqnzId.toString() },
            groupId: { value: groupHrefId.toString() },
            userSubscriptionId: { value: userSubsId }
          }
        }).$promise;
      },

      setPostVideoCount: function(objectId) {
        return $resource(
          ApiEndPoint.url + 'restful/objects/simple.Sequence/:objectId/actions/playVideoCount/invoke', objectId, {
            post: {
              method: 'POST',
              headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1" }
            }
          });
      }

    };
  }])

  .service('UserService', ['$rootScope', '$resource', 'ApiEndPoint', 'Utils', 'UserServiceFb', function($rootScope, $resource, ApiEndPoint, Utils, UserServiceFb) {
    /**
     * @type {string[]}
     */
    var PERMISSIONS = get_USER_PERMISSIONS();

    var PREFERENCES = get_USER_PREFERENCES();

    /**
     * @return {number}
     */
    function get_SIMPLEUSERINSTANCE_ID() {
      return +window.localStorage.getItem("simpleUserInstanceId")
    }

    /**
     * @return {string}
     */
    function get_USERSUBSCRIPTION_ID() {
      return window.localStorage.getItem("userSubscriptionId")
    }

    /**
     * @return {number}
     */
    function get_USERSUBSCRIPTIONINSTANCE_ID() {
      return +window.localStorage.getItem("userSubscriptionInstanceId")
    }

    function get_USER_INSTANCE_HREF() {
      return window.localStorage.getItem("userSubscriptionHref");
    }

    function get_USER_USERNAME() {
      var userFace = UserServiceFb.getUser('facebook');
      if (userFace.userID)
        return window.localStorage.getItem("userNameWeb");
      else
        return window.localStorage.getItem("userName");
    }

    function get_USER_NAME() {
      return window.localStorage.getItem("name") || Utils.translate('NOTIFICATIONS.DIALOG.SOMEONE');
    }

    function set_USER_NAME(newName) {
      window.localStorage.setItem("name", newName);
    }

    function get_USER_BIO() {
      return window.localStorage.getItem("userBiography") || '';
    }

    function get_USER_MEMBERSHIP() {
      var m = window.localStorage.getItem("userMembership");
      return m != 'null' ? m : '';
    }

    function set_USER_MEMBERSHIP(value) {
      return window.localStorage.setItem("userMembership", value);
    }

    function get_USER_PHOTO() {
      var localPhoto = window.localStorage.getItem("photoProfileBlob");
      return localPhoto ? localPhoto : 'img/ProfilePhoto.svg';
    }

    function get_USER_EMAIL() {
      return window.localStorage.getItem("userEmail");
    }

    function get_USER_ROLE_ID() {
      return window.localStorage.getItem("userRoleId");
    }

    function get_BACK_GROUND() {
      if (window.localStorage.getItem("bkgMyProfile")) {
        return window.localStorage.getItem("bkgMyProfile");
      } else {
        return "./img/postBg.png";
      }
    }

    /**
     * @returns {string[]}
     */
    function get_USER_PERMISSIONS() {
      if (PERMISSIONS) return PERMISSIONS;

      var p = window.localStorage.getItem("userPermissions");
      return p ? JSON.parse(p) : [];
    }

    /**
     * @param permissions {string[]}
     * @param newDate {string?}
     */
    function set_USER_PERMISSIONS(permissions, newDate) {
      PERMISSIONS = permissions;
      window.localStorage.setItem("userPermissions", JSON.stringify(permissions));
      $rootScope.$broadcast("rolePermissions-changed", { newDate: newDate });
    }

    function USER_IS_SUPERADMIN() {
      return [1, '1'].indexOf(get_USER_ROLE_ID()) > -1; //true
    }

    function USER_IS_ADVERTISER() {
      return [3, '3'].indexOf(get_USER_ROLE_ID()) > -1;
    }

    function get_USER_PREFERENCES() {
      if (PREFERENCES) return PREFERENCES;

      var p = window.localStorage.getItem("userPreferences");
      return p ? JSON.parse(p) : [];
    }

    /**
     * @param preferences {string[]}
     */
    function set_USER_PREFERENCES(preferences) {
      PREFERENCES = preferences;
      window.localStorage.setItem("userPreferences", JSON.stringify(preferences));
    }

    /**
     *
     * @param data {{userSubscriptionId: string, code: string}}
     * @return {*}
     */
    function redeemCodeWS(data) {
      //console.log("Validating redeemable code: " + data.code);
      return $resource(ApiEndPoint.url + "restful/services/UserInvitationCodeRepository/actions/accessToGroup/invoke", {}, {
        get: {
          method: 'GET',
          headers: { 'Content-Type': 'application/json;profile=urn:org.apache.isis/v1' }
        }
      }).get({
        "x-isis-querystring": {
          userSubscription: {
            value: {
              href: ApiEndPoint.url + "restful/objects/simple.UserSubscription/" + data.userSubscriptionId
            }
          },
          code: { value: data.code.toString() }
        }
      });
    }

    /* Back List*/

    function runBlackListWS() {
      //console.log("Validating redeemable code: " + data.code);
      return $resource(ApiEndPoint.url + "restful/services/SequenceRepository/actions/changeInReview/invoke", {}, {
        get: {
          method: 'GET',
          headers: { 'Content-Type': 'application/json;profile=urn:org.apache.isis/v1' }
        }
      }).get();
    }

    /**
     *
     * @param data {{userId: number|string, membership: string}}
     * @return {*}
     */
    function changeMembershipWS(data) {
      return $resource(ApiEndPoint.url + "restful/objects/simple.UserSubscription/:objectId/actions/changeMembershipId/invoke", { objectId: data.userId }, {
        post: {
          method: 'POST',
          headers: { 'Content-Type': 'application/json;profile=urn:org.apache.isis/v1' }
        }
      }).save({
        string: { value: data.membership }
      }).$promise;
    }

    //fixme: it gets too much info
    /**
     * @param userInstanceId {number|string}
     * @return {*}
     */
    function getUserSubscriptionByinstanceId(userInstanceId) {
      return $resource(ApiEndPoint.url + "restful/objects/simple.UserSubscription/:userInstanceId", {}, {
        get: {
          method: 'GET',
          headers: { 'Content-Type': 'application/json;profile=urn:org.apache.isis/v1' }
        }
      }).get({
        userInstanceId: userInstanceId
      });
    }

    //new WS instead of getUserSubscriptionByinstanceId
    /**
     * @return name
     * @return href
     * @return profilepicture
     * @return profilepictureUrl
     */
    function getUserSubscriptionByinstanceIdProfileData(userInstanceId) {
      return $resource(ApiEndPoint.url + "restful/services/UserSubscriptionRepository/actions/findUserSubscriptionsByInstanceId/invoke", {}, {
        get: {
          method: 'GET',
          isArray: true,
          headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1' }
        }
      }).get({
        "x-isis-querystring": {
          userSubscription: {
            value: {
              href: ApiEndPoint.url + "restful/objects/simple.UserSubscription/" + userInstanceId
            }
          }
        }
      });
    }

    //new WS instead of getUserSubscriptionByinstanceId for get private account
    /**
     * @return result.value true
     */
    function getUserSubscriptionByinstanceIdPrivateAccount(userInstanceId) {
      return $resource(ApiEndPoint.url + "restful/services/UserSubscriptionRepository/actions/findPrivateAccountByUserSubscription/invoke", {}, {
        get: {
          method: 'GET',
          headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1' }
        }
      }).get({
        "x-isis-querystring": {
          userSubscription: {
            value: {
              href: ApiEndPoint.url + "restful/objects/simple.UserSubscription/" + userInstanceId
            }
          }
        }
      });
    }

    //new WS instead of getUserSubscriptionByinstanceId for get complete profile
    /**
     * @return result.value true
     */
    function getUserSubscriptionByinstanceIdCompleteProfile(userInstanceId) {
      return $resource(ApiEndPoint.url + "restful/services/UserSubscriptionRepository/actions/findProfileByUserSubscriptionId/invoke", {}, {
        get: {
          method: 'GET',
          isArray: true,
          headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1' }
        }
      }).get({
        "x-isis-querystring": {
          userSubscriptionId: {
            value: {
              href: ApiEndPoint.url + "restful/objects/simple.UserSubscription/" + userInstanceId
            }
          }
        }
      });
    }


    /**
     * @param data {{userInstanceId:number|string, friendInstaceId:number|string}}
     * @return {*}
     */
    function getFollowingIsActiveWS(data) {
      return $resource(ApiEndPoint.url + 'restful/objects/simple.UserSubscription/:objectId/actions/getFollowingIsActive/invoke', { objectId: data.userInstanceId }, {
        get: {
          method: 'GET',
          headers: { "Accept": "application/json" }
        }
      }).get({
        "x-isis-querystring": {
          friendId: {
            value: {
              href: ApiEndPoint.url + "restful/objects/simple.UserSubscription/" + data.friendInstaceId
            }
          }
        }
      });
    }

    //Service for login
    /*function findUserSubscriptionByUserName() {
      return $resource(ApiEndPoint.url + 'restful/services/UserSubscriptionRepository/actions/findUserSubscriptionsByUserName/invoke',
        {},
        {
          get: {
            method: 'GET',
            isArray: true,
            headers: {"Accept": "application/json;profile=urn:org.apache.isis/v1"}
          }
        });
    }*/

    //Login service optimized
    function findUserSubscriptionByUserName() {
      return $resource(ApiEndPoint.url + 'restful/services/UserSubscriptionRepository/actions/findUserSubscriptionsByUserNamev1106/invoke', {}, {
        get: {
          method: 'GET',
          isArray: true,
          headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1" }
        }
      });
    }


    //Service for search friends
    function findFriendUserSubscriptionsByUserName() {
      return $resource(ApiEndPoint.url + 'restful/services/UserSubscriptionRepository/actions/findFriendUserSubscriptionsByUserName/invoke', {}, {
        get: {
          method: 'GET',
          isArray: true,
          headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1" }
        }
      });
    }

    function findFriendUserSubscriptionsByUserNamev157() {
      return $resource(ApiEndPoint.url + 'restful/services/UserSubscriptionRepository/actions/findFriendUserSubscriptionsByUserNamev157/invoke', {}, {
        get: {
          method: 'GET',
          isArray: true,
          headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1" }
        }
      });
    }

    /**
     *
     * @param userSubscriptionId {number|string}
     * @return {*}
     */
    function findUserSubscriptionsByWebUserWS(userSubscriptionId) {
      return $resource(ApiEndPoint.url + 'restful/services/UserSubscriptionRepository/actions/findWebUserByUserSubscriptionId/invoke', {}, {
        get: {
          method: 'GET',
          //isArray: true,
          headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1" }
        }
      }).get({ userSubscriptionId: '"' + userSubscriptionId + '"' });
    }


    //new Service for search sugested friends
    /**
     * @param data {{userId:number|string, start:number, count:number}}
     * @return {*}
     */
    function findSuggestedFriends(data) {
      return $resource(
        ApiEndPoint.url + 'restful/objects/simple.UserSubscription/:objectId/actions/findUsersRandom/invoke', { objectId: data.userId }, {
          get: {
            method: 'GET',
            isArray: true,
            headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1;suppress=true;" }
          }
        }).get({
        "withStart": '"' + data.start + '"',
        "withCount": '"' + data.count + '"'
      });
    }

    /**
     * @param data {{userInstanceId:number|string, friendInstaceId:number|string}}
     * @return {*}
     */
    function toggleFriendhipStateWS(data) {
      return $resource(ApiEndPoint.url + 'restful/objects/simple.UserSubscription/:objectId/actions/addFriends/invoke', { objectId: data.userInstanceId }, {
        post: {
          method: 'POST',
          isArray: true,
          headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1" }
        }
      }).save({
        friendId: {
          value: {
            href: ApiEndPoint.url + "restful/objects/simple.UserSubscription/" + data.friendInstaceId
          }
        }
      });
    }

    function followersByUserId(objectId) {
      return $resource(
        ApiEndPoint.url + 'restful/objects/simple.UserSubscription/:objectId/actions/findFollowersByUserId/invoke',
        objectId, {
          get: {
            method: 'GET',
            isArray: true,
            headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1;suppress=true;" }
          }
        }
      );
    }

    /**
     * @param data {{userId:number|string, start:number, count:number}}
     * @return {*}
     */
    function findFriendsByUserSubscriptionId(data) {
      return $resource(
        ApiEndPoint.url + 'restful/objects/simple.UserSubscription/:objectId/actions/findFriendsByUserSubscriptionId/invoke', { objectId: data.userId }, {
          get: {
            method: 'GET',
            isArray: true,
            headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1;suppress=true" }
          }
        }
      ).get({
        withStart: '"' + data.start + '"',
        withCount: '"' + data.count + '"'
      });
    }

    function changePrivateAccount(objectId) {
      return $resource(
        ApiEndPoint.url + 'restful/objects/simple.UserSubscription/:objectId/actions/changePrivateAccount/invoke',
        objectId, {

          post: {
            method: 'POST',
            headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1;repr-type=object;' }
          }

        }
      );
    }

    function getStatusPrivateAccount(objectId) {
      return $resource(
        ApiEndPoint.url + 'restful/objects/simple.UserSubscription/:objectId/actions/findPrivateAccountByUserSubscription/invoke',
        objectId, {
          get: {
            method: 'GET',
            headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1;suppress=true" }
          }

        }
      );
    }

    function cancelRequestToPrivate(objectId) {
      return $resource(
        ApiEndPoint.url + 'restful/objects/simple.Friend/:objectId/actions/delete/invoke',
        objectId, {

          post: {
            method: 'POST',
            headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1;repr-type=object;' }
          }

        }
      );
    }

    function getStatusPrivateRequest(data) {
      return $resource(
        ApiEndPoint.url + 'restful/objects/simple.UserSubscription/:objectId/actions/getFollowingStatus/invoke', { objectId: data.userId }, {
          get: {
            method: 'GET',
            headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1;suppress=true" }
          }

        }
      ).get({
        "x-isis-querystring": {
          "friendId": {
            "value": {
              "href": ApiEndPoint.url + "restful/objects/simple.UserSubscription/" + data.friendId
            }
          }
        }
      });
    }

    function blockToUser(user, userBlocked) {
      return $resource(
        ApiEndPoint.url + 'restful/objects/simple.UserSubscription/:objectId/actions/Block/invoke', { objectId: user }, {
          post: {
            method: 'POST',
            headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1' }
          }
        }
      ).save({
        userSubscription: {
          value: {
            href: ApiEndPoint.url + "restful/objects/simple.UserSubscription/" + userBlocked
          }
        }
      }).$promise;
    }

    function unblockUser(user, userBlocked) {
      return $resource(
        ApiEndPoint.url + 'restful/objects/simple.UserSubscription/:objectId/actions/unBlock/invoke', { objectId: user }, {
          post: {
            method: 'POST',
            headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1' }
          }
        }
      ).save({
        userSubscription: {
          value: {
            href: ApiEndPoint.url + "restful/objects/simple.UserSubscription/" + userBlocked
          }
        }
      }).$promise;
    }

    function findBlockUserById() {
      return $resource(
        ApiEndPoint.url + 'restful/services/UserBlackListRepository/actions/findBlockedUserBlackListById/invoke', {}, {
          get: {
            method: 'GET',
            isArray: true,
            headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1" }
          }
        }
      );
    }

    function findBlackListbyOwnerId(userInstanceId, start, count) {
      return $resource(
        ApiEndPoint.url + 'restful/services/UserBlackListRepository/actions/findUserBlackListById/invoke', {}, {
          get: {
            method: 'GET',
            isArray: true,
            headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1" }
          }
        }).get({
        "x-isis-querystring": {
          "userSubscriptionId": {
            "value": {
              "href": ApiEndPoint.url + 'restful/objects/simple.UserSubscription/' + userInstanceId
            }
          },
          "withStart": {
            "value": '' + start
          },
          "withCount": {
            "value": '' + count
          }
        }
      }).$promise;
    }

    function updatePassword(objectId) {
      return $resource(
        ApiEndPoint.url + 'restful/objects/isissecurity.ApplicationUser/:objectId/actions/updatePassword/invoke', objectId, {
          put: {
            method: 'PUT',
            headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1;repr-type=object;' }
          }
        }
      );
    }

    function sendEmail(objectId) {
      return $resource(
        ApiEndPoint.url + 'restful/objects/simple.users/:objectId/actions/sendEmail/invoke', objectId, {
          post: {
            method: 'PUT',
            headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1;repr-type=object;' }
          }
        }
      );
    }

    function findUserByUserName() {
      return $resource(
        ApiEndPoint.url + 'restful/services/UserRepository/actions/findUsersByName/invoke', {}, {
          get: {
            method: 'GET',
            isArray: true,
            headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1' }
          }
        }
      );
    }

    function sendNewPassword() {
      return $resource(ApiEndPoint.url + 'restful/services/UserRepository/actions/sendNewPassword/invoke', {}, {
        post: {
          method: 'POST',
          headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1' }
        }
      });
    }

    function updateNotificationStatus(objectId) {
      return $resource(ApiEndPoint.url + 'restful/objects/simple.UserNotification/:objectId/actions/updateNotificationStatus/invoke', objectId, {
        post: {
          method: 'POST',
          headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1' }
        }
      });
    }

    function updatePackNotificationStatus(objectId) {
      return $resource(ApiEndPoint.url + 'restful/services/UserNotificationRepository/actions/updateNotificationsStatusSentPendingNotifications/invoke', {}, {
        post: {
          method: 'POST',
          headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1' }
        }
      });
    }

    function findUserSubscriptionById() {
      return $resource(ApiEndPoint.url + 'restful/services/UserSubscriptionRepository/actions/findUserSubscriptionById/invoke', {}, {
        get: {
          method: 'GET',
          isArray: true,
          headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1' }
        }
      });
    }

    //OmRo Token History
    function historyToken(data) {
      return $resource(
        ApiEndPoint.url + 'restful/services/UserTransactionPromLogRepository/actions/findUserTransactionPromLogByUserSubscriptionId/invoke', {}, {
          get: {
            method: 'GET',
            isArray: true,
            headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1" }
          }
        }
      ).get({
        userSubscriptionId: '"' + data.userSubscriptionId + '"',
        withStart: '"' + data.start + '"',
        withCount: '"' + data.count + '"'
      })
    }
    
    //only returns status account and role
    function findUserSubscriptionv157() {
      return $resource(ApiEndPoint.url + 'restful/services/UserSubscriptionRepository/actions/findUserSubscriptionv157/invoke', {}, {
        get: {
          method: 'GET',
          isArray: true,
          headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1' }
        }
      });
    }

    function sendSupportEmail(objectId) {
      return $resource(
        //ApiEndPoint.url + 'restful/objects/simple.User/:objectId/actions/sendEmailToSupport/invoke', objectId,
        ApiEndPoint.url + 'restful/objects/simple.User/:objectId/actions/sendEmailToSupportv194/invoke', objectId, {
          post: {
            method: 'PUT',
            headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1;repr-type=object;' }
          }
        }
      );
    }

    function getsupportType() {
      return $resource(
        ApiEndPoint.url + 'restful/services/SupportTypeRepository/actions/findAll/invoke', {}, {
          get: {
            method: 'GET',
            isArray: true,
            headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1' }
          }
        }
      );
    }

    function cancelUserSubscription(objectId) {
      return $resource(
        ApiEndPoint.url + 'restful/objects/simple.UserSubscription/:objectId/actions/cancel/invoke', objectId, {
          post: {
            method: 'PUT',
            headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1;repr-type=object;' }
          }
        }
      );
    }

    function changeProfilePicture(objectId) {
      return $resource(
        ApiEndPoint.url + 'restful/objects/simple.UserSubscription/:objectId/actions/changeProfilePicture/invoke', objectId, {
          post: {
            method: 'PUT',
            headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1;repr-type=object;' }
          }
        }
      );
    }

    function sendReaction(objectId) {
      return $resource(ApiEndPoint.url + 'restful/objects/simple.Sequence/:objectId/actions/sendReaction/invoke', objectId, {
        post: {
          method: 'POST',
          headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1;repr-type=object;' }
        }
      });
    }

    function acceptFriend(objectId) {
      return $resource(ApiEndPoint.url + 'restful/objects/simple.Friend/:objectId/actions/approved/invoke', objectId, {
        post: {
          method: 'POST',
          headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1;repr-type=object;' }
        }
      });
    }

    // function needed to check if the username is already taken
    function getCities() {
      return $resource(
        ApiEndPoint.url + 'restful/services/CityRepository/actions/findAllCity/invoke', {}, {
          get: {
            method: 'GET',
            isArray: true,
            headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1' }
          }
        }
      ).get();
    }

    function getSections(data) {
      return $resource(
        ApiEndPoint.url + 'restful/services/GroupMemberRepository/actions/findModeratorByGroupIdv2/invoke', {}, {
          get: {
            method: 'GET',
            isArray: true,
            headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1' }
          }
        }
      ).get(
      {
        'x-isis-querystring': {
          groupId: {
            value: data.groupId+""
          }
        }
      });
    }

    function checkCitiesByCity(cityGiven) {
      return $resource(
        ApiEndPoint.url + 'restful/services/CityRepository/actions/findCityByCity/invoke', {}, {
          get: {
            method: 'GET',
            isArray: true,
            headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1' }
          }
        }
      ).get({
        city: cityGiven
      }).$promise;
    }

    // function needed to check if the username is already taken
    function validateUserName() {
      return $resource(
        //For old versions
        //ApiEndPoint.url + 'restful/services/UserRepository/actions/verifyUserName/invoke',

        //For newest version verifyUserNamev1117
        ApiEndPoint.url + 'restful/services/UserRepository/actions/verifyUserNamev1117/invoke', {}, {
          get: {
            method: 'GET',
            //isArray: true,//<- For old versions
            headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1' }
          }
        }
      );
    }

    // function that returns only the pending notifications (everything except followers) count
    function countPendingNotifications() {
      return $resource(ApiEndPoint.url + 'restful/services/UserNotificationRepository/actions/countPendingNotifications/invoke', {}, {
        get: {
          method: 'GET',
          headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1' }
        }
      });
    }

    /**
     * function that returns only the pending followers notifications count
     * @param userInstanceId
     * @returns {Promise}
     */
    function countPendingFollowersNotifications(userInstanceId) {
      return $resource(ApiEndPoint.url + 'restful/services/UserNotificationRepository/actions/countPendingNotificationsFollow/invoke', {}, {
        get: {
          method: 'GET',
          headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1' }
        }
      }).get({
        "x-isis-querystring": {
          "userSubscription": {
            "value": {
              "href": ApiEndPoint.url + 'restful/objects/simple.UserSubscription/' + userInstanceId
            }
          }
        }
      }).$promise;
    }

    //function that returns all the needed notifications
    function findAllUserNotificationsByUserSubscription(userSub) {
      return $resource(
        ApiEndPoint.url + 'restful/objects/simple.UserSubscription/:userSub/actions/allUserNotificationByUserSubscription/invoke',
        userSub, {
          get: {
            method: 'GET',
            isArray: true,
            headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1;suppress=true' }
          }
        });
    }

    /**
     * @param userId {number|string}
     * @param pagination {{start:number,count:number}}
     * @returns {Promise}
     */
    function findAllUserNotificationsByUserSubscriptionNotifications(userId, pagination) {
      return $resource(
        ApiEndPoint.url + 'restful/objects/simple.UserSubscription/:userSub/actions/allUserNotificationByUserSubscriptionNotification/invoke', { userSub: userId }, {
          get: {
            method: 'GET',
            isArray: true,
            headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1;suppress=true' }
          }
        }).get({
        withStart: '"' + pagination.start + '"',
        withCount: '"' + pagination.count + '"'
      }).$promise;
    }

    /**
     * @param userId {number|string}
     * @param pagination {{start:number,count:number}}
     * @returns {Promise}
     */
    function findAllUserNotificationsByUserSubscriptionFollow(userId, pagination) {
      return $resource(
        ApiEndPoint.url + 'restful/objects/simple.UserSubscription/:userSub/actions/allUserNotificationByUserSubscriptionFollow/invoke', { userSub: userId }, {
          get: {
            method: 'GET',
            isArray: true,
            headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1;suppress=true' }
          }
        }).get({
        withStart: '"' + pagination.start + '"',
        withCount: '"' + pagination.count + '"'
      }).$promise;
    }

    function countSequencesToAUser(objectId) {
      return $resource(
        ApiEndPoint.url + 'restful/objects/simple.UserSubscription/:objectId/actions/countSequencesToAUser/invoke',
        objectId, {
          get: {
            method: 'GET',
            headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1" }
          }
        });
    }

    function countFollowersToAUser(objectId) {
      return $resource(
        ApiEndPoint.url + 'restful/services/FriendRepository/actions/countFollowersByUserId/invoke', {}, {
          get: {
            method: 'GET',
            headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1" }
          }
        });
    }

    function countFollowingToAUser(objectId) {
      return $resource(
        ApiEndPoint.url + 'restful/services/FriendRepository/actions/countFriendsByUserSubscriptionId/invoke', {}, {
          get: {
            method: 'GET',
            headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1" }
          }
        });
    }

    function findUserProfilePictureLargeById(objectId) {
      return $resource(
        ApiEndPoint.url + 'restful/objects/simple.UserSubscription/:objectId/collections/findUserProfilePictureLargeById',
        objectId, {
          get: {
            method: 'GET',
            isArray: true,
            headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1" }
          }
        });
    }

    function findFriendsByUserSubscriptionIdTag(objectId) {
      return $resource(
        ApiEndPoint.url + 'restful/objects/simple.UserSubscription/:objectId/actions/findFriendsByUserSubscriptionIdTag/invoke',
        objectId, {
          get: {
            method: 'GET',
            isArray: true,
            headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1" }
          }
        });
    }


    function findFriendsByUserSubscriptionIdTagv167(data) { //stop
      return $resource(
        ApiEndPoint.url + 'restful/objects/simple.UserSubscription/:objectId/actions/findFriendsByUserSubscriptionIdTagv167/invoke', { objectId: data.userId }, {
          get: {
            method: 'GET',
            isArray: true,
            headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1" }
            //timeout: stop.promise
          }
        }).get({
        "string": data.term,
        "withStart": data.start,
        "withCount": data.count
      });
    }

    function findFriendsByUserSubscriptionIdTagv157(data) { //stop
      return $resource(
        ApiEndPoint.url + 'restful/services/UserSubscriptionRepository/actions/findUserSubscriptionTagv157/invoke', {}, {
          get: {
            method: 'GET',
            isArray: true,
            headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1" }
          }
        }).get({
        pagTag: data.term,
        withStart: data.start,
        withCount: data.count
      });
    }

    /**
     * Finds the users whose name are LIKE term and/or includes spaces
     * @example term = 'an' will return: "Andres VB", "Angel Manuel", etc..
     * @param data {{term:string, start:number, count:number}}
     * @return Promise {{
     *  id:string,
     *  href:string
     *  name:string,
     *  photo:string,
     * }}|*
     */
    function searchUsersByPartialNameOrIncludingSpaces(data) {
      return Utils.$q(function(resolve, reject) {
        return $resource(
          ApiEndPoint.url + 'restful/services/UserSubscriptionRepository/actions/findUserSubscriptionTagv157/invoke', {}, {
            get: {
              method: 'GET',
              isArray: true,
              headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1" }
            }
          }).get({
          pagTag: data.term,
          withStart: data.start,
          withCount: data.count
        }).$promise.then(
          /**
           * @param response {[{
           *  name:string,
           *  profilePicture:string|null,
           *  profilePictureUrl:string|null,
           *  userSubscription:{}
           * }] | []}
           */
          function(response) {
            var tagsList = [];

            if (!response) return resolve(tagsList);

            Utils.removeLastItemIfHasNoAttribute(response, 'userSubscription');

            response.forEach(function(tag) {
              tagsList.push({
                id: Utils.getLastUrlComponent(tag.userSubscription.href),
                href: tag.userSubscription.href,
                name: tag.name.replace(/\s\s+/g, ' '),
                photo: Utils.getUserImgUrl(tag)
              });
            });

            resolve(tagsList)
          },
          function(error) {
            console.error("findFriendsByUserSubscriptionIdTagv167", error);
            reject(error)
          });
      })
    }

    function editTextfromUserBiography(objectId) {
      return $resource(
        ApiEndPoint.url + 'restful/objects/simple.UserSubscription/:objectId/actions/changeUserBio/invoke', objectId, {
          post: {
            method: 'PUT',
            headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1;repr-type=object;' }
          }
        }
      );
    }

    function addDevice(objectId) {

      return $resource(
        ApiEndPoint.url + 'restful/objects/simple.UserSubscription/:objectId/actions/addUserDevice/invoke', objectId, {
          post: {
            method: 'POST',
            headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1' }
          }
        }
      );
    }

    /**
     * @param userId {number|string}
     */
    function getDevices(userId) {
      return $resource(
        //to use with older versions
        //ApiEndPoint.url + 'restful/objects/simple.UserSubscription/:objectId/collections/userDevices',
        //{objectId: userId},

        //for newest version
        ApiEndPoint.url + 'restful/services/UserDeviceRepository/actions/findUserDeviceByUserSubscription/invoke', {}, {
          get: {
            method: 'GET',
            headers: { "Accept": "application/json" }
          }
        }).get({
        'x-isis-querystring': {
          userSubscription: {
            value: {
              href: ApiEndPoint.url + "restful/objects/simple.UserSubscription/" + userId
            }
          }
        }
      });
    }

    function chkStatusForPush(userId) {
      return $resource(
        ApiEndPoint.url + 'restful/objects/simple.UserSubscription/:objectId/actions/getSendUserNotification/invoke', { objectId: userId.userSubs }, {
          get: {
            method: 'GET',
            headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1;suppress=true" }
          }
        }
      ).get({
        "x-isis-querystring": {
          "int": {
            "value": userId.type
          }
        }
      })
    }

    function getDevicesByRegion(userInfo) {
      return $resource(
        ApiEndPoint.url + 'restful/services/UserDeviceRepository/actions/findUserDeviceByCity/invoke', {}, {
          get: {
            method: 'GET',
            headers: { "Accept": "application/json" }
          }
        }).get({
        'x-isis-querystring': {
          ciudad: {
            value: userInfo.ciudad

          },
          withStart: {
            value: userInfo.withStart

          },
          withCount: {
            value: userInfo.withCount

          }
        }
      }).$promise;
    }

    function getDevicesUsersCommentAPost(postData) {
      return $resource(
        ApiEndPoint.url + 'restful/services/SequenceRepository/actions/devicesAllComment/invoke', {}, {
          get: {
            method: 'GET',
            isArray: true,
            headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1" }
          }
        }
      ).get({
        "x-isis-querystring": {
          sequenceId: { value: postData.sequenceId.toString() },
          userSubscriptionId: { value: postData.userSubscriptionId.toString() },
          groupId: { value: postData.groupId.toString() }
        }
      }).$promise;
    }

    //NEW WS WITH TYPE
    function getDevicesUsersCommentAPostWithType(postData) {
      return $resource(
        ApiEndPoint.url + 'restful/services/SequenceRepository/actions/devicesAllCommentv200/invoke', {}, {
          get: {
            method: 'GET',
            isArray: true,
            headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1" }
          }
        }
      ).get({
        "x-isis-querystring": {
          sequenceId: { value: postData.sequenceId.toString() },
          userSubscriptionId: { value: postData.userSubscriptionId.toString() },
          groupId: { value: postData.groupId.toString() },
          notificationType: { value: postData.notificationType.toString() }
        }
      }).$promise;
    }

    function getDevicesUsersLikedAPost(postData) {
      return $resource(
        ApiEndPoint.url + 'restful/services/SequenceRepository/actions/devicesAllLikes/invoke', {}, {
          get: {
            method: 'GET',
            isArray: true,
            headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1" }
          }
        }
      ).get({
        "x-isis-querystring": {
          sequenceId: { value: postData.sequenceId.toString() },
          userSubscriptionId: { value: postData.userSubscriptionId.toString() }
        }
      }).$promise;
    }
    /*
    withStart: { value: { userInfo.start } },
    withCount: { value: { userInfo.count } }
    */
    function deleteDevice() {
      return $resource(
        ApiEndPoint.url + 'restful/services/UserDeviceRepository/actions/deleteUserDevice/invoke', {}, {
          get: {
            method: 'GET',
            headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1" }
          }
        });
    }

    function getPushNotificationsConfig(objectId) {
      return $resource(
        ApiEndPoint.url + 'restful/objects/simple.UserSubscription/:objectId/actions/findConfigureUserNotificationByUserSubscription/invoke',
        objectId, {
          get: {
            method: 'GET',
            isArray: true,
            headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1;suppress=true" }
          }
        });
    }

    function updatePushNotificationConfig(objectId) {

      return $resource(
        ApiEndPoint.url + 'restful/objects/simple.ConfigureUserNotification/:objectId/actions/updateSendNotification/invoke', objectId, {
          post: {
            method: 'POST',
            headers: { 'Accept': 'application/json' }
          }
        }
      );
    }

    function findNewUsers(itemId) {
      return $resource(
        ApiEndPoint.url + 'restful/objects/simple.UserSubscription/:itemId/actions/findNewUsers/invoke',
        itemId, {
          get: {
            method: 'GET',
            isArray: true,
            headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1;suppress=true" }
          }
        }
      );
    }

    function findFeatured(itemId) {
      return $resource(
        ApiEndPoint.url + 'restful/objects/simple.UserSubscription/:itemId/actions/findFeatured/invoke',
        itemId, {
          get: {
            method: 'GET',
            isArray: true,
            headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1;suppress=true" }
          }
        }
      );
    }

    function findLatestItemBelongingToAUserSubscription(itemId) {
      return $resource(
        ApiEndPoint.url + 'restful/objects/simple.UserSubscription/:itemId/actions/findLatestItemBelongingToAUserSubscription/invoke',
        itemId, {
          get: {
            method: 'GET',
            isArray: true,
            headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1;suppress=true" }
          }
        }
      );
    }

    function findLatestItemThumbBelongingToAUserSubscription(itemId) {
      return $resource(
        ApiEndPoint.url + 'restful/objects/simple.UserSubscription/:itemId/actions/findLatestItemThumbBelongingToAUserSubscription/invoke',
        itemId, {
          get: {
            method: 'GET',
            isArray: true,
            headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1;suppress=true" }
          }
        }
      );
    }

    function findLatestItemThumbBelongingToAUserSubscriptionByType(itemId) {
      return $resource(
        ApiEndPoint.url + 'restful/objects/simple.UserSubscription/:itemId/actions/findLatestItemThumbBelongingToAUserSubscriptionByType/invoke',
        itemId, {
          get: {
            method: 'GET',
            isArray: true,
            headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1;suppress=true" }
          }
        }
      );
    }

    /**
     * @param data{{userId:number, friendId:number}}
     * @return {*}
     */
    function findFriendInstanceId(data) {
      return $resource(
        ApiEndPoint.url + 'restful/objects/simple.UserSubscription/:itemId/actions/findFriendsByUserSubscriptionIdAndFriendId/invoke', { itemId: data.userId }, {
          get: {
            method: 'GET',
            headers: { "Accept": "application/json" }
          }
        }
      ).get({
        "x-isis-querystring": {
          friendId: {
            value: { href: ApiEndPoint.url + "restful/objects/simple.UserSubscription/" + data.friendId }
          }
        }
      }).$promise;
    }

    function getFriend(itemId) {
      return $resource(ApiEndPoint.url + "restful/objects/simple.Friend/:itemId", itemId, {
        get: {
          method: 'GET',
          headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1;suppress=true" }
        }
      });
    }

    function favorite(objectId) {
      return $resource(
        ApiEndPoint.url + 'restful/objects/simple.Friend/:objectId/actions/favorite/invoke', objectId, {
          post: {
            method: 'POST',
            headers: { 'Accept': 'application/json' }
          }
        }
      );
    }

    function email(objectId) {
      return $resource(
        ApiEndPoint.url + 'restful/objects/simple.User/:objectId/actions/ChangeEmail/invoke', objectId, {
          post: {
            method: 'POST',
            headers: { 'Accept': 'application/json' }
          }
        }
      );
    }

    function name(objectId) {
      return $resource(
        ApiEndPoint.url + 'restful/objects/simple.User/:objectId/actions/ChangeName/invoke', objectId, {
          post: {
            method: 'POST',
            headers: { 'Accept': 'application/json' }
          }
        }
      );
    }

    function sendNewPasswordEmail() {
      return $resource(ApiEndPoint.url + 'restful/services/UserRepository/actions/sendNewPasswordEmail/invoke', {}, {
        post: {
          method: 'POST',
          headers: {
            'Accept': 'application/json;profile=urn:org.apache.isis/v1'
          }
        }
      });
    }

    function sendEmailToSupportLogin() {
      return $resource(ApiEndPoint.url + 'restful/services/UserRepository/actions/sendEmailToSupportLogin/invoke', {}, {
        post: {
          method: 'POST',
          headers: {
            'Accept': 'application/json;profile=urn:org.apache.isis/v1'
          }
        }
      });
    }

    function validateUserEmail() {
      return $resource(ApiEndPoint.url + 'restful/services/UserRepository/actions/findUserByEmail/invoke', {}, {
        get: {
          method: 'GET',
          isArray: true,
          headers: {
            'Accept': 'application/json;profile=urn:org.apache.isis/v1'
          }
        }
      });
    }

    function deleteUserComplete(objectId) {
      return $resource(
        ApiEndPoint.url + 'restful/objects/simple.UserSubscription/:objectId/actions/deleteSubscription/invoke', objectId, {
          post: {
            method: 'PUT',
            headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1;repr-type=object;' }
          }
        }
      );
    }

    //OmRo 200919 update ws city.
    function city(objectId) {
      return $resource(
        ApiEndPoint.url + 'restful/objects/simple.User/:objectId/actions/ChangeCity/invoke', objectId, {
          post: {
            method: 'POST',
            headers: { 'Accept': 'application/json' }
          }
        }
      );
    }

    /**
     * @param data {{userInstanceId:number|string, start:number, count:number}}
     * @return {*}
     */
    function findUsersRandomWS(data) {
      return $resource(
        ApiEndPoint.url + 'restful/services/UserSubscriptionRepository/actions/findUsersRandom/invoke', {}, {
          get: {
            method: 'GET',
            isArray: true,
            headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1' }
          }
        }
      ).get({
        "x-isis-querystring": {
          userSubscription: {
            value: {
              href: ApiEndPoint.url + 'restful/objects/simple.UserSubscription/' + data.userInstanceId
            }
          },
          withStart: { value: data.start },
          withCount: { value: data.count }
        }
      });
    }

    /**
     * @param data ({userSubscriptionId:number|string, facebookUser:string})
     * @return {*}
     **/
    function accessToLinkGroup(data) {
      return $resource(
        ApiEndPoint.url + 'restful/services/LinkGroupMemberRepository/actions/accessToLinkGroup/invoke', {}, {
          get: {
            method: 'GET',
            headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1' }
          }
        }
      ).get({
        "x-isis-querystring": {
          userSubscriptionId: {
            value: data.userSubscriptionId
          },
          facebookUser: {
            value: data.facebookUser
          }
        }
      });
    }

    /**
     * @param data (objectID:number|sttring)
     *
     **/
    function linkAccountWithFacebook(objectId) {
      return $resource(
        ApiEndPoint.url + 'restful/objects/simple.User/:objectId/actions/linkUserName/invoke', objectId, {
          post: {
            method: 'POST',
            headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1;' }
          }
        }
      );
    }

    function updateBirthDay(objectId) {
      return $resource(
        ApiEndPoint.url + 'restful/objects/simple.User/:objectId/actions/ChangeBirthDate/invoke', objectId, {
          post: {
            method: 'POST',
            headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1;' }
          }
        }
      );
    }

    function findUsersBirthDate(userId) {
      return $resource(
        ApiEndPoint.url + 'restful/services/UserRepository/actions/findBirthDateByUserId/invoke', {}, {
          get: {
            method: 'GET',
            headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1' }
          }
        }
      ).get({
        "x-isis-querystring": {
          usersId: { value: userId.objectId }
        }
      });
    }

    function getAllMetaDataWithUserSubscriptionId(data) {
      return $resource(
        ApiEndPoint.url + 'restful/services/UserSubscriptionDetailRepository/actions/findByUserDetailByUserSubscriptionId/invoke', {}, {
          get: {
            method: 'GET',
            isArray: true,
            headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1' }
          }
        }
      ).get({
        "x-isis-querystring": {
          userSubscriptionId: { value: data.userSubscriptionId }
        }
      });
    }

    function updateLegalUserVersion(objectId) {
      return $resource(
        ApiEndPoint.url + 'restful/objects/simple.UserSubscription/:objectId/actions/updateTermsAndConditionsVersion/invoke',
        objectId, {
          post: {
            method: 'POST',
            headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1' }
          }
        }
      )
    }

    //LuMa Live Streaming
    function findFollowersUserDeviceUserSubscriptionId(userSubscriptionId, notificationType) {
      return $resource(
        ApiEndPoint.url + 'restful/services/FriendRepository/actions/findFollowersUserDeviceUserSubscriptionId/invoke', {}, {
          get: {
            method: 'GET',
            isArray: true,
            headers: {
              "Accept": "application/json;profile=urn:org.apache.isis/v1;suppress=true;"
            }
          }
        }
      ).get({
        userSubscriptionId: '"' + userSubscriptionId + '"',
        notificationType: notificationType
      });
    }

    function findByUserSubscriptionFollow(userSubscriptionId) {
      return $resource(
        ApiEndPoint.url + 'restful/services/GeneralParametersRepository/actions/findByUserSubscriptionFollow/invoke', {}, {
          get: {
            method: 'GET',
            headers: {
              "Accept": "application/json;profile=urn:org.apache.isis/v1;"
            }
          }
        }
      ).get({
        "x-isis-querystring": {
          userSubscription: { value: userSubscriptionId }
        }
      });
    }

    return {
      get_SIMPLEUSERINSTANCE_ID: get_SIMPLEUSERINSTANCE_ID,
      get_USERSUBSCRIPTION_ID: get_USERSUBSCRIPTION_ID,
      get_USERSUBSCRIPTIONINSTANCE_ID: get_USERSUBSCRIPTIONINSTANCE_ID,
      get_USER_INSTANCE_HREF: get_USER_INSTANCE_HREF,
      get_USER_USERNAME: get_USER_USERNAME,
      get_USER_NAME: get_USER_NAME,
      set_USER_NAME: set_USER_NAME,
      get_BACK_GROUND: get_BACK_GROUND,
      get_USER_BIO: get_USER_BIO,
      get_USER_MEMBERSHIP: get_USER_MEMBERSHIP,
      set_USER_MEMBERSHIP: set_USER_MEMBERSHIP,
      get_USER_PHOTO: get_USER_PHOTO,
      get_USER_EMAIL: get_USER_EMAIL,
      get_USER_ROLE_ID: get_USER_ROLE_ID,
      get_USER_PERMISSIONS: get_USER_PERMISSIONS,
      set_USER_PERMISSIONS: set_USER_PERMISSIONS,
      USER_IS_SUPERADMIN: USER_IS_SUPERADMIN,
      USER_IS_ADVERTISER: USER_IS_ADVERTISER,
      get_USER_PREFERENCES: get_USER_PREFERENCES,
      set_USER_PREFERENCES: set_USER_PREFERENCES,
      redeemCodeWS: redeemCodeWS,
      changeMembershipWS: changeMembershipWS,
      runBlackListWS: runBlackListWS,
      getUserSubscriptionByinstanceId: getUserSubscriptionByinstanceId,
      getUserSubscriptionByinstanceIdProfileData: getUserSubscriptionByinstanceIdProfileData,
      getUserSubscriptionByinstanceIdPrivateAccount: getUserSubscriptionByinstanceIdPrivateAccount,
      getUserSubscriptionByinstanceIdCompleteProfile: getUserSubscriptionByinstanceIdCompleteProfile,
      getFollowingIsActiveWS: getFollowingIsActiveWS,
      findUserSubscriptionByUserName: findUserSubscriptionByUserName,
      findFriendUserSubscriptionsByUserName: findFriendUserSubscriptionsByUserName,
      findFriendUserSubscriptionsByUserNamev157: findFriendUserSubscriptionsByUserNamev157,
      findUserSubscriptionsByWebUserWS: findUserSubscriptionsByWebUserWS,
      findSuggestedFriends: findSuggestedFriends,
      toggleFriendhipStateWS: toggleFriendhipStateWS,
      followersByUserId: followersByUserId,
      findFriendsByUserSubscriptionId: findFriendsByUserSubscriptionId,
      changePrivateAccount: changePrivateAccount,
      getStatusPrivateAccount: getStatusPrivateAccount,
      cancelRequestToPrivate: cancelRequestToPrivate,
      getStatusPrivateRequest: getStatusPrivateRequest,
      blockToUser: blockToUser,
      unblockUser: unblockUser,
      findBlockUserById: findBlockUserById,
      findBlackListbyOwnerId: findBlackListbyOwnerId,
      updatePassword: updatePassword,
      sendEmail: sendEmail,
      findUserByUserName: findUserByUserName,
      sendNewPassword: sendNewPassword,
      updateNotificationStatus: updateNotificationStatus,
      updatePackNotificationStatus: updatePackNotificationStatus,
      findUserSubscriptionById: findUserSubscriptionById,
      findUserSubscriptionv157: findUserSubscriptionv157,
      sendSupportEmail: sendSupportEmail,
      getsupportType: getsupportType,
      cancelUserSubscription: cancelUserSubscription,
      changeProfilePicture: changeProfilePicture,
      sendReaction: sendReaction,
      acceptFriend: acceptFriend,
      getCities: getCities,
      getSections: getSections,
      checkCitiesByCity: checkCitiesByCity,
      validateUserName: validateUserName,
      countPendingNotifications: countPendingNotifications,
      countPendingFollowersNotifications: countPendingFollowersNotifications,
      findAllUserNotificationsByUserSubscription: findAllUserNotificationsByUserSubscription,
      findAllUserNotificationsByUserSubscriptionNotifications: findAllUserNotificationsByUserSubscriptionNotifications,
      findAllUserNotificationsByUserSubscriptionFollow: findAllUserNotificationsByUserSubscriptionFollow,
      countSequencesToAUser: countSequencesToAUser,
      countFollowersToAUser: countFollowersToAUser,
      countFollowingToAUser: countFollowingToAUser,
      findUserProfilePictureLargeById: findUserProfilePictureLargeById,
      findFriendsByUserSubscriptionIdTag: findFriendsByUserSubscriptionIdTag,
      findFriendsByUserSubscriptionIdTagv167: findFriendsByUserSubscriptionIdTagv167,
      findFriendsByUserSubscriptionIdTagv157: findFriendsByUserSubscriptionIdTagv157,
      searchUsersByPartialNameOrIncludingSpaces: searchUsersByPartialNameOrIncludingSpaces,
      editTextfromUserBiography: editTextfromUserBiography,
      addDevice: addDevice,
      getDevices: getDevices,
      chkStatusForPush: chkStatusForPush,
      getDevicesByRegion: getDevicesByRegion,
      getDevicesUsersCommentAPost: getDevicesUsersCommentAPost,
      getDevicesUsersCommentAPostWithType: getDevicesUsersCommentAPostWithType,
      getDevicesUsersLikedAPost: getDevicesUsersLikedAPost,
      deleteDevice: deleteDevice,
      getPushNotificationsConfig: getPushNotificationsConfig,
      updatePushNotificationConfig: updatePushNotificationConfig,
      findNewUsers: findNewUsers,
      findFeatured: findFeatured,
      findLatestItemBelongingToAUserSubscription: findLatestItemBelongingToAUserSubscription,
      findLatestItemThumbBelongingToAUserSubscription: findLatestItemThumbBelongingToAUserSubscription,
      findLatestItemThumbBelongingToAUserSubscriptionByType: findLatestItemThumbBelongingToAUserSubscriptionByType,
      findFriendInstanceId: findFriendInstanceId,
      getFriend: getFriend,
      favorite: favorite,
      city: city,
      email: email,
      name: name,
      sendNewPasswordEmail: sendNewPasswordEmail,
      sendEmailToSupportLogin: sendEmailToSupportLogin,
      validateUserEmail: validateUserEmail,
      deleteUserComplete: deleteUserComplete,
      findUsersRandomWS: findUsersRandomWS,
      accessToLinkGroup: accessToLinkGroup,
      linkAccountWithFacebook: linkAccountWithFacebook,
      updateBirthDay: updateBirthDay,
      findUsersBirthDate: findUsersBirthDate,
      getAllMetaDataWithUserSubscriptionId: getAllMetaDataWithUserSubscriptionId,
      updateLegalUserVersion: updateLegalUserVersion,
      findFollowersUserDeviceUserSubscriptionId: findFollowersUserDeviceUserSubscriptionId, //LuMa Live Streaming
      findByUserSubscriptionFollow: findByUserSubscriptionFollow,
      historyToken: historyToken
    };

  }])


  //Servicio para realizar Sign up via Facebook
  .factory('SignUpService', ['$resource', 'ApiEndPoint', function($resource, ApiEndPoint) {
    return {
      addUserSignUp: function() {
        return $resource(
          //ApiEndPoint.url + 'restful/services/UserRepository/actions/addUserSignUp/invoke',
          ApiEndPoint.url + 'restful/services/UserRepository/actions/addUserSignUpv1711/invoke', {}, {
            post: {
              method: 'POST',
              headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1;repr-type=object;' }
            }
          });
      },
      //new version for add birthday into the info
      addUserSignUpv1174: function() {
        return $resource(
          ApiEndPoint.url + 'restful/services/UserRepository/actions/addUserSignUpv1174/invoke', {}, {
            post: {
              method: 'POST',
              headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1;repr-type=object;' }
            }
          });
      }
    };
  }])


  //Servicios para realizar Sign in via Facebook
  .factory('SignInService', ['$resource', 'ApiEndPoint', function($resource, ApiEndPoint) {
    return {
      findByWebUserId: function() {
        return $resource(
          ApiEndPoint.url + 'restful/services/WebUserRepository/actions/findByWebUserId/invoke', {}, {
            get: {
              method: 'GET',
              isArray: true,
              headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1;suppress=true' }
            }
          });
      }
    };
  }])

  //Servicio para agregar suscripcion
  .factory('AddSubscriptionService', ['$resource', 'ApiEndPoint', function($resource, ApiEndPoint) {
    return {
      addSubscription: function() {
        return $resource(
          ApiEndPoint.url + 'restful/services/UserSubscriptionRepository/actions/addSubscription/invoke', {}, {
            post: {
              method: 'POST',
              headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1;repr-type=object;' }
            }
          });
      },

      addSubscriptionv200: function () {
        return $resource(
          ApiEndPoint.url + 'restful/services/UserSubscriptionRepository/actions/addSubscriptionv200/invoke', {}, {
            post: {
              method: 'POST',
              headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1;repr-type=object;' }
            }
          })
      },

      addSubscriptionv201: function () {
        return $resource(
          ApiEndPoint.url + 'restful/services/UserSubscriptionRepository/actions/addSubscriptionv201/invoke', {}, {
            post: {
              method: 'POST',
              headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1;repr-type=object;' }
            }
          })
      },

      validatePassCode: function (data) {
        return $resource(
          ApiEndPoint.url + 'restful/services/UserSubscriptionRepository/actions/reviewCode/invoke', {}, {
            post: {
              method: 'GET',
              headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1;repr-type=object;' }
            }
          }).get({
            "x-isis-querystring": {
              code: {
                value: data.code
              }
            }
          }
        )
      },

      generateSubscriptionv200: function (data) {
        return $resource(
          ApiEndPoint.url + 'restful/services/UserSubscriptionRepository/actions/generateSubscriptionv200/invoke', {}, {
            post: {
              method: 'POST',
              headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1;repr-type=object;' }
            }
          }).get({
            "x-isis-querystring": {
              userSubscriptionId: {
                value: ""+data.userSubs
              }
            }
          })
      }
      //value: { href: ApiEndPoint.url + 'restful/objects/simple.UserSubscription/' + data.userId }
    };
  }])

  //Servicio para agregar sign up sin facebook
  .factory('AddUserService', ['$resource', 'ApiEndPoint', function($resource, ApiEndPoint) {
    return {
      addUser: function() {
        return $resource(
          //ApiEndPoint.url + 'restful/services/UserRepository/actions/addUser/invoke', {},//
          ApiEndPoint.url + 'restful/services/UserRepository/actions/addUserv1711/invoke', {}, {
            post: {
              method: 'POST',
              headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1;repr-type=object;' }
            }
          }
        );
      },

      addUserv1174: function() {
        return $resource(
          //ApiEndPoint.url + 'restful/services/UserRepository/actions/addUser/invoke', {},//
          ApiEndPoint.url + 'restful/services/UserRepository/actions/addUserv1174/invoke', {}, {
            post: {
              method: 'POST',
              headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1;repr-type=object;' }
            }
          }
        );
      },

      /**
       * @param cityName {string}
       * @return {*}
       */
      addCityToCatalogWS: function(cityName) {
        return $resource(
          //ApiEndPoint.url + 'restful/services/UserRepository/actions/addUser/invoke', {},//
          ApiEndPoint.url + 'restful/services/CityRepository/actions/addCity/invoke', {}, {
            post: {
              method: 'POST',
              headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1;repr-type=object;' }
            }
          }
        ).save({
          city: { value: cityName }
        });
      },
      newUser: {}
    };
  }])

  //servicio para cambiar profile picture
  .factory('changeProfilePictureService', ['$resource', 'ApiEndPoint', function($resource, ApiEndPoint) {
    return {
      changeProfPict: function(userSubscriptionInstanceId) {
        return $resource(
          ApiEndPoint.url + 'restful/objects/simple.UserSubscription/' + userSubscriptionInstanceId.userSubscriptionId + '/actions/changeProfilePictures/invoke', userSubscriptionInstanceId.userSubscriptionId, {
            post: {
              method: 'POST',
              headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1' }
            }
          }
        );
      },
      changeProfPictv181: function(userSubscriptionInstanceId) {
        return $resource(
          ApiEndPoint.url + 'restful/objects/simple.UserSubscription/' + userSubscriptionInstanceId.userSubscriptionId + '/actions/changeProfilePicturesv181/invoke', userSubscriptionInstanceId.userSubscriptionId, {
            post: {
              method: 'POST',
              headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1' }
            }
          }
        );
      },
      changeBackPict: function(userSubscriptionInstanceId) {
        return $resource(
          ApiEndPoint.url + 'restful/objects/simple.UserSubscription/' + userSubscriptionInstanceId.userSubscriptionId + '/actions/changeProfilePictureBackgroundUrl/invoke', userSubscriptionInstanceId.userSubscriptionId, {
            post: {
              method: 'POST',
              headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1' }
            }
          }
        );
      },
      getBackgroundPictureFromId: function(data) {
        return $resource(
          ApiEndPoint.url + 'restful/objects/simple.UserSubscription/:objectId/actions/findProfileBackGroundUrl/invoke', { objectId: data.userId }, {
            get: {
              method: 'GET',
              headers: { "Accept": "application/json" }
            }
          }
        ).get().$promise;
      }

    };
  }])

  //servicio para buscar id subscription por webuserid
  .factory('FindUserSubscriptionbyWebUser', ['$resource', 'ApiEndPoint', function($resource, ApiEndPoint) {
    return {
      findUserSubscription: function() {
        return $resource(
          ApiEndPoint.url + 'restful/services/UserSubscriptionRepository/actions/findUserSubscriptionsByWebUser/invoke', {}, {
            get: {
              method: 'GET',
              isArray: true,
              headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1;suppress=true' }
            }
          });
      }
    };
  }])

  .factory('UserServiceFb', function() {
    var setUser = function(user_data) {
      window.localStorage.starter_facebook_user = JSON.stringify(user_data);
    };

    var getUser = function() {
      return JSON.parse(window.localStorage.starter_facebook_user || '{}');
    };

    return {
      getUser: getUser,
      setUser: setUser
    };
  })

  .factory('ionicService', ['$resource', 'ApiEndPoint', function($resource, ApiEndPoint) {
    return {
      sendPushNotification: function() {
        return $resource(
          ApiEndPoint.ionic + '/notifications', {}, {
            post: {
              method: 'POST',
              headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJqdGkiOiI3YjE0MTY1Yi1jMWY2LTRhMTgtYWJkNi0yNmNhNDU0ZDQ0MDMifQ.gbaK9NiP2ycCrsC4Hl3zbTS4G7CnpMEI7_OqjZUWl2I"
              }
            }
          });
      }
    };
  }])


  .factory('reDirectService', function($state) {

    function reDirectProfile(userSubscriptionInstanceId) {
      if (userSubscriptionInstanceId == window.localStorage.getItem("userSubscriptionInstanceId")) {
        $state.go('menu.myProfile', {}, { reload: true });
      } else {
        $state.go('friendProfile', { "instanceId": userSubscriptionInstanceId }, { reload: true });
      }
    }

    return {
      reDirectProfile: reDirectProfile
    };
  })

  .factory('userAttendanceService', ['$resource', 'ApiEndPoint', function($resource, ApiEndPoint) {

    /**
     *
     *
     **/
    function addUserAttendance(objectId) {
      return $resource(
        ApiEndPoint.url + 'restful/services/UserAttendanceRepository/actions/addUserAttendance/invoke', {}, {
          post: {
            method: 'POST',
            headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1;' }
          }
        }
      );
    }

    function countUserAttendance(objectId) {
      return $resource(
        ApiEndPoint.url + 'restful/services/UserAttendanceRepository/actions/countUserAttendanceByDate/invoke', {}, {
          get: {
            method: 'GET',
            headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1;' }
          }
        }
      );
    }

    function countUserAttendanceRange(objectId) {
      return $resource(
        ApiEndPoint.url + 'restful/services/UserAttendanceRepository/actions/countUserAttendanceByDatev2/invoke', {}, {
          get: {
            method: 'GET',
            headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1;' }
          }
        }
      );
    }

    function findListUserAttendance(objectId) {
      return $resource(
        ApiEndPoint.url + 'restful/services/UserAttendanceRepository/actions/findUserAttendanceByDate/invoke', {}, {
          get: {
            method: 'GET',
            isArray: true,
            headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1;' }
          }
        }
      );
    }

    function findListUserAttendanceDetails(objectId) {
      return $resource(
        ApiEndPoint.url + 'restful/services/UserAttendanceRepository/actions/findUserAttendanceDetailByDate/invoke', {}, {
          get: {
            method: 'GET',
            isArray: true,
            headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1;' }
          }
        }
      );
    }

    function findListUserAttendanceDetailsRange(objectId) {
      return $resource(
        ApiEndPoint.url + 'restful/services/UserAttendanceRepository/actions/findUserAttendanceDetailByDatev2/invoke', {}, {
          get: {
            method: 'GET',
            isArray: true,
            headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1;' }
          }
        }
      );
    }

    return {
      addUserAttendance: addUserAttendance,
      countUserAttendance: countUserAttendance,
      countUserAttendanceRange: countUserAttendanceRange,
      findListUserAttendance: findListUserAttendance,
      findListUserAttendanceDetails: findListUserAttendanceDetails,
      findListUserAttendanceDetailsRange: findListUserAttendanceDetailsRange
    }
  }])

  .factory('userLockerService', ['$resource', 'ApiEndPoint', function($resource, ApiEndPoint) {

    /**
     *
     * @type {{SEQUENCE: number, PROMOTION: number}}
     */
    var LOCKER_TYPES = {
      SEQUENCE: 1,
      PROMOTION: 2
    }
    /**
     * @typedef {Object} PROMO_TYPES
     * @property PROMOTION {string}
     * @property COUPON {string}
     * @property EASTER_EGG {string}
     */

    /**@type {PROMO_TYPES}*/
    var PROMO_TYPES = {
      //{0: PROMOTION, 1: COUPON, 2: EASTER_EGG}
      PROMOTION: 0,
      COUPON: 1,
      EASTER_EGG: 2
    };

    /**
     * @typedef {Object} PROMO_MEDIA_TYPES
     * @property SINGLE_IMAGE {number}
     * @property IMAGE_GALLERY {number}
     * @property VIDEO {number}
     */

    /**@type {PROMO_MEDIA_TYPES}*/
    var PROMO_MEDIA_TYPES = {
      UNKNOWN: 0,
      SINGLE_IMAGE: 1,
      IMAGE_GALLERY: 2,
      VIDEO: 3
    };

    /**
     * @typedef {Object} Locker
     * @property creationDate {string}
     * @property date {string}
     * @property lockerId {number}
     * @property lockerType {number}
     *
     * @property promotion? {Object}
     * @property promotion.href {string}
     * @property promotion.title {string}

     * @property sequence? {href:{string}}
     * @property sequence.href {string}
     * @property sequence.title {string}
     *
     * @property sequenceLocker {Object}
     * @property sequenceLocker.href {string}
     * @property userSubscription {href:{string}}
     */

    /**
     * @typedef {Object} PromoBasicData
     * @property creationDate {string}
     * @property date {string}
     * @property description {string}
     * @property promotion {Object}
     * @property promotion.href {string}
     * @property promotionId {number}
     * @property promotionType {number} - promotionType = {0: promo, 1: cupon, 2: easteregg}
     * @property userSubscription {{href:string}}
     */

    /**
     * @typedef {Object} Promotion
     * @property id {number}
     * @property href {string}
     * @property type {PROMO_TYPES}
     * @property date {string}
     * @property description {string}
     * @property mediaType {PROMO_MEDIA_TYPES}
     * @property items {Array<{src:string, thumb?:string}>}
     */

    /**
     * @param data
     * @return {*}
     */
    function getlockerOfUser(data) {
      return $resource(
        ApiEndPoint.url + 'restful/services/SequenceLockerRepository/actions/findSequenceLockerByUserSubscriptionId/invoke', {}, {
          get: {
            method: 'GET',
            isArray: true,
            headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1;' }
          }
        }
      ).get({
        "userSubscriptionId": '"' + data.id + '"',
        "withStart": '"' + data.start + '"',
        "withCount": '"' + data.count + '"'
      });
    }

    /**
     * @param data {{sequenceHref?: string, promotionHref?: string, userSubscriptionId: number|string}}
     * @return {*}
     */
    function addItemToLocker(data) {
      var data2send = {
        userSubscriptionId: { value: data.userSubscriptionId }
      };

      if (data.sequenceHref)
        data2send.sequence = { value: { href: data.sequenceHref } };
      if (data.promotionHref)
        data2send.promotion = { value: { href: data.promotionHref } };

      return $resource(
        ApiEndPoint.url + 'restful/services/SequenceLockerRepository/actions/addSequenceLocker/invoke', {}, {
          post: {
            method: 'POST',
            headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1;' }
          }
        }
      ).save(data2send);
    }

    function removeItemFromLocker(objectId) {

      return $resource(
        ApiEndPoint.url + 'restful/objects/simple.SequenceLocker/:objectId/actions/delete/invoke', { objectId: objectId }, {
          post: {
            method: 'POST',
            headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1;' }
          }
        }
      ).save();
    }

    return {
      LOCKER_TYPES: LOCKER_TYPES,
      PROMO_TYPES: PROMO_TYPES,
      PROMO_MEDIA_TYPES: PROMO_MEDIA_TYPES,
      getlockerOfUser: getlockerOfUser,
      addItemToLocker: addItemToLocker,
      removeItemFromLocker: removeItemFromLocker
    }
  }])

  .factory('UserInterestService', ['$resource', 'ApiEndPoint', function($resource, ApiEndPoint) {
    function findInterestByUserSubscriptionId(data) {
      return $resource(
        ApiEndPoint.url + 'restful/services/UserInterestRepository/actions/findInterestByUserSubscriptionId/invoke', {}, {
          get: {
            method: 'GET',
            isArray: true,
            headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1;' }
          }
        }
      ).get({
        "x-isis-querystring": {
          userSubscriptionid: {
            value: data.userSubscriptionid
          }
        }
      })
    }

    function findAllInterests() {
      return $resource(
        ApiEndPoint.url + 'restful/services/InterestRepository/actions/findAllInterests/invoke', {}, {
          get: {
            method: 'GET',
            //isArray: true,
            //headers: {'Accept': 'application/json;profile=urn:org.apache.isis/v1;'}
            headers: { 'Accept': 'application/json;profile=urn:org.restfulobjects:repr-types/action-result' }
          }
        }
      ).get();
    }

    function addNewInteresttoList() {
      return $resource(
        ApiEndPoint.url + 'restful/services/InterestRepository/actions/addInterest/invoke', {}, {
          post: {
            method: 'POST',
            headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1;' }
          }
        }
      );
    }

    function addInterestToUser() {
      return $resource(
        ApiEndPoint.url + 'restful/services/UserInterestRepository/actions/addUserInterest/invoke', {}, {
          post: {
            method: 'POST',
            headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1;' }
          }
        }
      );
    }

    return {
      findInterestByUserSubscriptionId: findInterestByUserSubscriptionId,
      findAllInterests: findAllInterests,
      addNewInteresttoList: addNewInteresttoList,
      addInterestToUser: addInterestToUser
    }
  }])

  .factory('userScheduledService', ['$resource', 'ApiEndPoint', function($resource, ApiEndPoint) {
    function findScheduledPosts(data) {
      return $resource(
        ApiEndPoint.url + 'restful/services/PostScheduleRepository/actions/findSchedulePublicationsByUserSubscriptionId/invoke', {}, {
          get: {
            method: 'GET',
            isArray: true,
            headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1;' }
          }
        }
      ).get({
        "userSubscriptionId": '"' + data.id + '"',
        "withStart": '"' + data.start + '"',
        "withCount": '"' + data.count + '"'
      })
    }

    function findScheduledGroupsPosts(data) {
      return $resource(
        ApiEndPoint.url + 'restful/services/SequenceGroupRepository/actions/findSchedulePublicationsByUserSubscriptionId/invoke', {}, {
          get: {
            method: 'GET',
            isArray: true,
            headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1;' }
          }
        }
      ).get({
        "userSubscriptionId": '"' + data.id + '"',
        "withStart": '"' + data.start + '"',
        "withCount": '"' + data.count + '"'
      })
    }

    function changeInitialDate(data) {
      return $resource(
        ApiEndPoint.url + 'restful/objects/simple.Sequence/:objectId/actions/changePostInitialDate/invoke', { objectId: data.sequenceId }, {
          post: {
            method: 'POST',
            headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1" }
          }
        }
      ).save({
        initialDate: { value: data.date }
      })
    }

    function changeInitialTime(data) {
      return $resource(
        ApiEndPoint.url + 'restful/objects/simple.Sequence/:objectId/actions/changePostInitialTime/invoke', { objectId: data.sequenceId }, {
          post: {
            method: 'POST',
            headers: { "Accept": "application/json;profile=urn:org.apache.isis/v1" }
          }
        }
      ).save({
        initialDate: { value: data.date }
      })
    }

    function getGroupInfoFromScheduledPost(data) {
      return $resource(
        ApiEndPoint.url + 'restful/services/SequenceGroupRepository/actions/findSchedulePublicationsGroupBySequenceId/invoke', {}, {
          get: {
            method: 'GET',
            isArray: true,
            headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1;' }
          }
        }
      ).get({
        "sequenceId": '"' + data.sequenceId + '"',
        "withStart": '"' + data.start + '"',
        "withCount": '"' + data.count + '"'
      })
    }

    return {
      findScheduledPosts: findScheduledPosts,
      findScheduledGroupsPosts: findScheduledGroupsPosts,
      changeInitialDate: changeInitialDate,
      changeInitialTime: changeInitialTime,
      getGroupInfoFromScheduledPost: getGroupInfoFromScheduledPost
    }
  }])

  //LuMa Live Streaming
  .factory('StreamingService', ['$resource', 'ApiEndPoint', function($resource, ApiEndPoint) {

    function addUserStreaming(data) {
      return $resource(
        ApiEndPoint.url + 'restful/services/UserStreamingRepository/actions/addUserStreaming/invoke', {}, {
          post: {
            method: 'POST',
            headers: {
              'Accept': 'application/json;profile=urn:org.apache.isis/v1;suppress=true'
            }
          }
        }
      ).save({
        userSubscriptionId: {
          value: "" + data.userSubscriptionId
        },
        rmtpUrl: {
          value: data.rtmpUrl
        },
        mp4Url: {
          value: data.mp4Url
        }
      });
    }

    function addUserStreamingNotification(data) {
      return $resource(
        ApiEndPoint.url + 'restful/services/UserNotificationRepository/actions/addUserStreamingNotification/invoke', {}, {
          post: {
            method: 'POST',
            headers: {
              'Accept': 'application/json;profile=urn:org.apache.isis/v1;suppress=true'
            }
          }
        }
      ).save({
        userStreamingId: {
          value: "" + data.UserStreaming
        }
      });
    }

    function finish(objectId) {
      return $resource(
        ApiEndPoint.url + 'restful/objects/simple.UserStreaming/:objectId/actions/finish/invoke', {
          objectId: objectId
        }, {
          post: {
            method: 'POST',
            headers: {
              'Accept': 'application/json;profile=urn:org.apache.isis/v1;suppress=true'
            }
          }
        }).save();
    }

    function findStreamingByUserSubscriptionId(userSubscriptionid) {
      return $resource(
        ApiEndPoint.url + 'restful/services/UserStreamingRepository/actions/findStreamingByUserSubscriptionId/invoke', {}, {
          get: {
            method: 'GET',
            isArray: true,
            headers: {
              'Accept': 'application/json;profile=urn:org.apache.isis/v1;suppress=true'
            }
          }
        }).get({
        userSubscriptionid: '"' + userSubscriptionid + '"'
      });
    }

    function findStreamingByUserStreamingId(userStreaming) {
      return $resource(ApiEndPoint.url + 'restful/services/UserStreamingRepository/actions/findStreamingByUserStreamingId/invoke', {}, {
        get: {
          method: 'GET',
          isArray: true,
          headers: {
            'Accept': 'application/json;profile=urn:org.apache.isis/v1;suppress=true'
          }
        }
      }).get({
        userStreaming: '"' + userStreaming + '"'
      });
    }

    function findAllStreamingv2(withStart, withCount) {
      return $resource(ApiEndPoint.url + 'restful/services/UserStreamingRepository/actions/findAllStreamingv2/invoke', {}, {
        get: {
          method: 'GET',
          isArray: true,
          headers: {
            'Accept': 'application/json;profile=urn:org.apache.isis/v1;suppress=true'
          }
        }
      }).get({
        withStart: withStart,
        withCount: withCount
      });
    }

    function updateStraeaming(objectId) {
      return $resource(ApiEndPoint.url + 'restful/objects/simple.Sequence/:objectId/actions/updateStraeaming/invoke', {
        objectId: objectId
      }, {
        post: {
          method: 'POST',
          headers: {
            'Accept': 'application/json;profile=urn:org.apache.isis/v1;suppress=true'
          }
        }
      }).save();
    }

    function findAllStreamingPublications(withStart, withCount) {
      return $resource(ApiEndPoint.url + 'restful/services/SequenceRepository/actions/findAllStreamingPublications/invoke', {}, {
        get: {
          method: 'GET',
          isArray: true,
          headers: {
            'Accept': 'application/json;profile=urn:org.apache.isis/v1;suppress=true'
          }
        }
      }).get({
        withStart: '"' + withStart + '"',
        withCount: '"' + withCount + '"'
      });
    }

    function incrementUserStreamingViewCount(objectId) { //Luma Live Streaming Statistics
      return $resource(ApiEndPoint.url + 'restful/objects/simple.UserStreaming/:objectId/actions/viewCount/invoke', {
        objectId: objectId
      }, {
        post:{

          method: 'POST',
          headers: {
            'Accept': 'application/json;profile=urn:org.apache.isis/v1;suppress=true'
          }
        }
      }).save();
    }

    function updateVideoPostStream (data) {
      return $resource(ApiEndPoint.url + 'restful/services/SequenceRepository/actions/changeStreamFinalUrl/invoke', {},
      {
        get: {
          method: 'GET',
          headers: {
            'Accept': 'application/json;profile=urn:org.apache.isis/v1;suppress=true'
          }
        }
      }).get({
        "x-isis-querystring": {
          sequenceId: {
            value: data.sequenceId
          },
          uRL: {
            value: data.url
          }
        }
      })
    }

    function getBannersForVideoOrStream () {
      return $resource(ApiEndPoint.url + 'restful/services/AdPictureRepository/actions/findAllAdPictures/invoke', {}, {
        get: {
          method: 'GET',
          isArray: true,
          headers: {
            'Accept': 'application/json;profile=urn:org.apache.isis/v1;suppress=true'
          }
        }
      }).get({});
    }

    return {
      addUserStreaming: addUserStreaming,
      addUserStreamingNotification: addUserStreamingNotification,
      finish: finish,
      findStreamingByUserSubscriptionId: findStreamingByUserSubscriptionId,
      findStreamingByUserStreamingId: findStreamingByUserStreamingId,
      findAllStreamingv2: findAllStreamingv2,
      updateStraeaming: updateStraeaming,
      findAllStreamingPublications: findAllStreamingPublications,
      incrementUserStreamingViewCount: incrementUserStreamingViewCount,
      updateVideoPostStream: updateVideoPostStream,
      getBannersForVideoOrStream: getBannersForVideoOrStream
    }

  }])

  .factory('onBoardingService', ['$resource', 'ApiEndPoint', function($resource, ApiEndPoint) {

    function getPendingAccounts(init, increase, search) {
      return $resource(
        ApiEndPoint.url + 'restful/services/UserSubscriptionRepository/actions/findUserSubscriptionsPendingForReview/invoke', {}, {
          get: {
            method: 'GET',
            isArray: true,
            headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1;' }
          }
        }
      ).get({
        "withStart": '"' + init + '"',
        "withCount": '"' + increase + '"',
        "search": '"' + search + '"'
      })
    }

    function activateAccounts(data) {
      return $resource(
        ApiEndPoint.url + 'restful/objects/simple.UserSubscription/:objectId/actions/activate/invoke', {
          objectId: data.data
        }, {
          post: {
            method: 'POST',
            headers: {
              'Accept': 'application/json;profile=urn:org.apache.isis/v1;suppress=true'
            }
          }
        }
      ).save();
    }

    return {
      activateAccounts: activateAccounts,
      getPendingAccounts: getPendingAccounts
    }

  }])
  //LuMa Live Streaming
  .factory('AntMediaServerService', ['$resource', 'AntMediaServer', function($resource, AntMediaServer) {

    function createBroadcast(name) {
      return $resource(AntMediaServer.apiEndPoint + '/v2/broadcasts/create', {}, {
        post: {
          method: 'POST',
          headers: {
            'Accept': 'application/json'
          }
        }
      }).save({
        name: name
      });
    }

    function deleteBroadcast(id) {
      return $resource(AntMediaServer.apiEndPoint + '/v2/broadcasts/delete/:id', {
        id: id
      }, {
        post: {
          method: 'POST',
          headers: {
            'Accept': 'application/json'
          }
        }
      }).save();
    }
    
    function getStreamInfo(id) {
      return $resource(AntMediaServer.apiEndPoint + '/v2/broadcasts/:id/stream-info', {
        id: id
      }, {
        post: {
          method: 'GET',
          headers: {
            'Accept': 'application/json'
          }
        }
      }).save();
    }

    return {
      createBroadcast: createBroadcast,
      deleteBroadcast: deleteBroadcast,
      getStreamInfo: getStreamInfo
    }

  }])

  //LuMa Live Streaming 
  .factory('ImageServiceStreaming', function($cordovaCamera, FileServiceStreaming, $q, $cordovaFile, $cordovaImagePicker, $rootScope) {

    function optionsForType(type) {
      var source;
      switch (type) {
        case 0:
          source = Camera.PictureSourceType.CAMERA;
          break;
        case 1:
          source = Camera.PictureSourceType.PHOTOLIBRARY;
          break;
      }
      return {
        quality: 100,
        targetWidth: 648,
        targetHeight: 648,
        destinationType: Camera.DestinationType.FILE_URI,
        sourceType: source,
        allowEdit: true,
        encodingType: Camera.EncodingType.JPEG,
        popoverOptions: CameraPopoverOptions,
        saveToPhotoAlbum: false,
        correctOrientation: true
      };
    }
    /*NEW PLUGIN SECTION*/
    function saveCameraMedia(type) {
      return $q(function(resolve) {
        var options = optionsForType(type);
        MediaPicker.takePhoto(function(media) {
          media.index = 0;
          console.log('Image URI: ', media);
          var promise1 = imageUriToImage64(media.path);
          var promise2 = imageUriToImage64Thumb(media.path);
          $q.all([promise1, promise2]).then(function success() {
            resolve(FileServiceStreaming);
          });
        }, function(error) {
          console.error("fail: ", error);
        }, options);
      });
    }

    function saveAlbumMedia(opts) {
      return $q(function(resolve) {

        var resultMedias = [];
        var args = {
          'selectMode': 100,
          'maxSelectCount': 1
        }
        console.log("here", $rootScope.MEDIA_PICKER);
        MediaPicker.getMedias(args, function(medias) { //photoLibrary
          console.log("success: ", medias);
          var promises = [];
          for (var i = 0; i < medias.length; i++) {
            medias[i].quality = 55;
            $rootScope.moment = 0;
            var mediaSel = medias[i];
            var isIOS = ionic.Platform.isIOS();
            if (isIOS) {
              MediaPicker.compressImage(medias[i], function(compressData) {
                MediaPicker.getExifForKey(compressData.path, "Orientation", function(oriExif) {
                  console.log("data", oriExif);
                  promises.push(imageUriToImage64Fix(compressData.path, medias.length, oriExif));
                  promises.push(imageUriToImage64ThumbFix(compressData.path, oriExif));
                })
              })
            } else {
              MediaPicker.compressImage(mediaSel, function(compressData) {
                promises.push(imageUriToImage64(compressData.path, medias.length));
                promises.push(imageUriToImage64Thumb(compressData.path));
              })
            }
            /*promises.push(imageUriToImage64(medias[i].path));
            promises.push(imageUriToImage64Thumb(medias[i].path));*/
          }
          $q.all(promises).then(function success() {
            console.log("resolved");
            resolve(FileServiceStreaming);
          });
        }, function(error) {
          console.error("fail: ", error);
        });

      });
    }
    /*END NEW PLUGIN SECTION*/
    function saveAlbumMediaFix(preExisted) {
      var picsAllowed = 6 - preExisted;
      return $q(function(resolve) {
        var options = {
          width: 648,
          height: 648,
          quality: 100,
          maximumImagesCount: picsAllowed
        };

        $cordovaImagePicker.getPictures(options)
          .then(function(results) {
            var promises = [];
            for (var i = 0; i < results.length; i++) {
              console.log('Image URI: ' + results[i]);
              promises.push(imageUriToImage64(results[i]));
              promises.push(imageUriToImage64Thumb(results[i]));
              //imageUriToImage64Thumb(results[i], callback);
            }
            $q.all(promises).then(function success() {
              resolve(FileServiceStreaming);
            });
          }, function error() {
            console.log(' error getting photos');
          });

      });
    }

    function imageUriToImage64(imageUri, final) {
      return $q(function(resolve) {
        //FileServiceStreaming.storeImage(imageUri);
        //resolve();
        var c = document.createElement('canvas');
        var ctx = c.getContext("2d");
        var img = new Image();
        img.onload = function() {
          c.width = this.width;
          c.height = this.height;
          ctx.drawImage(img, 0, 0);
          var dataURL = c.toDataURL("image/jpeg");
          //FileServiceStreaming.storeImage(dataURL.replace("data:image/jpeg;base64,", ""));
          FileServiceStreaming.storeImage(dataURL);
          console.log("image is loaded");
          if ($rootScope.moment === (final - 1))
            $rootScope.$broadcast('addedImage');
          $rootScope.moment++;
          resolve();
        };
        img.src = imageUri;
      });
    }

    function imageUriToImage64Fix(imageUri, final, exif) {
      return $q(function(resolve) {
        var newUri = window.Ionic.WebView.convertFileSrc(imageUri);
        loadImage(newUri, function(img) {
          //return CANVAS
          var dataURL = img.toDataURL("image/jpeg");
          //FileServiceStreaming.storeImage(dataURL.replace("data:image/jpeg;base64,", ""));
          FileServiceStreaming.storeImage(dataURL);
          console.log("image Fixed is loaded");
          if ($rootScope.moment === (final - 1))
            $rootScope.$broadcast('addedImage');
          $rootScope.moment++;
          resolve();
        }, {
          canvas: true,
          orientation: exif
        })
      })
    }

    function imageUriToImage64Thumb(imageUri) {
      return $q(function(resolve) {
        //FileServiceStreaming.storeThumb(imageUri);
        //resolve();
        var c = document.createElement('canvas');
        var ctx = c.getContext("2d");
        var img = new Image();
        img.onload = function() {
          c.width = Math.floor(this.width * 0.5);
          c.height = Math.floor(this.height * 0.5);
          ctx.drawImage(img, 0, 0, c.width, c.height);
          var dataURL = c.toDataURL("image/jpeg");
          FileServiceStreaming.storeThumb(dataURL);
          console.log("image is loaded");
          resolve();
        };
        img.src = imageUri;
      });
    }

    function imageUriToImage64ThumbFix(imageUri, exif) {
      return $q(function(resolve) {
        loadImage(imageUri, function(img) {
          //return CANVAS
          var dataURL = img.toDataURL("image/jpeg");
          FileServiceStreaming.storeThumb(dataURL);
          console.log("image Fixed is loaded");
          resolve();
        }, {
          canvas: true,
          orientation: exif
        })
      })
    }

    return {
      saveCameraMedia: saveCameraMedia,
      saveAlbumMedia: saveAlbumMedia,
      saveAlbumMediaFix: saveAlbumMediaFix
    };
  })

  //LuMa Live Streaming
  .factory('FileServiceStreaming', function() {
    var images = [];
    var thumbImages = [];

    function getImages() {
      return images;
    }

    function getThumbImages() {
      return thumbImages;
    }

    function storeImage(img) {
      //images.push(img);
      images.push(img);
    }

    function storeThumb(img) {
      thumbImages.push(img);
    }

    function cleanImages() {
      images = [];
      thumbImages = [];
    }

    return {
      storeImage: storeImage,
      images: getImages,
      storeThumb: storeThumb,
      thumbImages: getThumbImages,
      cleanImages: cleanImages
    };
  })

  //BALA NEW QUESTIONS ONBOARDING
  .factory('UserAdditionalInfo', ['$resource', 'ApiEndPoint', function($resource, ApiEndPoint) {

    function addAdditionalInfoToUser(data) {
      return $resource(
        ApiEndPoint.url + 'restful/services/UserAdditionalInformationRepository/actions/addUserAdditionaInformation/invoke', {}, {
          method: 'POST',
          headers: { 'Accept': 'application/json;profile=urn:org.apache.isis/v1' }
        }
      ).save({
        user: { value: { href: ApiEndPoint.url + "restful/objects/simple.User/" + data.user } },
        question: { value: ''+data.question },
        answer: { value: ''+data.answer}
      }).$promise;
    }

    return {
      addAdditionalInfoToUser: addAdditionalInfoToUser
    }
  }])
  //END BALA NEW QUESTIONS ONBOARDING
;
