"use strict";
appControllers
  .controller('discoveryCtrl', ['$rootScope', '$scope', '$state', 'ApiEndPoint', 'DBServices', 'UserService', 'usersData', '$ionicModal', '$ionicScrollDelegate', 'ionicService', 'TimeLineService', 'SequenceService', '$ionicSlideBoxDelegate', '$timeout', 'reDirectService', 'AWSServices', 'cqnzService', 'SequenceFactory', 'TagsService', 'notificationsService', 'QRScannerService', 'promosService', 'userLockerService', 'Utils', 'permissionValidationService','searchFactory', 'GroupFactory', 'Personalized',
    function ($rootScope, $scope, $state, ApiEndPoint, DBServices, UserService, usersData, $ionicModal, $ionicScrollDelegate, ionicService, TimeLineService, SequenceService, $ionicSlideBoxDelegate, $timeout, reDirectService, AWSServices, cqnzService, SequenceFactory, TagsService, notificationsService, QRScannerService, promosService, userLockerService, Utils, permissionValidationService, searchFactory, GroupFactory, Personalized) {
      $scope._controllerName = 'discoveryCtrl';
      Utils.clearHistory();
      var permissions = permissionValidationService;
      $scope.showToken = permissions.viewTokens();
      $scope.mySubscriptionHref = UserService.get_USER_INSTANCE_HREF();

      $scope.isAllowedScanQRCode = permissionValidationService.generalCanScanQRCode();

      var lastUsersSearch = 0,
        lastPostsSearch = 0,
        pendingUsersSearch,
        pendingPostsSearch,
        cancelUsersSearch = angular.noop,
        cancelPostsSearch = angular.noop;

      $scope.data = {};

      //check permmissions about Promos
      //$scope.canScanCodes = permissionValidationService.generalCanScanQRCode();
      // <-- END ZONE OF DECLARATIONS <---

      //----------------- Variables for seach modal ------------
      $scope.resultsForTerm = '';
      $scope.data.searchActiveTab = 'none';
      $scope.activateSearchTab = function (tabName) {
        $scope.data.searchActiveTab = tabName
      };

      $scope.usersResults = [];
      $scope.canSearchMoreUsers = true;
      $scope.searchingUsers = false;

      $scope._sequenceList = [];
      $scope.canSearchMorePosts = true;
      $scope.searchingPosts = false;

      var usersPagination = {
        start: 0,
        count: 15,
        reset: function () {
          this.start = 0;
          this.count = 15;
        },
        increaseCount: function (step) {
          this.count = step || 5
        }
      };

      var postsPagination = {
        start: 0,
        count: 5,
        reset: function () {
          this.start = 0;
          this.count = 5;
        },
        increaseCount: function (step) {
          this.count = step || 2
        }
      };

      $scope.isIOS = ionic.Platform.isIOS();
      $scope.isLoadingNewUsersList = false;
      $scope.isLoadingFeatUsersList = false;
      //============= END Variables for seach modal ============

      $scope.data.searchFor = 'users';
      $scope.newUsers = [];
      $scope.featuredUsers = [];

      $scope.newUsersCount = {};
      $scope.newUsersCount.start = 0;
      $scope.newUsersCount.pagination = {};
      $scope.newUsersCount.pagination.withStart = '"' + $scope.newUsersCount.start + '"';
      $scope.newUsersCount.pagination.withCount = '"' + 6 + '"';

      $scope.featuredUsersCount = {};
      $scope.featuredUsersCount.start = 0;
      $scope.featuredUsersCount.pagination = {};
      $scope.featuredUsersCount.pagination.withStart = '"' + $scope.featuredUsersCount.start + '"';
      $scope.featuredUsersCount.pagination.withCount = '"' + 5 + '"';
      $scope.featuredUsersCount.pagination.random = false;

      $scope.data.noMoreUsersAvailable = false;

      $scope.data.unfollowText = Utils.translate('GLOBAL.UNFOLLOW');
      $scope.data.followText = Utils.translate('GLOBAL.FOLLOW');
      $scope.data.pendingRequest = Utils.translate('GLOBAL.PENDING');

      $scope.data.activeTab = "featured";

      $scope.errorLoading = false;
      $scope.textOnboarding = [];

      $scope.data.trendingList = [];

      $scope.initDiscover = function () {
        $scope.newUsers = [];
        $scope.featuredUsers = [];
        $scope.newUsersCount.start = 0;
        $scope.newUsersCount.pagination.withStart = '"' + $scope.newUsersCount.start + '"';
        $scope.featuredUsersCount.start = 0;
        $scope.featuredUsersCount.pagination.withStart = '"' + $scope.featuredUsersCount.start + '"';
        $scope.changeTab($scope.data.activeTab);
        $scope.data.random = true;
      };

      $scope.changeTab = function (tab) {
        $scope.data.activeTab = tab;
        $scope.$broadcast('scroll.infiniteScrollComplete');
        $ionicScrollDelegate.resize();
        $scope.data.noMoreUsersAvailable = false;
      };

      $scope.changeTab("featured");

      $scope.loadMore = function () {
        $scope.isSearching = true;
        switch ($scope.data.activeTab) {
          case "featured":
            $scope.findFeatured();
            break;
          case "newUsers":
            $scope.findNewUsers();
            break;
        }
      };

      $scope.initSearch = function () {
        $scope.data.noMoreItemsAvailable = false;
        $scope.users = [];
        $scope.start = 0;
        $scope.count = 6;
      };


      $scope.checkSelectedOption = function () {
        //$scope.limitSearch(true);
        setTimeout(function(){document.getElementById("search-input").focus();},10);
        $scope.beginSearch(true);//$scope.beginSearch(false);
        $scope.data.searchActiveTab = $scope.data.searchFor;
      };

      var term = '';
      $scope.beginSearch = function (onlyClean) {
        term = $scope.data.searchTerm;
        $scope.resultsForTerm = '';
        $scope.errorLoading = false;

        if (onlyClean) {
          $scope.usersResults = [];
          $scope._sequenceList = [];
          usersPagination.reset();
          postsPagination.reset();
        }
        cancelUsersSearch();
        cancelPostsSearch();

        if ($scope.data.searchFor === 'posts') {

          $scope.canSearchMorePosts = true;
          if (!term || pendingPostsSearch /*|| debouncePostsSearch()*/) return;
          $scope.loadMorePostsSearch();

        } else if ($scope.data.searchFor === 'users') {
          
          $scope.canSearchMoreUsers = true;
          if (!term || pendingUsersSearch /*|| debounceUsersSearch()*/) return;
          $scope.loadMoreUsersSearch();

        } else if (term.charAt(0) === '#') {
          console.log("Don't search for Users");
          $scope.usersResults = [];
          $scope.searchingUsers = false;
          onSearchUsersFinished();
        }
      }

      $scope.beginSearch2 = function (onlyClean) {
        usersPagination.reset();
        postsPagination.reset();

        //term = $scope.data.userName;
        term = $scope.data.searchTerm;
        $scope.resultsForTerm = '';
        $scope.errorLoading = false;

        $scope.canSearchMoreUsers = true;
        $scope.canSearchMorePosts = true;

        if (!onlyClean) {
          $scope.usersResults = [];
          $scope._sequenceList = [];
          term = '';
          return;
        }

        if (!term || pendingUsersSearch || pendingPostsSearch || debounceUsersSearch() || debouncePostsSearch()) return;

        $scope.usersResults = [];
        $scope._sequenceList = [];

        cancelUsersSearch();
        cancelPostsSearch();

        if ($scope.data.searchFor === 'posts') {
          $scope.loadMorePostsSearch();
        }

        //user dont want to search other users
        if (term.charAt(0) === '#') {
          console.log("Don't search for Users");
          $scope.usersResults = [];
          $scope.searchingUsers = false;
          onSearchUsersFinished();
        }
        else if ($scope.data.searchFor === 'users') {
          $scope.loadMoreUsersSearch();
        }
      }

      var iteraciones=0;
      $scope.loadMoreUsersSearch = function () {
        if (!term) return;
        console.log("loading More Users Search", usersPagination);
        $scope.searchingUsers = true;
        searchForUsers(term).then(function (value) {
          $scope.canSearchMoreUsers = value.length >= usersPagination.count;
          usersPagination.start += value.length;
          usersPagination.increaseCount();
          $scope.usersResults.push.apply($scope.usersResults, value);
          iteraciones = $scope.usersResults.length;
          console.log("lleva", iteraciones);
        }, function (error) {
          console.error("search For Users", error);
          $scope.errorLoading = true;
        }).finally(function () {
          Utils.$ionicScrollDelegate.resize();
          $scope.searchingUsers = false;
          $scope.resultsForTerm = term;
          onSearchUsersFinished();
          Utils.$timeout(function () {
            $scope.$broadcast('scroll.infiniteScrollComplete');
          }, 100);
        });
      };

      $scope.loadMorePostsSearch = function () {
        if (!term) return;
        console.log("loading More Posts Search", postsPagination);
        $scope.searchingPosts = true;
        searchForSequenceDescription(term).then(function (value) {
          $scope.canSearchMorePosts = value.length >= postsPagination.count;
          postsPagination.start += value.length;
          postsPagination.increaseCount();
          $scope._sequenceList.push.apply($scope._sequenceList, value);
        }, function (error) {
          console.error("search For SequenceDescription", error);
          $scope.errorLoading = true;
        }).finally(function () {
          //Utils.$ionicScrollDelegate.resize();
          $scope.searchingPosts = false;
          $scope.resultsForTerm = term;
          onSearchPostsFinished();
          $scope.$broadcast('scroll.infiniteScrollComplete');
        });
      };

      /**
       * @param term
       * @return Promise {*}
       */
      function searchForUsers(term) {
        return pendingUsersSearch = searchFactory.madeMinSearch(
          term,
          usersPagination.start,
          usersPagination.count
        );
      }

      /**
       * @param description
       * @return Promise {*}
       */
      function searchForSequenceDescription(description) {
        return pendingPostsSearch = searchFactory.madePostSearch(
          description,
          UserService.get_USERSUBSCRIPTION_ID(),
          postsPagination.start,
          postsPagination.count
        );
      }

      function onSearchUsersFinished() {
        refreshDebounceUsersSearch();
        $scope.data.showUsersTab = $scope.usersResults.length > 0;

        if ($scope.data.showUsersTab) {
          $scope.data.searchActiveTab = 'users';
        }
      }

      function onSearchPostsFinished() {
        refreshDebouncePostsSearch();
        $scope.data.showPostsTab = $scope._sequenceList.length > 0;

        if ($scope.data.showPostsTab && !$scope.data.showUsersTab) {
          $scope.data.searchActiveTab = 'posts';
        }
      }

      function refreshDebounceUsersSearch() {
        console.log("Refreshing debounce users...");
        lastUsersSearch = null;
        pendingUsersSearch = null;
        cancelUsersSearch = angular.noop;
      }

      function refreshDebouncePostsSearch() {
        console.log("Refreshing debounce posts...");
        lastPostsSearch = null;
        pendingPostsSearch = null;
        cancelPostsSearch = angular.noop;
      }

      /**
       * Debounce if querying faster than 300ms
       */
      function debounceUsersSearch() {
        if (!lastUsersSearch) return false;

        var now = new Date().getMilliseconds();
        var debounce = (now - lastUsersSearch) < 300;
        lastUsersSearch = now;
        return debounce;
      }

      /**
       * Debounce if querying faster than 300ms
       */
      function debouncePostsSearch() {
        if (!lastPostsSearch) return false;

        var now = new Date().getMilliseconds();
        var debounce = (now - lastPostsSearch) < 300;
        lastPostsSearch = now;
        return debounce;
      }

      /*$scope.search = function () {
        console.log("executing search()")
        if ($scope.data.userName) {
          $scope.errorLoading = false;
          $scope.isSearching = true;
          UserService.findFriendUserSubscriptionsByUserName().get({
            'userName': $scope.data.userName,
            'withStart': $scope.start,
            'withCount': $scope.count
          }).$promise.then(function success(response) {
            if (response.length > 1) {
              response.length--;
              $scope.start += response.length;
              $scope.users.push.apply($scope.users, response);
              $scope.isSearching = false;
            } else {
              $scope.data.noMoreItemsAvailable = true;
              $scope.isSearching = false;
            }
            $scope.$broadcast('scroll.infiniteScrollComplete');

          }, function error(response) {
            $scope.errorLoading = true;
            $scope.isSearching = false;
            $scope.data.noMoreItemsAvailable = true;
            $scope.$broadcast('scroll.infiniteScrollComplete');
            console.log("findFriendUserSubscriptionsByUserName error");
          });
        }
      };*/

      $scope.findNewUsers = function () {
        //$scope.isLoadingDiscoveryUsers = true;
        if ( $scope.isLoadingNewUsersList ) {
          console.log("wait please");
        } else {
          $scope.isLoadingNewUsersList = true;
          UserService.findNewUsers({
            "itemId": window.localStorage.getItem("userSubscriptionInstanceId")
          }).get(
            $scope.newUsersCount.pagination
          ).$promise.then(function success(response) {
            if (response.length > 0) {
              $scope.newUsersCount.start += response.length;
              $scope.newUsersCount.pagination.withStart = '"' + $scope.newUsersCount.start + '"';
              $scope.newUsers.push.apply($scope.newUsers, response);
            } else {
              $scope.data.noMoreUsersAvailable = true;
            }
            $scope.isSearching = false;
            $scope.isLoadingNewUsersList = false;
            $scope.$broadcast('scroll.infiniteScrollComplete');
          }, function error(response) {
            console.log("findNewUsers error");
            $scope.isSearching = false;
            $scope.errorLoading = true;
            $scope.data.noMoreUsersAvailable = true;
            $scope.isLoadingNewUsersList = false;
            $scope.$broadcast('scroll.infiniteScrollComplete');
          });
        }
      };

      $scope.findFeatured = function () {
        UserService.findFeatured({
          "itemId": window.localStorage.getItem("userSubscriptionInstanceId")
        }).get(
          $scope.featuredUsersCount.pagination
        ).$promise.then(function success(response) {
          if (response.length > 0) {
            $scope.featuredUsersCount.start += response.length;
            $scope.featuredUsersCount.pagination.withStart = '"' + $scope.featuredUsersCount.start + '"';
            var dataLength = response.length;
            //$scope.featuredUsers.push.apply($scope.featuredUsers, response);
            for (var i = 0; i < dataLength; i++) {
              var pictureResult = UserService.findLatestItemThumbBelongingToAUserSubscriptionByType({
                "itemId": response[i].userSubscription.href.split('/')[6]
              }).get({
                "withStart": '"0"',
                "withCount": '"3"'
              });

              $scope.featuredUsers.push({
                profilePicture: response[i].profilePicture,
                profilePictureUrl: response[i].profilePictureUrl,
                userSubscription: response[i].userSubscription,
                name: response[i].name,
                pictures: pictureResult
              });
            }
          } else {
            $scope.data.noMoreUsersAvailable = true;
          }
          $scope.isSearching = false;
          $scope.$broadcast('scroll.infiniteScrollComplete');
        }, function error(response) {
          console.log("findNewUsers error");
          $scope.isSearching = false;
          $scope.errorLoading = true;
          $scope.data.noMoreUsersAvailable = true;
          $scope.$broadcast('scroll.infiniteScrollComplete');
        });
      };

      $scope.retry = function () {
        $scope.errorLoading = false;
        $scope.initDiscover();
        $scope.initSearch();
      };

      $scope.$on('$stateChangeStart', function (event, toState, toParams, fromState, fromParams) {
        $scope.modalSearch.remove();
      });

      $scope.$on("$ionicView.enter", function (event, toState, toParams, fromState, fromParams) {
        $ionicModal.fromTemplateUrl('templates/search.html', {
          scope: $scope,
          focusFirstInput: true
        }).then(function (modal) {
          $scope.modalSearch = modal;
        });
      });

      //reset data to initial state and close modal
      $scope.closeSearch = function () {
        $scope.usersResults = [];
        $scope._sequenceList = [];
        $scope.data.userName = '';
        $scope.data.searchTerm = '';
        $scope.data.usersOption = true;
        $scope.data.postsOption = false;
        $scope.data.searchActiveTab = 'none';
        $scope.searchingUsers = $scope.searchingPosts = false;
        $scope.data.showUsersTab = $scope.data.showPostsTab = false;

        $scope.modalSearch.hide()
      };

      $scope.sendUserProfile = function (userHref) {
        if (userHref == UserService.get_USER_INSTANCE_HREF()) {
          $state.go('menu.myProfile', {}, {reload: true});
        }
        else {
          $state.go('friendProfile', {instanceId: Utils.getLastUrlComponent(userHref)}, {reload: true});
        }
      };

      $scope.toggleFriendhipState = function (user) {
        //in order to update the search results, the featured and new users,
        //if (when) any of those lists exists at the same time
        var oldState = user.isActive;
        var oldMsg = user.msgShow;
        var newState = "";
        var newMsg = "";
        /*var oldState = user.isActive;
        var newState = !oldState;*/

        if (user.isActive) {
          //visual change
          newState = false;
          newMsg = $scope.data.followText;

          UserService.cancelRequestToPrivate(
            {"objectId": user.simpleIdFriend}
          ).save().$promise.then(function success(response) {
            user.msgShow = $scope.data.followText;
            user.simpleIdFriend = "";
            user.waitingAns = false;
          }, function (err) {
          });
        } else {
          //visual changes
          if (user.isPrivate) {
            if (oldMsg = $scope.data.pendingRequest) {
              newMsg = $scope.data.followText;
            } else {
              newMsg = $scope.data.pendingRequest;
            }
            newState = false;
          } else {
            newState = true;
            newMsg = $scope.data.unfollowText;
          }

          if (user.waitingAns) {
            UserService.cancelRequestToPrivate(
              {"objectId": user.simpleIdFriend}
            ).save().$promise.then(function success(response) {
              user.msgShow = $scope.data.followText;
              user.simpleIdFriend = "";
              user.waitingAns = false;
            }, function (err) {
            });
          } else {

            user.isActive = newState;

            $scope.featuredUsers.some(function (userItem) {
              if (userItem.userSubscription.href === (user.href || user.userSubscription.href)) {
                userItem.isActive = newState;
                userItem.msgShow = newMsg;
                return true;
              }
            });

            $scope.newUsers.some(function (userItem) {
              if (userItem.userSubscription.href === (user.href || user.userSubscription.href)) {
                userItem.isActive = newState;
                userItem.msgShow = newMsg;
                return true;
              }
            });

            if ($scope.usersResults) {
              $scope.usersResults.some(function (userItem) {
                if (userItem.href === (user.href || user.userSubscription.href)) {
                  userItem.isActive = newState;
                  userItem.msgShow = newMsg;
                  return true;
                }
              });
            }


            UserService.toggleFriendhipStateWS({
              userInstanceId: UserService.get_USERSUBSCRIPTIONINSTANCE_ID(),
              friendInstaceId: Utils.getLastUrlComponent(user.href || user.userSubscription.href)
            }).$promise.then(function (response) {
              if (response.result.value) {
                var dialogSend = "";
                if (user.isPrivate) {
                  dialogSend = UserService.get_USER_NAME() + ' ' + Utils.translate('NOTIFICATIONS.DIALOG.SEND_REQUEST');
                  $scope.findStatusRequestFriend(user);
                } else {
                  dialogSend = UserService.get_USER_NAME() + ' ' + Utils.translate('NOTIFICATIONS.DIALOG.IS_FOLLOWING_YOU');
                }
                //CHECK TRUE/FALSE TO SEND
                UserService.getDevices(Utils.getLastUrlComponent(user.href || user.userSubscription.href)).$promise.then( function (responseEndPoint) {
                  responseEndPoint.result.value.forEach( function (endPointArn) {
                    AWSServices.sendNotifaboutFollowAction(
                      dialogSend,
                      endPointArn.title,
                      UserService.get_USER_NAME(),
                      UserService.get_USERSUBSCRIPTIONINSTANCE_ID()
                    )
                  })
                })
              }
            }, function (error) {
              user.isActive = oldState;
              $scope.featuredUsers.some(function (userItem) {
                if (userItem.userSubscription.href === (user.href || user.userSubscription.href)) {
                  userItem.isActive = oldState;
                  userItem.msgShow = oldMsg;
                  return true;
                }
              });

              $scope.newUsers.some(function (userItem) {
                if (userItem.userSubscription.href === (user.href || user.userSubscription.href)) {
                  userItem.isActive = oldState;
                  userItem.msgShow = oldMsg;
                  return true;
                }
              });

              if ($scope.usersResults) {
                $scope.usersResults.some(function (userItem) {
                  if (userItem.href === (user.href || user.userSubscription.href)) {
                    userItem.isActive = oldState;
                    userItem.msgShow = oldMsg;
                    return true;
                  }
                });
              }
              user.waitingAns = false;

              Utils.toast.error(Utils.translate('PROFILE.DIALOG.' + (user.isActive ? 'UN' : '') + 'FOLLOW_USER_ERROR'));
              console.error("toggleFriendhipStateWS", error);
            });
          }
        }
      }
      ;

      $scope.getStatusUser = function (user) {
        user.isPrivate = false;
        //$scope.addPrivateStatus(user);
        $scope.findStatusRequestFriend(user);
        //$scope.getFollowingIsActive(user);
      };

      $scope.addPrivateStatus = function (user) {
        UserService.getStatusPrivateAccount({
          "objectId": Utils.getLastUrlComponent(user.href || user.userSubscription.href)
        }).get().$promise.then(function (privateData) {
          user.isPrivate = privateData.result.value;
        }, function (err) {
          console.log("get private data fail", err);
        })
      };

      $scope.findStatusRequestFriend = function (friend) {
        UserService.getStatusPrivateRequest({
          userId: UserService.get_USERSUBSCRIPTIONINSTANCE_ID(),
          friendId: Utils.getLastUrlComponent(friend.href || friend.userSubscription.href)
        }).$promise.then(function success(response) {
          //console.log("success", response);
          if (response.friend) {
            friend.simpleIdFriend = Utils.getLastUrlComponent(response.friend.href);
          }
          if (response.status == 1) {
            //son amigos
            friend.msgShow = $scope.data.unfollowText;
            friend.isActive = true;
            friend.waitingAns = false;
          } else if (response.status == 2) {
            //waiting
            friend.msgShow = $scope.data.pendingRequest;
            friend.isActive = false;
            friend.waitingAns = true;
          } else if (response.status == 3) {
            //no son amigos
            friend.msgShow = $scope.data.followText;
            friend.isActive = false;
            friend.waitingAns = false;
          }
        }, function (err) {
          console.log("mistake when finding status request", err);
        })
      };

      $scope.showImages1 = function (pictures, index, userChoosen) {
        //console.log(pictures, index, userChoosen)
        var userInstanceId = Utils.getLastUrlComponent(userChoosen.userSubscription.href);

        $scope.picturesItem = [];
        $scope.loadingInit = 1;
        $scope.activeSlide = index;

        for (var i = 0; i < pictures.length; i++) {

          $scope.picturesItem.push({
            src: pictures[i].url,//'data:image/jpeg;base64,' + pictures[i].thumbPicture.split(':')[2],
            sequenceItemId: pictures[i].sequenceItem.href.split('/')[6],
            likeCount: pictures[i].likeCount,
            likeActive: likeItemIsActive(pictures[i].sequenceItem.href.split('/')[6]),
            userSubscriptionInstanceId: userInstanceId,
            itemId: pictures[i].itemId,
            key: index
          });
        }
        $scope.showModal('templates/gallery-zoomview2.html');
        $scope.loadingInit = 0;
      };

      function likeItemIsActive(sequenceItem) {
        return SequenceService.findSmileysItemCount().get(
          {
            "x-isis-querystring":
              {
                "sequenceItem": {
                  "value": {
                    "href": ApiEndPoint.url + "restful/objects/simple.SequenceItem/" + sequenceItem
                  }
                },
                "userSubs": {
                  "value": {
                    "href": ApiEndPoint.url + "restful/objects/simple.UserSubscription/" + window.localStorage.getItem('userSubscriptionInstanceId')
                  }
                }

              }
          }, function () {
          }, function (response) {
            console.log("findSmileysItemCount error");
          });
      }

      $scope.setLikeToItem = function (item, index) {
        if (!permissionValidationService.amISuperAdmin() && $scope.previewTimeline) {
          Utils.toast.warning(Utils.translate('PERMISSIONS.CANNOT.PERFORM_ACTION_ON_PREVIEW'));
          return;
        }

        item.likeActive.result.value = !item.likeActive.result.value;

        if (item.likeActive.result.value) {
          item.likeCount++;
          happyonItem(item.sequenceItemId);
        }
        else {
          item.likeCount--;
          happyoffItem(item.sequenceItemId);
        }

        SequenceService.setLikeToItem({"objectId": item.sequenceItemId}).save(
          {
            "userSubscription": {
              "value": {
                "href": ApiEndPoint.url + "/restful/objects/simple.UserSubscription/" + window.localStorage.getItem('userSubscriptionInstanceId')
              }
            }
          }, function (response) {
            //Send Push Notification Like SequenceItem
            if (response.result.value && item.userSubscriptionInstanceId != window.localStorage.getItem('userSubscriptionInstanceId')) {
              var message = UserService.get_USER_NAME()+ " " + Utils.translate('ALERTS.LIKE_PHOTO');
              /*notificationsService.sendNotificationToUserDevices(
                item.userSubscriptionInstanceId, message
              ).then(function () {
              }, function (error) {
              });*/
              notificationsService.sendDeepNotificationToUserDevices(
                item.userSubscriptionInstanceId,
                message,
                'LIKE',
                item.sequenceItemId
              ).then(function () {
              }, function (error) {
                console.error("sendNotificationToUserDevices", error)
              });
            }
          }, function (error) {
            console.log("setLikeToItem error");
            item.likeActive.result.value = !item.likeActive.result.value;

            if (item.likeActive.result.value) {
              item.likeCount++;
              happyonItem(item.sequenceItemId);
            }
            else {
              item.likeCount--;
              happyoffItem(item.sequenceItemId);
            }
          });
      };

      function happyonItem(itemId) {
        document.getElementById('happyonItem' + itemId).style.display = 'block';
        document.getElementById('happyoffItem' + itemId).style.display = 'none';
        document.getElementById('happyNumberonItem' + itemId).style.display = 'block';
        document.getElementById('happyNumberoffItem' + itemId).style.display = 'none';
        document.getElementById('happyNumberoffItem' + itemId).className = "off1";
      };

      function happyoffItem(itemId) {
        document.getElementById('happyonItem' + itemId).style.display = 'none';
        document.getElementById('happyoffItem' + itemId).style.display = 'block';
        document.getElementById('happyNumberonItem' + itemId).style.display = 'none';
        document.getElementById('happyNumberoffItem' + itemId).style.display = 'block';
        document.getElementById('happyNumberoffItem' + itemId).className = "on1";
      };

      $scope.showModal = function (templateUrl) {
        $ionicModal.fromTemplateUrl(templateUrl, {
          scope: $scope,
          animation: 'zoom-from-center'
        }).then(function (modal) {
          $scope.modal = modal;
          $scope.modal.show();
        });
      };

      $scope.zoomStatus = 0;

      $scope.closeModal = function () {
        $scope.modal.hide();
        $scope.modal.remove();
      };

      $scope.zoomMin = 1;

      $scope.doubleTapped = function (slide) {
        if ($scope.zoomStatus === 0) {
          $ionicScrollDelegate.$getByHandle('scrollHandle' + slide).zoomBy(2, true);
          $scope.zoomStatus++;
        } else {
          $ionicScrollDelegate.$getByHandle('scrollHandle' + slide).zoomBy(0, true);
          $scope.zoomStatus--;
        }
      };

      $scope.updateSlideStatus = function (slide) {
        var zoomFactor = $ionicScrollDelegate.$getByHandle('scrollHandle' + slide).getScrollPosition().zoom;
        if (zoomFactor == $scope.zoomMin) {
          $ionicSlideBoxDelegate.enableSlide(true);
        } else {
          $ionicSlideBoxDelegate.enableSlide(false);
        }
      };

      //check how many times the user have already logged in before show any tutorial
      $scope.chkTimesLogged = function () {
        var querySelect = "SELECT * FROM userLogCount WHERE name = ?";
        DBServices.execute(querySelect, [window.localStorage.getItem("name")]).then(function (resultSet) {
          if (resultSet.rows.length > 0) {
            if (resultSet.rows.item(0).count >= 1) {
              $scope.needsTutorial();
            }
          }
        }, function (error) {
        });

        /*userProfileData.dataBaseUser.transaction(function (transaction) {
          var querySelect = "SELECT * FROM userLogCount WHERE name = ?";
          transaction.executeSql(querySelect, [window.localStorage.getItem("name")], function (tx, resultSet) {
            if (resultSet.rows.length > 0) {
              if (resultSet.rows.item(0).count >= 1) {
                $scope.needsTutorial();
              }
            }
          })
        })*/
      };

      //CODE needed to show tutorial
      $scope.needsTutorial = function () {
        var querySelect = "SELECT * FROM tutorials WHERE name = ?";
        DBServices.execute(querySelect, ["discovery"]).then(function (resultSet) {
          var visitedJson = JSON.parse(resultSet.rows.item(0).visited);
          if (visitedJson.first) {
            document.getElementById("sideMenuCqnz").style.visibility = "hidden";
            window.localStorage.setItem("openTutorial", true);
            var intro = introJs();
            intro.setOptions({
              steps: [
                {
                  intro: '<p style="color:white !important; text-align:center; font-size: medium;">' + $filter('translate')('TUTORIAL.DISCOVER.FIRST.STEP1.TITLE') + '</p><p style="color:lightgrey !important; text-align:center; font-size: medium;  padding: 0 65px 0 65px;">' + $filter('translate')('TUTORIAL.DISCOVER.FIRST.STEP1.TEXT') + '</p>',
                  position: 'auto'
                },
                {
                  intro: '<p style="color:white !important; text-align:center; font-size: medium;">' + $filter('translate')('TUTORIAL.DISCOVER.FIRST.STEP2.TITLE') + '</p><p style="color:lightgrey !important; text-align:center; font-size: medium;">' + $filter('translate')('TUTORIAL.DISCOVER.FIRST.STEP2.TEXT') + '</p>',
                  position: 'auto',
                  tooltipClass: 'discoverPeople'
                },
                {
                  intro: '<p style="color:white !important; text-align:center; font-size: medium;">' + $filter('translate')('TUTORIAL.DISCOVER.FIRST.STEP3.TITLE') + '</p><p style="color:lightgrey !important; text-align:center; font-size: medium;">' + $filter('translate')('TUTORIAL.DISCOVER.FIRST.STEP3.TEXT') + '</p>',
                  position: 'auto',
                  tooltipClass: 'newUsers'
                }
              ],
              nextLabel: $filter('translate')('GLOBAL.NEXT'),
              prevLabel: $filter('translate')('GLOBAL.BACK'),
              doneLabel: $filter('translate')('GLOBAL.DONE'),
              skipLabel: $filter('translate')('GLOBAL.SKIP'),
              hidePrev: false,
              hideNext: false,
              exitOnOverlayClick: false,
              showStepNumbers: false,
              showBullets: false,
              showProgress: false,
              overlayOpacity: 1,
              scrollToElement: false,
              disableInteraction: true
            });
            intro.onexit(function () {
              console.log("Exit tutorial");
              document.getElementById("sideMenuCqnz").style.visibility = "initial";
              window.localStorage.setItem("openTutorial", false);
              visitedJson.first = false;
              $scope.updateBD("discovery", JSON.stringify(visitedJson));
            }).oncomplete(function () {
              console.log("Complete tutorial");
              document.getElementById("sideMenuCqnz").style.visibility = "initial";
              window.localStorage.setItem("openTutorial", false);
              visitedJson.first = false;
              $scope.updateBD("discovery", JSON.stringify(visitedJson));
            }).start();
          }
          else {
            document.getElementById("sideMenuCqnz").style.visibility = "initial";
            window.localStorage.setItem("openTutorial", false);
            console.log("Not new User");
          }
        }, function (error) {

        })

        /*userProfileData.dataBaseUser.transaction(function (transaction) {
          var querySelect = "SELECT * FROM tutorials WHERE name = ?";
          transaction.executeSql(querySelect, ["discovery"], function (tx, resultSet) {
            var visitedJson = JSON.parse(resultSet.rows.item(0).visited);
            if (visitedJson.first) {
              document.getElementById("sideMenuCqnz").style.visibility = "hidden";
              window.localStorage.setItem("openTutorial", true);
              var intro = introJs();
              intro.setOptions({
                steps: [
                  {
                    intro: '<p style="color:white !important; text-align:center; font-size: medium;">' + $filter('translate')('TUTORIAL.DISCOVER.FIRST.STEP1.TITLE') + '</p><p style="color:lightgrey !important; text-align:center; font-size: medium;  padding: 0 65px 0 65px;">' + $filter('translate')('TUTORIAL.DISCOVER.FIRST.STEP1.TEXT') + '</p>',
                    position: 'auto'
                  },
                  {
                    intro: '<p style="color:white !important; text-align:center; font-size: medium;">' + $filter('translate')('TUTORIAL.DISCOVER.FIRST.STEP2.TITLE') + '</p><p style="color:lightgrey !important; text-align:center; font-size: medium;">' + $filter('translate')('TUTORIAL.DISCOVER.FIRST.STEP2.TEXT') + '</p>',
                    position: 'auto',
                    tooltipClass: 'discoverPeople'
                  },
                  {
                    intro: '<p style="color:white !important; text-align:center; font-size: medium;">' + $filter('translate')('TUTORIAL.DISCOVER.FIRST.STEP3.TITLE') + '</p><p style="color:lightgrey !important; text-align:center; font-size: medium;">' + $filter('translate')('TUTORIAL.DISCOVER.FIRST.STEP3.TEXT') + '</p>',
                    position: 'auto',
                    tooltipClass: 'newUsers'
                  }
                ],
                nextLabel: $filter('translate')('GLOBAL.NEXT'),
                prevLabel: $filter('translate')('GLOBAL.BACK'),
                doneLabel: $filter('translate')('GLOBAL.DONE'),
                skipLabel: $filter('translate')('GLOBAL.SKIP'),
                hidePrev: false,
                hideNext: false,
                exitOnOverlayClick: false,
                showStepNumbers: false,
                showBullets: false,
                showProgress: false,
                overlayOpacity: 1,
                scrollToElement: false,
                disableInteraction: true
              });
              intro.onexit(function () {
                console.log("Exit tutorial");
                document.getElementById("sideMenuCqnz").style.visibility = "initial";
                window.localStorage.setItem("openTutorial", false);
                visitedJson.first = false;
                $scope.updateBD("discovery", JSON.stringify(visitedJson));
              }).oncomplete(function () {
                console.log("Complete tutorial");
                document.getElementById("sideMenuCqnz").style.visibility = "initial";
                window.localStorage.setItem("openTutorial", false);
                visitedJson.first = false;
                $scope.updateBD("discovery", JSON.stringify(visitedJson));
              }).start();
            } else {
              document.getElementById("sideMenuCqnz").style.visibility = "initial";
              window.localStorage.setItem("openTutorial", false);
              console.log("Not new User");
            }
          })
        })*/
      };

      /*$timeout(function() {
          $scope.chkTimesLogged();
          //$scope.needsTutorial();
      }, 1500);*/

      $scope.updateBD = function (tutorial, change) {
        var querySelect = "UPDATE tutorials SET visited = ? WHERE name = ?";
        DBServices.execute(querySelect, [change, tutorial]).then(function (resultSet) {
          console.log(name + " insertId: " + resultSet.insertId);
          console.log(name + " rowsAffected: " + resultSet.rowsAffected);
        }, function (error) {
          console.log('UPDATE error out: ' + error.message);
        })

        /*userProfileData.dataBaseUser.transaction(function (transaction) {
          var querySelect = "UPDATE tutorials SET visited = ? WHERE name = ?";
          transaction.executeSql(querySelect, [change, tutorial], function (tx, resultSet) {
            console.log(name + " insertId: " + resultSet.insertId);
            console.log(name + " rowsAffected: " + resultSet.rowsAffected);
          }, function (tx, error) {
            console.log('UPDATE error in: ' + error.message);
          })
        }, function (error) {
          console.log('UPDATE error out: ' + error.message);
        }, function () {
          console.log('transaction ok');
        });*/
      }
      //END CODE needed to show tutorial

      //zone for hashtags list
      $scope.getTrending = function () {
        SequenceService.getTrending().get({
          "withStart": '"' + 0 + '"',
          "withCount": '"' + 10 + '"'
        }).$promise.then(function (hashtagsList) {
          if (hashtagsList.length > 1) {
            hashtagsList.length--;
            if (hashtagsList.length >= 1) {
              for (var a = 0; a < hashtagsList.length; a++) {
                $scope.data.trendingList[a] = {
                  name: hashtagsList[a].hashTag
                }
              }
            } else {
              $scope.data.noTrending = 1;
            }
          } else {
            $scope.data.noTrending = 1;
          }
          //console.log("trending",hashtagsList);
        }, function (error) {
          $scope.data.noTrending = 1;
        })
      }
      $scope.getTrending();

      $scope.sendHashtagTimeline = function (text) {
        $state.go('hashTimeLine', {"hashName": "#" + text}, {reload: true});
      };
      //end zone for hashtags list

      //---zone for open camera/Scanner
      /**
       * @type {PROMO_TYPES}
       */
      $scope.PROMO_TYPES = userLockerService.PROMO_TYPES;

      /**
       * @type {PROMO_MEDIA_TYPES}
       */
      $scope.PROMO_MEDIA_TYPES = userLockerService.PROMO_MEDIA_TYPES;

      /**
       * @type {{
       *  id: number,
       *  href: string,
       *  type: PROMO_TYPES,
       *  date: string,
       *  description: string,
       *  mediaType: PROMO_MEDIA_TYPES,
       *  items: Array<{src:string, thumb?:string}>
       * }}
       */
      $scope.promotion = {
        //init (default) values, we'll change them later on
        id: 0,
        href:'',
        type: $scope.PROMO_TYPES.PROMOTION,
        date: '',
        description: '',
        mediaType: $scope.PROMO_MEDIA_TYPES.UNKNOWN,
        items: []//[{src:string, thumb?:string},...]
      };

      $scope.checkPermissions = function () {
        if ($scope.isIOS === true) {
          //startScan();
          $scope.openQRSCanner();
        } else {
          getMultiplePermissions();
        }
      };

      function getMultiplePermissions() {
        cordova.plugins.diagnostic.getPermissionsAuthorizationStatus(function (statuses) {
          var havePerm = 0;
          var deniedPerm = false;
          for (var permission in statuses) {
            switch (statuses[permission]) {
              case cordova.plugins.diagnostic.permissionStatus.GRANTED:
                console.log("Permission granted to use " + permission);
                havePerm++;
                break;
              case cordova.plugins.diagnostic.permissionStatus.NOT_REQUESTED:
                console.log("Permission to use " + permission + " has not been requested yet");
                havePerm--;
                break;
              case cordova.plugins.diagnostic.permissionStatus.DENIED:
                console.log("Permission denied to use " + permission + " - ask again?");
                havePerm--;
                break;
              case cordova.plugins.diagnostic.permissionStatus.DENIED_ALWAYS:
                console.log("Permission permanently denied to use " + permission + " - guess we won't be using it then!");
                deniedPerm = true;
                break;
            }
          }
          if (!deniedPerm) {
            if (havePerm == 2) {
              //have all permissions
              //startScan();
              $scope.openQRSCanner();
            } else if (havePerm < 2) {
              //both or one permission hasn't granted
              askMultiplePermissions();
            }
          } else {
            Utils.toast.error(Utils.translate('PLUGINS.PERMISSIONS.DENIED_PERMISSION') +
              Utils.translate('PLUGINS.PERMISSIONS.TYPE.CAMERA') + ' ' +
              Utils.translate('PLUGINS.PERMISSIONS.AND') + ' ' +
              Utils.translate('PLUGINS.PERMISSIONS.TYPE.GALLERY') + '. \n' +
              Utils.translate('PLUGINS.PERMISSIONS.ALWAYS_DENIED_PERMISSION'));
          }
        }, function (error) {
          console.error("The following error occurred: " + error);
        }, [
          cordova.plugins.diagnostic.permission.CAMERA,
          cordova.plugins.diagnostic.permission.READ_EXTERNAL_STORAGE
        ])
      };

      function askMultiplePermissions() {
        cordova.plugins.diagnostic.requestRuntimePermissions(function (statuses) {
          var havePerm = 0;
          var deniedPerm = false;
          for (var permission in statuses) {
            switch (statuses[permission]) {
              case cordova.plugins.diagnostic.permissionStatus.GRANTED:
                console.log("Permission granted to use " + permission);
                havePerm++;
                break;
              case cordova.plugins.diagnostic.permissionStatus.NOT_REQUESTED:
                console.log("Permission to use " + permission + " has not been requested yet");
                havePerm--;
                break;
              case cordova.plugins.diagnostic.permissionStatus.DENIED:
                console.log("Permission denied to use " + permission + " - ask again?");
                havePerm--;
                break;
              case cordova.plugins.diagnostic.permissionStatus.DENIED_ALWAYS:
                console.log("Permission permanently denied to use " + permission + " - guess we won't be using it then!");
                deniedPerm = true;
                break;
            }
          }
          if (!deniedPerm) {
            if (havePerm == 2) {
              //have both permissions granted
              //startScan();
              $scope.openQRSCanner();
            } else if (havePerm < 2) {
              //both or one permission hasn't granted
              Utils.toast.error(Utils.translate('PLUGINS.PERMISSIONS.DENIED_PERMISSION') +
                Utils.translate('PLUGINS.PERMISSIONS.TYPE.CAMERA') + ' ' +
                Utils.translate('PLUGINS.PERMISSIONS.AND') + ' ' +
                Utils.translate('PLUGINS.PERMISSIONS.TYPE.GALLERY') + '.');
            }
          } else {
            Utils.toast.error(Utils.translate('PLUGINS.PERMISSIONS.DENIED_PERMISSION') +
              Utils.translate('PLUGINS.PERMISSIONS.TYPE.CAMERA') + ' ' +
              Utils.translate('PLUGINS.PERMISSIONS.AND') + ' ' +
              Utils.translate('PLUGINS.PERMISSIONS.TYPE.GALLERY') + '. \n' +
              Utils.translate('PLUGINS.PERMISSIONS.ALWAYS_DENIED_PERMISSION'));
          }
        }, function (error) {
          console.error("The following error occurred: " + error);
        }, [
          cordova.plugins.diagnostic.permission.CAMERA,
          cordova.plugins.diagnostic.permission.READ_EXTERNAL_STORAGE
        ])
      };
      

      $scope.openQRSCanner = function () {
        QRScannerService.scan().then(function (response) {
          if (response.cancelled) return;

          if (!response.text) {
            return Utils.alert.show(Utils.translate("DISCOVER.QR_SCANNER.PROMO_NOT_FOUND_ERROR"));
          }

          onQRRead(response.text);
        }, function () {
          //Utils.toast.error(Utils.translate("ERROR.UNKNOWN"));
        })
      };

      function onQRRead(text) {
        console.log("QR text: %s", text);
        var components;
        /**@type Array<string>*/
        var promoIds;

        Utils.loading.show();
        if (text.split(Personalized.nameApp +'_Assist_List_').length > 1) { //BALA QRCODE FIX
          components = text.split(Personalized.nameApp +'_Assist_List_');// if is good it'll have len == 2, else 1
          var userInstanceId = components[1].split('_')[1];

          if (+userInstanceId === +UserService.get_USERSUBSCRIPTIONINSTANCE_ID()) {
            Utils.loading.hide();
            $state.go('menu.myProfile', {}, {reload: true});
          }
          else {
            //here we only need to know if the user exists
            UserService.findFriendInstanceId({
              userId: UserService.get_USERSUBSCRIPTIONINSTANCE_ID(),
              friendId: userInstanceId
            }).then(function () {
              $state.go('friendProfile', {instanceId: userInstanceId}, {reload: true});
            }, function () {
              Utils.alert.show(Utils.translate("DISCOVER.QR_SCANNER.FRIEND_NOT_FOUND_ERROR"));
            }).finally(function () {
              Utils.loading.hide();
            })
          }
        }
        else if (text.split(Personalized.nameApp +'_Promotion_List_').length > 1) { //BALA QRCODE FIX
          components = text.split(Personalized.nameApp +'_Promotion_List_');// if is good it'll have len == 2, else 1
          promoIds = components[1].split("_");// [id, instanceId]
          //console.log('componentIds', promoIds)

          increaseAndShowPromo($scope.PROMO_TYPES.PROMOTION, promoIds);
        }
        else if (text.split(Personalized.nameApp +'_Coupon_List_').length > 1) { //BALA QRCODE FIX
          components = text.split(Personalized.nameApp +'_Coupon_List_');// if is good it'll have len == 2, else 1, [id, instanceId]
          promoIds = components[1].split("_");// [id, instanceId]
          //console.log('componentIds', promoIds)

          increaseAndShowPromo($scope.PROMO_TYPES.COUPON, promoIds);
        }
        else if (text.split(Personalized.nameApp +'_EasterEgg_List_').length > 1) { //BALA QRCODE FIX
          components = text.split(Personalized.nameApp +'_EasterEgg_List_');// if is good it'll have len == 2, else 1, [id, instanceId]
          promoIds = components[1].split("_");// [id, instanceId]
          //console.log('componentIds', promoIds)

          increaseAndShowPromo($scope.PROMO_TYPES.EASTER_EGG, promoIds);
        }
        else {
          Utils.loading.hide();
          Utils.alert.show(Utils.translate("QRSCANPAGE.CODE.INVALID_CODE"));
        }
      }

      function increaseAndShowPromo(promoType, promoIds) {
        //return showPormotion(promoType, promoIds)
        promosService.increaseScannedPromotion({
          promoInstanceId: promoIds[1], userSubscriptionId: UserService.get_USERSUBSCRIPTION_ID()
        }).$promise.then(function () {
          showPormotion(promoType, promoIds)
        }, function (error) {
          Utils.loading.hide();
          console.error("increaseScannedPromotion", error);
          if(error) {
            if(error.data) {
              var getTypeError = error.data.causedBy.message;
              if(getTypeError.split('duplicate key').length > 1) {
                showPormotion(promoType, promoIds);
                Utils.toast.info(Utils.translate("QRSCANPAGE.CODE.DUPLICATE_SCAN"));
              }
              else
                Utils.toast.error(Utils.translate("ERROR.UNKNOWN"));
              
            } else{
              Utils.toast.error(Utils.translate("ERROR.UNKNOWN"));
            }
          } else{
            Utils.toast.error(Utils.translate("ERROR.UNKNOWN"));
          }
        })
      }

      /**
       *
       * @param type {PROMO_TYPES}
       * @param promoIds {[string]} - values for: ["USERSUBSCRIPTION_ID", "USERSUBSCRIPTIONINSTANCE_ID"]
       */
      function showPormotion(type, promoIds) {
        promosService.getPromotionByPromotionId(promoIds[0]).$promise.then(
          /**@param promoBasicData {[PromoBasicData]}*/
          function (promoBasicData) {
            Utils.removeLastItemIfHasNoAttribute(promoBasicData, 'promotionId');
            console.log("promotion info", promoBasicData);

            if (!promoBasicData.length) {
              Utils.loading.hide();
              Utils.alert.show(Utils.translate("DISCOVER.QR_SCANNER.PROMO_NOT_FOUND_ERROR"));
              return;
            }

            $scope.promotion.id = promoBasicData[0].promotionId;
            $scope.promotion.href = promoBasicData[0].promotion.href;
            $scope.promotion.type = type;
            $scope.promotion.date = promoBasicData[0].date;
            $scope.promotion.description = promoBasicData[0].description;
            $scope.promotion.token = promoBasicData[0].token;

            promosService.getPromotionItemByPromotionId({
              promoId: promoIds[0],
              //omit the pagination params :)
            }).$promise.then(
              /**@param mediaItems {[{creationDate:string, promotion:{href:string}, url: string}]}*/
              function (mediaItems) {
                Utils.removeLastItemIfHasNoAttribute(mediaItems, 'promotion');
                //console.log("promotion items", mediaItems);

                //we know that media is: SINGLE_IMAGE
                if (mediaItems.length === 1) {
                  $scope.promotion.mediaType = $scope.PROMO_MEDIA_TYPES.SINGLE_IMAGE;
                  $scope.promotion.items = [{src: mediaItems[0].url}]
                }
                else if (mediaItems.length === 2) {//but here media is either: IMAGE_GALLERY or VIDEO
                  var
                    id0 = mediaItems[0].url.indexOf(".mp4") > -1,
                    id1 = mediaItems[1].url.indexOf(".mp4") > -1;

                  if (id0 || id1) {//now we know that media is: VIDEO
                    $scope.promotion.mediaType = $scope.PROMO_MEDIA_TYPES.VIDEO;
                    $scope.promotion.items = [{src: mediaItems[id0 ? 0 : 1].url, thumb: mediaItems[id0 ? 1 : 0].url}]
                  }
                  else {//now we know that media is: IMAGE_GALLERY
                    $scope.promotion.mediaType = $scope.PROMO_MEDIA_TYPES.IMAGE_GALLERY;
                    $scope.promotion.items = [];
                    mediaItems.some(function (media) {
                      $scope.promotion.items.push({src: media.url})
                    })
                  }
                }
                else if (mediaItems.length > 2) {//we know that media is: IMAGE_GALLERY
                  $scope.promotion.mediaType = $scope.PROMO_MEDIA_TYPES.IMAGE_GALLERY;
                  $scope.promotion.items = [];
                  mediaItems.some(function (media) {
                    $scope.promotion.items.push({src: media.url})
                  })
                }
                else {//WE NEED TO CONSIDER ALL CASES
                  Utils.toast.warning("Promotion conains an invalid number of items", 5000);
                }

                Utils.$ionicModal.fromTemplateUrl('templates/Discovery/promo-viewer.html', {
                  scope: $scope,
                  animation: 'zoom-from-center'
                }).then(function (modal) {
                  $scope.promoViewer = modal;
                  $scope.promoViewer.show();
                });
              }, function (error) {
                console.error("getPromotionItemByPromotionId", error);
                Utils.alert.show("We couldn't get the promotion items")
              }).finally(function () {
              Utils.loading.hide();
            });
          }, function (error) {
            Utils.loading.hide();
            console.error("getPromotionByPromotionId", error);
            Utils.toast.warning("We couldn't get the promotion date and description", 5000);
          });
      }

      $scope.closePromoViewer = function () {
        $scope.promoViewer.hide();
        $scope.promoViewer.remove();
      };


      $scope.promotionPlayVideo = function (promotion) {
        var videoElement = document.getElementById('PromotionVideoArea' + promotion.id);
        videoElement.play();
        videoElement.controls = true;
        videoElement.addEventListener('ended', onVideoFinished, false);
        if ($scope.isIOS) {
          videoElement.addEventListener('pause', onVideoFinished, false);
        }

        $scope.isPlayingVideo = true;
        Utils.$timeout(function () {
          $scope.$apply()
        })
      };

      function onVideoFinished(e) {
        e.target.controls = false;
        $scope.isPlayingVideo = false;
        Utils.$timeout(function () {
          $scope.$apply()
        })
      }

      $scope.savePromoInLocker = function (promo) {
        Utils.loading.show();
        userLockerService.addItemToLocker({
          promotionHref: promo.href,
          userSubscriptionId: UserService.get_USERSUBSCRIPTION_ID()
        }).$promise.then(function () {
          Utils.toast.success(Utils.translate("DISCOVER.QR_SCANNER.SAVE_IN_LOCKER_OK"))
        }, function (error) {
          console.error("Cant add promotion to locker", error);
          Utils.toast.success(Utils.translate("DISCOVER.QR_SCANNER.SAVE_IN_LOCKER_ERROR"))
        }).finally(function () {
          Utils.loading.hide();
        })
      }

      $scope.selectedChatImage = '';
      $scope.activeSlide = 0;
      $scope.showImageViewer = function (imageSrc) {
        $scope.selectedChatImage = imageSrc;
        Utils.$ionicModal.fromTemplateUrl('templates/Chat/image-viewer.html', {
          scope: $scope,
          animation: 'zoom-from-center'
        }).then(function (modal) {
          $scope.imageViewer = modal;
          $scope.imageViewer.show();
        });
      };

      $scope.closeImageViewer = function () {
        $scope.selectedChatImage = '';
        $scope.imageViewer.hide();
        $scope.imageViewer.remove();
      };

      $scope.zoomStatus = 0;
      $scope.zoomMin = 1;
      $scope.doubleTapped = function (slide) {
        if ($scope.zoomStatus === 0) {
          Utils.$ionicScrollDelegate.$getByHandle('scrollHandle' + slide).zoomBy(2, true);
          $scope.zoomStatus++;
        } else {
          Utils.$ionicScrollDelegate.$getByHandle('scrollHandle' + slide).zoomBy(0, true);
          $scope.zoomStatus--;
        }
      };

      $scope.updateSlideStatus = function (slide) {
        var zoomFactor = Utils.$ionicScrollDelegate.$getByHandle('scrollHandle' + slide).getScrollPosition().zoom;
        if (zoomFactor === $scope.zoomMin) {
          Utils.$ionicSlideBoxDelegate.enableSlide(true);
        } else {
          Utils.$ionicSlideBoxDelegate.enableSlide(false);
        }
      };
      //end zone for open camera/Scanner

      //Redirect to the group of the post found
      $scope.redirectGroup = function (postData) {
        var currentGroup = GroupFactory.getCurrentGroupIndex()
        console.log("wait", currentGroup);
        var groupList = GroupFactory.getCurrentAvailableUserGroupsList();
        console.log("wait02", groupList);
        console.log("wait03", postData);

        //check first if the user can go to the group
        var cont = false;
        var index = 0;
        groupList.forEach( function (groupInfo) {
          if(groupInfo.id === postData.metadata.groupId) {
            cont = true;
          } else {
            index++;
          }
        })
        if(cont) {
          $state.go('menu.timeline', {groupIndex: index}, {reload: true});
        } else {
          //the user can't access the group
          Utils.toast.success("Can't access the group check if you're a member"); //Utils.translate("DISCOVER.QR_SCANNER.SAVE_IN_LOCKER_OK")
        }
        //$state.go('menu.timeline', {groupIndex: $scope.groupData.groupIndex}, {reload: true});
      };
      //
    }
  ])
;
//Para el locker lockerType: 1= secuencia, 2= promo
