"use strict";
appControllers
  .controller('login0Ctrl',
    ['$rootScope', '$scope', '$state', 'sessionFactory', 'Utils', function($rootScope, $scope, $state, sessionFactory, Utils) {
      var session = sessionFactory;

      $scope.regularLogin = function(username, password) {
        //console.log("login credentials", username, password);
        session.loginWithPublicUser(username, password).then(function() {
          session.getUserSubscriptionByUsername(username).then(function(subs) {
            session.getAccountStatusByUserName(username).then(function(userStatus) {
              var statusList = session.getStatusList();
              if (userStatus !== statusList.ACTIVE) {
                showStatusError(userStatus);
                regularLogout();
                return;
              }

              session.getRolePermissionAndSetUserData(
                +Utils.getLastUrlComponent(subs.role.href)
              ).then(function( /*alwaysTrue*/ ) {
                session.findUserByUserName(username).then(function(userFound) {
                  session.loadProfileImages(Utils.getLastUrlComponent(subs.userSubscription.href));

                  window.localStorage.setItem("ownPrivate", subs.privateAccount);
                  window.localStorage.setItem("name", subs.name);
                  window.localStorage.setItem("userName", username);
                  window.localStorage.setItem("simpleUserInstanceId", Utils.getLastUrlComponent(subs.user.href));
                  window.localStorage.setItem("userSubscriptionInstanceId", Utils.getLastUrlComponent(subs.userSubscription.href));
                  window.localStorage.setItem("userSubscriptionHref", subs.userSubscription.href);
                  window.localStorage.setItem("userSubscriptionId", subs.userSubscriptionId);
                  window.localStorage.setItem("userBiography", subs.userBio);

                  window.localStorage.setItem("applicationUser", userFound.applicationUser.href);
                  window.localStorage.setItem("simpleUserId", userFound.userId);
                  window.localStorage.setItem("userEmail", userFound.email);



                  session.getAndSetAWSToken();

                  if (window.localStorage.getItem("changePassword")) {
                    $state.go('menu.updatePassword', {}, { reload: true });
                    return Utils.alert.show(Utils.translate('MENU.SETTINGS.UPDATE_PASSWORD.RECOMMEND'));
                  }

                  session.checkDB().then(function( /*alwaysTrue*/ ) {
                    $state.go('menu.timeline', { "prepareStatement": 0 }, { reload: true });
                    setTimeout(function() {
                      $rootScope.$broadcast('login.success');
                    }, 1000);
                  }, function() {
                    Utils.alert.show(Utils.translate('Local data base: Internal error'));
                    regularLogout();
                  })
                }, function() {
                  Utils.alert.show(Utils.translate('User not found by user name'));
                  regularLogout();
                })
              }, function() {
                Utils.alert.show(Utils.translate('ADMIN_TOOLS.ADMIN_PERMISSIONS.DIALOG.LOAD_PERMS_IN_LOGIN_ERROR'));
                regularLogout();
              })
            }, function() {
              Utils.alert.show(Utils.translate('Account status not found'));
              regularLogout();
            })
          }, function() {
            Utils.alert.show(Utils.translate('User not found by user name'));
            regularLogout();
          })
        }, function() {
          Utils.alert.show(Utils.translate('Invalid credentials'));
        })
      };

      function showStatusError(status) {
        var statusList = session.getStatusList();
        switch (status) {
          case statusList.CANCELLED:
            Utils.alert.show(Utils.translate(
              'LOGIN.USERCANCELED_TEMPLATE'), {
              title: Utils.translate('LOGIN.USERCANCELED_TITLE')
            });
            break;
          case statusList.BANNED:
            Utils.alert.show(Utils.translate('LOGIN.USER_BANNED_MSG'));
            break;
          case statusList.BLOCKED:
            Utils.alert.show(Utils.translate('LOGIN.USER_BLOCKED_MSG'));
            break;
          case statusList.DELETED:
            Utils.alert.show(Utils.translate('LOGIN.USER_DELETED'));
            break;
          default:
            Utils.alert.show(Utils.translate("LOGIN.UNKNOWN_ACCOUNT_STATUS") + "<br>STATUS: " + status);
        }
      }

      function regularLogout() {
        AuthService.logout();
        var tempPers = window.localStorage.getItem('AppsPerzonalized');
        window.localStorage.clear();
        window.localStorage.setItem("AppsPerzonalized", tempPers);
      }
    }])

  .controller('loginCtrl', ['$rootScope', '$scope', '$state', '$ionicPopup', 'AuthService', 'SignUpService', 'SignInService', 'AddSubscriptionService', '$timeout', 'changeProfilePictureService', 'FindUserSubscriptionbyWebUser', '$q', 'UserServiceFb', 'UserService', '$ionicPush', 'DBServices', 's3', 'md5', 'ApiEndPoint', 'AppAdminRolesService', 'AddUserService', 'AWSServices', '$ionicPlatform', 'Utils', '$filter', '$localForage', 'Personalized', 'UserAdditionalInfo', '$window', 'Push_Notif_Variables', 'legalURl',
    function($rootScope, $scope, $state, $ionicPopup, AuthService, SignUpService, SignInService, AddSubscriptionService, $timeout, changeProfilePictureService, FindUserSubscriptionbyWebUser, $q, UserServiceFb, UserService, $ionicPush, DBServices, s3, md5, ApiEndPoint, AppAdminRolesService, AddUserService, AWSServices, $ionicPlatform, Utils, $filter, $localForage, Personalized, UserAdditionalInfo, $window, Push_Notif_Variables, legalURl) {
      $scope.data = {};
      $scope.pictures = [];
      $scope.images = [];
      $scope.checkTerms = false;
      $scope.betweenProcess = false;
      $scope.toStandByPage = false;
      //asign error message to ""
      $scope.ErrorMessage = '';
      $scope.AppName = Push_Notif_Variables.title;
      var lang = $window.navigator.languages ?
                 $window.navigator.languages[0] :
                 ($window.navigator.language || $window.navigator.userLanguage);
      $scope.english= false;
      if(lang.includes("es-")) {
        $scope.english= false;
      } else {
        $scope.english= true;
      }
      $scope.typeAccess = 0;
      
      // ZONE FOR DATABASE CREATION - BALA
        document.addEventListener("deviceready", function() {
          DB_create_log();
        }, false);
        function DB_create_log () {
            DBServices.init().then(function (response) {
                console.log("DONE: ", response);
            }, function (error) {
                console.error("ERROR: ", error);
            })
        }
      // ZONE FOR DATABASE CREATION - END
      
      // TERMS ZONE - BALA
        $scope.redirectPolitics = function() {
          var isIOS = ionic.Platform.isIOS();
          var zone = '_blank';
          var opt = '';
          if(isIOS){
            zone = '_blank';
            opt = 'clearsessioncache=yes,usewkwebview=yes,toolbar=yes,presentationstyle=fullscreen,hidespinner=yes,closebuttoncaption=Close,closebuttoncolor=#ffffff4,navigationbuttoncolor=#ffffff,lefttoright=yes,location=no';
          }
          else{
            zone ='_blank';
            opt = 'clearsessioncache=yes,usewkwebview=yes,toolbar=yes,presentationstyle=fullscreen,hidespinner=yes,closebuttoncaptionSet=Close,closeButtonColorSet=#ffffff4,navigationbuttoncolorSet=#ffffff,lefttoright=yes,location=no';
          }
          if (lang.includes("es")) {
            var ref = cordova.InAppBrowser.open( 'https://niido.cloud/'+ legalURl.app +'/politicaprivacidad.html', zone, opt);
          } else if (lang.includes("en")) {
            var ref = cordova.InAppBrowser.open( 'https://niido.cloud/'+ legalURl.app +'/privacypolicy.html', zone, opt);
          }
        }

        $scope.redirectTerms = function() {
          var isIOS = ionic.Platform.isIOS();
          var zone = '_blank';
          var opt = '';
          if(isIOS){
            zone = '_blank';
            opt = 'clearsessioncache=yes,usewkwebview=yes,toolbar=yes,presentationstyle=fullscreen,hidespinner=yes,closebuttoncaption=Close,closebuttoncolor=#ffffff4,navigationbuttoncolor=#ffffff,lefttoright=yes,location=no';
          }
          else{
            zone ='_blank';
            opt = 'clearsessioncache=yes,usewkwebview=yes,toolbar=yes,presentationstyle=fullscreen,hidespinner=yes,closebuttoncaptionSet=Close,closeButtonColorSet=#ffffff4,navigationbuttoncolorSet=#ffffff,lefttoright=yes,location=no';
          }
          if (lang.includes("es")) {
            var ref = cordova.InAppBrowser.open( 'https://niido.cloud/'+ legalURl.app +'/terminosycondiciones.html', zone, opt);
          } else if (lang.includes("en")) {
            var ref = cordova.InAppBrowser.open( 'https://niido.cloud/'+ legalURl.app +'/termsandconditions.html', zone, opt);
          }
        }
      // TERMS ZONE - END

      // CHECK WHAT TIPE OF 3RD PARTY LOGIN IS USING - BALA
        $scope.buttonClickedBegin = function (from) {
          $scope.isAppleUser = null;
          $scope.appleUserInfo = null;
          var pivot = JSON.parse(window.localStorage.getItem('AppsPerzonalized'));
          switch (from) {
            case 1:
              if(pivot.TermsConditions) {
                checkUpdatedLegal();
              } else {
                $state.go('signup', {}, { reload: true });
              }
            break;
            case 2:
              $scope.typeAccess = 1;
              if(pivot.TermsConditions) {
                terms();
              } else {
                $scope.facebookSignIn();
              }
            break;
            case 3:
              $scope.typeAccess = 2;
              if(pivot.TermsConditions) {
                terms();
              } else {
                $scope.appleSignIn();
              }
            break;
          }
        }

        $scope.chkTypeAccess = function () {
          $scope.betweenProcess = true;
          switch ($scope.typeAccess) {
            case 1:
              $scope.facebookSignIn();
            break;
            case 2:
              $scope.appleSignIn();
            break;
          }
        }

        function checkUpdatedLegal() {
          var pivot = JSON.parse(window.localStorage.getItem('AppsPerzonalized'));
          var actualLegal = JSON.parse(window.localStorage.getItem('legalVer'));
          var showCancel = true;
          if(pivot.bypassApple) {
              $state.go('signup', {}, { reload: true });
          } else {
              Utils.modal.show({
                templateUrl: 'templates/partials/updatedLegals.html',
                locals: {
                  showCancel: showCancel,
                  verLegal: pivot.legalVer
                },
                controller: function($scope, $mdDialog, locals, Utils, $window) {
                  $scope.data = {
                    Accepted: false,
                    verLegal: locals.verLegal,
                    showCancel: showCancel
                  };
                  var lang = $window.navigator.languages ?
                      $window.navigator.languages[0] :
                      ($window.navigator.language || $window.navigator.userLanguage);
                  $scope.english= false;
                    if(lang.includes("es-")) {
                      $scope.english= false;
                    } else {
                      $scope.english= true;
                    }
                  $scope.AppName = Push_Notif_Variables.title;
                  $scope.okButton = Utils.translate('GLOBAL.OK');

                  $scope.ok = function() {
                    $mdDialog.hide($scope.data)
                  };

                  $scope.cancel = function () {
                    $mdDialog.cancel();
                  }

                  $scope.redirectPolitics = function() {
                    var isIOS = ionic.Platform.isIOS();
                    var zone = '_blank';
                    var opt = '';
                    if(isIOS){
                      zone = '_blank';
                      opt = 'clearsessioncache=yes,usewkwebview=yes,toolbar=yes,presentationstyle=fullscreen,hidespinner=yes,closebuttoncaption=Close,closebuttoncolor=#ffffff4,navigationbuttoncolor=#ffffff,lefttoright=yes,location=no';
                    }
                    else{
                      zone ='_blank';
                      opt = 'clearsessioncache=yes,usewkwebview=yes,toolbar=yes,presentationstyle=fullscreen,hidespinner=yes,closebuttoncaptionSet=Close,closeButtonColorSet=#ffffff4,navigationbuttoncolorSet=#ffffff,lefttoright=yes,location=no';
                    }
                    if (lang.includes("es")) {
                      var ref = cordova.InAppBrowser.open( 'https://niido.cloud/'+ legalURl.app +'/politicaprivacidad.html', zone, opt);
                    } else if (lang.includes("en")) {
                      var ref = cordova.InAppBrowser.open( 'https://niido.cloud/'+ legalURl.app +'/privacypolicy.html', zone, opt);
                    }
                  }

                  $scope.redirectTerms = function() {
                    var isIOS = ionic.Platform.isIOS();
                    var zone = '_blank';
                    var opt = '';
                    if(isIOS){
                      zone = '_blank';
                      opt = 'clearsessioncache=yes,usewkwebview=yes,toolbar=yes,presentationstyle=fullscreen,hidespinner=yes,closebuttoncaption=Close,closebuttoncolor=#ffffff4,navigationbuttoncolor=#ffffff,lefttoright=yes,location=no';
                    }
                    else{
                      zone ='_blank';
                      opt = 'clearsessioncache=yes,usewkwebview=yes,toolbar=yes,presentationstyle=fullscreen,hidespinner=yes,closebuttoncaptionSet=Close,closeButtonColorSet=#ffffff4,navigationbuttoncolorSet=#ffffff,lefttoright=yes,location=no';
                    }
                    if (lang.includes("es")) {
                      var ref = cordova.InAppBrowser.open( 'https://niido.cloud/'+ legalURl.app +'/terminosycondiciones.html', zone, opt);
                    } else if (lang.includes("en")) {
                      var ref = cordova.InAppBrowser.open( 'https://niido.cloud/'+ legalURl.app +'/termsandconditions.html', zone, opt);
                    }
                  }
                }
              }).then(function (data) {
                $state.go('signup', {}, { reload: true });
              })
          }
        }
      // CHECK WHAT TIPE OF 3RD PARTY LOGIN IS USING - END
      
      // BALA ZONE TO SHOW/HIDE ACCESS TO APP
        window.onload = function() {
          console.log("FROM ONLOAD");
          $scope.loadingVisual = true;
          setTimeout(function() {
            $scope.prepareShows();
          }, 500);
        }

      $scope.prepareShows = function() {
        var isIOS = ionic.Platform.isIOS();
        var isAndroid = ionic.Platform.isAndroid();
        $scope.showDirectLogin = true;
        $scope.showFBLogin = true;
        $scope.showRegister = true;
        var pivot = null;
        pivot = JSON.parse(window.localStorage.getItem('AppsPerzonalized'));
        if(pivot) {
          $scope.showDirectLogin = pivot.showDirectAccess ? true : false;
          $scope.showFBLogin = pivot.showFbAccess ? true : false;
          $scope.showRegister = pivot.showRegisterAccess ? true : false;
          $scope.showAppleSignin = isAndroid ?  false: (pivot.showAppleSignin ? true : false);
        } else {
          $scope.showDirectLogin = true;
          $scope.showFBLogin = false;
          $scope.showRegister = true;
          $scope.showAppleSignin = isAndroid ?  false: (false);
          //$scope.showAppleSignin = pivot.showAppleSignin ? true : false;
          //$scope.$apply();
        }
      }

        $scope.validateVisuals = function() {
          console.log("FROM SCOPE");
          if ($scope.loadingVisual) {
            console.log("ALREADY LOADED");
          } else {
            $scope.loadingVisual = true;
            $scope.prepareShows();
          }
        }
        setTimeout(function() {
          $scope.validateVisuals();
        }, 500);
      // END BALA ZONE TO SHOW/HIDE ACCESS TO APP

      // ZONE FOR DATABASE FUNCTION - BALA
        if (true) { //window.localStorage.getItem('onboardingComplete')
          $localForage.length().then(function(dataLength) {
            console.log("local forage length", dataLength);
            if (window.localStorage.getItem('userSubscriptionId')) {
              $localForage.setItem('userSubscriptionId', window.localStorage.getItem('userSubscriptionId')).then(function(userSubsId) {
                $localForage.setItem('userSubscriptionInstanceId', window.localStorage.getItem('userSubscriptionInstanceId')).then(function(userSubsInstId) {
                  console.log("LOCALFORAGE UPDATED");
                })
              });
              Utils.loading.show();
              UserService.findUserSubscriptionv157().get({
                "x-isis-querystring": {
                  'userSubscription': {
                    'value': {
                      'href': ApiEndPoint.url + "restful/objects/simple.UserSubscription/" + window.localStorage.getItem('userSubscriptionInstanceId')
                    }
                  }
                }
              }).$promise.then(function(response) {
                Utils.removeLastItemIfHasNoAttribute(response, 'accountStatus');
                if (response[0].role) {
                  var accountStatus = response[0].accountStatus;
                  if (accountStatus === "Canceled") {
                    Utils.loading.hide();
                    userCanceled();
                    return;
                  } else if (accountStatus === "Banned") {
                    Utils.loading.hide();
                    Utils.alert.show(Utils.translate('LOGIN.USER_BANNED_MSG'));
                    return;
                  } else if (accountStatus === "Blocked") {
                    Utils.loading.hide();
                    Utils.alert.show(Utils.translate('LOGIN.USER_BLOCKED_MSG'));
                    return;
                  }
                  //CHECK GLOBAL OPTIONS FOR APP
                  var pivot = JSON.parse(window.localStorage.getItem('AppsPerzonalized'));
                  if (pivot.TypeOfOnboarding === 0) {
                    if (accountStatus !== "Active" && accountStatus !== "Pendingforreview") {
                      Utils.loading.hide();
                      Utils.alert.show(Utils.translate("LOGIN.UNKNOWN_ACCOUNT_STATUS") + "<br>STATUS: " + accountStatus);
                      return;
                    }
                  } else {
                    if (accountStatus !== "Active" && accountStatus !== "Pendingforreview") {
                      Utils.loading.hide();
                      Utils.alert.show(Utils.translate("LOGIN.UNKNOWN_ACCOUNT_STATUS") + "<br>STATUS: " + accountStatus);
                      return;
                    }
                  }
                  //CHECK AWS TOKEN NEEDED FOR PUSH NOTIFICATION
                  if (window.localStorage.getItem('AWSToken') && (window.localStorage.getItem('AWSToken') != '(null)')) {
                    AWSServices.awsInit();
                  } else {
                    //IF TOKEN ISN'T PRESENT IN LS WE NEED TO GET ONE FROM THE DEVICE
                    //$ionicPlatform.ready(function() {
                      var isIOS = ionic.Platform.isIOS();
                      if (isIOS === true) {
                          FCMPlugin.hasPermission(function(response) {
                              console.log("RES:", response);
                              if(response) {
                                  FCMPlugin.getAPNSToken(function(token) {
                                    //console.log("firebaseToken => " + token);
                                    window.localStorage.setItem('AWSToken', token);
                                      AWSServices.awsInit();
                                  }, function(error) {
                                    //alert("Couldn't get FCM token because: " +JSON.stringify(error));
                                    console.error("Couldn't get FCM token because: ", error);
                                  });
                              }
                          }, function (error) {
                              console.error("ERR: ", error);
                          })
                        /*if (window.ApnsToken) {
                          ApnsToken.getToken(function(token) {
                            window.localStorage.setItem('AWSToken', token);
                            if (typeof FCMPlugin != 'undefined') {
                              AWSServices.awsInit();
                            }
                          }, function(error) {
                            console.error("can't get ios token", error);
                          })
                        }*/
                      } else {
                        if (typeof FCMPlugin != 'undefined') {
                          FCMPlugin.getToken(function(token) {
                            window.localStorage.setItem('AWSToken', token);
                            AWSServices.awsInit();
                          }, function(response) {
                            console.error("couldn't get FCM token because: ", response);
                          })
                        }
                      }
                    //})
                  }
                  // CHECK FOR PUSH NOTIFICATTION CONFIGURATION
                  if (window.localStorage.getItem('pushNotificationsConfig') === null) {
                    UserService.getPushNotificationsConfig({
                      objectId: window.localStorage.getItem('userSubscriptionInstanceId')
                    }).get().$promise.then(function(response) {
                      var config = [];
                      response.forEach(function(item) {
                        var textForShow = "";
                        switch (item.notificationType) {
                          case 1:
                            textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.NEW_FOLLOWERS");
                            break;
                            /*case 2:
                              textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.NEW_FOLLOWERS");
                            break;*/
                            /*case 3:
                              textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.NEW_FOLLOWERS");
                            break;*/
                          case 4:
                            textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.REACTS");
                            break;
                          case 5:
                            textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.LIKES");
                            break;
                          case 6:
                            textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.COMMENTS");
                            break;
                          case 7:
                            textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.TAGGING");
                            break;
                            /*case 8:
                              textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.NEW_FOLLOWERS");
                            break;*/
                          case 9:
                            textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.LIKE_COMMENT");
                            break;
                          case 10:
                            textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.DELETED_GROUP");
                            break;
                          case 11:
                            textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.JOIN_GROUP");
                            break;
                          case 12:
                            textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.ACCEPTED_GROUP");
                            break;
                          case 13:
                            textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.FRIEND_POST_NEW");
                            break;
                          case 14:
                            textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.NEW_POST_GROUP");
                            break;
                          case 15:
                            textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.NEW_PROFILE_PHOTO");
                            break;
                          case 16:
                            textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.NEW_GROUP_COVER");
                            break;
                          case 17:
                            textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.LIKED_POST_COMMENTED");
                            break;
                          case 18:
                            textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.COMMENTED_POST_COMMENTED");
                            break;
                          case 19:
                            textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.LIKED_POST_LIKED");
                            break;
                          case 20:
                            textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.STREAM_NOTIFICATIONS");
                            break;
                        }
                        config.push({
                          instanceId: +Utils.getLastUrlComponent(item.configureUserNotification.href),
                          notificationType: item.notificationType,
                          sendNotification: item.sendNotification,
                          textForShow: textForShow
                        });
                      });

                      window.localStorage.setItem('pushNotificationsConfig', JSON.stringify(config));
                    }, function(error) {
                      console.error("get PushNotificationsConfig: ", error);
                    });
                  }
                  // CHECK ROLE FROM USER IF DOESN'T HAVE ONE WE ASUME IS REGULAR USER (2)
                  var newRoleId = Utils.getLastUrlComponent(response[0].role.href);
                  if (!newRoleId) newRoleId = 2;
                  var currentRoleId = window.localStorage.getItem('userRoleId');
                  if (currentRoleId !== newRoleId) {
                    window.localStorage.setItem('userRoleId', newRoleId);
                  }
                  //GET LEGAL VERSION FROM LS
                  window.localStorage.setItem('legalVer', response[0].termsAndConditionsVersion);
                  //GET ROLEPERMISSIONS 
                  getRolePermissionAndSetUserData(+newRoleId).then(function(boolResp) {
                    //CHECK WHERE SEND THE USER
                    var pivot = JSON.parse(window.localStorage.getItem('AppsPerzonalized'));
                    if (pivot.TypeOfOnboarding === 0) {
                      //ONBOARDING IS OPEN SEND TO TIMELINE
                      $state.go('menu.timeline', { "prepareStatement": 0 }, { reload: true });
                    } else {
                      //ONBOARDING CLOSED, PENDINGTOREVIEW INTO STANDBY, ACTIVE TO TIMELINE
                      if (accountStatus === "Pendingforreview") {
                        $state.go('standbyPage', {}, { reload: true });
                      } else {
                        $state.go('menu.timeline', { "prepareStatement": 0 }, { reload: true });
                      }
                    }
                    //NOTIFY LOGIN SUCCESS
                    setTimeout(function() {
                      $rootScope.$broadcast('login.success');
                    }, 1000);
                  }, function(error) {
                    console.error("getRolePermissions", error);
                    var tempPers = window.localStorage.getItem('AppsPerzonalized');
                    window.localStorage.clear();
                    window.localStorage.setItem("AppsPerzonalized", tempPers);
                    $localForage.clear();
                    window.localStorage.setItem("onboardingComplete", "yes");
                    $localForage.setItem("onboardingComplete", "yes").then(function(onboardComplete) {
                      console.log("onboardingComplete", onboardComplete);
                    });
                    Utils.alert.show(Utils.translate('ADMIN_TOOLS.ADMIN_PERMISSIONS.DIALOG.LOAD_PERMS_IN_LOGIN_ERROR')).then(function() {
                      location.reload();
                    })
                  }).finally(function() {
                    Utils.loading.hide();
                  })
                } else {
                  Utils.loading.hide();
                  console.error("No role attribute found");
                  var tempPers = window.localStorage.getItem('AppsPerzonalized');
                  window.localStorage.clear();
                  window.localStorage.setItem("AppsPerzonalized", tempPers);
                  $localForage.clear();
                  window.localStorage.setItem("onboardingComplete", "yes");
                  $localForage.setItem("onboardingComplete", "yes").then(function(onboardComplete) {
                    console.log("onboardingComplete", onboardComplete);
                  });
                  Utils.alert.show(Utils.translate('ADMIN_TOOLS.ADMIN_PERMISSIONS.DIALOG.LOAD_PERMS_IN_LOGIN_ERROR')).then(function() {
                    location.reload();
                  })
                }
              }, function(error) {
                console.error("findUserSubscriptionv157", error);
                Utils.loading.hide();
                var tempPers = window.localStorage.getItem('AppsPerzonalized');
                window.localStorage.clear();
                window.localStorage.setItem("AppsPerzonalized", tempPers);
                $localForage.clear();
                window.localStorage.setItem("onboardingComplete", "yes");
                $localForage.setItem("onboardingComplete", "yes").then(function(onboardComplete) {
                  console.log("onboardingComplete", onboardComplete);
                });
                Utils.alert.show(Utils.translate('ADMIN_TOOLS.ADMIN_PERMISSIONS.DIALOG.LOAD_PERMS_IN_LOGIN_ERROR')).then(function() {
                  location.reload();
                })
              });
            } else {
              Utils.loading.show();
              //IF EMPTY OR NULL CHECK IN LF
              $localForage.getItem('userSubscriptionId').then(function(LFuserSubscriptionId) {
                $localForage.getItem('userSubscriptionInstanceId').then(function(LFuserSubscriptionInstanceId) {
                  if (LFuserSubscriptionId != undefined || LFuserSubscriptionInstanceId != undefined) {
                    console.log("ASIGN TO LS");
                    window.localStorage.setItem('userSubscriptionId', LFuserSubscriptionId);
                    window.localStorage.setItem('userSubscriptionInstanceId', LFuserSubscriptionInstanceId);
                    UserService.findUserSubscriptionv157().get({
                      "x-isis-querystring": {
                        'userSubscription': {
                          'value': {
                            'href': ApiEndPoint.url + "restful/objects/simple.UserSubscription/" + window.localStorage.getItem('userSubscriptionInstanceId')
                          }
                        }
                      }
                    }).$promise.then(function(response) {
                      Utils.removeLastItemIfHasNoAttribute(response, 'accountStatus');
                      if (response[0].role) {
                        var accountStatus = response[0].accountStatus;
                        //console.log(accountStatus);

                        if (accountStatus === "Canceled") {
                          Utils.loading.hide();
                          userCanceled();
                          return;
                        } else if (accountStatus === "Banned") {
                          Utils.loading.hide();
                          Utils.alert.show(Utils.translate('LOGIN.USER_BANNED_MSG'));
                          return;
                        } else if (accountStatus === "Blocked") {
                          Utils.loading.hide();
                          Utils.alert.show(Utils.translate('LOGIN.USER_BLOCKED_MSG'));
                          return;
                        }
                        var pivot = JSON.parse(window.localStorage.getItem('AppsPerzonalized'));
                        if (pivot.TypeOfOnboarding === 0) {
                          if (accountStatus !== "Active") {
                            Utils.loading.hide();
                            Utils.alert.show(Utils.translate("LOGIN.UNKNOWN_ACCOUNT_STATUS") + "<br>STATUS: " + accountStatus);
                            return;
                          }
                        } else {
                          if (accountStatus !== "Active" && accountStatus !== "Pendingforreview") {
                            Utils.loading.hide();
                            Utils.alert.show(Utils.translate("LOGIN.UNKNOWN_ACCOUNT_STATUS") + "<br>STATUS: " + accountStatus);
                            return;
                          }
                        }

                        //Function to register ionic token when a user has logged in
                        if (window.localStorage.getItem('AWSToken') && (window.localStorage.getItem('AWSToken') != '(null)')) {
                          AWSServices.awsInit();
                        } else {
                          //$ionicPlatform.ready(function() {
                            var isIOS = ionic.Platform.isIOS();
                            if (isIOS === true) {
                                FCMPlugin.hasPermission(function(response) {
                                    console.log("RES:", response);
                                    if(response) {
                                        FCMPlugin.getAPNSToken(function(token) {
                                          //console.log("firebaseToken => " + token);
                                          window.localStorage.setItem('AWSToken', token);
                                            AWSServices.awsInit();
                                        }, function(error) {
                                          //alert("Couldn't get FCM token because: " +JSON.stringify(error));
                                          console.error("Couldn't get FCM token because: ", error);
                                        });
                                    }
                                }, function (error) {
                                    console.error("ERR: ", error);
                                })
                              /*if (window.ApnsToken) {
                                ApnsToken.getToken(function(token) {
                                  window.localStorage.setItem('AWSToken', token);
                                  if (typeof FCMPlugin != 'undefined') {
                                    AWSServices.awsInit();
                                  }
                                }, function(error) {
                                  console.error("can't get ios token", error);
                                })
                              }*/
                            } else {
                              if (typeof FCMPlugin != 'undefined') {
                                FCMPlugin.getToken(function(token) {
                                  window.localStorage.setItem('AWSToken', token);
                                  AWSServices.awsInit();
                                }, function(response) {
                                  console.error("couldn't get FCM token because: ", response);
                                })
                              }
                            }
                          //})
                        }

                        //Load push configuration if needed
                        if (window.localStorage.getItem('pushNotificationsConfig') === null) {
                          UserService.getPushNotificationsConfig({
                            objectId: window.localStorage.getItem('userSubscriptionInstanceId')
                          }).get().$promise.then(function(response) {
                            var config = [];
                            response.forEach(function(item) {
                              var textForShow = "";
                              switch (item.notificationType) {
                                case 1:
                                  textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.NEW_FOLLOWERS");
                                  break;
                                  /*case 2:
                                    textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.NEW_FOLLOWERS");
                                  break;*/
                                  /*case 3:
                                    textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.NEW_FOLLOWERS");
                                  break;*/
                                case 4:
                                  textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.REACTS");
                                  break;
                                case 5:
                                  textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.LIKES");
                                  break;
                                case 6:
                                  textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.COMMENTS");
                                  break;
                                case 7:
                                  textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.TAGGING");
                                  break;
                                  /*case 8:
                                    textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.NEW_FOLLOWERS");
                                  break;*/
                                case 9:
                                  textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.LIKE_COMMENT");
                                  break;
                                case 10:
                                  textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.DELETED_GROUP");
                                  break;
                                case 11:
                                  textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.JOIN_GROUP");
                                  break;
                                case 12:
                                  textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.ACCEPTED_GROUP");
                                  break;
                                case 13:
                                  textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.FRIEND_POST_NEW");
                                  break;
                                case 14:
                                  textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.NEW_POST_GROUP");
                                  break;
                                case 15:
                                  textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.NEW_PROFILE_PHOTO");
                                  break;
                                case 16:
                                  textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.NEW_GROUP_COVER");
                                  break;
                                case 17:
                                  textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.LIKED_POST_COMMENTED");
                                  break;
                                case 18:
                                  textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.COMMENTED_POST_COMMENTED");
                                  break;
                                case 19:
                                  textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.LIKED_POST_LIKED");
                                  break;
                                case 20:
                                  textForShow = $filter('translate')("MENU.SETTINGS.PUSH_NOTIFICATIONS.STREAM_NOTIFICATIONS");
                                  break;
                              }
                              config.push({
                                instanceId: +Utils.getLastUrlComponent(item.configureUserNotification.href),
                                notificationType: item.notificationType,
                                sendNotification: item.sendNotification,
                                textForShow: textForShow
                              });
                            });

                            window.localStorage.setItem('pushNotificationsConfig', JSON.stringify(config));
                          }, function(error) {
                            console.error("get PushNotificationsConfig: ", error);
                          });
                        }

                        var newRoleId = Utils.getLastUrlComponent(response[0].role.href);
                        if (!newRoleId) newRoleId = 2; //<--regular user
                        var currentRoleId = window.localStorage.getItem('userRoleId');

                        if (currentRoleId !== newRoleId) {
                          window.localStorage.setItem('userRoleId', newRoleId).$promise;
                        }

                        getRolePermissionAndSetUserData(+newRoleId).then(function(boolResp) {
                          // copy the LS main kay to LF
                          $localForage.setItem('userSubscriptionId', window.localStorage.getItem('userSubscriptionId')).then(function(userSubsId) {
                            //if the LS is in good state
                            $localForage.setItem('userSubscriptionInstanceId', window.localStorage.getItem('userSubscriptionInstanceId')).then(function(userSubsInstId) {
                              console.log("LOCALFORAGE UPDATED");
                            })
                          })
                          var pivot = JSON.parse(window.localStorage.getItem('AppsPerzonalized'));
                          if (pivot.TypeOfOnboarding === 0) {
                            //onboarding open
                            $state.go('menu.timeline', { "prepareStatement": 0 }, { reload: true });
                          } else {
                            //onboarding closed
                            //checkStatus after
                            if (accountStatus === "Pendingforreview") {
                              //send to waitingPage
                              $state.go('standbyPage', {}, { reload: true });
                            } else {
                              $state.go('menu.timeline', { "prepareStatement": 0 }, { reload: true });
                            }
                          }
                          setTimeout(function() {
                            $rootScope.$broadcast('login.success');
                          }, 1000);
                        }, function(error) {
                          console.error("getRolePermissions", error);
                          var tempPers = window.localStorage.getItem('AppsPerzonalized');
                          window.localStorage.clear();
                          window.localStorage.setItem("AppsPerzonalized", tempPers);
                          $localForage.clear();
                          window.localStorage.setItem("onboardingComplete", "yes");
                          $localForage.setItem("onboardingComplete", "yes").then(function(onboardComplete) {
                            console.log("onboardingComplete", onboardComplete);
                          });
                          Utils.alert.show(Utils.translate('ADMIN_TOOLS.ADMIN_PERMISSIONS.DIALOG.LOAD_PERMS_IN_LOGIN_ERROR')).then(function() {
                            location.reload();
                          })
                        }).finally(function() {
                          Utils.loading.hide();
                        })
                      } else {
                        Utils.loading.hide();
                        console.error("No role attribute found");
                        var tempPers = window.localStorage.getItem('AppsPerzonalized');
                        window.localStorage.clear();
                        window.localStorage.setItem("AppsPerzonalized", tempPers);
                        $localForage.clear();
                        window.localStorage.setItem("onboardingComplete", "yes");
                        $localForage.setItem("onboardingComplete", "yes").then(function(onboardComplete) {
                          console.log("onboardingComplete", onboardComplete);
                        });
                        Utils.alert.show(Utils.translate('ADMIN_TOOLS.ADMIN_PERMISSIONS.DIALOG.LOAD_PERMS_IN_LOGIN_ERROR')).then(function() {
                          location.reload();
                        })
                      }
                    }, function(error) {
                      console.error("findUserSubscriptionv157", error);
                      Utils.loading.hide();
                      var tempPers = window.localStorage.getItem('AppsPerzonalized');
                      window.localStorage.clear();
                      window.localStorage.setItem("AppsPerzonalized", tempPers);
                      $localForage.clear();
                      window.localStorage.setItem("onboardingComplete", "yes");
                      $localForage.setItem("onboardingComplete", "yes").then(function(onboardComplete) {
                        console.log("onboardingComplete", onboardComplete);
                      });
                      Utils.alert.show(Utils.translate('ADMIN_TOOLS.ADMIN_PERMISSIONS.DIALOG.LOAD_PERMS_IN_LOGIN_ERROR')).then(function() {
                        location.reload();
                      })
                    });
                  } else {
                    //NO SESSION FOUND IN LS OR LF
                    Utils.loading.hide();
                    var tempPers = window.localStorage.getItem('AppsPerzonalized');
                    window.localStorage.clear();
                    window.localStorage.setItem("AppsPerzonalized", tempPers);
                    $localForage.clear().then(function() {
                      console.log("Forage clean");
                      window.localStorage.setItem("onboardingComplete", "yes");
                      $localForage.setItem("onboardingComplete", "yes").then(function(onboardComplete) {
                        console.log("onboardingComplete", onboardComplete);
                      });
                    });
                  }
                }, function(LFUSIIError) {
                  console.error("findUserSubscriptionv157", LFUIError);
                  Utils.loading.hide();
                  var tempPers = window.localStorage.getItem('AppsPerzonalized');
                  window.localStorage.clear();
                  window.localStorage.setItem("AppsPerzonalized", tempPers);
                  $localForage.clear().then(function() {
                    console.log("Forage clean");
                  });
                  window.localStorage.setItem("onboardingComplete", "yes");
                  $localForage.setItem("onboardingComplete", "yes").then(function(onboardComplete) {
                    console.log("onboardingComplete", onboardComplete);
                  });
                })
              }, function(LFUIError) {
                console.error("findUserSubscriptionv157", LFUIError);
                Utils.loading.hide();
                var tempPers = window.localStorage.getItem('AppsPerzonalized');
                window.localStorage.clear();
                window.localStorage.setItem("AppsPerzonalized", tempPers);
                $localForage.clear().then(function() {
                  console.log("Forage clean");
                });
                window.localStorage.setItem("onboardingComplete", "yes");
                $localForage.setItem("onboardingComplete", "yes").then(function(onboardComplete) {
                  console.log("onboardingComplete", onboardComplete);
                });
              })
            }
          })
        } else {
          DBServices.execute("SELECT * FROM userSession").then(
            function(dbResp) {
              var columns = dbResp.extractItems();
              if (columns.length > 0) {
                //si había sesión previa
                window.localStorage.setItem('onboardingComplete', columns[0].onBoard);
                window.localStorage.setItem('userName', columns[0].userName);
                window.localStorage.setItem('userSubscriptionInstanceId', columns[0].userSubsInstId);
                window.localStorage.setItem('userSubscriptionId', columns[0].userSubsId);
                location.reload();
              } else {
                var dialog = Utils.alert.getCtrl();
                dialog.show({
                  templateUrl: 'templates/partials/onBoarding.html',
                  controller: 'onBoardingCtrl',
                  locals: { dialog: dialog },
                  clickOutsideToClose: false,
                  fullscreen: true // Only for -xs, -sm breakpoints.
                }).then(function(resp) {
                  $scope.data.sequenceName = resp.description;
                  $scope.data.mentionsList = resp.savedTags;
                  $scope.data.hashList = resp.savedHashes;
                });
              }
            },
            function(errorDb) {
              var dialog = Utils.alert.getCtrl();
              dialog.show({
                templateUrl: 'templates/partials/onBoarding.html',
                controller: 'onBoardingCtrl',
                locals: { dialog: dialog },
                clickOutsideToClose: false,
                fullscreen: true // Only for -xs, -sm breakpoints.
              }).then(function(resp) {
                $scope.data.sequenceName = resp.description;
                $scope.data.mentionsList = resp.savedTags;
                $scope.data.hashList = resp.savedHashes;
              });
            }
          )
        }
      // ZONE FOR DATABASE FUNCTION - END


      // ZONE FOR DIRECT LOGIN
        $scope.regularLogin = function() {
          var username = $scope.data.userName.toUpperCase();
          var password = $scope.data.password;

          $scope.ErrorMessage = '';

          Utils.loading.show(Utils.translate('LOGIN.LOGGING_IN'));
          AuthService.login(username, password).then(function() {
            $scope.data = {};
            $scope.error = undefined;
            $scope.userName = username;
            findSubscription();
          }, function(err) {
            Utils.loading.hide();
            Utils.alert.show(err);
            console.error("Error login", err);
            $scope.data.password = "";
          });
        };

        function findSubscription() {
          UserService.findUserSubscriptionByUserName().get({
            'userName': $scope.userName
          }, function(response) {
            //console.log("findUserSubscriptionByUserName", response);
            if (response[0].accountStatus == "Canceled") {
              AuthService.logout();
              Utils.loading.hide();
              var tempPers = window.localStorage.getItem('AppsPerzonalized');
              window.localStorage.clear();
              window.localStorage.setItem("AppsPerzonalized", tempPers);
              window.localStorage.setItem("onboardingComplete", "yes");
              userCanceled();
            } else if (response[0].accountStatus == "Banned") {
              Utils.loading.hide();
              Utils.alert.show(Utils.translate('LOGIN.USER_BANNED_MSG'));
              var tempPers = window.localStorage.getItem('AppsPerzonalized');
              window.localStorage.clear();
              window.localStorage.setItem("AppsPerzonalized", tempPers);
              window.localStorage.setItem("onboardingComplete", "yes");
              AuthService.logout();
            } else if (response[0].accountStatus == "Blocked") {
              Utils.loading.hide();
              Utils.alert.show(Utils.translate('LOGIN.USER_BLOCKED_MSG'));
              var tempPers = window.localStorage.getItem('AppsPerzonalized');
              window.localStorage.clear();
              window.localStorage.setItem("AppsPerzonalized", tempPers);
              window.localStorage.setItem("onboardingComplete", "yes");
              AuthService.logout();
            } else if (response[0].accountStatus !== "Active" && response[0].accountStatus !== "Pendingforreview") {
              Utils.loading.hide();
              Utils.alert.show(Utils.translate("LOGIN.UNKNOWN_ACCOUNT_STATUS") + "<br>STATUS: " + response[0].accountStatus);
              var tempPers = window.localStorage.getItem('AppsPerzonalized');
              window.localStorage.clear();
              window.localStorage.setItem("AppsPerzonalized", tempPers);
              window.localStorage.setItem("onboardingComplete", "yes");
              AuthService.logout();
            } else {
              // new step for onboarding close/open
              var pivot = JSON.parse(window.localStorage.getItem('AppsPerzonalized'));
              if (pivot.TypeOfOnboarding === 0) {
                //onboarding open
                $scope.toStandByPage = false;
              } else {
                //onboarding closed
                //checkStatus after
                if (response[0].accountStatus === "Pendingforreview") {
                  //send to waitingPage
                  $scope.toStandByPage = true;
                } else {
                  $scope.toStandByPage = false;
                }
              }
              if (response[0].name) {
                window.localStorage.setItem("ownPrivate", response[0].privateAccount);
                window.localStorage.setItem("name", response[0].name);
                window.localStorage.setItem("firstName", response[0].firstName);
                window.localStorage.setItem("lastName", response[0].lastName);
                window.localStorage.setItem("userName", $scope.userName);
                window.localStorage.setItem("simpleUserInstanceId", response[0].user.href.split('/')[6]);
                window.localStorage.setItem("userSubscriptionInstanceId", response[0].userSubscription.href.split('/')[6]);
                window.localStorage.setItem("userSubscriptionHref", response[0].userSubscription.href);
                window.localStorage.setItem("userSubscriptionId", response[0].userSubscriptionId);
                window.localStorage.setItem("userBiography", response[0].userBio);
                window.localStorage.setItem("birthDate", response[0].birthDate);
                window.localStorage.setItem("city", response[0].city);


                //window.localStorage.setItem("userAge", response[0]);
                DBServices.execute("SELECT * FROM userSession").then(
                  function(dbResp) {
                    var columns = dbResp.extractItems();
                    if (columns.length > 0) {
                      DBServices.execute("UPDATE userSession set userSubsId = ?, userSubsInstId = ?, userName = ?, onBoard = ? WHERE userSubsId = ?",
                        [
                          response[0].userSubscriptionId,
                          response[0].userSubscription.href.split('/')[6],
                          $scope.userName,
                          "yes",
                          response[0].userSubscriptionId
                        ]).then(function(updateResp) {}, function(updateError) {})
                    } else {
                      DBServices.execute("INSERT INTO userSession values(?,?,?,?)",
                        [
                          response[0].userSubscriptionId,
                          response[0].userSubscription.href.split('/')[6],
                          $scope.userName,
                          "yes"
                        ]).then(function(insertResp) {}, function(insertError) {})
                    }
                  },
                  function(errorDb) {}
                );

                //zone for update legal version from user
                window.localStorage.setItem('legalVer', response[0].termsAndConditionsVersion);

                //getBackgroundPicture
                changeProfilePictureService.getBackgroundPictureFromId({
                  userId: response[0].userSubscription.href.split('/')[6]
                }).then(function success(response) {
                  //console.log("get");
                  if (!response.result) {} else {
                    window.localStorage.setItem("bkgMyProfile", response.result.value);
                  }
                }, function(response) {
                  console.log("findFriendBackGround", response);
                });

                //Request for largest profile photo
                UserService.findUserProfilePictureLargeById({
                  "objectId": response[0].userSubscription.href.split('/')[6]
                }).get().$promise.then(function success(result) {
                  //If the user doesn't have a large profile photo we use the photo in the subscription
                  //This must be temporal and needs to be deprecated when all users have large photo
                  if (result[0].profilePicture) {
                    if (result[0].profilePicture !== null) {
                      window.localStorage.setItem("photoProfileBlob", 'data:image/jpeg;base64,' + result[0].profilePicture.split(':')[2]);
                    }
                  } else {
                    if (response[0].profilePicture !== null) {
                      window.localStorage.setItem("photoProfileBlob", 'data:image/jpeg;base64,' + response[0].profilePicture.split(':')[2]);
                    }
                  }
                  if (result[0].profilePictureUrl) {
                    if (result[0].profilePictureUrl !== null) {
                      window.localStorage.setItem("photoProfileBlob", result[0].profilePictureUrl);
                    }
                  } else {
                    if (response[0].profilePictureUrl !== null) {
                      window.localStorage.setItem("photoProfileBlob", response[0].profilePictureUrl);
                    }
                  }
                }, function(error) {
                  console.error("Error findUserProfilePictureLargeById", error);
                });

                var newRoleId = Utils.getLastUrlComponent(response[0].role.href);
                if (!newRoleId) newRoleId = 2; //<--regular user
                var currentRoleId = window.localStorage.getItem('userRoleId');

                if (currentRoleId !== newRoleId) {
                  window.localStorage.setItem('userRoleId', newRoleId);
                  //console.log("New role detected");
                }

                $scope.rolID = response[0].role.href;

                getRolePermissionAndSetUserData(+Utils.getLastUrlComponent(response[0].role.href)).then(function(boolResp) {
                  finduser();
                }, function(error) {
                  console.error("getRolePermissions", error);
                  Utils.alert.show(Utils.translate('ADMIN_TOOLS.ADMIN_PERMISSIONS.DIALOG.LOAD_PERMS_IN_LOGIN_ERROR')).then(function() {
                    location.reload();
                  });
                  var tempPers = window.localStorage.getItem('AppsPerzonalized');
                  window.localStorage.clear();
                  window.localStorage.setItem("AppsPerzonalized", tempPers);
                  window.localStorage.setItem("onboardingComplete", "yes");
                })
              } else {
                showErrorAndClean(Utils.translate('LOGIN.USER_DELETED'), 0, 1);
              }
            }
          }, function(error) {
            var tempPers = window.localStorage.getItem('AppsPerzonalized');
            window.localStorage.clear();
            window.localStorage.setItem("AppsPerzonalized", tempPers);
            window.localStorage.setItem("onboardingComplete", "yes");
            AuthService.logout();
            Utils.loading.hide();
            console.error("Error findUserSubscriptionByUserName", error);
            Utils.alert.show("Your username or password is incorrect");
          });
        }

        function finduser() {
          UserService.findUserByUserName().get({
            'userName': $scope.userName
          }, function(response) {
            //console.log("findUserByUserName", response);
            window.localStorage.setItem("applicationUser", response[0].applicationUser.href);
            window.localStorage.setItem("simpleUserId", response[0].userId);
            window.localStorage.setItem("userEmail", response[0].email);


            reDirect();
          }, function(error) {
            Utils.loading.hide();
            console.error("Error findUserByUserName", error);
          });
        }

        function reDirect() {
          //Utils.loading.hide();

          //function needed to prepare aws notification
          if (window.localStorage.getItem('AWSToken') && (window.localStorage.getItem('AWSToken') != '(null)')) {
            AWSServices.awsInit();
          } else {
            //$ionicPlatform.ready(function() {
              var isIOS = ionic.Platform.isIOS();
              if (isIOS === true) {
                  FCMPlugin.hasPermission(function(response) {
                      console.log("RES:", response);
                      if(response) {
                          FCMPlugin.getAPNSToken(function(token) {
                            //console.log("firebaseToken => " + token);
                            window.localStorage.setItem('AWSToken', token);
                              AWSServices.awsInit();
                          }, function(error) {
                            //alert("Couldn't get FCM token because: " +JSON.stringify(error));
                            console.error("Couldn't get FCM token because: ", error);
                          });
                      }
                  }, function (error) {
                      console.error("ERR: ", error);
                  })
                /*if (window.ApnsToken) {
                  ApnsToken.getToken(function(token) {
                    window.localStorage.setItem('AWSToken', token);
                    if (typeof FCMPlugin != 'undefined') {
                      AWSServices.awsInit();
                    }
                  }, function(error) {
                    console.error("can't get ios token", error);
                  })
                }*/
              } else {
                if (typeof FCMPlugin != 'undefined') {
                  FCMPlugin.getToken(function(token) {
                    window.localStorage.setItem('AWSToken', token);
                    AWSServices.awsInit();
                  }, function(response) {
                    console.error("couldn't get FCM token because: ", response);
                  })
                }
              }
            //})
          }

          if (window.localStorage.getItem("changePassword")) {
            Utils.loading.hide();
            $state.go('menu.updatePassword', {}, { reload: true });
            Utils.alert.show(Utils.translate('MENU.SETTINGS.UPDATE_PASSWORD.RECOMMEND'));
          } else {
            //Check if the user still have their logged count stored in the device
            DBServices.execute(
              "SELECT * FROM userLogCount WHERE name = ?",
              [window.localStorage.getItem("name")]
            ).then(function(resultSet) {
              if (resultSet.rows.length > 0) {
                //Check if user still have tutorial data stored
                DBServices.execute("SELECT * FROM tutorials").then(function(resultSetTwo) {
                  if (resultSetTwo.rows.length > 0) {
                    //redirect timeline
                    Utils.loading.hide();
                    if ($scope.toStandByPage) {
                      //status pending and or TL closed
                      $state.go('standbyPage', {}, { reload: true });
                    } else {
                      //open TL and/or status not pending
                      $state.go('menu.timeline', { "prepareStatement": 0 }, { reload: true });
                    }

                    setTimeout(function() {
                      $rootScope.$broadcast('login.success');
                    }, 1000);
                  } else {
                    //send populate tutorials
                    setDefaultsDataBase(1, 1);
                  }
                }, function(error) {
                  console.error('Execute SELECT tutorials error out', error);
                })
              } else {
                //send populate log count table
                setDefaultsDataBase(2, 1);
              }
            }, function(error) {
              console.error('Execute SELECT logCount error', error);
              setDefaultsDataBase(4, 1);
            });
          }
        };

        /**
         * @param roleId {number}
         * @returns {Promise}
         */
        function getRolePermissionAndSetUserData(roleId) {
          return Utils.$q(function(resolve, reject) {
            AppAdminRolesService.getRolePermissions(roleId).then(function(resources) {
              //console.log("Updating role/permissions...");
              //console.log("Permissions",resources);

              Utils.removeLastItemIfHasNoAttribute(resources, 'codeName');

              /**@type {string[]}*/
              var PERMISSIONS = [];
              resources.forEach(function(permission) {
                PERMISSIONS.push(permission.codeName);
              });

              //console.log("PERMISSIONS",PERMISSIONS);
              UserService.set_USER_PERMISSIONS(PERMISSIONS);

              resolve(true)
            }, function(error) {
              console.error("getRolePermissions", error);
              reject(error)
            })
          })
        }
      // END ZONE FOR DIRECT LOGIN
      
      // ZONE FOR FACEBOOK LOGIN/SIGN IN - BALA
        function fbLoginSuccess(response) { //CALLBACK FROM FB CONNECT
          if (!response.authResponse) {
            fbLoginError("Cannot find the authResponse");
            return;
          }
          Utils.loading.show(Utils.translate('LOGIN.LOGGING_IN'));
          var authResponse = response.authResponse;
          getFacebookProfileInfo(authResponse).then(function(profileInfo) {
            var p = {
              authResponse: authResponse,
              userID: profileInfo.id,
              name: profileInfo.name,
              firstName: profileInfo.first_name,
              lastName: profileInfo.last_name,
              email: profileInfo.email,
              pictureSmall: "https://graph.facebook.com/" + authResponse.userID + "/picture?type=small",
              pictureNormal: "https://graph.facebook.com/" + authResponse.userID + "/picture?type=normal",
              pictureLarge: "https://graph.facebook.com/" + authResponse.userID + "/picture?type=large"
            };
            if (profileInfo.hometown)
              p.city = profileInfo.hometown.name;

            UserServiceFb.setUser(p);
            verifyAge();
          }, function(fail) {
            showErrorAndClean(Utils.translate('ERROR.FACEBOOK_ERR01'), 1, 0);
            console.error('profile info fail', fail);
          });
        }

        function fbLoginError(error) { //ERROR CALLBACK FROM FB CONNECT
          if (error.errorCode == "4201") {
            showErrorAndClean(Utils.translate('ERROR.FACEBOOK_ERR07'), 1, 0);
          } else {
            showErrorAndClean(Utils.translate('ERROR.FACEBOOK_ERR02'), 1, 0);
          }
        }

        function getFacebookProfileInfo(authResponse) { //GET USER INFO FROM THE CONNECT
          var info = $q.defer();
          facebookConnectPlugin.api('/me?fields=id,email,name,first_name,last_name&access_token=' + authResponse.accessToken, null,
            function(response) {
              info.resolve(response);
            },
            function(response) {
              info.reject(response);
            }
          );
          return info.promise;
        }
        
        $scope.facebookSignIn = function() { //CONNECT WITH FB ACCOUNT
          $scope.ErrorMessage = '';
          Utils.loading.show(Utils.translate('LOGIN.LOGGING_IN'));
          facebookConnectPlugin.getLoginStatus(function(response) {
            /*STATUS AVALIBLE
             *@connected user logged into FB and have authorized the app
             *@not_authorized the user is logged into FB but has not authorized the app
             *FB permissions here: https://developers.facebook.com/docs/facebook-login/permissions
             */
            if (response.status == 'connected') {
              var user = UserServiceFb.getUser('facebook');
              //we look for stored FB data in LS but if the info is incomplete we ask again for it
              if (!user.userID) {
                getFacebookProfileInfo(response.authResponse).then(function(profileInfo) {
                  var p = {
                    authResponse: response.authResponse,
                    userID: profileInfo.id,
                    name: profileInfo.name,
                    firstName: profileInfo.first_name,
                    lastName: profileInfo.last_name,
                    email: profileInfo.email,
                    pictureSmall: "https://graph.facebook.com/" + response.authResponse.userID + "/picture?type=small",
                    pictureNormal: "https://graph.facebook.com/" + response.authResponse.userID + "/picture?type=normal",
                    pictureLarge: "https://graph.facebook.com/" + response.authResponse.userID + "/picture?type=large"
                  };

                  if (profileInfo.hometown)
                    p.city = profileInfo.hometown.name;

                  UserServiceFb.setUser(p);
                  Auth($scope, AuthService);
                }, function(fail) {
                  // Fail get profile info
                  showErrorAndClean(Utils.translate('ERROR.FACEBOOK_ERR01'), 0, 0);
                  console.error('profile info fail', fail);
                });
              } else {
                //Se tienen ya los datos de usuario de Fb
                verifyAge();
              }
            } else if (response.status == 'authorization_expired') {
              //At this moment the user is logged into FB but need to reddo all the flow to get new authorization
              //manually make her/him do something before ask again for permission
              facebookConnectPlugin.login(['public_profile', 'email'], fbLoginSuccess, fbLoginError);
            } else if (response.status == 'not_authorized') {
              //Not authorized show again loginFB to ask about the authorization
              facebookConnectPlugin.login(['public_profile', 'email'], fbLoginSuccess, fbLoginError);
            } else {
              //user isn't logged or hasn't logged out properly or other thing so we must ask again for login
              //facebookConnectPlugin.login(['public_profile', 'email'/*, 'user_friends', 'user_birthday', 'user_hometown'*/], fbLoginSuccess, fbLoginError);
              facebookConnectPlugin.login(['public_profile', 'email'], fbLoginSuccess, fbLoginError);
            }
          });
        };

        function verifyAge() { // CHECK IF FB BRINGS BIRTHDAY
          $scope.userFb = UserServiceFb.getUser();
          var userFbBirth = $scope.userFb.birthday;
          if (userFbBirth !== null && userFbBirth !== undefined) {
            var userMonth = userFbBirth.split('/')[0];
            var userDay = userFbBirth.split('/')[1];
            var userYear = userFbBirth.split('/')[2];
            var currentTime = new Date();
            var todayMonth = currentTime.getMonth();
            var todayYear = currentTime.getFullYear();
            var todayDay = currentTime.getDate();
            var userAge = todayYear - userYear;
            if (todayMonth < userMonth - 1) {
              userAge--;
            }
            if (userMonth - 1 == todayMonth && todayDay < userDay) {
              userAge--;
            }
            if (userAge <= 13) {
              showErrorAndClean(Utils.translate('ERROR.FACEBOOK_AGE_ERR'), 1, 0);
            } else {
              $scope.realAge = userAge;
            }
          } else {
            $scope.realAge = 0;
          }
          Auth($scope, AuthService);
        };
      // ZONE FOR FACEBOOK LOGIN/SIGN IN - END

      // ZONE TO CONTINUE 3RD PARTY LOGIN/SIGIN - BALA
        function Auth($scope, AuthService) { // LOGIN SVEN TO CALL WS WITHOUT USER
          Utils.loading.show();
          var username = 'sven';
          var password = 'm<}WU6ZEFvKqks-"';
          AuthService.login(username, password).then(
            function success() {
              switch ($scope.typeAccess) {
                case 1: //Facebook sign in - log in
                  findByWebUserId();
                break;
                case 2: 
                  findByWebUserIdApple();
                break;
              } 
            },
            function(error) {
              console.error("Error login with sven", error);
              showErrorAndClean(Utils.translate('ERROR.FACEBOOK_ERR03'), 1, 0);
            }
          );
        };

        function findByWebUserId() { // CHECK IF WEBUSERID IS ALREADY IN SERVER
          var userFace = UserServiceFb.getUser('facebook');
          SignInService.findByWebUserId().get({ "webUserid": userFace.userID }, function(data) {
            if (data.length > 0) {
              window.localStorage.setItem("simpleUserInstanceId", data[0].userId.href.split('/')[6]);
              window.localStorage.setItem("userNameWeb", data[0].userName);
              AuthService.logout();
              console.log("first log out sven");
              AuthLog(AuthService, data[0].userName, userFace.userID, '1'); //Usuario ya existente procede a logeo
            } else {
              //terms(); //Usuario nuevo, se verifican datos
              validateEmailThirdParty();
              //$scope.showAditionalInfoForm();
            }
          }, function(err) {
            Utils.loading.hide();
            showErrorAndClean(Utils.translate('ERROR.FACEBOOK_ERR04'), 1, 1);
            console.error('Error tipo findByWebUserId', err);
          });
        }

        function terms() { // SHOW TERMS TO USER
          Utils.loading.hide();
          $scope.checkTerms = true;
        }

        $scope.cancelTerms = function() { // CANCEL TERMS
          AuthService.logout();
          $scope.checkTerms = false;
        };

        $scope.showAditionalInfoForm = function() { // SHOW ZONE FOR ADD INFORMATION MISSING
          $scope.checkTerms = false;
          $scope.betweenProcess = false;
          Utils.loading.hide();
          $scope.checkTerms = false;
          var userData = null;
          userData = UserServiceFb.getUser('facebook');
          userData.isAppleLogin = false;
          userData.age = parseInt($scope.realAge) || 0;
          //console.log("userData", userData);
          $scope.userMembership = "";
          if($scope.emailGivenByUser) {
            if($scope.emailGivenByUser.length > 1)
               userData.email = $scope.emailGivenByUser;
          }
          Utils.modal.show({
            templateUrl: 'templates/Login/aditionalInfoForm.html',
            locals: {
              userData: userData
            },
            controller: function($scope, $mdDialog, locals, ImageService2, $rootScope, FileService2, $ionicActionSheet, $jrCrop, UserService, $state) {
              $scope.userData = locals.userData;
              $scope.data = {};
                $scope.data = $scope.userData;
                $scope.data.selectedYear = 0;
                $scope.data.yearList = [];
                $scope.data.errorBirthday = false;
                $scope.data.finalDate = null;
                $scope.data.membership = null;
                $scope.data.needMembership = false;
                $scope.data.birthday = new Date();
                $scope.data.city = '';
              var isIOS = ionic.Platform.isIOS();
              $scope.validate = {};
              $scope.pivot = JSON.parse(window.localStorage.getItem('AppsPerzonalized'));
              $scope.methods = {};

              //CHECK INFO FROM FB TO SHOW HIDE ELEMENTS - BALA 
                if($scope.data.firstName === '' || $scope.data.firstName === null || $scope.data.firstName === undefined)
                  $scope.validate.FN = true;
                if($scope.data.lastName === '' || $scope.data.lastName === null || $scope.data.lastName === undefined)
                  $scope.validate.LN = true;
                if($scope.data.email === '' || $scope.data.email === null || $scope.data.email === undefined)
                  $scope.validate.EMAIL = true;
                if($scope.data.name === '' || $scope.data.name === null || $scope.data.name === undefined)
                  $scope.validate.FBNAME = true;
              //CHECK INFO FROM FB TO SHOW HIDE ELEMENTS - END
              
              //BALA NEW QUESTIONS ONBOARDING
                $scope.data.usingDate = true;
                $scope.data.usingCity = true;
                $scope.data.extraQuestions = false;
                $scope.data.firstQuestion = "";
                $scope.data.secondQuestion = [];
                $scope.data.thirdQuestion = [];
                $scope.data.fourthQuestion = [];
                $scope.data.secondSelected = "";
                $scope.data.thirdSelected = "";
                $scope.data.fourthSelected = "";
                $scope.data.answersList = [];
                $scope.data.questionList = [];
                $scope.data.passCode = "";
                $scope.prepareQuestions = function() {
                  //true
                  var realValue = true;
                  var realText = "TRUE";
                  for (var i = 0; i < 2; i++) {
                    //1
                    $scope.data.secondQuestion.push({
                      value: realValue,
                      text: Utils.translate("LOGIN." + realText)
                    })
                    //2
                    $scope.data.thirdQuestion.push({
                      value: realValue,
                      text: Utils.translate("LOGIN." + realText)
                    })
                    //3
                    $scope.data.fourthQuestion.push({
                      value: realValue,
                      text: Utils.translate("LOGIN." + realText)
                    })
                    realValue = false;
                    realText = "FALSE"
                  }
                  $scope.data.secondSelected = $scope.data.secondQuestion[0];
                  $scope.data.thirdSelected = $scope.data.thirdQuestion[0];
                  $scope.data.fourthSelected = $scope.data.fourthQuestion[0];
                };
                $scope.prepareQuestions();
              //END BALA NEW QUESTIONS ONBOARDING

              //FOR NEW BIRTHDAY FORM
                $scope.initDates = function() {
                  for (var i = 2010; i >= 1920; i--) {
                    $scope.data.yearList.push({
                      id: i,
                      text: "" + i
                    })
                  }
                  $scope.data.selectedYear = $scope.data.yearList[0];
                }
                $scope.initDates();

                $scope.selectYear = function(year) {
                  $scope.data.isDateEmpty = true;
                }
              //ENDFUNCTIONS NEW DATE

              //GET CITIES - BALA
                UserService.getCities().$promise.then(function(resp) {
                  Utils.removeLastItemIfHasNoAttribute(resp, 'idCity');
                  resp.unshift({ idCity: 0, city: Utils.translate("SIGNUP.SELECT_CITY") });
                  resp.push({ idCity: -1, city: Utils.translate("SIGNUP.OTHER") });
                  $scope.data.cities = resp;
                  $scope.data.selectedCity = resp[0];
                }, function(error) {
                  console.error("get Cities", error);
                });
              //GET CITIES - END
              //SELECT CITY - BALA
                $scope.selectCity = function(option) {
                  if ([-1, 0].includes(option.idCity)) {
                    $scope.data.city = '';
                    $scope.data.addCityToCatalog = true;
                  } else {
                    $scope.data.city = option.city;
                    $scope.data.addCityToCatalog = false;
                  }
                  Utils.$timeout(function() {
                    $scope.$apply()
                  }, 10)
                };
              //SELECT CITY - END

              //CHECK IF APP USES MEMBERSHIP/INVITATION CODE AND ITS VALIDATION
                $scope.data.needMembership = $scope.pivot.showInvitationCode ? true : false;
                $scope.data.openTL = $scope.pivot.TypeOfOnboarding === 0 ? 'O' : 'C';
                $scope.data.showMsgCode = false;
                $scope.data.codeInvalid = false;
                $scope.data.errCode = Utils.translate('SIGNUP.INVITATION_ERR');
                $scope.data.validCode = Utils.translate('SIGNUP.INVITATION_PASS');
                $scope.validateCode = function () {
                  var correctCode = false;
                  if($scope.data.passCode.length === 0) {
                    $scope.data.showMsgCode = null;
                    return false;
                  }
                  AddSubscriptionService.validatePassCode({
                    code: $scope.data.passCode.toUpperCase()
                  }).$promise.then( function (response) {
                    console.log("got", response);
                    $scope.data.showMsgCode = true;
                    if(response.result.value)
                      $scope.data.codeInvalid = false;
                    else
                      $scope.data.codeInvalid = true;
                  }, function (error) {
                    console.error("something went wrong");
                  })
                }
              //END CHECK IF APP USES MEMBERSHIP/INVITATION CODE AND ITS VALIDATION

              //CHECK IF NEEDED INVITATION CODE - BALA
                $scope.data.needredeemableCode = $scope.pivot.showredeemableCode ? true : false;
              //CHECK IF NEEDED INVITATION CODE - END

              //GET AGE AND DATE - BALA
                $scope.selectAge = function(option) {
                  $scope.data.age = option;
                  Utils.$timeout(function() {
                    $scope.$apply()
                  }, 10)
                };
              //GET AGE AND DATE - END

              //VALIDATE EMAIL BEFORE CLOSING MODAL - BALA
                $scope.chkEmail = function () {
                  //$scope.data.email
                  UserService.validateUserEmail().get({ email: $scope.data.email }, function(response) {
                    if (response.length > 1) { //
                      //CHECK BEFORE IF MAIL USED FOR ANOTHER TYPE OF SIGN IN - BALA
                        if(response[0].passwordRecoveryAnswer === "Yes") { //FbUser works for both Apple/FB
                          switch (response[0].passwordRecoveryQuestion) {
                            case "¿Access with Facebook?": //Facebook sign in - log in
                              Utils.alert.show(Utils.translate('LOGIN.VALIDATE_EMAIL_01') + $scope.data.email + Utils.translate('LOGIN.VALIDATE_EMAIL_02')).then(function(res) {
                                showErrorAndClean(Utils.translate('LOGIN.EMAIL_USED'), 1, 1);
                              });
                            break;
                            case "¿Access with Apple?": //Apple sign in - log in
                              Utils.alert.show(Utils.translate('LOGIN.VALIDATE_EMAIL_01') + $scope.data.email + Utils.translate('LOGIN.VALIDATE_EMAIL_03')).then(function(res) {
                                showErrorAndClean(Utils.translate('LOGIN.EMAIL_USED'), 1, 1);
                              });
                            break;
                          }
                        } else { //the email is used but not for Apple/FB login
                          var redirectPopUp = $ionicPopup.confirm({
                            cssClass: 'popupClass',
                            title: $filter('translate')('LOGIN.EMAIL_USED'),
                            template: $filter('translate')('LOGIN.VALIDATE_EMAIL_01') + $scope.data.email + $filter('translate')('LOGIN.VALIDATE_EMAIL_04') + response[0].userName,
                            cancelText: $filter('translate')('LOGIN.REDIRECT_FORGOTPASS_01'),
                            okType: 'button-assertive',
                            okText: $filter('translate')('LOGIN.REDIRECT_LOGIN_01')
                          });
                          redirectPopUp.then(function (res) {
                            if (res) {
                              $scope.cancel();
                            } else {
                              $scope.cancel();
                              Utils.$timeout(function() {
                                $state.go('forgotPassword', {}, { reload: true });
                              }, 100)
                            }
                          });
                        }
                      //CHECK BEFORE IF MAIL USED FOR ANOTHER TYPE OF SIGN IN - END
                    } else {
                      $scope.ok();
                    }
                  }, function(error) {
                    $scope.ok();
                  })
                }
              //VALIDATE EMAIL BEFORE CLOSING MODAL - END

              //CLOSE MODAL - BALA
                $scope.ok = function() {
                  //BALA NEW QUESTIONS ONBOARDING
                  if ($scope.data.extraQuestions) {
                    //add them to one ṕlace
                    $scope.data.answersList.push($scope.data.firstQuestion);
                    $scope.data.answersList.push($scope.data.secondSelected.value);
                    $scope.data.answersList.push($scope.data.thirdSelected.value);
                    $scope.data.answersList.push($scope.data.fourthSelected.value);
                    //and the questons
                    $scope.data.questionList.push(Utils.translate("LOGIN.ASK_EXTRA_QUESTION01"));
                    $scope.data.questionList.push(Utils.translate("LOGIN.ASK_EXTRA_QUESTION02"));
                    $scope.data.questionList.push(Utils.translate("LOGIN.ASK_EXTRA_QUESTION03"));
                    $scope.data.questionList.push(Utils.translate("LOGIN.ASK_EXTRA_QUESTION04"));
                  }
                  //IF CODE IS INVALID CLEAN WHEN USER TRY TO CONTINUE
                  if($scope.data.codeInvalid) {
                    $scope.data.passCode = "";
                  }

                  //END BALA NEW QUESTIONS ONBOARDING
                  $scope.data.finalDate = $scope.data.selectedYear.text + "-01-01";
                  $mdDialog.hide($scope.data);
                };

                $scope.cancel = function() {
                  $mdDialog.cancel()
                };
              //CLOSE MODAL - END
            }
          }).then(function(info) {
            userData.birthday = info.finalDate;
            userData.emptyBirthday = false;
            //CHECK MEMBERSHIP
              userData.userMembership = null;
              userData.needMembership = null;
              userData.openTL = info.openTL;
              if(info.needMembership) {
                if(info.passCode) {
                  userData.userMembership = info.passCode;
                  userData.needMembership = info.needMembership;
                }
              }
            //END CHECK MEMBERSHIP

            if (info.firstName)
              userData.firstName = info.firstName;

            if (info.lastName)
              userData.lastName = info.lastName;

            if (info.city)
              userData.city = info.city;
            userData.addCityToCatalog = info.addCityToCatalog;

            //SECOND CHECK CATALOG
              if (userData.addCityToCatalog) {
                UserService.checkCitiesByCity(
                  userData.city
                ).then(function(response) {
                  Utils.removeLastItemIfHasNoAttribute(response, 'idCity');
                  console.log("success");
                  if (response.length > 0) {
                    console.log("the writen city is already register but not seen");
                    userData.addCityToCatalog = false;
                  } else {
                    console.log("the writen city isn't register");
                  }
                }, function(error) {
                  console.log("Error trying to check city", error);
                });
              }
              if (userData.city == null || userData.city == undefined)
                userData.city = null;
            //END SECOND CHECK CATALOG

            if (info.facebookUsername)
              userData.facebookUsername = info.facebookUsername;
            else
              userData.facebookUsername = info.name;

            //BALA NEW QUESTIONS ONBOARDING
              if (info.extraQuestions) {
                $scope.data.extraQuestions = true;
                $scope.data.extraAnswersList = info.answersList;
                $scope.data.extraQuestionsList = info.questionList;
              } else {
                $scope.data.extraQuestions = false;
              }
            //END BALA NEW QUESTIONS ONBOARDING

            info.email = info.email || userData.email;
            userData.email = info.email;
            addusersignup(userData);
          });
        };

        $scope.showAditionalInfoFormApple = function () {
          $scope.checkTerms = false;
          $scope.betweenProcess = false;
          Utils.loading.hide();
          $scope.checkTerms = false;
          var userData = null;
          userData = $scope.appleUserInfo;
          //userData = UserServiceFb.getUser('facebook');
          userData.firstName = $scope.appleUserInfo ? $scope.appleUserInfo.fullName.givenName : 'NameApple';
          userData.lastName = $scope.appleUserInfo ? $scope.appleUserInfo.fullName.familyName : 'LastNameApple';
          userData.email = $scope.appleUserInfo ? $scope.appleUserInfo.email  : '';
          userData.isAppleLogin = true;
          $scope.userMembership = "";
          if($scope.emailGivenByUser){
            if($scope.emailGivenByUser.length > 1)
               userData.email = $scope.emailGivenByUser;
          }
          var pivot = JSON.parse(window.localStorage.getItem('AppsPerzonalized'));
          if(pivot.bypassApple) {
          	//PREPARE ALL USERDATA
          	userData.birthday = "1980-01-01";
          	userData.emptyBirthday = false;
          	userData.userMembership = " ";
          	userData.needMembership = pivot.showInvitationCode ? true : false;
          	userData.city = "México";
          	userData.facebookUsername = "AppleLogin";
          	userData.appleInfo = $scope.appleUserInfo;
            userData.imageApple = "";
            userData.openTL = pivot.TypeOfOnboarding === 0 ? 'O' : 'C';;
            addusersignup(userData);
          } else {
            userData.firstName = userData.firstName === "NameApple" ? null : userData.firstName;
            userData.lastName = userData.lastName === "LastNameApple" ? null : userData.lastName;
          	Utils.modal.show({
	            templateUrl: 'templates/Login/aditionalInfoFormApple.html',
	            locals: {
	              userData: userData
	            },
	            controller: function($scope, $mdDialog, locals, ImageService2, $rootScope, FileService2, $ionicActionSheet, $jrCrop) {
	              $scope.userData = locals.userData;
	              $scope.data = {};
	                $scope.data = $scope.userData;
	                $scope.data.selectedYear = 0;
	                $scope.data.yearList = [];
	                $scope.data.errorBirthday = false;
	                $scope.data.finalDate = null;
	                $scope.data.membership = null;
	                $scope.data.needMembership = false;
	                $scope.data.birthday = new Date();
	                $scope.data.city = '';
	                $scope.data.pictures = [];
	              var isIOS = ionic.Platform.isIOS();
	              $scope.validate = {};
	              $scope.pivot = JSON.parse(window.localStorage.getItem('AppsPerzonalized'));
	              $scope.methods = {};

	              //CHECK INFO FROM FB TO SHOW HIDE ELEMENTS - BALA 
	                if($scope.data.firstName === '' || $scope.data.firstName === null || $scope.data.firstName === undefined)
	                  $scope.validate.FN = true;
	                if($scope.data.lastName === '' || $scope.data.lastName === null || $scope.data.lastName === undefined)
	                  $scope.validate.LN = true;
	                if($scope.data.email === '' || $scope.data.email === null || $scope.data.email === undefined)
	                  $scope.validate.EMAIL = true;
	                if($scope.data.name === '' || $scope.data.name === null || $scope.data.name === undefined)
	                  $scope.validate.FBNAME = true;
	              //CHECK INFO FROM FB TO SHOW HIDE ELEMENTS - END

	              //BALA NEW QUESTIONS ONBOARDING
	                $scope.data.usingDate = true;
	                $scope.data.usingCity = true;
	                $scope.data.extraQuestions = false;
	                $scope.data.firstQuestion = "";
	                $scope.data.secondQuestion = [];
	                $scope.data.thirdQuestion = [];
	                $scope.data.fourthQuestion = [];
	                $scope.data.secondSelected = "";
	                $scope.data.thirdSelected = "";
	                $scope.data.fourthSelected = "";
	                $scope.data.answersList = [];
	                $scope.data.questionList = [];
	                $scope.data.passCode = "";
	                $scope.prepareQuestions = function() {
	                  //true
	                  var realValue = true;
	                  var realText = "TRUE";
	                  for (var i = 0; i < 2; i++) {
	                    //1
	                    $scope.data.secondQuestion.push({
	                      value: realValue,
	                      text: Utils.translate("LOGIN." + realText)
	                    })
	                    //2
	                    $scope.data.thirdQuestion.push({
	                      value: realValue,
	                      text: Utils.translate("LOGIN." + realText)
	                    })
	                    //3
	                    $scope.data.fourthQuestion.push({
	                      value: realValue,
	                      text: Utils.translate("LOGIN." + realText)
	                    })
	                    realValue = false;
	                    realText = "FALSE"
	                  }
	                  $scope.data.secondSelected = $scope.data.secondQuestion[0];
	                  $scope.data.thirdSelected = $scope.data.thirdQuestion[0];
	                  $scope.data.fourthSelected = $scope.data.fourthQuestion[0];
	                };
	                $scope.prepareQuestions();
	              //END BALA NEW QUESTIONS ONBOARDING
	              
	              //FOR NEW BIRTHDAY FORM
	                $scope.initDates = function() {
	                  for (var i = 2010; i >= 1920; i--) {
	                    $scope.data.yearList.push({
	                      id: i,
	                      text: "" + i
	                    })
	                  }
	                  $scope.data.selectedYear = $scope.data.yearList[0];
	                }
	                $scope.initDates();

	                $scope.selectYear = function(year) {
	                  $scope.data.isDateEmpty = true;
	                }
	              //ENDFUNCTIONS NEW DATE

	              //GET CITIES - BALA
	                UserService.getCities().$promise.then(function(resp) {
	                  Utils.removeLastItemIfHasNoAttribute(resp, 'idCity');
	                  resp.unshift({ idCity: 0, city: Utils.translate("SIGNUP.SELECT_CITY") });
	                  resp.push({ idCity: -1, city: Utils.translate("SIGNUP.OTHER") });
	                  $scope.data.cities = resp;
	                  $scope.data.selectedCity = resp[0];
	                }, function(error) {
	                  console.error("get Cities", error);
	                });
	              //GET CITIES - END
	              //SELECT CITY - BALA
	                $scope.selectCity = function(option) {
	                  if ([-1, 0].includes(option.idCity)) {
	                    $scope.data.city = '';
	                    $scope.data.addCityToCatalog = true;
	                  } else {
	                    $scope.data.city = option.city;
	                    $scope.data.addCityToCatalog = false;
	                  }
	                  Utils.$timeout(function() {
	                    $scope.$apply()
	                  }, 10)
	                };
	              //SELECT CITY - END

	              //CHECK IF APP USES MEMBERSHIP/INVITATION CODE AND ITS VALIDATION
	                $scope.data.needMembership = $scope.pivot.showInvitationCode ? true : false;
	                $scope.data.openTL = $scope.pivot.TypeOfOnboarding === 0 ? 'O' : 'C';
	                $scope.data.showMsgCode = false;
	                $scope.data.codeInvalid = false;
	                $scope.data.errCode = Utils.translate('SIGNUP.INVITATION_ERR');
	                $scope.data.validCode = Utils.translate('SIGNUP.INVITATION_PASS');
	                $scope.validateCode = function () {
	                  var correctCode = false;
	                  if($scope.data.passCode.length === 0) {
	                    $scope.data.showMsgCode = null;
	                    return false;
	                  }
	                  AddSubscriptionService.validatePassCode({
	                    code: $scope.data.passCode.toUpperCase()
	                  }).$promise.then( function (response) {
	                    console.log("got", response);
	                    $scope.data.showMsgCode = true;
	                    if(response.result.value)
	                      $scope.data.codeInvalid = false;
	                    else
	                      $scope.data.codeInvalid = true;
	                  }, function (error) {
	                    console.error("something went wrong");
	                  })
	                }
	              //END CHECK IF APP USES MEMBERSHIP/INVITATION CODE AND ITS VALIDATION

	              //CHECK IF NEEDED INVITATION CODE - BALA
	                $scope.data.needredeemableCode = $scope.pivot.showredeemableCode ? true : false;
	              //CHECK IF NEEDED INVITATION CODE - END

	              //GET AGE AND DATE - BALA
	                $scope.selectAge = function(option) {
	                  $scope.data.age = option;
	                  Utils.$timeout(function() {
	                    $scope.$apply()
	                  }, 10)
	                };
	              //GET AGE AND DATE - END

	              //GET PHOTO PROFILE - BALA
	                $scope.methods.addPhoto = function() {
	                  $scope.hideSheet = $ionicActionSheet.show({
	                    buttons: [
	                      { text: 'Take photo' },
	                      { text: 'Photo from library' }
	                    ],
	                    titleText: 'Add photo from',
	                    cancelText: 'Cancel',
	                    buttonClicked: function(index) {
	                      $scope.hideSheet();
	                      var permit = "";
	                      var msg = "";
	                      if (isIOS === true) {
	                        //getPermission(0);
	                        obtainPhoto(index);
	                      } else {
	                        getMultiplePermissions(index);
	                      }
	                    }
	                  });
	                };

	                function getMultiplePermissions(index) {
	                  cordova.plugins.diagnostic.getPermissionsAuthorizationStatus(function(statuses) {
	                    var havePerm = 0;
	                    var deniedPerm = false;
	                    for (var permission in statuses) {
	                      switch (statuses[permission]) {
	                        case cordova.plugins.diagnostic.permissionStatus.GRANTED:
	                          console.log("Permission granted to use " + permission);
	                          havePerm++;
	                          break;
	                        case cordova.plugins.diagnostic.permissionStatus.NOT_REQUESTED:
	                          console.log("Permission to use " + permission + " has not been requested yet");
	                          havePerm--;
	                          break;
	                        case cordova.plugins.diagnostic.permissionStatus.DENIED:
	                          console.log("Permission denied to use " + permission + " - ask again?");
	                          havePerm--;
	                          break;
	                        case cordova.plugins.diagnostic.permissionStatus.DENIED_ALWAYS:
	                          console.log("Permission permanently denied to use " + permission + " - guess we won't be using it then!");
	                          deniedPerm = true;
	                          break;
	                      }
	                    }
	                    if (!deniedPerm) {
	                      if (havePerm == 2) {
	                        //have both permissions granted
	                        obtainPhoto(index);
	                      } else if (havePerm < 2) {
	                        //both or one permission hasn't granted
	                        askMultiplePermissions(index);
	                      }
	                    } else {
	                      Utils.toast.error(Utils.translate('PLUGINS.PERMISSIONS.DENIED_PERMISSION') +
	                        Utils.translate('PLUGINS.PERMISSIONS.TYPE.CAMERA') + ' ' +
	                        Utils.translate('PLUGINS.PERMISSIONS.AND') + ' ' +
	                        Utils.translate('PLUGINS.PERMISSIONS.TYPE.GALLERY') + '. \n' +
	                        Utils.translate('PLUGINS.PERMISSIONS.ALWAYS_DENIED_PERMISSION'));
	                    }
	                  }, function(error) {
	                    console.error("The following error occurred: " + error);
	                  }, [
	                    cordova.plugins.diagnostic.permission.CAMERA,
	                    cordova.plugins.diagnostic.permission.READ_EXTERNAL_STORAGE
	                  ])
	                }

	                function askMultiplePermissions(index) {
	                  cordova.plugins.diagnostic.requestRuntimePermissions(function(statuses) {
	                    var havePerm = 0;
	                    var deniedPerm = false;
	                    for (var permission in statuses) {
	                      switch (statuses[permission]) {
	                        case cordova.plugins.diagnostic.permissionStatus.GRANTED:
	                          console.log("Permission granted to use " + permission);
	                          havePerm++;
	                          break;
	                        case cordova.plugins.diagnostic.permissionStatus.NOT_REQUESTED:
	                          console.log("Permission to use " + permission + " has not been requested yet");
	                          havePerm--;
	                          break;
	                        case cordova.plugins.diagnostic.permissionStatus.DENIED:
	                          console.log("Permission denied to use " + permission + " - ask again?");
	                          havePerm--;
	                          break;
	                        case cordova.plugins.diagnostic.permissionStatus.DENIED_ALWAYS:
	                          console.log("Permission permanently denied to use " + permission + " - guess we won't be using it then!");
	                          deniedPerm = true;
	                          break;
	                      }
	                    }
	                    if (!deniedPerm) {
	                      if (havePerm == 2) {
	                        //have both permissions granted
	                        obtainPhoto(index);
	                      } else if (havePerm < 2) {
	                        //both or one permission hasn't granted
	                        Utils.toast.error(Utils.translate('PLUGINS.PERMISSIONS.DENIED_PERMISSION') +
	                          Utils.translate('PLUGINS.PERMISSIONS.TYPE.CAMERA') + ' ' +
	                          Utils.translate('PLUGINS.PERMISSIONS.AND') + ' ' +
	                          Utils.translate('PLUGINS.PERMISSIONS.TYPE.GALLERY') + '.');
	                      }
	                    } else {
	                      Utils.toast.error(Utils.translate('PLUGINS.PERMISSIONS.DENIED_PERMISSION') +
	                        Utils.translate('PLUGINS.PERMISSIONS.TYPE.CAMERA') + ' ' +
	                        Utils.translate('PLUGINS.PERMISSIONS.AND') + ' ' +
	                        Utils.translate('PLUGINS.PERMISSIONS.TYPE.GALLERY') + '. \n' +
	                        Utils.translate('PLUGINS.PERMISSIONS.ALWAYS_DENIED_PERMISSION'));
	                    }
	                  }, function(error) {
	                    console.error("The following error occurred: " + error);
	                  }, [
	                    cordova.plugins.diagnostic.permission.CAMERA,
	                    cordova.plugins.diagnostic.permission.READ_EXTERNAL_STORAGE
	                  ])
	                }

	                $scope.uploadingPhoto = false;
	                $scope.openCrop = false;

	                function obtainPhoto(index) { //USING NEW PLUGIN MediaPicker
	                  $scope.data.pictures = [];
	                  if (index === 0) { // camera 
	                    ImageService2.saveCameraMediaProfilePhoto(index).then(function() {});
	                  } else { // library
	                    ImageService2.saveAlbumMediaProfilePhoto(index).then(function() {});
	                  }
	                }

	                $rootScope.$on("addedImageB", function() {
	                  showImageUser();
	                })

	                function showImageUser() {
	                  if ($scope.openCrop) {
	                    return true;
	                  }
	                  $scope.openCrop = true;
	                  var img = FileService2.images(); //$scope.data.pictures
	                  var exifTemp = FileService2.exifImage();
	                  if (img.length === 0) {
	                    $timeout(function() {
	                      showImageUser();
	                    }, 1000);
	                  } else {
	                    if ($scope.data.pictures === null || $scope.data.pictures === undefined || $scope.data.pictures.length === 0) {
	                      var opt = {};
	                      if (isIOS === true) {
	                        //prepare IOS
	                        opt = {
	                          url: img[0],
	                          width: 200,
	                          height: 200,
	                          circle: true,
	                          allowRotation: true,
	                          title: 'Usa tus dedos para ajustar la imagen'
	                        }
	                        $jrCrop.crop(opt).then(function(canvas) {
	                          // success!
	                          //$scope.$apply();
	                          $scope.data.pictures[0] = canvas.toDataURL();
	                          $timeout(function() {
	                            $scope.openCrop = false;
	                            $scope.$apply();
	                          }, 0);
	                        }, function(err) {
	                          console.error(err);
	                          $scope.data.pictures[0] = img[0];
	                          $scope.openCrop = false;
	                          $scope.$apply();
	                        });
	                      } else {
	                        var urlToUse = null;
	                        if (img[0].uri) {
	                          urlToUse = img[0].uri;
	                        } else {
	                          urlToUse = img[0];
	                        }
	                        opt = {
	                          url: urlToUse,
	                          width: 200,
	                          height: 200,
	                          circle: true,
	                          allowRotation: true,
	                          title: 'Usa tus dedos para ajustar la imagen'
	                        }
	                        $jrCrop.crop(opt).then(function(canvas) {
	                          // success!
	                          //$scope.$apply();
	                          $scope.data.pictures[0] = canvas.toDataURL();
	                          $timeout(function() {
	                            $scope.openCrop = false;
	                            $scope.$apply();
	                          }, 0);
	                        }, function(err) {
	                          console.error(err);
	                          $scope.data.pictures[0] = img[0];
	                          $scope.openCrop = false;
	                          $scope.$apply();
	                        });
	                      }
	                    } else {
	                      console.log("finish loading");
	                      $scope.openCrop = false;
	                    }
	                  }
	                }
	              //GET PHOTO PROFILE - END

	              //VALIDATE EMAIL BEFORE CLOSING MODAL - BALA
	                $scope.chkEmail = function () {
	                  //$scope.data.email
	                  UserService.validateUserEmail().get({ email: $scope.data.email }, function(response) {
	                    if (response.length > 1) { //
	                      //CHECK BEFORE IF MAIL USED FOR ANOTHER TYPE OF SIGN IN - BALA
	                        if(response[0].passwordRecoveryAnswer === "Yes") { //FbUser works for both Apple/FB
	                          switch (response[0].passwordRecoveryQuestion) {
	                            case "¿Access with Facebook?": //Facebook sign in - log in
	                              Utils.alert.show(Utils.translate('LOGIN.VALIDATE_EMAIL_01') + $scope.data.email + Utils.translate('LOGIN.VALIDATE_EMAIL_02')).then(function(res) {
	                                showErrorAndClean(Utils.translate('LOGIN.EMAIL_USED'), 1, 1);
	                              });
	                            break;
	                            case "¿Access with Apple?": //Apple sign in - log in
	                              Utils.alert.show(Utils.translate('LOGIN.VALIDATE_EMAIL_01') + $scope.data.email + Utils.translate('LOGIN.VALIDATE_EMAIL_03')).then(function(res) {
	                                showErrorAndClean(Utils.translate('LOGIN.EMAIL_USED'), 1, 1);
	                              });
	                            break;
	                          }
	                        } else { //the email is used but not for Apple/FB login
	                          var redirectPopUp = $ionicPopup.confirm({
	                            cssClass: 'popupClass',
	                            title: $filter('translate')('LOGIN.EMAIL_USED'),
	                            template: $filter('translate')('LOGIN.VALIDATE_EMAIL_01') + $scope.data.email + $filter('translate')('LOGIN.VALIDATE_EMAIL_04') + response[0].userName,
	                            cancelText: $filter('translate')('LOGIN.REDIRECT_FORGOTPASS_01'),
	                            okType: 'button-assertive',
	                            okText: $filter('translate')('LOGIN.REDIRECT_LOGIN_01')
	                          });
	                          redirectPopUp.then(function (res) {
	                            if (res) {
	                              $scope.cancel();
	                            } else {
	                              $scope.cancel();
	                              Utils.$timeout(function() {
	                                $state.go('forgotPassword', {}, { reload: true });
	                              }, 100)
	                            }
	                          });
	                        }
	                      //CHECK BEFORE IF MAIL USED FOR ANOTHER TYPE OF SIGN IN - END
	                    } else {
	                      $scope.ok();
	                    }
	                  }, function(error) {
	                    $scope.ok();
	                  })
	                }
	              //VALIDATE EMAIL BEFORE CLOSING MODAL - END

	              //CLOSE MODAL - BALA
	                $scope.ok = function() {
	                  //PASS APPLE INFO
	                  $scope.data.appleInfo = $scope.userData;
	                  $scope.data.imageApple = $scope.data.pictures[0];
	                  //BALA NEW QUESTIONS ONBOARDING
	                  if ($scope.data.extraQuestions) {
	                    //add them to one ṕlace
	                    $scope.data.answersList.push($scope.data.firstQuestion);
	                    $scope.data.answersList.push($scope.data.secondSelected.value);
	                    $scope.data.answersList.push($scope.data.thirdSelected.value);
	                    $scope.data.answersList.push($scope.data.fourthSelected.value);
	                    //and the questons
	                    $scope.data.questionList.push(Utils.translate("LOGIN.ASK_EXTRA_QUESTION01"));
	                    $scope.data.questionList.push(Utils.translate("LOGIN.ASK_EXTRA_QUESTION02"));
	                    $scope.data.questionList.push(Utils.translate("LOGIN.ASK_EXTRA_QUESTION03"));
	                    $scope.data.questionList.push(Utils.translate("LOGIN.ASK_EXTRA_QUESTION04"));
	                  }
	                  //IF CODE IS INVALID CLEAN WHEN USER TRY TO CONTINUE
	                  if($scope.data.codeInvalid) {
	                    $scope.data.passCode = "";
	                  }

	                  //END BALA NEW QUESTIONS ONBOARDING
	                  $scope.data.finalDate = $scope.data.selectedYear.text + "-01-01";
	                  $mdDialog.hide($scope.data);
	                };

	                $scope.cancel = function() {
	                  $mdDialog.cancel()
	                };
	              //CLOSE MODAL - END
	            }
  	        }).then(function(info) {
  	            userData.birthday = info.finalDate;
  	            userData.emptyBirthday = false;
  	            //CHECK MEMBERSHIP
  	              userData.userMembership = null;
  	              userData.needMembership = null;
  	              userData.openTL = info.openTL;
  	              if(info.needMembership) {
  	                if(info.passCode) {
  	                  userData.userMembership = info.passCode;
  	                  userData.needMembership = info.needMembership;
  	                }
  	              }
  	            //END CHECK MEMBERSHIP

  	            if (info.firstName)
  	              userData.firstName = info.firstName;

  	            if (info.lastName)
  	              userData.lastName = info.lastName;

  	            if (info.city)
  	              userData.city = info.city;
  	            userData.addCityToCatalog = info.addCityToCatalog;

  	            //SECOND CHECK CATALOG
  	              if (userData.addCityToCatalog) {
  	                UserService.checkCitiesByCity(
  	                  userData.city
  	                ).then(function(response) {
  	                  Utils.removeLastItemIfHasNoAttribute(response, 'idCity');
  	                  console.log("success");
  	                  if (response.length > 0) {
  	                    console.log("the writen city is already register but not seen");
  	                    userData.addCityToCatalog = false;
  	                  } else {
  	                    console.log("the writen city isn't register");
  	                  }
  	                }, function(error) {
  	                  console.log("Error trying to check city", error);
  	                });
  	              }
  	              if (userData.city == null || userData.city == undefined)
  	                userData.city = null;
  	            //END SECOND CHECK CATALOG

  	            /*if (info.facebookUsername)
  	              userData.facebookUsername = info.facebookUsername;
  	            else
  	              userData.facebookUsername = info.name;*/
  	            userData.facebookUsername = "AppleLogin";
  	            //BALA NEW QUESTIONS ONBOARDING
  	              if (info.extraQuestions) {
  	                $scope.data.extraQuestions = true;
  	                $scope.data.extraAnswersList = info.answersList;
  	                $scope.data.extraQuestionsList = info.questionList;
  	              } else {
  	                $scope.data.extraQuestions = false;
  	              }
  	            //END BALA NEW QUESTIONS ONBOARDING

  	            //PASS APPLE DATA - BALA
  	              if(info.appleInfo) {
  	                userData.appleInfo = info.appleInfo;
  	                userData.imageApple = info.imageApple;
  	              }
  	            //PASS APPLE DATA - END

  	            info.email = info.email || userData.email;
  	            userData.email = info.email;
  	            addusersignup(userData);
  	        });
          }     
        }

        function addusersignup(userData) { // ADD USER WITH 3RD PARTY LOGIN
          console.log("Signing up facebook user", userData);
          var nombres = "";
          var apellidos = "";
          nombres = userData.firstName;
          apellidos = userData.lastName;
          Utils.loading.show(Utils.translate('LOGIN.LOGGING_IN'));
          if (userData.addCityToCatalog) {
            AddUserService.addCityToCatalogWS(userData.city).$promise.then(function() {
              console.log("The city '" + userData.city + "' was added to catalog");
            }, function(error) {
              console.error("addCityToCatalog WS", error);
            })
          }
          //prepare date
          var realBirthday = userData.birthday;
          if (userData.emptyBirthday) {
            var fullYear = userData.birthday.getFullYear();
            var fullMonth = userData.birthday.getMonth() + 1;
            if (fullMonth < '10')
              fullMonth = '0' + fullMonth;
            var fullDay = userData.birthday.getDate();
            if (fullDay < '10')
              fullDay = '0' + fullDay;
            realBirthday = fullYear + '-' + fullMonth + '-' + fullDay;
          }

          var typeAccessSaved = "";
          var questionSaved = "";
          //PREPARE IOS DATA - BALA
          	if(userData.appleInfo){
              userData.userID = userData.username;
              userData.webUserID = userData.appleWebUserID
              $scope.applePhoto = userData.imageApple;
              typeAccessSaved = "Apple"
              questionSaved = "¿Access with Apple?";
          	} else{
              userData.webUserID = userData.userID;
              typeAccessSaved = "Facebook"
              questionSaved = "¿Access with Facebook?";
            }
          //PREPARE IOS DATA - END

          //SignUpService.addUserSignUp().save({
          SignUpService.addUserSignUpv1174().save({
            firstName: { value: nombres }, //{value: nombre[0]},
            middleName: { value: "" }, //{value: nombre[1]},
            lastName: { value: apellidos }, //{value: apellido[0]},
            lastName2: { value: "" }, //{value: apellido[1]},
            webUser: { value: userData.webUserID },
            webUserType: { value: typeAccessSaved },
            username: { value: userData.userID },
            password: { value: userData.userID },
            passwordRepeat: { value: userData.userID },
            email: { value: userData.email },
            city: { value: userData.city },
            facebookUser: { value: userData.facebookUsername || userData.name },
            passwordRecoveryQuestion: { value: questionSaved },
            passwordRecoveryAnswer: { value: "Yes" },
            birthDate: { value: realBirthday }
          }, function(response) {
            $scope.simpleuserinstId = response.result.instanceId;
            $scope.simpleuserId = response.result.members.userId.value;
            var fullnameTemp = ""
            var fullnameTemp = "";
            if(userData.appleInfo)
              fullnameTemp = userData.firstName + " " + userData.lastName;
            else
              fullnameTemp = userData.name
            window.localStorage.setItem("name", fullnameTemp);
            window.localStorage.setItem("firstName", userData.firstName);
            window.localStorage.setItem("lastName", userData.lastName);
            window.localStorage.setItem("applicationUser", response.result.members.applicationUser.value.href);
            var usernameTemp = "";
            if(userData.appleInfo)
              usernameTemp = userData.userID;
            else
              usernameTemp = userData.name
            window.localStorage.setItem("userName", usernameTemp);
            window.localStorage.setItem("userNameWeb", userData.userID);
            window.localStorage.setItem("birthDate", realBirthday);
            window.localStorage.setItem("userEmail", userData.email);
            window.localStorage.setItem("city", userData.city);
            AddSubscription(
              response.result.links[0].href,
              userData.userID,
              userData.userID,
              userData //SEND EVERYTHING
            );
            $scope.webUser = "";
          }, function(err) {
            console.error('Error tipo addUserSignUp', err);
            showErrorAndClean(Utils.translate('ERROR.FACEBOOK_ERR03'), 1, 1);
          });
        }

        function AddSubscription(userRef, username, password, fullData ) { // ADD SUBSCRIPTION TO THAT USER
          var nms = fullData.needMembership;
          var otl = fullData.openTL;
          var ums = " ";
          if(fullData.userMembership === null || fullData.userMembership === undefined) {
            ums = " ";
          } else {
            ums = fullData.userMembership
          }
          AddSubscriptionService.addSubscriptionv201().save({
            user: {
              value: {
                href: userRef
              }
            },
            onBoarding: {
              value: otl
            },
            code: {
              value: ums.toUpperCase()
            }
          }, function success (response) {
            $scope.privateAcc = response.result.members.privateAccount.value;
            $scope.usersubsid = response.result.title.substr(response.result.title.lastIndexOf("-") + 1).replace(",", "");
            $scope.usersubinstid = response.result.instanceId;
            $scope.useGetName = response.result.members.name.value;
            $scope.rolID = response.result.members.role.value.href;
            $scope.accountStatus = response.result.members.accountStatus.value;
            if (response.result.members.userBio.value !== null) {
              $scope.userBio = response.result.members.userBio.value;
            } else {
              $scope.userBio = Utils.translate('GLOBAL.BIOGRAPHY');
            }
            $scope.newUserSubs = response.result.members.userSubscriptionId.value;
            var generatedSubs = AddSubscriptionService.generateSubscriptionv200({
              userSubs: $scope.newUserSubs 
            }).$promise.then( function success(response) {
              console.log("done");
            }, function error(data) {
              if (data && (data.status === 504 || data.status === -1)) {
                console.log("We don't care");
              } else {
                console.log("fallo en cliente");
              }
            })
            AuthService.logout();
            console.log("first log out sven");
            AuthLog(AuthService, username, password, '0');
          }, function error(mistakeData) {
            showErrorAndClean(Utils.translate('ERROR.FACEBOOK_ERR03'), 1, 1);
          })
        }

        function AuthLog(AuthService, username, password, news) { // LOGIN WITH USER OR NEW USER
          AuthService.logout();
          console.log("second log out sven");
          AuthService.login(username.toUpperCase(), password).then(function success() {
            //console.log("***AuthService.login()")
            if (news == '1') {
              //console.log("***news == 1")
              FindUserSubs();
            } else {
              window.localStorage.setItem("ownPrivate", $scope.privateAcc);
              window.localStorage.setItem("simpleUserId", $scope.simpleuserId);
              window.localStorage.setItem("simpleUserInstanceId", $scope.simpleuserinstId);
              window.localStorage.setItem("userSubscriptionId", $scope.usersubsid);
              window.localStorage.setItem("userSubscriptionHref", ApiEndPoint.url + "restful/objects/simple.UserSubscription/" + $scope.usersubinstid);
              window.localStorage.setItem("userSubscriptionInstanceId", $scope.usersubinstid);
              window.localStorage.setItem("userName", $scope.useGetName);
              window.localStorage.setItem("userBiography", $scope.userBio);
              DBServices.execute("SELECT * FROM userSession").then(
                function(dbResp) {
                  var columns = dbResp.extractItems();
                  if (columns.length > 0) {
                    DBServices.execute("UPDATE userSession set userSubsId = ?, userSubsInstId = ?, userName = ?, onBoard = ? WHERE userSubsId = ?",
                      [
                        $scope.usersubsid,
                        $scope.usersubinstid,
                        $scope.useGetName,
                        "yes",
                        $scope.usersubsid
                      ]).then(function(updateResp) {}, function(updateError) {})
                  } else {
                    DBServices.execute("INSERT INTO userSession values(?,?,?,?)",
                      [
                        $scope.usersubsid,
                        $scope.usersubinstid,
                        $scope.useGetName,
                        "yes"
                      ]).then(function(insertResp) {}, function(insertError) {})
                  }
                },
                function(errorDb) {}
              );

              if($scope.isAppleUser){
              	if($scope.applePhoto.length > 0)
                  blobPhotoApple();
				        else{
                  updateProfilePicture({
  		                photoSmallKey: "defaultProfile.png",
  		                photoNormalKey: "defaultProfile.png",
  		                photoLargeKey: "defaultProfile.png"
  		            }).then(function() {
  		                
  		            }, function(error) {
  		                reject(error)
  		            })
				        }
              } else
              	BlobPhoto();

              /*if (redeemableCode) {
                console.log("Redeeming code...");
                UserService.redeemCodeWS({
                  userSubscriptionId: Utils.getLastUrlComponent(ApiEndPoint.url + "restful/objects/simple.UserSubscription/" + $scope.simpleuserId),
                  code: redeemableCode
                }).$promise.then(function () {
                  console.log("-- OK redeemCode");
                }, function (error) {
                  console.error("-- redeemCode", error);
                })
              }*/
            }
          }, function(response ) {
            showErrorAndClean(Utils.translate('ERROR.FACEBOOK_ERR03'), 1, 1);
            $scope.error = "Wrong user or pass";
          });
        }

        function FindUserSubs() { // FIND SUBSCRIPTION FOR THE USER LOGGED
          if($scope.isAppleUser) {
          	var userFace = $scope.appleUserInfo;
          	userFace.userID = $scope.appleUserInfo.appleWebUserID;
          	window.localStorage.setItem("userEmail", $scope.appleUserInfo.email);
          } else {
          	var userFace = UserServiceFb.getUser('facebook');
          	window.localStorage.setItem("userEmail", userFace.email);
          }
          
          FindUserSubscriptionbyWebUser.findUserSubscription().get({ "webUser": userFace.userID }, function(data) {
            if (data.length > 0) {
              var accountStatus = data[0].accountStatus;
              //console.log("***accountStatus:"+accountStatus);
              if (accountStatus == "Canceled") {
                AuthService.logout();
                Utils.loading.hide();
                userCanceledFB();
              } else if (accountStatus === "Banned") {
                Utils.loading.hide();
                Utils.alert.show(Utils.translate('LOGIN.USER_BANNED_MSG'));
                AuthService.logout();
                var tempPers = window.localStorage.getItem('AppsPerzonalized');
                window.localStorage.clear();
                window.localStorage.setItem("AppsPerzonalized", tempPers);
                window.localStorage.setItem("onboardingComplete", "yes");
                facebookConnectPlugin.logout(function() {}, function() {});
              } else if (accountStatus === "Blocked") {
                Utils.loading.hide();
                Utils.alert.show(Utils.translate('LOGIN.USER_BLOCKED_MSG'));
                AuthService.logout();
                var tempPers = window.localStorage.getItem('AppsPerzonalized');
                window.localStorage.clear();
                window.localStorage.setItem("AppsPerzonalized", tempPers);
                window.localStorage.setItem("onboardingComplete", "yes");
                facebookConnectPlugin.logout(function() {}, function() {});
              } else if (accountStatus !== "Active") {
                Utils.loading.hide();
                Utils.alert.show(Utils.translate("LOGIN.UNKNOWN_ACCOUNT_STATUS") + "<br>STATUS: " + accountStatus);
                AuthService.logout();
                var tempPers = window.localStorage.getItem('AppsPerzonalized');
                window.localStorage.clear();
                window.localStorage.setItem("AppsPerzonalized", tempPers);
                window.localStorage.setItem("onboardingComplete", "yes");
                facebookConnectPlugin.logout(function() {}, function() {});
              } else {
                window.localStorage.setItem("ownPrivate", data[0].privateAccount);
                window.localStorage.setItem("name", data[0].name);
                window.localStorage.setItem("firstName", data[0].firstName);
                window.localStorage.setItem("lastName", data[0].lastName);
                window.localStorage.setItem("simpleUserId", data[0].userId);
                window.localStorage.setItem("userSubscriptionId", data[0].userSubscriptionId);
                window.localStorage.setItem("userSubscriptionHref", data[0].userSubscription.href);
                window.localStorage.setItem("userSubscriptionInstanceId", data[0].userSubscription.href.split('/')[6]);
                window.localStorage.setItem("birthDate", data[0].birthDate);

                //zone for update legal version from user
                window.localStorage.setItem('legalVer', data[0].termsAndConditionsVersion)

                //window.localStorage.setItem("userAge", response[0]); 
                DBServices.execute("SELECT * FROM userSession").then(
                  function(dbResp) {
                    var columns = dbResp.extractItems();
                    if (columns.length > 0) {
                      DBServices.execute("UPDATE userSession set userSubsId = ?, userSubsInstId = ?, userName = ?, onBoard = ? WHERE userSubsId = ?",
                        [
                          data[0].userSubscriptionId,
                          data[0].userSubscription.href.split('/')[6],
                          data[0].name,
                          "yes",
                          data[0].userSubscriptionId
                        ]).then(function(updateResp) {}, function(updateError) {})
                    } else {
                      DBServices.execute("INSERT INTO userSession values(?,?,?,?)",
                        [
                          data[0].userSubscriptionId,
                          data[0].userSubscription.href.split('/')[6],
                          data[0].name,
                          "yes"
                        ]).then(function(insertResp) {}, function(insertError) {})
                    }
                  },
                  function(errorDb) {}
                );
                $scope.rolID = data[0].role.href;
                //getBackgroundPicture
                changeProfilePictureService.getBackgroundPictureFromId({
                  userId: data[0].userSubscription.href.split('/')[6]
                }).then(function success(response) {
                  console.log("get");
                  if (!response.result) {} else {
                    window.localStorage.setItem("bkgMyProfile", response.result.value);
                  }
                }, function(response) {
                  console.log("findFriendBackGround", response);
                });

                if (data[0].profilePicture !== null) {
                  window.localStorage.setItem("photoProfileBlob", 'data:image/jpeg;base64,' + data[0].profilePicture.split(':')[2]);
                }
                if (data[0].profilePictureUrl !== null) {
                  //profilePictureUrl
                  window.localStorage.setItem("photoProfileBlob", data[0].profilePictureUrl);
                }
                window.localStorage.setItem("userName", data[0].name);
                window.localStorage.setItem("applicationUser", data[0].applicationUser.href);

                if (data[0].userBio !== null) {
                  window.localStorage.setItem("userBiography", data[0].userBio);
                } else {
                  window.localStorage.setItem("userBiography", Utils.translate('GLOBAL.BIO'));
                }

                UserService.findUserSubscriptionById().get({
                  "x-isis-querystring": {
                    userSubscriptionId: { value: data[0].userSubscriptionId.toString() }
                  }
                }).$promise.then(function(resp) {
                  Utils.removeLastItemIfHasNoAttribute(resp, 'role');

                  if (resp[0].role) {

                    var newRoleId = Utils.getLastUrlComponent(resp[0].role.href);
                    if (!newRoleId) newRoleId = 2; //<--regular user
                    var currentRoleId = window.localStorage.getItem('userRoleId');

                    if (currentRoleId !== newRoleId) {
                      window.localStorage.setItem('userRoleId', newRoleId);
                      //console.log("New role detected");
                    }

                    getRolePermissionAndSetUserData(+Utils.getLastUrlComponent(resp[0].role.href)).then(function(boolResp) {
                      //nothing to do...
                    }, function(error) {
                      console.error("getRolePermissions", error);
                      //window.localStorage.clear();
                      Utils.alert.show(Utils.translate('ADMIN_TOOLS.ADMIN_PERMISSIONS.DIALOG.LOAD_PERMS_IN_LOGIN_ERROR')).then(function() {
                        location.reload();
                      })
                    }).finally(function() {
                      continueFacebookLoginProcess();
                    })
                  } else {
                    console.error("Facebook login: find User Subscription By Id, no user subscription found");
                    Utils.alert.show(Utils.translate('ADMIN_TOOLS.ADMIN_PERMISSIONS.DIALOG.LOAD_PERMS_IN_LOGIN_ERROR')).then(function() {
                      location.reload();
                    })
                    continueFacebookLoginProcess();
                  }
                }, function(error) {
                  console.error("find User Subscription By Id", error);
                  Utils.alert.show(Utils.translate('ADMIN_TOOLS.ADMIN_PERMISSIONS.DIALOG.LOAD_PERMS_IN_LOGIN_ERROR')).then(function() {
                    location.reload();
                  })
                  continueFacebookLoginProcess();
                })
              }
            } else {
              showErrorAndClean(Utils.translate('ERROR.FACEBOOK_ERR05'), 1, 1);
              console.error("Error");
            }
          }, function(error) {
            console.error("findUserSubscription error", error);
          });
        };

        function continueFacebookLoginProcess() { // CONTINUE WITH PROCESS LOGGIN
          if (window.localStorage.getItem('AWSToken') && (window.localStorage.getItem('AWSToken') != '(null)')) {
            AWSServices.awsInit();
          } else {
            //$ionicPlatform.ready(function() {
              var isIOS = ionic.Platform.isIOS();
              if (isIOS === true) {
                  FCMPlugin.hasPermission(function(response) {
                      console.log("RES:", response);
                      if(response) {
                          FCMPlugin.getAPNSToken(function(token) {
                            //console.log("firebaseToken => " + token);
                            window.localStorage.setItem('AWSToken', token);
                              AWSServices.awsInit();
                          }, function(error) {
                            //alert("Couldn't get FCM token because: " +JSON.stringify(error));
                            console.error("Couldn't get FCM token because: ", error);
                          });
                      }
                  }, function (error) {
                      console.error("ERR: ", error);
                      $scope.checkTerms = false;
                  })
                /*if (window.ApnsToken) {
                  ApnsToken.getToken(function(token) {
                    window.localStorage.setItem('AWSToken', token);
                    if (typeof FCMPlugin != 'undefined') {
                      AWSServices.awsInit();
                    }
                  }, function(error) {
                    console.error("can't get ios token", error);
                    $scope.checkTerms = false;
                  })
                }*/
              } else {
                if (typeof FCMPlugin != 'undefined') {
                  FCMPlugin.getToken(function(token) {
                    window.localStorage.setItem('AWSToken', token);
                    AWSServices.awsInit();
                  }, function(response) {
                    console.error("couldn't get FCM token because: ", response);
                    $scope.checkTerms = false;
                  })
                }
              }
            //})
          }
          $scope.checkTerms = false;
          DBServices.execute(
            "SELECT * FROM userLogCount WHERE name = ?",
            [window.localStorage.getItem("name")]
          ).then(function(resultSet) {
            resultSet.rows.length > 0 ? setDefaultsDataBase(3, 1) : setDefaultsDataBase(2, 1);
          }, function(error) {
            console.error("continueFacebookLoginProcess", error)
            setDefaultsDataBase(4, 1);
          });
        }

        function BlobPhoto() { // PREPARE PHOTO BRING FROM FB
          var user = UserServiceFb.getUser('facebook');
          var canvas;
          var ctx;
          var dataURL;
          var num = 0;

          var imagePaths = [
            user.pictureSmall,
            user.pictureNormal,
            user.pictureLarge
          ];	

          function loadProfilePhotos(paths) {
            paths.forEach(function(path) {
              var img = new Image();
              img.crossOrigin = 'Anonymous';
              img.onload = function() {
                canvas = document.createElement('CANVAS');
                ctx = canvas.getContext('2d');
                canvas.height = this.height;
                canvas.width = this.width;
                ctx.drawImage(this, 0, 0);
                dataURL = canvas.toDataURL("image/jpeg", 1.0);
                window.localStorage.setItem(path.split('/')[4], dataURL);
                //$scope.pictures.push({"blob": dataURL, "name": path.split('/')[4]});
                $scope.$apply();
                if (num == 2) {
                  addPhoto();
                }
                num++;
              };
              img.src = path;
            });
          }

          loadProfilePhotos(imagePaths);
        }

        function addPhoto() { // ADD PHOTO TO SERVER
          var photoName = UserServiceFb.getUser();
          var realPhotoName = photoName.firstName.replace(" ", "_");
          var pictureName = realPhotoName + "_" + window.localStorage.getItem("simpleUserId");

          //Steps to upload
          var s3Service = new AWS.S3({
            apiVersion: '2006-03-01',
            params: { Bucket: s3.bucket }
          });
          //encrypt subscriptioninstanceID and folder name
          var userSubscriptionInstanceId = md5.createHash(window.localStorage.getItem("userSubscriptionInstanceId"));
          var folder = md5.createHash("profilePicture");

          //create key for each picture
          var photoSmallKey = s3.prefix + '/' + userSubscriptionInstanceId + '/' + folder + '/' + 'small.jpg';
          var photoNormalKey = s3.prefix + '/' + userSubscriptionInstanceId + '/' + folder + '/' + 'normal.jpg';
          var photoLargeKey = s3.prefix + '/' + userSubscriptionInstanceId + '/' + folder + '/' + 'large.jpg';

          //photo to blob
          var fileSmall = Utils.dataURLtoBlob(window.localStorage.getItem("picture?type=normal"));
          var fileNormal = Utils.dataURLtoBlob(window.localStorage.getItem("picture?type=large"));
          var fileLarge = Utils.dataURLtoBlob(window.localStorage.getItem("picture?type=large"));

          //upload to s3
          //small
          s3Service.upload({
            Key: photoSmallKey,
            Body: fileSmall,
            ACL: 'public-read',
            ContentType: fileSmall.type
          }, function(err, data) {
            if (err) {
              return console.error('There was an error uploading the small jpg:', err);
            }
            //console.log('Successfully uploaded thumb image.');
          });
          //normal
          s3Service.upload({
            Key: photoNormalKey,
            Body: fileNormal,
            ACL: 'public-read',
            ContentType: fileNormal.type
          }, function(err, data) {
            if (err) {
              return console.error('There was an error uploading the normal jpg:', err);
            }
            //console.log('Successfully uploaded thumb image.');
          });
          //large
          s3Service.upload({
            Key: photoLargeKey,
            Body: fileLarge,
            ACL: 'public-read',
            ContentType: fileLarge.type
          }, function(err, data) {
            if (err) {
              return console.error('There was an error uploading the large jpg:', err);
            }
            //console.log('Successfully uploaded thumb image.');
          });
          //

          //upload links to server
          changeProfilePictureService.changeProfPictv181({
            "userSubscriptionId": window.localStorage.getItem("userSubscriptionInstanceId")
          }).save({
            "profilePictureSmallUrl": {
              "value": "http://s3-us-west-2.amazonaws.com/" + s3.bucket + "/" + photoSmallKey
            },
            "profilePictureMedUrl": {
              "value": "http://s3-us-west-2.amazonaws.com/" + s3.bucket + "/" + photoNormalKey
            },
            "profilePictureLargeUrl": {
              "value": "http://s3-us-west-2.amazonaws.com/" + s3.bucket + "/" + photoLargeKey
            }
          }, function success(response) {
            //window.localStorage.setItem("photoProfileBlob", window.localStorage.getItem("picture?type=large") );
            window.localStorage.setItem("photoProfileBlob", "http://s3-us-west-2.amazonaws.com/" + s3.bucket + "/" + photoLargeKey);
            //Utils.loading.hide();

            //function needed to prepare aws notification
            if (window.localStorage.getItem('AWSToken') && (window.localStorage.getItem('AWSToken') != '(null)')) {
              AWSServices.awsInit();
            } else {
              //$ionicPlatform.ready(function() {
                var isIOS = ionic.Platform.isIOS();
                if (isIOS === true) {
                    FCMPlugin.hasPermission(function(response) {
                        console.log("RES:", response);
                        if(response) {
                            FCMPlugin.getAPNSToken(function(token) {
                              //console.log("firebaseToken => " + token);
                              window.localStorage.setItem('AWSToken', token);
                                AWSServices.awsInit();
                            }, function(error) {
                              //alert("Couldn't get FCM token because: " +JSON.stringify(error));
                              console.error("Couldn't get FCM token because: ", error);
                            });
                        }
                    }, function (error) {
                        console.error("ERR: ", error);
                        $scope.checkTerms = false;
                    })
                  /*if (window.ApnsToken) {
                    ApnsToken.getToken(function(token) {
                      window.localStorage.setItem('AWSToken', token);
                      if (typeof FCMPlugin != 'undefined') {
                        AWSServices.awsInit();
                      }
                    }, function(error) {
                      console.error("can't get ios token", error);
                      $scope.checkTerms = false;
                    })
                  }*/
                } else {
                  if (typeof FCMPlugin != 'undefined') {
                    FCMPlugin.getToken(function(token) {
                      window.localStorage.setItem('AWSToken', token);
                      AWSServices.awsInit();
                    }, function(response) {
                      console.error("couldn't get FCM token because: ", response);
                      $scope.checkTerms = false;
                    })
                  }
                }
              //})
            }

            //add membership if needed $scope.userMembership
            /*if($scope.userMembership === "" || $scope.userMembership === null || $scope.userMembership === undefined) {
              console.log("nothing")
            } else {
              UserService.changeMembershipWS({
                userId: UserService.get_USERSUBSCRIPTIONINSTANCE_ID(),
                membership: $scope.data.newUser.membership
              }).then(function success(response) {
                console.log("resp", response);
                UserService.set_USER_MEMBERSHIP($scope.data.newUser.membership);
              }, function (error) {
                console.error("Cant changeMembership", error);
              })
            }*/

            //BALA NEW QUESTIONS ONBOARDING
              if ($scope.data.extraQuestions) {
                //$scope.data.extraAnswersList = info.answersList;
                console.log("here i'll call the new WS when i'm sure the user and subs have already created");
                $scope.advanceInt = 0;
                $scope.questionsForLS = [];
                $scope.data.extraAnswersList.forEach(function(part) {
                  UserAdditionalInfo.addAdditionalInfoToUser({
                    user: window.localStorage.getItem("simpleUserId"),
                    question: $scope.data.extraQuestionsList[$scope.advanceInt],
                    answer: part
                  }).then(function success(response) {
                    var minData = {
                      question: $scope.data.extraQuestionsList[$scope.advanceInt],
                      answer: part
                    }
                    $scope.questionsForLS.push(minData);
                  }, function(error) {
                    console.error("couldn't add the question");
                  })
                  $scope.advanceInt++;
                })
                window.localStorage.setItem('personalQuestions', JSON.stringify($scope.questionsForLS));
              }
            //END BALA NEW QUESTIONS ONBOARDING
            checkGroupsByNameAndCity();
          }, function() {
            showErrorAndClean(Utils.translate('ERROR.FACEBOOK_ERR06'), 1, 1);
          });
        }
        $scope.messageToShow = "";

        function checkGroupsByNameAndCity() { // STEP TO VERIFY ACCESS TO GROUP FOR NEW USERS ONLY
          var userFace = UserServiceFb.getUser('facebook');
          var sendThisID = window.localStorage.getItem("userSubscriptionId");
          //WS called
          //after transform the account we add it to the required group if have any
          UserService.accessToLinkGroup({
            userSubscriptionId: sendThisID,
            facebookUser: userFace.name
          }).$promise.then(
            /*
             *Data received
             *result.value
             *1 the user was added directly
             *2 Generated a request to the proper group
             *3 didn't find the user in the group
             */
            function(resp) {
              //console.log('got it!!', resp);
              var message = "";
              if (resp.result.value == 1)
                $scope.messageToShow = Utils.translate("MENU.LINK_FB_ACCOUNT.ADDED_TO_GROUP");
              else if (resp.result.value == 2)
                $scope.messageToShow = Utils.translate("MENU.LINK_FB_ACCOUNT.PETITION_TO_GROUP");
              else if (resp.result.value == 3)
                $scope.messageToShow = Utils.translate("MENU.LINK_FB_ACCOUNT.NO_GROUP_TOBE_ADDED");

              $scope.checkTerms = false;
              DBServices.execute(
                "SELECT * FROM userLogCount WHERE name = ?",
                [window.localStorage.getItem("name")]
              ).then(function(resultSet) {
                resultSet.rows.length > 0 ? setDefaultsDataBase(3, 2) : setDefaultsDataBase(2, 2);
              }, function(error) {
                console.error('UPDATE error out', error);
                setDefaultsDataBase(4, 2);
              });
            },
            function(error) {
              //console.log('not got it??', error);
              $scope.messageToShow = Utils.translate("ERROR.FACEBOOK_ERR08");
              $scope.checkTerms = false;
              DBServices.execute(
                "SELECT * FROM userLogCount WHERE name = ?",
                [window.localStorage.getItem("name")]
              ).then(function(resultSet) {
                resultSet.rows.length > 0 ? setDefaultsDataBase(3, 2) : setDefaultsDataBase(2, 2);
              }, function(error) {
                console.error('UPDATE error out', error);
                setDefaultsDataBase(4, 2);
              });
              //showErrorAndClean(Utils.translate('ERROR.FACEBOOK_ERR08'), 1, 1);
            }
          );
        }
      // ZONE TO CONTINUE 3RD PARTY LOGIN/SIGIN - END

      // ZONE FOR USER CANCELED SUBSCRIPTION - BALA
        function userCanceled() {
          Utils.alert.show(Utils.translate('LOGIN.USERCANCELED_TEMPLATE'), {
            title: Utils.translate('LOGIN.USERCANCELED_TITLE')
          }).then(function() {
            AuthService.logout();
          });
        }

        function userCanceledFB() {
          facebookConnectPlugin.logout(function() {
              var tempPers = window.localStorage.getItem('AppsPerzonalized');
              window.localStorage.clear();
              window.localStorage.setItem("AppsPerzonalized", tempPers);
              window.localStorage.setItem("onboardingComplete", "yes");
              Utils.alert.show(Utils.translate('LOGIN.USERCANCELED_TEMPLATE'), {
                title: Utils.translate('LOGIN.USERCANCELED_TITLE')
              }).then(function() {
                AuthService.logout();
              });
            },
            function(fail) {
              console.error("facebookConnectPlugin.logout", fail);
            });
        };
      // ZONE FOR USER CANCELED SUBSCRIPTION - END

      // ZONE FOR SHOW ERROR DURING PROCESS LOGIN/SIGNIN - BALA
        function showErrorAndClean(error, face, loged) {
          Utils.loading.hide();
          console.error(error)
          $scope.ErrorMessage = error;
          if (face == 1) {
            facebookConnectPlugin.logout(function success() {
                if (loged == 1) {
                  AuthService.logout();
                }
              },
              function() {});
          } else {
            if (loged == 1) {
              AuthService.logout();
            }
          }
          $scope.checkTerms = false;
          var tempPers = window.localStorage.getItem('AppsPerzonalized');
          window.localStorage.clear();
          window.localStorage.setItem("AppsPerzonalized", tempPers);
          window.localStorage.setItem("onboardingComplete", "yes");
        };
      // ZONE FOR SHOW ERROR DURING PROCESS LOGIN/SIGNIN - END

      // ZONE FOR DATABASE DEFAULTS - BALA
        function setDefaultsDataBase(option, redirect) {
          //console.log("**set Defaults Data Base case " + option);
          //case to set tutorial in default
          if (option == 1) {
            //var statusJson = [];
            //var listOfTutorials = ["discovery", "upload", "timelineOrganize", "favorites"];

            var statusJson1 = JSON.stringify({ first: true, second: true });
            var statusJson2 = JSON.stringify({ first: true });
            DBServices.batch([
              ["INSERT INTO tutorials (name, visited) VALUES (?,?)", ["discovery", statusJson1]],
              ["INSERT INTO tutorials (name, visited) VALUES (?,?)", ["upload", statusJson1]],
              ["INSERT INTO tutorials (name, visited) VALUES (?,?)", ["favorites", statusJson1]],
              ["INSERT INTO tutorials (name, visited) VALUES (?,?)", ["timelineOrganize", statusJson2]]
            ]).then(function() {
              setDefaultsDataBase(4, redirect);
            }, function(error) {
              console.error('Transaction ERROR:', error);
              setDefaultsDataBase(4, redirect);
            })
          }
          //case to set log count in default
          //after
          if (option == 2) {
            DBServices.execute(
              "INSERT INTO userLogCount (name, count) VALUES (?,?)",
              [window.localStorage.getItem("name"), 1]
            ).then(function() {
              setDefaultsDataBase(3, redirect);
            }, function(error) {
              console.error("Insert log Count error", error);
              setDefaultsDataBase(4, redirect);
            });
          }
          //after case 2 we check if table for tutorial have any data
          if (option == 3) {
            DBServices.execute("SELECT * FROM tutorials").then(function(resultSet) {
              resultSet.rows.length > 0 ? setDefaultsDataBase(4, redirect) : setDefaultsDataBase(1, redirect);
            }, function(error) {
              console.error("SELECT tutorials error:", error);
              setDefaultsDataBase(4, redirect);
            })
          }
          //after all we need to redirect acordly
          if (option == 4) {
            if ($scope.messageToShow != "")
              //Utils.toast.success($scope.messageToShow);
            if (UserService.get_USER_PERMISSIONS().length) {
              Utils.loading.hide();
              // copy the LS main kay to LF
              $localForage.setItem('userSubscriptionId', window.localStorage.getItem('userSubscriptionId')).then(function(userSubsId) {
                //if the LS is in good state
                $localForage.setItem('userSubscriptionInstanceId', window.localStorage.getItem('userSubscriptionInstanceId')).then(function(userSubsInstId) {
                  console.log("LOCALFORAGE UPDATED");
                })
              });
              /////////////////////////////////////////////////////////////////////////
                if (redirect != 1) { // got from server for new user
                  var pivot = JSON.parse(window.localStorage.getItem('AppsPerzonalized'));
                  //call new WS to update user legal Version
                  UserService.updateLegalUserVersion({
                    objectId: window.localStorage.getItem("userSubscriptionInstanceId")
                  }).save({
                    int: { value: pivot.legalVer }
                  }, function(ret) {
                    window.localStorage.setItem('legalVer', pivot.legalVer);
                  }, function(err) {
                    console.error("can't save legal");
                  })
                }
              /////////////////////////////////////////////////////////////////////////
                if (redirect == 1) {
                  //va a timeline usuario ya existente 
                  if ($scope.toStandByPage) {
                    //mandar a pantalla de espera
                    $state.go('standbyPage', {}, { reload: true });
                  } else {
                    //usuario ya existente con status vivo
                    $state.go('menu.timeline', { "prepareStatement": 0 }, { reload: true });
                  }
                } else {
                  //va a discover usuario nuevo
                  //para usuarios nuevos sólo necesitamos ver si la app tiene TL cerrado o no
                  var pivot = JSON.parse(window.localStorage.getItem('AppsPerzonalized'));
                  if (pivot.TypeOfOnboarding === 0) {
                    //libre acceso
                    $state.go('menu.discovery', {}, { reload: true });
                  } else {
                    //mandar a pantalla de espera
                    //new step for created userswith passCode
                    if($scope.accountStatus === 'Active') //
                      $state.go('menu.discovery', {}, { reload: true });
                    else 
                      $state.go('standbyPage', {}, { reload: true });
                  }
                }
                //$state.go('menu.' + (redirect == 1 ? 'timeline' : 'discovery'), {}, {reload: true});
                setTimeout(function() {
                  $rootScope.$broadcast('login.success');
                }, 1000);
                return;
              /////////////////////////////////////////////////////////////////////////
            }

            //Prepare permissions for new user
            getRolePermissionAndSetUserData(+Utils.getLastUrlComponent($scope.rolID)).then(function(boolResp) {
              Utils.loading.hide();
              $localForage.setItem('userSubscriptionId', window.localStorage.getItem('userSubscriptionId')).then(function(userSubsId) {
                //if the LS is in good state
                $localForage.setItem('userSubscriptionInstanceId', window.localStorage.getItem('userSubscriptionInstanceId')).then(function(userSubsInstId) {
                  console.log("LOCALFORAGE UPDATED");
                })
              });
              if (redirect != 1) {
                var pivot = JSON.parse(window.localStorage.getItem('AppsPerzonalized'));
                UserService.updateLegalUserVersion({
                  objectId: window.localStorage.getItem("userSubscriptionInstanceId")
                }).save({
                  int: { value: pivot.legalVer }
                }, function(ret) {
                  window.localStorage.setItem('legalVer', pivot.legalVer);
                }, function(err) {
                  console.error("can't save legal");
                })
              }
              if (redirect == 1) {
                //va a timeline usuario ya existente 
                if ($scope.toStandByPage) {
                  //mandar a pantalla de espera
                  $state.go('standbyPage', {}, { reload: true });
                } else {
                  //usuario ya existente con status vivo
                  $state.go('menu.timeline', { "prepareStatement": 0 }, { reload: true });
                }
              } else {
                //va a discover usuario nuevo
                //para usuarios nuevos sólo necesitamos ver si la app tiene TL cerrado o no
                var pivot = JSON.parse(window.localStorage.getItem('AppsPerzonalized'));
                if (pivot.TypeOfOnboarding === 0) {
                  //libre acceso
                  $state.go('menu.discovery', {}, { reload: true });
                } else {
                  //mandar a pantalla de espera
                  if($scope.accountStatus === 'Active')
                    $state.go('menu.discovery', {}, { reload: true });
                  else
                    $state.go('standbyPage', {}, { reload: true });
                }
              }
              //$state.go('menu.' + (redirect == 1 ? 'timeline' : 'discovery'), {}, {reload: true});
              setTimeout(function() {
                $rootScope.$broadcast('login.success');
              }, 1000);
            }, function(error) {
              console.error("getRolePermissions", error);
              Utils.alert.show(Utils.translate('ADMIN_TOOLS.ADMIN_PERMISSIONS.DIALOG.LOAD_PERMS_IN_LOGIN_ERROR')).then(function() {
                location.reload();
              });
              var tempPers = window.localStorage.getItem('AppsPerzonalized');
              window.localStorage.clear();
              window.localStorage.setItem("AppsPerzonalized", tempPers);
              window.localStorage.setItem("onboardingComplete", "yes");
            })
          }
        }
      // ZONE FOR DATABASE DEFAULTS - END

      // AWS RETRY UPLOAD DATA - BALA
        AWS.events.on('retry', function(response) {  
          if (response.error.name === 'RequestTimeTooSkewed') {
            console.error('User time is not correct. Handling error!');
            console.log('AWS systemClockOffset:', AWS.config.systemClockOffset);
            var serverTime = Date.parse(response.httpResponse.headers['date']);
            var timeNow = new Date().getTime();
            console.log('AWS timestamp:', new Date(serverTime));
            console.log('Browser timestamp:', new Date(timeNow));
            AWS.config.systemClockOffset = Math.abs(timeNow - serverTime);
            response.error.retryable = true;
            console.log('Setting systemClockOffset to:', AWS.config.systemClockOffset);
            console.log('Retrying uploading to S3 once more...');
          }
        });
      // AWS RETRY UPLOAD DATA - BALA

      //ZONE FOR APPLE SIGN IN - BALA
        $scope.appleSignIn = function () {
          window.cordova.plugins.SignInWithApple.signin(
            { requestedScopes: [0, 1] },
            function(succ){
              console.log(succ)
              //alert(JSON.stringify(succ))
              //AFTER GET ALL APPLE DATA
              $scope.isAppleUser = true;
              //VALIDATE GIVEN NAME APPLE BALA
                  if(succ.fullName.givenName.length === 0)
                      succ.fullName.givenName = "NameApple";
                  var nomTemp = succ.fullName.givenName.split(' ').join('');
                  nomTemp = nomTemp.toLowerCase();
                  if(nomTemp.length > 5)
                      nomTemp = nomTemp.substring(0,5);
              //VALIDATE GIVEN NAME APPLE END
              //VALIDATE GIVEN FAMILY APPLE BALA
                  if(succ.fullName.familyName.length === 0)
                      succ.fullName.familyName = "LastnameApple"
                  var givenTemp = succ.fullName.familyName.split(' ').join('');
                  givenTemp = givenTemp.toLowerCase();
                  if(givenTemp.length > 5)
                      givenTemp = givenTemp.substring(0,5);
              //VALIDATE GIVEN FAMILY APPLE END
              //VALIDATE GIVEN USERNAME APPLE BALA
                  succ.username = "apple" + nomTemp + givenTemp + succ.user.split(".")[0];
                  if(succ.username.length > 30)
                      succ.username = succ.username.substring(0,25);
              //VALIDATE GIVEN USERNAME APPLE END
              //VALIDATE GIVEN WEBUSERID APPLE BALA
                succ.appleWebUserID = succ.user.split(".").join('');
              //VALIDATE GIVEN WEBUSERID APPLE END
              //VALIDATE GIVEN EMAIL IF EMPTY CREATE FAKE ONE BALA --"privaterelay.appleid.com"
                  if(succ.email === "") {
                      succ.email = succ.username+"@" + legalURl.app + "_niido.com";
                  }
              //VALIDATE GIVEN EMAIL IF EMPTY CREATE FAKE ONE END
              succ.tryNo = 0;
              $scope.appleUserInfo = succ;
              Auth($scope, AuthService);
            },
            function(err){
              console.error(err)
              console.log(JSON.stringify(err))
              $scope.checkTerms = false;
            }
          )
        }

        function findByWebUserIdApple() {
            SignInService.findByWebUserId().get({ "webUserid": $scope.appleUserInfo.appleWebUserID }, function(data) {
              if (data.length > 0) {
                window.localStorage.setItem("simpleUserInstanceId", data[0].userId.href.split('/')[6]);
                window.localStorage.setItem("userNameWeb", data[0].userName);
                AuthService.logout();
                console.log("first log out sven");
                AuthLog(AuthService, data[0].userName, data[0].userName.toLowerCase(), '1'); //Usuario ya existente procede a logeo
              } else {
                chkUserNameApple();
              }
            }, function(err) {
              Utils.loading.hide();
              showErrorAndClean(Utils.translate('ERROR.FACEBOOK_ERR04'), 1, 1);
              console.error('Error tipo findByWebUserId', err);
            });
                 
        }
      
        function chkUserNameApple() {
            UserService.validateUserName().get({
              "userName": $scope.appleUserInfo.username
            }, function success(response) {
              if(response.result.value) {
                //IF GENERATED USER IT'S THE SAME AS OBE CREATED BEFORE
                $scope.appleUserInfo.tryNo++;
                if($scope.appleUserInfo.tryNo < 10)
                  $scope.appleUserInfo.username = $scope.appleUserInfo.username + "_00" + $scope.appleUserInfo.tryNo;
                else{
                  if($scope.appleUserInfo.tryNo < 100)
                    $scope.appleUserInfo.username = $scope.appleUserInfo.username + "_0" + $scope.appleUserInfo.tryNo;
                  else
                    $scope.appleUserInfo.username = $scope.appleUserInfo.username + "_" + $scope.appleUserInfo.tryNo;
                }
                  chkUserNameApple();
              } else {
                validateEmailThirdParty();
              }
            }, function(error) {
              Utils.loading.hide();
              showErrorAndClean(Utils.translate('ERROR.FACEBOOK_ERR04'), 1, 1);
              console.error('Error tipo findByWebUserId', err);
            });
        }

        function blobPhotoApple() {
	        //var realPhotoName = $scope.data.newUser.username.replace(" ", "_");
	          //var pictureName = realPhotoName + "_" + window.localStorage.getItem("simpleUserId");
	          //Steps to upload
	          var s3Service = new AWS.S3({
	            apiVersion: '2006-03-01',
	            params: { Bucket: s3.bucket }
	          });
	          //encrypt subscriptioninstanceID and folder name
	          var userSubscriptionInstanceId = md5.createHash(window.localStorage.getItem("userSubscriptionInstanceId"));
	          var folder = md5.createHash("profilePicture");

	          //create key for each picture
	          var photoSmallKey = s3.prefix + '/' + userSubscriptionInstanceId + '/' + folder + '/' + 'small.jpg';
	          /*var photoNormalKey = s3.prefix + '/' + userSubscriptionInstanceId + '/' + folder + '/' + 'normal.jpg';
	          var photoLargeKey = s3.prefix + '/' + userSubscriptionInstanceId + '/' + folder + '/' + 'large.jpg';*/

	          //photo to blob
	          var fileSmall = Utils.dataURLtoBlob($scope.applePhoto);
	          /*var fileNormal = Utils.dataURLtoBlob($scope.data.pictures[1]);
	          var fileLarge = Utils.dataURLtoBlob($scope.data.pictures[2]);*/

	          //upload to s3
	          s3Service.upload({
	            Key: photoSmallKey,
	            Body: fileSmall,
	            ACL: 'public-read',
	            ContentType: fileSmall.type
	          }, function(err, data) {
	            if (err) {
	              return console.log('There was an error uploading the main jpg:'); // cancel all
	              return reject(err);
	            }
	            if (data) {
	              console.log("OK, Now updating profile images fields in DB...");
	              window.localStorage.setItem("photoProfileBlob", "http://s3-us-west-2.amazonaws.com/" + s3.bucket + "/" + photoSmallKey);
	              updateProfilePicture({
	                photoSmallKey: photoSmallKey,
	                photoNormalKey: photoSmallKey,
	                photoLargeKey: photoSmallKey
	              }).then(function() {
	                
	              }, function(error) {
	                reject(error)
	              })
	            }
	          })
      	}

      	function updateProfilePicture(uploadPicsResponse) {
	        //upload to server
	          var profilePictureBucket = "http://s3-us-west-2.amazonaws.com/" + s3.bucket + "/";
	          changeProfilePictureService.changeProfPictv181({
	            userSubscriptionId: window.localStorage.getItem("userSubscriptionInstanceId")
	          }).save({
	            profilePictureSmallUrl: { value: profilePictureBucket + uploadPicsResponse.photoSmallKey },
	            profilePictureMedUrl: { value: profilePictureBucket + uploadPicsResponse.photoNormalKey },
	            profilePictureLargeUrl: { value: profilePictureBucket + uploadPicsResponse.photoLargeKey }
	          }, function() {
	            //function needed to prepare aws notification
	            if (window.localStorage.getItem('AWSToken') && (window.localStorage.getItem('AWSToken') != '(null)')) {
	              AWSServices.awsInit();
	            } else {
	              //$ionicPlatform.ready(function() {
	                var isIOS = ionic.Platform.isIOS();
	                if (isIOS === true) {
                        FCMPlugin.hasPermission(function(response) {
                            console.log("RES:", response);
                            if(response) {
                                FCMPlugin.getAPNSToken(function(token) {
                                  //console.log("firebaseToken => " + token);
                                  window.localStorage.setItem('AWSToken', token);
                                    AWSServices.awsInit();
                                }, function(error) {
                                  //alert("Couldn't get FCM token because: " +JSON.stringify(error));
                                  console.error("Couldn't get FCM token because: ", error);
                                });
                            }
                        }, function (error) {
                            console.error("ERR: ", error);
                            $scope.checkTerms = false;
                        })
	                  /*if (window.ApnsToken) {
	                    ApnsToken.getToken(function(token) {
	                      window.localStorage.setItem('AWSToken', token);
	                      if (typeof FCMPlugin != 'undefined') {
	                        AWSServices.awsInit();
	                      }
	                    }, function(error) {
	                      console.error("can't get ios token", error);
	                      $scope.checkTerms = false;
	                    })
	                  }*/
	                } else {
	                  if (typeof FCMPlugin != 'undefined') {
	                    FCMPlugin.getToken(function(token) {
	                      window.localStorage.setItem('AWSToken', token);
	                      AWSServices.awsInit();
	                    }, function(response) {
	                      console.error("couldn't get FCM token because: ", response);
	                      $scope.checkTerms = false;
	                    })
	                  }
	                }
	              //})
	            }

	            //add membership if needed $scope.userMembership
	            /*if($scope.userMembership === "" || $scope.userMembership === null || $scope.userMembership === undefined) {
	              console.log("nothing")
	            } else {
	              UserService.changeMembershipWS({
	                userId: UserService.get_USERSUBSCRIPTIONINSTANCE_ID(),
	                membership: $scope.data.newUser.membership
	              }).then(function success(response) {
	                console.log("resp", response);
	                UserService.set_USER_MEMBERSHIP($scope.data.newUser.membership);
	              }, function (error) {
	                console.error("Cant changeMembership", error);
	              })
	            }*/

	            checkGroupsByNameAndCity();
	          }, function(error) {
	            console.error('changeProfilePictureService.changeProfPict error', error);
	            reject(error)
	          });
      	}
      //ZONE FOR APPLE SIGN IN - END

      //ZONE FOR VALIDATE EMAIL FROM 3RD PARTY LOGIN - BALA
        function validateEmailThirdParty () {
          Utils.loading.show();
          var emailToVerify = null;
          //CHECK TYPE OF LOGIN - BALA
            switch ($scope.typeAccess) {
              case 1: //Facebook sign in - log in
                var FBData = UserServiceFb.getUser('facebook');
                emailToVerify = FBData.email;
              break;
              case 2: //Apple sign in - log in
                emailToVerify = $scope.appleUserInfo.email;
              break;
            }
          //CHECK TYPE OF LOGIN - END
          //IF EMAIL ISN'T PRESENT SEND TO ADITIONAL INFO - BALA
            if(emailToVerify === null || emailToVerify === undefined || emailToVerify === '')
              askForEmail3rdApp();
            else {
              //CHECK EMAIL WITH WS - BALA
                UserService.validateUserEmail().get({ email: emailToVerify }, function(response) {
                  if (response.length > 1) {
                    //CHECK BEFORE IF MAIL USED FOR ANOTHER TYPE OF SIGN IN - BALA
                      Utils.loading.hide();
                      if(response[0].passwordRecoveryAnswer === "Yes") { //FbUser works for both Apple/FB
                          switch (response[0].passwordRecoveryQuestion) {
                            case "¿Access with Facebook?": //Facebook sign in - log in
                              Utils.alert.show(Utils.translate('LOGIN.VALIDATE_EMAIL_01') + $scope.data.email + Utils.translate('LOGIN.VALIDATE_EMAIL_02')).then(function(res) {
                                showErrorAndClean(Utils.translate('LOGIN.EMAIL_USED'), 1, 1);
                              });
                            break;
                            case "¿Access with Apple?": //Apple sign in - log in
                              Utils.alert.show(Utils.translate('LOGIN.VALIDATE_EMAIL_01') + $scope.data.email + Utils.translate('LOGIN.VALIDATE_EMAIL_03')).then(function(res) {
                                showErrorAndClean(Utils.translate('LOGIN.EMAIL_USED'), 1, 1);
                              });
                            break;
                          }
                      } else { //the email is used but not for Apple/FB login
                        var redirectPopUp = $ionicPopup.confirm({
                          cssClass: 'popupClass',
                          title: $filter('translate')('LOGIN.EMAIL_USED'),
                          template: $filter('translate')('LOGIN.VALIDATE_EMAIL_01') + $scope.data.email + $filter('translate')('LOGIN.VALIDATE_EMAIL_04') + response[0].userName,
                          cancelText: $filter('translate')('LOGIN.REDIRECT_FORGOTPASS_01'),
                          okType: 'button-assertive',
                          okText: $filter('translate')('LOGIN.REDIRECT_LOGIN_01')
                        });
                        redirectPopUp.then(function (res) {
                          if (res) {
                            $scope.cancel();
                          } else {
                            $scope.cancel();
                            Utils.$timeout(function() {
                              $state.go('forgotPassword', {}, { reload: true });
                            }, 100)
                          }
                        });
                      }
                    //CHECK BEFORE IF MAIL USED FOR ANOTHER TYPE OF SIGN IN - END
                  } else {
                    chkBeforeAdditionalInfo();
                  }
                }, function(error) {
                  console.error('Error tipo verifyEmailExists', error);
                  showErrorAndClean(Utils.translate('ERROR.FACEBOOK_ERR04'), 1, 1);
                })
              //CHECK EMAIL WITH WS - END
            }
          //IF EMAIL ISN'T PRESENT SEND TO ADITIONAL INFO - END
        }

        //ZONE TO ASK EMAIL AND VALIDATE BEFORE CONTINUE - BALA
          function askForEmail3rdApp () {
            Utils.loading.hide();
            var dataVerify = {};
            switch ($scope.typeAccess) {
              case 1: //Facebook sign in - log in
                var FBData = UserServiceFb.getUser('facebook');
                dataVerify.emailToVerify =  null;//FBData.email
                dataVerify.thirdApp = 1; //FB
              break;
              case 2: //Apple sign in - log in
                dataVerify.emailToVerify = null;
                dataVerify.thirdApp = 2; //Apple
              break;
            }
            $scope.checkTerms = false;
            $scope.betweenProcess = false;
            Utils.modal.show({
              templateUrl: 'templates/Login/askEmailTL.html',
              locals: {
                userData: dataVerify
              },
              controller: function($scope, $mdDialog, locals, $rootScope, UserService) {
                $scope.data = {};
                $scope.data.dataVerify = locals.userData;
                $scope.data.emailGivenByUser = null;
                $scope.data.typeofAction = 0;
                $scope.data.userFind = "";
                //VALIDATE EMAIL BEFORE CLOSING MODAL - BALA
                  $scope.chkEmail = function () {
                    //$scope.data.email
                    UserService.validateUserEmail().get({ email: $scope.data.emailGivenByUser }, function(response) {
                      if (response.length > 1) { //
                        //CHECK BEFORE IF MAIL USED FOR ANOTHER TYPE OF SIGN IN - BALA
                          if(response[0].passwordRecoveryAnswer === "Yes") { //FbUser works for both Apple/FB
                            switch (response[0].passwordRecoveryQuestion) {
                              case "¿Access with Facebook?": //Facebook sign in - log in
                                $scope.data.typeofAction = 2;
                                $scope.data.userFind = "";
                                $scope.ok();
                              break;
                              case "¿Access with Apple?": //Apple sign in - log in
                                $scope.data.typeofAction = 3;
                                $scope.data.userFind = "";
                                $scope.ok();
                              break;
                            }
                          } else { //the email is used but not for Apple/FB login
                            $scope.data.typeofAction = 1;
                            $scope.data.userFind = response[0].userName;
                            $scope.ok();
                          }
                        //CHECK BEFORE IF MAIL USED FOR ANOTHER TYPE OF SIGN IN - END
                      } else {
                        $scope.ok();
                      }
                    }, function(error) {
                      $scope.ok();
                    })
                  }
                //VALIDATE EMAIL BEFORE CLOSING MODAL - END

                //CLOSE MODAL - BALA
                  $scope.ok = function() {
                    $mdDialog.hide($scope.data);
                  };

                  $scope.cancel = function() {
                    $mdDialog.cancel()
                  };
                //CLOSE MODAL - END
              }
            }).then(function(info) {
              if(info) {
                var infoGotten = info;
                $scope.emailGivenByUser = infoGotten.emailGivenByUser;
                switch (infoGotten.typeofAction) {
                  case 0: //clean, pass email
                    chkBeforeAdditionalInfo();
                  break;
                  case 1: //user created manually
                    var redirectPopUp = $ionicPopup.confirm({
                      cssClass: 'popupClass',
                      title: $filter('translate')('LOGIN.EMAIL_USED'),
                      template: $filter('translate')('LOGIN.VALIDATE_EMAIL_01') + $scope.emailGivenByUser + $filter('translate')('LOGIN.VALIDATE_EMAIL_04') + infoGotten.userFind,
                      cancelText: $filter('translate')('LOGIN.REDIRECT_FORGOTPASS_01'),
                      okType: 'button-assertive',
                      okText: $filter('translate')('LOGIN.REDIRECT_LOGIN_01')
                    });
                    redirectPopUp.then(function (res) {
                      if (res) {
                        $scope.cancel();
                      } else {
                        $scope.cancel();
                        Utils.$timeout(function() {
                          $state.go('forgotPassword', {}, { reload: true });
                        }, 100)
                      }
                    });
                  break;
                  case 2: //FB
                    Utils.alert.show(Utils.translate('LOGIN.VALIDATE_EMAIL_01') + $scope.emailGivenByUser + Utils.translate('LOGIN.VALIDATE_EMAIL_02')).then(function(res) {
                      showErrorAndClean(Utils.translate('LOGIN.EMAIL_USED'), 1, 1);
                    });
                  break;
                  case 3: //Apple
                    Utils.alert.show(Utils.translate('LOGIN.VALIDATE_EMAIL_01') + $scope.emailGivenByUser + Utils.translate('LOGIN.VALIDATE_EMAIL_03')).then(function(res) {
                      showErrorAndClean(Utils.translate('LOGIN.EMAIL_USED'), 1, 1);
                    });
                  break;
                }
                
              } else {
                Utils.loading.hide();
              }
            });
          }
        //ZONE TO ASK EMAIL AND VALIDATE BEFORE CONTINUE - END

        function chkBeforeAdditionalInfo () {
          switch ($scope.typeAccess) {
            case 1: //Facebook sign in - log in
              $scope.showAditionalInfoForm();
            break;
            case 2: //Apple sign in - log in
              $scope.showAditionalInfoFormApple();
            break;
          }
        }
      //ZONE FOR VALIDATE EMAIL FROM 3RD PARTY LOGIN - END
    }
  ])

  .controller('signupCtrl', ['$scope', '$state', '$ionicHistory', 'AuthService', 'AddUserService', 'UserService', 'Utils', '$localForage', 'AddSubscriptionService','$window',
    function($scope, $state, $ionicHistory, AuthService, AddUserService, UserService, Utils, $localForage, AddSubscriptionService, $window) {

      $scope.data = {};
      $scope.methods = {};

      $scope.data.newUser = AddUserService.newUser;

      //$scope.data.newUser.birthday = new Date();
      $scope.data.addedBirth = false;
      $scope.data.errorBirthday = false;
      $scope.data.birthday = {};
      $scope.data.birthday.day = 1;
      $scope.data.birthday.month = 1;
      $scope.data.birthday.year = 1900;
      $scope.data.memberShip = " ";
      $scope.data.selectedCity = { idCity: 0, city: Utils.translate("SIGNUP.SELECT_CITY") };
      $scope.data.newUser.city = " ";

      /*FOR NEW BIRTHDAY FORM*/
      $scope.data.selectedDay = 0;
      $scope.data.selectedMonth = 0;
      $scope.data.selectedYear = 0;
      $scope.data.showDay = false;
      $scope.data.showYear = false;
      $scope.data.dayList = [];
      $scope.data.monthList = [];
      $scope.data.yearList = [];
      $scope.data.addedBirth = false;
      $scope.data.errorBirthday = false;
      $scope.data.finalDate = null;
      $scope.data.isDateEmpty = true;
      /**/
      var lang = $window.navigator.languages ?
                 $window.navigator.languages[0] :
                 ($window.navigator.language || $window.navigator.userLanguage);
      $scope.english= false;
      if(lang.includes("es-")) {
        $scope.english= false;
      } else {
        $scope.english= true;
      }

      AuthService.login("sven", 'm<}WU6ZEFvKqks-"').then(function() {
        UserService.getCities().$promise.then(function(resp) {
          Utils.removeLastItemIfHasNoAttribute(resp, 'idCity');
          //console.log(resp);

          resp.unshift({ idCity: 0, city: Utils.translate("SIGNUP.SELECT_CITY") });
          resp.push({ idCity: -1, city: Utils.translate("SIGNUP.OTHER") });
          $scope.data.cities = resp;
          $scope.data.selectedCity = resp[0];

          //AuthService.logout();
        }, function(error) {
          console.error("get Cities", error);
        });
      }, function(error) {
        console.error("Login with public user", error);
        $scope.error = "Wrong user or pass";
      });

      //FUNCTIONS NEW DATE
        $scope.initDates = function() {
          //PREPARE MONTH
          $scope.data.monthList.push({
            id: 1,
            text: Utils.translate("BIRTHDAY_INFO.MONTH_LIST.01")
          })
          for (var i = 2010; i >= 1920; i--) {
            $scope.data.yearList.push({
              id: i,
              text: "" + i
            })
          }
          $scope.data.dayList.push({
            id: 1,
            text: "" + i
          })
          $scope.data.selectedMonth = $scope.data.monthList[0];
          $scope.data.selectedYear = $scope.data.yearList[0];
          $scope.data.selectedDay = $scope.data.dayList[0];
          $scope.data.isDateEmpty = false;
        }
        $scope.initDates();

        $scope.selectYear = function(year) {
          if (year.id === 0) {
            $scope.data.isDateEmpty = false;
          }
        }

        $scope.selectMonth = function(month) {
          console.log("month", month);
          if (month.id === 0) {
            //not 
            $scope.data.showDay = false;
            $scope.data.dayList = [];
            $scope.data.isDateEmpty = true;
          } else {
            $scope.data.isDateEmpty = false;
            $scope.data.showDay = true;
            if (month.id === 2) {
              $scope.data.dayList = [];
              $scope.prepareDays(28);
            } else if (month.id === 1 || month.id === 3 || month.id === 5 || month.id === 7 || month.id === 8 || month.id === 10 || month.id === 12) {
              //31
              $scope.data.dayList = [];
              $scope.prepareDays(31);
            } else {
              //30
              $scope.data.dayList = [];
              $scope.prepareDays(30);
            }
          }
        }

        $scope.prepareDays = function(days) {
          $scope.data.dayList.push({
            id: 0,
            text: "Select Day"
          })
          for (var i = 1; i <= days; i++) {
            $scope.data.dayList.push({
              id: i,
              text: "" + i
            })
          }
          $scope.data.selectedDay = $scope.data.dayList[0];
        }

        $scope.selectDay = function(day) {
          $scope.data.isDateEmpty = false;
          console.log("day", day);
        }
      //ENDFUNCTIONS NEW DATE

      //FUNCTIONS FOR PASSCODE/INVITATION CODE
        $scope.data.newUser.passCode = "";
        var pivot = JSON.parse(window.localStorage.getItem('AppsPerzonalized'));
        $scope.data.newUser.needMembership = pivot.showInvitationCode ? true : false;
        $scope.data.newUser.openTL = pivot.TypeOfOnboarding === 0 ? 'O' : 'C';
        $scope.data.showMsgCode = false;
        $scope.data.codeInvalid = false;
        $scope.data.errCode = Utils.translate('SIGNUP.INVITATION_ERR');
        $scope.data.validCode = Utils.translate('SIGNUP.INVITATION_PASS');
        $scope.validateCode = function () {
          var correctCode = false;
          if($scope.data.newUser.passCode.length === 0) {
            $scope.data.showMsgCode = null;
            return false;
          }
          AddSubscriptionService.validatePassCode({
            code: $scope.data.newUser.passCode.toUpperCase()
          }).$promise.then( function (response) {
            console.log("got", response);
            $scope.data.showMsgCode = true;
            if(response.result.value)
              $scope.data.codeInvalid = false;
            else
              $scope.data.codeInvalid = true;
          }, function (error) {
            console.error("something went wrong");
          })
        }
      //END FUNCTIONS FOR PASSCODE/INVITATION CODE

      $scope.getDate = function(date) {
        $scope.data.addedBirth = true;
      }

      //OmRo ciudad advertencia
      $scope.selectCity = function(option) {
        $scope.data.validate = false;
        if ([0].includes(option.idCity)) {
          $scope.data.newUser.addCityToCatalog = true;
          Utils.toast.info(Utils.translate("SIGNUP.SELECT_CITYNO"));
        } else if ([-1].includes(option.idCity)) {
          $scope.data.newUser.city = "";
          $scope.data.newUser.addCityToCatalog = true;
        } else {
          $scope.data.newUser.city = option.city;
          $scope.data.newUser.addCityToCatalog = false;
        }
        window.localStorage.setItem("city", $scope.data.newUser.city);
      };

      $scope.methods.findUsername = function() {
        $scope.data.newUser.availableUsername = 0;
        if ($scope.data.newUser.username) {
          AuthService.login("sven", 'm<}WU6ZEFvKqks-"').then(function() {
            //console.log("Access with sven");
            UserService.validateUserName().get({
              "userName": $scope.data.newUser.username
            }, function success(response) {
              $scope.data.newUser.availableUsername = response.result.value ? 1 : 2;
              AuthService.logout();
            }, function(error) {
              console.error("error login", error);
              $scope.data.newUser.availableUsername = 0;
              AuthService.logout();
            });
          }, function(error) {
            console.error("Error login with sven", error);
            $scope.error = "Wrong user or pass";
          });
        }
      };

      $scope.methods.goBack = function() {
        $ionicHistory.goBack();
      };
      
      /*$scope.methods.chkBeforeContinue = function () {
        //check if username/mail is already used
        $scope.data.newUser.username = $scope.data.newUser.email;
        AuthService.login("sven", 'm<}WU6ZEFvKqks-"').then(function () {
          UserService.validateUserName().get({
            "userName": $scope.data.newUser.username
          }, function success(response) {
            $scope.data.newUser.availableUsername = response.result.value ? 1 : 2;
            //AuthService.logout();
            if($scope.data.newUser.availableUsername === 2) {
              //PASS
              Utils.toast.success(Utils.translate('SIGNUP.AVAILABLE'),6000);
              //$scope.methods.continue();
              $scope.methods.chkEmailAvailability();
            } else {
              Utils.toast.error(Utils.translate('SIGNUP.ALREADY_EXISTS'),6000);
            }
          }, function(error) {
            console.error("error login", error);
            $scope.data.newUser.availableUsername = 0;
            AuthService.logout();
          }, function(error) {
            console.error("Error login with sven", error);
            $scope.error = "Wrong user or pass";
          });
        })
      }*/

      $scope.methods.chkEmailAvailability = function () {
        AuthService.login("sven", 'm<}WU6ZEFvKqks-"').then(function() {
          UserService.validateUserEmail().get({ email: $scope.data.newUser.email }, function(response) {
            AuthService.logout();
            if (response.length > 1) { //
              //CHECK BEFORE IF MAIL USED FOR ANOTHER TYPE OF SIGN IN - BALA
                if(response[0].passwordRecoveryAnswer === "Yes") { //FbUser works for both Apple/FB
                  switch (response[0].passwordRecoveryQuestion) {
                    case "¿Access with Facebook?": //Facebook sign in - log in
                      Utils.alert.show(Utils.translate('LOGIN.VALIDATE_EMAIL_01') + $scope.data.newUser.email + Utils.translate('LOGIN.VALIDATE_EMAIL_02')).then(function(res) {
                          $state.go('login', {}, {reload: false});
                      });
                    break;
                    case "¿Access with Apple?": //Apple sign in - log in
                      Utils.alert.show(Utils.translate('LOGIN.VALIDATE_EMAIL_01') + $scope.data.newUser.email + Utils.translate('LOGIN.VALIDATE_EMAIL_03')).then(function(res) {
                          $state.go('login', {}, {reload: false});
                      });
                    break;
                  }
                } else { //the email is used but not for Apple/FB login
                  var redirectPopUp = $ionicPopup.confirm({
                    cssClass: 'popupClass',
                    title: $filter('translate')('LOGIN.EMAIL_USED'),
                    template: $filter('translate')('LOGIN.VALIDATE_EMAIL_01') + $scope.data.newUser.email + $filter('translate')('LOGIN.VALIDATE_EMAIL_04') + response[0].userFind,
                    cancelText: $filter('translate')('LOGIN.REDIRECT_FORGOTPASS_01'),
                    okType: 'button-assertive',
                    okText: $filter('translate')('LOGIN.REDIRECT_LOGIN_01')
                  });
                  redirectPopUp.then(function (res) {
                    if (res) {
                      
                    } else {
                      $scope.data = {};
                      Utils.$timeout(function() {
                        $state.go('forgotPassword', {}, { reload: true });
                      }, 100)
                    }
                  });
                }
              //CHECK BEFORE IF MAIL USED FOR ANOTHER TYPE OF SIGN IN - END
            } else {
              $scope.methods.continue();
            }
          }, function(error) {
            console.error("error login", error);
            $scope.data.newUser.availableUsername = 0;
            AuthService.logout();
          })
        }, function(error) {
          console.error("Login with public user", error);
          $scope.error = "Wrong user or pass";
        });
          
      }

      $scope.methods.continue = function() {
        if ($scope.data.selectedCity.idCity === 0) //OmRom City 10-18-19
        {
          Utils.toast.info(Utils.translate("SIGNUP.SELECT_CITYNO"));
        }
        //prepare YEAR
        var realYear = $scope.data.selectedYear.text;
        //prepare MONTH
        var realMonth = "01";
        if ($scope.data.selectedMonth.id < 10) {
          realMonth = "0" + $scope.data.selectedMonth.id;
        } else {
          realMonth = "" + $scope.data.selectedMonth.id;
        }
        //prepare DAY
        var realDay = "01"
        if ($scope.data.selectedDay.id < 10) {
          realDay = "0" + $scope.data.selectedDay.text;
        } else {
          realDay = $scope.data.selectedDay.text;
        }

        $scope.data.newUser.birthday = realYear + "-01-01";
        Utils.confirm.show($scope.data.newUser.email, {
          title: Utils.translate('SIGNUP.EMAIL_CORRECT'),
          cancelText: Utils.translate('GLOBAL.NO'),
          okText: Utils.translate('GLOBAL.YES')
        }).then(function(res) {
          if (res) {
            if ($scope.data.newUser.availableUsername === 2) {
              //PREPARE ALL THINGS FOR INVITATIONCODE
                if($scope.data.codeInvalid)
                  $scope.data.newUser.passCode = " ";
                if($scope.data.newUser.passCode === "")
                  $scope.data.newUser.passCode = " ";
              //END PREPARE ALL THINGS FOR INVITATIONCODE
              AuthService.logout();
              $state.go('signup2', {}, { reload: true });
            }
          } else {
            console.log('You are not sure');
          }
        });
      };
    }
  ])

  .controller('signup2Ctrl', ['$rootScope', '$scope', '$state', '$ionicHistory', 'AuthService', 'AddSubscriptionService', 'AddUserService', 'changeProfilePictureService', '$ionicActionSheet', 'ImageService2', 'FileService2', '$ionicPlatform', 'UserService', '$ionicPush', 'DBServices', 's3', 'md5', 'ApiEndPoint', 'Utils', 'AWSServices', 'AppAdminRolesService', 'ImageService', '$jrCrop', '$localForage', 'Personalized', '$window', '$timeout', 'Push_Notif_Variables', 'legalURl',
    function($rootScope, $scope, $state, $ionicHistory, AuthService, AddSubscriptionService, AddUserService, changeProfilePictureService, $ionicActionSheet, ImageService2, FileService2, $ionicPlatform, UserService, $ionicPush, DBServices, s3, md5, ApiEndPoint, Utils, AWSServices, AppAdminRolesService, ImageService, $jrCrop, $localForage, Personalized, $window, $timeout, Push_Notif_Variables, legalURl) {

      $scope.data = {};
      $scope.methods = {};
      $scope.data.newUser = AddUserService.newUser;
      $scope.data.showTerms = true;
      FileService2.cleanImages();
      $scope.data.pictures = FileService2.images();
      $scope.data.creating = false;
      $scope.data.addPhoto = Utils.translate('SIGNUP.ADDPHOTO');
      var isIOS = ionic.Platform.isIOS();
      $scope.accountStatus = "";
      $scope.methods.goBack = function() {
        $ionicHistory.goBack();
      };
      $scope.AppName = Push_Notif_Variables.title;
      $scope.methods.addPhoto = function() {
        $scope.hideSheet = $ionicActionSheet.show({
          buttons: [
            { text: 'Take photo' },
            { text: 'Photo from library' }
          ],
          titleText: 'Add photo from',
          cancelText: 'Cancel',
          buttonClicked: function(index) {
            $scope.hideSheet();
            var permit = "";
            var msg = "";
            if (isIOS === true) {
              //getPermission(0);
              obtainPhoto(index);
            } else {
              getMultiplePermissions(index);
            }
          }
        });
      };

      //NEW FUNCTION TO SHOW/HIDE BUTTON FOR 
      $scope.validateTerms = function() {
        var pivot = JSON.parse(window.localStorage.getItem('AppsPerzonalized'));
        if (pivot) { //The App have configured options
          if (pivot.TermsConditions) {
            //SHOW TERMS AND CONDITIONS
            $scope.data.showTerms = true;
          } else {
            //SKIP TERMS AND CONDITIONS
            $scope.data.showTerms = false;
            $scope.data.acceptTerms = true;
          }
        } else {
          //DEFAULT OPTION IF NOT PERSONALIZED APP
          $scope.data.showTerms = false;
          $scope.data.acceptTerms = true;
        }
      }
      $scope.validateTerms();


      $scope.chkCity = function() {
        if ($scope.data.newUser.addCityToCatalog) {
          AuthService.login("sven", 'm<}WU6ZEFvKqks-"').then(function() {
            UserService.checkCitiesByCity(
              $scope.data.newUser.city
            ).then(function(response) {
              Utils.removeLastItemIfHasNoAttribute(response, 'idCity');
              console.log("success");
              if (response.length > 0) {
                console.log("the writen city is already register but not seen");
                $scope.data.newUser.city = option.city;
                $scope.data.newUser.addCityToCatalog = false;
              } else {
                console.log("the writen city isn't register");
              }
              AuthService.logout();
            }, function(error) {
              console.log("Error trying to check city", error);
              AuthService.logout();
            });
          }, function(error) {
            console.error("Login with public user", error);
            $scope.error = "Wrong user or pass";
          })
        } else {
          console.log("nothing to check")
        }
      };
      $scope.chkCity();

      /**
       *function to send user o Settings of the App
       */
      function switchToSets() {
        cordova.plugins.diagnostic.switchToSettings(function() {
          console.log("Successfully switched to Settings app");
        }, function(error) {
          console.error("The following error occurred: " + error);
        });
      }

      /**
       *function to get permission for camera
       */
      function getPermission(index) {
        var typOfPerm = index === 0 ? cordova.plugins.diagnostic.permission.CAMERA : cordova.plugins.diagnostic.permission.READ_EXTERNAL_STORAGE;
        var typeText = index === 0 ? Utils.translate('PLUGINS.PERMISSIONS.TYPE.CAMERA') : Utils.translate('PLUGINS.PERMISSIONS.TYPE.GALLERY');
        cordova.plugins.diagnostic.getPermissionAuthorizationStatus(function(status) {
          switch (status) {
            case cordova.plugins.diagnostic.permissionStatus.GRANTED:
              //user granted permission
              if (index === 0) {
                getPermission(1);
              } else {
                obtainPhoto(index);
              }
              break;
            case cordova.plugins.diagnostic.permissionStatus.NOT_REQUESTED:
              //user hasn't been asked for this permission
              //android sometimes fails when asking so we ask again
              askPermission(index);
              break;
            case cordova.plugins.diagnostic.permissionStatus.DENIED:
              //user already denied this permission before or cancel it in sys config
              //android can ask everytime until user denied always that permission
              askPermission(index);
              break;
            case cordova.plugins.diagnostic.permissionStatus.DENIED_ALWAYS:
              //user denied forever this permission for this app
              Utils.toast.error(Utils.translate('PLUGINS.PERMISSIONS.DENIED_PERMISSION') +
                typeText +
                Utils.translate('PLUGINS.PERMISSIONS.ALWAYS_DENIED_PERMISSION'));
              break;
          }
        }, function(error) {
          console.error("The following error occurred: " + error);
        }, typOfPerm);
      }

      /**
       *function to ask permission for camera
       */
      function askPermission(index) {
        var typOfPerm = index === 0 ? cordova.plugins.diagnostic.permission.CAMERA : cordova.plugins.diagnostic.permission.READ_EXTERNAL_STORAGE;
        var typeText = index === 0 ? Utils.translate('PLUGINS.PERMISSIONS.TYPE.CAMERA') : Utils.translate('PLUGINS.PERMISSIONS.TYPE.GALLERY');
        cordova.plugins.diagnostic.requestRuntimePermission(function(status) {
          switch (status) {
            case cordova.plugins.diagnostic.permissionStatus.GRANTED:
              //when asked user agreed
              if (index === 0) {
                getPermission(1);
              } else {
                obtainPhoto(index);
              }
              break;
            case cordova.plugins.diagnostic.permissionStatus.NOT_REQUESTED:
              //user close or hide the permission ask
              Utils.toast.error(Utils.translate('PLUGINS.PERMISSIONS.DENIED_PERMISSION') +
                typeText +
                Utils.translate('PLUGINS.PERMISSIONS.ALWAYS_DENIED_PERMISSION'));
              break;
            case cordova.plugins.diagnostic.permissionStatus.DENIED:
              //when asked the user denied this permission again
              Utils.toast.error(Utils.translate('PLUGINS.PERMISSIONS.DENIED_PERMISSION') +
                typeText +
                Utils.translate('PLUGINS.PERMISSIONS.ALWAYS_DENIED_PERMISSION'));
              break;
            case cordova.plugins.diagnostic.permissionStatus.DENIED_ALWAYS:
              //when asked user denied forever this permission for this app
              Utils.toast.error(Utils.translate('PLUGINS.PERMISSIONS.DENIED_PERMISSION') +
                typeText +
                Utils.translate('PLUGINS.PERMISSIONS.ALWAYS_DENIED_PERMISSION'));
              break;
          }
        }, function(error) {
          console.error("The following error occurred: " + error);
        }, typOfPerm);
      }

      /**
       *function to get multiple permission for camera
       */
      function getMultiplePermissions(index) {
        cordova.plugins.diagnostic.getPermissionsAuthorizationStatus(function(statuses) {
          var havePerm = 0;
          var deniedPerm = false;
          for (var permission in statuses) {
            switch (statuses[permission]) {
              case cordova.plugins.diagnostic.permissionStatus.GRANTED:
                console.log("Permission granted to use " + permission);
                havePerm++;
                break;
              case cordova.plugins.diagnostic.permissionStatus.NOT_REQUESTED:
                console.log("Permission to use " + permission + " has not been requested yet");
                havePerm--;
                break;
              case cordova.plugins.diagnostic.permissionStatus.DENIED:
                console.log("Permission denied to use " + permission + " - ask again?");
                havePerm--;
                break;
              case cordova.plugins.diagnostic.permissionStatus.DENIED_ALWAYS:
                console.log("Permission permanently denied to use " + permission + " - guess we won't be using it then!");
                deniedPerm = true;
                break;
            }
          }
          if (!deniedPerm) {
            if (havePerm == 2) {
              //have both permissions granted
              obtainPhoto(index);
            } else if (havePerm < 2) {
              //both or one permission hasn't granted
              askMultiplePermissions(index);
            }
          } else {
            Utils.toast.error(Utils.translate('PLUGINS.PERMISSIONS.DENIED_PERMISSION') +
              Utils.translate('PLUGINS.PERMISSIONS.TYPE.CAMERA') + ' ' +
              Utils.translate('PLUGINS.PERMISSIONS.AND') + ' ' +
              Utils.translate('PLUGINS.PERMISSIONS.TYPE.GALLERY') + '. \n' +
              Utils.translate('PLUGINS.PERMISSIONS.ALWAYS_DENIED_PERMISSION'));
          }
        }, function(error) {
          console.error("The following error occurred: " + error);
        }, [
          cordova.plugins.diagnostic.permission.CAMERA,
          cordova.plugins.diagnostic.permission.READ_EXTERNAL_STORAGE
        ])
      }

      /**
       *function to get multiple permission for camera
       */
      function askMultiplePermissions(index) {
        cordova.plugins.diagnostic.requestRuntimePermissions(function(statuses) {
          var havePerm = 0;
          var deniedPerm = false;
          for (var permission in statuses) {
            switch (statuses[permission]) {
              case cordova.plugins.diagnostic.permissionStatus.GRANTED:
                console.log("Permission granted to use " + permission);
                havePerm++;
                break;
              case cordova.plugins.diagnostic.permissionStatus.NOT_REQUESTED:
                console.log("Permission to use " + permission + " has not been requested yet");
                havePerm--;
                break;
              case cordova.plugins.diagnostic.permissionStatus.DENIED:
                console.log("Permission denied to use " + permission + " - ask again?");
                havePerm--;
                break;
              case cordova.plugins.diagnostic.permissionStatus.DENIED_ALWAYS:
                console.log("Permission permanently denied to use " + permission + " - guess we won't be using it then!");
                deniedPerm = true;
                break;
            }
          }
          if (!deniedPerm) {
            if (havePerm == 2) {
              //have both permissions granted
              obtainPhoto(index);
            } else if (havePerm < 2) {
              //both or one permission hasn't granted
              Utils.toast.error(Utils.translate('PLUGINS.PERMISSIONS.DENIED_PERMISSION') +
                Utils.translate('PLUGINS.PERMISSIONS.TYPE.CAMERA') + ' ' +
                Utils.translate('PLUGINS.PERMISSIONS.AND') + ' ' +
                Utils.translate('PLUGINS.PERMISSIONS.TYPE.GALLERY') + '.');
            }
          } else {
            Utils.toast.error(Utils.translate('PLUGINS.PERMISSIONS.DENIED_PERMISSION') +
              Utils.translate('PLUGINS.PERMISSIONS.TYPE.CAMERA') + ' ' +
              Utils.translate('PLUGINS.PERMISSIONS.AND') + ' ' +
              Utils.translate('PLUGINS.PERMISSIONS.TYPE.GALLERY') + '. \n' +
              Utils.translate('PLUGINS.PERMISSIONS.ALWAYS_DENIED_PERMISSION'));
          }
        }, function(error) {
          console.error("The following error occurred: " + error);
        }, [
          cordova.plugins.diagnostic.permission.CAMERA,
          cordova.plugins.diagnostic.permission.READ_EXTERNAL_STORAGE
        ])
      }

      /**
       * funtion for get image
       **/
      $scope.uploadingPhoto = false;
      $scope.openCrop = false;

      function obtainPhoto(index) { //USING NEW PLUGIN MediaPicker
        $scope.data.pictures = [];
        if (index === 0) { // camera 
          ImageService2.saveCameraMediaProfilePhoto(index).then(function() {});
        } else { // library
          ImageService2.saveAlbumMediaProfilePhoto(index).then(function() {});
        }
      }

      $rootScope.$on("addedImageB", function() {
        showImageUser();
      })

      function showImageUser() {
        if ($scope.openCrop) {
          return true;
        }
        $scope.openCrop = true;
        var img = FileService2.images(); //$scope.data.pictures
        var exifTemp = FileService2.exifImage();
        if (img.length === 0) {
          $timeout(function() {
            showImageUser();
          }, 1000);
        } else {
          if ($scope.data.pictures === null || $scope.data.pictures === undefined || $scope.data.pictures.length === 0) {
            var opt = {};
            if (isIOS === true) {
              //prepare IOS
              opt = {
                url: img[0],
                width: 200,
                height: 200,
                circle: true,
                allowRotation: true,
                title: 'Usa tus dedos para ajustar la imagen'
              }
              $jrCrop.crop(opt).then(function(canvas) {
                // success!
                //$scope.$apply();
                $scope.data.pictures[0] = canvas.toDataURL();
                $timeout(function() {
                  $scope.openCrop = false;
                  $scope.$apply();
                }, 0);
              }, function(err) {
                console.error(err);
                $scope.data.pictures[0] = img[0];
                $scope.openCrop = false;
                $scope.$apply();
              });
            } else {
              var urlToUse = null;
              if (img[0].uri) {
                urlToUse = img[0].uri;
              } else {
                urlToUse = img[0];
              }
              opt = {
                url: urlToUse,
                width: 200,
                height: 200,
                circle: true,
                allowRotation: true,
                title: 'Usa tus dedos para ajustar la imagen'
              }
              $jrCrop.crop(opt).then(function(canvas) {
                // success!
                //$scope.$apply();
                $scope.data.pictures[0] = canvas.toDataURL();
                $timeout(function() {
                  $scope.openCrop = false;
                  $scope.$apply();
                }, 0);
              }, function(err) {
                console.error(err);
                $scope.data.pictures[0] = img[0];
                $scope.openCrop = false;
                $scope.$apply();
              });
            }
          } else {
            console.log("finish loading");
            $scope.openCrop = false;
          }
        }
      }

      /**
       * @return {Promise}
       */
      function defaultLogin() {
        return Utils.$q(function(resolve, reject) {
          AuthService.login('sven', 'm<}WU6ZEFvKqks-"').then(function() {
            resolve(true)
          }, function(error) {
            reject(error);
            console.error("Error login with sven", error);
          }) //<-login() with sven account
        })
      }

      /**
       * @return {Promise}
       */
      function addUser() {
        if ($scope.data.newUser.addCityToCatalog) {
          AddUserService.addCityToCatalogWS($scope.data.newUser.city).$promise.then(function() {
            console.log("The city '" + $scope.data.newUser.city + "' was added to catalog");
          }, function(error) {
            console.error("addCityToCatalog WS", error);
          })
        }

        return Utils.$q(function(resolve, reject) {
          $scope.data.realBirthday = $scope.data.newUser.birthday;

          //AddUserService.addUser().save({
          AddUserService.addUserv1174().save({
            firstName: { value: $scope.data.newUser.firstName }, //{value: splitName[0]},
            middleName: { value: "" }, //{value: middleName},
            lastName: { value: $scope.data.newUser.lastName }, //{value: splitLastName[0]},
            lastName2: { value: "" }, //{value: lastName2},
            username: { value: $scope.data.newUser.username.toUpperCase() },
            password: { value: $scope.data.newUser.password },
            passwordRepeat: { value: $scope.data.newUser.password },
            email: { value: $scope.data.newUser.email },
            passwordRecoveryQuestion: { value: "¿Access with Facebook?" },
            passwordRecoveryAnswer: { value: "No" },
            city: { value: $scope.data.newUser.city },
            facebookUser: { value: $scope.data.newUser.facebookUsername || '' },
            birthDate: { value: $scope.data.realBirthday }
          }).$promise.then(function(response) {
            resolve(response)
          }, function(error) {
            console.error("AddUserService.addUser()", error);
            reject(error);
          }); //<-addUser()
        })
      }

      /**
       * @return {Promise}
       */
      function realLogin(addUserResponse) {
        return Utils.$q(function(resolve, reject) {
          AuthService.logout();
          //Check if is retrieve by other resquest.
          $scope.data.newUser.href = addUserResponse.result.links[0].href;
          window.localStorage.setItem("applicationUser", addUserResponse.result.members.applicationUser.value.href);
          window.localStorage.setItem("userName", $scope.data.newUser.username);
          window.localStorage.setItem("simpleUserId", addUserResponse.result.members.userId.value);
          window.localStorage.setItem("simpleUserInstanceId", addUserResponse.result.instanceId);
          window.localStorage.setItem("userEmail", $scope.data.newUser.email);
          window.localStorage.setItem("birthDate", $scope.data.realBirthday);

          AuthService.login(
            $scope.data.newUser.username.toUpperCase(),
            $scope.data.newUser.password
          ).then(function() {
            resolve(true)
          }, function(error) {
            console.error("Error login with new user", error);
            reject(error);
          }) //<--login() with real user account
        })
      }

      /**
       * @return {Promise}
       */
      function addSubscription() {
        return Utils.$q(function(resolve, reject) {
          var nms = $scope.data.newUser.needMembership; 
          var otl = $scope.data.newUser.openTL;
          var ums = " ";
          if($scope.data.newUser.passCode === null || $scope.data.newUser.passCode === undefined) {
            ums = " ";
          } else {
            ums = $scope.data.newUser.passCode;
          }
          AddSubscriptionService.addSubscriptionv201().save({
            user: {
              value: {
                href: $scope.data.newUser.href
              }
            },
            onBoarding: {
              value: otl
            },
            code: {
              value: ums.toUpperCase()
            }
          }, function success(response) {
            window.localStorage.setItem("ownPrivate", response.result.members.privateAccount.value);
            window.localStorage.setItem("name", response.result.members.name.value);
            window.localStorage.setItem("firstName", $scope.data.newUser.firstName);
            window.localStorage.setItem("lastName", $scope.data.newUser.lastName);
            window.localStorage.setItem("userSubscriptionId", response.result.title.substr(response.result.title.lastIndexOf("-") + 1).replace(",", ""));
            window.localStorage.setItem("userSubscriptionInstanceId", response.result.instanceId);
            window.localStorage.setItem("userSubscriptionHref", ApiEndPoint.url + "restful/objects/simple.UserSubscription/" + response.result.instanceId);
            $scope.accountStatus = response.result.members.accountStatus.value;
            DBServices.execute("SELECT * FROM userSession").then(
              function(dbResp) {
                var columns = dbResp.extractItems();
                if (columns.length > 0) {
                  DBServices.execute("UPDATE userSession set userSubsId = ?, userSubsInstId = ?, userName = ?, onBoard = ? WHERE userSubsId = ?",
                    [
                      response.result.title.substr(response.result.title.lastIndexOf("-") + 1).replace(",", ""),
                      response.result.instanceId,
                      response.result.members.name.value,
                      "yes",
                      response.result.title.substr(response.result.title.lastIndexOf("-") + 1).replace(",", "")
                    ]).then(function(updateResp) {}, function(updateError) {})
                } else {
                  DBServices.execute("INSERT INTO userSession values(?,?,?,?)",
                    [
                      response.result.title.substr(response.result.title.lastIndexOf("-") + 1).replace(",", ""),
                      response.result.instanceId,
                      response.result.members.name.value,
                      "yes"
                    ]).then(function(insertResp) {}, function(insertError) {})
                }
              },
              function(errorDb) {}
            );
            $scope.rolID = response.result.members.role.value.href;
            //NEW STEP
            $scope.newUserSubs = response.result.members.userSubscriptionId.value;
            var generatedSubs = AddSubscriptionService.generateSubscriptionv200({
              userSubs: $scope.newUserSubs 
            }).$promise.then( function success(response) {
              console.log("done");
            }, function error(data) {
              if (data && (data.status === 504 || data.status === -1)) {
                console.log("We don't care");
              } else {
                console.log("fallo en cliente");
              }
            })
            resolve(response);
          }, function error(mistakeData) {
            console.error("AddSubscriptionService.addSubscription()", error);
            reject(error);
          })
        })
      }

      /**
       * @return {Promise}
       */
      function addAWSToken() {
        return Utils.$q(function(resolve, reject) {
          if (window.localStorage.getItem('AWSToken') && (window.localStorage.getItem('AWSToken') != '(null)')) {
            console.log("A previous AWS token found in local storage");
            AWSServices.awsInit();
            resolve(true);
          } else {
            console.log("-- Getting and setting AWS token...");
            //$ionicPlatform.ready(function() {
              var isIOS = ionic.Platform.isIOS();
              if (isIOS === true) {
                  FCMPlugin.hasPermission(function(response) {
                      console.log("RES:", response);
                      if(response) {
                          FCMPlugin.getAPNSToken(function(token) {
                            //console.log("firebaseToken => " + token);
                            window.localStorage.setItem('AWSToken', token);
                              AWSServices.awsInit();
                              resolve(true);
                          }, function(error) {
                            //alert("Couldn't get FCM token because: " +JSON.stringify(error));
                            console.error("Couldn't get FCM token because: ", error);
                          });
                      }
                  }, function (error) {
                      console.error("ERR: ", error);
                  })
                /*if (window.ApnsToken) {
                  ApnsToken.getToken(function(token) {
                    window.localStorage.setItem('AWSToken', token);
                    if (typeof FCMPlugin != 'undefined') {
                      console.log("-- OK, AWS token was retrieved successfully");
                      AWSServices.awsInit();
                      resolve(true);
                    } else {
                      console.error("--FCMPlugin is not installed");
                      reject("FCMPlugin is not installed")
                    }
                  }, function(error) {
                    console.error("-- can't get ios token", error);
                    $scope.checkTerms = false;
                    reject(error)
                  })
                } else {
                  console.error("-- NO ApnsToken Plugin found");
                  reject("NO ApnsToken Plugin found");
                }*/
              } else {
                if (typeof window.FCMPlugin != 'undefined') {
                  FCMPlugin.getToken(function(token) {
                    console.log("-- OK, AWS token was retrieved successfully");
                    window.localStorage.setItem('AWSToken', token);
                    AWSServices.awsInit();
                    resolve(true);
                  }, function(error) {
                    console.error("-- couldn't get FCM token because: ", response);
                    $scope.checkTerms = false;
                    reject(error)
                  })
                } else {
                  console.error("-- NO FCMPlugin Plugin found");
                  reject("NO FCMPlugin Plugin found")
                }
              }
            //})
          }
        })
      }

      function addUserBio() {
        console.log("Adding user bio...");
        if ($scope.data.newUser.bio) {
          UserService.editTextfromUserBiography({
            objectId: window.localStorage.getItem("userSubscriptionInstanceId")
          }).save({
            string: { value: $scope.data.newUser.bio }
          }, function() {
            console.log("OK, User bio added");
            window.localStorage.setItem("userBiography", $scope.data.newUser.bio);
          }, function(error) {
            console.error("User bio couldn't be added", error);
          });
        } else {
          console.log("OK, User bio added");
          window.localStorage.setItem("userBiography", Utils.translate('GLOBAL.BIO'));
        }
      }

      /**
       *
       * @param params {{userSubscriptionId: string, code: string}}
       * @return {Promise}
       */

      /*function redeemCode(params) {
        return Utils.$q(function (resolve, reject) {
          UserService.redeemCodeWS({
            userSubscriptionId: params.userSubscriptionId,
            code: params.code
          }).$promise.then(function () {
            console.log("-- OK redeemCode");
            resolve(response);
          }, function (error) {
            console.error("-- redeemCode", error);
            reject(error);
          })
        });
      }*/

      /**
       * @return {Promise}
       */
      function uploadProfilePictures() {
        return Utils.$q(function(resolve, reject) {
          //var realPhotoName = $scope.data.newUser.username.replace(" ", "_");
          //var pictureName = realPhotoName + "_" + window.localStorage.getItem("simpleUserId");
          //Steps to upload
          var s3Service = new AWS.S3({
            apiVersion: '2006-03-01',
            params: { Bucket: s3.bucket }
          });
          //encrypt subscriptioninstanceID and folder name
          var userSubscriptionInstanceId = md5.createHash(window.localStorage.getItem("userSubscriptionInstanceId"));
          var folder = md5.createHash("profilePicture");

          //create key for each picture
          var photoSmallKey = s3.prefix + '/' + userSubscriptionInstanceId + '/' + folder + '/' + 'small.jpg';
          /*var photoNormalKey = s3.prefix + '/' + userSubscriptionInstanceId + '/' + folder + '/' + 'normal.jpg';
          var photoLargeKey = s3.prefix + '/' + userSubscriptionInstanceId + '/' + folder + '/' + 'large.jpg';*/

          //photo to blob
          var fileSmall = Utils.dataURLtoBlob($scope.data.pictures[0]);
          /*var fileNormal = Utils.dataURLtoBlob($scope.data.pictures[1]);
          var fileLarge = Utils.dataURLtoBlob($scope.data.pictures[2]);*/

          //upload to s3
          s3Service.upload({
            Key: photoSmallKey,
            Body: fileSmall,
            ACL: 'public-read',
            ContentType: fileSmall.type
          }, function(err, data) {
            if (err) {
              return console.log('There was an error uploading the main jpg:'); // cancel all
              return reject(err);
            }
            if (data) {
              console.log("OK, Now updating profile images fields in DB...");
              updateProfilePicture({
                photoSmallKey: photoSmallKey,
                photoNormalKey: photoSmallKey,
                photoLargeKey: photoSmallKey
              }).then(function() {
                resolve();
              }, function(error) {
                reject(error)
              })
            }
          })
          //small
        })
      }

      /**
       * @param uploadPicsResponse {{photoSmallKey:string, photoNormalKey:string, photoLargeKey: string}}
       * @return {Promise}
       */
      function updateProfilePicture(uploadPicsResponse) {
        return Utils.$q(function(resolve, reject) {
          //upload to server
          var profilePictureBucket = "http://s3-us-west-2.amazonaws.com/" + s3.bucket + "/";
          changeProfilePictureService.changeProfPictv181({
            userSubscriptionId: window.localStorage.getItem("userSubscriptionInstanceId")
          }).save({
            profilePictureSmallUrl: { value: profilePictureBucket + uploadPicsResponse.photoSmallKey },
            profilePictureMedUrl: { value: profilePictureBucket + uploadPicsResponse.photoNormalKey },
            profilePictureLargeUrl: { value: profilePictureBucket + uploadPicsResponse.photoLargeKey }
          }, function() {
            //window.localStorage.setItem("photoProfileBlob", $scope.data.pictures[0] );
            window.localStorage.setItem("photoProfileBlob", profilePictureBucket + uploadPicsResponse.photoLargeKey);
            AddUserService.newUser = {};
            FileService2.cleanImages();
            resolve(true)
          }, function(error) {
            console.error('changeProfilePictureService.changeProfPict error', error);
            reject(error)
          });
        })
      }

      function sendToDefaultLandPage() {
        console.log("Finally redirecting to discovery...");

        //check permissions based of role ID
        getRolePermissionAndSetUserData(+Utils.getLastUrlComponent($scope.rolID)).then(function(boolResp) {
          //here is new user so only check if the app have TL closed or not
          var pivot = JSON.parse(window.localStorage.getItem('AppsPerzonalized'));
          window.localStorage.setItem('legalVer', pivot.legalVer);
          UserService.updateLegalUserVersion({
            objectId: window.localStorage.getItem("userSubscriptionInstanceId")
          }).save({
            int: { value: pivot.legalVer }
          }, function(ret) {
            window.localStorage.setItem('legalVer', pivot.legalVer);
          }, function(err) {
            console.error("can't save legal");
          })
          if (pivot.TypeOfOnboarding === 0) {
            $state.go('menu.discovery', {}, { reload: true });
          } else {
            if($scope.accountStatus === 'Active') //
              $state.go('menu.discovery', {}, { reload: true });
            else 
              $state.go('standbyPage', {}, { reload: true });
          }

          setTimeout(function() {
            Utils.loading.hide();
            $localForage.setItem('userSubscriptionId', window.localStorage.getItem('userSubscriptionId')).then(function(userSubsId) {
              //if the LS is in good state
              $localForage.setItem('userSubscriptionInstanceId', window.localStorage.getItem('userSubscriptionInstanceId')).then(function(userSubsInstId) {
                console.log("LOCALFORAGE UPDATED");
              })
            });
            $rootScope.$broadcast('login.success', { isSignUp: true });
          }, 1000);
        }, function(error) {
          console.error("getRolePermissions", error);
          Utils.alert.show(Utils.translate('ADMIN_TOOLS.ADMIN_PERMISSIONS.DIALOG.LOAD_PERMS_IN_LOGIN_ERROR')).then(function() {
            location.reload();
          })
          var tempPers = window.localStorage.getItem('AppsPerzonalized');
          window.localStorage.clear();
          window.localStorage.setItem("AppsPerzonalized", tempPers);
          window.localStorage.setItem("onboardingComplete", "yes");
        })
      }

      function onCreateAccounError() {
        $scope.data.creating = false;
        Utils.loading.hide();
      }

      function addMemberShip() {
      }

      $scope.methods.createAccount = function() {
        $scope.data.creating = true;
        Utils.loading.show();
        console.log("Login in with default credentials...");
        defaultLogin().then(function() {
          console.log("OK, Now Adding user...");
          addUser().then(function(addUserResponse) {
            console.log("OK, Now Login in with real user credentials...");
            realLogin(addUserResponse).then(function() {
              console.log("OK, Now adding user subscription...");
              addSubscription().then(function() {

                addAWSToken().then();

                addUserBio();

                /*if($scope.data.newUser.membership === "" || $scope.data.newUser.membership === null || $scope.data.newUser.membership === undefined) {
                  //nothing
                  //
                } else {
                  addMemberShip();
                }*/
                /*if ($scope.data.newUser.redeemableCode) {
                  redeemCode({
                    userSubscriptionId: Utils.getLastUrlComponent($scope.data.newUser.href),
                    code: $scope.data.newUser.redeemableCode
                  }).then();
                }*/

                if ($scope.data.pictures.length === 0) {
                  console.log("User didn't choose profile image");
                  AddUserService.newUser = {};
                  sendToDefaultLandPage()
                } else {
                  console.log("OK, Now Uploading profile images choosen...");
                  uploadProfilePictures().then(function() {
                    console.log("OK, Now Setting DB defaults...");
                    setDefaultsDataBase(4).then(function() {
                      console.log("DB is set OK");
                    }, function() {
                      //Error: set Defaults Data Base
                    }).finally(function() {
                      sendToDefaultLandPage()
                    });
                  }, function() {
                    //Error: upload profile images
                    sendToDefaultLandPage();
                  })
                }
              }, function() {
                //Error: Add subscription
                onCreateAccounError();
              })
            }, function() {
              //Error: real login (with real user credentials
              onCreateAccounError();
            })
          }, function() {
            //Error: add User
            onCreateAccounError();
          })
        }, function() {
          //Error: default login
          onCreateAccounError();
        })
      }; //<-$scope.methods.createAccount()

      /**
       * @param roleId {number}
       * @returns {Promise}
       */
      function getRolePermissionAndSetUserData(roleId) {
        return Utils.$q(function(resolve, reject) {
          AppAdminRolesService.getRolePermissions(roleId).then(function(resources) {
            //console.log("Updating role/permissions...");
            //console.log("Permissions",resources);

            if (resources.length && !resources[resources.length - 1].codeName)
              resources.splice(resources.length - 1, 1);

            /**@type {string[]}*/
            var PERMISSIONS = [];
            resources.forEach(function(permission) {
              PERMISSIONS.push(permission.codeName);
            });

            //console.log("PERMISSIONS",PERMISSIONS);
            UserService.set_USER_PERMISSIONS(PERMISSIONS);

            resolve(true)
          }, function(error) {
            console.error("getRolePermissions", error);
            reject(error)
          })
        })
      }

      //Zone for Database about user
      /**
       * @param option {number}
       * @return {Promise}
       */
      function setDefaultsDataBase(option) {
        return Utils.$q(function(resolve, reject) {
          //case to set tutorial in default
          switch (option) {
            case 1:
              {
                //var statusJson = [];
                //var listOfTutorials = ["discovery", "upload", "timelineOrganize", "favorites"];

                var statusJson1 = JSON.stringify({ first: true, second: true });
                var statusJson2 = JSON.stringify({ first: true });

                DBServices.batch([
                  ["INSERT INTO tutorials (name, visited) VALUES (?,?)", ["discovery", statusJson1]],
                  ["INSERT INTO tutorials (name, visited) VALUES (?,?)", ["upload", statusJson1]],
                  ["INSERT INTO tutorials (name, visited) VALUES (?,?)", ["favorites", statusJson1]],
                  ["INSERT INTO tutorials (name, visited) VALUES (?,?)", ["timelineOrganize", statusJson2]]
                ]).then(function() {
                  resolve(setDefaultsDataBase(5));
                }, function(error) {
                  console.error('Case 1: Transaction ERROR:', error);
                  resolve(setDefaultsDataBase(5));
                });
              }
              break;
            case 2:
              //case to set log count in default
              DBServices.execute(
                "INSERT INTO userLogCount (name, count) VALUES (?, ?)",
                [window.localStorage.getItem("name"), 1]
              ).then(function(value) {
                resolve(setDefaultsDataBase(3));
              }, function(error) {
                console.error("Case 2: Insert log Count error", error);
                resolve(setDefaultsDataBase(5));
              });
              break;
            case 3:
              //check if table for tutorial have any data
              DBServices.execute("SELECT * FROM tutorials").then(function(resultSet) {
                resolve(resultSet.rows.length > 0 ? setDefaultsDataBase(5) : setDefaultsDataBase(1));
              }, function(error) {
                console.error("Case 3: SELECT tutorials error", error);
                resolve(setDefaultsDataBase(5));
              });
              break;
            case 4:
              //check if table for login count have any data
              DBServices.execute(
                "SELECT * FROM userLogCount WHERE name = ?",
                [window.localStorage.getItem("name")]
              ).then(function(resultSet) {
                resolve(resultSet.rows.length > 0 ? setDefaultsDataBase(3) : setDefaultsDataBase(2));
              }, function(error) {
                console.error('Case 4: Execute SELECT logCount error in', error);
                resolve(setDefaultsDataBase(5));
              });
              break;
            case 5:
              //after all we need to redirect acordly
              resolve(true);
              break;
            default:
              reject("Defaults database option '" + option + "' no valid");
          }
        });
      }

      //End Zone for Database about user
      var lang = $window.navigator.languages ?
                 $window.navigator.languages[0] :
                 ($window.navigator.language || $window.navigator.userLanguage);
      $scope.english= false;
      if(lang.includes("es-")) {
        $scope.english= false;
      } else {
        $scope.english= true;
      }

      //Politics
      $scope.redirectPolitics = function() {
        var isIOS = ionic.Platform.isIOS();
        var zone = '_blank';
        var opt = '';
        if(isIOS){
          zone = '_blank';
          opt = 'clearsessioncache=yes,usewkwebview=yes,toolbar=yes,presentationstyle=fullscreen,hidespinner=yes,closebuttoncaption=Close,closebuttoncolor=#ffffff4,navigationbuttoncolor=#ffffff,lefttoright=yes,location=no';
        }
        else{
          zone ='_blank';
          opt = 'clearsessioncache=yes,usewkwebview=yes,toolbar=yes,presentationstyle=fullscreen,hidespinner=yes,closebuttoncaptionSet=Close,closeButtonColorSet=#ffffff4,navigationbuttoncolorSet=#ffffff,lefttoright=yes,location=no';
        }
        if (lang.includes("es")) {
          var ref = cordova.InAppBrowser.open( 'https://niido.cloud/'+ legalURl.app +'/politicaprivacidad.html', zone, opt);
        } else if (lang.includes("en")) {
          var ref = cordova.InAppBrowser.open( 'https://niido.cloud/'+ legalURl.app +'/privacypolicy.html', zone, opt);
        }
      }
      //Terms of use
      $scope.redirectTerms = function() {
        var isIOS = ionic.Platform.isIOS();
        var zone = '_blank';
        var opt = '';
        if(isIOS){
          zone = '_blank';
          opt = 'clearsessioncache=yes,usewkwebview=yes,toolbar=yes,presentationstyle=fullscreen,hidespinner=yes,closebuttoncaption=Close,closebuttoncolor=#ffffff4,navigationbuttoncolor=#ffffff,lefttoright=yes,location=no';
        }
        else{
          zone ='_blank';
          opt = 'clearsessioncache=yes,usewkwebview=yes,toolbar=yes,presentationstyle=fullscreen,hidespinner=yes,closebuttoncaptionSet=Close,closeButtonColorSet=#ffffff4,navigationbuttoncolorSet=#ffffff,lefttoright=yes,location=no';
        }
        if (lang.includes("es")) {
          var ref = cordova.InAppBrowser.open( 'https://niido.cloud/'+ legalURl.app +'/terminosycondiciones.html', zone, opt);
        } else if (lang.includes("en")) {
          var ref = cordova.InAppBrowser.open( 'https://niido.cloud/'+ legalURl.app +'/termsandconditions.html', zone, opt);
        }
      }

      //ASK AWS TO RETRY UPLOAD UPDATING TIMESTAMP
      AWS.events.on('retry', function(response) {  
        if (response.error.name === 'RequestTimeTooSkewed') {
          console.error('User time is not correct. Handling error!');
          console.log('AWS systemClockOffset:', AWS.config.systemClockOffset);
          var serverTime = Date.parse(response.httpResponse.headers['date']);
          var timeNow = new Date().getTime();
          console.log('AWS timestamp:', new Date(serverTime));
          console.log('Browser timestamp:', new Date(timeNow));
          AWS.config.systemClockOffset = Math.abs(timeNow - serverTime);
          response.error.retryable = true;
          console.log('Setting systemClockOffset to:', AWS.config.systemClockOffset);
          console.log('Retrying uploading to S3 once more...');
        }
      });
    }
  ]);
