"use strict";
appControllers
  .controller('notificationsTabsCtrl', ['$rootScope', '$scope', 'notificationsService', 'Utils', function ($rootScope, $scope, notificationsService, Utils) {
    Utils.clearHistory();

    //console.log("notificationsTabsCtrl created!!!");

    $scope.badges = notificationsService.badges;

  }])
  //LuMa Se agrego 'StreamingService' al controler 
  .controller('notificationsRegularCtrl', ['$rootScope', '$scope', '$state', '$ionicPopup', 'notificationsService', 'UserService', 'SequenceService', 'reDirectService', 'selectedSequenceData', 'GroupFactory', 'Utils', '$location', 'StreamingService', '$anchorScroll',
    function ($rootScope, $scope, $state, $ionicPopup, notificationsService, UserService, SequenceService, reDirectService, selectedSequenceData, GroupFactory, Utils, $location, StreamingService, $anchorScroll) {
    //console.log("notificationsRegularCtrl created!!!");
    var mySubscriptionId = UserService.get_USERSUBSCRIPTIONINSTANCE_ID();

    $scope.notifications = notificationsService.notifications.regular;

    $scope.unreadNotifications = 0;

    $scope.isFirstTime = true;
    $scope.isRefreshing = false;
    $scope.isLoadingContent = false;
    $scope.canGetMoreItems = true;
    $scope.isReading = false;//LuMa activar variable
    $scope.returnShow = false;
    $scope.totalNotifLoaded = 0;
    $scope.wsCalled = 0;
    $scope.ViewHeight = 0;
    var toastCtrl = Utils.toast.getCtrl();
    var newNotifToast;

    function closeNewNotificationsToast() {
      //console.log("Closing notifications...");
      if (newNotifToast) {
        toastCtrl.clear(newNotifToast);
        toastCtrl.remove(newNotifToast);//myabe it's unnecessary
      }

      newNotifToast = undefined;
    }

    $scope.reloadToViewNewNotifications = function (mustReload) {
      if (mustReload) {
        $scope.refreshItems(true);//true == keep old data
      }

      closeNewNotificationsToast();
    };

    $scope.showNewNotificationsToast = function () {
      if (true) {
        console.log("there are new notifications but by now, I can't show you any message ;(");
        return;
      }

      newNotifToast = toastCtrl.info(
        Utils.translate('NOTIFICATIONS.DIALOG.NEW_REG_NOTIF_FOUND') +
        '<br><button id="reg-notif-close" class="md-button md-raised" ng-click="reloadToViewNewNotifications(false)">' +
        Utils.translate('GLOBAL.NO') +
        '</button>' +
        '<button id="reg-notif-reload" class="md-button md-raised md-primary" ng-click="reloadToViewNewNotifications(true)">' +
        Utils.translate('GLOBAL.YES') +
        '</button>', {
          allowHtml: true, timeOut: 0, extendedTimeOut: 0, tapToDismiss: false, onShown: function () {
            var el1 = document.getElementById('reg-notif-reload');
            if (el1) Utils.$compile(el1)($scope);
            var el2 = document.getElementById('reg-notif-close');
            if (el2) Utils.$compile(el2)($scope);
          }
        });

      $scope.isRefreshing = false;
      $scope.isLoadingContent = false;
      $scope.$broadcast('scroll.refreshComplete');
      $scope.$broadcast('scroll.infiniteScrollComplete');
    };

    $scope.$on("$ionicView.enter", function () {
      //FIRST STEP: GET HEIGHT FROM VIEW
        if($rootScope.viewScrollHeight) {
          $scope.ViewHeight = $rootScope.viewScrollHeight;
        } else {
          $scope.ViewHeight = (window.innerHeight || document.documentElement.clientHeight);
        }
      //SECOND STEP: GET ITEM SCROLL LAST POSITION FROM ROOTSCOPE
        var posYb = 0;
        if($rootScope.itemAnchorYb) {
          posYb = $rootScope.itemAnchorYb;
        } else {
          posYb = 0;
        }
        var posYt = 0;
        if($rootScope.itemAnchorYb) {
          posYt = $rootScope.itemAnchorYb;
        } else {
          posYt = 0;
        }
      //console.log("anchor: ",  $anchorScroll);
      if($rootScope.cancelRefreshNotif) {
        //STEP CHECK NOTIF CALLED
          if($rootScope.totalLoaded) {
            $scope.totalNotifLoaded = $rootScope.totalLoaded;
          }
          if($rootScope.wsCalled) {
            $scope.wsCalled = $rootScope.wsCalled;
          }
        //STEP CHECK ANCHOR AND DO THE MOVEMENT
        if($rootScope.anchorID) {
          for(var i = $rootScope.anchorID; i > 0; i-- ) {
            var h1 = document.getElementById("pos"+i);
            var posT = h1.getBoundingClientRect().top;
            var tall = (posT * 100) / $scope.ViewHeight;
            if(tall < 20) {
              //this is the needed anchor
              Utils.$timeout(function () {
                var anchorF = document.getElementById("pos"+ i);
                anchorF.scrollIntoView({block: "start", behavior: "auto"});
              }, 0);
              break;
            }
          }
        }
        /*if($rootScope.anchorID) {
          if($rootScope.totalLoaded < 11) { //ALL LOADED < 10
            $location.hash(); // NO MOVEMENT
          } else { // LOADED EXCESS ONE SCREEN LARGE
            //CHECK CLICK TO LAST
            var lastRank = ( $rootScope.totalLoaded - $rootScope.anchorID ) <= 5 ? true : false;
            var lastRankSteps = 5 - ( $rootScope.totalLoaded - $rootScope.anchorID );
            //CHECK CLICK TO BEGIN
            var firstRank = $rootScope.anchorID <= 5 ? true : false;
            var firstRankSteps = $rootScope.anchorID - 5;

            //VALIDATIONS
            if(lastRank) { //NEAR INFINITE SCROLL, GO UP SOME STEPS
              if(firstRank) //ALSO NEAR BEGIN (IMPOSIBLE TO GET HERE BECAUSE FIRST IF - 86)
                $location.hash(); // NO MOVEMENT
              else { //CAN MOVE UP
                if(firstRankSteps > 3)
                  $location.hash('pos'+ ($rootScope.anchorID -3 ) );
                else
                  $location.hash('pos'+ $rootScope.anchorID );
              }
            } else { //NOT NEAR INFINITE SCROLL, DOESN'T NEED TO GO UP
              if(firstRank) //NEAR BEGIN CAN'T MOVE SCROLL UP
                $location.hash('pos'+ $rootScope.anchorID );
              else {
                if(firstRankSteps > 3)
                  $location.hash('pos'+ ($rootScope.anchorID -3 ) );
                else
                  $location.hash('pos'+ $rootScope.anchorID );
              }
            }
          }
          //FINALLY MADE THE MOVEMENT
          $anchorScroll();
        } else {
          //DOESN'T HAVE ANCHOR CAN'T DO ANYTHING
        }*/
      } else {
        console.error("FALSE");
        $rootScope.cancelRefreshNotif = false;
      }
      if ($scope.isFirstTime && $rootScope.cancelRefreshNotif === false) {
        $scope.getMoreItems();
        return;
      }

      $scope.isLoadingContent = true;
      countUnreadRegularNotifications().then(function (numUnreadNotif) {
        //console.log("$scope.unreadNotifications: " + $scope.unreadNotifications + "; unread notif: " + numUnreadNotif);

        if (numUnreadNotif > 0) {//$scope.unreadNotifications) {
          $scope.unreadNotifications = numUnreadNotif;
          //$scope.showNewNotificationsToast();
        }
      }, function (error) {
        console.error(error);
      }).finally(function () {
        $scope.isLoadingContent = false;
      })
    });

    //we use this because $ionicView.???Leave events doesn't trigger with the (current side-menus) + tabs structure
    //only on changes between tabs or inside tab
    $rootScope.$on('$stateChangeStart', function (event, toState, toParams, fromState, fromParams) {
      console.log("TRIGGER VIEW CHANGE");
      if (fromState.name === 'menu.notificationTabs.regular') {
        $scope.canGetMoreItems = true;
        closeNewNotificationsToast();
        if(toState.name != 'showNotification') {
          if(toState.name != 'menu.notificationTabs.regular') {
            if(toState.name != 'menu.notificationTabs.follwers') {
              updatePackNotificationStatus(1);
              updateVisualNotificationsBeforeLeave();
            }
          }
        }
      } else if (fromState.name === 'showNotification') {
        if(toState.name != 'menu.notificationTabs.regular') { 
          //updatePackNotificationStatus(1);
          //updateVisualNotificationsBeforeLeave();
        }
      }
    });

    function updatePackNotificationStatus(type) {
      var myId = UserService.get_USERSUBSCRIPTION_ID();
      return Utils.$q(function (resolve, reject) {
        UserService.updatePackNotificationStatus().post({
          "userSubscriptionId": {"value": myId },
          "notificationsType": {"value": type}
        }, function (data) {
          $scope.unreadNotifications = 0;
          console.log("everything it's all right", $scope.unreadNotifications);
        }, function (err) {
          console.log("can't update them", $scope.unreadNotifications);
        })
      })
    }

    function updateVisualNotificationsBeforeLeave() {
      console.log("change the visual for all notifications updated");
      $scope.notifications.forEach(function (indNotif) {
        if(indNotif.notificationType != 4) {
          //the reacts will never be auto updated
          indNotif.notificationStatusInt = 3;
          indNotif.notificationStatus = 'Sent';
          if(notificationsService.badges.unreadRegularNotifications > 0)
            notificationsService.badges.unreadRegularNotifications--;
          else
            notificationsService.badges.unreadRegularNotifications = 0;

        } else {
          //if any react already seen
          if(indNotif.notificationStatus = 'Read')
            indNotif.notificationStatusInt = 3;
        }
      })
    }

    /*$rootScope.$on('$ionicView.beforeLeave', function (event, toState, toParams, fromState, fromParams) {
      if ($scope.unreadNotifications > 0) {
        //the user is leaving the page with unreaded notifications
        //check if the user doesn't go to showNotification if they we don't clean
        //UserService.cleanAllNotifications
      } else {
        //nothing here
      }
    });*/

    $scope.getMoreItems = function () {
      if ($scope.isLoadingContent) return;

      $scope.isLoadingContent = true;
      countUnreadRegularNotifications().then(function (numUnreadNotif) {
        //console.log("LOCAL unread notif: " + $scope.unreadNotifications + "; REMOTE unread notif: " + numUnreadNotif);

        //if new notifications were found (after scrolling down or view re-enter)
        if (numUnreadNotif > $scope.unreadNotifications && !$scope.isFirstTime) {
          $scope.unreadNotifications = numUnreadNotif;
          //$scope.showNewNotificationsToast();
          $scope.isLoadingContent = false;
          return;
        }

        $scope.unreadNotifications = numUnreadNotif;

        getAllRegularNotifications().then(function (newNotifications) {
          //console.log(newNotifications);
          if (!notificationsService.notifications.regular.length) {// || $scope.newNotificationsFound) {
            $scope.notifications = notificationsService.notifications.regular = newNotifications;
            Utils.$ionicScrollDelegate.scrollTop();
            Utils.$ionicScrollDelegate.resize();
            $scope.isLoadingContent = false;
            return;
          }

          notificationsService.notifications.regular = notificationsService.notifications.regular.concat(newNotifications);
          $scope.notifications = notificationsService.notifications.regular;
          Utils.$ionicScrollDelegate.resize();
          $scope.isLoadingContent = false;
        }, function (error) {
          console.error(error);
          $scope.isLoadingContent = false;
        });
      }, function (error) {
        console.error(error);
        $scope.isLoadingContent = false;
      })
    };

    /**
     * @param notificationId {Object}
     * @returns {Promise}
     */
    function updateNotificationStatus(notificationId) {
      return Utils.$q(function (resolve, reject) {
        UserService.updateNotificationStatus({
          objectId: notificationId
        }).save({int: {value: 3}}).$promise.then(function () {
          resolve(notificationId)
        }, function (error) {
          reject(error);
          console.error("updateNotificationStatus error", error);
        });
      })
    }

    /**
     * @returns {Promise} - Number
     */
    function countUnreadRegularNotifications() {
      return Utils.$q(function (resolve, reject) {
        notificationsService.countPendingRegularNotifications(UserService.get_USER_INSTANCE_HREF()).then(function (total) {
          resolve(total);
        }, function (error) {
          console.error("countPendingNotifications error", error);
          $scope.errorLoading = true;
          $scope.isRefreshing = false;
          $scope.isLoadingContent = false;
          $scope.canGetMoreItems = false;
          $scope.$broadcast('scroll.refreshComplete');
          $scope.$broadcast('scroll.infiniteScrollComplete');
          reject(error);
        });

        notificationsService.countPendingFollowersNotifications(UserService.get_USER_INSTANCE_HREF());
      })
    }

    /**
     * @returns {Promise}
     */
    function getAllRegularNotifications() {
      return Utils.$q(function (resolve, reject) {
        //console.log("pagination", notificationsService.paginator.regular.pagination);
        UserService.findAllUserNotificationsByUserSubscriptionNotifications(
          mySubscriptionId,
          notificationsService.paginator.regular.pagination
        ).then(function (allUserNotifications) {
          //console.log("allUserNotifications", allUserNotifications);

          var notifications = [];
          if(allUserNotifications.length > 0) {
            $scope.wsCalled++;
          }
          console.error("WS CALLED: ", $scope.wsCalled);
          allUserNotifications.forEach(function (notification) {
            // mantain the total of notifications loaded
            $scope.totalNotifLoaded++;
            console.error("TOTAL LOADED", $scope.totalNotifLoaded);
            //-------------  START OF: Filter out the existing notifications ------
            var exists = $scope.notifications.some(function (currNotif) {
              return notification.userNotification.href === currNotif.userNotification.href
            });

            if (exists) {
              //console.log("id: "+Utils.getLastUrlComponent(notification.userNotification.href)+" already exists");
              return; //<-- this will make the foreach to continue with the next item...
            }
            //----------- END OF: Filter out the existing notifications ---------

            var friendHref = notification.userSubscriptionSent.href;
            var friendSubscriptionIntanceId = Utils.getLastUrlComponent(friendHref);

            //prepare the data of the user that make the action for the notification
            //var userSend = UserService.getUserSubscriptionByinstanceId(friendSubscriptionIntanceId);
            var userSend = UserService.getUserSubscriptionByinstanceIdProfileData(friendSubscriptionIntanceId);
            //prepare the data to check if user is following the new follower
            var isFollowed = UserService.getFollowingIsActiveWS({
              userInstanceId: mySubscriptionId,
              friendInstaceId: Utils.getLastUrlComponent(friendHref)
            });

            var ownerSequence = null;
            var postExists = false;
            if (notification.sequence) {
              //ownerSequence = SequenceService.obtainSequence(Utils.getLastUrlComponent(notification.sequence.href));
              postExists = SequenceService.isValidSequenceBySequenceId(notification.sequenceId);
              //postExists = true;
            } else {
              postExists = false;
            }

            //console.log(userSend.members)
            var realImg;
            if (notification.sequenceUrl != null) {
              var nameArchive = Utils.getLastUrlComponent(notification.sequenceUrl);//OmRo
              var nameExtension = nameArchive.split('.')[1];
              if (nameExtension != 'jpg') {
                realImg = 'img/icons/photo_camera_24px.svg';
              } else {
                realImg = notification.sequenceUrl;
              }
            }
            else {
              realImg = 'img/icons/edit_24px.svg';
            }

            /************************************************************************************/
            /*NOTIFICATIONS TYPE*****************************************************************/
            /*FOLLOW---------------A user has started following you--------------------------1***/
            /*VIRAL----------------You have a viral sequence---------------------------------2***/
            /*PRIVATE--------------A user wants to follow you  and you have private profile--3***/
            /*REACTION-------------A user sent you a reaction--------------------------------4***/
            /*LIKE-----------------A user sent you a like------------------------------------5***/
            /*COMMENT--------------A user sent you a comment---------------------------------6***/
            /*TAGGED---------------A user tagged you-----------------------------------------7***/
            /*TAGGEDCOMMENT--------A user tagged you in a comment----------------------------8***/
            /*LIKECOMMENT----------A user sent you a like in a comment-----------------------9***/
            /*DELETEGROUP----------A user delete the group----------------------------------10***/
            /*JOINGROUP------------A user wants to join a group-----------------------------11***/
            /*ACCEPTGROUP----------A user accepted to join a group--------------------------12***/
            /*FRIENDPOST-----------A user post something in normal TL-----------------------13***/
            /*GROUPPOST------------A user post something in a Group TL----------------------14***/
            /*PROFILEPHOTO---------A user updates the profile photo-------------------------15***/
            /*COVERGROUP-----------A group updates the cover photo--------------------------16***/
            /*LIKEPOSTCOMMENT------Someone liked a post commented---------------------------17***/
            /*COMMENTPOSTCOMMENT---Someone comment a post commented-------------------------18***/
            /*LIKEPOSTLIKED--------Someone liked a post liked-------------------------------19***/
            /*LIVE-----------------Someone create a streaming-------------------------------20***/
            /************************************************************************************/
            
            /*NOTIFICATIONS STATUS*/
            /*PENDING-------1******/
            /*QUEUED--------2******/
            /*SENT----------3******/
            /*READ----------4******/
            /**********************/

            //Update the notification status if required
            if ( notification.notificationType != 4 && (notification.notificationStatusInt != 3 || notification.notificationStatus === 'Pending') ) {
              // auto update all in server but in user's view not except for reacts
              updateNotificationStatus(Utils.getLastUrlComponent(notification.userNotification.href)).then(function (updatedId) {
                console.log("made the update of status");
                $scope.unreadNotifications--;
              }, function (error) {
                console.log("got error updating status");
              });
            }
            var nameSender = "";
            if(userSend[0])
              if(userSend[0].name)
                nameSender = userSend[0].name;
              else
                nameSender = Utils.translate('NOTIFICATIONS.DIALOG.SOMEONE');
            var groupOrigin = "";
            if(notification)
              if(notification.groupName)
                groupOrigin = notification.groupName;
              else
                groupOrigin = Utils.translate('ALERTS.SOME_GROUP');

            //Add every package of info for each notification
            notifications.push({
              notificationStatus: notification.notificationStatus,
              notificationStatusInt: notification.notificationStatusInt,
              notificationType: notification.notificationType,
              notificationText: getNotificationText(notification.notificationType, notification.itemId, notification.notificationStatusInt, nameSender,groupOrigin),
              sequenceId: notification.sequenceId,
              sequenceInstanceId: notification.sequence ? Utils.getLastUrlComponent(notification.sequence.href) : null,
              userNotification: notification.userNotification,
              itemId: notification.itemId,
              sequencePicture: notification.sequencePicture,
              //sequencePictureUrl: notification.sequenceUrl,
              sequencePictureUrl: realImg,
              notificationPicture: notification.notificationPicture,
              reactUrl: notification.reactUrl,
              creationTime: notification.creationTime,
              description: notification.description,
              userSubscriptionSent: notification.userSubscriptionSent,
              userSend: userSend,
              friend: notification.friend,
              followed: isFollowed,
              ownerSequence: ownerSequence,
              groupId: notification.groupId,
              postExists: postExists,
              userStreaming: notification.userStreaming //LuMa Live Streaming
            });
            //console.log("Notification id: " + Utils.getLastUrlComponent(notification.userNotification.href));
          });

          setTimeout(function () {
            notificationsService.updateBadgesCount.regularNotifications($scope.unreadNotifications);
          }, 2000);

          notificationsService.paginator.regular.pagination.start += allUserNotifications.length;

          $scope.canGetMoreItems = allUserNotifications.length > 0;
          $scope.isFirstTime = false;
          resolve(notifications);
        }, function (error) {
          console.error("findAllUserNotificationsByUserSubscription error", error);

          $scope.canGetMoreItems = false;
          $scope.errorLoading = true;
          reject(error);
        }).finally(function () {
          $scope.isRefreshing = false;
          $scope.isLoadingContent = false;
          $scope.$broadcast('scroll.refreshComplete');
          $scope.$broadcast('scroll.infiniteScrollComplete');
        });
      })
    }

    /**
     * @param type {number}
     * @param itemId {number}
     * @return {string}
     */
    function getNotificationText(type, itemId, statusID, user, group) {
      var text = 'UNKNOWN DESCRIPTION';
      switch (type) {
        case 4:
          if(statusID == 1)
            text = Utils.translate('ALERTS.NEW_REACT');
          else
            text = Utils.translate('ALERTS.OLD_REACT');
          break;
        case 5:
          text = Utils.translate('ALERTS.' + (itemId == 0 ? 'LIKE_SEQUENCE' : 'LIKE_PHOTO'));
          break;
        case 6:
          text = Utils.translate('ALERTS.' + (itemId == 0 ? 'COMMENT_SEQUENCE' : 'COMMENT_PHOTO'));
          break;
        case 7:
          text = Utils.translate('ALERTS.TAG_SEQUENCE');
          break;
        case 8:
          text = Utils.translate('ALERTS.TAG_COMMENT');
          break;
        case 9:
          text = Utils.translate('ALERTS.LIKE_COMMENT');
          break;
        /*case 10:
          text = Utils.translate('ALERTS.GROUP_DELETE');
          break;*/
        case 11:
          text = Utils.translate('ALERTS.USER_WANTS_JOIN_GROUP');
          break;
        case 12:
          text = Utils.translate('ALERTS.USER_ACCEPTED_IN_GROUP');
          break;
        case 13:
          text = Utils.translate('ALERTS.NEW_POST_IN_TL_01_B');
          break;
        case 14:
          text = Utils.translate('ALERTS.NEW_POST_IN_GROUP_01_B') + group;
          break;
        case 15:
          text = Utils.translate('ALERTS.NEW_PROFILE_PICTURE_02');
          break;
        case 16:
          text = Utils.translate('ALERTS.NEW_GROUP_BACKGROUND_02_B') + group;
          break;
        case 17:
          text = Utils.translate('ALERTS.LIKED_POST_COMMENTED');
          break;
        case 18:
          text = Utils.translate('ALERTS.COMMENTED_POST_COMMENTED');
          break;
        case 19:
          text = Utils.translate('ALERTS.LIKED_POST_LIKED');
          break;
        case 20: //LuMa
          text = Utils.translate('ALERTS.STREAM_CREATED');
          break;
        default:
          text = Utils.translate('ALERTS.UNKNOWN_NOTIF');
          break;
      }

      return text;
    }


    $scope.refreshItems = function (keepOldNotifications) {
      //console.log("Refreshing items...");

      closeNewNotificationsToast();

      $scope.$broadcast('scroll.refreshComplete');
      if (!keepOldNotifications)
        $scope.notifications = notificationsService.notifications.regular = [];

      $scope.errorLoading = false;
      $scope.isFirstTime = true;
      $scope.isRefreshing = true;
      $rootScope.cancelRefreshNotif = false;

      notificationsService.paginator.regular.reset();
      Utils.$ionicScrollDelegate.resize();
      Utils.$ionicScrollDelegate.scrollTop();
      $scope.getMoreItems()
    };

    $scope.sendUserProfile = function (userChosen) {
      var friendSubscriptionIntanceId = Utils.getLastUrlComponent(userChosen.href);
      reDirectService.reDirectProfile(friendSubscriptionIntanceId);
    };

    $scope.showReactPicture = function (sequencePicture, reactPicture, index, id, data) {
      $scope.loadingInit = 1;
      $scope.activeSlide = index;
      if (data.notificationStatusInt == 1) {
        var myVarPicture = $ionicPopup.show({
          scope: $scope,
          animation: 'zoom-from-center',
          templateUrl: 'templates/reactZoomView.html'
        });

        setTimeout(function () {
          $scope.reactPictures = {
            sequencePicture: sequencePicture,
            reactPicture: reactPicture,
            description: data.description
          };
        }, 200);

        $scope.myReactPicture = function () {
          $scope.reactPictures = {};
          myVarPicture.close();
        };

        if( data.notificationStatus != 'Read' ) {
          data.notificationStatus = 'Read';
          if(notificationsService.badges.unreadRegularNotifications > 0)
            notificationsService.badges.unreadRegularNotifications--;
          else
            notificationsService.badges.unreadRegularNotifications = 0;
        }
        //data.notificationStatusInt = 3;
        

        updateNotificationStatus(Utils.getLastUrlComponent(data.userNotification.href)).then(function (updatedId) {
          //console.log("updateNotificationStatus react", response);
          data.description = "Read";
        }, function (error) {
          //error already printed out
        });
      }
    };

    $scope.checkBeforeSend = function (notification, listIndex) {
      console.log("notification", notification);
      switch (notification.notificationType) {
        case 4:
          var sequencePictureUrl = "", reactUrl = "";

          if (notification.sequencePicture != null) {
            sequencePictureUrl = 'data:image/png;base64,' + notification.sequencePicture.split(':')[2];
            reactUrl = 'data:image/png;base64,' + notification.notificationPicture.split(':')[2];
          }
          else if (notification.sequencePictureUrl != null) {
            sequencePictureUrl = notification.notificationPictureUrl;
            reactUrl = notification.reactUrl;
          }
          else {
            console.warn("No picture was found for Notification");
            return;
          }

          $scope.showReactPicture(
            sequencePictureUrl,
            reactUrl,
            listIndex,
            Utils.getLastUrlComponent(notification.userNotification.href),
            notification
            /*notification.notificationStatus*/
          );
          break;
        case 5:
        case 6:
        case 7:
        case 8:
        case 9:
        case 13:
        case 14:
        case 17:
        case 18:
        case 19:
          console.log("canOpenNotificationWS", notification.groupId, UserService.get_USERSUBSCRIPTIONINSTANCE_ID());
          notification.isValidating = true;
          notificationsService.canOpenNotificationWS({
            //sequenceId: notification.sequenceInstanceId,
            groupId: notification.groupId,
            userInstanceId: UserService.get_USERSUBSCRIPTIONINSTANCE_ID()
          }).$promise.then(function (response) {
            console.log("canOpenNotificationWS?", response);
            if (notification.groupId != 0 && !response.result.value) {
              Utils.toast.warning(Utils.translate("NOTIFICATIONS.DIALOG.CANNOT_OPEN_NOTIFICATION"));
              return;
            }

            Utils.removeLastItemIfHasNoAttribute(notification.ownerSequence, "sequenceId");
            notification.notificationStatusInt = 3;
            notification.notificationStatus = 'Sent';
            if(notificationsService.badges.unreadRegularNotifications > 0)
              notificationsService.badges.unreadRegularNotifications--;
            else
              notificationsService.badges.unreadRegularNotifications = 0;
            if (notification.postExists){
              if(notification.postExists.result.value) {
                //get Anchor from index
                  $rootScope.anchorID = listIndex;
                //get data from Anchor element
                  var h1 = document.getElementById("pos"+listIndex);
                //get Anchor's Y position
                  $rootScope.itemAnchorYb = h1.getBoundingClientRect().bottom;
                  $rootScope.itemAnchorYt = h1.getBoundingClientRect().top;
                // get view height and save it
                  $rootScope.viewScrollHeight = $scope.ViewHeight;
                //console.log("posicion del elemeno: " + h1.getBoundingClientRect() );
                //Prepare all others variables to trasfer
                  $rootScope.cancelRefreshNotif = false;
                  $rootScope.totalLoaded = $scope.totalNotifLoaded;
                  $rootScope.wsCalled = $scope.wsCalled;
                //
                $state.go('showNotification', {
                    sequenceId: notification.sequenceId,
                    groupId: notification.groupId,
                    fromWhere: $state.current.name,
                    groupIndex: 0}, {reload: true});
              } else
                Utils.toast.warning(Utils.translate("NOTIFICATIONS.DIALOG.CONTENT_NOT_AVAILABLE"));
            }
            else
              Utils.toast.warning(Utils.translate("NOTIFICATIONS.DIALOG.CONTENT_NOT_AVAILABLE"));
          }, function (error) {
            console.error("canOpenNotificationWS", error);
            Utils.toast.error(Utils.translate("ERROR.UNKNOWN"));
          }).finally(function () {
            notification.isValidating = false;
          });
          break;
        case 11:
          $state.go('groupReceivedRequests', {groupId: notification.groupId});
          break;
        case 12:
        case 16:
          notification.isValidating = true;
          var groups = GroupFactory.getCurrentAvailableUserGroupsList();
          var groupIdx = -1;
          var found = groups.some(function (group, idx) {
            if (group.id == notification.groupId) {
              groupIdx = idx;
              return true;
            }
          });

          if (found) {
            console.log("Going to group idx: " + groupIdx + 1);
            notification.isValidating = false;
            //$state.go('menu.timeline', {prepareStatement: 0, groupIndex: groupIdx + 1});
            Utils.clearCache();
            Utils.clearHistory();
            Utils.$timeout(function () {
              $rootScope.$apply();
              $state.go("menu.timeline", {groupIndex:groupIdx + 1}, {reload:true})
            }, 100);
          }
          else {
            console.log("Group '" + notification.groupId + "' not found, reloading your groups...");
            GroupFactory.loadAvailableUserGroups({
              userSubscriptionHref: UserService.get_USER_INSTANCE_HREF()
            }).then(function (groups) {
              groupIdx = -1;
              found = groups.some(function (group, idx) {
                if (group.id == notification.groupId) {
                  groupIdx = idx;
                  return true;
                }
              });

              if (found) {
                console.log("Going to group idx: " + groupIdx + 1);
                notification.isValidating = false;
                //$state.go('menu.timeline', {prepareStatement: 0, groupIndex: groupIdx + 1});
                Utils.clearCache();
                Utils.clearHistory();

                Utils.$timeout(function () {
                  $rootScope.$apply();
                  $state.go("menu.timeline", {groupIndex:groupIdx + 1}, {reload:true})
                }, 100);
              }
              else {
                notification.isValidating = false;
                Utils.toast.warning(Utils.translate('NOTIFICATIONS.DIALOG.GROUP_NOT_AVAILABLE'))
              }
            }, function () {
              notification.isValidating = false;
              Utils.toast.error(Utils.translate('ERROR.UNKNOWN'));
            })
          }
          break;
        case 15:
          //redirect to user profile
          var friendSubscriptionIntanceId = Utils.getLastUrlComponent(notification.href);
          reDirectService.reDirectProfile(friendSubscriptionIntanceId);
          break;
        case 20:
          console.log("canOpenNotificationWS", notification.groupId, UserService.get_USERSUBSCRIPTIONINSTANCE_ID());
          notification.isValidating = true;
          notificationsService.canOpenNotificationWS({
            //sequenceId: notification.sequenceInstanceId,
            groupId: notification.groupId,
            userInstanceId: UserService.get_USERSUBSCRIPTIONINSTANCE_ID()
          }).$promise.then(function (response) {
            console.log("canOpenNotificationWS?", response);
            if (notification.groupId != 0 && !response.result.value) {
              Utils.toast.warning(Utils.translate("NOTIFICATIONS.DIALOG.CANNOT_OPEN_NOTIFICATION"));
              return;
            }

            Utils.removeLastItemIfHasNoAttribute(notification.ownerSequence, "sequenceId");
            notification.notificationStatusInt = 3;
            notification.notificationStatus = 'Sent';
            if(notificationsService.badges.unreadRegularNotifications > 0)
              notificationsService.badges.unreadRegularNotifications--;
            else
              notificationsService.badges.unreadRegularNotifications = 0;
            if (notification.postExists){
              if(notification.postExists.result.value) {
                //get Anchor from index
                  $rootScope.anchorID = listIndex;
                //get data from Anchor element
                  var h1 = document.getElementById("pos"+listIndex);
                //get Anchor's Y position
                  $rootScope.itemAnchorYb = h1.getBoundingClientRect().bottom;
                  $rootScope.itemAnchorYt = h1.getBoundingClientRect().top;
                // get view height and save it
                  $rootScope.viewScrollHeight = $scope.ViewHeight;
                //console.log("posicion del elemeno: " + h1.getBoundingClientRect() );
                //Prepare all others variables to trasfer
                  $rootScope.cancelRefreshNotif = false;
                  $rootScope.totalLoaded = $scope.totalNotifLoaded;
                  $rootScope.wsCalled = $scope.wsCalled;
                //
                $state.go('showStreaming', {
                    sequenceId: notification.sequenceId,
                    groupId: notification.groupId,
                    fromWhere: $state.current.name,
                    groupIndex: 0}, {reload: true});
              } else
                Utils.toast.warning(Utils.translate("NOTIFICATIONS.DIALOG.CONTENT_NOT_AVAILABLE"));
            }
            else
              Utils.toast.warning(Utils.translate("NOTIFICATIONS.DIALOG.CONTENT_NOT_AVAILABLE"));
          }, function (error) {
            console.error("canOpenNotificationWS", error);
            Utils.toast.error(Utils.translate("ERROR.UNKNOWN"));
          }).finally(function () {
            notification.isValidating = false;
          });
          break;
          break;
        /*case 20: //LuMa
         notification.isValidating = true;
          if($scope.isReading) {
            return true;
          }
          $scope.isReading = true;
          StreamingService.findStreamingByUserStreamingId(Utils.getLastUrlComponent(notification.userStreaming.href)).$promise.then(
            function(response) {
              $scope.isReading = false;
              if (response.length == 0) {
                Utils.toast.info(Utils.translate('LIVE_STREAMING.END_STREAMING'));
                notification.isValidating = false;
                return;
              }
              var url;
              var pivot = JSON.parse(window.localStorage.getItem('AppsPerzonalized'));  
              var isLiveStreaming = false; // LuMa Live Streaming Statistics
              if (response != null && response.length > 0) {
                var userStreaming = response[0];
                if (userStreaming.status == 'Finished')
                  url = userStreaming.mp4Url;
                else{
                  url = userStreaming.rmtpUrl;
                  isLiveStreaming = true; // LuMa Live Streaming Statistics
                }
                //IF HAVE URL WE SHOW IT
                  if (url != null) {
                    //IF STREAM WE SHOW BANNERS
                      StreamingService.getBannersForVideoOrStream().$promise.then(function(response) {
                        console.log("GOT: ", response)
                        //ADD ALL THE RESPONSES TO ARRAY
                          var urls = {};
                          response.forEach( function(url) {
                            urls[url.pictureId] = url.url;
                          })
                        //ADD ALL THE RESPONSES TO ARRAY END
                        //CALL PLUGIN TO SHOW VIDEO
                          var options = {
                            successCallback: function() {
                              Utils.toast.info(Utils.translate('LIVE_STREAMING.END_STREAMING'));
                              if(isLiveStreaming) { // LuMa Live Streaming Statistics
                                StreamingService.incrementUserStreamingViewCount(Utils.getLastUrlComponent(data.data.param2)).$promise.then(
                                  function(resp) {
                                    console.log('Increment UserStreamingViewCount');
                                  }
                                );
                              }
                            },
                            errorCallback: function(errMsg) {
                              Utils.toast.error(Utils.translate('SEQUENCE.DIALOG.STREAM_NOT_FOUND'));
                              console.log('error:' + errMsg);
                            },
                            timeBetween: ""+pivot.timeForBanners,            
                            orientation: 'portrait',
                            shouldAutoClose: true, // true(default)/false
                            controls: true // true(default)/false. Used to hide controls on fullscreen
                          };
                          window.plugins.streamingMedia.playVideo(url, options, urls);
                        //CALL PLUGIN TO SHOW VIDEO END
                      }, function (error) {
                        console.error("fail findAllAdPictures");
                        //NOT GOT ANY BANNER, SHOW VIDEO ONLY
                          var options = {
                            successCallback: function() {
                            },
                            errorCallback: function(errMsg) {
                              if(urlToUse.endsWith('m3u8')) {
                                Utils.toast.error(Utils.translate('SEQUENCE.DIALOG.STREAM_NOT_FOUND'));
                              } else {
                                Utils.toast.error(Utils.translate('SEQUENCE.DIALOG.VIDEO_NOT_FOUND'));
                              }
                              console.log('error:' + errMsg);
                            },
                            timeBetween: "0",
                            orientation: 'portrait',
                            shouldAutoClose: true, // true(default)/false
                            controls: true // true(default)/false. Used to hide controls on fullscreen
                          };
                          window.plugins.streamingMedia.playVideo(url, options, null);
                        //NOT GOT ANY BANNER, SHOW VIDEO ONLY
                      });
                    //IF STREAM WE SHOW BANNERS END
                  }
                //IF HAVE URL WE SHOW IT END
              }
            }
          );
          break;*/
        default:
          console.log("Notification type '" + notification.notificationType + "' is not a valid type")
      }
    };

    function removeListeners() {

    }

  }])
  .controller('notificationsFollowersCtrl', ['$rootScope', '$scope', 'notificationsService', 'UserService', 'reDirectService', 'Utils', 'AWSServices', function ($rootScope, $scope, notificationsService, UserService, reDirectService, Utils, AWSServices) {
    //console.log("notificationsFollowersCtrl loaded!!!");

    var mySubscriptionId = UserService.get_USERSUBSCRIPTIONINSTANCE_ID();

    $scope.followText = Utils.translate('GLOBAL.FOLLOW'); //Follow
    $scope.followingText = Utils.translate('GLOBAL.UNFOLLOW'); //Following
    $scope.unfollowText = Utils.translate('GLOBAL.UNFOLLOW'); //UnFollow
    $scope.pendingRequest = Utils.translate('GLOBAL.PENDING'); //Pending request
    $scope.acceptPendingRequest = Utils.translate('GLOBAL.ACCEPT'); //Accept
    $scope.acceptedPendingRequest = Utils.translate('GLOBAL.ACCEPTED'); //Accepted
    $scope.friendsNow = Utils.translate('GLOBAL.FRIENDS'); //Friends
    $scope.waitingNow = Utils.translate('GLOBAL.WAITING'); //Waiting

    $scope.followerNotifications = notificationsService.notifications.followers;

    $scope.unreadFollowersNotifications = 0;

    $scope.isFirstTime = true;
    $scope.isRefreshing = false;
    $scope.isLoadingContent = false;
    $scope.canGetMoreItems = true;

    var toastCtrl = Utils.toast.getCtrl();
    var newNotifToast;

    function closeNewFollowersToast() {
      if (newNotifToast) {
        toastCtrl.clear(newNotifToast);
        toastCtrl.remove(newNotifToast);//myabe it's unnecessary
      }

      newNotifToast = undefined;
    }

    $scope.reloadToViewNewFollowers = function (mustReload) {
      if (mustReload) {
        $scope.refreshItems(true);//true == keep old data
      }

      closeNewFollowersToast();
    };

    $scope.showNewFollowersToast = function () {
      newNotifToast = toastCtrl.info(
        Utils.translate('NOTIFICATIONS.DIALOG.NEW_FOLLOWERS_FOUND') +
        '<br><button id="reg-notif-close" class="md-button md-raised" ng-click="reloadToViewNewFollowers(false)">' +
        Utils.translate('GLOBAL.NO') +
        '</button>' +
        '<button id="reg-notif-reload" class="md-button md-raised md-primary" ng-click="reloadToViewNewFollowers(true)">' +
        Utils.translate('GLOBAL.YES') +
        '</button>', {
          allowHtml: true, timeOut: 0, extendedTimeOut: 0, tapToDismiss: false, onShown: function () {
            var el1 = document.getElementById('reg-notif-reload');
            if (el1) Utils.$compile(el1)($scope);
            var el2 = document.getElementById('reg-notif-close');
            if (el2) Utils.$compile(el2)($scope);
          }
        });
    };

    $scope.$on("$ionicView.enter", function () {
      if ($scope.isFirstTime) {
        $scope.getMoreItems();
        return;
      }

      $scope.isLoadingContent = true;
      countUnreadFollowersNotifications().then(function (numUnreadNotif) {
        //console.log("$scope.unreadFollowersNotifications: " + $scope.unreadFollowersNotifications + "; unread notif: " + numUnreadNotif);

        if (numUnreadNotif > 0) {//$scope.unreadFollowersNotifications) {
          $scope.unreadFollowersNotifications = numUnreadNotif;
          //$scope.showNewFollowersToast();
        }
      }, function (error) {
        console.error(error);
      }).finally(function () {
        $scope.isLoadingContent = false;
      })
    });

    //we use this because $ionicView.???Leave events doesn't trigger with the current side-menus + tabs structure
    //only on changes between tabs o inside tabs
    $rootScope.$on('$stateChangeStart', function (event, toState, toParams, fromState, fromParams) {
      if (fromState.name === 'menu.notificationTabs.follwers') {
        $scope.canGetMoreItems = true;
        closeNewFollowersToast();
        if(toState.name != 'showNotification') {
          updatePackNotificationStatus(1)
        }
      } else if (fromState.name === 'showNotification') {
        if(toState.name != 'menu.notificationTabs.follwers') {
          updatePackNotificationStatus(1)
        }
      }
    });

    function updatePackNotificationStatus(type) {
      var myId = UserService.get_USERSUBSCRIPTION_ID();
      return Utils.$q(function (resolve, reject) {
        UserService.updatePackNotificationStatus().post({
          "userSubscriptionId": {"value": myId },
          "notificationsType": {"value": type}
        }, function (data) {
          $scope.unreadFollowersNotifications = 0;
          console.log("everything it's all right", $scope.unreadFollowersNotifications);
        }, function (err) {
          console.log("can't update them", $scope.unreadFollowersNotifications);
        })
      })
    }

    $scope.getMoreItems = function () {
      $scope.isLoadingContent = true;
      countUnreadFollowersNotifications().then(function (numUnreadNotif) {
        //console.log("LOCAL unread notif: " + $scope.unreadFollowersNotifications + "; REMOTE unread notif: " + numUnreadNotif);

        if (numUnreadNotif > $scope.unreadFollowersNotifications && !$scope.isFirstTime) {
          $scope.unreadFollowersNotifications = numUnreadNotif;
          //$scope.showNewFollowersToast();
          $scope.isLoadingContent = false;
          return;
        }

        $scope.unreadFollowersNotifications = numUnreadNotif;

        getAllFollowersNotifications().then(function (newNotifications) {
          if (!notificationsService.notifications.followers.length) {
            $scope.followerNotifications = notificationsService.notifications.followers = newNotifications;
            $scope.followerNotifications.forEach(function(singleNotif){
              getFollowStatus(singleNotif);
            });
            Utils.$ionicScrollDelegate.scrollTop();
            Utils.$ionicScrollDelegate.resize();
            return;
          }

          notificationsService.notifications.followers = notificationsService.notifications.followers.concat(newNotifications);
          $scope.followerNotifications = notificationsService.notifications.followers;
          //check status for each follow notification
          $scope.followerNotifications.forEach(function(singleNotif){
            getFollowStatus(singleNotif);
          }); 
          Utils.$ionicScrollDelegate.resize();
        }, function (error) {
          console.error(error)
        });
      }, function (error) {
        console.error(error);
      })
    };


    /**
     * @param notification {Object}
     * @returns {Promise}
     */
    function updateNotificationStatus(notificationId) {
      return Utils.$q(function (resolve, reject) {
        UserService.updateNotificationStatus({
          objectId: notificationId
        }).save({int: {value: 3}}).$promise.then(function () {
          resolve(notificationId)
        }, function (error) {
          reject(error);
          console.error("updateNotificationStatus error", error);
        });
      })
    }

    /**
     * @returns {Promise}
     */
    function countUnreadFollowersNotifications() {
      return Utils.$q(function (resolve, reject) {
        notificationsService.countPendingFollowersNotifications(UserService.get_USER_INSTANCE_HREF()).then(function (total) {
          resolve(total);
        }, function (error) {
          console.error("countPendingFollowersNotifications error", error);
          $scope.errorLoading = true;
          $scope.isRefreshing = false;
          $scope.isLoadingContent = false;
          $scope.canGetMoreItems = false;
          $scope.$broadcast('scroll.refreshComplete');
          $scope.$broadcast('scroll.infiniteScrollComplete');
          reject(error);
        });

        notificationsService.countPendingRegularNotifications(UserService.get_USER_INSTANCE_HREF());
      })
    }

    /**
     * @returns {Promise}
     */
    function getAllFollowersNotifications() {
      return Utils.$q(function (resolve, reject) {
        //console.log("Followers pagination", notificationsService.paginator.followers.pagination);
        UserService.findAllUserNotificationsByUserSubscriptionFollow(
          mySubscriptionId,
          notificationsService.paginator.followers.pagination
        ).then(function (allUserNotifications) {
          //console.log("Regular notifications: ", allUserNotifications.length);

          var notifications = [];
          allUserNotifications.forEach(function (notification) {
            //-------------  START OF: Filter out the existing notifications ------
            var exists = $scope.followerNotifications.some(function (currNotif) {
              return notification.userNotification.href === currNotif.userNotification.href
            });

            if (exists) {
              //console.log("id: "+Utils.getLastUrlComponent(notification.userNotification.href)+" already exists");
              return; //<-- this will make the foreach to continue with the next item...
            }
            //----------- END OF: Filter out the existing notifications ---------

            var friendHref = notification.userSubscriptionSent.href;
            var friendSubscriptionIntanceId = Utils.getLastUrlComponent(friendHref);

            //prepare the data of the user that make the action for the notification
            //var userSend = UserService.getUserSubscriptionByinstanceId(friendSubscriptionIntanceId);
            var userSend = UserService.getUserSubscriptionByinstanceIdProfileData(friendSubscriptionIntanceId);
            //prepare the data to check if user is following the new follower
            var isFollowed = UserService.getFollowingIsActiveWS({
              userInstanceId: mySubscriptionId,
              friendInstaceId: Utils.getLastUrlComponent(friendHref)
            });

            var isPrivate = UserService.getStatusPrivateAccount({
              "objectId": Utils.getLastUrlComponent(notification.userSubscriptionSent.href)
            }).get();

            //Utils.getLastUrlComponent(notification.userSubscriptionSent.href)


            //Add every package of info for each notification
            notifications.push({
              notificationStatus: notification.notificationStatus,
              notificationStatusInt: notification.notificationStatusInt,
              notificationType: notification.notificationType,
              sequenceId: notification.sequenceId,
              sequenceInstanceId: notification.sequence ? Utils.getLastUrlComponent(notification.sequence.href) : null,
              userNotification: notification.userNotification,
              itemId: notification.itemId,
              sequencePicture: notification.sequencePicture,
              notificationPicture: notification.notificationPicture,
              creationTime: notification.creationTime,
              description: notification.description,
              userSubscriptionSent: notification.userSubscriptionSent,
              userSend: userSend,
              friend: notification.friend,
              followed: isFollowed,
              privateAccount: isPrivate
            });

            //console.log("Follower Notification id: " + Utils.getLastUrlComponent(notification.userNotification.href));

            //Update the notification status if required
            if (notification.notificationType != 4 && notification.notificationStatusInt != 3 || notification.notificationStatus === 'Pending') {
              updateNotificationStatus(Utils.getLastUrlComponent(notification.userNotification.href)).then(function (updatedId) {
                $scope.unreadFollowersNotifications--;
              }, function (error) {
                //error already printed out
              });
            }
          });

          setTimeout(function () {
            notificationsService.updateBadgesCount.followersNotifications($scope.unreadFollowersNotifications);
          }, 2000);

          notificationsService.paginator.followers.pagination.start += allUserNotifications.length;

          $scope.canGetMoreItems = allUserNotifications.length > 0;
          $scope.isFirstTime = false;
          resolve(notifications);
        }, function (error) {
          console.error("findAllUserNotificationsByUserSubscriptionFollow error", error);

          $scope.errorLoading = true;
          $scope.canGetMoreItems = false;
          reject(error);
        }).finally(function () {
          $scope.isRefreshing = false;
          $scope.isLoadingContent = false;
          $scope.$broadcast('scroll.refreshComplete');
          $scope.$broadcast('scroll.infiniteScrollComplete');
        });
      })
    }


    $scope.refreshItems = function (keepOldFollowers) {
      //console.log("Refresing items...");
      //$scope.canGetMoreItems = true;
      closeNewFollowersToast();

      $scope.$broadcast('scroll.refreshComplete');

      if (!keepOldFollowers)
        $scope.followerNotifications = notificationsService.notifications.followers = [];

      $scope.errorLoading = false;
      $scope.isFirstTime = true;
      $scope.isRefreshing = true;

      notificationsService.paginator.followers.reset();
      Utils.$ionicScrollDelegate.resize();
      Utils.$ionicScrollDelegate.scrollTop();
      $scope.getMoreItems()
    };

    $scope.sendUserProfile = function (userChosen) {
      var friendSubscriptionIntanceId = Utils.getLastUrlComponent(userChosen.href);
      reDirectService.reDirectProfile(friendSubscriptionIntanceId);
    };

    //New function to get follow status
    function getFollowStatus(notif) {
      //obtener status del otro usuario a mi
      var otherMe = UserService.getStatusPrivateRequest({
        userId: Utils.getLastUrlComponent(notif.userSubscriptionSent.href),
        friendId: UserService.get_USERSUBSCRIPTIONINSTANCE_ID()
      }).$promise;
      //obtener status de  mi al otro usuario
      var meOther = UserService.getStatusPrivateRequest({
        userId: UserService.get_USERSUBSCRIPTIONINSTANCE_ID(),
        friendId: Utils.getLastUrlComponent(notif.userSubscriptionSent.href)
      }).$promise;

      //work with both
      Utils.$q.all({
        OthersToMe: otherMe,
        meToOthers: meOther
      }).then(function (currentStatus) {
        if(currentStatus.OthersToMe.status == 1) {
          //Ya me sigue, se debe ver si lo sigo o no
            if(currentStatus.meToOthers.status == 1) {
              //Ya lo sigo, debe aparecer "Siguiendo"
              //dar click-cancelar debe mostrar "Follow" ya que dejo de seguirlo
                notif.msgShow = $scope.followingText;
                notif.itFollows = 1;
                notif.meFollow = 1;
                notif.isActive = true;
                notif.waitingAns = false;
                notif.shutdownButton = false;
            } else if(currentStatus.meToOthers.status == 2) {
              //Espero que acepte mi solitud debe mostrar "Waiting"
              //click se debe cancelar la solicitud y mostrar "Follow" Ya que no lo sigo
                notif.msgShow = $scope.waitingNow;
                notif.itFollows = 1;
                notif.meFollow = 2;
                notif.isActive = true;
                notif.waitingAns = true;
                notif.shutdownButton = false;
            } else if(currentStatus.meToOthers.status == 3) {
              //No he mandado solicitud debe'aparecer "Follow"
              //Dar click debe cambiar a "Friends"/"Waiting" (depende si es privado)
                notif.msgShow = $scope.followText;
                notif.itFollows = 1;
                notif.meFollow = 3;
                notif.isActive = true;
                notif.waitingAns = false;
                notif.shutdownButton = false;
            }
        } else if(currentStatus.OthersToMe.status == 2) {
          //Espera a que acepte su solicitud
            if(currentStatus.meToOthers.status == 1) {
              //Ya lo sigo, debe aparecer "Accept"
              //y al aceptar se debe ver "Friends" ya que nos seguimos mutuamente
                notif.msgShow = $scope.acceptPendingRequest;
                notif.itFollows = 2;
                notif.meFollow = 1;
                notif.isActive = true;
                notif.waitingAns = false;
                notif.shutdownButton = false;
            } else if(currentStatus.meToOthers.status == 2) {
              //Estoy en espera de que me acepte pero mostrará primero "Accept"
              //si lo acepto debo mostrar "Waiting" ya que sigo esperando
                notif.msgShow = $scope.acceptPendingRequest;
                notif.itFollows = 2;
                notif.meFollow = 2;
                notif.isActive = true;
                notif.waitingAns = true;
                notif.shutdownButton = false;
            } else if(currentStatus.meToOthers.status == 3) {
              //No le he mandado solicitud debe mostrar "Accept"
              //Si lo acepto debe mostrar "Follow" ya que no he mandado nada aun
                notif.msgShow = $scope.acceptPendingRequest;
                notif.itFollows = 2;
                notif.meFollow = 3;
                notif.isActive = true;
                notif.waitingAns = false;
                notif.shutdownButton = false;
            }
        } else if(currentStatus.OthersToMe.status == 3) {
          //No me ha mandado solicitud y por ende no debería aparecer en lista
            if(currentStatus.meToOthers.status == 1) {
              //Ya lo sigo, debe mostrar "Siguiendo"
              //al dar click debe mostrar "Follow" ya que lo dejo de seguir
                notif.msgShow = $scope.followingText;
                notif.itFollows = 3;
                notif.meFollow = 1;
                notif.isActive = true;
                notif.waitingAns = false;
                notif.shutdownButton = false;
            } else if(currentStatus.meToOthers.status == 2) {
              //Espero su respuesta debe mostrar "Waiting"
              //Al dar click debe mostrar "Follow" ya que cancelo solicitd
                notif.msgShow = $scope.waitingNow;
                notif.itFollows = 3;
                notif.meFollow = 2;
                notif.isActive = true;
                notif.waitingAns = true;
                notif.shutdownButton = false;
            } else if(currentStatus.meToOthers.status == 3) {
              //No lo sigo ni me sigue asi que debe mostrar "Follow"
              //Al dar click debe mostar "Friends"/"Unfollow" depende de su tipo de perfil
                notif.msgShow = $scope.followText;
                notif.itFollows = 3;
                notif.meFollow = 3;
                notif.isActive = true;
                notif.waitingAns = false;
                notif.shutdownButton = false;
            }
        }
      })
    }

    //function to know status of request
    /*$scope.findStatusRequestFriend = function (notification) {

      //obtener status del otro usuario a mi
      var otherMe = UserService.getStatusPrivateRequest({
        userId: Utils.getLastUrlComponent(notification.userSubscriptionSent.href),
        friendId: UserService.get_USERSUBSCRIPTIONINSTANCE_ID()
      }).$promise;
      //obtener status de  mi al otro usuario
      var meOther = UserService.getStatusPrivateRequest({
        userId: UserService.get_USERSUBSCRIPTIONINSTANCE_ID(),
        friendId: Utils.getLastUrlComponent(notification.userSubscriptionSent.href)
      }).$promise;

      //work with both
      Utils.$q.all({
        toMe: otherMe,
        toOthers: meOther
      }).then(function (allStatus){
        console.log("done it");
        if(allStatus.toMe.status == 1){
          //Ese usuario ya me sigue
          if(allStatus.toOthers.status == 1){
            //ya lo sigo
            if(notification.notificationType === 1){
              notification.msgShow = $scope.followingText;
              notification.isActive = true;
              notification.waitingAns = false;
              notification.shutdownButton = false;
            } else if (notification.notificationType === 3){
              notification.msgShow = $scope.acceptedPendingRequest;
              notification.isActive = false;
              notification.waitingAns = false;
              notification.shutdownButton = true;
            }
          } else if(allStatus.toOthers.status == 2){
            //Lo estoy esperando
            if(notification.notificationType === 1){
              notification.msgShow = $scope.pendingRequest;
              notification.isActive = true;
              notification.waitingAns = true;
              notification.shutdownButton = false;
            } else if (notification.notificationType === 3){
              notification.msgShow = $scope.acceptedPendingRequest;
              notification.isActive = false;
              notification.waitingAns = false;
              notification.shutdownButton = true;
            }
          } else if(allStatus.toOthers.status == 3){
            //No he mandado solicitud
            if(notification.notificationType === 1){
              notification.msgShow = $scope.followText;
              notification.isActive = false;
              notification.waitingAns = false;
              notification.shutdownButton = false;
            } else if (notification.notificationType === 3){
              notification.msgShow = $scope.acceptedPendingRequest;
              notification.isActive = false;
              notification.waitingAns = false;
              notification.shutdownButton = true;
            }
          }
          ///////////////////////////////
        } else if(allStatus.toMe.status == 2){
          //Ese usuario espera mi respuesta
          if(allStatus.toOthers.status == 1){
            //ya lo sigo
            notification.msgShow = $scope.acceptPendingRequest;
            notification.isActive = false;
            notification.waitingAns = false;
            notification.shutdownButton = false;
          } else if(allStatus.toOthers.status == 2){
            //Lo estoy esperando
            notification.msgShow = $scope.acceptPendingRequest;
            notification.isActive = false;
            notification.waitingAns = true;
            notification.shutdownButton = false;
          } else if(allStatus.toOthers.status == 3){
            //No he mandado solicitud
            notification.msgShow = $scope.acceptPendingRequest;
            notification.isActive = false;
            notification.waitingAns = false;
            notification.shutdownButton = false;
          }
          //////////////////////////////
        } else if(allStatus.toMe.status == 3){
          //Ese usuario no me ha mandado solicitud
          console.log("no debería salir nada aquí");
        }
      });
    };*/

    //new functtion used for actions refered to status friendship
    $scope.changeStatusFriend = function(notif) {
      if(notif.shutdownButton || notif.togglingFollow)
        return false;

      notif.togglingFollow = true;
      var prevText = notif.msgShow;
      //visual changes
        notif.isActive = false;
        notif.msgShow = "-----------"; //Temporal
      //
      //Check first status
      if(notif.itFollows == 1) {
        //she follow me
          if(notif.meFollow == 1) {
            //cancel follow
            ceaseFollowStatus(notif, $scope.followText, prevText, 3, 1);
          } else if(notif.meFollow == 2) {
            //Cancel Request
            ceaseFollowStatus(notif, $scope.followText, prevText, 3, 2);
          } else if(notif.meFollow == 3) {
            //mandar solicitud
            if(notif.privateAccount.result.value) //se pínta en espera
              askFollowPermission(notif, $scope.waitingNow, prevText, 2, 3);
            else //Se pinta son siguiendo
              askFollowPermission(notif, $scope.followingText, prevText, 1, 3);
          }
      } else if(notif.itFollows == 2) {
        //She's waiting for my answer
          if(notif.meFollow == 1) {
            //Lo aceptamos y muestro que lo sigo
            acceptRequestFollow(notif, $scope.followingText, prevText, 1, 2);
          } else if(notif.meFollow == 2) {
            //Lo aceptamos y mostramos mensaje de espera
            acceptRequestFollow(notif, $scope.waitingNow, prevText, 1, 2);
          } else if(notif.meFollow == 3) {
            //Lo aceptamos y mostramos boton para seguirlo
            acceptRequestFollow(notif, $scope.followText, prevText, 1, 2);
          }
      } else if(notif.itFollows == 3) {
        //she doesn't follow me
          if(notif.meFollow == 1) {
            //cancel follow
            ceaseFollowStatus(notif, $scope.followText, prevText, 3, 1);
          } else if(notif.meFollow == 2) {
            //Cancel Request
            ceaseFollowStatus(notif, $scope.followText, prevText, 3, 2);
          } else if(notif.meFollow == 3) {
            //mandar solicitud
            if(notif.privateAccount.result.value) //se pínta en espera
              askFollowPermission(notif, $scope.waitingNow, prevText, 2, 3);
            else //Se pinta son amigos
              askFollowPermission(notif, $scope.followingText, prevText, 1, 3);
          }
      }
    }

    //NEW function to cease follow a user
    function ceaseFollowStatus(notif, newText, oldText, newState, oldState) {
      UserService.cancelRequestToPrivate({
        objectId: Utils.getLastUrlComponent(notif.friend.href)
      }).save().$promise.then(function success(response) {
        notif.msgShow = newText;
        notif.simpleIdFriend = "";
        notif.waitingAns = false;
        notif.meFollow = newState;
      }, function (err) {
        notif.followed.result.value = !notif.followed.result.value;
        notif.msgShow = oldText;
        notif.meFollow = oldState;
        console.error("cancel Request ToPrivate", err);
        Utils.toast.error(Utils.translate("ERROR.UNKNOWN"));
      }).finally(function () {
        notif.togglingFollow = false;
      });
    }

    //NEW function to ask to follow a user
    function askFollowPermission(notif, newText, oldText, newState, oldState) {
      UserService.toggleFriendhipStateWS({
        userInstanceId: mySubscriptionId,
        friendInstaceId: Utils.getLastUrlComponent(notif.userSubscriptionSent.href)
      }).$promise.then(function (response) {
        //Send push notification Follower Follower
        if (response.result.value) {
          var dialogSend = "";
          notif.msgShow = newText;
          notif.meFollow = newState;
          if(newState == 2) {
            notif.waitingAns = true;
          }
          if (notif.privateAccount.result.value)
            dialogSend = UserService.get_USER_NAME() + ' ' + Utils.translate('NOTIFICATIONS.DIALOG.SEND_REQUEST');
          else 
            dialogSend = UserService.get_USER_NAME() + ' ' + Utils.translate('NOTIFICATIONS.DIALOG.IS_FOLLOWING_YOU');

          UserService.getDevices(Utils.getLastUrlComponent(notif.userSubscriptionSent.href)).$promise.then( function (responseEndPoint) {
            //CHECK T/F TO SEND
            responseEndPoint.result.value.forEach( function (endPointArn) {
              AWSServices.sendNotifaboutFollowAction(
                dialogSend,
                endpointArn.title,
                UserService.get_USER_NAME(),
                UserService.get_USERSUBSCRIPTIONINSTANCE_ID()
              )
            })
          })

          /*notificationsService.sendDeepNotificationToUserDevices(
            Utils.getLastUrlComponent(notif.userSubscriptionSent.href),
            UserService.get_USER_NAME() + dialogSend,
            'FOLLOW',
            null
          ).then(function (value) {
          }, function (error) {
            console.error("UserService.addDevice error: ", error);
          });*/
        }
        else {
          console.warn("toggleFriendhipState", response)
        }
      }, function (error) {
        notif.followed.result.value = !notif.followed.result.value;
        notif.msgShow = oldText;
        notif.meFollow = oldState;
        console.error("addFriends error", error);
      }).finally(function () {
        notif.togglingFollow = false;
      });
    }

    //NEW function to accept a friend request
    function acceptRequestFollow(notif, newText, oldText, newState, oldState) {
      UserService.acceptFriend({
        objectId: Utils.getLastUrlComponent(notif.friend.href)
      }).save(function () {
        notif.msgShow = newText;
        notif.itFollows = newState; //al aceptar no cambia mi status hacia ella sino al reves
        notif.togglingFollow = false;
      }, function (error) {
        notif.msgShow = oldText;
        notif.itFollows = oldState; //al aceptar no cambia mi status hacia ella sino al reves
        notif.togglingFollow = false;
        console.error("acceptFriend error", error);
      });
    }

    /*$scope.addFriends = function (notification) {
      console.log("notification", notification);
      if (notification.shutdownButton || notification.togglingFollow)
        return false;

      notification.togglingFollow = true;

      if (notification.isActive) {
        console.log("notification.isActive");
        //visual changes
        notification.isActive = false;
        notification.msgShow = $scope.followText;

        notification.followed.result.value = !notification.followed.result.value;
        UserService.cancelRequestToPrivate({
          objectId: Utils.getLastUrlComponent(notification.friend.href)
        }).save().$promise.then(function success(response) {
          notification.msgShow = $scope.followText;
          notification.simpleIdFriend = "";
          notification.waitingAns = false;
        }, function (err) {
          notification.followed.result.value = !notification.followed.result.value;
          notification.msgShow = $scope.unfollowText;
          console.error("cancel Request ToPrivate", err);
          Utils.toast.error(Utils.translate("ERROR.UNKNOWN"));
        }).finally(function () {
          notification.togglingFollow = false;
        });
      }
      else {
        //visual changes
        if (notification.privateAccount.result.value) {
          //cuenta privada se espera respuesta
          notification.msgShow = $scope.pendingRequest;
          notification.waitingAns = true;
        }
        else {
          //cuenta publica se autoacepta
          notification.msgShow = $scope.unfollowText;
        }
        notification.isActive = true;
        console.log("Otra...");
        notification.followed.result.value = !notification.followed.result.value;
        UserService.toggleFriendhipStateWS({
          userInstanceId: mySubscriptionId,
          friendInstaceId: Utils.getLastUrlComponent(notification.userSubscriptionSent.href)
        }).$promise.then(function (response) {
          //Send push notification Follower Follower
          if (response.result.value) {
            var dialogSend = "";
            if (notification.privateAccount.result.value) {
              dialogSend = Utils.translate('NOTIFICATIONS.DIALOG.SEND_REQUEST');
              $scope.findStatusRequestFriend(notification);
            }
            else {
              dialogSend = Utils.translate('NOTIFICATIONS.DIALOG.IS_FOLLOWING_YOU');
            }
            notificationsService.sendNotificationToUserDevices(
              Utils.getLastUrlComponent(notification.userSubscriptionSent.href),
              UserService.get_USER_NAME() + dialogSend
            ).then(function (value) {
            }, function (error) {
              console.error("UserService.addDevice error: ", error);
            });
          }
          else {
            console.warn("toggleFriendhipState", response)
          }
        }, function (error) {
          notification.followed.result.value = !notification.followed.result.value;
          console.error("addFriends error", error);
        }).finally(function () {
          notification.togglingFollow = false;
        });
      }
    };*/

    /*$scope.acceptFriend = function (notification) {
      console.log("acceptFriend", notification);
      if (notification.shutdownButton || notification.togglingFollow)
        return false;

      //if(notification.msgShow = 'Accepted') return;
      notification.togglingFollow = true;
      notification.msgShow = $scope.acceptedPendingRequest;
      notification.shutdownButton = true;
      UserService.acceptFriend({
        objectId: Utils.getLastUrlComponent(notification.friend.href)
      }).save(function () {
        notification.togglingFollow = false;
      }, function (error) {
        console.error("acceptFriend error", error);
        notification.togglingFollow = false;
        notification.msgShow = $scope.acceptPendingRequest;
      });
    };*/
  }])

  .controller('showNotificationCtrl', ['$rootScope', '$scope', 'UserService', 'SequenceService', 'adsService', '$state', 'permissionValidationService', 'cqnzService', 'SequenceFactory', 'CommentFactory', 'notificationsService', 'Utils',
    function ($rootScope, $scope, UserService, SequenceService, adsService, $state, permissionValidationService, cqnzService, SequenceFactory, CommentFactory, notificationsService, Utils) {
      //var sequenceBasicData = $state.params.sequenceBasicData;
      //console.log("showNotificationCtrl", sequenceBasicData);
      var sequenceIdTaken = $state.params.sequenceId;
      var groupIdTaken = $state.params.groupId;
      var previousState = $state.params.fromWhere;
      var groupIndexFrom = $state.params.groupIndex;
      var sequenceBasicData = null;
      $scope.isInShow = true;
      var myUserId = UserService.get_USERSUBSCRIPTIONINSTANCE_ID();
      var permissions = permissionValidationService;
      //$scope.iAmAdvertiser = UserService.USER_IS_ADVERTISER();
      $scope.iAmAdvertiser = permissions.canAdvertisementPermit();
      $scope._controllerName = 'showNotificationCtrl';
      $scope.hideShareButton = true;
      $scope.showAllComments = true;//for showing more than 2 comments in list
      //$scope.showCommentAvatar = true;
      $scope.showCommentLikeCounter = true;
      var pagination = {
        start: 0,
        count: 10
      };
      $scope.disableBtn = true;
      $scope.isRefreshing = false;
      $scope.isLoadingComments = false;
      $scope.canGetMoreItems = true;
      $scope.isFirstTime = true;
      $scope.errorLoading = false;
      $scope.isIOS = ionic.Platform.isIOS();
      $scope.isAndroid = ionic.Platform.isAndroid();
      $scope.showAllPics = true;
      /**
       * @type {SequenceType[]}
       * @private
       */
      $scope._sequenceList = [];

      var totalChildCommentsFound = 0;
      var sequenceMetadata = null;
      var sequenceOwnerMetadata = null;
      var listTags = null;
      var listHashs = null;
      var commentsCounts = null;

      $scope.getSequenceDataForShow = function () {
        $scope._groupHrefId = groupIdTaken;
        SequenceService.findSequenceBySequenceIdV181(sequenceIdTaken).$promise.then(function (gottenData){
          Utils.removeLastItemIfHasNoAttribute(gottenData, 'sequenceId');
          sequenceBasicData = gottenData[0];

          //we need to put this in $scope in order to sequeneceController can access it
          //$scope._groupHrefId = sequenceBasicData.groupId || 0;

          $scope.canComment = !!(sequenceBasicData.commentEnable &&
            ($scope._groupHrefId ? permissionValidationService.canCreateCommentInGroupTimeline() : permissionValidationService.canCreateCommentInGralTimeline())
          );

          /**@type {SequenceMetadataType}*/
          sequenceMetadata = {
            id: sequenceBasicData.sequenceId,
            instanceId: +Utils.getLastUrlComponent(sequenceBasicData.sequence.href),
            href: sequenceBasicData.sequence.href + "",
            dateTime: sequenceBasicData.creationTime,
            finalDate: sequenceBasicData.finalDate,
            lifetime: sequenceBasicData.lifetime,
            isPinned: sequenceBasicData.pinned,
            isAdvertisement: sequenceBasicData.isAdvertisement,
            mustBeDeleted: !(!sequenceBasicData.mustBeDeleted),
            belongsMe: UserService.get_USERSUBSCRIPTIONINSTANCE_ID() == Utils.getLastUrlComponent(sequenceBasicData.userSubscriptionId.href)
          };

          /**@type {SequenceOwnerMetadataType}*/
          sequenceOwnerMetadata = {
            id: +Utils.getLastUrlComponent(sequenceBasicData.userSubscriptionId.href),
            //instanceId:pendiente...
            name: sequenceBasicData.name + "",
            avatar: Utils.getUserImgUrl(sequenceBasicData)
          };

          $scope.isFirstTime = false;
          $scope.isLoadingComments = true;

          listTags = SequenceService.obtainTagwithIdandType({
            sequenceId: sequenceBasicData.sequenceId,
            notificationType: 7
          });

          //LuMa HashTags in sequence
          //listHashs = SequenceService.getHashFromSequence(sequenceBasicData.sequenceId);
          listHashs = SequenceService.findSequenceHashTagComment({
            sequenceId: sequenceBasicData.sequenceId,
            notificationType: 7,
            commentId: 0
          });

          commentsCounts = cqnzService.countSequenceCommentsByGroupWS({
            sequenceId: sequenceBasicData.sequenceId,
            groupId: $scope._groupHrefId
          }).$promise;
            

          Utils.$q.all({
            basicData: sequenceBasicData,
            commentsCounts: commentsCounts,
            tagsList: listTags,
            hashesList: listHashs
          }).then(function (notifCqnz) {
            notifCqnz.basicData.groupId = $scope._groupHrefId;
              
            notifCqnz.sequenceOwnerId = Utils.getLastUrlComponent(notifCqnz.basicData.userSubscriptionId.href);
            notifCqnz.sequenceItems = cqnzService.getItemsToSequenceV165WS(notifCqnz.basicData.sequenceId);
            notifCqnz.likeActive = SequenceService.findSmileysCount({
              sequenceId: Utils.getLastUrlComponent(notifCqnz.basicData.sequence.href),
              userId: myUserId
            });
            notifCqnz.followEachOther = myUserId == notifCqnz.sequenceOwnerId ? {result: {value: true}} : SequenceService.followEachOther({
              userId: myUserId,
              friendId: notifCqnz.sequenceOwnerId
            });
            notifCqnz.viewsCounter = $scope.iAmAdvertiser && notifCqnz.basicData.isAdvertisement ? adsService.getViewsCount(notifCqnz.basicData.sequenceId) : null;
            notifCqnz.clicksCounter = $scope.iAmAdvertiser && notifCqnz.basicData.isAdvertisement ? adsService.getClicksCount(notifCqnz.basicData.sequenceId) : null;
            notifCqnz.URLClicksCounter = $scope.iAmAdvertiser && notifCqnz.basicData.isAdvertisement ? adsService.getURLClicksCount(notifCqnz.basicData.sequenceId) : null;

            notifCqnz.basicData.sequenceCommentCount = notifCqnz.commentsCounts.result.value;

            var commentsPromises = {};
            if (notifCqnz.basicData.sequenceCommentCount) {
              //console.log("getting comments of (" + cqnzId + ", " + groupId + ")");
              commentsPromises[$scope._groupHrefId] = cqnzService.getCommentsOfSequenceWS({
                sequenceId: notifCqnz.basicData.sequenceId,
                groupId: $scope._groupHrefId,
                start: pagination.start,
                count: pagination.count
              }).$promise
            }

            notifCqnz.comments = [];
            Utils.$q.all(commentsPromises).then(function (resolvedComments) {
              Object.keys(resolvedComments).forEach(function (groupId) {
                Utils.removeLastItemIfHasNoAttribute(resolvedComments[groupId], 'commentId');
                if (resolvedComments[groupId].length) {
                  resolvedComments[groupId].groupId = groupId;
                  notifCqnz.comments = notifCqnz.comments.concat(resolvedComments[groupId]);
                }
              });

              /**@type {SequenceType}*/
              $scope._sequenceList[0] = SequenceFactory.buildSequenceObject(
                notifCqnz, {repliesCount: 0/*I want all the replies*/}
              );

              $scope.canComment = ($scope._sequenceList[0].comments.enabled &&
                ($scope._groupHrefId ? permissionValidationService.canCreateCommentInGroupTimeline() : permissionValidationService.canCreateCommentInGralTimeline())
              );

              Utils.removeLastItemIfHasNoAttribute(notifCqnz.comments, 'sequenceComments');
              $scope.canGetMoreItems = notifCqnz.comments.length === pagination.count;

              pagination.start = notifCqnz.comments.length;
              pagination.count = 15;

              $scope.isRefreshing = false;
              $scope.isLoadingComments = false;
              $scope.$broadcast('scroll.refreshComplete');
              $scope.$broadcast('scroll.infiniteScrollComplete');
              console.log("End loading sequence")
            }, function (error) {
              /**@type {SequenceType}*/
              $scope._sequenceList[0] = SequenceFactory.buildSequenceObject(notifCqnz, {repliesCount: 0});

              $scope.canComment = ($scope._sequenceList[0].comments.enabled &&
                ($scope._groupHrefId ? permissionValidationService.canCreateCommentInGroupTimeline() : permissionValidationService.canCreateCommentInGralTimeline())
              );

              Utils.removeLastItemIfHasNoAttribute(notifCqnz.comments, 'sequenceComments');
              $scope.canGetMoreItems = notifCqnz.comments.length === pagination.count;

              pagination.start = notifCqnz.comments.length;
              pagination.count = 15;

              $scope.isRefreshing = false;
              $scope.isLoadingComments = false;
              $scope.$broadcast('scroll.refreshComplete');
              $scope.$broadcast('scroll.infiniteScrollComplete');
              console.log("End loading sequence")
            })
          }, function (error) {
            onLoadError();
              console.error("cant get basicData, listTags or listHashs", error);
          })

        }, function (error){
          onLoadError();
          console.log("something wrong", error);
        })

      }
      $scope.getSequenceDataForShow();

      $scope.loadComments = function () {
        console.log("loading comments...", pagination.start, pagination.count);
        $scope.isLoadingComments = true;

        cqnzService.getCommentsOfSequenceWS({
          sequenceId: sequenceBasicData.sequenceId,
          start: pagination.start,
          count: pagination.count,
          groupId: $scope._groupHrefId
        }).$promise.then(function (comments) {
          Utils.removeLastItemIfHasNoAttribute(comments, 'sequenceComments');

          if (!$scope.isFirstTime) {
            notificationsService.countPendingRegularNotifications(UserService.get_USER_INSTANCE_HREF());
            notificationsService.countPendingFollowersNotifications(UserService.get_USER_INSTANCE_HREF());
          }

          $scope.isFirstTime = false;

          var totalParentsFetched = comments.length;
          if (!totalParentsFetched) {
            $scope.isRefreshing = false;
            $scope.canGetMoreItems = false;
            $scope.isLoadingComments = false;
            $scope.$broadcast('scroll.refreshComplete');
            $scope.$broadcast('scroll.infiniteScrollComplete');
            return;
          }


          var totalChildResolved = 0;
          comments.forEach(function (comment) {
            comment.groupId = $scope._groupHrefId;
            var parentComment = CommentFactory.buildCommentObject({
              comment: comment,
              sequenceMetadata: sequenceMetadata,
              sequenceOwnerMetadata: sequenceOwnerMetadata
            });

            if (comment.answerCount) {
              CommentFactory.getCommentReplies({
                commentId: comment.commentId,
                sequenceMetadata: sequenceMetadata,
                sequenceOwnerMetadata: sequenceOwnerMetadata,
                start: 0,
                count: 0//get all
              }).then(function (childComments) {
                parentComment.responses = childComments;
                $scope._sequenceList[0].comments.items.push(parentComment);
              }, function (error) {
                parentComment.responses = [];
                //console.log("Parent comment", parentComment);
                $scope._sequenceList[0].comments.items.push(parentComment);
              }).finally(function () {
                totalChildResolved++;
                if (totalParentsFetched === totalChildResolved) {
                  $scope.canGetMoreItems = totalParentsFetched === pagination.count;

                  pagination.start = $scope._sequenceList[0].comments.items.length;
                  pagination.count = 15;
                  $scope.isRefreshing = false;
                  $scope.isLoadingComments = false;
                  $scope.$broadcast('scroll.refreshComplete');
                  $scope.$broadcast('scroll.infiniteScrollComplete');
                }
              });//<-- getChildComments.finally()
            }
            else {
              parentComment.responses = [];
              $scope._sequenceList[0].comments.items.push(parentComment);

              totalChildResolved++;
              if (totalParentsFetched === totalChildResolved) {
                $scope.canGetMoreItems = totalParentsFetched === pagination.count;

                pagination.start = $scope._sequenceList[0].comments.items.length;
                pagination.count = 15;

                $scope.isRefreshing = false;
                $scope.isLoadingComments = false;
                $scope.$broadcast('scroll.refreshComplete');
                $scope.$broadcast('scroll.infiniteScrollComplete');
              }
            }
          });
        }, function (error) {
          onLoadError();
          console.error("getCommentsOfSequenceWS", error);
        });
      };

      $scope.reloadNotifComments = function () {
        $scope.isRefreshing = true;
        $scope.errorLoading = false;
        $scope.canGetMoreItems = true;
        pagination.start = 0;
        pagination.count = 10;
        $scope._sequenceList[0].comments.items = [];

        $scope.loadComments();

        notificationsService.countPendingRegularNotifications(UserService.get_USER_INSTANCE_HREF());
        notificationsService.countPendingFollowersNotifications(UserService.get_USER_INSTANCE_HREF());
      };

      function onLoadError() {
        $scope.errorLoading = true;
        $scope.isRefreshing = false;
        $scope.canGetMoreItems = false;
        $scope.isLoadingComments = false;
        $scope.$broadcast('scroll.refreshComplete');
        $scope.$broadcast('scroll.infiniteScrollComplete');
      }

      //append here the child functions
      //that need tobe executed from this control
      $scope.commentListSharedCtrl = {};
      $scope.openCommentComposer = function () {
        $scope.commentListSharedCtrl.openTextEditorWithTags().then(function (form) {
          createComment(form)
        })
      };

      /**
       * @param form {messageComposerFormType}
       */
      function createComment(form) {
        Utils.loading.show();
        $scope.isCreatingComment = true;

        CommentFactory.createComment({
          sequenceMetadata: sequenceMetadata,
          sequenceOwnerMetadata: sequenceOwnerMetadata,
          description: form.description,
          tagsList: form.savedTags,
          hashTagsList: form.savedHashes, //LuMa HashTags in comments
          imageData: form.imagePath,
          groupId: $scope._groupHrefId
        }).then(/**@param newComment {CommentStructureType}*/function (newComment) {
          //backupDescription
          //editableDescription
          //description - description
          newComment.description = cqnzService.getTextWithAnchors(newComment.description);
          $scope._sequenceList[0].comments.items.push(newComment);
          //$scope._sequenceList[0].comments.counter++; //because is increased down below on $rootScope events
          Utils.$timeout(function () {
            Utils.$ionicScrollDelegate.resize();
            Utils.$ionicScrollDelegate.scrollBottom();
          }, 800);
        }, function (error) {
          //the errors are printed inside the function
          Utils.toast.error(Utils.translate("SEQUENCE.DIALOG.CREATE_POST_COMMENT_ERROR"))
        }).finally(function () {
          $scope.isCreatingComment = false;
          Utils.loading.hide();
        });
      }

      var deregisterFn1 = $rootScope.$on('sequence.comment.created', function (ev, data) {
        console.log("showNotificationCtrl on(sequence.comment.created)", $scope._sequenceList[0]);
        $scope._sequenceList[0].comments.counter++;
      });

      var deregisterFn2 = $rootScope.$on('sequence.comment.deleted', function (ev, data) {
        console.log("showNotificationCtrl on(sequence.comment.deleted)", $scope._sequenceList[0]);
        $scope._sequenceList[0].comments.counter--;

        if (!data.comment.isReply)
          $scope._sequenceList[0].comments.counter -= data.childrenDeleted;
      });

      // clean up listener when controller's scope is destroyed
      $scope.$on('$destroy', function () {
        console.log("showNotificationCtrl: Deregistering sequence.comment event listeners");
        deregisterFn1();
        deregisterFn2();
      });

      //when enter this page we need to know from where the user is coming to send them there with back
      /*$rootScope.$on('$stateChangeSuccess', function (ev, to, toParams, from, fromParams) {
        //assign the "from" parameter to something
        console.log("from name", from.name);
        console.log("to name", to.name);
        $scope.fromWhere = from.name;
        $scope.toWhere = to.name;
      });*/

      $scope.checkBacktrack = function () {
        console.log("from to", previousState);
        if(previousState === 'friendProfile' || previousState === "menu.myProfile" || previousState === 'vod')/*LuMa Live Streaming*/ {
          window.history.back();
        } else if(previousState === 'menu.timeline') {
          $state.go('menu.timeline', {prepareStatement: 0, groupIndex: groupIndexFrom});
        } else {
          //UPDATE VARIABLE TO STOP REFRESH
            $rootScope.cancelRefreshNotif = true;
          //$state.go('menu.notificationTabs.regular', {}, {reload: false});
          window.history.back();
          /*
          $state.go('menu.timeline', {prepareStatement: 0, groupIndex: groupIdx + 1});
          */
        }
      }    
  }])

  .controller('showStreamingCtrl', ['$rootScope', '$scope', 'UserService', 'SequenceService', 'adsService', '$state', 'permissionValidationService', 'cqnzService', 'SequenceFactory', 'CommentFactory', 'notificationsService', 'Utils', 'StreamingService',
    function ($rootScope, $scope, UserService, SequenceService, adsService, $state, permissionValidationService, cqnzService, SequenceFactory, CommentFactory, notificationsService, Utils, StreamingService) {

      var sequenceIdTaken = $state.params.sequenceId;
      var groupIdTaken = $state.params.groupId;
      var previousState = $state.params.fromWhere;
      var groupIndexFrom = $state.params.groupIndex;
      var sequenceBasicData = null;
      $scope.isInShow = true;
      var myUserId = UserService.get_USERSUBSCRIPTIONINSTANCE_ID();
      var permissions = permissionValidationService;
      $scope.iAmAdvertiser = permissions.canAdvertisementPermit();
      $scope._controllerName = 'showStreamingCtrl';
      $scope.hideShareButton = true;
      $scope.showAllComments = true;
      $scope.showCommentLikeCounter = true;
      var pagination = {
        start: 0,
        count: 10
      };
      $scope.disableBtn = true;
      $scope.isRefreshing = false;
      $scope.isLoadingComments = false;
      $scope.canGetMoreItems = true;
      $scope.isFirstTime = true;
      $scope.errorLoading = false;
      $scope.isIOS = ionic.Platform.isIOS();
      $scope.isAndroid = ionic.Platform.isAndroid();
      $scope.showAllPics = true;
      $scope._sequenceList = [];
      var totalChildCommentsFound = 0;
      var sequenceMetadata = null;
      var sequenceOwnerMetadata = null;
      var listTags = null;
      var listHashs = null;
      var commentsCounts = null;

      $scope.getSequenceDataForShow = function () {
        $scope._groupHrefId = groupIdTaken;
        SequenceService.findSequenceBySequenceIdV181(sequenceIdTaken).$promise.then(function (gottenData){
          Utils.removeLastItemIfHasNoAttribute(gottenData, 'sequenceId');
          sequenceBasicData = gottenData[0];

          //we need to put this in $scope in order to sequeneceController can access it
          //$scope._groupHrefId = sequenceBasicData.groupId || 0;

          $scope.canComment = !!(sequenceBasicData.commentEnable &&
            ($scope._groupHrefId ? permissionValidationService.canCreateCommentInGroupTimeline() : permissionValidationService.canCreateCommentInGralTimeline())
          );

          /**@type {SequenceMetadataType}*/
          sequenceMetadata = {
            id: sequenceBasicData.sequenceId,
            instanceId: +Utils.getLastUrlComponent(sequenceBasicData.sequence.href),
            href: sequenceBasicData.sequence.href + "",
            dateTime: sequenceBasicData.creationTime,
            finalDate: sequenceBasicData.finalDate,
            lifetime: sequenceBasicData.lifetime,
            isPinned: sequenceBasicData.pinned,
            isAdvertisement: sequenceBasicData.isAdvertisement,
            mustBeDeleted: !(!sequenceBasicData.mustBeDeleted),
            belongsMe: UserService.get_USERSUBSCRIPTIONINSTANCE_ID() == Utils.getLastUrlComponent(sequenceBasicData.userSubscriptionId.href)
          };

          /**@type {SequenceOwnerMetadataType}*/
          sequenceOwnerMetadata = {
            id: +Utils.getLastUrlComponent(sequenceBasicData.userSubscriptionId.href),
            //instanceId:pendiente...
            name: sequenceBasicData.name + "",
            avatar: Utils.getUserImgUrl(sequenceBasicData)
          };

          $scope.isFirstTime = false;
          $scope.isLoadingComments = true;

          listTags = SequenceService.obtainTagwithIdandType({
            sequenceId: sequenceBasicData.sequenceId,
            notificationType: 7
          });

          //LuMa HashTags in sequence
          //listHashs = SequenceService.getHashFromSequence(sequenceBasicData.sequenceId);
          listHashs = SequenceService.findSequenceHashTagComment({
            sequenceId: sequenceBasicData.sequenceId,
            notificationType: 7,
            commentId: 0
          });

          commentsCounts = cqnzService.countSequenceCommentsByGroupWS({
            sequenceId: sequenceBasicData.sequenceId,
            groupId: $scope._groupHrefId
          }).$promise;
            
          Utils.$q.all({
            basicData: sequenceBasicData,
            commentsCounts: commentsCounts,
            tagsList: listTags,
            hashesList: listHashs
          }).then(function (notifCqnz) {
            notifCqnz.basicData.groupId = $scope._groupHrefId;
              
            notifCqnz.sequenceOwnerId = Utils.getLastUrlComponent(notifCqnz.basicData.userSubscriptionId.href);
            notifCqnz.sequenceItems = cqnzService.getItemsToSequenceV165WS(notifCqnz.basicData.sequenceId);
            notifCqnz.likeActive = SequenceService.findSmileysCount({
              sequenceId: Utils.getLastUrlComponent(notifCqnz.basicData.sequence.href),
              userId: myUserId
            });
            notifCqnz.followEachOther = myUserId == notifCqnz.sequenceOwnerId ? {result: {value: true}} : SequenceService.followEachOther({
              userId: myUserId,
              friendId: notifCqnz.sequenceOwnerId
            });
            notifCqnz.viewsCounter = $scope.iAmAdvertiser && notifCqnz.basicData.isAdvertisement ? adsService.getViewsCount(notifCqnz.basicData.sequenceId) : null;
            notifCqnz.clicksCounter = $scope.iAmAdvertiser && notifCqnz.basicData.isAdvertisement ? adsService.getClicksCount(notifCqnz.basicData.sequenceId) : null;
            notifCqnz.URLClicksCounter = $scope.iAmAdvertiser && notifCqnz.basicData.isAdvertisement ? adsService.getURLClicksCount(notifCqnz.basicData.sequenceId) : null;

            notifCqnz.basicData.sequenceCommentCount = notifCqnz.commentsCounts.result.value;

            var commentsPromises = {};
            if (notifCqnz.basicData.sequenceCommentCount) {
              //console.log("getting comments of (" + cqnzId + ", " + groupId + ")");
              commentsPromises[$scope._groupHrefId] = cqnzService.getCommentsOfSequenceWS({
                sequenceId: notifCqnz.basicData.sequenceId,
                groupId: $scope._groupHrefId,
                start: pagination.start,
                count: pagination.count
              }).$promise
            }

            notifCqnz.comments = [];
            Utils.$q.all(commentsPromises).then(function (resolvedComments) {
              Object.keys(resolvedComments).forEach(function (groupId) {
                Utils.removeLastItemIfHasNoAttribute(resolvedComments[groupId], 'commentId');
                if (resolvedComments[groupId].length) {
                  resolvedComments[groupId].groupId = groupId;
                  notifCqnz.comments = notifCqnz.comments.concat(resolvedComments[groupId]);
                }
              });

              /**@type {SequenceType}*/
              $scope._sequenceList[0] = SequenceFactory.buildSequenceObject(
                notifCqnz, {repliesCount: 0/*I want all the replies*/}
              );

              $scope.canComment = ($scope._sequenceList[0].comments.enabled &&
                ($scope._groupHrefId ? permissionValidationService.canCreateCommentInGroupTimeline() : permissionValidationService.canCreateCommentInGralTimeline())
              );

              Utils.removeLastItemIfHasNoAttribute(notifCqnz.comments, 'sequenceComments');
              $scope.canGetMoreItems = notifCqnz.comments.length === pagination.count;

              pagination.start = notifCqnz.comments.length;
              pagination.count = 15;

              newCallforM3U8();

              $scope.isRefreshing = false;
              $scope.isLoadingComments = false;
              $scope.$broadcast('scroll.refreshComplete');
              $scope.$broadcast('scroll.infiniteScrollComplete');
              console.log("End loading sequence")
              $scope.prepareTO();
              $scope.callBanners();
            }, function (error) {
              /**@type {SequenceType}*/
              $scope._sequenceList[0] = SequenceFactory.buildSequenceObject(notifCqnz, {repliesCount: 0});

              $scope.canComment = ($scope._sequenceList[0].comments.enabled &&
                ($scope._groupHrefId ? permissionValidationService.canCreateCommentInGroupTimeline() : permissionValidationService.canCreateCommentInGralTimeline())
              );

              Utils.removeLastItemIfHasNoAttribute(notifCqnz.comments, 'sequenceComments');
              $scope.canGetMoreItems = notifCqnz.comments.length === pagination.count;

              pagination.start = notifCqnz.comments.length;
              pagination.count = 15;

              $scope.isRefreshing = false;
              $scope.isLoadingComments = false;
              $scope.$broadcast('scroll.refreshComplete');
              $scope.$broadcast('scroll.infiniteScrollComplete');
              console.log("End loading sequence");
              $scope.prepareTO();
            })
          }, function (error) {
            onLoadError();
              console.error("cant get basicData, listTags or listHashs", error);
          })

        }, function (error){
          onLoadError();
          console.log("something wrong", error);
        })

      }
      $scope.getSequenceDataForShow();

      function newCallforM3U8 () {
        if($scope._sequenceList[0].content.items[0]) {
          /*TO LOAD M3U8 EXTERNAL LIBRARY BALA*/
            var idVideo = $scope._controllerName+"VideoArea"+$scope._sequenceList[0].metadata.id;
            var video = document.getElementById(idVideo);
            var newURL = $scope._sequenceList[0].content.items[0].url;
            if(!$scope.isAndroid){
              newURL = newURL + "?playsinline=1";
              $scope._sequenceList[0].content.items[0].url = newURL;
            }
            if($scope.isAndroid) {
              if(Hls.isSupported())
              {
                  var hls = new Hls();
                  hls.loadSource(newURL);
                  hls.attachMedia(video);
                  hls.on(Hls.Events.MANIFEST_PARSED,function()
                  {
                      video.play();
                  });
              } else if (video.canPlayType('application/vnd.apple.mpegurl'))
              {
                  video.src = newURL;
                  video.addEventListener('canplay',function()
                  {
                      video.play();
                  });
              }
            } else {
              if(video)
                  video.play();
              else {
                  Utils.$timeout(function () {
                    newCallforM3U8();
                  }, 1000);
              }
            }
          /*TO LOAD M3U8 EXTERNAL LIBRARY END*/
        } else {
          Utils.$timeout(function () {
            newCallforM3U8();
          }, 1000);
          
        }
      }

      $scope.loadComments = function () {
        console.log("loading comments...", pagination.start, pagination.count);
        $scope.isLoadingComments = true;
        cqnzService.getCommentsOfSequenceWS({
          sequenceId: sequenceBasicData.sequenceId,
          start: pagination.start,
          count: pagination.count,
          groupId: $scope._groupHrefId
        }).$promise.then(function (comments) {
          Utils.removeLastItemIfHasNoAttribute(comments, 'sequenceComments');

          if (!$scope.isFirstTime) {
            notificationsService.countPendingRegularNotifications(UserService.get_USER_INSTANCE_HREF());
            notificationsService.countPendingFollowersNotifications(UserService.get_USER_INSTANCE_HREF());
          }

          $scope.isFirstTime = false;

          var totalParentsFetched = comments.length;
          if (!totalParentsFetched) {
            $scope.isRefreshing = false;
            $scope.canGetMoreItems = false;
            $scope.isLoadingComments = false;
            $scope.$broadcast('scroll.refreshComplete');
            $scope.$broadcast('scroll.infiniteScrollComplete');
            Utils.$timeout(function () {
              Utils.$ionicScrollDelegate.$getByHandle('messages-stream-view').scrollBottom();
              /*Utils.$ionicScrollDelegate.resize();
              Utils.$ionicScrollDelegate.scrollBottom();*/
              //$scope.loadComments();
            }, 800);
            return;
          }


          var totalChildResolved = 0;
          comments.forEach(function (comment) {
            comment.groupId = $scope._groupHrefId;
            var parentComment = CommentFactory.buildCommentObject({
              comment: comment,
              sequenceMetadata: sequenceMetadata,
              sequenceOwnerMetadata: sequenceOwnerMetadata
            });

            if (comment.answerCount) {
              CommentFactory.getCommentReplies({
                commentId: comment.commentId,
                sequenceMetadata: sequenceMetadata,
                sequenceOwnerMetadata: sequenceOwnerMetadata,
                start: 0,
                count: 0//get all
              }).then(function (childComments) {
                parentComment.responses = childComments;
                $scope._sequenceList[0].comments.items.push(parentComment);
              }, function (error) {
                parentComment.responses = [];
                //console.log("Parent comment", parentComment);
                $scope._sequenceList[0].comments.items.push(parentComment);
              }).finally(function () {
                totalChildResolved++;
                if (totalParentsFetched === totalChildResolved) {
                  $scope.canGetMoreItems = totalParentsFetched === pagination.count;
                  pagination.start = $scope._sequenceList[0].comments.items.length;
                  pagination.count = 15;
                  $scope.isRefreshing = false;
                  $scope.isLoadingComments = false;
                  $scope.$broadcast('scroll.refreshComplete');
                  $scope.$broadcast('scroll.infiniteScrollComplete');
                  Utils.$timeout(function () {
                    Utils.$ionicScrollDelegate.resize();
                    Utils.$ionicScrollDelegate.scrollBottom();
                    //$scope.loadComments();
                  }, 800);
                }
              });//<-- getChildComments.finally()
            }
            else {
              parentComment.responses = [];
              $scope._sequenceList[0].comments.items.push(parentComment);

              totalChildResolved++;
              if (totalParentsFetched === totalChildResolved) {
                $scope.canGetMoreItems = totalParentsFetched === pagination.count;

                pagination.start = $scope._sequenceList[0].comments.items.length;
                pagination.count = 15;

                $scope.isRefreshing = false;
                $scope.isLoadingComments = false;
                
                Utils.$timeout(function () {
                  Utils.$ionicScrollDelegate.resize();
                  Utils.$ionicScrollDelegate.scrollBottom();
                  $scope.$broadcast('scroll.refreshComplete');
                $scope.$broadcast('scroll.infiniteScrollComplete');
                  //$scope.loadComments();
                }, 800);
              }
            }
          });
        }, function (error) {
          onLoadError();
          console.error("getCommentsOfSequenceWS", error);
        });
      };

      $scope.reloadNotifComments = function () {
        $scope.isRefreshing = true;
        $scope.errorLoading = false;
        $scope.canGetMoreItems = true;
        pagination.start = 0;
        pagination.count = 10;
        $scope._sequenceList[0].comments.items = [];

        $scope.loadComments();

        notificationsService.countPendingRegularNotifications(UserService.get_USER_INSTANCE_HREF());
        notificationsService.countPendingFollowersNotifications(UserService.get_USER_INSTANCE_HREF());
      };

      function onLoadError() {
        $scope.errorLoading = true;
        $scope.isRefreshing = false;
        $scope.canGetMoreItems = false;
        $scope.isLoadingComments = false;
        $scope.$broadcast('scroll.refreshComplete');
        $scope.$broadcast('scroll.infiniteScrollComplete');
      }

      //append here the child functions
      //that need tobe executed from this control
      $scope.commentListSharedCtrl = {};
      $scope.openCommentComposer = function () {
        $scope.commentListSharedCtrl.openTextEditorWithTags().then(function (form) {
          createComment(form)
        })
      };

      /**
       * @param form {messageComposerFormType}
       */
      function createComment(form) {
        Utils.loading.show();
        $scope.isCreatingComment = true;
        //clearInterval($scope.toVar);
        CommentFactory.createComment({
          sequenceMetadata: sequenceMetadata,
          sequenceOwnerMetadata: sequenceOwnerMetadata,
          description: form.description,
          tagsList: form.savedTags,
          hashTagsList: form.savedHashes, //LuMa HashTags in comments
          imageData: form.imagePath,
          groupId: $scope._groupHrefId
        }).then(function (newComment) {
          //newComment.description = cqnzService.getTextWithAnchors(newComment.description);
          //$scope._sequenceList[0].comments.items.push(newComment);
          Utils.$timeout(function () {
            Utils.$ionicScrollDelegate.resize();
            Utils.$ionicScrollDelegate.scrollBottom();
            //$scope.loadComments();
          }, 800);
        }, function (error) {
          //the errors are printed inside the function
          Utils.toast.error(Utils.translate("SEQUENCE.DIALOG.CREATE_POST_COMMENT_ERROR"))
        }).finally(function () {
          $scope.isCreatingComment = false;
          Utils.loading.hide();
        });
      }

      var deregisterFn1 = $rootScope.$on('sequence.comment.created', function (ev, data) {
        console.log("showNotificationCtrl on(sequence.comment.created)", $scope._sequenceList[0]);
        $scope._sequenceList[0].comments.counter++;
      });

      var deregisterFn2 = $rootScope.$on('sequence.comment.deleted', function (ev, data) {
        console.log("showNotificationCtrl on(sequence.comment.deleted)", $scope._sequenceList[0]);
        $scope._sequenceList[0].comments.counter--;

        if (!data.comment.isReply)
          $scope._sequenceList[0].comments.counter -= data.childrenDeleted;
      });

      // clean up listener when controller's scope is destroyed
      $scope.$on('$destroy', function () {
        console.log("showNotificationCtrl: Deregistering sequence.comment event listeners");
        deregisterFn1();
        deregisterFn2();
        $scope._controllerName = null;
        //clearInterval($scope.toVar);
      });

      //when enter this page we need to know from where the user is coming to send them there with back
      /*$rootScope.$on('$stateChangeSuccess', function (ev, to, toParams, from, fromParams) {
        //assign the "from" parameter to something
        console.log("from name", from.name);
        console.log("to name", to.name);
        $scope.fromWhere = from.name;
        $scope.toWhere = to.name;
      });*/

      $scope.checkBacktrack = function () {
        console.log("from to", previousState);
        if(previousState === 'friendProfile' || previousState === "menu.myProfile" || previousState === 'vod')/*LuMa Live Streaming*/ {
          window.history.back();
        } else if(previousState === 'menu.timeline') {
          $state.go('menu.timeline', {prepareStatement: 0, groupIndex: groupIndexFrom});
        } else {
          //UPDATE VARIABLE TO STOP REFRESH
            $rootScope.cancelRefreshNotif = true;
          //$state.go('menu.notificationTabs.regular', {}, {reload: false});
          window.history.back();
          /*
          $state.go('menu.timeline', {prepareStatement: 0, groupIndex: groupIdx + 1});
          */
        }
      }

      /*
      prepare timeout for loading messages
      */

      $scope.toVar = null;
      $scope.prepareTO = function () {
        console.log("begin loop");
        var pivot = JSON.parse(window.localStorage.getItem('AppsPerzonalized'));
        var pivotNum = +pivot.timerRefreshMsgStream;
        Utils.$timeout(function () {
          if($scope._controllerName === 'showStreamingCtrl') {
            if($scope.isLoadingComments) {
              $scope.prepareTO();
            } else {
              $scope.loadComments();
              $scope.prepareTO();
            }
          }
        }, pivotNum);
      }

      $scope.banersList = {};
      $scope.showBannerArea = false;
      $scope.sliderOptions = {
        initialSlide: 0,
        direction: 'horizontal', //or vertical
        speed: 300 //0.3s transition
      }
      $scope.sliderDelegate = null;
      $scope.callBanners = function () {
        console.log("begin banners");
        var pivot = JSON.parse(window.localStorage.getItem('AppsPerzonalized'));
        var pivotNum = +pivot.timerRefreshMsgStream;
        Utils.$timeout(function () {
          StreamingService.getBannersForVideoOrStream().$promise.then(function (response) {
            if(response.length > 1)
              $scope.showBannerArea = true;
            response.forEach( function(url) {
              $scope.banersList[url.pictureId] = url.url;
            })
            
            //document.getElementById
          }, function (error) {
            console.error("error getting the banners")
          })
        }, pivotNum);
      }

      $scope.callViewers = function () {

      }

  }])
;
