"use strict";
appControllers
  .controller('MyProfileCtrl', ['$rootScope', '$scope', '$state', 'TimeLineService', 'timelinesService', 'UserService', 'SequenceService', 'ApiEndPoint', 'cqnzData', 'usersData', 'followersData', 'friendsData', '$q', '$sce', 'reDirectService', 'ionicService', '$timeout', 's3', 'md5', '$ionicActionSheet', 'permissionValidationService', 'cqnzService', 'Utils', 'FileService2', 'GroupsService', 'AWSServices',
    function($rootScope, $scope, $state, TimeLineService, timelinesService, UserService, SequenceService, ApiEndPoint, cqnzData, usersData, followersData, friendsData, $q, $sce, reDirectService, ionicService, $timeout, s3, md5, $ionicActionSheet, permissionValidationService, cqnzService, Utils, FileService2, GroupsService, AWSServices) {
      Utils.clearHistory();

      var myUserId = UserService.get_USERSUBSCRIPTIONINSTANCE_ID();
      var permissions = permissionValidationService;
      //append here the child functions
      //that need tobe executed from this control
      $scope.MyProfileSharedCtrl = {};

      //Check what device
      $scope.isIOS = Utils.isIOS();
      $scope.isAndroid = Utils.isAndroid();
      $scope.editBio = false;
      $scope.activeMenus = false;

      /*CHECK IF THE USER CAN HAVE SCHELUDED POSTS*/
      $scope.haveScheduledPermit = permissions.canCreateScheduledPostInGroupTimeline();

      $scope.data = { userMembership: '' };

      /*
       * deregister back button
       */
      function irPaTras() {
        $rootScope.$ionicGoBack();
      }
      var deregisterHardBack = Utils.$ionicPlatform.registerBackButtonAction(
        irPaTras, 101
      );

      /*
       * cancel custom action for back button
       */
      $scope.$on('$routeChangeStart', function() {
        deregisterHardBack();
      })

      /*
       * Stay alert to when the user changes his/her name
       */
      $scope.$on("$ionicView.beforeEnter", function() {
        FileService2.cleanImages;
        $scope.nameProfile = UserService.get_USER_NAME();
        $scope.userBio = UserService.get_USER_BIO();
        $scope.backgroundPhoto = UserService.get_BACK_GROUND();
        $scope.pictureProfile = UserService.get_USER_PHOTO();

        $timeout(function() {
          $scope.$apply();
        });
      });


      //Code to check if the user is verfied or not
      $scope.verifiedUser = function() {
        UserService.findUserSubscriptionById().get({
          "userSubscriptionId": '"' + myUserId + '"'
        }, function(response) {
          $scope.verifyUser = response[0].verifyUser;
        }, function(error) {
          console.log("findUserSubscriptionById Error");
        });
      };

      //count CQNZs for  my Profile
      $scope.getCountSequences = function() {
        UserService.countSequencesToAUser({ "objectId": window.localStorage.getItem('userSubscriptionInstanceId') }).get({},
          function(data) {
            $scope.numberSequences = data.result.value;
          },
          function(error) {
            console.log("countSequencesToAUser Error");
          }
        );
      };
      $scope.getCountSequences();

      //count followers for  my Profile
      $scope.getCountFollowers = function() {
        UserService.countFollowersToAUser().get({
            "x-isis-querystring": {
              "userId": {
                "value": {
                  "href": ApiEndPoint.url + "restful/objects/simple.UserSubscription/" + window.localStorage.getItem('userSubscriptionInstanceId')
                }
              }
            }
          },
          function(data) {
            $scope.numberFollowers = data.result.value;
          },
          function(error) {
            console.log("countFollowersToAUser Error");
          }
        );
      };
      $scope.getCountFollowers();

      //count following for  my Profile
      $scope.getCountFollowing = function() {
        UserService.countFollowingToAUser().get({
            "x-isis-querystring": {
              "userSubscriptionId": {
                "value": {
                  "href": ApiEndPoint.url + "restful/objects/simple.UserSubscription/" + window.localStorage.getItem('userSubscriptionInstanceId')
                }
              }
            }
          },
          function(data) {
            $scope.numberFollowing = data.result.value;
          },
          function(error) {
            console.log("countFollowingToAUser Error");
          }
        );
      };
      $scope.getCountFollowing();

      $scope.canUpdateBio = permissionValidationService.canUpdateUserBio();
      $scope.editBiography = function(newText) {
        UserService.editTextfromUserBiography({ "objectId": myUserId }).save({
          "string": {
            "value": newText
          }
        }, function success(data) {
          //console.log(data);
          $scope.userBio = newText;
          window.localStorage.setItem("userBiography", newText);
        }, function(response) {
          console.log("editTextfromUserBiography error:");
        });
      };

      //Followers PAGE
      $scope.reDirectFollowersPage = function() {
        $state.go('followersFollowing', { userInstanceId: myUserId, listType: 'followers' }, { reload: true });
      };

      //Following page
      $scope.reDirectFriendsPage = function() {
        $state.go('followersFollowing', { userInstanceId: myUserId, listType: 'following' }, { reload: true });
      };

      //Scheduled posts page
      $scope.reDirectScheduledPage = function() {
        $state.go('scheduledPostsPage', { userInstanceId: myUserId }, { reload: true });
      }

      //execution of child scope (footer) function
      $scope.openPostFirstTime = function() {
        $scope.MyProfileSharedCtrl.openUploadAreaFromParent(true);
      }

      $scope.refreshMyPostsFunction = function() {
        $scope.MyProfileSharedCtrl.refreshMyProfilePosts(true);
      };

      timelinesService.myProfileTimeline.events.sequence.onDelete = function(data) {
        $scope.MyProfileSharedCtrl.SequenceOnPostDeleted(data);
        $scope.numberSequences--;
      };

      timelinesService.myProfileTimeline.events.sequence.onTitleEdited = function(data) {
        $scope.MyProfileSharedCtrl.SequenceOnTitleEdited(data);
      };

      timelinesService.myProfileTimeline.events.sequence.onContentEdited = function(data) {
        $scope.MyProfileSharedCtrl.SequenceOnContentEdited();
      };

      timelinesService.myProfileTimeline.events.sequence.onShareableUpdated = function(data) {
        $scope.MyProfileSharedCtrl.SequenceOnShareableUpdated(data);
      };

      timelinesService.myProfileTimeline.events.sequence.onCountersUpdated = function(data) {
        $scope.MyProfileSharedCtrl.SequenceOnCountersUpdated(data);
      };

      timelinesService.myProfileTimeline.events.comment.onEnabledUpdated = function(data) {
        $scope.MyProfileSharedCtrl.commentOnEnabledUpdated(data);
      };

      timelinesService.myProfileTimeline.events.comment.onCreate = function(data) {
        $scope.MyProfileSharedCtrl.commentOnCreate(data);
      };

      timelinesService.myProfileTimeline.events.comment.onUpdate = function(data) {
        $scope.MyProfileSharedCtrl.commentOnUpdate(data);
      };

      timelinesService.myProfileTimeline.events.comment.onDelete = function(data) {
        $scope.MyProfileSharedCtrl.commentOnDelete(data);
      };

      timelinesService.myProfileTimeline.events.comment.onLikeUpdated = function(data) {
        $scope.MyProfileSharedCtrl.commentOnLikeUpdated(data);
      };

      $scope.notifing = false;
      $scope.$on("photo.upload", function (event, data) {
        console.log("CALLED ROOTSCOPE.ON");
        if($scope.notifing) {
          return true;
        }
        $scope.notifing = true;
        var wsData = {
          groupId: 0,
          userSubscriptionId: UserService.get_USERSUBSCRIPTION_ID(),
          notification: 15 //AGREGAR TIPO DE NOTIF 15
        };
        GroupsService.getEndPointsFollowerswithNotif(wsData).then( function (dataWS) {
          console.log("CALLED WS");
          var messageForShow = Utils.translate('ALERTS.NEW_PROFILE_PICTURE_01') + 
            UserService.get_USER_NAME() +
            Utils.translate('ALERTS.NEW_PROFILE_PICTURE_02');

          dataWS.forEach( function (dataDevices) {

            //console.log("for each", dataDevices);
            AWSServices.sendNewProfilePhotoNotification(
              messageForShow, 
              dataDevices.userDeviceId,
              0,
              UserService.get_USERSUBSCRIPTION_ID()
            )

          })
          $scope.notifing = false;
        }, function (errorWS) {
          console.log("complete error", errorWS);
        })
      })
    }
  ])

  .controller('friendProfileCtrl', ['$scope', '$state', 'UserService', 'ApiEndPoint', 'TimeLineService', 'SequenceService', 'usersData', 'friendsData', 'followersData', 'likeUsersData', 'cqnzData', '$sce', 'ionicService', '$timeout', '$ionicHistory', 'reDirectService', 'permissionValidationService', 'AppAdminMembersService', 'notificationsService', 'ChatFactory2', 'Utils', 'AWSServices', 'changeProfilePictureService',
    function($scope, $state, UserService, ApiEndPoint, TimeLineService, SequenceService, usersData, friendsData, followersData, likeUsersData, cqnzData, $sce, ionicService, $timeout, $ionicHistory, reDirectService, permissionValidationService, AppAdminMembersService, notificationsService, ChatFactory2, Utils, AWSServices, changeProfilePictureService) {
      var myUserId = UserService.get_USERSUBSCRIPTIONINSTANCE_ID();

      $scope.iAmAdmin = UserService.USER_IS_SUPERADMIN();

      $scope.userName = null;
      $scope.newProfileImage = [];
      $scope.friend = {};

      $scope.countSequences = 0;

      $scope.togglingFollow = false;
      $scope.unfollowText = Utils.translate('GLOBAL.UNFOLLOW');
      $scope.followText = Utils.translate('GLOBAL.FOLLOW');
      $scope.sendMessageText = Utils.translate('PROFILE.MESSAGE');
      $scope.pendingRequest = Utils.translate('GLOBAL.PENDING');
      $scope.msgShowRequest = "";
      $scope.waitingAnswer = false;
      $scope.simpleIdFriend = "";
      $scope.hidePrivBanner = true;
      //Obtener datos del usuario que se selecciono previamente Timeline/Search/notifications

      $scope.data = {};
      $scope.data.bloqued = false;
      $scope.data.unbloqued = true;

      //CODE TO REDIRECT TO LIST OF FRIENDS
      $scope.reDirectListFriends = function() {
        if ($state.params.instanceId !== undefined) {
          //check if the profile is private and if i'm friends with it if not i can't access following
          //super admin can see ANYBODY
          if ($scope.profileStatus === false || ($scope.profileStatus === true && $scope.isFriend === true) || $scope.iAmAdmin === true) {
            $state.go('followersFollowing', {
              userInstanceId: $state.params.instanceId,
              listType: 'following'
            }, { reload: true });
          }
        }
      };

      //CODE TO REDIRECT TO LIST OF FOLLOWERS
      $scope.reDirectFriendFollowersPage = function() {
        if ($state.params.instanceId !== undefined) {
          //check if the profile is private and if i'm friends with it if not i can't access followers
          //super admin can see ANYBODY
          if ($scope.profileStatus === false || ($scope.profileStatus === true && $scope.isFriend === true) || $scope.iAmAdmin === true) {
            $state.go('followersFollowing', {
              userInstanceId: $state.params.instanceId,
              listType: 'followers'
            }, { reload: true });
          }
        }
      };

      // Function to obtain the data of the friend
      $scope.initFriendProfile = function() {
        getFriendSubscription();
        countMySequences();
        countMyFollowers();
        getCountFollowing();
        findFriendInstanceId();
        findFriendBackGround();
        findStatusRequestFriend();
      };
      $scope.initFriendProfile();

      function getFriendSubscription() {
        //UserService.getUserSubscriptionByinstanceId($state.params.instanceId).$promise.then(function (data) {
        UserService.getUserSubscriptionByinstanceIdCompleteProfile($state.params.instanceId).$promise.then(function(data) {
          $scope.profileStatus = data[0].privateAccount;
          $scope.hidePrivBanner = $scope.profileStatus == true ? false : true;
          //$scope.hidePrivBanner = $scope.iAmAdmin === true ? true : false; //super admin can see ANYBODY
          if (data[0].userBio !== null && data[0].userBio !== undefined) {

            $scope.friendBio = data[0].userBio;
          } else {
            $scope.friendBio = "I love to travel";
          }
          //Request for largest profile photo
          UserService.findUserProfilePictureLargeById({
            "objectId": $state.params.instanceId
          }).get().$promise.then(function success(result) {
            //If the user doesn't have a large profile photo we use the photo in the subscription
            //This must be temporal and needs to be deprecated when all users have large photo
            if (result[0].profilePicture) {
              $scope.pictureFriendProfile = "data:image/jpeg;base64," + result[0].profilePicture.split(':')[2];
            } else {
              $scope.pictureFriendProfile = data[0].profilePicture !== null ? "data:image/jpeg;base64," + data[0].profilePicture.split(':')[2] : "img/ProfilePhoto.svg";
            }
            if (result[0].profilePictureUrl) {
              $scope.pictureFriendProfile = result[0].profilePictureUrl;
            } else {
              $scope.pictureFriendProfile = data[0].profilePictureUrl !== null ? +data[0].profilePictureUrl : "img/ProfilePhoto.svg";
            }
          }, function(response) {
            console.error("findUserProfilePictureLargeById", response);
          });


          $scope.nameFriendProfile = data[0].name;
          $scope.subscriptionId = data[0].userSubscriptionId;

          UserService.findUserSubscriptionById().get({
            "userSubscriptionId": '"' + $scope.subscriptionId + '"'
          }, function(response) {
            $scope.verifyFriendUser = response[0].verifyUser;
          }, function(error) {
            console.error("findUserSubscriptionById", error);
          });
        }, function(error) {
          console.error("getUserSubscriptionByinstanceId", error);
        });
      }

      //count CQNZs for  my Profile
      function countMySequences() {
        UserService.countSequencesToAUser({ "objectId": $state.params.instanceId }).get({},
          function(data) {
            $scope.listCQNZ = data.result.value;
            $scope.topCQNZ = data.result.value;
          },
          function(error) {
            console.error("countSequencesToAUser: ", error);
          }
        );
      }

      //count followers for  my Profile
      function countMyFollowers() {
        UserService.countFollowersToAUser().get({
            "x-isis-querystring": {
              "userId": {
                "value": {
                  "href": ApiEndPoint.url + "restful/objects/simple.UserSubscription/" + $state.params.instanceId
                }
              }
            }
          },
          function(data) {
            $scope.numberFollowers = data.result.value;
          },
          function(error) {
            console.error("countFollowersToAUser", error);
          }
        );
      }

      //count following for  my Profile
      function getCountFollowing() {
        UserService.countFollowingToAUser().get({
            "x-isis-querystring": {
              "userSubscriptionId": {
                "value": {
                  "href": ApiEndPoint.url + "restful/objects/simple.UserSubscription/" + $state.params.instanceId
                }
              }
            }
          },
          function(data) {
            $scope.numberFollowing = data.result.value;
          },
          function(error) {
            console.error("countFollowingToAUser", error);
          }
        );
      }

      function findFriendInstanceId() {
        UserService.findFriendInstanceId({
          userId: myUserId,
          friendId: $state.params.instanceId
        }).then(function success(response) {
          if (response.result.value.length > 0) {
            $scope.friend.instanceId = response.result.value[0].href.split('/')[6]
            UserService.getFriend({
              "itemId": $scope.friend.instanceId
            }).get().$promise.then(function success(response) {
              $scope.friend.favorite = response.favorite;
            }, function(response) {
              console.log("findFriend", response);
            });
          }
        }, function(response) {
          console.log("findFriend", response);
        });
      }

      function findStatusRequestFriend() {
        UserService.getStatusPrivateRequest({
          userId: UserService.get_USERSUBSCRIPTIONINSTANCE_ID(),
          friendId: $state.params.instanceId
        }).$promise.then(function success(response) {
          console.log("success", response);
          if (response.friend) {
            $scope.simpleIdFriend = Utils.getLastUrlComponent(response.friend.href);
          }
          if (response.status == 1) {
            //son amigos
            $scope.msgShowRequest = $scope.unfollowText;
            $scope.waitingAnswer = false;
            $scope.hidePrivBanner = true;
          } else if (response.status == 2) {
            //waiting
            $scope.msgShowRequest = $scope.pendingRequest;
            $scope.waitingAnswer = true;
            $scope.hidePrivBanner = false;
          } else if (response.status == 3) {
            //no son amigos
            $scope.msgShowRequest = $scope.followText;
            $scope.waitingAnswer = false;
            $scope.hidePrivBanner = false;
          }
        }, function(err) {
          console.log("mistake when finding status request", err);
        })
      }

      //WS to ge friend background
      function findFriendBackGround() {
        changeProfilePictureService.getBackgroundPictureFromId({
          userId: $state.params.instanceId
        }).then(function success(response) {
          console.log("get");
          if (!response.result) {
            $scope.backgroundPhoto = "./img/postBg.png";
          } else {
            $scope.backgroundPhoto = response.result.value;
          }
        }, function(response) {
          console.log("findFriendBackGround", response);
        })
      }

      //Zone to add hashtags
      $scope.addHash = function(sequenceInfo) {
        var listHashTags = [];
        var fixHash = "";
        var pivotInsert = 0;
        var positionHashTag = 0;
        var HashtagId = 0;
        var calcEnd = 0;
        var fixedHashArray = [];
        //LuMa HashTags in sequence
        //SequenceService.getHashFromSequence(sequenceInfo.key).then(function (hashData) {
        SequenceService.findSequenceHashTagComment({
          sequenceId: sequenceInfo.key,
          notificationType: 7,
          commentId: 0
        }).then(function (hashData) {
          if (hashData.length > 0) {
            hashData.length--;
            for (var a = 0; a < hashData.length; a++) {
              listHashTags.push(hashData[a].hash);
              fixedHashArray[a] = "#" + hashData[a].hash;
            }
            fixedHashArray.sort(function(a, b) {
              return b.length - a.length;
            });
            for (var b = 0; b < fixedHashArray.length; b++) {
              fixHash = fixedHashArray[b];
              if (sequenceInfo.descriptionSequence.indexOf(fixHash) != -1) {
                positionHashTag = sequenceInfo.descriptionSequence.indexOf(fixHash, pivotInsert);
                if (positionHashTag == 0) {
                  sequenceInfo.descriptionSequence = sequenceInfo.descriptionSequence.substr(0, positionHashTag) + '<span class="mentionTag" name="' + fixedHashArray[b] + '">' + fixHash + '</span>&nbsp;' + sequenceInfo.descriptionSequence.substr(positionHashTag + fixHash.length);
                  pivotInsert = pivotInsert + (positionHashTag - pivotInsert) + 31 + fixedHashArray[b].length + 2 + fixHash.length + 13;
                } else {
                  calcEnd = positionHashTag + fixHash.length;
                  if (calcEnd == sequenceInfo.descriptionSequence.length) {
                    sequenceInfo.descriptionSequence = sequenceInfo.descriptionSequence.substr(0, positionHashTag) + '<span class="mentionTag" name="' + fixedHashArray[b] + '">' + fixHash + '</span>&nbsp;' + sequenceInfo.descriptionSequence.substr(positionHashTag + fixHash.length);
                    pivotInsert = 0;
                  } else {
                    positionHashTag = sequenceInfo.descriptionSequence.indexOf(" " + fixHash + " ");
                    if (positionHashTag == -1) {
                      positionHashTag = sequenceInfo.descriptionSequence.indexOf(" " + fixHash);
                    }
                    if (positionHashTag == -1) {
                      positionHashTag = sequenceInfo.descriptionSequence.indexOf(fixHash + " ");
                      positionHashTag = positionHashTag - 1;
                    }
                    positionHashTag = positionHashTag + 1;
                    sequenceInfo.descriptionSequence = sequenceInfo.descriptionSequence.substr(0, positionHashTag) + '<span class="mentionTag" name="' + fixedHashArray[b] + '">' + fixHash + '</span>&nbsp;' + sequenceInfo.descriptionSequence.substr(positionHashTag + fixHash.length);
                  }
                }
              }
            }
          }
          sequenceInfo.hashtagIdAssociated = listHashTags;
        });
      };

      $scope.addFavorite = function() {
        if ($scope.friend.instanceId) {
          $scope.friend.favorite = $scope.friend.favorite === 0 ? 5 : 0;
          UserService.favorite({ "objectId": $scope.friend.instanceId }).post({
            "int": {
              "value": $scope.friend.favorite
            }
          }).$promise.then(function success(response) {
            console.log("favorite level: ")
          }, function(response) {
            console.log("addFavorite error");
          });
        }
      };

      //function to check friend or not
      $scope.getFollowingIsActive = function() {

        UserService.getFollowingIsActiveWS({
          userInstanceId: UserService.get_USERSUBSCRIPTIONINSTANCE_ID(),
          friendInstaceId: $state.params.instanceId
        }).$promise.then(function(data) {
          $scope.isFriend = data.result.value;
          /*if($scope.isFriend){
            $scope.msgShowRequest = $scope.unfollowText;
          } else {
            $scope.msgShowRequest = $scope.followText;
          }*/
        }, function(error) {
          $scope.isFriend = false;
          console.log("getFollowingIsActive error");
        });
      };
      $scope.getFollowingIsActive();

      //function to follow/unfollow users
      $scope.addFriends = function() {
        $scope.togglingFollow = true;

        if ($scope.isFriend) {
          //visual changes
          $scope.isFriend = false;
          $scope.msgShowRequest = $scope.followText;

          if ($scope.simpleIdFriend != "") {
            UserService.cancelRequestToPrivate({ "objectId": $scope.simpleIdFriend }).save().$promise.then(function success(response) {
              $scope.msgShowRequest = $scope.followText;
              $scope.simpleIdFriend = "";
              $scope.waitingAnswer = false;
            }, function(err) {});
          }
        } else {
          //visual changes
          if ($scope.profileStatus) {
            if ($scope.msgShowRequest === $scope.pendingRequest) {
              $scope.msgShowRequest = $scope.followText;
            } else {
              $scope.msgShowRequest = $scope.pendingRequest;
            }
            $scope.isFriend = false;
          } else {
            $scope.isFriend = true;
            $scope.msgShowRequest = $scope.unfollowText;
          }

          if ($scope.waitingAnswer) {
            if ($scope.simpleIdFriend != "") {
              UserService.cancelRequestToPrivate({ "objectId": $scope.simpleIdFriend }).save().$promise.then(function success(response) {
                $scope.msgShowRequest = $scope.followText;
                $scope.simpleIdFriend = "";
                $scope.waitingAnswer = false;
              }, function(err) {});
            }
          } else {
            UserService.toggleFriendhipStateWS({
              userInstanceId: UserService.get_USERSUBSCRIPTIONINSTANCE_ID(),
              friendInstaceId: $state.params.instanceId
            }).$promise.then(function(response) {
              //search friend object in case we don't have it so we can add to favorites
              if (!$scope.friend.instanceId) {
                findFriendInstanceId();
              }
              if ($scope.profileStatus) {
                findStatusRequestFriend(); //refresh ids and messages
              }
              //Send push notification Follower FriendProfile
              if (response.result.value) {
                var message = "";
                if ($scope.msgShowRequest === $scope.pendingRequest) {
                  message = UserService.get_USER_NAME() + ' ' + Utils.translate('NOTIFICATIONS.DIALOG.SEND_REQUEST');
                } else {
                  message = UserService.get_USER_NAME() + ' ' + Utils.translate('NOTIFICATIONS.DIALOG.IS_FOLLOWING_YOU');
                }
                //T/F TO CHECK SEND
                UserService.getDevices($state.params.instanceId).$promise.then(function(responseEndPoint) {
                  responseEndPoint.result.value.forEach(function(endPointArn) {
                    AWSServices.sendNotifaboutFollowAction(
                      message,
                      endPointArn.title,
                      UserService.get_USER_NAME(),
                      UserService.get_USERSUBSCRIPTIONINSTANCE_ID()
                    )
                  })
                })
                /*notificationsService.sendDeepNotificationToUserDevices(
                  $state.params.instanceId,
                  message,
                  'FOLLOW',
                  null
                ).then(function () {
                }, function () {
                });*/
              }
              $scope.togglingFollow = false;

            }, function(error) {
              console.log("addFriends error", error);
              $scope.togglingFollow = false;
              $scope.waitingAnswer = false;
            });
          }
        }
      };

      var currentContacts = [];
      $scope.canShowDirectMsgButton = false;

      ChatFactory2.DB.getCurrentRooms().then(function(contactList) {
        currentContacts = contactList;
        $scope.canShowDirectMsgButton = true;
      }, function(error) {
        console.error("Couldn't get the current rooms", error);
        $scope.canShowDirectMsgButton = false;
      });

      $scope.gotoChatroom = function() {
        var exists = currentContacts.some(function(contact) {
          return contact.id === +$state.params.instanceId;
        });

        var friend = {};
        if (exists) {
          console.log("The contact already exists", +$state.params.instanceId)
          ChatFactory2.DB.getInboxContact(
            +$state.params.instanceId
          ).then(function(contact) {
            $state.go('chatPrivate', { friend: contact, addToContacts: false }, { reload: true });
          })
        } else {
          friend.socket = { isOnline: false };
          friend.user = {
            id: +$state.params.instanceId,
            name: $scope.nameFriendProfile,
            avatar: $scope.pictureFriendProfile,
            bio: $scope.friendBio
          };
          friend.message = {};

          console.log("Creating new contact for chatting", friend);

          $state.go('chatPrivate', { friend: friend, addToContacts: true }, { reload: true });
        }
      };


      $scope.findBlockUserById = function() {
        UserService.findBlockUserById().get({
          "x-isis-querystring": {
            "userSubscriptionId": {
              "value": {
                "href": ApiEndPoint.url + 'restful/objects/simple.UserSubscription/' + myUserId
              }
            },
            "userBlockedId": {
              "value": {
                "href": ApiEndPoint.url + 'restful/objects/simple.UserSubscription/' + $state.params.instanceId
              }
            }
          }
        }, function success(response) {
          if (response.length > 1) {
            $scope.data.bloqued = true;
            $scope.data.unbloqued = false;
          } else {
            $scope.data.bloqued = false;
            $scope.data.unbloqued = true;
          }
          Utils.loading.hide();
        }, function(response) {
          console.log("findBlockUserById error");
          Utils.loading.hide();
        });
      };

      $scope.showOptionsMenu = function() {
        var buttons = [];
        var buttonsIds = [];

        /*  if ($scope.data.bloqued == false && $scope.data.unbloqued == true) {
          buttons.push({text: Utils.translate('GLOBAL.BLOCK_USER')});
          buttonsIds.push('GLOBAL.BLOCK_USER');
        } else if ($scope.data.bloqued == true && $scope.data.unbloqued == false) {
          buttons.push({text: Utils.translate('GLOBAL.UNBLOCK_USER')});
          buttonsIds.push('GLOBAL.UNBLOCK_USER');
        }*/

        if ($scope.iAmAdmin) {
          buttons.push({ text: Utils.translate('MENU.ADMIN_TOOLS.TITLE') + ' <i class="icon adminToolsTitle"></i>' });
          buttonsIds.push('MENU.ADMIN_TOOLS.TITLE');
          buttons.push({ text: Utils.translate('MENU.ADMIN_TOOLS.BAN_USER') });
          buttonsIds.push('MENU.ADMIN_TOOLS.BAN_USER');
          buttons.push({ text: Utils.translate('MENU.ADMIN_TOOLS.BLOCK_USER') });
          buttonsIds.push('MENU.ADMIN_TOOLS.BLOCK_USER');
        }

        Utils.$ionicActionSheet.getCtrl().show({
          cssClass: 'friendProfile-actionSheet',
          buttons: buttons,
          /*titleText: Utils.translate('GLOBAL.GENERAL_OPTIONS'),*/
          buttonClicked: function(buttonIndex) {
            switch (buttonsIds[buttonIndex]) {
              case 'GLOBAL.BLOCK_USER':
                askBlockUser(true);
                break;
              case 'GLOBAL.UNBLOCK_USER':
                askBlockUser(false);
                break;
              case 'MENU.ADMIN_TOOLS.TITLE':
                return false;
              case 'MENU.ADMIN_TOOLS.BAN_USER':
                confirmBanUser();
                break;
              case 'MENU.ADMIN_TOOLS.BLOCK_USER':
                confirmLockUser();
                break;
              default:
                Utils.toast.warning("Invalid option '" + buttonsIds[buttonIndex] + "'");
            }
            return true;
          },
          destructiveText: $scope.iAmAdmin ? Utils.translate('MENU.ADMIN_TOOLS.DELETE_USER') : null,
          destructiveButtonClicked: $scope.iAmAdmin ? function() {
            confirmDeleteUser();
            return true;
          } : null
        });

        //fake group divider...
        setTimeout(function() {
          var el = document.getElementsByClassName('adminToolsTitle');
          if (el && el.length) {
            var parentEl = el[0].parentElement;

            if (Utils.isIOS()) {
              parentEl.style.fontSize = '13px';
              parentEl.style.color = '#8f8f8f';
            } else if (Utils.isAndroid()) {
              parentEl.style.fontSize = '14px';
              parentEl.style.color = '#666';
              parentEl.style.paddingLeft = '16px';
            }
          }
        }, 100)
      };

      function confirmBanUser() {
        Utils.confirm.show(Utils.translate('ADMIN_TOOLS.ADMIN_MEMBERS.DIALOG.BAN_ACCOUNT_CONF')).then(function(boolResp) {
          if (!boolResp) return;

          Utils.loading.show();
          AppAdminMembersService.banUser(
            $scope.subscriptionId
          ).then(function(value) {
            Utils.toast.success(Utils.translate('ADMIN_TOOLS.ADMIN_MEMBERS.DIALOG.BAN_ACCOUNT_OK'))
          }, function(error) {
            console.error(error);
            Utils.toast.error(Utils.translate('ADMIN_TOOLS.ADMIN_MEMBERS.DIALOG.BAN_ACCOUNT_ERROR'))
          }).finally(function() {
            Utils.loading.hide();
          })
        })
      }

      function confirmLockUser() {
        Utils.confirm.show(Utils.translate('ADMIN_TOOLS.ADMIN_MEMBERS.DIALOG.LOCK_ACCOUNT_CONF')).then(function(boolResp) {
          if (!boolResp) return;

          Utils.loading.show();
          AppAdminMembersService.lockUser(
            $scope.subscriptionId
          ).then(function(value) {
            Utils.toast.success(Utils.translate('ADMIN_TOOLS.ADMIN_MEMBERS.DIALOG.LOCK_ACCOUNT_OK'))
          }, function(error) {
            console.error(error);
            Utils.toast.error(Utils.translate('ADMIN_TOOLS.ADMIN_MEMBERS.DIALOG.LOCK_ACCOUNT_ERROR'))
          }).finally(function() {
            Utils.loading.hide();
          })
        })
      }

      function confirmDeleteUser() {
        Utils.confirm.show(
          Utils.translate('ADMIN_TOOLS.ADMIN_MEMBERS.DIALOG.DELETE_ACCOUNT_CONF') +
          "<br><b>" + Utils.translate('ADMIN_TOOLS.ADMIN_MEMBERS.DIALOG.DELETE_ACCOUNT_DISCOURAGE') + "</b>"
        ).then(function(boolResp) {
          if (!boolResp) return;

          Utils.loading.show();
          AppAdminMembersService.deleteSubscription(
            $scope.subscriptionId
          ).then(function(value) {
            Utils.toast.success(Utils.translate('ADMIN_TOOLS.ADMIN_MEMBERS.DIALOG.DELETE_ACCOUNT_OK'))
          }, function(error) {
            console.error(error);
            Utils.toast.error(Utils.translate('ADMIN_TOOLS.ADMIN_MEMBERS.DIALOG.DELETE_ACCOUNT_ERROR'))
          }).finally(function() {
            Utils.loading.hide();
          })
        })
      }

      function askBlockUser(type) {
        var msg = "";
        if (type == true) {
          msg = Utils.translate('GLOBAL.ASK_USERBLOCK');
        } else {
          msg = Utils.translate('GLOBAL.ASK_USERUNBLOCK');
        }
        Utils.confirm.show(msg).then(function(boolResp) {
          if (!boolResp) return;
          if (type == true) {
            blockToUser();
          } else {
            unblockToUser();
          }

        })
      }

      function blockToUser() {
        Utils.loading.show();
        UserService.blockToUser(
          myUserId,
          $state.params.instanceId
        ).then(function(response) {
          Utils.loading.hide();
          console.log("blockToUser response");
          $scope.findBlockUserById();

          //after block it remove friendship if have any
          if ($scope.isFriend) {
            //visual changes
            $scope.isFriend = false;
            $scope.msgShowRequest = $scope.followText;

            if ($scope.simpleIdFriend != "") {
              UserService.cancelRequestToPrivate({ "objectId": $scope.simpleIdFriend }).save().$promise.then(function success(response) {
                $scope.msgShowRequest = $scope.followText;
                $scope.simpleIdFriend = "";
                $scope.waitingAnswer = false;
              }, function(err) {});
            }
          }
        }, function(error) {
          console.log("blockToUser error");
          Utils.loading.hide();
        }).finally(function() {
          Utils.loading.hide();
        });
      }

      function unblockToUser() {
        Utils.loading.show();
        UserService.unblockUser(
          myUserId,
          $state.params.instanceId
        ).then(function() {
          Utils.loading.hide();
          $scope.findBlockUserById();
        }, function(response) {
          console.log("unblockUser error");
        }).finally(function() {
          Utils.loading.hide();
        });
      }


      $scope.canShowFriendMenu = function() {
        return UserService.USER_IS_SUPERADMIN()
      }
    }
  ])

  .controller('configureMyProfileTabsCtrl', ['$scope', '$state', 'UserService', 'Utils', '$rootScope',
    function($scope, $state, UserService, Utils, $rootScope) {
      //Utils.clearHistory();

      $scope.activateTab = function(tabname) {
        $scope.activeTab = tabname;
        var view1 = document.getElementsByClassName('config-view-basicData');
        var view2 = document.getElementsByClassName('config-view-metaData');

        var i;
        if (tabname === 'basicData') {
          for (i = 0; i < view1.length; i++) {
            if (view1[i].children[0])
              view1[i].children[0].setAttribute('nav-view', 'active')
          }

          for (i = 0; i < view2.length; i++) {
            if (view2[i].children[0])
              view2[i].children[0].setAttribute('nav-view', 'cached')
          }
        } else {
          for (i = 0; i < view1.length; i++) {
            if (view1[i].children[0])
              view1[i].children[0].setAttribute('nav-view', 'cached')
          }

          for (i = 0; i < view2.length; i++) {
            if (view2[i].children[0])
              view2[i].children[0].setAttribute('nav-view', 'active')
          }
        }
      }

      $scope.$on('$ionicView.beforeEnter', function() {
        if ($state.current.name === 'menu.configProfileTabs.configureMyProfile')
          $scope.activeTab = 'basicData';
        else
          $scope.activeTab = 'metaData';

        Utils.$timeout(function() {
          $scope.activateTab($scope.activeTab);
        }, 100);
      })
  }])

  .controller('configureMyProfileCtrl', ['$scope', '$state', 'UserService', 'Utils', 'UserServiceFb', '$rootScope', 'permissionValidationService', 'Personalized',
    function($scope, $state, UserService, Utils, UserServiceFb, $rootScope, permissionValidationService, Personalized) {

      $scope.data = {};
      $scope.advice = false;
      $scope.isFBUser = false;
      $scope.showPrivateOptions = true;
      $scope.data.viewChangePriv = false;
      $scope.countErrorsOnUpdate = 0;
      $scope.countChangesMade = 0;
      $scope.usingLink = false;
      $scope.usingMembership = false;
      $scope.warningName = false;
      $scope.data.birthday = new Date();
      $scope.userSubscriptionId = UserService.get_USERSUBSCRIPTION_ID(); //Token
      var permissions = permissionValidationService;
      //Order
      //name - can modify
      //email- can modify
      //biography - can modify
      //username - can't modify
      //private - can modify
      $scope.obtainData = function() {
        var userName;
        if (window.localStorage.getItem('starter_facebook_user')) {
          $scope.isFBUser = true;
          userName = "Logged by Facebook";
        } else {
          userName = window.localStorage.getItem('userName')
        }
        //check in Ls for status of account
        var privateStatus = false;
        if (window.localStorage.getItem('ownPrivate') === 'true') {
          privateStatus = true;
        }
        //check if user is linked to FB
        var linkedAcc = false;
        var userFace = UserServiceFb.getUser();
        if (userFace.userID) {
          linkedAcc = true;
        }
        var textUse01 = "",
          textUse02 = "";
        if (window.localStorage.getItem('firstName') == '' || window.localStorage.getItem('firstName') == "undefined" || window.localStorage.getItem('firstName') == null) {
          textUse01 = window.localStorage.getItem('name');
        } else {
          textUse01 = window.localStorage.getItem('firstName');
        }
        if (window.localStorage.getItem('lastName') == '' || window.localStorage.getItem('lastName') == "undefined" || window.localStorage.getItem('lastName') == null) {
          textUse02 = "";
        } else {
          textUse02 = window.localStorage.getItem('lastName');
        }
        //look for birthday saved
        var storedBirthday = window.localStorage.getItem('birthDate');
        var temporalDate = null;
        var showDate = false;
        if (storedBirthday === "null" || storedBirthday === null) {
          storedBirthday = new Date();
          temporalDate = storedBirthday;
          showDate = true;
        } else {
          var dateParts = storedBirthday.split('-');
          temporalDate = new Date(dateParts[0], dateParts[1] - 1, dateParts[2]);
          showDate = false;
        }

        //////////////////////OmRo 200919 Select city/////////////////////////////////
        UserService.getCities().$promise.then(function(resp) {
          Utils.removeLastItemIfHasNoAttribute(resp, 'idCity');
          //console.log(resp);

          resp.unshift({ idCity: 0, city: Utils.translate("SIGNUP.SELECT_CITY") });
          $scope.data.cities = resp;
          $scope.data.selectedCity = resp[0];
          //AuthService.logout();
        }, function(error) {
          console.error("get Cities", error);
        });
        ///////////////////////////////OmRo Token 09102019e/////////////////////////////
        $scope.showToken = permissions.viewTokens();

        if (permissions.viewTokens()) {

          UserService.findUserSubscriptionById().get({
            "userSubscriptionId": '"' + $scope.userSubscriptionId + '"'
          }, function(response) {
            $scope.data.token = response[0].tokensCount;
          }, function(error) {
            console.log("findUserSubscriptionById error", error);

          });
        }

        ////////////////////////////////////////////////////////////////////////////

        $scope.data.fields = [{
            isActive: false, //0 name
            value: window.localStorage.getItem('name'),
            backUp: window.localStorage.getItem('name')
          },
          {
            isActive: false, //1 Firstname
            value: textUse01,
            backUp: textUse01
          },
          {
            isActive: false, //2 Lastname
            value: textUse02,
            backUp: textUse02
          },
          {
            isActive: false, //3 mail
            value: window.localStorage.getItem('userEmail'),
            backUp: window.localStorage.getItem('userEmail')
          },
          {
            isActive: false, //4 BIO
            value: window.localStorage.getItem('userBiography'),
            backUp: window.localStorage.getItem('userBiography')
          },
          {
            isActive: false, //5 userName
            value: userName,
            backUp: userName
          },
          { //6 status private or public
            isActive: privateStatus,
            value: privateStatus,
            backUp: false
          },
          { //7 Membership
            isActive: false,
            placeholder: Utils.translate('PROFILE.ADD_MEMBERSHIP'),
            value: UserService.get_USER_MEMBERSHIP(),
            backUp: UserService.get_USER_MEMBERSHIP()
          },
          { //8 AccountLinked
            isActive: false,
            placeholder: linkedAcc ? 'Linked' : 'Not Linked',
            value: linkedAcc ? 'Linked' : 'Not Linked',
            backUp: linkedAcc ? 'Linked' : 'Not Linked'
          },
          { //9 Birthday
            isActive: showDate,
            value: temporalDate,
            backuUp: storedBirthday,
            changed: false
          },
          {
            isActive: false, //10 City OmRo 200919 Select city
            value: window.localStorage.getItem('city'),
            backUp: window.localStorage.getItem('city')
          }
        ];

        $scope.data.viewChangePriv = false;
      };
      $scope.obtainData();

      $scope.chkTypeUser = function(num) {
        if ($scope.isFBUser) {
          if (num != 1) {
            $scope.toogleActive(num);
          } else {
            $scope.advice = true;
          }
        } else {
          $scope.toogleActive(num);
        }
      }

      $scope.toogleActive = function(num) {
        if (!$scope.data.fields[num].isActive) {
          $scope.data.fields[num].isActive = true;
          if (num == 0) {
            $scope.data.fields[1].isActive = true;
            $scope.data.fields[2].isActive = true;
          }
        } else {
          $scope.data.fields[num].isActive = false;
          $scope.data.fields[num].value = $scope.data.fields[num].backUp;
          if (num == 0) {
            $scope.data.fields[1].isActive = false;
            $scope.data.fields[1].value = $scope.data.fields[1].backUp;
            $scope.data.fields[2].isActive = false;
            $scope.data.fields[2].value = $scope.data.fields[2].backUp;
          }
        }
      };

      /*$scope.checkChanges = function () {
        $scope.advice = false;
        if ($scope.data.fields[0].isActive) {
          $scope.data.fields[0].isActive = false;
          $scope.updateName();
        }
        if ($scope.data.fields[1].isActive) {
          $scope.data.fields[1].isActive = false;
          $scope.updateEmail();
        }
        if ($scope.data.fields[2].isActive) {
          $scope.data.fields[2].isActive = false;
          $scope.updateBio();
        }
        if ($scope.data.fields[5].isActive) {
          $scope.data.fields[5].isActive = false;
          $scope.data.fields[5].backup = $scope.data.fields[5].value;
          addMembership();
        }
        if ($scope.data.viewChangePriv) {
          $scope.changePrivateAccount();
        }
      };*/

      /*$scope.updateName = function () {
        $scope.data.fields[0].backUp = $scope.data.fields[0].value;
        var tempText = $scope.data.fields[0].value.split(" ");
        var firstName = " ";
        var middleName = " ";
        var lastName = " ";
        var lastName2 = " ";
        if (tempText.length == 1) {
          firstName = $scope.data.fields[0].value;
        } else if (tempText.length == 2) {
          firstName = tempText[0];
          lastName = tempText[1];
        } else {
          firstName = tempText[0];
          for (var i = 1; i < tempText.length; i++) {
            if (i == 1) {
              lastName = tempText[i];
            }
            else {
              lastName = lastName + " " + tempText[i];
            }
          }
        }
        if (firstName.length > 20) {
          middleName = firstName.slice(21);
          firstName = firstName.slice(0, 20);
        }
        if (lastName.length > 20) {
          lastName2 = lastName.slice(21);
          lastName = lastName.slice(0, 20);
        }

        UserService.name({
          objectId: UserService.get_SIMPLEUSERINSTANCE_ID()
        }).post({
          "firstName": {
            "value": firstName
          },
          "middleName": {
            "value": middleName
          },
          "lastName": {
            "value": lastName
          },
          "lastName2": {
            "value": lastName2
          }
        }).$promise.then(function success(response) {
            //window.localStorage.setItem('name', $scope.data.fields[0].value);
            UserService.set_USER_NAME($scope.data.fields[0].value);
          }, function (response) {
          }
        );
      };*/

      /*$scope.updateEmail = function () {
        $scope.data.fields[1].backUp = $scope.data.fields[1].value;
        UserService.email({
          objectId: UserService.get_SIMPLEUSERINSTANCE_ID()
        }).post({
          email: {
            value: $scope.data.fields[1].value
          }
        }).$promise.then(function success(response) {
            window.localStorage.setItem("userEmail", $scope.data.fields[1].value);
          }, function (response) {
          }
        );
      };*/

      /*$scope.updateBio = function () {
        $scope.data.fields[2].backUp = $scope.data.fields[2].value;
        UserService.editTextfromUserBiography({"objectId": window.localStorage.getItem("userSubscriptionInstanceId")}).save(
          {
            "string": {
              "value": $scope.data.fields[2].value
            }
          }, function success(data) {
            window.localStorage.setItem("userBiography", $scope.data.fields[2].value);
          }, function (response) {
          })
      };*/

      $scope.prepareChangeStatus = function() {
        $scope.data.viewChangePriv = true;
      }

      $scope.changePrivacy = function() {
        console.log($scope.data.fields[6].value);
        UserService.changePrivateAccount({ "objectId": window.localStorage.getItem('userSubscriptionInstanceId') }).save().$promise.then(function success(response) {
          if (window.localStorage.getItem('ownPrivate') === 'true') {
            window.localStorage.setItem('ownPrivate', false);
          } else {
            window.localStorage.setItem('ownPrivate', true);
          }
        }, function(error) {});
      }

      /*function addMembership() {
        UserService.changeMembershipWS({
          userId: UserService.get_USERSUBSCRIPTIONINSTANCE_ID(),
          membership: $scope.data.fields[5].value
        }).then(function (resp) {
          //console.log("resp", resp);
          UserService.set_USER_MEMBERSHIP($scope.data.fields[5].value);
          Utils.toast.success(Utils.translate("PROFILE.DIALOG.CHANGE_MEMBERSHIP_OK"))
        }, function (error) {
          console.error("Cant changeMembership", error);
          Utils.toast.error(Utils.translate("ERROR.UNKNOWN"))
        })
      }*/

      /*
      new code for process for updating info in cascade
      */
      $scope.beginChanges = function() {
        $scope.advice = false;
        $scope.countErrorsOnUpdate = 0;
        $scope.countChangesMade = 0;
        $scope.warningName = false;
        Utils.loading.show();
        checkForNameUpdated();
      }

      function checkForNameUpdated() {
        if ($scope.data.fields[0].isActive) {
          $scope.data.fields[0].isActive = false;
          $scope.data.fields[1].isActive = false;
          $scope.data.fields[2].isActive = false;
          var chkTxt = 0,
            chkTxtVal = 0;
          //check first that firstName/lastName isn't empty or blank
          if ($scope.data.fields[1].value == '' || $scope.data.fields[1].value == null || $scope.data.fields[1].value == undefined)
            chkTxtVal++;

          if ($scope.data.fields[2].value == '' || $scope.data.fields[2].value == null || $scope.data.fields[2].value == undefined)
            chkTxtVal++;

          if (chkTxtVal > 0) {
            $scope.warningName = true;
            checkFormMailUpdated();
          } else {
            //check second if in reality the user have changed any of the names
            if ($scope.data.fields[1].value == $scope.data.fields[1].backUp)
              chkTxt++;

            if ($scope.data.fields[2].value == $scope.data.fields[2].backUp)
              chkTxt++;

            if (chkTxt == 2)
              checkFormMailUpdated();
            else {
              //change backup data for real
              $scope.data.fields[0].value = $scope.data.fields[1].value + " " + $scope.data.fields[2].value;
              $scope.data.fields[0].backUp = $scope.data.fields[0].value;
              $scope.data.fields[1].backUp = $scope.data.fields[1].value;
              $scope.data.fields[2].backUp = $scope.data.fields[2].value;


              //with one change made at least we call the WS
              UserService.name({
                objectId: UserService.get_SIMPLEUSERINSTANCE_ID()
              }).post({
                "firstName": {
                  "value": $scope.data.fields[1].value
                },
                "middleName": {
                  "value": ""
                },
                "lastName": {
                  "value": $scope.data.fields[2].value
                },
                "lastName2": {
                  "value": ""
                }
              }).$promise.then(function(response) {
                window.localStorage.setItem('name', $scope.data.fields[0].backUp);
                window.localStorage.setItem('firstName', $scope.data.fields[1].value);
                window.localStorage.setItem('lastName', $scope.data.fields[2].value);
                $scope.countChangesMade++;
                //next step
                checkFormMailUpdated();
              }, function(error) {
                //show error toast
                //at the end with "Not all changes has been saved"
                //Utils.toast.error("Can't change your name");
                $scope.countErrorsOnUpdate++;
                checkFormMailUpdated();
              });
            }
          }
        } else {
          checkFormMailUpdated();
        }
      }

      function checkFormMailUpdated() {
        if ($scope.data.fields[3].isActive) {
          $scope.data.fields[3].isActive = false;
          var chkMail = false;
          //check first if mail isn't empty or blank
          if ($scope.data.fields[3].value == '' || $scope.data.fields[3].value == null || $scope.data.fields[3].value == undefined)
            checkForBioUpdated();
          else {
            //check if in reality the user have changed the mail
            if ($scope.data.fields[3].value == $scope.data.fields[3].backUp)
              checkForBioUpdated();
            else {
              //change backup data for real
              $scope.data.fields[3].backUp = $scope.data.fields[3].value;

              UserService.email({
                objectId: UserService.get_SIMPLEUSERINSTANCE_ID()
              }).post({
                email: {
                  value: $scope.data.fields[3].value
                }
              }).$promise.then(function success(response) {
                window.localStorage.setItem("userEmail", $scope.data.fields[3].value);
                $scope.countChangesMade++;
                //next step
                checkForBioUpdated();
              }, function(error) {
                //show error toast
                //at the end with "Not all changes has been saved"
                //Utils.toast.error("Can't change your name");
                $scope.countErrorsOnUpdate++;
                checkForBioUpdated();
              });
            }
          }
        } else {
          checkForBioUpdated();
        }
      }

      function checkForBioUpdated() {
        if ($scope.data.fields[4].isActive) {
          $scope.data.fields[4].isActive = false;
          var chkBio = false;
          //check first if Bio isn't empty or blank
          if ($scope.data.fields[4].value == '' || $scope.data.fields[4].value == null || $scope.data.fields[4].value == undefined)
            checkForMembershipUpdated();
          else {
            //check if in reality the user have changed the bio
            if ($scope.data.fields[4].value == $scope.data.fields[4].backUp)
              checkForMembershipUpdated();
            else {
              //change backup data for real
              $scope.data.fields[4].backUp = $scope.data.fields[4].value;



              UserService.editTextfromUserBiography({
                "objectId": window.localStorage.getItem("userSubscriptionInstanceId")
              }).save({
                "string": {
                  "value": $scope.data.fields[4].value
                }
              }, function success(data) {
                window.localStorage.setItem("userBiography", $scope.data.fields[4].value);
                $scope.countChangesMade++;
                //next step
                checkForMembershipUpdated();
              }, function(error) {
                //show error toast
                //at the end with "Not all changes has been saved"
                //Utils.toast.error("Can't change your name");
                $scope.countErrorsOnUpdate++;
                checkForMembershipUpdated();
              });
            }
          }
        } else {
          checkForMembershipUpdated();
          checkCity();
        }
      }

      function checkForMembershipUpdated() {
        if ($scope.data.fields[7].isActive) {
          $scope.data.fields[7].isActive = false;
          //check first if Bio isn't empty or blank
          if ($scope.data.fields[7].value == '' || $scope.data.fields[7].value == null || $scope.data.fields[7].value == undefined)
            checkForBirthdayUpdated();
          else {
            //check if in reality the user have changed the bio
            if ($scope.data.fields[7].value == $scope.data.fields[7].backUp)
              checkForBirthdayUpdated();
            else {
              //change backup data for real
              $scope.data.fields[7].backUp = $scope.data.fields[7].value;

              UserService.changeMembershipWS({
                userId: UserService.get_USERSUBSCRIPTIONINSTANCE_ID(),
                membership: $scope.data.fields[7].value
              }).then(function success(response) {
                //console.log("resp", resp);
                UserService.set_USER_MEMBERSHIP($scope.data.fields[7].value);
                $scope.countChangesMade++;
                //next step
                checkForBirthdayUpdated();
              }, function(error) {
                $scope.countErrorsOnUpdate++;
                checkForBirthdayUpdated();
                //console.error("Cant changeMembership", error);
                //Utils.toast.error(Utils.translate("ERROR.UNKNOWN"))
              })
            }
          }
        } else {
          checkForBirthdayUpdated();
        }
      }

      function checkForPrivacyUpdated() {
        if ($scope.data.viewChangePriv) {
          UserService.changePrivateAccount({ "objectId": window.localStorage.getItem('userSubscriptionInstanceId') }).save().$promise.then(function success(response) {
            $scope.data.viewChangePriv = false;
            if (window.localStorage.getItem('ownPrivate') === 'true') {
              window.localStorage.setItem('ownPrivate', false);
            } else {
              window.localStorage.setItem('ownPrivate', true);
            }
            $scope.countChangesMade++;
            //next step
            checkCity();
          }, function(error) {
            $scope.countErrorsOnUpdate++;
            checkCity();
          });
        } else {
          checkCity();
        }
      }
      //OmRo 200919 Select city
      $scope.selectCity = function(data) {
        console.log(data);
        $scope.data.fields[10].value = data.city;
      }

      function checkCity() {
        if ($scope.data.fields[10].isActive) {
          $scope.data.fields[10].isActive = false;
          var chkCity = false;

          //check first if City isn't empty or blank
          if ($scope.data.fields[10].value == '' || $scope.data.fields[10].value == null || $scope.data.fields[10].value == undefined)
            checkForBirthdayUpdated();
          else {
            //check if in reality the user have changed the bio
            if ($scope.data.fields[10].value == $scope.data.fields[10].backUp)
              checkForBirthdayUpdated();
            else {
              //change backup data for real
              $scope.data.fields[10].backUp = $scope.data.fields[10].value;

              UserService.city({
                objectId: UserService.get_SIMPLEUSERINSTANCE_ID()
              }).post({
                city: {
                  value: $scope.data.fields[10].value
                }
              }).$promise.then(function success(response) {
                window.localStorage.setItem("city", $scope.data.fields[10].value);
                $scope.countChangesMade++;
                //next step
                checkForBirthdayUpdated();
              }, function(error) {
                //show error toast
                //at the end with "Not all changes has been saved"
                //Utils.toast.error("Can't change your name");
                $scope.countErrorsOnUpdate++;
                checkForBirthdayUpdated();
              });
            }
          }
          //call WS
        } else {
          concludeUpdates();
        }
      }

      function checkForBirthdayUpdated() {
        if ($scope.data.fields[9].changed) {
          var fullYear = $scope.data.fields[9].value.getFullYear();
          var fullMonth = $scope.data.fields[9].value.getMonth() + 1;
          if (fullMonth < '10')
            fullMonth = '0' + fullMonth;
          var fullDay = $scope.data.fields[9].value.getDate();
          if (fullDay < '10')
            fullDay = '0' + fullDay;
          var realBirthday = fullYear + '-' + fullMonth + '-' + fullDay;
          UserService.updateBirthDay({
            objectId: UserService.get_SIMPLEUSERINSTANCE_ID()
          }).post({
            "birthDate": {
              "value": realBirthday
            }
          }).$promise.then(function(response) {
            window.localStorage.setItem('birthDate', realBirthday);
            $scope.data.fields[9].changed = false;
            $scope.countChangesMade++;
            concludeUpdates();
          }, function(error) {
            $scope.countErrorsOnUpdate++;
            $scope.data.fields[9].changed = false;
            concludeUpdates();
          })
        } else {
          concludeUpdates();
        }
      }

      $scope.getDate = function() {
        $scope.data.fields[9].changed = true;
      }

      function concludeUpdates() {
        //try to leave clear any name or lastname?
        Utils.loading.hide();
        if ($scope.warningName) {
          Utils.toast.error(Utils.translate("PROFILE.DIALOG.RENEMBER_NAMES"));
        }
        //any change attempt?
        if ($scope.countChangesMade > 0) {
          //any error made?
          if ($scope.countErrorsOnUpdate == 0) {
            Utils.toast.success(Utils.translate("PROFILE.DIALOG.SUCCESS_ALL_CHANGES_MYPROFILE"));
          } else {
            if ($scope.countErrorsOnUpdate < 4) {
              Utils.toast.error(Utils.translate("PROFILE.DIALOG.ERRORS_IN_CHANGES_MYPROFILE"));
            } else {
              Utils.toast.error(Utils.translate("PROFILE.DIALOG.FULL_ERROR_IN_CHANGES_MYPROFILE"));
            }

          }
        } else {
          return true;
        }

      }

      $scope.prepareQR = function() {
        //to make sure to get id when scanning the QRCode
        //we add more text for check
        var textID = Personalized.nameApp + "_Assist_List_"; //BALA QRCODE FIX
        var qrcode = new QRCode(document.getElementById("qrcode"), {
          text: textID + UserService.get_USERSUBSCRIPTION_ID() + '_' + UserService.get_USERSUBSCRIPTIONINSTANCE_ID(),
          width: 150,
          height: 150,
          colorDark: "#2d2d2d",
          colorLight: "#ffffff",
          correctLevel: QRCode.CorrectLevel.H
        })
      }


      $scope.$on('$ionicView.beforeEnter', function() {
        console.log("enter tab basic data: ", $scope.showPrivateOptions);
        Utils.$timeout(function() {
          $scope.prepareQR();
        }, 400);
      })

      $scope.$on('gettingOut-basicData', function() {
        console.log("exit tab basic data: ", $scope.showPrivateOptions);
        var qrcode = document.getElementById("qrcode");
        while (qrcode.firstChild) {
          qrcode.removeChild(qrcode.firstChild);
        }
      })
    }
  ])

  .controller('configureMetadataCtrl', ['$scope', '$state', 'UserService', 'Utils', 'UserServiceFb', '$rootScope',
    function($scope, $state, UserService, Utils, UserServiceFb, $rootScope) {

      /*DATA DECLARATION*/
      var myUserSubsId = UserService.get_USERSUBSCRIPTION_ID();
      $scope.data = {};

      $scope.obtainData = function() {
        //call to the WS needed
        UserService.getAllMetaDataWithUserSubscriptionId({
          userSubscriptionId: myUserSubsId
        }).$promise.then(
          function(response) {
            console.log("got: ", response);
          },
          function(err) {
            console.log("error: ", err);
          })
        /*
        UserService.findUsersBirthDate({
            objectId: window.localStorage.getItem('simpleUserId')
          }).$promise.then
        */
      }
      $scope.obtainData();

      $scope.$on('$ionicView.beforeEnter', function() {
        console.log("enter tab meta data: ", myUserSubsId);
        Utils.$timeout(function() {

        }, 400);
      })

  }])

  .controller('showUserLockerCtrl', ['$rootScope', '$scope', '$state', 'UserService', 'SequenceService', 'SequenceFactory', 'GroupFactory', '$ionicActionSheet', 'promosService', 'userLockerService', 'cqnzService', 'Utils',
    function($rootScope, $scope, $state, UserService, SequenceService, SequenceFactory, GroupFactory, $ionicActionSheet, promosService, userLockerService, cqnzService, Utils) {
      $scope._controllerName = 'showUserLockerCtrl';

      $scope.isLoadingContent = false;
      $scope.isRefreshing = false;
      $scope.canGetMoreItems = true;
      $scope.errorLoading = false;
      $scope.firstTime = true;

      var pagination = {
        start: 0,
        count: 6,
        reset: function() {
          this.start = 0;
          this.count = 6;
        },
        increaseCount: function(step) {
          this.count += step || 1
        }
      };

      $scope.isIOS = ionic.Platform.isIOS();
      $scope.isAndroid = ionic.Platform.isAndroid();
      $scope.listenInc = 0;

      $scope.PROMO_MEDIA_TYPES = userLockerService.PROMO_MEDIA_TYPES; //also used in the UI
      $scope.LOCKER_TYPES = userLockerService.LOCKER_TYPES; //used in the UI

      $scope.lockerItemList = [];

      $scope.loadLocker = function() {
        $scope.isLoadingContent = true;

        userLockerService.getlockerOfUser({
          id: UserService.get_USERSUBSCRIPTION_ID(),
          start: pagination.start,
          count: pagination.count
        }).$promise.then( /**@param lockerList {Array<Locker>}*/ function(lockerList) {
          Utils.removeLastItemIfHasNoAttribute(lockerList, "lockerId");
          //console.log("promotionBasicList", lockerList);

          var totalRetrieved = lockerList.length;

          $scope.canGetMoreItems = totalRetrieved >= pagination.count;
          $scope.firstTime = false;

          if (!totalRetrieved) {
            $scope.isRefreshing = false;
            $scope.isLoadingContent = false;
            $scope.$broadcast('scroll.refreshComplete');
            $scope.$broadcast('scroll.infiniteScrollComplete');
            return
          }

          var promises = [];

          lockerList.forEach( /**@param lockerData {Locker}*/ function(lockerData) {
            if (!lockerData.promotion && !lockerData.sequence) return; //continues in this context

            switch (lockerData.lockerType) {
              case 1: //sequence
                promises.push(setLockerTypeSequence(lockerData));
                break;
              case 2: //promotion
                promises.push(setLockerTypePromotion(lockerData));
                break;
              default:
                console.error("unknown locker type", lockerData)
            }
          });

          Utils.$q.all(promises).then(function(responses) {
            pagination.start += totalRetrieved;
            pagination.increaseCount();
          }, function(errors) {
            $scope.canGetMoreItems = false;
          }).finally(function() {
            $scope.isLoadingContent = false;
            $scope.isRefreshing = false;
            $scope.$broadcast('scroll.refreshComplete');
            $scope.$broadcast('scroll.infiniteScrollComplete');
          });
        }, function(gralDataError) {
          console.log("getlockerOfUser", gralDataError);
          $scope.isRefreshing = false;
          $scope.isLoadingContent = false;
          $scope.canGetMoreItems = false;
          $scope.errorLoading = true;
          $scope.$broadcast('scroll.refreshComplete');
          $scope.$broadcast('scroll.infiniteScrollComplete');
        })
      };
      $scope.loadLocker();

      /**
       * @param lockerData {Locker}
       * @return {Promise<boolean>}
       */
      function setLockerTypeSequence(lockerData) {
        //console.log("setLockerTypeSequence lockerData", lockerData);
        return filterSequences(lockerData);
      }

      /**
       * @param lockerData
       * @return {Promise<boolean>}
       */
      function filterSequences(lockerData) {
        var deferred = Utils.$q.defer();

        //get the groupID list
        GroupFactory.findSequenceGroups(
          lockerData.sequence.title.replace(/,/g, ''),
          UserService.get_USER_INSTANCE_HREF()
        ).$promise.then(function(groupsList) {
          Utils.removeLastItemIfHasNoAttribute(groupsList, 'groupId');
          console.log("groupsList", groupsList);

          var groupsIdsList = groupsList.map(function(group) {
            return group.groupId;
          });

          //console.log("sequencesListAndGroups", {sequenceId: +lockerData.sequence.title, groupsIdsList: groupsIdsList});

          if (groupsIdsList.length)
            deferred.resolve(
              complementLockerCqnzData({
                sequenceId: +lockerData.sequence.title.replace(/,/g, ''),
                groupsIdsList: groupsIdsList
              }, lockerData)
            );
          else
            deferred.resolve()

        }, function(error) {
          deferred.reject(error)
        });
        return deferred.promise;
      }

      /**
       * @param sequenceIdAndGroups
       * @param lockerData {Locker}
       * @return {Promise<boolean>}
       */
      function complementLockerCqnzData(sequenceIdAndGroups, lockerData) {
        var deferred = Utils.$q.defer();

        var cqnzId = lockerData.sequence.title.replace(/,/g, '');
        var data = SequenceService.findSequenceBySequenceIdV181(cqnzId).$promise;

        //count the num of comments available in each of my groups
        var commentsCountPromises = {};
        sequenceIdAndGroups.groupsIdsList.forEach(function(groupId) {
          console.log("Counting comments for (" + cqnzId + ", " + groupId + ")");
          commentsCountPromises[groupId] = cqnzService.countSequenceCommentsByGroupWS({
            sequenceId: cqnzId,
            groupId: groupId
          }).$promise;
        });

        var listTags = SequenceService.obtainTagwithIdandTypev166({
          sequenceId: cqnzId,
          notificationType: 7
        });
        //LuMa HashTags in sequence
        //var hashesList = SequenceService.getHashFromSequence(cqnzId);
        var hashesList = SequenceService.findSequenceHashTagComment({
          sequenceId: cqnzId,
          notificationType: 7,
          commentId: 0
        });

        Utils.$q.all({
          basicData: data,
          commentsCounts: Utils.$q.all(commentsCountPromises),
          tagsList: listTags,
          hashesList: hashesList
        }).then(function(userCqnz) {
          Utils.removeLastItemIfHasNoAttribute(userCqnz.basicData, 'sequence');
          userCqnz.basicData = userCqnz.basicData[0];

          userCqnz.sequenceOwnerId = Utils.getLastUrlComponent(userCqnz.basicData.userSubscriptionId.href);
          userCqnz.sequenceItems = cqnzService.getItemsToSequenceV165WS(cqnzId);
          userCqnz.likeActive = SequenceService.findSmileysCount({
            sequenceId: Utils.getLastUrlComponent(userCqnz.basicData.sequence.href),
            userId: UserService.get_USERSUBSCRIPTIONINSTANCE_ID()
          });
          userCqnz.followEachOther = UserService.get_USERSUBSCRIPTIONINSTANCE_ID() == userCqnz.sequenceOwnerId ? { result: { value: true } } : SequenceService.followEachOther({
            userId: UserService.get_USERSUBSCRIPTIONINSTANCE_ID(),
            friendId: userCqnz.sequenceOwnerId
          });
          userCqnz.viewsCounter = userCqnz.basicData.isAdvertisement && userCqnz.sequenceOwnerId == UserService.get_USERSUBSCRIPTIONINSTANCE_ID() ? adsService.getViewsCount(cqnzId) : null;
          userCqnz.clicksCounter = userCqnz.basicData.isAdvertisement && userCqnz.sequenceOwnerId == UserService.get_USERSUBSCRIPTIONINSTANCE_ID() ? adsService.getClicksCount(cqnzId) : null;
          userCqnz.URLClicksCounter = userCqnz.basicData.isAdvertisement && userCqnz.sequenceOwnerId == UserService.get_USERSUBSCRIPTIONINSTANCE_ID() ? adsService.getURLClicksCount(cqnzId) : null;

          userCqnz.basicData.sequenceCommentCount = 0;

          var totalComments = 0;
          var commentsPromises = {};
          Object.keys(userCqnz.commentsCounts).forEach(function(groupId) {
            var numOfComments = userCqnz.commentsCounts[groupId].result.value;
            totalComments += numOfComments;

            //console.log("Total comments in group " + groupId + " = "+ totalComments);

            if (numOfComments) {
              //console.log("getting comments of (" + cqnzId + ", " + groupId + ")");
              commentsPromises[groupId] = cqnzService.getCommentsOfSequenceWS({
                sequenceId: cqnzId,
                start: 0,
                count: 2,
                groupId: groupId
              }).$promise
            }
          });
          userCqnz.basicData.sequenceCommentCount = totalComments;

          userCqnz.comments = [];
          Utils.$q.all(commentsPromises).then(function(resolvedComments) {
            Object.keys(resolvedComments).forEach(function(groupId) {
              Utils.removeLastItemIfHasNoAttribute(resolvedComments[groupId], 'commentId');
              if (resolvedComments[groupId].length) {
                resolvedComments[groupId].groupId = groupId;
                userCqnz.comments = userCqnz.comments.concat(resolvedComments[groupId]);
              }
            });
            //console.log('hashCqnz.comments', hashCqnz.comments);

            var groupIdSend = sequenceIdAndGroups.groupsIdsList[0];
            userCqnz.basicData.groupId = groupIdSend;

            var cqnz = SequenceFactory.buildSequenceObject(userCqnz);
            cqnz.allowedGroups = sequenceIdAndGroups.groupsIdsList;
            cqnz.locker = {
              lockerId: lockerData.lockerId,
              sequence: lockerData.sequence,
              sequenceLocker: lockerData.sequenceLocker
            };

            $scope.lockerItemList.push({
              type: lockerData.lockerType,
              data: cqnz
            });

            deferred.resolve(true);
          }, function(errors) {
            console.error("$q.all(commentsPromises)", errors);
            var cqnz = SequenceFactory.buildSequenceObject(userCqnz);
            cqnz.locker = {
              lockerId: lockerData.lockerId,
              sequence: lockerData.sequence,
              sequenceLocker: lockerData.sequenceLocker
            };

            $scope.lockerItemList.push({
              type: lockerData.lockerType,
              data: cqnz
            });

            deferred.resolve(true);
          });
        }, function(errors) {
          console.error("complementUserCqnzData", errors);
          deferred.reject(errors);
        }); //end $q.all(data, comments, listTags, hashesList)
        return deferred.promise;
      }

      /**
       * @param lockerData {Locker}
       * @return {Promise<boolean>}
       */
      function setLockerTypePromotion(lockerData) {
        //console.log("setLockerTypePromotion lockerData", lockerData);
        var deferred = Utils.$q.defer();
        promosService.getPromotionByPromotionId(
          lockerData.promotion.title.replace(/,/g, '')
        ).$promise.then( /**@param promoBasicData {[PromoBasicData]}*/ function(promoBasicData) {
          Utils.removeLastItemIfHasNoAttribute(promoBasicData, 'promotionId');
          //console.log("getPromotionByPromotionId", promoBasicData);

          if (!promoBasicData.length) {
            console.warn("No getPromotionByPromotionId found");
            return
          }

          promosService.getPromotionItemByPromotionId({
            promoId: +promoBasicData[0].promotionId,
            //omit the pagination params :)
          }).$promise.then(
            /**@param mediaItems {[{creationDate:string, promotion:{href:string}, url: string}]}*/
            function(mediaItems) {
              Utils.removeLastItemIfHasNoAttribute(mediaItems, 'promotion');
              //console.log("getPromotionItemByPromotionId", mediaItems);

              var promoData = {
                id: promoBasicData[0].promotionId,
                lockerId: lockerData.lockerId,
                promotion: lockerData.promotion,
                sequenceLocker: lockerData.sequenceLocker,
                href: promoBasicData[0].promotion.href,
                type: promoBasicData[0].promotionType,
                date: promoBasicData[0].date,
                description: promoBasicData[0].description,
                mediaType: -1, //<- unknown
                items: [],
              };

              //we know that media is: SINGLE_IMAGE
              if (mediaItems.length === 1) {
                promoData.mediaType = $scope.PROMO_MEDIA_TYPES.SINGLE_IMAGE;
                promoData.items = [{ src: mediaItems[0].url }]
              } else if (mediaItems.length === 2) { //but here media is either: IMAGE_GALLERY or VIDEO
                var
                  id0 = mediaItems[0].url.indexOf(".mp4") > -1,
                  id1 = mediaItems[1].url.indexOf(".mp4") > -1;

                if (id0 || id1) { //now we know that media is: VIDEO
                  promoData.mediaType = $scope.PROMO_MEDIA_TYPES.VIDEO;
                  promoData.items = [{ src: mediaItems[id0 ? 0 : 1].url, thumb: mediaItems[id0 ? 1 : 0].url }]
                } else { //now we know that media is: IMAGE_GALLERY
                  promoData.mediaType = $scope.PROMO_MEDIA_TYPES.IMAGE_GALLERY;
                  mediaItems.some(function(media) {
                    promoData.items.push({ src: media.url })
                  })
                }
              } else if (mediaItems.length > 2) { //we know that media is: IMAGE_GALLERY
                promoData.mediaType = $scope.PROMO_MEDIA_TYPES.IMAGE_GALLERY;
                mediaItems.some(function(media) {
                  promoData.items.push({ src: media.url })
                })
              } else { //WE NEED TO CONSIDER ALL CASES
                Utils.toast.warning("Promotion conains an invalid number of items", 5000);
              }

              $scope.lockerItemList.push({ type: lockerData.lockerType, data: promoData });

              deferred.resolve(true);
            },
            function(error) {
              deferred.reject(error);
              console.error("getPromotionItemByPromotionId", error);
              Utils.alert.show("We couldn't get the promotion items")
            });
        }, function(error) {
          deferred.reject(error);
          console.error("getPromotionByPromotionId", error)
        });

        return deferred.promise;
      }

      $scope.canShow3DotsLockerPromoMenu = function() {
        return true
      };

      $scope.open3DotsLockerPromoMenu = function(idx) {
        var buttons = [];
        var buttonsIds = [];
        console.log("Remove promo %d from locker", idx);

        buttons.push({ text: Utils.translate('SEQUENCE.REMOVE_FROM_LOCKER') + ' <i class="icon ion-ios-undo assertive"></i>' });
        buttonsIds.push('REMOVE_FROM_LOCKER');

        Utils.$ionicActionSheet.show({
          buttons: buttons,
          titleText: Utils.translate('SEQUENCE.OPTIONS'),
          buttonClicked: function(buttonIndex) {
            switch (buttonsIds[buttonIndex]) {
              case 'REMOVE_FROM_LOCKER':
                Utils.confirm.show(Utils.translate('LOCKER.DIALOG.REMOVE_ITEM_CONFIRM')).then(function(confirmed) {
                  if (!confirmed) return;
                  removePromoFromLocker(idx);
                });
                break;
              default:
                Utils.toast.warning("Invalid option '" + buttonsIds[buttonIndex] + "'");
            }
            return true;
          }
        })
      };

      function removePromoFromLocker(idx) {
        Utils.loading.show();
        userLockerService.removeItemFromLocker(
          Utils.getLastUrlComponent($scope.lockerItemList[idx].data.sequenceLocker.href)
        ).$promise.then(function() {
          $scope.lockerItemList.splice(idx, 1);
          Utils.$timeout(function() {
            Utils.$ionicScrollDelegate.resize();
          }, 300);
          Utils.toast.success(Utils.translate("LOCKER.DIALOG.REMOVE_ITEM_OK"))
        }, function(error) {
          console.error("removePromoFromLocker", error);
          Utils.toast.error(Utils.translate("LOCKER.DIALOG.REMOVE_ITEM_ERROR"))
        }).finally(function() {
          Utils.loading.hide();
        })
      }

      //____ZONE FOR REFRESH FUNCTION
      $scope.refreshLockerTL = function() {
        $scope.lockerItemList = [];

        $scope.isLoadingContent = false;
        $scope.canGetMoreItems = true;
        $scope.errorLoading = false;
        $scope.isRefreshing = true;
        $scope.firstTime = true;
        pagination.reset();

        setTimeout(function() {
          Utils.$ionicScrollDelegate.resize();
          $scope.loadLocker();
        }, 800);
      };
      //END ZONE FOR REFRESH FUNCTION

      $scope.promotionPlayVideo = function(promotion) {
        var videoElement = document.getElementById('PromotionVideoArea' + promotion.id);
        videoElement.play();
        videoElement.controls = true;
        videoElement.addEventListener('ended', onVideoFinished, false);
        if ($scope.isIOS) {
          videoElement.addEventListener('pause', onVideoFinished, false);
        }

        $scope.isPlayingVideo = true;
        Utils.$timeout(function() {
          $scope.$apply()
        })
      };

      function onVideoFinished(e) {
        e.target.controls = false;
        $scope.isPlayingVideo = false;
        Utils.$timeout(function() {
          $scope.$apply()
        })
      }


      $scope.selectedChatImage = '';
      $scope.activeSlide = 0;
      $scope.showImageViewer = function(imageSrc) {
        $scope.selectedChatImage = imageSrc;
        Utils.$ionicModal.fromTemplateUrl('templates/Chat/image-viewer.html', {
          scope: $scope,
          animation: 'zoom-from-center'
        }).then(function(modal) {
          $scope.imageViewer = modal;
          $scope.imageViewer.show();
        });
      };

      $scope.closeImageViewer = function() {
        $scope.selectedChatImage = '';
        $scope.imageViewer.hide();
        $scope.imageViewer.remove();
      };

      $scope.zoomStatus = 0;
      $scope.zoomMin = 1;
      $scope.doubleTapped = function(slide) {
        if ($scope.zoomStatus === 0) {
          Utils.$ionicScrollDelegate.$getByHandle('scrollHandle' + slide).zoomBy(2, true);
          $scope.zoomStatus++;
        } else {
          Utils.$ionicScrollDelegate.$getByHandle('scrollHandle' + slide).zoomBy(0, true);
          $scope.zoomStatus--;
        }
      };

      $scope.updateSlideStatus = function(slide) {
        var zoomFactor = Utils.$ionicScrollDelegate.$getByHandle('scrollHandle' + slide).getScrollPosition().zoom;
        if (zoomFactor === $scope.zoomMin) {
          Utils.$ionicSlideBoxDelegate.enableSlide(true);
        } else {
          Utils.$ionicSlideBoxDelegate.enableSlide(false);
        }
      };

      $scope.goBack = function() {
        $state.go("menu.myProfile")
      }
    }
  ])

  .controller('scheduledPostCtrl', ['$rootScope', '$scope', '$state', 'UserService', 'SequenceService', 'SequenceFactory', 'GroupFactory', '$ionicActionSheet', 'promosService', 'userScheduledService', 'cqnzService', 'Utils', 'permissionValidationService',
    function($rootScope, $scope, $state, UserService, SequenceService, SequenceFactory, GroupFactory, $ionicActionSheet, promosService, userScheduledService, cqnzService, Utils, permissionValidationService) {

      var myUserId = UserService.get_USERSUBSCRIPTIONINSTANCE_ID();
      var permissions = permissionValidationService;
      $scope._controllerName = 'scheduledPostCtrl';
      $scope.isLoadingContent = false;
      $scope.isRefreshing = false;
      $scope.canGetMoreItems = true;
      $scope.errorLoading = false;
      $scope.firstTime = true;
    }
  ])

  .controller('historyToken', ['$scope', '$state', 'UserService', 'Utils', 'UserServiceFb', '$rootScope', 'Tokens',
    function($scope, $state, UserService, Utils, UserServiceFb, $rootScope, Tokens) {

      $scope.data = {};
      $scope.data.normalfin = Tokens.normalfin;
      $scope.data.normalinit = Tokens.normalinit;
      $scope.data.broncefin = Tokens.broncefin;
      $scope.data.platafin = Tokens.platafin;
      $scope.data.orofin = Tokens.orofin;
      $scope.userSubscriptionId = UserService.get_USERSUBSCRIPTION_ID();
      var pagination = {
        start: 0,
        count: 8,
        reset: function() {
          this.start = 0;
          this.count = 8;
        },
        increaseCount: function(step) {
          this.count += step || 5
        }
      };
      $scope.isLoadingContent = false;
      $scope.isRefreshing = false;
      $scope.canGetMoreItems = true;
      $scope.userTokenList = [];

      /////////////////////////////////////////////////////////////////////////
      UserService.findUserSubscriptionById().get({
        "userSubscriptionId": '"' + $scope.userSubscriptionId + '"'
      }, function(response) {
        $scope.data.token = response[0].tokensCount;
        $scope.data.tokenHist = response[0].tokensHist;
      }, function(error) {
        console.log("findUserSubscriptionById error", error);

      });
      //////////////////////////////////////////////////////////////////////77    

      $scope.tokenHistory = function(data) {
        var datatosent = {
          userSubscriptionId: $scope.userSubscriptionId,
          start: pagination.start,
          count: pagination.count
        }
        UserService.historyToken({
          userSubscriptionId: datatosent.userSubscriptionId,
          start: datatosent.start,
          count: datatosent.count

        }).$promise.then(function tokenok(success) {
          if (success.length > 0) {
            $scope.start += success.length;
            $scope.userTokenList.push.apply($scope.userTokenList, success);
            Utils.removeLastItemIfHasNoAttribute($scope.userTokenList, success, 'token');
            var totalRetrieved = $scope.userTokenList.length;
            $scope.canGetMoreItems = totalRetrieved >= pagination.count;

          }
          if (!totalRetrieved) {
            onLoadingEnd();
            return;
          }
          //$scope.$broadcast('scroll.infiniteScrollComplete');
          console.log(success)
          pagination.start = totalRetrieved;
          pagination.increaseCount();
          onLoadingEnd();
        }, function failtoken(error) {
          console.log(error);
          onLoadingEnd();
        })
      }
      $scope.tokenHistory();

      function onLoadingEnd() {
        $scope.isRefreshing = false;
        $scope.isLoadingContent = false;
        $scope.$broadcast('scroll.refreshComplete');
        $scope.$broadcast('scroll.infiniteScrollComplete');
      }
    }
  ])

  .controller('changeProfilePhotoCtrl', ['$scope', '$state', '$timeout', '$ionicActionSheet', 'ImageService2', 'FileService2', '$rootScope', '$jrCrop', '$interval', 'changeProfilePictureService', '$ionicPush', 'ionicService', 'reDirectService', '$filter', 's3', 'md5', 'Utils', 'AWSServices', 'GroupsService', 'UserService', '$ionicHistory',
    function($scope, $state, $timeout, $ionicActionSheet, ImageService2, FileService2, $rootScope, $jrCrop, $interval, changeProfilePictureService, $ionicPush, ionicService, reDirectService, $filter, s3, md5, Utils, AWSServices, GroupsService, UserService, $ionicHistory) {
      $scope.newProfileImage = [];
      $scope.newBackImage = [];
      var isIOS = ionic.Platform.isIOS();
      $scope.pictureProfile = window.localStorage.getItem("photoProfileBlob") !== null ? window.localStorage.getItem("photoProfileBlob") + '?decache=' + Math.random() : "img/ProfilePhoto.svg";
      $scope.oldPhoto = window.localStorage.getItem("photoProfileBlob") !== null ? window.localStorage.getItem("photoProfileBlob") + '?decache=' + Math.random() : "img/ProfilePhoto.svg";
      FileService2.cleanImages();
      $scope.newProfileImage = FileService2.images();

      $scope.checkBefore = function (type) {
        if(isIOS === true) {
          $scope.addMedia();
        } else {
          getMultiplePermissions(type);
        }
      };

      function getMultiplePermissions(type) {
        cordova.plugins.diagnostic.getPermissionsAuthorizationStatus(function(statuses) {
          var havePerm = 0;
          var deniedPerm = false;
          for (var permission in statuses){
            switch(statuses[permission]){
              case cordova.plugins.diagnostic.permissionStatus.GRANTED:
                console.log("Permission granted to use "+permission);
                havePerm++;
                break;
              case cordova.plugins.diagnostic.permissionStatus.NOT_REQUESTED:
                console.log("Permission to use "+permission+" has not been requested yet");
                havePerm--;
                break;
              case cordova.plugins.diagnostic.permissionStatus.DENIED:
                console.log("Permission denied to use "+permission+" - ask again?");
                havePerm--;
                break;
              case cordova.plugins.diagnostic.permissionStatus.DENIED_ALWAYS:
                console.log("Permission permanently denied to use "+permission+" - guess we won't be using it then!");
                deniedPerm = true;
                break;
            }
          }
          if(!deniedPerm){
            if(havePerm == 2){
              //have both permissions granted
              $scope.addMedia();
            } else if(havePerm <2){
              //both or one permission hasn't granted
              askMultiplePermissions(type);
            }
          } else {
            Utils.toast.error(Utils.translate('PLUGINS.PERMISSIONS.DENIED_PERMISSION') +
              Utils.translate('PLUGINS.PERMISSIONS.TYPE.CAMERA') + ' ' +
              Utils.translate('PLUGINS.PERMISSIONS.AND') + ' ' +
              Utils.translate('PLUGINS.PERMISSIONS.TYPE.GALLERY') + '. \n' +
              Utils.translate('PLUGINS.PERMISSIONS.ALWAYS_DENIED_PERMISSION'));
          }
        }, function(error){
          console.error("The following error occurred: "+error);
        }, [
          cordova.plugins.diagnostic.permission.CAMERA,
          cordova.plugins.diagnostic.permission.READ_EXTERNAL_STORAGE
        ])
      }

      function askMultiplePermissions(type) {
        cordova.plugins.diagnostic.requestRuntimePermissions(function(statuses) {
          var havePerm = 0;
          var deniedPerm = false;
          for (var permission in statuses){
            switch(statuses[permission]){
              case cordova.plugins.diagnostic.permissionStatus.GRANTED:
                console.log("Permission granted to use "+permission);
                havePerm++;
                break;
              case cordova.plugins.diagnostic.permissionStatus.NOT_REQUESTED:
                console.log("Permission to use "+permission+" has not been requested yet");
                havePerm--;
                break;
              case cordova.plugins.diagnostic.permissionStatus.DENIED:
                console.log("Permission denied to use "+permission+" - ask again?");
                havePerm--;
                break;
              case cordova.plugins.diagnostic.permissionStatus.DENIED_ALWAYS:
                console.log("Permission permanently denied to use "+permission+" - guess we won't be using it then!");
                deniedPerm = true;
                break;
            }
          }
          if(!deniedPerm){
            if(havePerm == 2){
              //have both permissions granted
              $scope.addMedia();
            } else if(havePerm <2){
              //both or one permission hasn't granted
              Utils.toast.error(Utils.translate('PLUGINS.PERMISSIONS.DENIED_PERMISSION') +
              Utils.translate('PLUGINS.PERMISSIONS.TYPE.CAMERA') + ' ' +
              Utils.translate('PLUGINS.PERMISSIONS.AND') + ' ' +
              Utils.translate('PLUGINS.PERMISSIONS.TYPE.GALLERY') + '.');
            }
          } else {
            Utils.toast.error(Utils.translate('PLUGINS.PERMISSIONS.DENIED_PERMISSION') +
              Utils.translate('PLUGINS.PERMISSIONS.TYPE.CAMERA') + ' ' +
              Utils.translate('PLUGINS.PERMISSIONS.AND') + ' ' +
              Utils.translate('PLUGINS.PERMISSIONS.TYPE.GALLERY') + '. \n' +
              Utils.translate('PLUGINS.PERMISSIONS.ALWAYS_DENIED_PERMISSION'));
          }
        }, function(error){
          console.error("The following error occurred: "+error);
        }, [
          cordova.plugins.diagnostic.permission.CAMERA,
          cordova.plugins.diagnostic.permission.READ_EXTERNAL_STORAGE
        ])
      }

      $scope.uploadingPhoto = false;
      $scope.openCrop = false;
      $scope.addMedia = function () {
        $scope.hideSheet = $ionicActionSheet.show({
          buttons: [
            {text: 'Take photo'},
            {text: 'Photo from library'}
          ],
          titleText: 'Add images',
          cancelText: 'Cancel',
          buttonClicked: function (index) {
            $scope.addImage(index);
          }
        });
      };

      $scope.addImage = function (type) {
        $scope.hideSheet(); //USING NEW PLUGIN MediaPicker
        $scope.newProfileImage = [];
        if(type === 0) { // camera
          ImageService2.saveCameraMediaProfilePhoto(type).then(function () {
          });
        } else { // library
          ImageService2.saveAlbumMediaProfilePhoto(type).then(function () {
          });
        }
      };

      $rootScope.$on("addedImageB", function () { // LISTENER FOR IMAGE LOADED
        showImageUser();
      });

      function showImageUser() {
        console.log("CALLED FUNCTION");
        if($scope.openCrop) {
          return true;
        }
        $scope.openCrop = true;
        var img = FileService2.images();
        var exifTemp = FileService2.exifImage();
        if(img.length === 0) { //ask again in 1 sec
          $timeout(function () {
            showImageUser();
          }, 1000);
        } else {
          if($scope.newProfileImage === null || $scope.newProfileImage === undefined || $scope.newProfileImage.length === 0) {
            var opt = {};
            if(isIOS === true) {
              //prepare IOS
              opt = {
                url: img[0],
                width: 200,
                height: 200,
                circle: true,
                allowRotation: true,
                title: 'Usa tus dedos para ajustar la imagen'
              }
              $jrCrop.crop(opt).then(function(canvas) {
                // success!
                console.log("INIT CUT IOS");
                $scope.newProfileImage[0] = canvas.toDataURL();
                $timeout(function() {
                  $scope.openCrop = false;
                  $scope.changeProfilePicture();
                  $scope.$apply();
                }, 0);
              }, function(err) {
                console.error(err);
                $scope.newProfileImage[0] = $scope.oldPhoto;
                $scope.openCrop = false;
                FileService2.cleanImages;
                $ionicHistory.nextViewOptions({disableBack: true});
                $state.go('menu.myProfile', {}, {reload: false});
              });
            } else {
              var urlToUse = null;
              //urlToUse = img[0].src;
              if(img[0].src) {
                urlToUse = img[0].src;
              } else {
                urlToUse = img[0];
              }
              opt = {
                url: urlToUse,
                width: 150,
                height: 150,
                circle: true,
                allowRotation: true,
                title: 'Usa tus dedos para ajustar la imagen'
              }
              $jrCrop.crop(opt).then(function(canvas) {
                console.log("INIT CUT ANDROID");
                $scope.newProfileImage[0] = canvas.toDataURL();
                $timeout(function() {
                  $scope.openCrop = false;
                  $scope.changeProfilePicture();
                  $scope.$apply();
                }, 0);
              }, function(err) {
                console.error(err);
                $scope.newProfileImage[0] = $scope.oldPhoto;
                $scope.openCrop = false;
                FileService2.cleanImages;
                $ionicHistory.nextViewOptions({disableBack: true});
                $state.go('menu.myProfile', {}, {reload: false});
              });
            }
          } else {
            $scope.openCrop = false;
            console.log("finish loading");
          }
        }
      }

      $scope.changeProfilePicture = function () {
        console.log("CALLED FUNCTION UPDATE");
        $scope.uploadingPhoto = true;
        var pictureName = window.localStorage.getItem("userSubscriptionInstanceId") + window.localStorage.getItem("userName");
        window.localStorage.setItem("photoProfileBlob", "nothing");
        $scope.pictureProfile = "nothing";
        //Steps to upload
        var s3Service = new AWS.S3({
          apiVersion: '2006-03-01',
          params: {Bucket: s3.bucket}
        });
        //encrypt subscriptioninstanceID and folder name
        var userSubscriptionInstanceId = md5.createHash(UserService.get_USERSUBSCRIPTIONINSTANCE_ID().toString());
        var folder = md5.createHash("profilePicture");

        //Create random number for image index
        var indexRandom = Math.floor(Math.random() * 1000);
        //create key for each picture
        var photoSmallKey = s3.prefix + '/' + userSubscriptionInstanceId + '/' + folder + '/' + 'small' + indexRandom + '.jpg';

        //photo to blob
        var fileSmall = Utils.dataURLtoBlob($scope.newProfileImage[0]);

        // begin process to upload
        s3Service.upload({
          Key: photoSmallKey,
          Body: fileSmall,
          ACL: 'public-read',
          ContentType: fileSmall.type
        }, function (err, data) {
          if (err) {
            return console.log('There was an error uploading the main jpg:'); // cancel all
          }
          if (data) {
            console.log('Successfully uploaded main image.');
            // call the WS
            changeProfilePictureService.changeProfPictv181(
              {"userSubscriptionId": window.localStorage.getItem("userSubscriptionInstanceId")}
            ).save({
              "profilePictureSmallUrl":
                {
                  "value": "http://s3-us-west-2.amazonaws.com/" + s3.bucket + "/" + photoSmallKey
                },
              "profilePictureMedUrl":
                {
                  "value": "http://s3-us-west-2.amazonaws.com/" + s3.bucket + "/" + photoSmallKey
                },
              "profilePictureLargeUrl":
                {
                  "value": "http://s3-us-west-2.amazonaws.com/" + s3.bucket + "/" + photoSmallKey
                }
            }, function success() {
              console.log("all good");
              //sendNotifToFollowers();
            }, function (response) {
              if (response && (response.status === 504 || response.status === -1)) {
                console.log("We don't care");
                //sendNotifToFollowers();
              } else {
                console.log("changeProfilePicture error");
              }
            });
            // redirect
            $timeout(function () {
              $rootScope.$broadcast("photo.upload");
              $scope.uploadingPhoto = false;
              window.localStorage.setItem("photoProfileBlob", "http://s3-us-west-2.amazonaws.com/" + s3.bucket + "/" + photoSmallKey + '?decache=' + Math.random());
              $scope.pictureProfile = "http://s3-us-west-2.amazonaws.com/" + s3.bucket + "/" + photoSmallKey;
              FileService2.cleanImages;
              $ionicHistory.nextViewOptions({disableBack: true});
              $state.go('menu.myProfile', {}, {reload: false});
              //window.history.back();
            }, 1000);
          }
        })
      };

      function sendNotifToFollowers() {
        var wsData = {
          groupId: 0,
          userSubscriptionId: UserService.get_USERSUBSCRIPTION_ID(),
          notification: 15 //AGREGAR TIPO DE NOTIF 15
        };
        //SE OCUPA WS QUE MANDA TIPO DE NOTIFICACIÓN
        GroupsService.getEndPointsFollowerswithNotif(wsData).then( function (dataWS) {
          //GroupsService.getEndPointsFollowers(wsData).then( function (dataWS) {
          var messageForShow = Utils.translate('ALERTS.NEW_PROFILE_PICTURE_01') + 
            UserService.get_USER_NAME() +
            Utils.translate('ALERTS.NEW_PROFILE_PICTURE_02');

          dataWS.forEach( function (dataDevices) {

            //console.log("for each", dataDevices);
            AWSServices.sendNewProfilePhotoNotification(
              messageForShow, 
              dataDevices.userDeviceId,
              0,
              UserService.get_USERSUBSCRIPTION_ID()
            )

          })
        }, function (errorWS) {
          console.log("complete error", errorWS);
        })
      }

      //ASK AWS TO RETRY UPLOAD UPDATING TIMESTAMP
        AWS.events.on('retry', function(response) {  
          if (response.error.name === 'RequestTimeTooSkewed') {
            console.error('User time is not correct. Handling error!');
            console.log('AWS systemClockOffset:', AWS.config.systemClockOffset);
            var serverTime = Date.parse(response.httpResponse.headers['date']);
            var timeNow = new Date().getTime();
            console.log('AWS timestamp:', new Date(serverTime));
            console.log('Browser timestamp:', new Date(timeNow));
            AWS.config.systemClockOffset = Math.abs(timeNow - serverTime);
            response.error.retryable = true;
            console.log('Setting systemClockOffset to:', AWS.config.systemClockOffset);
            console.log('Retrying uploading to S3 once more...');
          }
        });
      //ASK AWS TO RETRY UPLOAD UPDATING TIMESTAMP
    }
  ])

  .controller('changeProfileBackgroundPhotoCtrl', ['$scope', '$state', '$timeout', '$ionicActionSheet', 'ImageService2', 'FileService2', '$rootScope', '$jrCrop', '$interval', 'changeProfilePictureService', '$ionicPush', 'ionicService', 'reDirectService', '$filter', 's3', 'md5', 'Utils', 'AWSServices', 'GroupsService', 'UserService', '$ionicHistory',
    function($scope, $state, $timeout, $ionicActionSheet, ImageService2, FileService2, $rootScope, $jrCrop, $interval, changeProfilePictureService, $ionicPush, ionicService, reDirectService, $filter, s3, md5, Utils, AWSServices, GroupsService, UserService, $ionicHistory) {
      $scope.newBackImage = [];
      var isIOS = ionic.Platform.isIOS();
      $scope.pictureBackground = window.localStorage.getItem("bkgMyProfile") !== null ? window.localStorage.getItem("bkgMyProfile") + '?decache=' + Math.random() : "./img/postBg.png";
      $scope.oldBackgroundPhoto = window.localStorage.getItem("bkgMyProfile") !== null ? window.localStorage.getItem("bkgMyProfile") + '?decache=' + Math.random() : "./img/postBg.png";
      FileService2.cleanImages();
      $scope.newProfileImage = FileService2.images();

      $scope.checkBefore = function (type) {
        if(isIOS === true) {
          $scope.addMediaBack();
        } else {
          getMultiplePermissions(type);
        }
      };

      function getMultiplePermissions(type) {
        cordova.plugins.diagnostic.getPermissionsAuthorizationStatus(function(statuses) {
          var havePerm = 0;
          var deniedPerm = false;
          for (var permission in statuses){
            switch(statuses[permission]){
              case cordova.plugins.diagnostic.permissionStatus.GRANTED:
                console.log("Permission granted to use "+permission);
                havePerm++;
                break;
              case cordova.plugins.diagnostic.permissionStatus.NOT_REQUESTED:
                console.log("Permission to use "+permission+" has not been requested yet");
                havePerm--;
                break;
              case cordova.plugins.diagnostic.permissionStatus.DENIED:
                console.log("Permission denied to use "+permission+" - ask again?");
                havePerm--;
                break;
              case cordova.plugins.diagnostic.permissionStatus.DENIED_ALWAYS:
                console.log("Permission permanently denied to use "+permission+" - guess we won't be using it then!");
                deniedPerm = true;
                break;
            }
          }
          if(!deniedPerm){
            if(havePerm == 2){
              //have both permissions granted
              $scope.addMediaBack();
            } else if(havePerm <2){
              //both or one permission hasn't granted
              askMultiplePermissions(type);
            }
          } else {
            Utils.toast.error(Utils.translate('PLUGINS.PERMISSIONS.DENIED_PERMISSION') +
              Utils.translate('PLUGINS.PERMISSIONS.TYPE.CAMERA') + ' ' +
              Utils.translate('PLUGINS.PERMISSIONS.AND') + ' ' +
              Utils.translate('PLUGINS.PERMISSIONS.TYPE.GALLERY') + '. \n' +
              Utils.translate('PLUGINS.PERMISSIONS.ALWAYS_DENIED_PERMISSION'));
          }
        }, function(error){
          console.error("The following error occurred: "+error);
        }, [
          cordova.plugins.diagnostic.permission.CAMERA,
          cordova.plugins.diagnostic.permission.READ_EXTERNAL_STORAGE
        ])
      }

      function askMultiplePermissions(type) {
        cordova.plugins.diagnostic.requestRuntimePermissions(function(statuses) {
          var havePerm = 0;
          var deniedPerm = false;
          for (var permission in statuses){
            switch(statuses[permission]){
              case cordova.plugins.diagnostic.permissionStatus.GRANTED:
                console.log("Permission granted to use "+permission);
                havePerm++;
                break;
              case cordova.plugins.diagnostic.permissionStatus.NOT_REQUESTED:
                console.log("Permission to use "+permission+" has not been requested yet");
                havePerm--;
                break;
              case cordova.plugins.diagnostic.permissionStatus.DENIED:
                console.log("Permission denied to use "+permission+" - ask again?");
                havePerm--;
                break;
              case cordova.plugins.diagnostic.permissionStatus.DENIED_ALWAYS:
                console.log("Permission permanently denied to use "+permission+" - guess we won't be using it then!");
                deniedPerm = true;
                break;
            }
          }
          if(!deniedPerm){
            if(havePerm == 2){
              //have both permissions granted
              $scope.addMediaBack();
            } else if(havePerm <2){
              //both or one permission hasn't granted
              Utils.toast.error(Utils.translate('PLUGINS.PERMISSIONS.DENIED_PERMISSION') +
              Utils.translate('PLUGINS.PERMISSIONS.TYPE.CAMERA') + ' ' +
              Utils.translate('PLUGINS.PERMISSIONS.AND') + ' ' +
              Utils.translate('PLUGINS.PERMISSIONS.TYPE.GALLERY') + '.');
            }
          } else {
            Utils.toast.error(Utils.translate('PLUGINS.PERMISSIONS.DENIED_PERMISSION') +
              Utils.translate('PLUGINS.PERMISSIONS.TYPE.CAMERA') + ' ' +
              Utils.translate('PLUGINS.PERMISSIONS.AND') + ' ' +
              Utils.translate('PLUGINS.PERMISSIONS.TYPE.GALLERY') + '. \n' +
              Utils.translate('PLUGINS.PERMISSIONS.ALWAYS_DENIED_PERMISSION'));
          }
        }, function(error){
          console.error("The following error occurred: "+error);
        }, [
          cordova.plugins.diagnostic.permission.CAMERA,
          cordova.plugins.diagnostic.permission.READ_EXTERNAL_STORAGE
        ])
      }

      $scope.uploadingPhoto = false;
      $scope.openCrop = false;
      $scope.addMediaBack = function () {
        $scope.hideSheet = $ionicActionSheet.show({
          buttons: [
            {text: 'Take photo'},
            {text: 'Photo from library'}
          ],
          titleText: 'Add images',
          cancelText: 'Cancel',
          buttonClicked: function (index) {
            $scope.addImageBack(index);
          }
        });
      };

      $scope.addImageBack = function (type) {
        $scope.hideSheet(); //USING NEW PLUGIN MediaPicker
        $scope.newBackImage = [];
        if(type === 0) { // camera
          ImageService2.saveCameraMediaBackgroundPhoto(type).then(function () {
          });
        } else { // library
          ImageService2.saveAlbumMediaBackgroundPhoto(type).then(function () {
          });
        }
      };

      $rootScope.$on("addedImageC", function () { // LISTENER FOR IMAGE LOADED
        showBackImageUser();
      });

      function showBackImageUser() {
        console.log("CALLED FUNCTION");
        if($scope.openCrop) {
          return true;
        }
        $scope.openCrop = true;
        var img = FileService2.images();
        var exifTemp = FileService2.exifImage();
        if(img.length === 0) { //ask again in 1 sec
          $timeout(function () {
            showImageUser();
          }, 1000);
        } else {
          if($scope.newBackImage === null || $scope.newBackImage === undefined || $scope.newBackImage.length === 0) {
            var opt = {};
            if(isIOS === true) {
              //prepare IOS
              opt = {
                url: img[0],
                width: 393,
                height: 230,
                circle: true,
                allowRotation: true,
                title: 'Usa tus dedos para ajustar la imagen'
              }
              $jrCrop.crop(opt).then(function(canvas) {
                // success!
                console.log("INIT CUT IOS");
                $scope.newBackImage[0] = canvas.toDataURL();
                $timeout(function() {
                  $scope.openCrop = false;
                  $scope.changeBackPicture();
                  $scope.$apply();
                }, 0);
              }, function(err) {
                console.error(err);
                $scope.newBackImage[0] = $scope.oldBackgroundPhoto;
                $scope.openCrop = false;
                FileService2.cleanImages;
                $ionicHistory.nextViewOptions({disableBack: true});
                $state.go('menu.myProfile', {}, {reload: false});
              });
            } else {
              var urlToUse = null;
              if(img[0].src) {
                urlToUse = img[0].src;
              } else {
                urlToUse = img[0];
              }
              opt = {
                url: urlToUse,
                width: 393,
                height: 230,
                circle: true,
                allowRotation: true,
                title: 'Usa tus dedos para ajustar la imagen'
              }
              $jrCrop.crop(opt).then(function(canvas) {
                console.log("INIT CUT ANDROID");
                $scope.newBackImage[0] = canvas.toDataURL();
                $timeout(function() {
                  $scope.openCrop = false;
                  $scope.changeBackPicture();
                  $scope.$apply();
                }, 0);
              }, function(err) {
                console.error(err);
                $scope.newBackImage[0] = $scope.oldBackgroundPhoto;
                $scope.openCrop = false;
                FileService2.cleanImages;
                $ionicHistory.nextViewOptions({disableBack: true});
                $state.go('menu.myProfile', {}, {reload: false});
              });
            }
          } else {
            $scope.openCrop = false;
            console.log("finish loading");
          }
        }
      }

      $scope.changeBackPicture = function () {
        $scope.uploadingPhoto = true;
        var pictureName = window.localStorage.getItem("userSubscriptionInstanceId") + "_back_" + window.localStorage.getItem("userName");
        window.localStorage.setItem("bkgMyProfile", "nothing");
        $scope.pictureBackground = "nothing";
        //Steps to upload
        var s3Service = new AWS.S3({
          apiVersion: '2006-03-01',
          params: {Bucket: s3.bucket}
        });
        //encrypt subscriptioninstanceID and folder name
        var userSubscriptionInstanceId = md5.createHash(UserService.get_USERSUBSCRIPTIONINSTANCE_ID().toString());
        var folder = md5.createHash("profileBackgroundPicture");

        //Create random number for image index
        var indexRandom = Math.floor(Math.random() * 1000);

        //create key for each picture
        var photoKey = s3.prefix + '/' + userSubscriptionInstanceId + '/' + folder + '/' + 'background' + indexRandom + '.jpg';

        //photo to blob
        var file = Utils.dataURLtoBlob($scope.newBackImage[0]);

        //upload to s3
        //small
        s3Service.upload({
          Key: photoKey,
          Body: file,
          ACL: 'public-read',
          ContentType: file.type
        }, function (err, data) {
          if (err) {
            return console.log('There was an error uploading the background jpg:');
          }
          if (data) {
            console.log('Successfully uploaded large image.');
            //updating the background photo
            changeProfilePictureService.changeBackPict(
              {"userSubscriptionId": window.localStorage.getItem("userSubscriptionInstanceId")}
            ).save({
              "string":
                {
                  "value": "http://s3-us-west-2.amazonaws.com/" + s3.bucket + "/" + photoKey
                }
            }, function succes() {
              //nothing more
            }, function (response) {
              if (response && (response.status === 504 || response.status === -1)) {
                console.log("We don't care");
                $scope.uploadingPhoto = false;
                window.localStorage.setItem("bkgMyProfile", "http://s3-us-west-2.amazonaws.com/" + s3.bucket + "/" + photoKey + '?decache=' + Math.random());
                $scope.pictureProfile = "http://s3-us-west-2.amazonaws.com/" + s3.bucket + "/" + photoKey;
                $ionicHistory.nextViewOptions({disableBack: true});
                $state.go('menu.myProfile', {}, {reload: false});
              } else {
                console.log("changeProfilePicture error");
              }
            });
            //freeing the user from the process
            $timeout(function () {
              $scope.uploadingPhoto = false;
              window.localStorage.setItem("bkgMyProfile", "http://s3-us-west-2.amazonaws.com/" + s3.bucket + "/" + photoKey + '?decache=' + Math.random());
              $scope.pictureProfile = "http://s3-us-west-2.amazonaws.com/" + s3.bucket + "/" + photoKey;
              FileService2.cleanImages;
              $ionicHistory.nextViewOptions({disableBack: true});
              $state.go('menu.myProfile', {}, {reload: false});
            }, 1000);
          }
        });
      };

      //ASK AWS TO RETRY UPLOAD UPDATING TIMESTAMP
        AWS.events.on('retry', function(response) {  
          if (response.error.name === 'RequestTimeTooSkewed') {
            console.error('User time is not correct. Handling error!');
            console.log('AWS systemClockOffset:', AWS.config.systemClockOffset);
            var serverTime = Date.parse(response.httpResponse.headers['date']);
            var timeNow = new Date().getTime();
            console.log('AWS timestamp:', new Date(serverTime));
            console.log('Browser timestamp:', new Date(timeNow));
            AWS.config.systemClockOffset = Math.abs(timeNow - serverTime);
            response.error.retryable = true;
            console.log('Setting systemClockOffset to:', AWS.config.systemClockOffset);
            console.log('Retrying uploading to S3 once more...');
          }
        });
      //ASK AWS TO RETRY UPLOAD UPDATING TIMESTAMP
    }
  ])

;
