"use strict";

appControllers
  .controller('QRMainPageCtrl', ['$scope', 'ApiEndPoint', '$state', 'reDirectService', 'Utils', 'UserService', 'userAttendanceService', 'permissionValidationService', 'Personalized',
    function($scope, ApiEndPoint, $state, reDirectService, Utils, UserService, userAttendanceService, permissionValidationService, Personalized) {

      //Declaration zone
      $scope.isIOS = ionic.Platform.isIOS();
      $scope.isAndroid = ionic.Platform.isAndroid();
      $scope.resultID = "";
      $scope.scannerIsOn = false;
      $scope.userFoundName = "";

      //

      //--- permissions zone
      $scope.isAllowedMakePromotion = permissionValidationService.canCreatePromotion();
      $scope.isAllowedMakeEasterEgg = permissionValidationService.canCreateEasterEgg();
      $scope.isAllowedAdminEvents = permissionValidationService.canAdminEvents();
      //END permissions zone

      //For IOS isn't necesary to check for permissions
      $scope.checkPermissions = function() {
        if ($scope.isIOS === true) {
          //startScan();
          IOSStartScanner();
        } else {
          getMultiplePermissions();
        }
      };

      /**
       *function to get multiple permission for camera
       */
      function getMultiplePermissions() {
        cordova.plugins.diagnostic.getPermissionsAuthorizationStatus(function(statuses) {
          var havePerm = 0;
          var deniedPerm = false;
          for (var permission in statuses) {
            switch (statuses[permission]) {
              case cordova.plugins.diagnostic.permissionStatus.GRANTED:
                console.log("Permission granted to use " + permission);
                havePerm++;
                break;
              case cordova.plugins.diagnostic.permissionStatus.NOT_REQUESTED:
                console.log("Permission to use " + permission + " has not been requested yet");
                havePerm--;
                break;
              case cordova.plugins.diagnostic.permissionStatus.DENIED:
                console.log("Permission denied to use " + permission + " - ask again?");
                havePerm--;
                break;
              case cordova.plugins.diagnostic.permissionStatus.DENIED_ALWAYS:
                console.log("Permission permanently denied to use " + permission + " - guess we won't be using it then!");
                deniedPerm = true;
                break;
            }
          }
          if (!deniedPerm) {
            if (havePerm == 2) {
              //have all permissions
              //startScan();
              IOSStartScanner();
            } else if (havePerm < 2) {
              //both or one permission hasn't granted
              askMultiplePermissions();
            }
          } else {
            Utils.toast.error(Utils.translate('PLUGINS.PERMISSIONS.DENIED_PERMISSION') +
              Utils.translate('PLUGINS.PERMISSIONS.TYPE.CAMERA') + ' ' +
              Utils.translate('PLUGINS.PERMISSIONS.AND') + ' ' +
              Utils.translate('PLUGINS.PERMISSIONS.TYPE.GALLERY') + '. \n' +
              Utils.translate('PLUGINS.PERMISSIONS.ALWAYS_DENIED_PERMISSION'));
          }
        }, function(error) {
          console.error("The following error occurred: " + error);
        }, [
          cordova.plugins.diagnostic.permission.CAMERA,
          cordova.plugins.diagnostic.permission.READ_EXTERNAL_STORAGE
        ])
      };

      /**
       *function to get multiple permission for camera
       */
      function askMultiplePermissions() {
        cordova.plugins.diagnostic.requestRuntimePermissions(function(statuses) {
          var havePerm = 0;
          var deniedPerm = false;
          for (var permission in statuses) {
            switch (statuses[permission]) {
              case cordova.plugins.diagnostic.permissionStatus.GRANTED:
                console.log("Permission granted to use " + permission);
                havePerm++;
                break;
              case cordova.plugins.diagnostic.permissionStatus.NOT_REQUESTED:
                console.log("Permission to use " + permission + " has not been requested yet");
                havePerm--;
                break;
              case cordova.plugins.diagnostic.permissionStatus.DENIED:
                console.log("Permission denied to use " + permission + " - ask again?");
                havePerm--;
                break;
              case cordova.plugins.diagnostic.permissionStatus.DENIED_ALWAYS:
                console.log("Permission permanently denied to use " + permission + " - guess we won't be using it then!");
                deniedPerm = true;
                break;
            }
          }
          if (!deniedPerm) {
            if (havePerm == 2) {
              //have both permissions granted
              //startScan();
              IOSStartScanner();
            } else if (havePerm < 2) {
              //both or one permission hasn't granted
              Utils.toast.error(Utils.translate('PLUGINS.PERMISSIONS.DENIED_PERMISSION') +
                Utils.translate('PLUGINS.PERMISSIONS.TYPE.CAMERA') + ' ' +
                Utils.translate('PLUGINS.PERMISSIONS.AND') + ' ' +
                Utils.translate('PLUGINS.PERMISSIONS.TYPE.GALLERY') + '.');
            }
          } else {
            Utils.toast.error(Utils.translate('PLUGINS.PERMISSIONS.DENIED_PERMISSION') +
              Utils.translate('PLUGINS.PERMISSIONS.TYPE.CAMERA') + ' ' +
              Utils.translate('PLUGINS.PERMISSIONS.AND') + ' ' +
              Utils.translate('PLUGINS.PERMISSIONS.TYPE.GALLERY') + '. \n' +
              Utils.translate('PLUGINS.PERMISSIONS.ALWAYS_DENIED_PERMISSION'));
          }
        }, function(error) {
          console.error("The following error occurred: " + error);
        }, [
          cordova.plugins.diagnostic.permission.CAMERA,
          cordova.plugins.diagnostic.permission.READ_EXTERNAL_STORAGE
        ])
      };

      /**
       *function to start QR Scan
       **/
      function IOSStartScanner() {
        cordova.plugins.barcodeScanner.scan(
          function(result) {
            $scope.scannerIsOn = false;
            var cleanIds = "";
            var idsForLook = "";
            if (result.text.indexOf(Personalized.nameApp +'_Assist_List_') >= 0) {   //BALA QRCODE FIX
              cleanIds = result.text.split(Personalized.nameApp +'_Assist_List_')[1];
              idsForLook = cleanIds.split('_');
              //Search for the user
              searchUser(idsForLook[0], idsForLook[1]);
              console.log(cleanIds);
            } else { //
              if (result.text.indexOf(Personalized.nameApp +'_Promotion_List_') >= 0 ||  //BALA QRCODE FIX
                result.text.indexOf(Personalized.nameApp +'_Coupon_List_') >= 0 ||
                result.text.indexOf(Personalized.nameApp +'_EasterEgg_List_') >= 0) {
                Utils.toast.error(Utils.translate('QRSCANPAGE.CODE.ANOTHER_CODE_TYPE'));
              } else {
                Utils.toast.error(Utils.translate('QRSCANPAGE.CODE.INVALID_CODE'));
              }
              //The QRCode doesn't valid
              console.error("INVALID QRCode");
            }
          },
          function(error) {
            alert("Scanning failed: " + error);
          }, {
            preferFrontCamera: false, // iOS and Android
            showFlipCameraButton: true, // iOS and Android
            showTorchButton: true, // iOS and Android
            torchOn: false, // Android, launch with the torch switched on (if available)
            saveHistory: false, // Android, save scan history (default false)
            prompt: "Place a barcode inside the scan area", // Android
            resultDisplayDuration: 0, // Android, display scanned text for X ms. 0 suppresses it entirely, default 1500
            formats: "QR_CODE,PDF_417", // default: all but PDF_417 and RSS_EXPANDED
            //orientation : "landscape", // Android only (portrait|landscape), default unset so it rotates with the device
            disableAnimations: false, // iOS
            disableSuccessBeep: true // iOS and Android
          }
        );
      }

      //After get valid ID open dialog to add info before sending to Server
      function searchUser(saveId, searchId) { // instanceID
        Utils.loading.show();
        UserService.getUserSubscriptionByinstanceIdCompleteProfile(searchId).$promise.then(
          function(data) {
            $scope.nameFriendProfile = data[0].name;
            Utils.loading.hide();
            var dialog = Utils.alert.getCtrl();
            dialog.show({
              templateUrl: 'templates/QRList/UserFoundTpl.html',
              controller: "QRAddInfoCtrl",
              locals: {
                userID: saveId,
                name: $scope.nameFriendProfile,
                dialog: dialog,
                instanceID: searchId
              },
              clickOutsideToClose: false,
              fullscreen: true // Only for -xs, -sm breakpoints.
            }).then(function() {

              $scope.statementBtnAction = 'open';
            }, function() {

              $scope.statementBtnAction = 'open';
            });
          }
        )
      }



      /**
       *Function for create new Event List
       **/
      $scope.addEventList = function() {
        var dialog = Utils.alert.getCtrl();
        dialog.show({
          templateUrl: 'templates/QRList/ExhiCreateEventListTpl.html',
          controller: "CreateEventListCtrl",
          locals: {
            saved: false,
            dialog: dialog
          },
          clickOutsideToClose: false,
          fullscreen: true // Only for -xs, -sm breakpoints.
        }).then(function(response) {
          if (response.saved) {
            $state.go('menu.ExhiEventList', {}, { reload: true });
          } else {
            return true;
          }
          console.log("opened dialog");
        }, function() {
          console.log("opened dialog");
        });
      }

    }
  ])

  .controller('QRAddInfoCtrl', ['$scope', 'ApiEndPoint', '$state', 'reDirectService', 'Utils', 'locals', '$rootScope', 'userAttendanceService', 'UserService', 'promosService', 'permissionValidationService',
    function($scope, ApiEndPoint, $state, reDirectService, Utils, locals, $rootScope, userAttendanceService, UserService, promosService, permissionValidationService) {

      var permissions = permissionValidationService;
      $scope.showToken = permissions.viewTokens();
      $scope.data = {};
      $scope.name = locals.name;
      $scope.idForSend = locals.userID;
      $scope.idInstance = locals.instanceID;
      $scope.textForSave = "";
      $scope.dateForSave = new Date();
      $scope.savingTime = false;
      $scope.userSubscriptionRedim = UserService.get_USERSUBSCRIPTION_ID();
      $scope.data.tokenRest = ""; //OmRo
      $scope.closeDialog = function() {
        locals.dialog.hide();
      };

      UserService.getUserSubscriptionByinstanceIdCompleteProfile($scope.idInstance).$promise.then(
        function(data) {
          $scope.nameFriendProfile = data[0].name;
          $scope.tokenDisp = data[0].tokensCount.toString();

        }).then(function() {
        console.log();

      }, function() {


      });

      $scope.saveUserParticipation = function() {
        {
        if (!/^([0-9])*$/.test($scope.data.tokenRest)){
             Utils.toast.warning(Utils.translate("TOKENS.TOKENVALID"));
             return;
        }
        if (parseInt($scope.tokenDisp) < parseInt($scope.data.tokenRest)) {
          Utils.toast.warning(Utils.translate("TOKENS.TOKENERR"));
        } else if (parseInt($scope.tokenDisp) >= parseInt($scope.data.tokenRest) || ($scope.data.tokenRest == "")) {
          $scope.savingTime = true;
          userAttendanceService.addUserAttendance().save({
            userSubscriptionId: {
              value: locals.userID
            },
            date: {
              value: $scope.dateForSave
            },
            comment: {
              value: $scope.textForSave
            },
            userSubscriptionIdOwn: {
              value: UserService.get_USERSUBSCRIPTION_ID()
            }
          }).$promise.then(function(respoonse) {

            $scope.savingTime = false;
            $scope.closeDialog();
            $scope.restToken();
            Utils.toast.success(Utils.translate('QRSCANPAGE.CODE.REGISTED'))

          }, function(err) {
            $scope.savingTime = false;
            Utils.toast.error(Utils.translate('QRSCANPAGE.CODE.CANT_REGISTED'));
            console.error("something happen", err);
            $scope.closeDialog();
          })
          console.log($scope.name + " se ha registrado con: " + $scope.textForSave);
        }
      }

      $scope.restToken = function(data) {
        if ($scope.data.tokenRest === "0") {

        } else if ($scope.data.tokenRest !== "") {

          var datatosent = {
            userSubscriptionId: $scope.idForSend,
            tokens: $scope.data.tokenRest,
            userSubscriptionRedim: $scope.userSubscriptionRedim
          }
          promosService.redimTokens({
            userSubscriptionId: datatosent.userSubscriptionId,
            tokens: datatosent.tokens,
            userSubscriptionRedim: datatosent.userSubscriptionRedim

          }).$promise.then(function tokenplus(success) {
            console.log(success)
          }, function failtokenplus(error) {
            console.log(error);
          })
        }
      }
      
      }

      $scope.change = function() {
        $scope.data.tokenRest = "";
      }

    }
  ])

  .controller('ListAttendantCtrl', ['$scope', 'ApiEndPoint', '$state', 'reDirectService', 'Utils', '$rootScope', 'userAttendanceService', 'UserService',
    function($scope, ApiEndPoint, $state, reDirectService, Utils, $rootScope, userAttendanceService, UserService) {
      $scope.dateForLook = new Date();
      $scope.dateForLookTop = new Date();
      $scope.days = "";
      $scope.numberUsersFound = null;
      $scope.userList = [];
      $scope.start = 0;
      $scope.count = 30;
      $scope.listenInc = 0;
      $scope.noMoreItemsAvailable = false;
      $scope.finalDateForUse = "";
      $scope.finalTopDateForUse = "";
      $scope.SearchWithRange = false;
      $scope.NumSelected = 0;
      $scope.listDevicesForSend = [];
      $scope.listNamesForSend = [];

      $scope.lookForNo = function(date, dateTop, range) {
        Utils.loading.show();
        console.log("ok", date);
        $scope.userList.length = 0;
        if (!$scope.SearchWithRange) {
          userAttendanceService.countUserAttendance().get({
            "x-isis-querystring": {
              "creationDate": {
                "value": date
              },
              "userSubscriptionId": {
                "value": UserService.get_USERSUBSCRIPTION_ID()
              }
            }
          }, function(response) {
            $scope.showExtraList = false;
            $scope.finalDateForUse = date;
            $scope.numberUsersFound = response.result.value;
            Utils.loading.hide();
            console.log(response);
          }, function(err) {
            $scope.showExtraList = false;
            console.log(err);
            Utils.loading.hide();
          });
        } else {
          userAttendanceService.countUserAttendanceRange().get({
            "x-isis-querystring": {
              "initialDate": {
                "value": date
              },
              "finalDate": {
                "value": dateTop
              },
              "userSubscriptionId": {
                "value": UserService.get_USERSUBSCRIPTION_ID()
              }
            }
          }, function(response) {
            $scope.showExtraList = false;
            $scope.finalDateForUse = date;
            $scope.finalTopDateForUse = dateTop;
            $scope.numberUsersFound = response.result.value;
            Utils.loading.hide();
            console.log(response);
          }, function(err) {
            $scope.showExtraList = false;
            console.log(err);
            Utils.loading.hide();
          });
        }
      }

      $scope.showListByDate = function(date, newSearch) {
        if (newSearch) {
          Utils.loading.show();
          $scope.showExtraList = false;
          $scope.userList = [];
          $scope.start = 0;
          $scope.count = 30;
          $scope.noMoreItemsAvailable = false;
          $scope.listenInc = 0;
        }
        if (!$scope.SearchWithRange) {
          userAttendanceService.findListUserAttendanceDetails().get({
            "x-isis-querystring": {
              "creationDate": {
                "value": $scope.finalDateForUse
              },
              "userSubscriptionId": {
                "value": UserService.get_USERSUBSCRIPTION_ID()
              },
              "withStart": {
                "value": $scope.start
              },
              "withCount": {
                "value": $scope.count
              }
            }
          }, function(usersListed) {
            Utils.removeLastItemIfHasNoAttribute(usersListed, 'userSubscription');
            var userByOne = [];
            usersListed.forEach(function(userAlone) {
              var commentExtra = userAlone.comment;
              var userExtra = userAlone.name;
              var userDevices = UserService.getDevices(userAlone.userSubscription.href.split('/')[6]).$promise;
              //var userExtra = UserService.getUserSubscriptionByinstanceIdCompleteProfile(userAlone.userSubscription.href.split('/')[6]).$promise;
              var firstPartDate = null;
              var secondPartDate = null;
              var fullDate = " ";
              if (userAlone.creationTime) {
                firstPartDate = userAlone.split('T')[0];
                secondPartDate = userAlone.split('T')[1].replace('Z', '');
              }
              if (firstPartDate != null && secondPartDate != null)
                fullDate = firstPartDate + " " + secondPartDate;
              $scope.userList.push({
                comment: commentExtra,
                userData: userExtra,
                userSubsInstanceID: userAlone.userSubscription.href.split('/')[6],
                userSubsID: userAlone.userSubscriptionId,
                showAllText: false,
                selected: false,
                devicesList: userDevices,
                date: fullDate
              });
              $scope.listenInc++;
            })
            $scope.showingList = true;
            if ($scope.listenInc == 0 || $scope.listenInc < 30)
              $scope.noMoreItemsAvailable = true;
            $scope.start += $scope.listenInc;
            $scope.showExtraList = true;
            Utils.loading.hide();
            console.log($scope.userList);
            $scope.listenInc = 0;
            $scope.$broadcast('scroll.infiniteScrollComplete');
          }, function(err) {
            $scope.showExtraList = false;
            $scope.noMoreItemsAvailable = true;
            $scope.listenInc = 0;
            console.log(err);
            Utils.loading.hide();
            $scope.$broadcast('scroll.infiniteScrollComplete');
          })
        } else {
          userAttendanceService.findListUserAttendanceDetailsRange().get({
            "x-isis-querystring": {
              "initialDate": {
                "value": $scope.finalDateForUse
              },
              "finalDate": {
                "value": $scope.finalTopDateForUse
              },
              "userSubscriptionId": {
                "value": UserService.get_USERSUBSCRIPTION_ID()
              },
              "withStart": {
                "value": $scope.start
              },
              "withCount": {
                "value": $scope.count
              }
            }
          }, function(usersListed) {
            Utils.removeLastItemIfHasNoAttribute(usersListed, 'userSubscription');
            var userByOne = [];
            usersListed.forEach(function(userAlone) {
              var commentExtra = userAlone.comment;
              var userExtra = userAlone.name;
              var userDevices = UserService.getDevices(userAlone.userSubscription.href.split('/')[6]).$promise;
              //var userExtra = UserService.getUserSubscriptionByinstanceIdCompleteProfile(userAlone.userSubscription.href.split('/')[6]).$promise;
              var firstPartDate = null;
              var secondPartDate = null;
              var fullDate = " ";
              if (userAlone.creationTime) {
                firstPartDate = userAlone.split('T')[0];
                secondPartDate = userAlone.split('T')[1].replace('Z', '');
              }
              if (firstPartDate != null && secondPartDate != null)
                fullDate = firstPartDate + " " + secondPartDate;

              $scope.userList.push({
                comment: commentExtra,
                userData: userExtra,
                userSubsInstanceID: userAlone.userSubscription.href.split('/')[6],
                userSubsID: userAlone.userSubscriptionId,
                showAllText: false,
                selected: false,
                devicesList: userDevices,
                date: fullDate
              });
              $scope.listenInc++;
            })
            $scope.showingList = true;
            if ($scope.listenInc == 0 || $scope.listenInc < 20)
              $scope.noMoreItemsAvailable = true;
            $scope.start += $scope.listenInc;
            $scope.showExtraList = true;
            Utils.loading.hide();
            console.log($scope.userList);
            $scope.listenInc = 0;
            $scope.$broadcast('scroll.infiniteScrollComplete');
          }, function(err) {
            $scope.showExtraList = false;
            $scope.noMoreItemsAvailable = true;
            $scope.listenInc = 0;
            console.log(err);
            Utils.loading.hide();
            $scope.$broadcast('scroll.infiniteScrollComplete');
          })
        }
      }

      $scope.showFullText = function(user) {
        user.showAllText = true;
        $scope.$apply();
      }

      $scope.sendToContact = function(user) {
        var me = UserService.get_USERSUBSCRIPTIONINSTANCE_ID();
        if (me === parseInt(user.userSubsInstanceID)) {
          $state.go('menu.myProfile', {}, { reload: true });
        } else {
          $state.go('menu.QRUserContact', {
            idInstanceUser: user.userSubsInstanceID,
            idUser: user.userSubsID,
            promoText: user.comment,
            dateAdded: user.date
          });
        }
      }

      $scope.changeTypeSearch = function(change) {
        $scope.SearchWithRange = change;
        $scope.numberUsersFound = null;
        $scope.showExtraList = false;
        $scope.userList = [];
        $scope.start = 0;
        $scope.count = 30;
        $scope.noMoreItemsAvailable = false;
        $scope.listenInc = 0;
      }

      $scope.selectUser = function(selected, devices, name, index) {
        if (!selected) {
          $scope.NumSelected++;
          $scope.listDevicesForSend[index] = devices.$$state.value.result.value;
          $scope.listNamesForSend[index] = name;
          console.log($scope.listDevicesForSend);
        } else {
          $scope.NumSelected--;
          $scope.listDevicesForSend.splice(index, 1);
          $scope.listNamesForSend.splice(index, 1);
          console.log($scope.listDevicesForSend);
        }
      }

      $scope.openPushWindow = function() {
        if ($scope.NumSelected === 0) {
          return true;
        } else {
          var dialog = Utils.alert.getCtrl();
          dialog.show({
            templateUrl: 'templates/QRList/QRMultipleContactPushTpl.html',
            controller: "sendPushMultipleContacsCtrl",
            locals: {
              deviceList: $scope.listDevicesForSend,
              names: $scope.listNamesForSend,
              dialog: dialog
            },
            clickOutsideToClose: false,
            fullscreen: true // Only for -xs, -sm breakpoints.
          }).then(function() {
            console.log("opened dialog");
          }, function() {
            console.log("opened dialog");
          });
        }
      }
    }
  ])

  .controller('sendPushMultipleContacsCtrl', ['$scope', 'ApiEndPoint', '$state', 'reDirectService', 'Utils', 'locals', '$rootScope', 'userAttendanceService', 'UserService', 'AWSServices',
    function($scope, ApiEndPoint, $state, reDirectService, Utils, locals, $rootScope, userAttendanceService, UserService, AWSServices) {
      $scope.names = locals.names;
      $scope.list = locals.deviceList;
      $scope.textForPush = "";
      $scope.savingTime = false;
      $scope.closeDialog = function() {
        locals.dialog.hide();
      };


      $scope.sendPush = function() {
        if ($scope.textForPush === "") {
          return true;
        } else {
          $scope.savingTime = true;
          //var nameExhibitor = UserService.get_USER_NAME();
          for (var i = 0; i < $scope.list.length; i++) {
            if ($scope.names[i] != '' || $scope.names[i] != null) {
              if ($scope.list[i] != null || $scope.list[i] != undefined) {
                $scope.list[i].forEach(function(data) {
                  AWSServices.sendNotificationexhibitor(
                    $scope.textForPush,
                    $scope.names[i],
                    data.title,
                    true,
                    'CONTACT_EXHIBITOR',
                    UserService.get_USERSUBSCRIPTIONINSTANCE_ID()
                  );
                })
                console.log($scope.list[i]);
                console.log($scope.names[i]);
              }
            }
          }
          $scope.savingTime = false;
          $scope.closeDialog();
          Utils.toast.success(Utils.translate('QRSCANPAGE.ATTENDANT_INFO.SENT_PUSH'));
        }
      }
    }
  ])

  .controller('AttendantInfoCtrl', ['$scope', 'ApiEndPoint', '$state', 'reDirectService', 'Utils', '$rootScope', 'userAttendanceService', 'UserService', 'ChatFactory2',
    function($scope, ApiEndPoint, $state, reDirectService, Utils, $rootScope, userAttendanceService, UserService, ChatFactory2) {

      //console.log('111', $state.params.idInstanceUser);
      $scope.userInfo = [];
      $scope.deviceList = [];
      $scope.pushNotifDisabled = true;
      $scope.currentContacts = [];

      /*
       * deregister back button
       */
      function irPaTras() {
        $rootScope.$ionicGoBack();
      }

      var deregisterHardBack = Utils.$ionicPlatform.registerBackButtonAction(
        irPaTras, 101
      );

      /*
       * cancel custom action for back button
       */
      /*$scope.$on('$destroy', function () {
        console.log("si destruyó");
        deregisterHardBack();
      });*/

      $scope.$on('$routeChangeStart', function() {
        console.log("si destruyó");
        deregisterHardBack();
      });

      /*
       * INIT ZONE
       */
      $scope.searchUser = function(searchId) { // instanceID
        UserService.getUserSubscriptionByinstanceIdCompleteProfile(searchId).$promise.then(
          function(data) {
            Utils.removeLastItemIfHasNoAttribute(data, 'userSubscription');
            var realPhoto = "";
            if (data[0].profilePictureUrl)
              realPhoto = data[0].profilePictureUrl;
            else
              realPhoto = "img/ProfilePhoto.svg";
            $scope.userInfo.push({
              profilePicture: data[0].profilePicture,
              profilePictureUrl: realPhoto,
              userName: data[0].name,
              userBio: data[0].userBio,
              userSubscriptionID: data[0].userSubscriptionId,
              userSubscriptionInstanceID: data[0].userSubscription.href.split('/')[6],
              userEmail: data[0].email,
              userComment: $state.params.promoText,
              userDate: $state.params.dateAdded
            })
            console.log($scope.userInfo);
            $scope.findDevices(searchId);
          },
          function(error) {
            Utils.toast.error(Utils.translate('QRSCANPAGE.ATTENDANT_INFO.FAIL_FOUND'));
            console.log("Can't get info from user show toast");
          }
        )
      }
      $scope.searchUser($state.params.idInstanceUser);

      $scope.findDevices = function(searchId) {
        UserService.getDevices(searchId).$promise.then(
          function(data) {
            if (data.result.value.length > 0) {
              $scope.pushNotifDisabled = false;
              $scope.deviceList = data.result.value;
            } else {
              $scope.pushNotifDisabled = true;
              Utils.toast.error(Utils.translate('QRSCANPAGE.ATTENDANT_INFO.ENDPOINT_NOT'));
              console.log("user doesn't have valid endPoint or don't want to be bothered")
            }
            console.log(data);
          },
          function(error) {
            $scope.pushNotifDisabled = true;
            Utils.toast.error(Utils.translate('QRSCANPAGE.ATTENDANT_INFO.ENDPOINT_ERROR'));
            console.log("Can't get devices block this button");
          }
        )
      }

      ChatFactory2.DB.getCurrentRooms().then(function(items) {
        $scope.currentContacts = items;
      }, function(error) {
        console.error("Couldn't get the current rooms", error)
      }).finally(function() {
        console.log("got contacts", $scope.currentContacts);
      });

      /*
       * ACTIONS ZONE
       */
      $scope.showPushForm = function() {
        if ($scope.pushNotifDisabled || $scope.deviceList.length === 0) {
          return true;
        } else {
          var dialog = Utils.alert.getCtrl();
          dialog.show({
            templateUrl: 'templates/QRList/QRContactPushTpl.html',
            controller: "sendPushForContacCtrl",
            locals: {
              deviceList: $scope.deviceList,
              name: $scope.userInfo[0].userName,
              dialog: dialog
            },
            clickOutsideToClose: false,
            fullscreen: true // Only for -xs, -sm breakpoints.
          }).then(function() {
            console.log("opened dialog");
          }, function() {
            console.log("opened dialog");
          });
        }
      }

      $scope.sendPrivateMessage = function(userInfo) {
        //Before send to chat we make sure they don't have already a private chat
        var exists = $scope.currentContacts.some(function(contact) {
          return contact.id === +userInfo.userSubscriptionInstanceID
        })
        var friend = {};
        if (exists) {
          ChatFactory2.DB.getInboxContact(
            +userInfo.userSubscriptionInstanceID
          ).then(function(contact) {
            $state.go('chatPrivate', { friend: contact, addToContacts: false }, { reload: true });
          })
        } else {
          friend.socket = { isOnline: false };
          friend.user = {
            id: +userInfo.userSubscriptionInstanceID,
            name: userInfo.userName,
            avatar: userInfo.profilePictureUrl,
            bio: userInfo.userBio
          };
          friend.message = {};
          $state.go('chatPrivate', { friend: friend, addToContacts: true }, { reload: true });
        }
      }

      $scope.showPushEmail = function(userInfo) {
        if (userInfo.userEmail === "" || userInfo.userEmail === null) {
          return true;
        } else {
          var dialog = Utils.alert.getCtrl();
          dialog.show({
            templateUrl: 'templates/QRList/QRContactEmailTpl.html',
            controller: "sendEmailForContacCtrl",
            locals: {
              contactMail: userInfo.userEmail,
              name: userInfo.userName,
              dialog: dialog
            },
            clickOutsideToClose: false,
            fullscreen: true // Only for -xs, -sm breakpoints.
          }).then(function() {
            console.log("opened dialog");
          }, function() {
            console.log("opened dialog");
          });
        }
      }
    }
  ])

  .controller('sendPushForContacCtrl', ['$scope', 'ApiEndPoint', '$state', 'reDirectService', 'Utils', 'locals', '$rootScope', 'userAttendanceService', 'UserService', 'AWSServices',
    function($scope, ApiEndPoint, $state, reDirectService, Utils, locals, $rootScope, userAttendanceService, UserService, AWSServices) {
      $scope.name = locals.name;
      $scope.list = locals.deviceList;
      $scope.textForPush = "";
      $scope.savingTime = false;
      $scope.closeDialog = function() {
        locals.dialog.hide();
      };


      $scope.sendPush = function() {
        if ($scope.textForPush === "") {
          return true;
        } else {
          $scope.savingTime = true;
          var nameExhibitor = UserService.get_USER_NAME();
          $scope.list.forEach(function(endpointArn) {
            AWSServices.sendNotificationexhibitor(
              $scope.textForPush,
              nameExhibitor,
              endpointArn.title,
              true,
              'CONTACT_EXHIBITOR',
              UserService.get_USERSUBSCRIPTIONINSTANCE_ID()
            );
          })
          $scope.savingTime = false;
          $scope.closeDialog();
          Utils.toast.success(Utils.translate('QRSCANPAGE.ATTENDANT_INFO.SENT_PUSH'));
        }
      }
    }
  ])

  .controller('sendEmailForContacCtrl', ['$scope', 'ApiEndPoint', '$state', 'reDirectService', 'Utils', 'locals', '$rootScope', 'userAttendanceService', 'UserService', 'AWSServices',
    function($scope, ApiEndPoint, $state, reDirectService, Utils, locals, $rootScope, userAttendanceService, UserService, AWSServices) {
      $scope.name = locals.name;
      $scope.contactMail = locals.contactMail;
      $scope.exhibitorMail = UserService.get_USER_EMAIL();
      $scope.textSubject = ""
      $scope.textBody = "";
      $scope.savingTime = false;

      $scope.closeDialog = function() {
        locals.dialog.hide();
      };


      $scope.sendEmailNotification = function(userInfo) {
        if ($scope.contactMail === "" || $scope.exhibitorMail === "") {
          return true;
        } else {
          $scope.savingTime = true;
          UserService.sendEmailToSupportLogin().save({
            "string1": { //To Who
              "value": $scope.contactMail
            },
            "string2": { //From Who
              "value": $scope.exhibitorMail
            },
            "string3": { //Subject
              "value": $scope.textSubject
            },
            "string4": { //Body
              "value": $scope.textBody
            }
          }, function(data) {
            $scope.savingTime = false;
            $scope.closeDialog();
            Utils.toast.success(Utils.translate('QRSCANPAGE.ATTENDANT_INFO.SENT_EMAIL'));
          }, function(error) {
            $scope.savingTime = false;
            $scope.closeDialog();
            Utils.toast.error(Utils.translate('QRSCANPAGE.ATTENDANT_INFO.ERROR_EMAIL'));
          });
        }
      }
    }
  ])

  .controller('showPostQRCodeCtrl', ['$scope', 'ApiEndPoint', '$state', 'reDirectService', 'Utils', 'locals', '$rootScope', 'userAttendanceService', 'UserService', 'AWSServices', '$cordovaFileTransfer', 'Personalized',
    function($scope, ApiEndPoint, $state, reDirectService, Utils, locals, $rootScope, userAttendanceService, UserService, AWSServices, $cordovaFileTransfer, Personalized) {
      $scope.codeForUse = locals.dataCode;
      $scope.nameFile = locals.type;
      $scope.nameType = locals.nameAdd;
      $scope.showQR = false;
      $scope.savingTime = false;
      $scope.isIOS = ionic.Platform.isIOS();
      $scope.closeDialog = function() {
        locals.dialog.hide();
      };

      $scope.generateQRCodeForPost = function() {
        $scope.showQR = true;
        Utils.loading.show();
        setTimeout(function() {
          var qrcode = new QRCode(document.getElementById("qrcode"), {
            text: $scope.codeForUse,
            width: 150,
            height: 150,
            colorDark: "#2d2d2d",
            colorLight: "#ffffff",
            correctLevel: QRCode.CorrectLevel.H
          })
          Utils.loading.hide();
        }, 1000);
      }


      $scope.b64ToBlob = function(b64Data, contentType, sliceSize) {
        contentType = contentType || '';
        sliceSize = sliceSize || 512;

        var byteCharacters = atob(b64Data);
        var byteArrays = [];

        for (var offset = 0; offset < byteCharacters.length; offset += sliceSize) {
          var slice = byteCharacters.slice(offset, offset + sliceSize);

          var byteNumbers = new Array(slice.length);
          for (var i = 0; i < slice.length; i++) {
            byteNumbers[i] = slice.charCodeAt(i);
          }

          var byteArray = new Uint8Array(byteNumbers);

          byteArrays.push(byteArray);
        }

        var blob = new Blob(byteArrays, { type: contentType });
        return blob;
      }

      $scope.saveQRIntoDevice = function() {

        var completeFileName = $scope.nameFile + $scope.nameType + ".png";

        var urlOfQRCode = document.getElementById("qrcode").lastChild.currentSrc;
        var block = urlOfQRCode.split(";");
        var dataType = block[0].split(":")[1];
        var realData = block[1].split(",")[1];

        var folderpath = null;
        /*if ($scope.isIOS)
          folderpath = cordova.file.documentsDirectory;
        else*/
        folderpath = cordova.file.externalRootDirectory;

        var folder = "Codigos " + Personalized.nameApp;  //BALA QRCODE FIX
        var trustHosts = true;
        var options = {};

        //var DataBlob = b64toBlob(urlOfQRCode,'image/png');
        var DataBlob = $scope.b64ToBlob(realData, dataType, null);

        window.resolveLocalFileSystemURL(folderpath, function(dir) {
          console.log("Access to root");
          dir.getDirectory(folder, { create: true, exclusive: false }, function(dirEntry) {
            console.log("create folder");
            dirEntry.getFile(completeFileName, { create: true }, function(file) {
              console.log("created file");
              file.createWriter(function(fileWriter) {
                console.log("writing content");
                fileWriter.write(DataBlob);
                Utils.toast.success(Utils.translate('QRSCANPAGE.CODE.SAVED_IN_DEVICE'));
              }, function(error) {
                Utils.toast.success(Utils.translate('QRSCANPAGE.CODE.SAVED_IN_DEVICE_FAIL'));
              });
            }, function(error) {
              console.error("Couldn't access file", error);
            })
          }, function(error) {
            console.error("Couldn't access folder", error);
          })
        }, function(errorDir) {
          console.error("can't access dir because: ", errorDir);
        })
      }

      setTimeout(function() {
        console.log("generando");
        $scope.generateQRCodeForPost();
      }, 0);
    }
  ])

  .controller('createPromosCtrl', ['$rootScope', '$scope', '$state', 'FileService', '$timeout', 'ImageService', 'ApiEndPoint', '$ionicModal', 'MultiImageService', '$ionicPopup', 'usersData', 'SequenceService', 'UserService', 'ionicService', '$ionicPlatform', 's3', 'md5', 'VideoService', 'FileVideoService', '$sce', 'adsService', '$ionicPickerI18n', 'AWSServices', 'permissionValidationService', 'GroupFactory', 'Utils', 'promosService', 'Personalized', 'ImageService2', 'FileService2',
    function($rootScope, $scope, $state, FileService, $timeout, ImageService, ApiEndPoint, $ionicModal, MultiImageService, $ionicPopup, usersData, SequenceService, UserService, ionicService, $ionicPlatform, s3, md5, VideoService, FileVideoService, $sce, adsService, $ionicPickerI18n, AWSServices, permissionValidationService, GroupFactory, Utils, promosService, Personalized, ImageService2, FileService2) {


      //____ZONE FOR DECLARATE
      var userId = UserService.get_USERSUBSCRIPTION_ID();
      var userInstId = UserService.get_USERSUBSCRIPTIONINSTANCE_ID();
      var exits = 0;
      var mentionFix = "";
      var deleteArray = [];
      var typeUpload = "3"; //VIDEO
      var realTemplateName = 'templateVideo';
      var widthFinal = 0;
      var heightFinal = 0;
      var file = null;
      var thumbVideoFile = null;
      var permissions = permissionValidationService;
      $scope.showToken = permissions.viewTokens();
      $scope.uploadingMedia = false;
      $scope.galleryIsOpen = false;
      $scope.isIOS = ionic.Platform.isIOS();
      $scope.isAndroid = ionic.Platform.isAndroid();
      $scope.videInfoNeeded = "";
      $scope.idImages = "";
      var s3Service = new AWS.S3({
        apiVersion: '2006-03-01',
        params: { Bucket: s3.bucket }
      });
      FileService.cleanImages();
      $scope.data = {
        hasMedia: false,
        numImages: 0,
        numVideos: 0,
        pictures: [],
        thumbPictures: [],
        promotionName: '',
        video: [],
        haveVideo: false,
        havePhotos: false,
        videoBlob: null,
        videoFile: null,
        totalFileUpload: 300,
        totalFileloaded: 0,
        labelProgress: "",
        temporalVideoThumbnail: "",
        codecProgress: null,
        typePromo: 0,
        sliderOptions: {
          initialSlide: 0,
          direction: 'horizontal', //or vertical
          speed: 300 //0.3s transition
        },
        sliderDelegate: null,
        valuetoken: "" //OmRo Token
      };
      $scope.optionsPromo = [];
      FileVideoService.cleanVideo();
      $scope.uploadButtonText = Utils.translate('UPLOAD.UPLOAD');
      //END ZONE FOR DECLARATE

      //____ZONE FOR PERMISSIONS
      $scope.isAllowedMakePromotion = permissionValidationService.canCreatePromotion();
      $scope.isAllowedMakeEasterEgg = permissionValidationService.canCreateEasterEgg();
      $scope.fillSelectPromos = function() {
        if ($scope.isAllowedMakePromotion) {
          $scope.optionsPromo.push({ id: 0, name: Utils.translate('QRSCANPAGE.CREATE_PROMO_ZONE.PROMOTION_TYPE') }, { id: 1, name: Utils.translate('QRSCANPAGE.CREATE_PROMO_ZONE.COUPON_TYPE') });
        }
        if ($scope.isAllowedMakeEasterEgg) {
          $scope.optionsPromo.push({ id: 2, name: Utils.translate('QRSCANPAGE.CREATE_PROMO_ZONE.EASTEREGG_TYPE') })
        }
        $scope.data.typePromo = { id: 0, name: Utils.translate('QRSCANPAGE.CREATE_PROMO_ZONE.PROMOTION_TYPE') };
      }
      $scope.fillSelectPromos();
      //END ZONE FOR PERMISSIONS

      //____VISUAL OPTIONS/FUNCTIONS
      $scope.mantainCheckType = function() {
        console.log("seleccionado", $scope.data.typePromo);
      }

      $scope.defaultTemplate = function() {
        $scope.idImages = 'templateF11'; //change for template 1 photo
      };

      $scope.sortableOptions = {
        containment: '#horizontal-container',
        //containment:'#Board-container',
        containerPositioning: 'relative',
        'ui-floating': true,
        orderChanged: function(event) {
          console.log("fuente", event.source.index);
          console.log("final", event.dest.index);
          $scope.temporalThumb = $scope.data.thumbPictures[event.source.index];
          $scope.data.thumbPictures.splice(event.source.index, 1);
          $scope.data.thumbPictures.splice(event.dest.index, 0, $scope.temporalThumb);
        }
      };

      $scope.UniqueTracking = function(index, id) {
        return index + id;
      };

      $scope.removeImage = function(indexItem) {
        $scope.data.pictures.splice(indexItem, 1);
        $scope.data.thumbPictures.splice(indexItem, 1);
        $scope.data.numElements = $scope.data.pictures.length;
        if ($scope.data.pictures.length === 0) {
          $scope.data.havePhotos = null;
          $scope.data.hasMedia = false;
        } else if ($scope.data.pictures.length === 1) {
          $scope.idImages = 'templateF11';
        }
      };

      $scope.onDropComplete = function(index, obj) {
        var otherObj = $scope.pictures[index];
        var otherIndex = $scope.pictures.indexOf(obj);
        $scope.data.pictures[index] = obj;
        $scope.data.pictures[otherIndex] = otherObj;
      };

      $scope.deleteVideo = function() {
        var newSrc = document.getElementById("videoAreaUpload");
        newSrc.src = '';
        $scope.data.videoFile = null;
        $scope.data.haveVideo = false;
        $scope.data.hasMedia = false;
      };

      $scope.updateSlideStatus = function(panel) {
        console.log("it's", panel);
      }
      //END VISUAL OPTIONS/FUNCTIONS

      //____OPEN EDIT TEXTAREA
      $scope.openTextEditArea = function() {
        var dialog = Utils.alert.getCtrl();
        dialog.show({
          templateUrl: 'templates/partials/tags-modal.html',
          controller: 'tagsModalCtrl',
          fullscreen: true,
          locals: {
            description: $scope.data.promotionName,
            tagsList: $scope.data.mentionsList,
            hash: $scope.data.hashList,
            plusLength: true,
            dialog: dialog,
            needSearch: true
          },
          clickOutsideToClose: false,
          multiple: true
        }).then(function(form) {
          $scope.data.promotionName = form.description;
          $scope.data.mentionsList = form.savedTags;
          $scope.data.hashList = form.savedHashes;

          console.log("new mentions:", $scope.data.mentionsList, $scope.data.hashList)
        });
      }
      //END OPEN EDIT TEXTAREA

      //____PERMISSIONS TO USE CAMERA/GALLERY
      $scope.checkPermissions = function(type) {
        if ($scope.isIOS === true) {
          if (type === 1)
            $scope.addMedia();
          else
            $scope.getVideoFromDevice();
        } else {
          //for camera in Android we need camera and external storage permissions
          // 1 - multi
          // 2 - camera alone // library
          getMultiplePermissions(type);
        }
      }

      function getMultiplePermissions(type) {
        cordova.plugins.diagnostic.getPermissionsAuthorizationStatus(function(statuses) {
          var havePerm = 0;
          var deniedPerm = false;
          for (var permission in statuses) {
            switch (statuses[permission]) {
              case cordova.plugins.diagnostic.permissionStatus.GRANTED:
                console.log("Permission granted to use " + permission);
                havePerm++;
                break;
              case cordova.plugins.diagnostic.permissionStatus.NOT_REQUESTED:
                console.log("Permission to use " + permission + " has not been requested yet");
                havePerm--;
                break;
              case cordova.plugins.diagnostic.permissionStatus.DENIED:
                console.log("Permission denied to use " + permission + " - ask again?");
                havePerm--;
                break;
              case cordova.plugins.diagnostic.permissionStatus.DENIED_ALWAYS:
                console.log("Permission permanently denied to use " + permission + " - guess we won't be using it then!");
                deniedPerm = true;
                break;
            }
          }
          if (!deniedPerm) {
            if (havePerm == 2) {
              //have both permissions granted
              if (type === 1)
                $scope.addMedia();
              else
                $scope.getVideoFromDevice();
            } else if (havePerm < 2) {
              //both or one permission hasn't granted
              askMultiplePermissions(type);
            }
          } else {
            Utils.toast.error(Utils.translate('PLUGINS.PERMISSIONS.DENIED_PERMISSION') +
              Utils.translate('PLUGINS.PERMISSIONS.TYPE.CAMERA') + ' ' +
              Utils.translate('PLUGINS.PERMISSIONS.AND') + ' ' +
              Utils.translate('PLUGINS.PERMISSIONS.TYPE.GALLERY') + '. \n' +
              Utils.translate('PLUGINS.PERMISSIONS.ALWAYS_DENIED_PERMISSION'));
          }
        }, function(error) {
          console.error("The following error occurred: " + error);
        }, [
          cordova.plugins.diagnostic.permission.CAMERA,
          cordova.plugins.diagnostic.permission.READ_EXTERNAL_STORAGE
        ])
      }

      function askMultiplePermissions(type) {
        cordova.plugins.diagnostic.requestRuntimePermissions(function(statuses) {
          var havePerm = 0;
          var deniedPerm = false;
          for (var permission in statuses) {
            switch (statuses[permission]) {
              case cordova.plugins.diagnostic.permissionStatus.GRANTED:
                console.log("Permission granted to use " + permission);
                havePerm++;
                break;
              case cordova.plugins.diagnostic.permissionStatus.NOT_REQUESTED:
                console.log("Permission to use " + permission + " has not been requested yet");
                havePerm--;
                break;
              case cordova.plugins.diagnostic.permissionStatus.DENIED:
                console.log("Permission denied to use " + permission + " - ask again?");
                havePerm--;
                break;
              case cordova.plugins.diagnostic.permissionStatus.DENIED_ALWAYS:
                console.log("Permission permanently denied to use " + permission + " - guess we won't be using it then!");
                deniedPerm = true;
                break;
            }
          }
          if (!deniedPerm) {
            if (havePerm == 2) {
              //have both permissions granted
              if (type === 1)
                $scope.addMedia();
              else
                $scope.getVideoFromDevice();
            } else if (havePerm < 2) {
              //both or one permission hasn't granted
              Utils.toast.error(Utils.translate('PLUGINS.PERMISSIONS.DENIED_PERMISSION') +
                Utils.translate('PLUGINS.PERMISSIONS.TYPE.CAMERA') + ' ' +
                Utils.translate('PLUGINS.PERMISSIONS.AND') + ' ' +
                Utils.translate('PLUGINS.PERMISSIONS.TYPE.GALLERY') + '.');
            }
          } else {
            Utils.toast.error(Utils.translate('PLUGINS.PERMISSIONS.DENIED_PERMISSION') +
              Utils.translate('PLUGINS.PERMISSIONS.TYPE.CAMERA') + ' ' +
              Utils.translate('PLUGINS.PERMISSIONS.AND') + ' ' +
              Utils.translate('PLUGINS.PERMISSIONS.TYPE.GALLERY') + '. \n' +
              Utils.translate('PLUGINS.PERMISSIONS.ALWAYS_DENIED_PERMISSION'));
          }
        }, function(error) {
          console.error("The following error occurred: " + error);
        }, [
          cordova.plugins.diagnostic.permission.CAMERA,
          cordova.plugins.diagnostic.permission.READ_EXTERNAL_STORAGE
        ])
      }

      //END PERMISSIONS TO USE CAMERA/GALLERY

      //____GET IMAGES FROM CAMERA OR GALLERY
      $scope.processImg = false;
      $scope.addMedia = function() {
        var hideSheet = Utils.$ionicActionSheet.show({
          buttons: [
            { text: Utils.translate('UPLOAD.TAKE') + ' <i class="icon ion-camera"></i>' },
            { text: Utils.translate('UPLOAD.FROM_GALLERY') + ' <i class="icon ion-images"></i>' }
          ],
          titleText: Utils.translate('UPLOAD.ADD'),
          cancelText: Utils.translate('GLOBAL.CANCEL'),
          buttonClicked: function(index) {
            hideSheet();
            $scope.galleryIsOpen = true;
            switch (index) {
              case 0:
                ImageService2.saveCameraMediaPromoPhoto(index).then(function() {
                  $scope.galleryIsOpen = false;
                  $scope.processImg = true;
                });
                break;
              case 1:
                ImageService2.saveAlbumMediaPromoPhoto(index).then(function() {
                  $scope.galleryIsOpen = false;
                  $scope.processImg = true;
                });
                break;
            }
          }
        });
      };

      $rootScope.$on("addedImagePromo", function() {
        console.log("finally");
        showImagePromo();
      })

      function showImagePromo() {
        //begin the image functions
        var img = FileService2.images();
        var exifTemp = FileService2.exifImage();
        if (img.length === 0) { //ask again in 1 sec
          $timeout(function() {
            showImagePromo();
          }, 1000);
        } else {
          if ($scope.isIOS === true) {
            Utils.loading.show();
            var photosProcessed = 0;
            img.forEach(function(oneImage, index, photoPck) {
              $scope.data.pictures.push(oneImage);
              $scope.data.thumbPictures.push(oneImage);
              photosProcessed++;
              console.log(photosProcessed + " from " + photoPck.length);
              if (photosProcessed === photoPck.length) {
                $scope.data.hasMedia = true;
                $scope.data.havePhotos = true;
                Utils.loading.hide();
              }
            })
            $timeout(function() {
              $scope.processImg = false;
              $scope.apply();
            }, 0)
          } else {
            Utils.loading.show();
            var photosProcessed = 0;
            img.forEach(function(oneImage, index, photoPck) {
              photosProcessed++;
              if (oneImage.uri) {
                loadingPhotos(oneImage.uri, photosProcessed, photoPck.length);
              } else {
                loadingPhotos(oneImage, photosProcessed, photoPck.length);
              }
            })
          }
        }
      }

      function loadingPhotos(paths, step, end) {
        var canvas;
        var ctx;
        var dataURL;
        var num = 0;
        var img = new Image();
        img.crossOrigin = 'Anonymous';
        img.onload = function() {
          canvas = document.createElement('CANVAS');
          ctx = canvas.getContext('2d');
          canvas.height = this.height;
          canvas.width = this.width;
          ctx.drawImage(this, 0, 0);
          dataURL = canvas.toDataURL("image/jpeg", 1.0);
          //window.localStorage.setItem(path.split('/')[4], dataURL);
          $scope.data.pictures.push(dataURL);
          $scope.data.thumbPictures.push(dataURL)
          //$scope.pictures.push({"blob": dataURL, "name": path.split('/')[4]});
          $scope.$apply();
          console.log(step + " from " + end);
          if (step === end) {
            $scope.data.hasMedia = true;
            $scope.data.havePhotos = true;
            Utils.loading.hide();
            $scope.processImg = false;
          }
        };
        img.src = paths;
      }
      //END GET IMAGES FROM CAMERA OR GALLERY

      //____GET VIDEO FROM GALLERY
      $scope.getVideoFromDevice = function() {
        $scope.galleryIsOpen = true;
        VideoService.saveVideoMedia().then(function() {
          //Get video from library
          $scope.data.video = FileVideoService.video();

          //edit video
          $scope.realURL = 'file://' + $scope.data.video;

          //if (!$scope.isIOS) {
          VideoEditor.getVideoInfo(
            getInfoSuccess,
            getInfoError, {
              fileUri: $scope.realURL
            }
          );
        });
      };

      function getInfoSuccess(info) {
        console.log("got it" + info);
        $scope.videInfoNeeded = info;
        //Steps to generate random name for video
        var firstPartName = Math.floor(Math.random() * (100 - (0 + 1))) + 0;
        var secondPartName = Math.floor(Math.random() * (200 - (101 + 1))) + 101;
        var fullRandomName = firstPartName + "video" + secondPartName;
        var transOptions = {
          fileUri: $scope.realURL,
          outputFileName: fullRandomName,
          outputFileType: VideoEditorOptions.OutputFileType.MPEG4,
          optimizeForNetworkUse: VideoEditorOptions.OptimizeForNetworkUse.YES,
          saveToLibrary: false,
          deleteInputFile: false,
          mantainAspectRatio: true,
          height: 640,
          width: 640,
          progress: function(info) {
            console.log("progress in coding video: " + info);
            //var elem = document.getElementById("progressVideoCodec");
            //var roundProgress = (info * 100);
            //elem.style.width = roundProgress.toFixed(0) + '%';
            //$scope.data.codecProgress = roundProgress.toFixed(0) + '%';
            $scope.data.codecProgress = true;
            $scope.$apply();
          }
        };
        //transOptions.height = info.orientation === 'landscape' ? 720 : 1200;
        VideoEditor.transcodeVideo(
          successCoding,
          errorCoding,
          transOptions
        );
      }

      function getInfoError(err) {
        console.log("got it" + err);
      }

      function successCoding(result) {
        console.log('resultado code', result);
        console.log('data video', $scope.videInfoNeeded);
        var tempDuration = $scope.videInfoNeeded.duration;
        var posterAt = (tempDuration * 25) / 100;
        VideoEditor.createThumbnail(
          successThumbnail,
          errorThumbnail, {
            fileUri: result,
            outputFileName: '001',
            atTime: posterAt,
            width: $scope.videInfoNeeded.width,
            height: $scope.videInfoNeeded.height,
            quality: 100
          }
        );
        $scope.data.codecProgress = null;
        var newSrc = document.getElementById("videoAreaUpload");
        newSrc.preload = 'metadata';
        newSrc.src = 'file://' + result;
        var blob = null;
        var xhr = new XMLHttpRequest();
        xhr.open("GET", result);
        xhr.responseType = "blob";
        xhr.onload = function() {
          blob = xhr.response;
          $scope.data.videoFile = blob;
          console.log("blob");
        }
        xhr.send();
        $scope.data.haveVideo = true;
        $scope.data.hasMedia = true;
        $scope.galleryIsOpen = false;
        console.log("Successfull in coding " + result);
        $scope.$apply();
      }

      function errorCoding(err) {
        $scope.data.codecProgress = false;
        console.error("Error in coding", err);
        if (err && err.indexOf('InvalidOutputFormatException')) {
          Utils.alert.show("Lo sentimos, el formato de video no está soportado para este dispositivo", { title: "Error" });
        }
      }

      function successThumbnail(result) {
        console.log('thumb success', result);
        var videoBlob = null;
        var xhr = new XMLHttpRequest();
        xhr.open("GET", result);
        xhr.responseType = "blob";
        xhr.onload = function() {
          videoBlob = xhr.response;
          $scope.data.temporalVideoThumbnail = videoBlob;
          console.log("blobThumbnail", $scope.data.temporalVideoThumbnail);
        }
        xhr.send();
        console.log('thumb real', $scope.data.temporalVideoThumbnail);
      }

      function errorThumbnail(err) {
        console.log('thumb error', err);
      }

      $scope.chkVideoDuration = function() {
        console.log("nothing at the moment");
      };
      //END GET VIDEO FROM GALLERY

      //____PREPARE POR UPLOAD
      //create the promo base
      $scope.prepareUpload = function(template) {
        console.log($scope.data);
        if ($scope.galleryIsOpen === true) {
          Utils.alert.show("Gallery is still open");
          return;
        }
        if ($scope.data.promotionName === null) {
          $scope.data.promotionName = " ";
        }
        if (!$scope.data.hasMedia) {
          return true;
        } else {
          //Se encontró media para subir, **cambio Omro Tokens 0410209 y cambio WS
          $scope.uploadingMedia = true;
          if (!/^([0-9])*$/.test($scope.data.valuetoken)) {
            Utils.toast.warning(Utils.translate("TOKENS.TOKENVALID"));
            $scope.uploadingMedia = false;
            return;
           
          }else if( $scope.data.valuetoken === ""){
             $scope.data.valuetoken = "0";
          }
          promosService.addPromotionv200({
            userId: userId.toString(),
            typePromo: $scope.data.typePromo.id.toString(),
            descriptionPromo: $scope.data.promotionName,
            tokens: $scope.data.valuetoken.toString()
          }).$promise.then(function uploadPromoData(response) {
            uploadPromoMedia(response);
          }, function failUploadPromoMedia(error) {
            $scope.errorMsg = Utils.translate('QRSCANPAGE.CREATE_PROMO_ZONE.ERROR_AT_CREATE_PROMO1') + $scope.data.typePromo.name + Utils.translate('QRSCANPAGE.CREATE_PROMO_ZONE.ERROR_AT_CREATE_PROMO2');
            $scope.uploadingMedia = false;
            Utils.toast.error($scope.errorMsg); //Utils.translate('UPLOAD.DIALOG.POST_ERROR')
          })
        }
      }

      //upload the media, after create the QRCode and redirect to viewPromos
      function uploadPromoMedia(response) {
        console.log("answer from server", response);
        $scope.promoInstanceId = response.result.members.promotion.value.href.split('/')[6];
        $scope.promoId = response.result.members.promotionId.value;
        if ($scope.data.haveVideo) {
          //if for some reason we couldn't create the poster for the video
          //we try again here
          if ($scope.data.temporalVideoThumbnail == "") {
            var video = document.getElementById('videoAreaUpload');
            var canvas = document.createElement("canvas");
            //ZONE to calcule dimensions for thumbnail
            if (video.videoWidth >= video.videoHeight) {
              widthFinal = 310;
              heightFinal = (video.videoHeight * 310) / video.videoWidth;
            } else {
              heightFinal = 310;
              widthFinal = (video.videoWidth * 310) / video.videoHeight;
            }

            canvas.height = heightFinal;
            canvas.width = widthFinal;

            canvas.getContext('2d').drawImage(video, 0, 0, widthFinal, heightFinal);
            var imgDataUrl = canvas.toDataURL();

            thumbVideoFile = Utils.dataURLtoBlob(imgDataUrl);
            //END ZONE for make thumb image
          } else {
            thumbVideoFile = $scope.data.temporalVideoThumbnail;
          }
          file = $scope.data.videoFile;
          //promo with video
          uploadPromoVideo(response.result.members.promotion.value.href).then(
            function() {
              //continue with the QRCreation
              FileVideoService.cleanVideo();
              $scope.uploadingMedia = false;
              prepareQRScan();
              /*$state.go('menu.QRMain', {reload: true});
              Utils.toast.success("Your " + $scope.data.typePromo.name + " media has been uploaded"); //Utils.translate('QRSCANPAGE.CODE.REGISTED')*/
            },
            function(error) {
              $scope.uploadingMedia = false;
              $state.go('menu.QRMain', { reload: true });
              $scope.errorMsg = Utils.translate('QRSCANPAGE.CREATE_PROMO_ZONE.ERROR_AT_CREATE_PROMO1') + $scope.data.typePromo.name + Utils.translate('QRSCANPAGE.CREATE_PROMO_ZONE.ERROR_AT_CREATE_PROMO2');
              Utils.toast.error($scope.errorMsg);
            }
          )
        } else if ($scope.data.havePhotos) {
          //promo with photos
          uploadPromoPhotos(response.result.members.promotion.value.href).then(
            function() {
              FileService.cleanImages();
              $scope.uploadingMedia = false;
              prepareQRScan();
              /*$state.go('menu.QRMain', {reload: true});
              Utils.toast.success("Your " + $scope.data.typePromo.name + " media has been uploaded"); //Utils.translate('QRSCANPAGE.CODE.REGISTED')*/
            },
            function(error) {
              $scope.uploadingMedia = false;
              $state.go('menu.QRMain', { reload: true });
              $scope.errorMsg = Utils.translate('QRSCANPAGE.CREATE_PROMO_ZONE.ERROR_AT_CREATE_PROMO1') + $scope.data.typePromo.name + Utils.translate('QRSCANPAGE.CREATE_PROMO_ZONE.ERROR_AT_CREATE_PROMO2');
              Utils.toast.error($scope.errorMsg);
            }
          )
        } else {
          //the promo is empty and must be deleted
          promosService.deletePromotion({ objectId: Utils.getLastUrlComponent(response.result.members.promotion.value.href) }).post().$promise.then(
            function(onDeleteResponse) {
              $scope.uploadingMedia = false;
            },
            function(onDeleteError) {
              console.error("Wasn't able to delete Promotion record");
            }).finally(function() {
            $scope.errorMsg = Utils.translate('QRSCANPAGE.CREATE_PROMO_ZONE.ERROR_AT_CREATE_PROMO1') + $scope.data.typePromo.name + Utils.translate('QRSCANPAGE.CREATE_PROMO_ZONE.ERROR_AT_CREATE_PROMO2');
            Utils.toast.error($scope.errorMsg);
          });
        }
      }

      //upload the video to S3 and add it to the Promo base
      function uploadPromoVideo(promoHref) {
        return Utils.$q(function(resolve, reject) {
          //code Ids for make bucket url
          var codeUserInstId = Utils.md5.createHash(userInstId.toString());
          var codePromoInstId = Utils.md5.createHash($scope.promoInstanceId);
          var deferred = Utils.$q.defer();
          var totalFiles = 2; //When uploading Video it'll be always 2 at least 1 for video an other for poster
          var numResolved = 0;
          var numErrors = 0;
          if (!file) {
            return deferred.reject("Couldn't find video file");
          }
          var realNameType = "Promotion";
          if ($scope.data.typePromo.id == 0) { //Promotion
            realNameType = "Promotion";
          } else if ($scope.data.typePromo.id == 1) { //Coupon
            realNameType = "Coupon";
          } else if ($scope.data.typePromo.id == 2) { //EasterEgg
            realNameType = "EasterEgg";
          }
          //making the url to use in bucket
          var videoKey = s3.prefix + '/' + codeUserInstId + '/' + realNameType + '/' + codePromoInstId + '/video/001.mp4';
          var videoThumbKey = s3.prefix + '/' + codeUserInstId + '/' + realNameType + '/' + codePromoInstId + '/video/Thumb001.png';

          var videoPromises = [];

          //add thumb video to s3
          videoPromises[0] = Utils.$q(function(resolve, reject) {
            s3Service.upload({
              Key: videoThumbKey,
              Body: thumbVideoFile,
              ACL: 'public-read',
              ContentType: thumbVideoFile.type
            }, function(err, data) {
              if (err) {
                //sequence.sharing = false;
                console.log('There was an error uploading the thumb for the video: ', err);
                return reject(err);
              }
              resolve(data)
            });
          });

          //add video to S3
          videoPromises[1] = Utils.$q(function(resolve, reject) {
            s3Service.upload({
              Key: videoKey,
              Body: file,
              ACL: 'public-read',
              ContentType: file.type
            }, {
              partSize: 5 * 1024 * 1024,
              queueSize: 10
            }, function(err, data) {
              if (err) {
                return reject(err);
              }
              resolve(data)
              console.log("Video upload resolved")
            }).on('httpUploadProgress', function(progress) {
              var elem = document.getElementById("progressVideoUpload");
              var roundProgress = (progress.loaded / progress.total * 100);
              elem.style.width = roundProgress.toFixed(0) + '%';
              $scope.data.labelProgress = roundProgress.toFixed(0) + '%';
              $scope.$apply();

              if (progress.loaded == progress.total)
                resolve(data)
            });
          });

          Utils.$q.all(videoPromises).then(function(resolveResp) {
            //first upload the video
            if (resolveResp[1]) {
              if (resolveResp[1].Location) {
                promosService.addPromotionItems().save({
                  "promotion": { "value": { "href": promoHref } },
                  "url": { "value": resolveResp[1].Location }
                }).$promise.then(function(responeUpVideo) {
                  //after success in add the video to the promotion we add the poster
                  promosService.addPromotionItems().save({
                    "promotion": { "value": { "href": promoHref } },
                    "url": { "value": resolveResp[0].Location }
                  }).$promise.then(function(responeUpPoster) {
                    resolve();
                  }, function(errorUpPoster) {
                    console.log("fail to add poster for the promotion", errorUpPoster);
                    s3Service.deleteObjects({
                      Bucket: s3.bucket,
                      Delete: { Objects: [{ Key: resolveResp[0].Key }] }
                    }, function(err, data) {
                      if (err)
                        console.error('deleteS3Objects', err);
                    });
                    reject();
                  })
                }, function(errorUpVideo) {
                  console.log("fail to add video for the promotion", errorUpVideo);
                  s3Service.deleteObjects({
                    Bucket: s3.bucket,
                    Delete: { Objects: [{ Key: resolveResp[1].Key }] }
                  }, function(err, data) {
                    if (err)
                      console.error('deleteS3Objects', err);
                  });
                  reject();
                });
              } else {
                reject();
              }
            } else {
              reject();
            }

          }, function(errors) {
            console.log("uploadFailErros", errors);
            reject(errors)
          })
        })
      }

      //upload the photos to S3 and add it to the Promo base
      function uploadPromoPhotos(promoHref) {
        return Utils.$q(function(resolve, reject) {
          //code Ids for make bucket url
          var codeUserInstId = Utils.md5.createHash(userInstId.toString());
          var codePromoInstId = Utils.md5.createHash($scope.promoInstanceId);
          //more vars to use
          var totalPics = $scope.data.pictures.length;
          var numResolved = 0;
          var numErrors = 0;
          var photoUploadPromise = {};
          //begin to upload each photo to S3
          for (var i = 0; i < totalPics; i++) {
            //making the url to use in bucket
            var realNameType = "Promotion";
            if ($scope.data.typePromo.id == 0) { //Promotion
              realNameType = "Promotion";
            } else if ($scope.data.typePromo.id == 1) { //Coupon
              realNameType = "Coupon";
            } else if ($scope.data.typePromo.id == 2) { //EasterEgg
              realNameType = "EasterEgg";
            }
            var photoKey = s3.prefix + '/' + codeUserInstId + '/' + realNameType + '/' + codePromoInstId + '/image/' + (i + 1) + '.jpg';
            var photoThumbKey = s3.prefix + '/' + codeUserInstId + '/' + realNameType + '/' + codePromoInstId + '/thumb/' + (i + 1) + '.jpg';
            //convert base64 image to blob needed for aws S3
            var file = Utils.dataURLtoBlob($scope.data.pictures[i]);
            var fileThumb = Utils.dataURLtoBlob($scope.data.thumbPictures[i]);

            var uploadPromises = [];

            uploadPromises[0] = Utils.$q(function(resolve, reject) {
              s3Service.upload({
                Key: photoThumbKey,
                Body: fileThumb,
                ACL: 'public-read',
                ContentType: fileThumb.type
              }, function(err, data) {
                if (err) {
                  console.log('There was an error uploading the image: ', err);
                  reject(err)
                } else
                  resolve(data)
              });
            });

            uploadPromises[1] = Utils.$q(function(resolve, reject) {
              s3Service.upload({
                Key: photoKey,
                Body: file,
                ACL: 'public-read',
                ContentType: file.type
              }, function(err, data) {
                if (err) {
                  console.log('There was an error uploading the image: ', err);
                  reject(err)
                } else
                  resolve(data)
              });
            });
            photoUploadPromise[i + 1] = Utils.$q.all(uploadPromises);
          }

          //after send request to upload everyfile
          Utils.$q.all(photoUploadPromise).then(function(resolvedUploads) {
            Object.keys(photoUploadPromise).forEach(function(it) {
              promosService.addPromotionItems(it).save({
                "promotion": { "value": { "href": promoHref } },
                "url": { "value": resolvedUploads[it][1].Location }
              }).$promise.then(function() {
                numResolved++;
                if (numResolved === totalPics && !numErrors)
                  resolve()
              }, function(error) {
                console.error("update image db record", error);
                numResolved++;
                numErrors++;

                s3Service.deleteObjects({
                  Bucket: s3.bucket,
                  Delete: { Objects: [{ Key: resolvedUploads[it][0].Key }, { Key: resolvedUploads[it][1].Key }] }
                }, function(err, data) {
                  if (err)
                    console.error('deleteS3Objects', err);
                });

                if (numResolved === totalPics)
                  reject(numErrors);
              })
            });
          }, function(errors) {
            console.error("uploadPromises", errors);
            reject(errors);
          })
        })
      }

      //delete the empty promo base and alert the user
      function deleteEmptyPromo(promoHref) {
        return Utils.$q(function(resolve, reject) {

        })
      }

      //ASK AWS TO RETRY UPLOAD UPDATING TIMESTAMP
      AWS.events.on('retry', function(response) {  
        if (response.error.name === 'RequestTimeTooSkewed') {
          console.error('User time is not correct. Handling error!');
          console.log('AWS systemClockOffset:', AWS.config.systemClockOffset);
          var serverTime = Date.parse(response.httpResponse.headers['date']);
          var timeNow = new Date().getTime();
          console.log('AWS timestamp:', new Date(serverTime));
          console.log('Browser timestamp:', new Date(timeNow));
          AWS.config.systemClockOffset = Math.abs(timeNow - serverTime);
          response.error.retryable = true;
          console.log('Setting systemClockOffset to:', AWS.config.systemClockOffset);
          console.log('Retrying uploading to S3 once more...');
        }
      });

      //END PREPARE POR UPLOAD

      //____PREPARE TO OPEN QRCODE GENERATOR
      function prepareQRScan() {
        //show modal before redirect to timeline
        var dataForQRCode = "";
        var typeName = "";
        var nameAdded = "";
        if ($scope.data.typePromo.id == 0) { //Promotion
          dataForQRCode = Personalized.nameApp + "_Promotion_List_" + $scope.promoId + '_' + $scope.promoInstanceId;  //BALA QRCODE FIX
          typeName = "Promotion";
        } else if ($scope.data.typePromo.id == 1) { //Coupon
          dataForQRCode = Personalized.nameApp + "_Coupon_List_" + $scope.promoId + '_' + $scope.promoInstanceId;
          typeName = "Coupon";
        } else if ($scope.data.typePromo.id == 2) { //EasterEgg
          dataForQRCode = Personalized.nameApp + "_EasterEgg_List_" + $scope.promoId + '_' + $scope.promoInstanceId;
          typeName = "EasterEgg";
        }
        if ($scope.data.haveVideo) {
          nameAdded = "video" + $scope.promoId + $scope.promoInstanceId;
        } else if ($scope.data.havePhotos) {
          nameAdded = "pictures" + $scope.promoId + $scope.promoInstanceId;
        } else {
          nameAdded = "media" + $scope.promoId + $scope.promoInstanceId;
        }
        var dialog = Utils.alert.getCtrl();
        dialog.show({
          templateUrl: 'templates/QRList/QRCodeForPostTpl.html',
          controller: "showPostQRCodeCtrl",
          locals: {
            dataCode: dataForQRCode,
            type: typeName,
            nameAdd: nameAdded,
            dialog: dialog
          },
          clickOutsideToClose: false,
          fullscreen: true // Only for -xs, -sm breakpoints.
        }).then(function() {
          $state.go('menu.QRMain', { reload: true });
          $scope.successMsg = Utils.translate('QRSCANPAGE.CREATE_PROMO_ZONE.PROMO_CREATED1') + $scope.data.typePromo.name + Utils.translate('QRSCANPAGE.CREATE_PROMO_ZONE.PROMO_CREATED2');
          Utils.toast.success($scope.errorMsg);
        }, function() {
          $state.go('menu.timeline', { groupIndex: $scope.groupData.groupIndex }, { reload: true });
        });
      }

      //END PREPARE TO OPEN QRCODE GENERATOR
    }
  ])

  .controller('PromosListPageCtrl', ['$rootScope', '$scope', '$state', 'FileService', '$timeout', 'ImageService', 'ApiEndPoint', '$ionicModal', 'MultiImageService', '$ionicPopup', 'usersData', 'SequenceService', 'UserService', 'ionicService', '$ionicPlatform', 's3', 'md5', 'VideoService', 'FileVideoService', '$sce', 'adsService', '$ionicPickerI18n', 'AWSServices', 'permissionValidationService', 'GroupFactory', 'Utils', 'promosService', 'Personalized',
    function($rootScope, $scope, $state, FileService, $timeout, ImageService, ApiEndPoint, $ionicModal, MultiImageService, $ionicPopup, usersData, SequenceService, UserService, ionicService, $ionicPlatform, s3, md5, VideoService, FileVideoService, $sce, adsService, $ionicPickerI18n, AWSServices, permissionValidationService, GroupFactory, Utils, promosService, Personalized) {
      Utils.clearCache();
      Utils.clearHistory();

      //____ZONE FOR DECLARATE
      var permissions = permissionValidationService;
      $scope.showToken = permissions.viewTokens();
      var userId = UserService.get_USERSUBSCRIPTION_ID();
      var userInstId = UserService.get_USERSUBSCRIPTIONINSTANCE_ID();
      $scope.data = {
        promotion: [],
        sliderOptions: {
          initialSlide: 0,
          direction: 'horizontal', //or vertical
          speed: 300 //0.3s transition
        }
      }
      $scope.isRefreshing = false;
      $scope.isLoadingContent = false;
      $scope.isIOS = ionic.Platform.isIOS();
      $scope.isAndroid = ionic.Platform.isAndroid();
      $scope.selectedChatImage = '';
      $scope.activeSlide = 0;
      $scope.zoomStatus = 0;
      $scope.zoomMin = 1;
      //END ZONE FOR DECLARATE

      //____ZONE FOR GET PROMOTIONS
      $scope.getAllPromotions = function() {
        Utils.loading.show();
        var data = promosService.getPromotionsOfUser(userId).$promise;
        $scope.isLoadingContent = true;
        Utils.$q.all({
          data
        }).then(function(promoData) {
          //console.log('data', promoData.data);
          promoData.data.length--;
          promoData.data.forEach(function(promoAlone) {
            //Get number of time scanned
            var noScanned = promosService.getNumberScans(promoAlone.promotionId).$promise;

            var paramsForUse = {
              id: promoAlone.promotionId,
              start: 0,
              count: 10
            }
            //get all media asigned to that promo
            var mediaAsigned = promosService.getMediaAsignedPromo(paramsForUse).$promise;

            Utils.$q.all({
              noScanned,
              mediaAsigned
            }).then(function(promoExtraData) {
              //console.log('noScanned', promoExtraData.noScanned);
              //console.log('mediaAsigned', promoExtraData.mediaAsigned);
              Utils.removeLastItemIfHasNoAttribute(promoExtraData.mediaAsigned, 'url');
              var haveVideo = false;
              for (var i = 0; i < promoExtraData.mediaAsigned.length; i++) {
                if (promoExtraData.mediaAsigned[i].url.indexOf(".mp4") != -1)
                  haveVideo = true;
              }
              var promoVideo = false;
              var promoPhoto = false;
              var promoGallery = false;
              var videoMedia = null;
              var videoPoster = null;
              var videoUrl = null;
              var photoMedia = null
              if (promoExtraData.mediaAsigned.length > 0) {
                if (haveVideo) {
                  promoVideo = true;
                  promoGallery = false;
                  promoPhoto = false;
                  //Check what url have the video
                  for (var i = 0; i < promoExtraData.mediaAsigned.length; i++) {
                    if (promoExtraData.mediaAsigned[i].url.indexOf(".mp4") != -1)
                      videoUrl = promoExtraData.mediaAsigned[i];
                    else
                      videoPoster = promoExtraData.mediaAsigned[i];
                  }
                } else {
                  photoMedia = promoExtraData.mediaAsigned;
                  promoVideo = false;
                  if (promoExtraData.mediaAsigned.length >= 2)
                    promoGallery = true;
                  else
                    promoGallery = false;
                  promoPhoto = true;
                }
              }
              $scope.data.promotion.push({
                promotionId: promoAlone.promotionId,
                promoText: promoAlone.description,
                promotoken: promoAlone.token, //OmRo Token
                promotionInstanceId: promoAlone.promotion.href.split('/')[6],
                typePromotion: promoAlone.promotionType,
                promoCreation: promoAlone.date,
                howManyScans: promoExtraData.noScanned.result.value,
                haveVideo: promoVideo,
                havePhoto: promoPhoto,
                haveGallery: promoGallery,
                promoMediaPhotos: photoMedia,
                promoMediaVideo: videoUrl,
                promoMediaPoster: videoPoster
              })
            }, function(promoExtraDataError) {
              console.log("the error was: ", promoExtraDataError);
              $scope.isLoadingContent = false;
              $scope.isRefreshing = false;
              Utils.loading.hide();
            })
          }, function(promoAloneError) {
            $scope.isLoadingContent = false;
            $scope.isRefreshing = false;
            Utils.loading.hide();
            console.log("the error was: ", promoAloneError)
          })
          $scope.isLoadingContent = false;
          $scope.isRefreshing = false;
          $scope.$broadcast('scroll.refreshComplete');
          setTimeout(function() {
            Utils.loading.hide();
          }, 1000);
          //After get the data from the promotions we need to add all into
        }, function(promoDataError) {
          console.log('promoDataError', promoDataError);
          $scope.isLoadingContent = false;
          $scope.isRefreshing = false;
          Utils.loading.hide();
        })
      }
      $scope.getAllPromotions();

      $scope.refreshPage = function() {
        $scope.data.promotion.length = 0;
        $scope.isRefreshing = true;
        $scope.getAllPromotions();
      }
      //END ZONE FOR GET PROMOTIONS

      //____ZONE FOR PLAY VIDEO
      $scope.playVideoOwn = function(index, sequence, nameCtrl) {
        var videoElement = document.getElementById(nameCtrl + 'VideoArea' + index);
        videoElement.play();
        videoElement.controls = true;
        videoElement.addEventListener('ended', finished, false);
        if ($scope.isIOS) {
          videoElement.addEventListener('pause', finished, false);
        }
        var buttonPlay = document.getElementById(nameCtrl + 'ButtonPlay' + index);
        buttonPlay.style.display = 'none';
      };

      function finished(e) {
        console.log(e);
        e.target.controls = false;
        var getID = e.target.id.split('VideoArea')[1];
        var getIDCtrl = e.target.id.split('VideoArea')[0];
        var buttonPlay = document.getElementById(getIDCtrl + 'ButtonPlay' + getID);
        buttonPlay.style.display = 'block';
      }

      //END ZONE FOR PLAY VIDEO

      //____ZONE FOR OPEN IMAGE CLICKED
      $scope.showImageViewer = function(images, index) {
        $scope.imagesListToShow = images;
        $scope.activeSlide = index;
        Utils.$ionicModal.fromTemplateUrl('templates/QRList/image-viewerPromo.html', {
          scope: $scope,
          animation: 'zoom-from-center'
        }).then(function(modal) {
          $scope.imageViewer = modal;
          $scope.imageViewer.show();
        });
      };
      //END ZONE FOR OPEN IMAGE CLICKED

      //____ZONE FOR ACTIONS WITH IMAGE OPEN
      $scope.closeImageViewer = function() {
        $scope.selectedChatImage = '';
        $scope.imageViewer.hide();
        $scope.imageViewer.remove();
      };

      $scope.doubleTapped = function(slide) {
        if ($scope.zoomStatus === 0) {
          Utils.$ionicScrollDelegate.$getByHandle('scrollHandle' + slide).zoomBy(2, true);
          $scope.zoomStatus++;
        } else {
          Utils.$ionicScrollDelegate.$getByHandle('scrollHandle' + slide).zoomBy(0, true);
          $scope.zoomStatus--;
        }
      };
      //END ZONE FOR ACTIONS WITH IMAGE OPEN

      //____ZONE FOR DELETE PROMOTIONS
      $scope.deletePromotion = function(promo) {
        console.log("promo", promo)
        Utils.confirm.show(Utils.translate('QRSCANPAGE.SHOW_PROMOS_ZONE.CONFIRM_DELETE')).then(function(boolResp) {
          if (!boolResp) return;

          Utils.loading.show();
          promosService.deletePromotion({ objectId: promo.promotionInstanceId }).post().$promise.then(
            function(onDeleteResponse) {
              $scope.refreshPage();
              Utils.toast.success(Utils.translate('QRSCANPAGE.SHOW_PROMOS_ZONE.PROMOTION_DELETED'));
            },
            function(onDeleteError) {
              console.error("Wasn't able to delete Promotion record");
              Utils.toast.error(Utils.translate('QRSCANPAGE.SHOW_PROMOS_ZONE.PROMOTION_DELETED_ERROR'));
            }
          );
        })
      };
      //END ZONE FOR DELETE PROMOTIONS

      //____ZONE FOR SHOW QRCODE
      $scope.open3DotsPromoMenu = function(promo, index) {
        var buttons = [];
        var buttonsIds = [];

        buttons.push({ text: Utils.translate('QRSCANPAGE.SHOW_PROMOS_ZONE.SHOW_QRCODE') + '<i class="icon ion-android-create"></i>' });
        buttonsIds.push("SHOWQR");

        Utils.$ionicActionSheet.show({
          buttons: buttons,
          titleText: 'Options',
          buttonClicked: function(buttonIndex) {
            switch (buttonsIds[buttonIndex]) {
              case "SHOWQR":
                var dataForQRCode = "";
                var typeName = "";
                var nameAdded = "";
                if (promo.typePromotion == 0) { //Promotion
                  dataForQRCode = Personalized.nameApp + "_Promotion_List_" + promo.promotionId + '_' + promo.promotionInstanceId;  //BALA QRCODE FIX
                  typeName = "Promotion";
                } else if (promo.typePromotion == 1) { //Coupon
                  dataForQRCode = Personalized.nameApp + "_Coupon_List_" + promo.promotionId + '_' + promo.promotionInstanceId;
                  typeName = "Coupon";
                } else if (promo.typePromotion == 2) { //EasterEgg
                  dataForQRCode = Personalized.nameApp + "_EasterEgg_List_" + promo.promotionId + '_' + promo.promotionInstanceId;
                  typeName = "EasterEgg";
                }
                if (promo.haveVideo) {
                  nameAdded = "video" + promo.promotionId + promo.promotionInstanceId;
                } else if (promo.havePhotos) {
                  nameAdded = "pictures" + promo.promotionId + promo.promotionInstanceId;
                } else {
                  nameAdded = "media" + promo.promotionId + promo.promotionInstanceId;
                }
                var dialog = Utils.alert.getCtrl();
                dialog.show({
                  templateUrl: 'templates/QRList/QRCodeForPostTpl.html',
                  controller: "showPostQRCodeCtrl",
                  locals: {
                    dataCode: dataForQRCode,
                    type: typeName,
                    nameAdd: nameAdded,
                    dialog: dialog
                  },
                  clickOutsideToClose: false,
                  fullscreen: true // Only for -xs, -sm breakpoints.
                }).then(function() {}, function() {});
                break;
            }
          }
        })
      }
      //END ZONE FOR SHOW QRCODE

      //____ZONE TO REDIRECT SCANNERSINFO PAGE
      $scope.sendScannersInfo = function(promo) {
        $state.go('menu.showScannersInfoList', {
          idPromo: promo.promotionId,
          idInstancePromo: promo.promotionInstanceId
        });
      }
      //END ZONE TO REDIRECT SCANNERSINFO PAGE
    }
  ])

  .controller('scannersInfoCtrl', ['$rootScope', '$scope', '$state', 'FileService', '$timeout', 'ImageService', 'ApiEndPoint', '$ionicModal', 'MultiImageService', '$ionicPopup', 'usersData', 'SequenceService', 'UserService', 'ionicService', '$ionicPlatform', 's3', 'md5', 'VideoService', 'FileVideoService', '$sce', 'adsService', '$ionicPickerI18n', 'AWSServices', 'permissionValidationService', 'GroupFactory', 'Utils', 'promosService',
    function($rootScope, $scope, $state, FileService, $timeout, ImageService, ApiEndPoint, $ionicModal, MultiImageService, $ionicPopup, usersData, SequenceService, UserService, ionicService, $ionicPlatform, s3, md5, VideoService, FileVideoService, $sce, adsService, $ionicPickerI18n, AWSServices, permissionValidationService, GroupFactory, Utils, promosService) {

      //____ZONE FOR DECLARATE
      $scope.data = {
        promotionId: $state.params.idPromo,
        promotionInstId: $state.params.idInstancePromo,
        usersListed: []
      };

      var pagination = {
        start: 0,
        count: 30,
        reset: function() {
          this.start = 0;
          this.count = 30;
        },
        increaseCount: function(step) {
          this.count += step || 1
        }
      };

      $scope.isFirstTime = true;
      $scope.isLoadingContent = false;
      $scope.isIOS = ionic.Platform.isIOS();
      $scope.isAndroid = ionic.Platform.isAndroid();
      $scope.canGetMoreItems = true;
      $scope.NumSelected = 0;
      $scope.listDevicesForSend = [];
      $scope.listNamesForSend = [];
      //END ZONE FOR DECLARATE

      //____ZONE FOR GET LIST OF SCANNERS
      $scope.sendScannersInfo = function(newSearch) {
        if ($state.params.idPromo === null || $state.params.idInstancePromo === null) {
          //for some reason the params needed are null show toast and stop search
          Utils.toast.error("Can't get users list. go back to try again");
          $scope.canGetMoreItems = false;
          $scope.isLoadingContent = false;
          $scope.$broadcast('scroll.infiniteScrollComplete');
        } else {
          if (pagination.start == 0)
            Utils.loading.show();

          $scope.isLoadingContent = true;

          promosService.getInfoUsersScans().get({
            "x-isis-querystring": {
              promotionId: { value: $scope.data.promotionId.toString() },
              withStart: { value: pagination.start.toString() },
              withCount: { value: pagination.count.toString() }
            }
          }, function(listData) {
            $scope.isFirstTime = false;
            Utils.removeLastItemIfHasNoAttribute(listData, 'name');
            //console.log('data', listData);

            var totalRetrieved = listData.length;
            $scope.canGetMoreItems = totalRetrieved >= pagination.count;

            pagination.start += totalRetrieved;
            if (totalRetrieved) pagination.increaseCount();

            listData.forEach(function(usersGot) {
              var userDevices = UserService.getDevices(usersGot.userSubscription.href.split('/')[6]).$promise;
              $scope.data.usersListed.push({
                userSubscription: usersGot.userSubscription,
                creationDate: usersGot.creationDate,
                name: usersGot.name,
                position: usersGot.id,
                selected: false,
                devicesList: userDevices
              });
            });

            $scope.$broadcast('scroll.infiniteScrollComplete');
            $scope.isLoadingContent = false;
            Utils.loading.hide();
          }, function(listDataError) {
            $scope.isFirstTime = false;
            console.error("getInfoUsersScans", listDataError);
            Utils.loading.hide();
            $scope.canGetMoreItems = false;
            $scope.isLoadingContent = false;
            $scope.$broadcast('scroll.infiniteScrollComplete');
          })
        }
      };

      $scope.sendScannersInfo();
      //END ZONE FOR GET LIST OF SCANNERS

      //____ZONE TO REDIRECT USER'S PROFILE
      $scope.sendToContact = function(dataUser) {
        var me = UserService.get_USERSUBSCRIPTIONINSTANCE_ID();
        if (me === parseInt(dataUser.userSubscription.href.split('/')[6])) {
          $state.go('menu.myProfile', {}, { reload: true });
        } else {
          $state.go('menu.QRUserContact', {
            idInstanceUser: parseInt(dataUser.userSubscription.href.split('/')[6]),
            idUser: parseInt(dataUser.userSubscription.title),
            promoText: "",
            dateAdded: dataUser.creationDate
          });
        }
      }
      //END ZONE TO REDIRECT USER'S PROFILE

      $scope.selectUser = function(selected, devices, name, index) {
        if (!selected) {
          $scope.NumSelected++;
          $scope.listDevicesForSend[index] = devices.$$state.value.result.value;
          $scope.listNamesForSend[index] = name;
          console.log($scope.listDevicesForSend);
        } else {
          $scope.NumSelected--;
          $scope.listDevicesForSend.splice(index, 1);
          $scope.listNamesForSend.splice(index, 1);
          console.log($scope.listDevicesForSend);
        }
      }

      $scope.openPushWindow = function() {
        if ($scope.NumSelected === 0) {
          return true;
        } else {
          var dialog = Utils.alert.getCtrl();
          dialog.show({
            templateUrl: 'templates/QRList/QRMultipleContactPushTpl.html',
            controller: "sendPushMultipleContacsCtrl",
            locals: {
              deviceList: $scope.listDevicesForSend,
              names: $scope.listNamesForSend,
              dialog: dialog
            },
            clickOutsideToClose: false,
            fullscreen: true // Only for -xs, -sm breakpoints.
          }).then(function() {
            console.log("opened dialog");
          }, function() {
            console.log("opened dialog");
          });
        }
      }

    }
  ])

  //Events zone add it to new file

  .controller('EventMainPageCtrl', ['$scope', 'ApiEndPoint', '$state', 'reDirectService', 'Utils', 'UserService', 'userAttendanceService', 'permissionValidationService',
    function($scope, ApiEndPoint, $state, reDirectService, Utils, UserService, userAttendanceService, permissionValidationService) {

      //Declaration zone
      $scope.isIOS = ionic.Platform.isIOS();
      $scope.isAndroid = ionic.Platform.isAndroid();
      $scope.resultID = "";
      $scope.scannerIsOn = false;
      $scope.userFoundName = "";
      //

      /**
       *Function for create new Event List
       **/
      $scope.addEventList = function() {
        var dialog = Utils.alert.getCtrl();
        dialog.show({
          templateUrl: 'templates/QRList/ExhiCreateEventListTpl.html',
          controller: "CreateEventListCtrl",
          locals: {
            saved: false,
            dialog: dialog
          },
          clickOutsideToClose: false,
          fullscreen: true // Only for -xs, -sm breakpoints.
        }).then(function(response) {
          if (response.saved) {
            $state.go('menu.ExhiEventList', {}, { reload: true });
          } else {
            return true;
          }
          console.log("opened dialog");
        }, function() {
          console.log("opened dialog");
        });
      }
    }
  ])

  .controller('CreateEventListCtrl', ['$scope', 'ApiEndPoint', '$state', 'reDirectService', 'Utils', 'locals', '$rootScope', 'userAttendanceService', 'UserService', 'EventsServices',
    function($scope, ApiEndPoint, $state, reDirectService, Utils, locals, $rootScope, userAttendanceService, UserService, EventsServices) {
      $scope.saved = locals.saved;
      $scope.titleToSave = "";
      $scope.savingTime = false;
      var userId = UserService.get_USERSUBSCRIPTION_ID();
      userId.replace(/,/g, "");
      $scope.closeDialog = function(ok) {
        locals.dialog.hide({
          saved: ok
        });
      };


      $scope.chkExists = function() {
        Utils.loading.show();
        if ($scope.titleToSave === '' || $scope.titleToSave === null || $scope.titleToSave === undefined) {
          Utils.loading.hide();
          $scope.closeDialog(false);
          return true;
        }

        EventsServices.existEventByUserSubscriptionIdAndEventName().get({
          "x-isis-querystring": {
            "userSubscriptionId": {
              "value": userId
            },
            "eventName": {
              "value": $scope.titleToSave
            }
          }
        }, function(gotEventList) {

          if (gotEventList.result.value) {
            //the user have a event named like that
            console.log("resultado búsqueda", gotEventList);
            Utils.loading.hide();
            $scope.closeDialog(false);
            Utils.toast.error(Utils.translate('EVENTSPAGE.CREATE_EVENT.ERROR_ALREADY'));
          } else {
            $scope.saveUserParticipation();
          }
        }, function(error) {
          console.log("error in:", error);
          Utils.loading.hide();
          $scope.closeDialog(false);
        })
      }

      $scope.saveUserParticipation = function() {
        $scope.savingTime = true;
        EventsServices.addEvent({
          userId: userId,
          eventName: $scope.titleToSave
        }).$promise.then(function uploadPromoData(returnSaveEvent) {
          console.log('response add', returnSaveEvent);
          Utils.loading.hide();
          $scope.savingTime = false;
          $scope.closeDialog(true);
          Utils.toast.success(Utils.translate('EVENTSPAGE.CREATE_EVENT.SUCCESS_CREATE'));
        }, function failUploadPromoMedia(error) {
          console.log("error in:", error);
          Utils.loading.hide();
          $scope.savingTime = false;
          Utils.toast.error(Utils.translate('EVENTSPAGE.CREATE_EVENT.FAIL_CREATE'));
          $scope.closeDialog(false);
        })
      }
    }
  ])

  .controller('CheckEventListCtrl', ['$rootScope', '$scope', '$state', '$timeout', 'ApiEndPoint', '$ionicModal', '$ionicPopup', 'usersData', 'UserService', 'AWSServices', 'permissionValidationService', 'GroupFactory', 'Utils', 'promosService', 'EventsServices',
    function($rootScope, $scope, $state, $timeout, ApiEndPoint, $ionicModal, $ionicPopup, usersData, UserService, AWSServices, permissionValidationService, GroupFactory, Utils, promosService, EventsServices) {

      Utils.clearCache();
      Utils.clearHistory();

      //____ZONE FOR DECLARATE
      var userId = UserService.get_USERSUBSCRIPTION_ID();
      var userInstId = UserService.get_USERSUBSCRIPTIONINSTANCE_ID();
      $scope.data = {
        eventList: [],
        start: 0,
        count: 30
      }
      $scope.isRefreshing = false;
      $scope.isLoadingContent = false;
      $scope.noMoreItemsAvailable = false;
      $scope.isIOS = ionic.Platform.isIOS();
      $scope.isAndroid = ionic.Platform.isAndroid();

      //END ZONE FOR DECLARATE

      $scope.getGroupOfEvents = function(newSearch) {
        /*if($scope.isLoadingContent)
          return true;*/
        var added = 0;
        $scope.isLoadingContent = true;
        EventsServices.findEventByUserSubscriptionID().get({
          "x-isis-querystring": {
            "userSubscriptionId": {
              "value": userId
            },
            "withStart": {
              "value": $scope.data.start
            },
            "withCount": {
              "value": $scope.data.count
            }
          }
        }, function(gotEventList) {
          Utils.removeLastItemIfHasNoAttribute(gotEventList, 'eventId');
          gotEventList.forEach(function(events) {
            var cluster = {
              eventInstanceID: Utils.getLastUrlComponent(events.event.href),
              eventId: events.eventId,
              eventName: events.eventName,
              howMany: events.countEventRegistration
            }
            $scope.data.eventList.push(cluster);
            added++;
          })
          $scope.data.start += added;
          if (added == 0 || added < 30) {
            $scope.noMoreItemsAvailable = true;
          }
          $scope.isLoadingContent = false;
          $scope.isRefreshing = false;
          $scope.$broadcast('scroll.infiniteScrollComplete');
        }, function(error) {
          console.log("error in:", error);
          $scope.noMoreItemsAvailable = true;
          $scope.isLoadingContent = false;
          $scope.isRefreshing = false;
          $scope.$broadcast('scroll.infiniteScrollComplete');
        })
      }
      //$scope.getGroupOfEvents(true);

      $scope.sendToRecords = function(data) {
        $state.go('menu.CheckRegisterEvent', {
          idInstanceEvent: data.eventInstanceID,
          idEvent: data.eventId
        });
      }
    }
  ])

  .controller('CheckRegisterEventListCtrl', ['$rootScope', '$scope', '$state', '$timeout', 'ApiEndPoint', '$ionicModal', '$ionicPopup', 'usersData', 'UserService', 'AWSServices', 'permissionValidationService', 'GroupFactory', 'Utils', 'promosService', 'EventsServices', 'Personalized',
    function($rootScope, $scope, $state, $timeout, ApiEndPoint, $ionicModal, $ionicPopup, usersData, UserService, AWSServices, permissionValidationService, GroupFactory, Utils, promosService, EventsServices, Personalized) {

      var userId = UserService.get_USERSUBSCRIPTION_ID();
      var userInstId = UserService.get_USERSUBSCRIPTIONINSTANCE_ID();

      $scope.data = {
        userList: [],
        start: 0,
        count: 30,
        eventInstId: $state.params.idInstanceEvent,
        eventId: $state.params.idEvent
      }
      $scope.isRefreshing = false;
      $scope.isLoadingContent = false;
      $scope.noMoreItemsAvailable = false;
      $scope.isIOS = ionic.Platform.isIOS();
      $scope.isAndroid = ionic.Platform.isAndroid();

      $scope.getPersonsRegisted = function() {
        var added = 0;
        $scope.isLoadingContent = true;
        EventsServices.findEventRegistrationByEventId().get({
          "x-isis-querystring": {
            "eventId": {
              "value": '' + $scope.data.eventId
            },
            "withStart": {
              "value": '' + $scope.data.start
            },
            "withCount": {
              "value": '' + $scope.data.count
            }
          }
        }, function(peopleRegister) {
          Utils.removeLastItemIfHasNoAttribute(peopleRegister, 'name');
          peopleRegister.forEach(function(persons) {
            var cluster = {
              posId: persons.id,
              name: persons.name,
              phone: persons.phone ? persons.phone : Utils.translate('EVENTSPAGE.EVENTS_LIST.NO_PHONE'),
              mail: persons.email ? persons.email : Utils.translate('EVENTSPAGE.EVENTS_LIST.NO_EMAIL'),
              comment: persons.comment ? persons.comment : Utils.translate('EVENTSPAGE.EVENTS_LIST.NO_COMMENTS'),
              birthDay: persons.birthDate,
              dateAdded: persons.creationDate.split('T')[0],
              hourAdded: persons.creationDate.split('T')[1].replace('Z', ''),
            }
            $scope.data.userList.push(cluster);
            added++;
          })
          $scope.data.start += added;
          if (added == 0 || added < 30) {
            $scope.noMoreItemsAvailable = true;
          }
          $scope.isLoadingContent = false;
          $scope.isRefreshing = false;
          $scope.$broadcast('scroll.infiniteScrollComplete');
        }, function(errorGetPeople) {
          console.log("error in:", errorGetPeople);
          $scope.noMoreItemsAvailable = true;
          $scope.isLoadingContent = false;
          $scope.isRefreshing = false;
          $scope.$broadcast('scroll.infiniteScrollComplete');
        })
      }
      $scope.getPersonsRegisted();

      $scope.checkPermissions = function() {
        if ($scope.isIOS === true) {
          //startScan();
          IOSStartScanner();
        } else {
          getMultiplePermissions();
        }
      };

      function getMultiplePermissions() {
        cordova.plugins.diagnostic.getPermissionsAuthorizationStatus(function(statuses) {
          var havePerm = 0;
          var deniedPerm = false;
          for (var permission in statuses) {
            switch (statuses[permission]) {
              case cordova.plugins.diagnostic.permissionStatus.GRANTED:
                console.log("Permission granted to use " + permission);
                havePerm++;
                break;
              case cordova.plugins.diagnostic.permissionStatus.NOT_REQUESTED:
                console.log("Permission to use " + permission + " has not been requested yet");
                havePerm--;
                break;
              case cordova.plugins.diagnostic.permissionStatus.DENIED:
                console.log("Permission denied to use " + permission + " - ask again?");
                havePerm--;
                break;
              case cordova.plugins.diagnostic.permissionStatus.DENIED_ALWAYS:
                console.log("Permission permanently denied to use " + permission + " - guess we won't be using it then!");
                deniedPerm = true;
                break;
            }
          }
          if (!deniedPerm) {
            if (havePerm == 2) {
              //have all permissions
              //startScan();
              IOSStartScanner();
            } else if (havePerm < 2) {
              //both or one permission hasn't granted
              askMultiplePermissions();
            }
          } else {
            Utils.toast.error(Utils.translate('PLUGINS.PERMISSIONS.DENIED_PERMISSION') +
              Utils.translate('PLUGINS.PERMISSIONS.TYPE.CAMERA') + ' ' +
              Utils.translate('PLUGINS.PERMISSIONS.AND') + ' ' +
              Utils.translate('PLUGINS.PERMISSIONS.TYPE.GALLERY') + '. \n' +
              Utils.translate('PLUGINS.PERMISSIONS.ALWAYS_DENIED_PERMISSION'));
          }
        }, function(error) {
          console.error("The following error occurred: " + error);
        }, [
          cordova.plugins.diagnostic.permission.CAMERA,
          cordova.plugins.diagnostic.permission.READ_EXTERNAL_STORAGE
        ])
      };

      function askMultiplePermissions() {
        cordova.plugins.diagnostic.requestRuntimePermissions(function(statuses) {
          var havePerm = 0;
          var deniedPerm = false;
          for (var permission in statuses) {
            switch (statuses[permission]) {
              case cordova.plugins.diagnostic.permissionStatus.GRANTED:
                console.log("Permission granted to use " + permission);
                havePerm++;
                break;
              case cordova.plugins.diagnostic.permissionStatus.NOT_REQUESTED:
                console.log("Permission to use " + permission + " has not been requested yet");
                havePerm--;
                break;
              case cordova.plugins.diagnostic.permissionStatus.DENIED:
                console.log("Permission denied to use " + permission + " - ask again?");
                havePerm--;
                break;
              case cordova.plugins.diagnostic.permissionStatus.DENIED_ALWAYS:
                console.log("Permission permanently denied to use " + permission + " - guess we won't be using it then!");
                deniedPerm = true;
                break;
            }
          }
          if (!deniedPerm) {
            if (havePerm == 2) {
              //have both permissions granted
              //startScan();
              IOSStartScanner();
            } else if (havePerm < 2) {
              //both or one permission hasn't granted
              Utils.toast.error(Utils.translate('PLUGINS.PERMISSIONS.DENIED_PERMISSION') +
                Utils.translate('PLUGINS.PERMISSIONS.TYPE.CAMERA') + ' ' +
                Utils.translate('PLUGINS.PERMISSIONS.AND') + ' ' +
                Utils.translate('PLUGINS.PERMISSIONS.TYPE.GALLERY') + '.');
            }
          } else {
            Utils.toast.error(Utils.translate('PLUGINS.PERMISSIONS.DENIED_PERMISSION') +
              Utils.translate('PLUGINS.PERMISSIONS.TYPE.CAMERA') + ' ' +
              Utils.translate('PLUGINS.PERMISSIONS.AND') + ' ' +
              Utils.translate('PLUGINS.PERMISSIONS.TYPE.GALLERY') + '. \n' +
              Utils.translate('PLUGINS.PERMISSIONS.ALWAYS_DENIED_PERMISSION'));
          }
        }, function(error) {
          console.error("The following error occurred: " + error);
        }, [
          cordova.plugins.diagnostic.permission.CAMERA,
          cordova.plugins.diagnostic.permission.READ_EXTERNAL_STORAGE
        ])
      };

      function IOSStartScanner() {
        cordova.plugins.barcodeScanner.scan(
          function(result) {
            $scope.scannerIsOn = false;
            var cleanIds = "";
            var idsForLook = "";
            if (result.text.indexOf(Personalized.nameApp + '_Assist_List_') >= 0) {  //BALA QRCODE FIX
              cleanIds = result.text.split(Personalized.nameApp + '_Assist_List_')[1];
              idsForLook = cleanIds.split('_');
              //Search for the user
              searchUser(idsForLook[0], idsForLook[1]);
              console.log(cleanIds);
            } else { //
              if (result.text.indexOf(Personalized.nameApp + '_Promotion_List_') >= 0 ||
                result.text.indexOf(Personalized.nameApp + '_Coupon_List_') >= 0 ||
                result.text.indexOf(Personalized.nameApp + '_EasterEgg_List_') >= 0) {
                Utils.toast.error(Utils.translate('QRSCANPAGE.CODE.ANOTHER_CODE_TYPE'));
              } else {
                Utils.toast.error(Utils.translate('QRSCANPAGE.CODE.INVALID_CODE'));
              }
              //The QRCode doesn't valid
              console.error("INVALID QRCode");
            }
          },
          function(error) {
            alert("Scanning failed: " + error);
          }, {
            preferFrontCamera: false, // iOS and Android
            showFlipCameraButton: true, // iOS and Android
            showTorchButton: true, // iOS and Android
            torchOn: false, // Android, launch with the torch switched on (if available)
            saveHistory: false, // Android, save scan history (default false)
            prompt: "Place a barcode inside the scan area", // Android
            resultDisplayDuration: 0, // Android, display scanned text for X ms. 0 suppresses it entirely, default 1500
            formats: "QR_CODE,PDF_417", // default: all but PDF_417 and RSS_EXPANDED
            //orientation : "landscape", // Android only (portrait|landscape), default unset so it rotates with the device
            disableAnimations: false, // iOS
            disableSuccessBeep: true // iOS and Android
          }
        );
      };

      function searchUser(saveId, searchId) { // instanceID
        Utils.loading.show();
        UserService.getUserSubscriptionByinstanceIdCompleteProfile(searchId).$promise.then(
          function(data) {
            if (data[0].userSubscriptionId == userId) {
              //Utils.toast.error("Cannot add yourself to the event");
            }
            $scope.nameFriendProfile = data[0].name;
            Utils.loading.hide();
            var dialog = Utils.alert.getCtrl();
            var tempDate = new Date();
            dialog.show({
              templateUrl: 'templates/QRList/ExhiRegisterUserIntoEventTpl.html',
              controller: "AddUserToEventCtrl",
              locals: {
                eventInstID: $scope.data.eventInstId,
                userID: data[0].userSubscriptionId,
                userSubsID: Utils.getLastUrlComponent(data[0].userSubscription.href),
                email: data[0].email,
                name: data[0].name,
                birthdate: tempDate,
                phone: null,
                fromQR: true,
                dialog: dialog
              },
              clickOutsideToClose: false,
              fullscreen: true // Only for -xs, -sm breakpoints.
            }).then(function(get) {
              if (get.saved) {
                console.log("saved need to reload");
              }
            }, function(error) {
              console.log("nothing to do", error);
            });
          },
          function(err) {
            console.log("something wrong", err);
            Utils.loading.hide();
          }
        )
      };

      $scope.captureNewPerson = function() {
        var dialog = Utils.alert.getCtrl();
        var tempDate = new Date();
        tempDate.setHours(0, 0, 0, 0);
        dialog.show({
          templateUrl: 'templates/QRList/ExhiRegisterUserIntoEventTpl.html',
          controller: "AddUserToEventCtrl",
          locals: {
            eventInstID: $scope.data.eventInstId,
            userID: null,
            userSubsID: null,
            email: null,
            name: null,
            birthdate: tempDate,
            phone: null,
            fromQR: false,
            dialog: dialog
          },
          clickOutsideToClose: false,
          fullscreen: true // Only for -xs, -sm breakpoints.
        }).then(function(get) {
          if (get.saved) {
            console.log("saved need to reload");
            $scope.data.userList.length = 0;
            $scope.data.start = 0;
            $scope.getPersonsRegisted();
          }
        }, function(error) {
          console.log("nothing to do", error);
        });
      };

      //BALA SMS MESSAGE
      $scope.isLoadingContacts = false;
      $scope.sendMsgtoAllUsers = function() {
        if ($scope.data.userList.length <= 0) {
          return true;
        }
        //calling the new WS
        if ($scope.isLoadingContacts) {
          return true;
        }
        $scope.isLoadingContacts = true;
        Utils.loading.show();
        EventsServices.getListWithPhoneNumbers().get({
          "x-isis-querystring": {
            "eventId": {
              "value": '' + $scope.data.eventId
            }
          }
        }, function(phoneList) {
          Utils.loading.hide();
          Utils.removeLastItemIfHasNoAttribute(phoneList, 'phone');
          var interData = phoneList;
          $scope.isLoadingContacts = false;
          Utils.modal.show({
            templateUrl: 'templates/QRList/ExhiSendSMSToUsers.html',
            locals: {
              interData: interData
            },
            controller: function($scope, $mdDialog, locals, Utils) {
              $scope.data = {
                msgToSend: "",
                listUsers: locals.interData,
                processing: false
              }

              $scope.sendSMS = function() {
                if ($scope.data.msgToSend === '' || $scope.data.msgToSend === null || $scope.data.msgToSend === undefined) {
                  return true;
                }
                //prepare to send
                $scope.data.processing = true;
                $mdDialog.hide($scope.data);
              }

              $scope.cancel = function() {
                $mdDialog.cancel();
              }
            }
          }).then(function(data) {
            Utils.loading.show();
            //time to send SMS
            console.log("data", data);
            data.listUsers.forEach(function(user) {
              //clean the number deleting - _ or .
              user.phone = user.phone.split(' ').join('');
              user.phone = user.phone.split('-').join('');
              //validate first the number
              var isnum = /^\d+$/.test(user.phone);
              if (isnum) { //only numbers
                if (user.phone.length === 10) { //valid length
                  //add country code first release only for mexico
                  var completePhone = "+52" + user.phone;
                  AWSServices.sendSMSToUser(
                    completePhone,
                    data.msgToSend
                  );
                } else {
                  console.error("Phone length not valid");
                }
              } else {
                //check if phone begins with +52
                var beginCountry = user.phone.startsWith("+52");
                if (beginCountry) {
                  if (user.phone.length === 13) { //valid length
                    AWSServices.sendSMSToUser(
                      user.phone,
                      data.msgToSend
                    );
                  } else {
                    console.error("Phone length not valid");
                  }
                }
              }
            })
            Utils.toast.success(Utils.translate('QRSCANPAGE.CONTACT_PAGE.SMS_SEND'));
            Utils.loading.hide();
          })
        }, function(errorPhoneList) {

        })


      };

    }
  ])

  .controller('AddUserToEventCtrl', ['$scope', 'ApiEndPoint', '$state', 'reDirectService', 'Utils', 'locals', '$rootScope', 'userAttendanceService', 'UserService', 'EventsServices',
    function($scope, ApiEndPoint, $state, reDirectService, Utils, locals, $rootScope, userAttendanceService, UserService, EventsServices) {

      $scope.data = {
        eventIdforUse: locals.eventInstID,
        userID: locals.userID,
        userSubsID: locals.userSubsID,
        email: locals.email,
        name: locals.name,
        birthdate: locals.birthdate,
        birthdateTemp: locals.birthdate,
        phone: locals.phone,
        comment: "",
        fromQR: locals.fromQR,
        //allowDate: false,
        changeDate: false,
        listErrors: [],
        showErrors: false
      }
      $scope.savingTime = false;

      $scope.closeDialog = function(ok) {
        locals.dialog.hide({
          saved: ok
        });
      };

      $scope.changeDate = function() {
        let date01 = $scope.data.birthdate.getMonth();
        let date02 = $scope.data.birthdateTemp.getMonth();
        let year01 = $scope.data.birthdate.getFullYear();
        let year02 = $scope.data.birthdateTemp.getFullYear();
        let day01 = $scope.data.birthdate.getDate();
        let day02 = $scope.data.birthdateTemp.getDate();
        if ((date01 === date02) && (year01 === year02) && (day01 === day02)) {
          console.log("nothing");
        } else {
          $scope.data.changeDate = true;
        }
      }

      $scope.saveUserParticipation = function() {
        $scope.data.listErrors.length = 0;
        $scope.data.showErrors = false;
        //Part for validate form
        //name
        if ($scope.data.name === null || $scope.data.name === "" || $scope.data.name === undefined) {
          let errMail = {
            errorMsg: 'The name is needed',
            errorId: 3
          }
          $scope.data.listErrors.push(errMail);
        }

        //mail
        if ($scope.data.email === null || $scope.data.email === "" || $scope.data.email === undefined) {
          let errMail = {
            errorMsg: 'The email is needed',
            errorId: 2
          }
          $scope.data.listErrors.push(errMail);
          //errorMsg: 'Please, type the mail as: text@text.text',
        } else {
          let successTest = (/[^\s@]+@[^\s@]+\.[^\s@]+/).test($scope.data.email);
          if (successTest)
            console.log("success");
          else {
            let errMail = {
              errorMsg: 'Please, type the mail as: text@text.com',
              errorId: 2
            }
            $scope.data.listErrors.push(errMail);
          }
        }

        //date
        if ($scope.data.changeDate) {
          $scope.data.birthdate = $scope.data.birthdateTemp
        } else {
          $scope.data.birthdate = "";
        }

        //Phone
        let phoneReal = document.getElementById("phonePlace");
        if (phoneReal.value === null || phoneReal.value === "" || phoneReal.value === undefined) {
          $scope.data.phone = "";
        } else {
          $scope.data.phone = phoneReal.value;
        }

        //
        //
        //after all changes
        if ($scope.data.listErrors.length > 0) {
          $scope.data.showErrors = true;
          return true;
        }

        let idToSave = 0;
        if ($scope.data.fromQR)
          idToSave = $scope.data.userSubsID;

        $scope.savingTime = true;
        Utils.loading.show();
        EventsServices.addRegistration({
          eventID: $scope.data.eventIdforUse,
          userName: $scope.data.name,
          userMail: $scope.data.email,
          userBirth: $scope.data.birthdate,
          userPhone: $scope.data.phone,
          userSubscriptionId: '' + idToSave,
          comment: $scope.data.comment
        }).$promise.then(function(returnSaved) {
          Utils.loading.hide();
          $scope.savingTime = false;
          Utils.toast.success(Utils.translate('QRSCANPAGE.CODE.REGISTED'));
          $scope.closeDialog(true);
        }, function(errorSaved) {
          Utils.loading.hide();
          $scope.savingTime = false;
          Utils.toast.error(Utils.translate('QRSCANPAGE.CODE.CANT_REGISTED'));
          $scope.closeDialog(false);
        })
      }

    }
  ]);
