"use strict";
appControllers

  .controller("TimelinesContainerCtrl", ["$rootScope", "$state", "$scope", "GroupsService", "GroupFactory", "UserService", 'AppAdminRolesService', 'permissionValidationService', 'notificationsService', "Utils", "$location",
    function ($rootScope, $state, $scope, GroupsService, GroupFactory, UserService, AppAdminRolesService, permissionValidationService, notificationsService, Utils, $location) {
      //console.log("TimelinesContainerCtrl", $state.params);
      Utils.clearCache();
      Utils.clearHistory();

      var isFirstime = true;

      var permissions = permissionValidationService;

      $scope.nameProfile = UserService.get_USER_NAME();
      $scope.pictureProfile = UserService.get_USER_PHOTO();
      //$scope.openStatementForm = openStatementForm;
      $scope.openStatementForm = openComposerScreen;
      //append here the child functions
      //that need tobe executed from this control
      $scope.defaultTimelineSharedCtrl = {};
      //$scope.slidesCtrl = {};//parent container for child functions
      $scope.menuIcons = [
        'ion-funnel',
        'ion-shuffle',
        'ion-android-bookmark',
        'ion-android-sunny',
        'ion-clock'
      ];
      $scope.order = parseInt(window.localStorage.getItem("timelineOrder")) || 1;
      $scope.actionSheetItemText = [
        "Default",
        Utils.translate('TIMELINE.DEFAULT'),
        Utils.translate('TIMELINE.FAVORITE'),
        Utils.translate('TIMELINE.LIKES'),
        Utils.translate('TIMELINE.DATE')
      ];
      // Shows the action sheet
      $scope.showSortingMenu = function () {
        Utils.$ionicActionSheet.show({
          buttons: [
            {text: $scope.actionSheetItemText[1] + ' <i class="icon ' + $scope.menuIcons[1] + '"></i>'},
            {text: $scope.actionSheetItemText[2] + ' <i class="icon ' + $scope.menuIcons[2] + '"></i>'},
            {text: $scope.actionSheetItemText[3] + ' <i class="icon ' + $scope.menuIcons[3] + '"></i>'},
            {text: $scope.actionSheetItemText[4] + ' <i class="icon ' + $scope.menuIcons[4] + '"></i>'}
          ],
          titleText: Utils.translate('TIMELINE.ORGANIZE'),
          cancelText: Utils.translate('GLOBAL.CANCEL'),
          buttonClicked: function (index) {
            $scope.order = index + 1;
            window.localStorage.setItem("timelineOrder", $scope.order);
            $scope.defaultTimelineSharedCtrl.organize($scope.order);
            //in order to close the actionSheet
            return true;
          }
        });
      };


      if ($state.params.groupIndex === -1)
        $state.params.groupIndex = GroupFactory.getCurrentGroupIndex();
      if (parseInt($state.params.groupIndex) >= 0)
        GroupFactory.setCurrentGroupIndex($state.params.groupIndex);

      var sliderIndex = $scope.activeIndex = GroupFactory.getCurrentGroupIndex();

      $scope.groups = GroupFactory.getCurrentAvailableUserGroupsList();
      $scope.groupData = $state.params.groupIndex ? $scope.groups[$state.params.groupIndex - 1] : {};//current group data
      $scope.totalGroups = $scope.groups.length;

      /**
       * @return {Promise}
       */
      function loadUserGroups() {
        return Utils.$q(function (resolve, reject) {
          $scope.isLoadingGroups = true;

          GroupFactory.loadAvailableUserGroups({
            userSubscriptionHref: UserService.get_USER_INSTANCE_HREF()
          }).then(function (yourGroups) {
            $scope.groups = yourGroups;
            $scope.totalGroups = yourGroups.length;
            window.localStorage.setItem("totalGroups", $scope.totalGroups);
            resolve(yourGroups);
            console.log("- *Your (" + $scope.totalGroups + ") groups are now loaded!", $scope.groups);
          }, function (error) {
            console.error("Could not load the available user groups", error);
            Utils.toast.error(Utils.translate('GROUPS.TIMELINE_WRAPPER.DIALOG.GET_GROUPS_ERR'));
            reject(error);
          }).finally(function () {
            $scope.isLoadingGroups = false;
          });
        });
      }

      /**
       * @param checkForChanges? {boolean}
       */
      function setupSlider(checkForChanges) {
        //console.log("Setting up slider...");

        //some options to pass to our slider
        $scope.sliderOptions = {
          pagination: false,
          threshold: 125,
          initialSlide: sliderIndex,
          direction: 'horizontal', //or vertical
          speed: 300 //0.3s transition
        };

        $scope.$on("$ionicSlides.sliderInitialized", function (event, data) {
          // data.slider is the instance of Swiper
          $scope.slider = data.slider;
          Utils.$timeout(function () {
            $scope.$apply();
          });

          if (checkForChanges) {
            //console.info("will check for goups changes");
            checkForGroupsChanges();
          }

          //console.log("Slider initialized")
        });

        $scope.$on("$ionicSlides.slideChangeStart", function (event, data) {
          //console.log('Slide change is beginning');
          //console.log(data);
          checkForGroupsChanges();
        });

        $scope.$on("$ionicSlides.slideChangeEnd", function (event, data) {
          // note: the indexes are 0-based
          $scope.activeIndex = data.slider.activeIndex;
          $scope.previousIndex = data.slider.previousIndex;

          $scope.statementBtnAction = 'open';
          $scope.showButtonsArea = false;

          //You are in general timeline
          if ($scope.activeIndex == 0) {
            $scope.isGroupTimeline = false;
            $scope.groupIndex = -1;
            $scope.groupData = {};
            $scope.slideTemplate = "templates/Timelines/timeline.html";
            $scope.showStatementButton = permissions.canCreateStatementPostInGralTimeline();
            GroupFactory.setCurrentGroupIndex(0)

            //clearGroupsTimelineSubscribers();
          }
          else {
            $scope.isGroupTimeline = true;
            $scope.groupIndex = $scope.activeIndex - 1;
            $scope.slideTemplate = "templates/Timelines/group-timeline.html";
            $scope.groupData = $scope.groups[$scope.groupIndex];

            //usado en uploadCtrl
            $scope.groupData.groupIndex = $scope.activeIndex;

            $scope.showStatementButton = permissions.canCreateStatementPostInGroupTimeline();
            GroupFactory.setCurrentGroupIndex($scope.activeIndex)
          }

          //console.log("updating your role/permissions...")
          AppAdminRolesService.updateLocalUserPermissions();

          //console.log("$ionicSlides.slideChangeEnd", UserService.get_USER_INSTANCE_HREF())
          //avoid count new notifications before entering to notifications view
          notificationsService.countPendingRegularNotifications(UserService.get_USER_INSTANCE_HREF());
          notificationsService.countPendingFollowersNotifications(UserService.get_USER_INSTANCE_HREF());

          $scope.$apply();

        });
      }

      $scope.gotoSlide = function (number) {
        $scope.closePopover();

        if (number > 0)
          $scope.groupData = GroupFactory.getCurrentAvailableUserGroupsList()[number - 1];

        $scope.slider.slideTo(number);
      };


      if (sliderIndex === 0) {//You want to go directly to default timeline?
        $scope.slideTemplate = "templates/Timelines/timeline.html";
        $scope.showStatementButton = permissions.canCreateStatementPostInGralTimeline();
        $scope.groupIndex = -1;
        setupSlider(true/*check For Groups Changes*/);
      }
      else {
        console.log("Index", $state.params.groupIndex, $scope.activeIndex);
        $scope.groups = GroupFactory.getCurrentAvailableUserGroupsList();
        $scope.totalGroups = $scope.groups.length;

        $scope.groupIndex = ($state.params.groupIndex || $scope.activeIndex) - 1;
        $scope.groupData = $scope.groups[$scope.groupIndex];
        $scope.groupData.groupIndex = $scope.activeIndex;

        $scope.slideTemplate = "templates/Timelines/group-timeline.html";
        $scope.showStatementButton = permissions.canCreateStatementPostInGroupTimeline();

        setupSlider();
      }

      function openComposerScreen() {
        var dialog = Utils.alert.getCtrl();
        dialog.show({
          templateUrl: 'templates/partials/tags-modal.html',
          controller: 'tagsModalCtrl',
          fullscreen: true,
          locals: {description: "", plusLength: true, dialog: dialog, needSearch: true},
          clickOutsideToClose: false,
          multiple: true
        }).then(function (form) {
          openStatementForm(form);
        });
      }

      function openStatementForm(form) {
        var dialog = Utils.alert.getCtrl();
        dialog.show({
          controller: "statementCtrl",
          templateUrl: 'templates/Uploads/statementTpl.html',
          //targetEvent: ev,
          clickOutsideToClose: false,
          fullscreen: true, // Only for -xs, -sm breakpoints.
          locals: {groupData: $scope.groupData, form: form, dialog: dialog},
          openFrom: '#right',
          multiple: true
        }).then(function () {
          $scope.statementBtnAction = 'open';
        }, function () {
          $scope.statementBtnAction = 'open';
        });

        $scope.statementBtnAction = 'close';
      }

      Utils.$ionicPopover.fromTemplateUrl(
        'templates/Timelines/timelines-container-popover.tpl.html', {
          scope: $scope
        }
      ).then(
        function (popover) {
          $scope.popover = popover;

          //Cleanup the popover when we're done with it!
          $scope.$on('$destroy', function () {
            $scope.popover.remove();
          });
        },
        function (error) {
          console.error("Popover couldn't be created", error);
          Utils.toast.warning("Popover couldn't be created");
        }
      );

      $scope.closePopover = function () {
        $scope.popover.hide();
        Utils.$ionicScrollDelegate.scrollTop();
      };


      function checkForGroupsChanges() {
        //console.log("Checking for groups changes...");
        //$scope.groups = GroupFactory.getCurrentAvailableUserGroupsList();

        $scope.isLoadingGroups = true;

        GroupFactory.loadAvailableUserGroups({
          userSubscriptionHref: UserService.get_USER_INSTANCE_HREF()
        }).then(function (myNewerGroups) {
          var newerGroupsLen = $scope.totalGroups = myNewerGroups.length;

          if (newerGroupsLen > (window.localStorage.getItem('totalGroups') || 0))
            Utils.toast.info(Utils.translate("GROUPS.MAIN_PAGE.DIALOG.NEW_GROUPS_DETECTED"));

          window.localStorage.setItem("totalGroups", newerGroupsLen.toString());

          /*
          * CASES where lengths are:
          * 1) if(newer <> older):
          *      if(want to view 0): set older = newer and return
          *
          * 2) if(newer <> || == older):
          *     try to find the current group in newer list
          *     if(is not in list): set older = newer & redirect to 0
          *     else: check if is at same index
          *       if(is at same index):
          *         if(differenfces found)
          *           set older = newer
          *       else: set data accordingly
          * */

          if (newerGroupsLen !== $scope.groups.length) {
            if ($scope.activeIndex === 0) {
              $scope.groups = myNewerGroups;
              $scope.isLoadingGroups = false;
              return;
            }
          }

          if ($scope.activeIndex === 0) {
            //we need to check if some groups were deleted
            if (findDifferencesIngroupsList($scope.groups, myNewerGroups)) {
              $scope.groups = myNewerGroups;
            }
            $scope.isLoadingGroups = false;
            return;
          }

          var foundAt = findGroupInList($scope.groupData.id, myNewerGroups);
          if (foundAt === -1) {
            $scope.gotoSlide(0);
            $scope.groups = myNewerGroups;
          }
          else {//the group is in the newer list
            //at the same index
            if (foundAt === $scope.groupIndex) {
              //we need to check if some groups were deleted
              if (findDifferencesIngroupsList($scope.groups, myNewerGroups)) {
                $scope.groups = myNewerGroups;
              }
            }
            else {//the group is in the newer list but at different index
              console.warn("Current group found at different index");
              $scope.groups = myNewerGroups;
              sliderIndex = foundAt + 1;
              $scope.groupIndex = foundAt;
              Utils.$timeout(function () {
                $scope.$apply();
              });
            }
          }

          $scope.isLoadingGroups = false;
        }, function (error) {
          console.error("getUserGroups", error);
          $scope.isLoadingGroups = false;
        });
      }

      /**
       * @param groupId {number}
       * @param myNewerGroups {Array}
       * @return {number} - if found: >= 0 else: -1
       */
      function findGroupInList(groupId, myNewerGroups) {
        var foundAt = -1;
        myNewerGroups.some(function (myNewerGroup, idx) {
          if (myNewerGroup.id === groupId) {
            return foundAt = idx;
          }
        });

        return foundAt;
      }

      /**
       * @param list1 {Array}
       * @param list2 {Array}
       * @return {boolean}
       */
      function findDifferencesIngroupsList(list1, list2) {
        return list1.some(function (groupL1) {
          var found = list2.some(function (groupL2) {
            return groupL2.id === groupL1.id;
          });
          return !found;
        });
      }

      // ------------------------- PERMISSIONS VALIDATION SECTION ---------------------------
      $scope.$_canManageGroupMembers = function () {
        return UserService.USER_IS_SUPERADMIN() || permissions.canManageGroupMembers();
      };

      $scope.$_canViewGroupInfo = function () {
        return UserService.USER_IS_SUPERADMIN() || permissions.canViewGroupInfo();
      };

      // ------------------------- EVENTS ------------------------
      var unsubscribesrList = [];
      $scope.$on('$ionicView.beforeEnter', function () {
        console.log("TRIGGER CREATE EVENTS", unsubscribesrList)
        unsubscribesrList[0] = $rootScope.$on('groups.mine.reload', function (event, group) {
          loadUserGroups();
        });

        unsubscribesrList[1] = $rootScope.$on("gotoSlide", function (ev, data) {
          $scope.gotoSlide(data.slide)
        });

        unsubscribesrList[2] = $rootScope.$on('refresh-timeline-order', function (/*event, data*/) {
          $scope.order = parseInt(window.localStorage.getItem("timelineOrder")) || 1;
        });

        unsubscribesrList[3] = $rootScope.$on("rolePermissions-changed", function () {
          if ($scope.isGroupTimeline)
            $scope.showStatementButton = permissions.canCreateStatementPostInGroupTimeline();
          else
            $scope.showStatementButton = permissions.canCreateStatementPostInGralTimeline();
        });

        unsubscribesrList[4] = $rootScope.$on("groups.mine.reload", function () {
          Utils.$timeout(function () {
            if ($scope.isGroupTimeline) {
              $scope.groupData = GroupFactory.getCurrentAvailableUserGroupsList()[$scope.groupIndex];
            }
          }, 800);
        });

        unsubscribesrList[5] = $rootScope.$on("openStatementForm", function (ev, data) {
          console.log("openning statement form...");
          $scope.openStatementForm();
        });

        if ($state.params.prepareStatement == 1)
          $scope.openStatementForm();

        /**@type {string|number}*/
        $scope.statementBtnAction = $state.params.prepareStatement == 1 ? "close" : "open";

        if (isFirstime) {
          isFirstime = false;
          return;
        }

        checkForGroupsChanges();
      });
      
      $rootScope.$on('$stateChangeStart', function(event, toState, toParams, fromState, fromParams, options) {
          console.log("CHANGING VIEW");
          $rootScope.$on('$destroy', unsubscribesrList[5]);
          unsubscribesrList.forEach(function (unsubscribe, idx) {
            if (typeof unsubscribe === 'function') {
              unsubscribe();
              unsubscribesrList[idx] = undefined;
            }
          });
      });


      //this is triggered only when user leaves the timelines
      // NOT when changing between default/groups timeline
      $scope.$on('$ionicView.beforeLeave', function () {
        console.log('$ionicView.beforeLeave');
        $rootScope.$on('$destroy', unsubscribesrList[5]);
        unsubscribesrList.forEach(function (unsubscribe, idx) {
          if (typeof unsubscribe === 'function') {
            unsubscribe();
            unsubscribesrList[idx] = undefined;
          }
        });
      });
      
      function getGroupIndex() {
        return GroupFactory.getCurrentGroupIndex();
      }
      
      $scope.areInGroup = false;
      $scope.chkStateGroup = function () {
          var groupIndexIn = getGroupIndex();
          console.log("GROUP: ", groupIndexIn);
          if(groupIndexIn > 0) {
              $scope.areInGroup = true;
          } else {
              $scope.areInGroup = false
          }
      }
      $scope.chkStateGroup();
      
    }])

  .controller('TimeLineCtrl', ['$rootScope', '$scope', '$state', 'TimeLineService', 'timelinesService', 'UserService', 'SequenceService', 'GroupsService', 'GroupFactory', 'cqnzService', 'cqnzData', 'permissionValidationService', 'notificationsService', 'adsService', 'SequenceFactory', 'Utils',
    function ($rootScope, $scope, $state, TimeLineService, timelinesService, UserService, SequenceService, GroupsService, GroupFactory, cqnzService, cqnzData, permissionValidationService, notificationsService, adsService, SequenceFactory, Utils) {
      console.log("---------- TimeLineCtrl created!!!");
      //console.log($state.params);
      var permissions = permissionValidationService;
      var myUserId = UserService.get_USERSUBSCRIPTIONINSTANCE_ID();
      //$scope.iAmAdvertiser = UserService.USER_IS_ADVERTISER();
      $scope.iAmAdvertiser = permissions.canAdvertisementPermit();

      //-- All scope variables are shared with SequenceCtrl but these are the more relevant ones--------
      $scope._controllerName = 'TimeLineCtrl';
      $scope._groupHrefId = 0;//Default timeline
      $scope._totalPinnedSequences = 0;
      $scope._maxSequencesToPin = 1;
      $scope._sequenceList = [];

      //for showing the avatar in comments list
      //$scope.showCommentAvatar = false;
      //-------- END OF variables will be shared with SequenceCtrl -----


      var pagination = {
        start: 0,
        count: 3,
        order: parseInt(window.localStorage.getItem("timelineOrder")) || 1,
        reset: function () {
          this.start = 0;
          this.count = 3;
        },
        increaseCount: function (step) {
          this.count = 3
        }
      };

      var pinnedSequenceFetched = false;

      $scope.isFirstTime = true;
      $scope.isRefreshing = false;
      $scope.isLoadingContent = false;
      $scope.canGetMoreItems = true;
      $scope.errorLoading = false;

      //function appended to parent's defaultTimelineSharedCtrl object
      //so that it can be executed remotelly (from timelinesContainerCtrl)
      $scope.defaultTimelineSharedCtrl.organize = function (order) {
        pagination.order = order;
        $scope.refreshDefaultTimeline(true);
      };

      $scope.getMoreDefaultSequences = function () {
        !pinnedSequenceFetched ? getPinnedSequence() : getMoreDefaultSequences();
      };

      function getPinnedSequence() {
        if ($scope.isLoadingContent) return;

        $scope.isLoadingContent = true;
        $scope._totalPinnedSequences = 0;
        $scope.pinnedSequenceLoaded = false;

        cqnzService.getPinnedSequencesWS().then(function (cqnzPinnedResp) {
          Utils.removeLastItemIfHasNoAttribute(cqnzPinnedResp, 'sequenceId');
          //console.log("findPinnedSequenceWS", cqnzPinnedResp);

          $scope._totalPinnedSequences = cqnzPinnedResp.length;
          //console.log("total pinned: " + $scope._totalPinnedSequences);

          if ($scope._totalPinnedSequences) {
            var pinnedPromises = [];
            cqnzPinnedResp.forEach(function (sequence) {
              pinnedPromises.push(complementUserCqnzData(-1, false, false, sequence));
            });

            Utils.$q.all(pinnedPromises).then(function () {
              //nothing to do
            }, function (errors) {
              console.error("complementUserCqnzData (pinned) promises", errors);
            }).finally(function () {
              $scope.isLoadingContent = false;
              $scope.pinnedSequenceLoaded = true;
              //console.log("now we're getting the rest of cqnz's");
              getMoreDefaultSequences();
            });
          }
          else {
            $scope.isLoadingContent = false;
            $scope.pinnedSequenceLoaded = true;
            //console.log("now we're getting the rest of cqnz's");
            getMoreDefaultSequences();
          }
        }, function (findPinnedError) {
          $scope.isLoadingContent = false;
          $scope.pinnedSequenceLoaded = true;

          console.error("we couldn't get the pinned cqnz", findPinnedError);
          //console.log("now we're getting the rest of cqnz's");
          getMoreDefaultSequences();
        });
        pinnedSequenceFetched = true;
      }

      $scope.regularSequenceLoaded = false;

      function getMoreDefaultSequences() {
        if ($scope.isLoadingContent) return;

        $scope.isLoadingContent = true;

        //console.log("Start: ", new Date().getTime())
        //console.log("------ isLoading default sequences...", pagination);
        TimeLineService.findPendingLogByUserSubscription(
          myUserId,
          pagination
        ).then(function (sequences) {
          //console.log("findPendingLogByUserSubscription",sequences);//response: [] |[*]
          var totalRetrieved = sequences.length;
          $scope.canGetMoreItems = totalRetrieved >= pagination.count;

          if (!$scope.isFirstTime) {
            notificationsService.countPendingRegularNotifications(UserService.get_USER_INSTANCE_HREF());
            notificationsService.countPendingFollowersNotifications(UserService.get_USER_INSTANCE_HREF());
          }

          $scope.isFirstTime = false;

          if (!totalRetrieved) {
            //console.log("-------- totalRetrieved == 0")
            $scope.isRefreshing = false;
            $scope.isLoadingContent = false;
            $scope.regularSequenceLoaded = true;

            $scope.$broadcast('scroll.refreshComplete');
            $scope.$broadcast('scroll.infiniteScrollComplete');
            return;
          }

          pagination.start += totalRetrieved;

          pagination.increaseCount();

          recursiveLoading(sequences, 0).then(function () {

          }, function (error) {
            //Utils.toast.error("An error occurred, pull to refresh to try again", error);
            $scope.errorLoading = true;
            $scope.canGetMoreItems = false;
          }).finally(function () {
            $scope.isRefreshing = false;
            $scope.isLoadingContent = false;
            $scope.regularSequenceLoaded = true;

            $scope.$broadcast('scroll.refreshComplete');
            $scope.$broadcast('scroll.infiniteScrollComplete');
            //console.log("End: ", new Date().getTime())
          });
        }, function (error) {
          console.log("findPendingLogByUserSubscription error", error);
          $scope.errorLoading = true;
          $scope.canGetMoreItems = false;
          $scope.regularSequenceLoaded = true;

          $scope.isRefreshing = false;
          $scope.isLoadingContent = false;

          $scope.$broadcast('scroll.refreshComplete');
          $scope.$broadcast('scroll.infiniteScrollComplete');
        });
      }

      function recursiveLoading(sequences, idx) {
        var recommended = {
          id: sequences[idx].groupId,
          name: sequences[idx].groupName,
          is: sequences[idx].recommended
        }
        return complementUserCqnzData(sequences[idx].logItemId, sequences[idx].suggestedPost, recommended).then(function () {
          idx++;
          if (idx < sequences.length)
            return Utils.$q.resolve(recursiveLoading(sequences, idx));
          else
            return Utils.$q.resolve(true)
        }, function (error) {
          return Utils.$q.reject(error)
        })
      }

      //----------------- START CODE TO INCREASE AN AD VIEWS COUNTER ------------
      var adsNotViewed = [], scrollableContainer;

      var interval1 = setInterval(function () {
        scrollableContainer = document.getElementById('ion-content-userTimeline');

        if (scrollableContainer) {
          clearInterval(interval1);
          //console.info("TimeLineCtrl->scrollableContainer.removeEventListener('scroll') has been created!")
          scrollableContainer.addEventListener('scroll', increaseAdViewsCounter);
        }
      }, 200);

      function increaseAdViewsCounter() {
        adsNotViewed.forEach(function (item, idx) {
          var rect = item.el.getBoundingClientRect();
          if (rect.top <= (scrollableContainer.clientHeight / 3) * 2) {
            if (!item.sequence.adSeen) {
              //console.log("increasing ad views");
              item.sequence.adSeen = true;
              adsService.increaseViewsCount(item.sequence.metadata.instanceId).then(function (/*uselessData*/) {
                adsNotViewed.splice(idx, 1);
                /*if (item.sequence.metadata.belongsMe) {//if I can see the counters
                  $scope._sequenceList[item.listIndex].advertisement.counters.views ?
                    $scope._sequenceList[item.listIndex].advertisement.counters.views.result.value++ :
                    $scope._sequenceList[item.listIndex].advertisement.counters.views = {result: {value: 1}};
                }*/
              }, function (error) {
                console.error("increaseViewsCount", error)
              });
            }
          }
        })
      }

      $scope.$on('$destroy', function () {
        //console.info("------ TimeLineCtrl has been destroyed");
        if (scrollableContainer && scrollableContainer.removeEventListener)
          scrollableContainer.removeEventListener('scroll', increaseAdViewsCounter)

        $scope.$broadcast('scroll.refreshComplete');
        $scope.$broadcast('scroll.infiniteScrollComplete');
      });
      //----------------- END OF CODE TO INCREASE AN AD VIEWS COUNTER ------------


      //var totalSize = 0;
      var timelineLen = 0;

      /**
       * @param cqnzId {number}
       * @param {*?} pinnedSeqObj
       * @return {Promise}
       */
      function complementUserCqnzData(cqnzId, suggested, groupRecom, pinnedSeqObj) {
        var deferred = Utils.$q.defer();

        if (pinnedSeqObj)
          cqnzId = pinnedSeqObj.sequenceId;

        var data = !pinnedSeqObj ? SequenceService.findSequenceBySequenceIdV181(cqnzId).$promise : pinnedSeqObj;

        //count the num of comments available in each of my groups
        var commentsCounts = cqnzService.countSequenceCommentsByGroupWS({
          sequenceId: cqnzId,
          groupId: $scope._groupHrefId
        }).$promise;

        /*var comments = cqnzService.getCommentsOfSequenceWS({
          sequenceId: cqnzId,
          start: 0,
          count: 2
        }).$promise;*/

        var listTags = SequenceService.obtainTagwithIdandTypev166({
          sequenceId: cqnzId,
          notificationType: 7
        });

        //LuMa HashTags in sequence
        //var hashesList = SequenceService.getHashFromSequence(cqnzId);
        var hashesList = SequenceService.findSequenceHashTagComment({
            sequenceId: cqnzId,
            notificationType: 7,
            commentId: 0
          });

        Utils.$q.all({
          basicData: data,
          commentsCounts: commentsCounts,
          tagsList: listTags,
          hashesList: hashesList,
          suggestedPost: suggested,
          recommendedPost: groupRecom
        }).then(function (userCqnz) {
          //console.log("basicData", userCqnz.basicData);
          //console.log("comments to create:", comments);
          //if(userCqnz.basicData.mustBeDeleted == true){
          //  console.log("mustBeDeleted");
          //} else {
          if (!pinnedSeqObj) {
            Utils.removeLastItemIfHasNoAttribute(userCqnz.basicData, 'sequence');
            userCqnz.basicData = userCqnz.basicData[0];
          }

          //console.log("data.sequenceItems",data.sequenceItems)
          userCqnz.sequenceOwnerId = Utils.getLastUrlComponent(userCqnz.basicData.userSubscriptionId.href);
          userCqnz.sequenceItems = cqnzService.getItemsToSequenceV165WS(cqnzId);
          userCqnz.likeActive = SequenceService.findSmileysCount({
            sequenceId: Utils.getLastUrlComponent(userCqnz.basicData.sequence.href),
            userId: myUserId
          });
          userCqnz.followEachOther = myUserId == userCqnz.sequenceOwnerId ? {result: {value: true}} : SequenceService.followEachOther({
            userId: myUserId,
            friendId: userCqnz.sequenceOwnerId
          });
          userCqnz.viewsCounter = userCqnz.basicData.isAdvertisement && userCqnz.sequenceOwnerId == myUserId ? adsService.getViewsCount(cqnzId) : null;
          userCqnz.clicksCounter = userCqnz.basicData.isAdvertisement && userCqnz.sequenceOwnerId == myUserId ? adsService.getClicksCount(cqnzId) : null;
          userCqnz.URLClicksCounter = userCqnz.basicData.isAdvertisement && userCqnz.sequenceOwnerId == myUserId ? adsService.getURLClicksCount(cqnzId) : null;

          userCqnz.basicData.sequenceCommentCount = userCqnz.commentsCounts.result.value;
          userCqnz.basicData.suggestedPost = userCqnz.suggestedPost;
          userCqnz.basicData.recommendedPost = userCqnz.recommendedPost;
          var commentsPromises = {};
          if (userCqnz.basicData.sequenceCommentCount) {
            //console.log("getting comments of (" + cqnzId + ", " + groupId + ")");
            commentsPromises[$scope._groupHrefId] = cqnzService.getCommentsOfSequenceWS({
              sequenceId: cqnzId,
              start: 0,
              count: 2,
              groupId: $scope._groupHrefId
            }).$promise
          }

          userCqnz.comments = [];
          Utils.$q.all(commentsPromises).then(function (resolvedComments) {
            Object.keys(resolvedComments).forEach(function (groupId) {
              Utils.removeLastItemIfHasNoAttribute(resolvedComments[groupId], 'commentId');
              if (resolvedComments[groupId].length) {
                resolvedComments[groupId].groupId = groupId;
                userCqnz.comments = userCqnz.comments.concat(resolvedComments[groupId]);
              }
            });
            //console.log('hashCqnz.comments', hashCqnz.comments);

            //the pinned seqs will be pushed in the begining
            var realLen = pinnedSeqObj ? $scope._sequenceList.unshift(SequenceFactory.buildSequenceObject(userCqnz)) :
              $scope._sequenceList.push(SequenceFactory.buildSequenceObject(userCqnz));

            /*//test for  optimizing the timeline
            if (realLen > 15) {
              pinnedSeqObj ? $scope._sequenceList.splice(1, 1) : $scope._sequenceList.shift();
              realLen--;
            }

            console.log("timeline len: "+realLen);*/

            if (!userCqnz.basicData.pinned) timelineLen++;

            //if (!userCqnz.basicData.pinned && !UserService.USER_IS_ADVERTISER() && adsService.canInsertAd(timelineLen, pagination.count)) {
            //if (!userCqnz.basicData.pinned && !permissions.canAdvertisementPermit() && adsService.canInsertAd(timelineLen, pagination.count)) {  
            if (!userCqnz.basicData.pinned && adsService.canInsertAd(timelineLen, pagination.count)) {  
              console.log("inserting ad at " + timelineLen, realLen);
              adsService.getAdvertisement(UserService.get_USER_INSTANCE_HREF()).then(function (advertisementData) {
                //console.log("getAdv", advertisementData);
                if (advertisementData) {
                  $scope._sequenceList.splice(realLen - 1, 0, advertisementData);
                  var interval2 = setInterval(function () {
                    var el = document.getElementById($scope._controllerName + '_Ad_' + (realLen - 1));
                    if (el) {
                      clearInterval(interval2);
                      //console.log("userCqnz",userCqnz)
                      adsNotViewed.push({sequence: advertisementData, listIndex: realLen - 1, el: el});
                    }
                    /*else
                      console.warn("The ad '" + ($scope._controllerName + '_Ad_' + (realLen - 1)) + "' container was not found")*/
                  }, 500);
                }
              }, function (getAdError) {
                console.error("Couldn't get advertisement", getAdError)
              });
            }

            /*var s = Utils.sizeof($scope._sequenceList[data.index]);
            console.log("size of userCqnz: "+Utils.formatByteSize(s));
            console.log("timeline size: "+Utils.formatByteSize(totalSize+=s))*/
            deferred.resolve(true);
            /*if (!pinnedSeqObj)
              console.log("partial: ", new Date().getTime())*/
          }, function (errors) {
            console.error("$q.all(commentsPromises)", errors);
            //the pinned seqs will be pushed in the begining
            var realLen = pinnedSeqObj ? $scope._sequenceList.unshift(SequenceFactory.buildSequenceObject(userCqnz)) :
              $scope._sequenceList.push(SequenceFactory.buildSequenceObject(userCqnz));

            if (!userCqnz.basicData.pinned) timelineLen++;

            //if (!userCqnz.basicData.pinned && !UserService.USER_IS_ADVERTISER() && adsService.canInsertAd(timelineLen, pagination.count)) {
            //if (!userCqnz.basicData.pinned && !permissions.canAdvertisementPermit() && adsService.canInsertAd(timelineLen, pagination.count)) {              
            if (!userCqnz.basicData.pinned && adsService.canInsertAd(timelineLen, pagination.count)) {              
              console.log("inserting ad at " + timelineLen, realLen);
              adsService.getAdvertisement(UserService.get_USER_INSTANCE_HREF()).then(function (advertisementData) {
                //console.log("getAdv", advertisementData);
                if (advertisementData) {
                  $scope._sequenceList.splice(realLen - 1, 0, advertisementData);
                  var interval2 = setInterval(function () {
                    var el = document.getElementById($scope._controllerName + '_Ad_' + (realLen - 1));
                    if (el) {
                      clearInterval(interval2);
                      //console.log("userCqnz",userCqnz)
                      adsNotViewed.push({sequence: advertisementData, listIndex: realLen - 1, el: el});
                    }
                    else
                      console.warn("The ad '" + ($scope._controllerName + '_Ad_' + (realLen - 1)) + "' container was not found")
                  }, 500);
                }
              }, function (getAdError) {
                console.error("Couldn't get advertisement", getAdError)
              });
            }

            /*var s = Utils.sizeof($scope._sequenceList[data.index]);
            console.log("size of userCqnz: "+Utils.formatByteSize(s));
            console.log("timeline size: "+Utils.formatByteSize(totalSize+=s))*/
            deferred.resolve(true);
          });
        }, function (errors) {
          console.error("complementUserCqnzData", errors);
          deferred.reject(errors);
        });//end $q.all(data, comments, listTags, hashesList)

        return deferred.promise;
      }

      timelinesService.defaultTimeline.events.timeline.refresh =
        $scope.refreshDefaultTimeline = function (x) {
          if (!x || $scope.isRefreshing || $scope.isLoadingContent) return;//for some reason it gets triggered the first time with x = undefined :(
          //console.log("--------- On refreshDefaultTimeline");
          $scope._sequenceList = [];
          pinnedSequenceFetched = false;

          $scope.pinnedSequenceLoaded = false;
          $scope.regularSequenceLoaded = false;
          $scope.canGetMoreItems = true;
          $scope.errorLoading = false;
          $scope.isRefreshing = true;
          $scope.isFirstTime = true;

          pagination.reset();

          setTimeout(function () {
            Utils.$ionicScrollDelegate.resize();
            $scope.isLoadingContent = false;
            $scope.getMoreDefaultSequences();
          }, 800);

          notificationsService.countPendingRegularNotifications(UserService.get_USER_INSTANCE_HREF());
          notificationsService.countPendingFollowersNotifications(UserService.get_USER_INSTANCE_HREF());
        };

      timelinesService.defaultTimeline.events.sequence.onDelete = function (data) {
        console.log("defaultTimeline.events.sequence.onDelete", data);
        $scope._sequenceList.some(function (sequence, index) {
          if (sequence.metadata.id == data.sequenceMetadata.id) {
            $scope._sequenceList.splice(index, 1);
            pagination.count = 5;
            //pagination.start--;
            $scope.getMoreDefaultSequences();
            //pagination.count = 5;

            return true;
          }
        });
      };

      timelinesService.defaultTimeline.events.sequence.onTitleEdited = function (data) {
        console.log("Ctrl name: defaultTimeline");
        $scope._sequenceList.some(function (sequence) {
          if (sequence.metadata.id == data.sequenceId) {
            data.updaterFn(sequence, data);
            return true;
          }
        })
      };

      timelinesService.defaultTimeline.events.sequence.onContentEdited = function (data) {
        $scope.refreshDefaultTimeline(true);
      };

      timelinesService.defaultTimeline.events.sequence.onShareableUpdated = function (data) {
        $scope._sequenceList.some(function (sequence) {
          if (sequence.metadata.id == data.sequenceMetadata.id) {
            sequence.share.enabled = data.enabled;
            return true;
          }
        });
      };

      timelinesService.defaultTimeline.events.sequence.onCountersUpdated = function (newData) {
        $scope._sequenceList.some(function (sequence) {
          if (sequence.metadata.id == newData.sequenceMetadata.id) {
            newData.updaterFn(sequence, newData);
            return true;
          }
        })
      };

      timelinesService.defaultTimeline.events.comment.onEnabledUpdated = function (data) {
        $scope._sequenceList.some(function (sequence) {
          if (sequence.metadata.id == data.sequenceMetadata.id) {
            sequence.comments.enabled = data.enabled;
            return true;
          }
        });
      };

      timelinesService.defaultTimeline.events.comment.onCreate = function (data) {
        console.log("defaultTimeline.events.comment.onCreate", data);
        $scope._sequenceList.some(function (sequence) {
          if (sequence.metadata.id != data.comment.sequenceMetadata.id) return false;//<- continue in this context

          console.log("sequence found");
          sequence.comments.counter++;
          if (!data.comment.isReply) {
            //show only 2 comments for each sequence
            if (sequence.comments.items.length > 1) return true;

            console.log("Inserting regular comment");
            var len = sequence.comments.items.push({});
            setTimeout(function () {
              sequence.comments.items[len - 1] = data.comment;
            }, 800);
          }
          else {//it's a reply comment
            sequence.comments.items.some(function (parentComment) {
              if (parentComment.metadata.id != data.comment.metadata.parentCommentId) return false;//<- continue in this context

              console.log("parent comment found");
              //if (parentComment.responses.length) return true;//show only 1 reply for each parent comment
              parentComment.isReplying = true;

              console.log("Inserting reply");
              parentComment.responses.push(data.comment);
              Utils.$timeout(function () {
                parentComment.isReplying = false;
              }, 800);
              return true;//stop searching parent comments
            })
          }
          return true;//stop searching sequences
        })
      };

      timelinesService.defaultTimeline.events.comment.onUpdate = function (data) {
        console.log("defaultTimeline.events.comment.onUpdate", data);
        $scope._sequenceList.some(function (sequence, sIdx) {
          if (sequence.metadata.id != data.comment.sequenceMetadata.id) return false;//<- continue in this context

          //console.log("sequence found");
          var commentIdToFind = data.comment.isReply ? data.comment.metadata.parentCommentId : data.comment.metadata.id;
          sequence.comments.items.some(function (comment, cIdx) {
            if (comment.metadata.id != commentIdToFind) return false;//<- continue in this context

            if (!data.comment.isReply) {
              //console.log("single comment found");
              sequence.comments.items[cIdx] = {};
              setTimeout(function () {
                sequence.comments.items[cIdx] = data.comment;
              }, 800);
            }
            else {
              //console.log("parent comment found");
              comment.responses.some(function (reply, rIdx) {
                if (reply.metadata.id != data.comment.metadata.id) return false;//<- continue in this context

                //console.log("child (reply) comment found");
                sequence.comments.items[cIdx].responses[rIdx] = data.comment;
                return true;//stop searching child (replies) comments
              });
            }
            return true;//stop searching single/parent comments
          });
          return true;//stop searching sequences
        });
      };

      /**
       * @param data {{cqnzListIndex:number,commentListIndex:number, cqnzInstanceId:number}}
       */
      timelinesService.defaultTimeline.events.comment.onDelete = function (data) {
        console.log("defaultTimeline.events.comment.onDelete", data);
        $scope._sequenceList.some(function (sequence) {
          if (sequence.metadata.id != data.comment.sequenceMetadata.id) return false;//<- continue in this context

          //console.log("sequence found");
          sequence.comments.counter--;

          var commentIdToFind = data.comment.isReply ? data.comment.metadata.parentCommentId : data.comment.metadata.id;
          sequence.comments.items.some(function (comment, cIdx) {
            if (comment.metadata.id != commentIdToFind) return false;//<- continue in this context

            if (!data.comment.isReply) {
              console.log("comment found");
              sequence.comments.items.splice(cIdx, 1);
              sequence.comments.counter -= data.childrenDeleted;
              console.log("Counter: " + sequence.comments.counter);
            }
            else {
              console.log("parent comment found");
              comment.responses.some(function (reply, rIdx) {
                if (reply.metadata.id != data.comment.metadata.id) return false;//<- continue in this context

                console.log("reply found");
                comment.responses.splice(rIdx, 1);
                return true;//stop searching child (replies) comments
              });
            }
            return true;//stop searching single/parent comments
          });
          return true;//stop searching sequences
        });
      };

      timelinesService.defaultTimeline.events.comment.onLikeUpdated = function (data) {
        console.log('defaultTimeline.events.comment.onLikeUpdated', data);
        $scope._sequenceList.some(function (sequence) {
          if (sequence.metadata.id != data.comment.sequenceMetadata.id) return false;//<- continue in this context

          //console.log("sequence found");
          var commentIdToFind = data.comment.isReply ? data.comment.metadata.parentCommentId : data.comment.metadata.id;
          sequence.comments.items.some(function (comment) {
            if (comment.metadata.id != commentIdToFind) return false;//<- continue in this context

            if (!data.comment.isReply) {
              //console.log("single comment found");
              setTimeout(function () {
                comment.likeCounter = data.likeCounter;
                comment.likeActive = data.likeActive;
              }, 800);
            }
            else {
              //console.log("parent comment found");
              comment.responses.some(function (reply, rIdx) {
                if (reply.metadata.id != data.comment.metadata.id) return false;//<- continue in this context

                //console.log("child (reply) comment found");
                setTimeout(function () {
                  comment.responses[rIdx].likeCounter = data.likeCounter;
                  comment.responses[rIdx].likeActive = data.likeActive;
                }, 800);
                return true;//stop searching child (replies) comments
              });
            }
            return true;//stop searching single/parent comments
          });
          return true;//stop searching sequences
        });
      };

      //ads can only be inserted in default timeline
      timelinesService.defaultTimeline.events.advertisement.onSettingsUpdated = function (data) {
        $scope._sequenceList.some(function (sequence, index) {
          if (sequence.metadata.id == data.sequence.metadata.id) {
            console.log("Updating advertisement settings");
            $scope._sequenceList[index] = data.sequence;
            setTimeout(function () {
              $scope.$apply();
            }, 10);
            return true;
          }
        })
      };

      $rootScope.$on('login.success', function (event) {
        $scope.refreshDefaultTimeline(true);
      });

      if ($scope.isFirstTime) {
        $scope.getMoreDefaultSequences();
      }

      $scope.addCount = function () {
        console.log("Open browser222");
      }

      $rootScope.$on('openBrowser', function (event) {
        console.log("Open browser");
        $scope.addCount();
      })

    }])

  .controller("GroupTimeLineCtrl", ['$rootScope', '$scope', '$state', 'timelinesService', 'UserService', 'SequenceService', 'adsService', 'cqnzData', 'GroupsService', 'cqnzService', 'SequenceFactory', 'permissionValidationService', 'notificationsService', 'Utils',
    function ($rootScope, $scope, $state, timelinesService, UserService, SequenceService, adsService, cqnzData, GroupsService, cqnzService, SequenceFactory, permissionValidationService, notificationsService, Utils) {
      console.log("GroupTimeLineCtrl Created!");//, $state.params);
      var permissions = permissionValidationService;
      //$scope.iAmAdvertiser = UserService.USER_IS_ADVERTISER();
      $scope.iAmAdvertiser = permissions.canAdvertisementPermit();
      /**
       * $scope.groupData is inherited from slidesCtrl
       * $state.params can be inherited from slidesCtrl or
       * passsed as parameter from groupMainPageCtrl->showPublicTimelinePreview()
       */
      if ($state.params.groupData) $scope.groupData = $state.params.groupData;

      //console.log($scope.groupData);

      if (!$scope.groupData || !$scope.groupData.hrefId) {
        $state.go("menu.timeline", {groupIndex: -1}, {reload: true});
        return;
      }

      var myUserId = UserService.get_USERSUBSCRIPTIONINSTANCE_ID();

      //------------ variables will be shared with SequenceCtrl --------
      $scope._controllerName = "GroupTimeLineCtrl";
      $scope._groupHrefId = $scope.groupData.hrefId;
      $scope._groupId = $scope.groupData.id;
      $scope._totalPinnedSequences = 0;
      $scope._maxSequencesToPin = 1;
      /** @type {SequenceType[]}*/
      $scope._sequenceList = [];
      //-------- END OF variables will be shared with SequenceCtrl -----

      $scope.groupName = $scope.groupData.name;
      $scope.groupDescription = $scope.groupData.description;
      $scope.groupImage = $scope.groupData.image;
      $scope.groupBackground = $scope.groupData.backgroundImage;
      $scope.previewTimeline = $scope.groupData.isPreview;

      var pagination = {
        start: 0,
        count: 3,
        reset: function () {
          this.start = 0;
          this.count = 3;
        },
        increaseCount: function (step) {
          this.count = 3
        }
      };

      var pinnedSequenceFetched = false;

      $scope.isFirstTime = true;
      $scope.isRefreshing = false;
      $scope.isLoadingContent = false;
      $scope.canGetMoreItems = true;
      $scope.errorLoading = false;
      $scope.specificText = '';
      $scope.specificSearchActive = false;
      $scope.data = {
        realText: null,
        realCity: null,
        realSection: null
      }

      //----------------- START CODE TO INCREASE AN AD VIEWS COUNTER ------------
      var adsNotViewed = [],
        scrollableContainer,
        findAdContainerInterval;

      var findTimelineContainerInterval = setInterval(function () {
        scrollableContainer = document.getElementById('ion-content-groupTimeline');

        if (scrollableContainer) {
          clearInterval(findTimelineContainerInterval);
          findTimelineContainerInterval = undefined;
          scrollableContainer.addEventListener('scroll', increaseAdViewsCounter);
        }
      }, 200);

      function increaseAdViewsCounter() {
        adsNotViewed.forEach(function (item, idx) {
          var rect = item.el.getBoundingClientRect();
          if (rect.top <= (scrollableContainer.clientHeight / 3) * 2) {
            if (!item.sequence.adSeen) {
              item.sequence.adSeen = true;
              //console.log("increasing ad views")
              adsService.increaseViewsCount(item.sequence.metadata.instanceId).then(function (/*uselessData*/) {
                adsNotViewed.splice(idx, 1);
                /*if (item.sequence.metadata.belongsMe) {//if I can see the counters
                  $scope._sequenceList[item.listIndex].advertisement.counters.views ?
                    $scope._sequenceList[item.listIndex].advertisement.counters.views.result.value++ :
                    $scope._sequenceList[item.listIndex].advertisement.counters.views = {result: {value: 1}};
                }*/
              }, function (error) {
                console.error("increaseViewsCount", error)
              });
            }
          }
        })
      }

      $scope.$on('$destroy', function () {
        //console.info("---- GroupTimeLineCtrl has been destroyed");
        if (scrollableContainer && scrollableContainer.removeEventListener)
          scrollableContainer.removeEventListener('scroll', increaseAdViewsCounter);

        $scope.$broadcast('scroll.refreshComplete');
        $scope.$broadcast('scroll.infiniteScrollComplete');

        /*if (findTimelineContainerInterval) {
          clearInterval(findTimelineContainerInterval);
          findTimelineContainerInterval = undefined;
        }

        if (findAdContainerInterval) {
          clearInterval(findAdContainerInterval);
          findAdContainerInterval = undefined;
        }*/
      });
      //----------------- END OF CODE TO INCREASE AN AD VIEWS COUNTER ------------

      //triggered from template: on-infinite
      $scope.getMoreGroupSequences = function () {
        $scope.data.realText = null;
        $scope.data.realCity = null;
        !pinnedSequenceFetched ? getGroupPinnedSequences() : getMoreGroupSequences();
      };

      function getGroupPinnedSequences() {
        if ($scope.isLoadingContent) return;

        $scope.isLoadingContent = true;
        $scope._totalPinnedSequences = 0;
        $scope.pinnedSequenceLoaded = false;

        cqnzService.getGroupPinnedSequencesWS($scope._groupId+"").then(function (cqnzPinnedResp) {
          Utils.removeLastItemIfHasNoAttribute(cqnzPinnedResp, 'sequenceId');
          //console.log("getPinnedGroupSequence", cqnzPinnedResp);
          //console.log("total pinned: " + cqnzPinnedResp.length);

          $scope._totalPinnedSequences = cqnzPinnedResp.length;

          if ($scope._totalPinnedSequences) {
            var pinnedPromises = [];
            cqnzPinnedResp.forEach(function (sequence) {
              pinnedPromises.push(complementGroupCqnzData(sequence, null, null, true));
            });

            Utils.$q.all(pinnedPromises).then(function () {
              //nothing to do
            }, function (errors) {
              console.error("complementGroupCqnzData (pinned) promises", errors)
            }).finally(function () {
              $scope.isLoadingContent = false;
              $scope.pinnedSequenceLoaded = true;
              //console.log("now we're getting the rest of cqnz's");
              if($scope.specificSearchActive)
                getSpecificSequences();
              else
                getMoreGroupSequences();
            });
          }
          else {
            $scope.isLoadingContent = false;
            $scope.pinnedSequenceLoaded = true;
            //console.log("now we're getting the rest of cqnz's");
            if($scope.specificSearchActive)
              getSpecificSequences();
            else
              getMoreGroupSequences();
          }
        }, function (findPinnedError) {
          $scope.isLoadingContent = false;
          $scope.pinnedSequenceLoaded = true;

          console.error("we couldn't get the pinned cqnz", findPinnedError);
          //console.log("now we're getting the rest of cqnz's");
          getMoreGroupSequences();
        });
        pinnedSequenceFetched = true;
      }

      //var totalSize = 0;
      $scope.regularSequenceLoaded = false;

      function getMoreGroupSequences() {
        if ($scope.isLoadingContent) return;

        $scope.isLoadingContent = true;
        $scope.specificSearchActive = false;
        GroupsService.getGroupSequences(
          $scope._groupId,
          pagination
        ).then(function (groupSequences) {
          //console.log("getting More Group Sequences: ", groupSequences);
          Utils.removeLastItemIfHasNoAttribute(groupSequences, 'sequence');

          //console.log("groupSequences",groupSequences);

          var fetchedCqnzsLength = groupSequences.length;

          $scope.canGetMoreItems = fetchedCqnzsLength >= pagination.count;

          if (!$scope.isFirstTime) {
            notificationsService.countPendingRegularNotifications(UserService.get_USER_INSTANCE_HREF());
            notificationsService.countPendingFollowersNotifications(UserService.get_USER_INSTANCE_HREF());
          }

          $scope.isFirstTime = false;

          if (!fetchedCqnzsLength) {
            $scope.isRefreshing = false;
            $scope.isLoadingContent = false;
            $scope.regularSequenceLoaded = true;

            $scope.$broadcast('scroll.refreshComplete');
            $scope.$broadcast('scroll.infiniteScrollComplete');
            return;
          }

          pagination.start += fetchedCqnzsLength;
          pagination.increaseCount();

          var cqnzPromises = [];
          groupSequences.forEach(function (fetchedCqnz) {
            var recommended = {
              id: $scope._groupId,
              name: $scope.groupDescription,
              is: fetchedCqnz.recommended
            }
            cqnzPromises.push(complementGroupCqnzData(fetchedCqnz, fetchedCqnz.suggestedPost, recommended, null));
            /*var s = Utils.sizeof($scope._sequenceList[idx]);
            console.log("size of sequence: " + Utils.formatByteSize(s));
            console.log("groupTimeline size: " + Utils.formatByteSize(totalSize += s))*/
          });

          Utils.$q.all(cqnzPromises).then(function () {
            $scope.isRefreshing = false;
            $scope.isLoadingContent = false;
            $scope.regularSequenceLoaded = true;

            $scope.$broadcast('scroll.refreshComplete');
            $scope.$broadcast('scroll.infiniteScrollComplete');
          }, function (errors) {
            console.error(errors);
            $scope.errorLoading = true;
            $scope.isRefreshing = false;
            $scope.canGetMoreItems = false;
            $scope.isLoadingContent = false;
            $scope.regularSequenceLoaded = true;

            $scope.$broadcast('scroll.refreshComplete');
            $scope.$broadcast('scroll.infiniteScrollComplete');
          })
        }, function (error) {
          console.error("can't getMoreGroupSequences: ", error);
          $scope.errorLoading = true;
          $scope.canGetMoreItems = false;
          $scope.regularSequenceLoaded = true;

          $scope.isRefreshing = false;
          $scope.isLoadingContent = false;

          $scope.$broadcast('scroll.refreshComplete');
          $scope.$broadcast('scroll.infiniteScrollComplete');
        });
      }

      //GET SPECIFIC TIMELINE CITY&TEXT || CIY || SEARCH BALA
        $scope.searchSectionEnabled = false;
        var pivot = JSON.parse(window.localStorage.getItem('AppsPerzonalized'));
        if(pivot.searchSection) {
          $scope.searchSectionEnabled = true;
        }
        $scope.getSpecificSequences = function (clickSearch) {
          $scope.specificSearchActive = true;
          pinnedSequenceFetched = false;
          getSpecificSequences(clickSearch);
        };

        $scope.getSectionSequences = function (clickSearch) {
          $scope.specificSearchActive = true;
          pinnedSequenceFetched = false;
          getSectionSequences(clickSearch);
        }

        function getSpecificSequences (clickSearch) {
          var txtSaved = "";
          var citySaved = "";
          if($scope.isLoadingContent) return;

          $scope.isLoadingContent = true;

          if(clickSearch) pagination.reset();

          if(clickSearch) $scope._sequenceList = [];

          if($scope.data.realCity === null) {
            citySaved = "true";
          } else {
            if($scope.data.realCity.idCity === 0)
              citySaved = "true";
            else
              citySaved = $scope.data.realCity.city;
          }
            

          if($scope.data.realText === '' || $scope.data.realText === null || $scope.data.realText === undefined)
            txtSaved = "true";
          else
            txtSaved = $scope.data.realText;
          
          GroupsService.getSpecificGroupSequences(
            $scope._groupId,
            pagination,
            citySaved,
            txtSaved
          ).then(function (groupSequences) {
            Utils.removeLastItemIfHasNoAttribute(groupSequences, 'sequence');
            var fetchedCqnzsLength = groupSequences.length;
            $scope.canGetMoreItems = fetchedCqnzsLength >= pagination.count;
            if (!$scope.isFirstTime) {
              notificationsService.countPendingRegularNotifications(UserService.get_USER_INSTANCE_HREF());
              notificationsService.countPendingFollowersNotifications(UserService.get_USER_INSTANCE_HREF());
            }
            $scope.isFirstTime = false;
            if (!fetchedCqnzsLength) {
              $scope.isRefreshing = false;
              $scope.isLoadingContent = false;
              $scope.regularSequenceLoaded = true;
              $scope.$broadcast('scroll.refreshComplete');
              $scope.$broadcast('scroll.infiniteScrollComplete');
              return;
            }
            pagination.start += fetchedCqnzsLength;
            pagination.increaseCount();
            var cqnzPromises = [];
            groupSequences.forEach(function (fetchedCqnz) {
              var recommended = {
                id: $scope._groupId,
                name: $scope.groupDescription,
                is: fetchedCqnz.recommended
              }
              cqnzPromises.push(complementGroupCqnzData(fetchedCqnz, fetchedCqnz.suggestedPost, recommended, null));
            });
            Utils.$q.all(cqnzPromises).then(function () {
              $scope.isRefreshing = false;
              $scope.isLoadingContent = false;
              $scope.regularSequenceLoaded = true;

              $scope.$broadcast('scroll.refreshComplete');
              $scope.$broadcast('scroll.infiniteScrollComplete');
            }, function (errors) {
              console.error(errors);
              $scope.errorLoading = true;
              $scope.isRefreshing = false;
              $scope.canGetMoreItems = false;
              $scope.isLoadingContent = false;
              $scope.regularSequenceLoaded = true;

              $scope.$broadcast('scroll.refreshComplete');
              $scope.$broadcast('scroll.infiniteScrollComplete');
            })
          }, function (error) {
            console.error("can't getMoreGroupSequences: ", error);
            $scope.errorLoading = true;
            $scope.canGetMoreItems = false;
            $scope.regularSequenceLoaded = true;

            $scope.isRefreshing = false;
            $scope.isLoadingContent = false;

            $scope.$broadcast('scroll.refreshComplete');
            $scope.$broadcast('scroll.infiniteScrollComplete');
          })
        }

        function getSectionSequences (clickSearch) {
          var txtSaved = "";
          var citySaved = "";
          if($scope.isLoadingContent) return;

          $scope.isLoadingContent = true;

          if(clickSearch) pagination.reset();

          if(clickSearch) $scope._sequenceList = [];

          //if($scope.data.realSection === null) {
            citySaved = "true";
          /*} else {
            if($scope.data.realSection.userSubscription.title === 0)
              citySaved = "true";
            else
              citySaved = $scope.data.realSection.description;
          }*/
            

          if($scope.data.realText === '' || $scope.data.realText === null || $scope.data.realText === undefined)
            txtSaved = "true";
          else
            txtSaved = $scope.data.realText;
          var realUser = null;
          if($scope.data.realSection === undefined || $scope.data.realSection === null)
              realUser = 0;
          else{
              if($scope.data.realSection.userSubscription) {
                  if($scope.data.realSection.userSubscription.title === undefined || $scope.data.realSection.userSubscription.title === null)
                      realUser = 0;
                  else
                      realUser = $scope.data.realSection.userSubscription.title;
              } else {
                  realUser = 0;
              }
              
          }
          
          GroupsService.getSectionGroupSequences(
            $scope._groupId,
            pagination,
            citySaved,
            txtSaved,
            realUser
          ).then(function (groupSequences) {
            Utils.removeLastItemIfHasNoAttribute(groupSequences, 'sequence');
            var fetchedCqnzsLength = groupSequences.length;
            $scope.canGetMoreItems = fetchedCqnzsLength >= pagination.count;
            if (!$scope.isFirstTime) {
              notificationsService.countPendingRegularNotifications(UserService.get_USER_INSTANCE_HREF());
              notificationsService.countPendingFollowersNotifications(UserService.get_USER_INSTANCE_HREF());
            }
            $scope.isFirstTime = false;
            if (!fetchedCqnzsLength) {
              $scope.isRefreshing = false;
              $scope.isLoadingContent = false;
              $scope.regularSequenceLoaded = true;
              $scope.$broadcast('scroll.refreshComplete');
              $scope.$broadcast('scroll.infiniteScrollComplete');
              return;
            }
            pagination.start += fetchedCqnzsLength;
            pagination.increaseCount();
            var cqnzPromises = [];
            groupSequences.forEach(function (fetchedCqnz) {
              var recommended = {
                id: $scope._groupId,
                name: $scope.groupDescription,
                is: fetchedCqnz.recommended
              }
              cqnzPromises.push(complementGroupCqnzData(fetchedCqnz, fetchedCqnz.suggestedPost, recommended, null));
            });
            Utils.$q.all(cqnzPromises).then(function () {
              $scope.isRefreshing = false;
              $scope.isLoadingContent = false;
              $scope.regularSequenceLoaded = true;

              $scope.$broadcast('scroll.refreshComplete');
              $scope.$broadcast('scroll.infiniteScrollComplete');
            }, function (errors) {
              console.error(errors);
              $scope.errorLoading = true;
              $scope.isRefreshing = false;
              $scope.canGetMoreItems = false;
              $scope.isLoadingContent = false;
              $scope.regularSequenceLoaded = true;

              $scope.$broadcast('scroll.refreshComplete');
              $scope.$broadcast('scroll.infiniteScrollComplete');
            })
          }, function (error) {
            console.error("can't getMoreGroupSequences: ", error);
            $scope.errorLoading = true;
            $scope.canGetMoreItems = false;
            $scope.regularSequenceLoaded = true;

            $scope.isRefreshing = false;
            $scope.isLoadingContent = false;

            $scope.$broadcast('scroll.refreshComplete');
            $scope.$broadcast('scroll.infiniteScrollComplete');
          })
        }

        $scope.loadMorePosts = function () {
          if($scope.specificSearchActive) {
            if($scope.searchSectionEnabled)
              $scope.getSectionSequences(false);
            else
              $scope.getSpecificSequences(false);
          } else {
            $scope.getMoreGroupSequences();
          }
        }

        $scope.isWriting = function (text) {
          console.log("text1: ", text);
          console.log("text scope: ", $scope.specificText);
        }

        $scope.searchFromCity = function (city) {
          $scope.data.realCity = city;
          $scope.getSpecificSequences(true);
        }

        $scope.searchFromSection = function (section) {
          $scope.data.realSection = section;
          $scope.getSectionSequences(true);
        }

        $scope.searchFromtext = function (text) {
          $scope.data.realText = text;
          if($scope.searchSectionEnabled) {
            $scope.getSectionSequences(true);
          } else {
            $scope.getSpecificSequences(true);
          }
          
        }
      //GET SPECIFIC TIMELINE CITY&TEXT || CIY || SEARCH END

      //INIT CITYS AVALIBLE FOR SEARCH BALA
        function initCitySearch() {
          UserService.getCities().$promise.then(function(resp) {
            Utils.removeLastItemIfHasNoAttribute(resp, 'idCity');
            resp.unshift({ idCity: 0, city: Utils.translate("SIGNUP.SELECT_CITY") });
            $scope.cities = resp;
            $scope.selectedCity = resp[0];
          })
        }
      //INIT CITYS AVALIBLE FOR SEARCH END
      //INIT SECTIONS AVALIBLE FOR SEARCH BALA
        $scope.sections = {};
        function initSectionSearch() {
          var data = {
            groupId: $scope._groupId,
          }
          UserService.getSections(
            data
          ).$promise.then(function(resp) {
            Utils.removeLastItemIfHasNoAttribute(resp, 'idCity');
            resp.unshift({ groupId: 0, name: Utils.translate("SIGNUP.SELECT_SECTION") });
            $scope.sections = resp;
            $scope.selectedSection = resp[0];
          }, function (err) {
            console.error("got: ", err);
          })
          /*var res = null;
          for(var i=0; i<=9; i++) {
            res = {
              idSection: i,
              section: i+"_"+i
            }
            $scope.sections.push(res);
          }
          $scope.selectedSection = $scope.sections[0];*/
        }
      //INIT SECTIONS AVALIBLE FOR SEARCH END
      //INIT SECTION TO DECIDE KIND OF SEARCH BALA
        function initKindofSeach() {
          if($scope.searchSectionEnabled) {
            initSectionSearch();
          } else {
            initCitySearch();
          }
        }
        initKindofSeach();
      //INIT SECTION TO DECIDE KIND OF SEARCH END
              
      //CHANGE VISUAL BUTTON BALA
        $scope.statusVisualChange = false;
        $scope.showAreaSearch=false;
        $scope.changeVisual = function () {
            if($scope.statusVisualChange){
                $scope.statusVisualChange = false;
                //document.getElementById("SearchDiv").classList.remove("GroupSearchOn");
                $scope.showAreaSearch=false;
                //document.getElementById("SearchDiv").classList.add("GroupSearchOff");
            } else{
                $scope.statusVisualChange = true;
                
                //document.getElementById("SearchDiv").classList.remove("GroupSearchOff");
                $scope.showAreaSearch=true;
                //document.getElementById("SearchDiv").classList.add("GroupSearchOn");
                setTimeout(function(){
                    document.getElementById("SearchInput").focus();
                },100)
            }
        }
      //CHANGE VISUAL BUTTON END
      

      var timelineLen = 0;

      /**
       * @param groupCqnzBasicData {*}
       * @param isPinnedCqnz? {boolean}
       */
      function complementGroupCqnzData(groupCqnzBasicData, suggested, groupRecom, isPinnedCqnz) {
        var deferred = Utils.$q.defer();
        groupCqnzBasicData.groupId = $scope._groupId;
        groupCqnzBasicData.groupName = $scope.groupName;
        var cqnzId = Utils.getLastUrlComponent(groupCqnzBasicData.sequence.href);
        //count the num of comments available in each of my groups
        var commentsCounts = cqnzService.countSequenceCommentsByGroupWS({
          sequenceId: groupCqnzBasicData.sequenceId,
          groupId: $scope._groupId 
        }).$promise;

        /*var comments = cqnzService.getCommentsOfSequenceWS({
          sequenceId: groupCqnzBasicData.sequenceId,
          //sequenceId: Utils.getLastUrlComponent(groupCqnzBasicData.sequence.href),
          start: 0,
          count: 2,
          groupId: $scope._groupHrefId
        }).$promise;*/

        var tagsList = SequenceService.obtainTagwithIdandTypev166({
          sequenceId: groupCqnzBasicData.sequenceId,
          notificationType: 7
        });

        //LuMa HashTags in sequence
        //var hashesList = SequenceService.getHashFromSequence(groupCqnzBasicData.sequenceId);
        var hashesList = SequenceService.findSequenceHashTagComment({
            sequenceId: groupCqnzBasicData.sequenceId,
            notificationType: 7,
            commentId: 0
          });

        Utils.$q.all({
          commentsCounts: commentsCounts,
          tagsList: tagsList,
          hashesList: hashesList,
          suggestedPost: suggested,
          recommendedPost: groupRecom
        }).then(function (groupCqnz) {
          groupCqnz.basicData = groupCqnzBasicData;
          //console.log("groupCqnz.comments", groupCqnz.comments);

          groupCqnz.sequenceOwnerId = Utils.getLastUrlComponent(groupCqnz.basicData.userSubscriptionId.href);
          groupCqnz.sequenceItems = cqnzService.getItemsToSequenceV165WS(groupCqnz.basicData.sequenceId);
          groupCqnz.likeActive = SequenceService.findSmileysCount({
            sequenceId: Utils.getLastUrlComponent(groupCqnz.basicData.sequence.href),
            userId: myUserId
          });
          groupCqnz.followEachOther = myUserId == groupCqnz.sequenceOwnerId ? {result: {value: true}} : SequenceService.followEachOther({
            userId: myUserId,
            friendId: groupCqnz.sequenceOwnerId
          });

          //because an advertiser has no access to a group timeline
          groupCqnz.viewsCounter = null;//groupCqnz.basicData.isAdvertisement ? adsService.getViewsCount(groupCqnz.basicData.sequenceId) : null;
          groupCqnz.clicksCounter = null;//groupCqnz.basicData.isAdvertisement ? adsService.getClicksCount(groupCqnz.basicData.sequenceId) : null;
          groupCqnz.URLClicksCounter = null;//groupCqnz.basicData.isAdvertisement ? adsService.getClicksCount(groupCqnz.basicData.sequenceId) : null;

          groupCqnz.basicData.sequenceCommentCount = groupCqnz.commentsCounts.result.value;
          groupCqnz.basicData.suggestedPost = groupCqnz.suggestedPost;
          groupCqnz.basicData.recommendedPost = groupCqnz.recommendedPost;

          var commentsPromises = {};
          if (groupCqnz.basicData.sequenceCommentCount) {
            //console.log("getting comments of (" + cqnzId + ", " + $scope._groupHrefId + ")");
            commentsPromises[$scope._groupId] = cqnzService.getCommentsOfSequenceWS({
              sequenceId: groupCqnzBasicData.sequenceId,
              start: 0,
              count: 2,
              groupId: $scope._groupId
            }).$promise
          }

          groupCqnz.comments = [];
          Utils.$q.all(commentsPromises).then(function (resolvedComments) {
            //console.log("resolvedComments for sequence "+cqnzId, resolvedComments);
            Object.keys(resolvedComments).forEach(function (groupId) {
              Utils.removeLastItemIfHasNoAttribute(resolvedComments[groupId], 'commentId');
              if (resolvedComments[groupId].length) {
                resolvedComments[groupId].groupId = groupId;
                groupCqnz.comments = groupCqnz.comments.concat(resolvedComments[groupId]);
              }
            });
            //console.log('hashCqnz.comments', hashCqnz.comments);

            var realLen = isPinnedCqnz ? $scope._sequenceList.unshift(SequenceFactory.buildSequenceObject(groupCqnz)) :
              $scope._sequenceList.push(SequenceFactory.buildSequenceObject(groupCqnz));

            //console.log($scope._sequenceList[realLen-1]);

            if (!groupCqnz.basicData.pinned) timelineLen++;

            //if (!groupCqnz.basicData.pinned && !UserService.USER_IS_ADVERTISER() && adsService.canInsertAd(timelineLen, pagination.count)) {
            //if (!groupCqnz.basicData.pinned && !permissions.canAdvertisementPermit() && adsService.canInsertAd(timelineLen, pagination.count)) {              
            if (!groupCqnz.basicData.pinned && adsService.canInsertAd(timelineLen, pagination.count)) {              
              //console.log("inserting ad at " + timelineLen, realLen); 
              adsService.getAdvertisement(
                UserService.get_USER_INSTANCE_HREF(),
                $scope.groupData.id/*only for groups*/
              ).then(function (advertisementData) {
                //console.log("getAdv", advertisementData);
                if (advertisementData) {
                  $scope._sequenceList.splice(realLen - 1, 0, advertisementData);
                  findAdContainerInterval = setInterval(function () {
                    var el = document.getElementById($scope._controllerName + '_Ad_' + (realLen - 1));
                    if (el) {
                      clearInterval(findAdContainerInterval);
                      findAdContainerInterval = undefined;
                      adsNotViewed.push({sequence: advertisementData, listIndex: realLen - 1, el: el});
                    }
                    else
                      console.warn("The ad '" + ($scope._controllerName + '_Ad_' + (realLen - 1)) + "' container was not found")
                  }, 500);
                }
              }, function (adError) {
                console.error("Couldn't get advertisement", adError);
              });
            }

            deferred.resolve(true);
          }, function (errors) {
            console.error("$q.all(commentsPromises)", errors);
            var realLen = isPinnedCqnz ? $scope._sequenceList.unshift(SequenceFactory.buildSequenceObject(groupCqnz)) :
              $scope._sequenceList.push(SequenceFactory.buildSequenceObject(groupCqnz));

            //console.log($scope._sequenceList[realLen-1]);

            if (!groupCqnz.basicData.pinned) timelineLen++;

            //if (!groupCqnz.basicData.pinned && !UserService.USER_IS_ADVERTISER() && adsService.canInsertAd(timelineLen, pagination.count)) {
            //if (!groupCqnz.basicData.pinned && !permissions.canAdvertisementPermit() && adsService.canInsertAd(timelineLen, pagination.count)) {
            if (!groupCqnz.basicData.pinned && adsService.canInsertAd(timelineLen, pagination.count)) {
              //console.log("inserting ad at " + timelineLen, realLen); 
              adsService.getAdvertisement(
                UserService.get_USER_INSTANCE_HREF(),
                $scope.groupData.groupId/*only for groups*/
              ).then(function (advertisementData) {
                //console.log("getAdv", advertisementData);
                if (advertisementData) {
                  $scope._sequenceList.splice(realLen - 1, 0, advertisementData);
                  findAdContainerInterval = setInterval(function () {
                    var el = document.getElementById($scope._controllerName + '_Ad_' + (realLen - 1));
                    if (el) {
                      clearInterval(findAdContainerInterval);
                      findAdContainerInterval = undefined;
                      adsNotViewed.push({sequence: advertisementData, listIndex: realLen - 1, el: el});
                    }
                    else
                      console.warn("The ad '" + ($scope._controllerName + '_Ad_' + (realLen - 1)) + "' container was not found")
                  }, 500);
                }
              }, function (adError) {
                console.error("Couldn't get advertisement", adError);
              });
            }

            deferred.reject(errors);
          });
        }, function (errors) {
          console.error("Comments|Tags|Hashes error", errors);
          deferred.reject(errors);
        });
        return deferred.promise;
      }

      if ($scope.isFirstTime) {
        $scope.getMoreGroupSequences();
      }

      timelinesService.groupTimeline.events.timeline.refresh =
        $scope.refreshGroupTimeline = function (x) {
          if (!x || $scope.isRefreshing || $scope.isLoadingContent) return;

          console.log("refreshing...")

          $scope._sequenceList = [];
          $scope.specificSearchActive = false;
          $scope.data.realText = null;
          $scope.data.realCity = null;
          var clearCty = document.getElementById("ctySearchArea");
          clearCty.selectedIndex = 0;

          pinnedSequenceFetched = false;

          $scope.canGetMoreItems = true;
          $scope.errorLoading = false;
          $scope.isRefreshing = true;
          $scope.isFirstTime = true;

          pagination.reset();

          setTimeout(function () {
            $scope.isLoadingContent = false;
            Utils.$ionicScrollDelegate.resize();
            $scope.getMoreGroupSequences();
          }, 800);

          notificationsService.countPendingRegularNotifications(UserService.get_USER_INSTANCE_HREF());
          notificationsService.countPendingFollowersNotifications(UserService.get_USER_INSTANCE_HREF());
        };

      timelinesService.groupTimeline.events.sequence.onDelete = function (data) {

        if ($scope._totalPinnedSequences && data.sequenceMetadata.isPinned) {
          $scope._sequenceList.shift();
          $scope._totalPinnedSequences = 0;
        }

        $scope._sequenceList.some(function (sequence, index) {
          if (sequence.metadata.id == data.sequenceMetadata.id) {

            $scope._sequenceList.splice(index, 1);

            pagination.count = 5;
            //pagination.start--;
            $scope.getMoreGroupSequences();
            //pagination.count = 5;

            return true;
          }
        });
      };

      timelinesService.groupTimeline.events.sequence.onTitleEdited = function (data) {
        console.log("Ctrl name: groupTimeline");
        $scope._sequenceList.some(function (sequence) {
          if (sequence.metadata.id == data.sequenceId) {
            data.updaterFn(sequence, data);
            return true;
          }
        })
      };

      timelinesService.groupTimeline.events.sequence.onContentEdited = function (data) {
        $scope.refreshGroupTimeline();
      };

      timelinesService.groupTimeline.events.sequence.onShareableUpdated = function (data) {
        $scope._sequenceList.some(function (sequence) {
          if (sequence.metadata.id == data.sequenceMetadata.id) {
            sequence.share.enabled = data.enabled;
            return true;
          }
        });
      };

      timelinesService.groupTimeline.events.sequence.onCountersUpdated = function (newData) {
        $scope._sequenceList.some(function (sequence) {
          if (sequence.metadata.id == newData.sequenceMetadata.id) {
            newData.updaterFn(sequence, newData);
            return true;
          }
        })
      };

      timelinesService.groupTimeline.events.comment.onEnabledUpdated = function (data) {
        $scope._sequenceList.some(function (sequence) {
          if (sequence.metadata.id == data.sequenceMetadata.id) {
            sequence.comments.enabled = data.enabled;
            return true;
          }
        });
      };

      timelinesService.groupTimeline.events.comment.onCreate = function (data) {
        console.log("groupTimeline.events.comment.onCreate", data);
        $scope._sequenceList.some(function (sequence) {
          if (sequence.metadata.id != data.comment.sequenceMetadata.id) return false;//<- continue in this context

          console.log("sequence found");
          sequence.comments.counter++;
          if (!data.comment.isReply) {
            //show only 2 comments for each sequence
            if (sequence.comments.items.length > 1) return true;

            console.log("Inserting regular comment");
            var len = sequence.comments.items.push({});
            setTimeout(function () {
              sequence.comments.items[len - 1] = data.comment;
            }, 800);
          }
          else {//it's a reply comment
            sequence.comments.items.some(function (parentComment) {
              if (parentComment.metadata.id != data.comment.metadata.parentCommentId) return false;//<- continue in this context

              console.log("parent comment found");
              //if (parentComment.responses.length) return true;//show only 1 reply for each parent comment
              parentComment.isReplying = true;

              console.log("Inserting reply");
              parentComment.responses.push(data.comment);
              Utils.$timeout(function () {
                parentComment.isReplying = false;
              }, 800);
              return true;//stop searching parent comments
            })
          }
          return true;//stop searching sequences
        })
      };

      timelinesService.groupTimeline.events.comment.onUpdate = function (data) {
        console.log("groupTimeline.events.comment.onUpdate", data);
        $scope._sequenceList.some(function (sequence) {
          if (sequence.metadata.id != data.comment.sequenceMetadata.id) return false;//<- continue in this context

          //console.log("sequence found");
          var commentIdToFind = data.comment.isReply ? data.comment.metadata.parentCommentId : data.comment.metadata.id;
          sequence.comments.items.some(function (comment, cIdx) {
            if (comment.metadata.id != commentIdToFind) return false;//<- continue in this context

            if (!data.comment.isReply) {
              //console.log("single comment found");
              sequence.comments.items[cIdx] = {};
              setTimeout(function () {
                sequence.comments.items[cIdx] = data.comment;
              }, 800);
            }
            else {
              //console.log("parent comment found");
              comment.responses.some(function (reply, rIdx) {
                if (reply.metadata.id != data.comment.metadata.id) return false;//<- continue in this context

                //console.log("child (reply) comment found");
                sequence.comments.items[cIdx].responses[rIdx] = data.comment;
                return true;//stop searching child (replies) comments
              });
            }
            return true;//stop searching single/parent comments
          });
          return true;//stop searching sequences
        });
      };

      /**
       * @param data {{cqnzListIndex:number,commentListIndex:number, cqnzInstanceId:number}}
       */
      timelinesService.groupTimeline.events.comment.onDelete = function (data) {
        console.log("groupTimeline.events.comment.onDelete", data);
        $scope._sequenceList.some(function (sequence) {
          if (sequence.metadata.id != data.comment.sequenceMetadata.id) return false;//<- continue in this context

          //console.log("sequence found");
          sequence.comments.counter--;

          var commentIdToFind = data.comment.isReply ? data.comment.metadata.parentCommentId : data.comment.metadata.id;
          sequence.comments.items.some(function (comment, cIdx) {
            if (comment.metadata.id != commentIdToFind) return false;//<- continue in this context

            if (!data.comment.isReply) {
              console.log("comment found");
              sequence.comments.items.splice(cIdx, 1);
              sequence.comments.counter -= data.childrenDeleted;
              console.log("Counter: " + sequence.comments.counter);
            }
            else {
              console.log("parent comment found");
              comment.responses.some(function (reply, rIdx) {
                if (reply.metadata.id != data.comment.metadata.id) return false;//<- continue in this context

                console.log("reply found");
                comment.responses.splice(rIdx, 1);
                return true;//stop searching child (replies) comments
              });
            }
            return true;//stop searching single/parent comments
          });
          return true;//stop searching sequences
        });
      };

      timelinesService.groupTimeline.events.comment.onLikeUpdated = function (data) {
        console.log('groupTimeline.events.comment.onLikeUpdated', data);
        $scope._sequenceList.some(function (sequence) {
          if (sequence.metadata.id != data.comment.sequenceMetadata.id) return false;//<- continue in this context

          //console.log("sequence found");
          var commentIdToFind = data.comment.isReply ? data.comment.metadata.parentCommentId : data.comment.metadata.id;
          sequence.comments.items.some(function (comment) {
            if (comment.metadata.id != commentIdToFind) return false;//<- continue in this context

            if (!data.comment.isReply) {
              //console.log("single comment found");
              setTimeout(function () {
                comment.likeCounter = data.likeCounter;
                comment.likeActive = data.likeActive;
              }, 800);
            }
            else {
              //console.log("parent comment found");
              comment.responses.some(function (reply, rIdx) {
                if (reply.metadata.id != data.comment.metadata.id) return false;//<- continue in this context

                //console.log("child (reply) comment found");
                setTimeout(function () {
                  comment.responses[rIdx].likeCounter = data.likeCounter;
                  comment.responses[rIdx].likeActive = data.likeActive;
                }, 800);
                return true;//stop searching child (replies) comments
              });
            }
            return true;//stop searching single/parent comments
          });
          return true;//stop searching sequences
        });
      };
    }])

  .controller('hashtagTimeLineCtrl', ['$rootScope', '$scope', '$state', 'timelinesService', 'UserService', 'SequenceService', 'adsService', 'cqnzData', 'cqnzService', 'SequenceFactory', 'GroupFactory', 'permissionValidationService', 'notificationsService', 'Utils',
    function ($rootScope, $scope, $state, timelinesService, UserService, SequenceService, adsService, cqnzData, cqnzService, SequenceFactory, GroupFactory, permissionValidationService, notificationsService, Utils) {
      var myUserId = UserService.get_USERSUBSCRIPTIONINSTANCE_ID();
      var permissions = permissionValidationService;
      //$scope.iAmAdvertiser = UserService.USER_IS_ADVERTISER();
      $scope.iAmAdvertiser = permissions.canAdvertisementPermit();
      //Declare zone
      $scope._controllerName = "hashtagTimeLineCtrl";
      $scope._groupHrefId = undefined;//All of my groups

      $scope._sequenceList = [];
      var pagination = {
        start: 0,
        count: 3,
        reset: function () {
          this.start = 0;
          this.count = 3;
        },
        increaseCount: function (step) {
          this.count = 3
        }
      };
      $scope.canGetMoreItems = true;
      $scope.isRefreshing = false;
      $scope.isLoadingContent = false;
      $scope.errorLoading = false;
      $scope.titlePage = $state.params.hashName;

      $scope.$on("$ionicView.enter", function () {
        $scope.canGetMoreItems = true;
      });

      $scope.$on("$ionicView.beforeLeave", function () {
        $scope.canGetMoreItems = false;
      });

      var userGroups = [];
      $scope.getMoreHashtagsSequences = function () {
        $scope.isFirstTime = false;

        if ($scope.isLoadingContent) return;

        $scope.isLoadingContent = true;

        userGroups = GroupFactory.getCurrentAvailableUserGroupsList();
        console.log("You are in " + userGroups.length + " groups");

        SequenceService.findHashDataFromHash(
          $state.params.hashName.replace('#', '')
        ).$promise.then(function (hashtagData) {

          //with the ID we'll get all the sequences that use it
          SequenceService.getSequenceFromHashtags({
            hashtagId: Utils.getLastUrlComponent(hashtagData[0].hashTagObj.href),
            start: pagination.start,
            count: pagination.count
          }).$promise.then(function (listSequences) {
            Utils.removeLastItemIfHasNoAttribute(listSequences, 'sequence');

            $scope.canGetMoreItems = listSequences.length >= pagination.count;

            if (!listSequences.length) {
              $scope.isRefreshing = false;
              $scope.isLoadingContent = false;

              $scope.$broadcast('scroll.refreshComplete');
              $scope.$broadcast('scroll.infiniteScrollComplete');
              return;
            }

            pagination.start += listSequences.length;
            pagination.increaseCount();

            var cqnzIdsList = listSequences.map(function (data) {
              return data.sequence.title;
            });
            filterSequences(cqnzIdsList);

            setTimeout(function () {
              $scope.isRefreshing = false;
              $scope.isLoadingContent = false;

              $scope.$broadcast('scroll.refreshComplete');
              $scope.$broadcast('scroll.infiniteScrollComplete');
            }, 1500);


          }, function (error) {
            console.log("getSequenceFromHashtags", error);
            $scope.canGetMoreItems = false;
            $scope.errorLoading = true;

            $scope.isRefreshing = false;
            $scope.isLoadingContent = false;

            $scope.$broadcast('scroll.refreshComplete');
            $scope.$broadcast('scroll.infiniteScrollComplete');
          })
        }, function (error) {
          console.log("findHashDataFromHash", error);
          $scope.canGetMoreItems = false;
          $scope.errorLoading = true;

          $scope.isRefreshing = false;
          $scope.isLoadingContent = false;

          $scope.$broadcast('scroll.refreshComplete');
          $scope.$broadcast('scroll.infiniteScrollComplete');
        })
      };

      function filterSequences(cqnzIdsList) {
        var groupsPromises = {};
        //filtrar secuencias con mi lista de grupos
        cqnzIdsList.forEach(function (sequenceId) {
          sequenceId = sequenceId.replace(/,/g,"");
          groupsPromises[sequenceId] = GroupFactory.findSequenceGroups(
            sequenceId,
            UserService.get_USER_INSTANCE_HREF()
          ).$promise
        });

        var sequencesListAndGroups = [];
        Utils.$q.all(groupsPromises).then(function (resolvedPromises) {
          console.log("resolvedPromises", resolvedPromises);

          Object.keys(resolvedPromises).forEach(function (groupsList) {
            Utils.removeLastItemIfHasNoAttribute(resolvedPromises[groupsList], 'groupId');
            console.log("groupsList", resolvedPromises[groupsList]);

            var groupsIdsList = resolvedPromises[groupsList].map(function (group) {
              return group.groupId;
            });

            if (groupsIdsList.length)
              sequencesListAndGroups.push({sequenceId: groupsList, groupsIdsList: groupsIdsList})
          });

          console.log("sequencesListAndGroups", sequencesListAndGroups);

          sequencesListAndGroups.forEach(function (sequenceIdAndGroups) {
            //console.log("cqnz", cqnz);
            //complementHashtagCqnzData(Utils.getLastUrlComponent(cqnz.sequence.href));
            complementHashtagCqnzData(sequenceIdAndGroups);
          });//end forEach()
        }, function (error) {
        });
      }

      function complementHashtagCqnzData(sequenceIdAndGroups) {
        var cqnzId = sequenceIdAndGroups.sequenceId;
        //The data required
        var data = SequenceService.findSequenceBySequenceIdV181(cqnzId).$promise;

        //count the num of comments available in each of my groups
        var commentsCountPromises = {};
        sequenceIdAndGroups.groupsIdsList.forEach(function (groupId) {
          console.log("Counting comments for (" + cqnzId + ", " + groupId + ")");
          commentsCountPromises[groupId] = cqnzService.countSequenceCommentsByGroupWS({
            sequenceId: cqnzId,
            groupId: groupId
          }).$promise;
        });

        //Ws call to check if the sequence have 2 or more comments to display at timeline
        /*var comments = cqnzService.getCommentsOfSequenceWS({
          sequenceId: cqnzId,
          start: 0,
          count: 2
        }).$promise;*/

        //Ws called to check if the sequence have any tags in title
        var listTags = SequenceService.obtainTagwithIdandTypev166({
          sequenceId: cqnzId,
          notificationType: 7
        });

        //Ws called to check if the sequence have any hashtags in title
        //var hashesList = SequenceService.getHashFromSequence(cqnzId);
        var hashesList = SequenceService.findSequenceHashTagComment({
            sequenceId: cqnzId,
            notificationType: 7,
            commentId: 0
          });

        Utils.$q.all({
          basicData: data,
          commentsCounts: Utils.$q.all(commentsCountPromises),
          tagsList: listTags,
          hashesList: hashesList
        }).then(function (hashCqnz) {
          Utils.removeLastItemIfHasNoAttribute(hashCqnz.basicData, 'sequence');

          hashCqnz.basicData = hashCqnz.basicData[0];

          hashCqnz.sequenceOwnerId = Utils.getLastUrlComponent(hashCqnz.basicData.userSubscriptionId.href);
          hashCqnz.sequenceItems = cqnzService.getItemsToSequenceV165WS(hashCqnz.basicData.sequenceId);
          hashCqnz.likeActive = SequenceService.findSmileysCount({
            sequenceId: Utils.getLastUrlComponent(hashCqnz.basicData.sequence.href),
            userId: myUserId
          });
          hashCqnz.followEachOther = myUserId == hashCqnz.sequenceOwnerId ? {result: {value: true}} : SequenceService.followEachOther({
            userId: myUserId,
            friendId: hashCqnz.sequenceOwnerId
          });
          hashCqnz.viewsCounter = hashCqnz.basicData.isAdvertisement && hashCqnz.sequenceOwnerId == myUserId ? adsService.getViewsCount(hashCqnz.basicData.sequenceId) : null;
          hashCqnz.clicksCounter = hashCqnz.basicData.isAdvertisement && hashCqnz.sequenceOwnerId == myUserId ? adsService.getClicksCount(hashCqnz.basicData.sequenceId) : null;
          hashCqnz.URLClicksCounter = hashCqnz.basicData.isAdvertisement && hashCqnz.sequenceOwnerId == myUserId ? adsService.getURLClicksCount(hashCqnz.basicData.sequenceId) : null;

          //$scope._sequenceList.push(cqnzService.configureSequence(hashCqnz))

          //console.log('hashCqnz commentsCounts', hashCqnz.commentsCounts);

          hashCqnz.basicData.sequenceCommentCount = 0;

          var totalComments = 0;
          var commentsPromises = {};
          Object.keys(hashCqnz.commentsCounts).forEach(function (groupId) {
            var numOfComments = hashCqnz.commentsCounts[groupId].result.value;
            totalComments += numOfComments;

            //console.log("Total comments in group " + groupId + " = "+ totalComments);

            if (numOfComments) {
              //console.log("getting comments of (" + cqnzId + ", " + groupId + ")");
              commentsPromises[groupId] = cqnzService.getCommentsOfSequenceWS({
                sequenceId: cqnzId,
                start: 0,
                count: 2,
                groupId: groupId
              }).$promise
            }
          });
          hashCqnz.basicData.sequenceCommentCount = totalComments;
          //console.log("Total comments for sequence " + cqnzId + " = ", totalComments);

          hashCqnz.comments = [];
          Utils.$q.all(commentsPromises).then(function (resolvedComments) {
            //console.log("resolvedComments for sequence "+cqnzId, resolvedComments);
            Object.keys(resolvedComments).forEach(function (groupId) {
              Utils.removeLastItemIfHasNoAttribute(resolvedComments[groupId], 'commentId');
              if (resolvedComments[groupId].length) {
                resolvedComments[groupId].groupId = groupId;
                hashCqnz.comments = hashCqnz.comments.concat(resolvedComments[groupId]);
              }
            });
            //console.log('hashCqnz.comments', hashCqnz.comments);

            var cqnz = SequenceFactory.buildSequenceObject(hashCqnz);
            cqnz.allowedGroups = sequenceIdAndGroups.groupsIdsList;
            $scope._sequenceList.push(cqnz)
          }, function (errors) {
            console.error("$q.all(commentsPromises)", errors);
            var cqnz = SequenceFactory.buildSequenceObject(hashCqnz);
            cqnz.allowedGroups = sequenceIdAndGroups.groupsIdsList;
            $scope._sequenceList.push(cqnz);
          });
        })
      }

      $scope.refreshHashtagTimeline = function () {
        if ($scope.isRefreshing) {
          return;
        }

        $scope.isLoadingContent = false;
        $scope.errorLoading = false;
        $scope.isRefreshing = true;
        pagination.reset();
        $scope._sequenceList = [];
        $scope.$broadcast('scroll.refreshComplete');
        $scope.$broadcast('scroll.infiniteScrollComplete');
        Utils.$ionicScrollDelegate.resize();
        $scope.canGetMoreItems = true;

        notificationsService.countPendingRegularNotifications(UserService.get_USER_INSTANCE_HREF());
        notificationsService.countPendingFollowersNotifications(UserService.get_USER_INSTANCE_HREF());
      };

      timelinesService.hashTimeline.events.comment.onCreate = function (data) {
        console.log("hashTimeline.events.comment.onCreate", data);
        $scope._sequenceList.some(function (sequence) {
          if (sequence.metadata.id != data.comment.sequenceMetadata.id) return false;//<- continue in this context

          console.log("sequence found");
          sequence.comments.counter++;
          if (!data.comment.isReply) {
            //show only 2 comments for each sequence
            if (sequence.comments.items.length > 1) return true;

            console.log("Inserting regular comment");
            var len = sequence.comments.items.push({});
            setTimeout(function () {
              sequence.comments.items[len - 1] = data.comment;
            }, 800);
          }
          else {//it's a reply comment
            sequence.comments.items.some(function (parentComment) {
              if (parentComment.metadata.id != data.comment.metadata.parentCommentId) return false;//<- continue in this context

              console.log("parent comment found");
              //if (parentComment.responses.length) return true;//show only 1 reply for each parent comment
              parentComment.isReplying = true;

              console.log("Inserting reply");
              parentComment.responses.push(data.comment);
              Utils.$timeout(function () {
                parentComment.isReplying = false;
              }, 800);
              return true;//stop searching parent comments
            })
          }
          return true;//stop searching sequences
        })
      };
    }])

  .controller('myProfileTimelineCtrl', ['$rootScope', '$scope', 'UserService', 'TimeLineService', 'SequenceService', 'cqnzService', 'SequenceFactory', 'adsService', 'permissionValidationService', 'notificationsService', 'Utils',
    function ($rootScope, $scope, UserService, TimeLineService, SequenceService, cqnzService, SequenceFactory, adsService, permissionValidationService, notificationsService, Utils) {
      var myUserId = UserService.get_USERSUBSCRIPTIONINSTANCE_ID();
      //$scope.iAmAdvertiser = UserService.USER_IS_ADVERTISER();
      var permissions = permissionValidationService;
      $scope.iAmAdvertiser = permissions.canAdvertisementPermit();
      $scope._controllerName = "myProfileTimelineCtrl";
      $scope._groupHrefId = 0;//Default timeline
      $scope.blockSearch = false;
      //------- CONFIG FOR SEQUENCE ITEMS -------
      $scope.isUserProfile = true;
      $scope.hideAvatar = true;
      $scope.hideUsername = true;
      //---- END CONFIG FOR SEQUENCE ITEMS -----


      var pagination = {
        start: 0,
        count: 3,
        reset: function () {
          this.start = 0;
          this.count = 3;
        },
        increaseCount: function (step) {
          this.count = 3
        }
      };
      $scope._sequenceList = [];

      $scope.isFirstTime = true;
      $scope.isRefreshing = false;
      $scope.isLoadingMyContent = false;
      $scope.canGetMoreItems = true;
      $scope.errorLoading = false;
      

      $scope.findMySequences = function () {
        if($scope.blockSearch) {
          return true;
        }
        $scope.blockSearch = true;
        $scope.isFirstTime = false;

        if ($scope.isLoadingMyContent) return;

        $scope.isLoadingMyContent = true;

        TimeLineService.findLatestSequencesBelongingToAUser({
          userId: myUserId,
          start: pagination.start,
          count: pagination.count
        }).then(function (sequencesMyProfile) {
          Utils.removeLastItemIfHasNoAttribute(sequencesMyProfile, 'sequence');
          $scope.blockSearch = false;
          //console.log(sequencesMyProfile);

          var fetchedCqnzsLength = sequencesMyProfile.length;

          $scope.canGetMoreItems = fetchedCqnzsLength >= pagination.count;

          if (!fetchedCqnzsLength) {
            $scope.isRefreshing = false;
            $scope.isLoadingMyContent = false;
            $scope.$broadcast('scroll.infiniteScrollComplete');
            return;
          }

          pagination.start += sequencesMyProfile.length;
          pagination.increaseCount();

          sequencesMyProfile.forEach(function (cqnzBasicData) {
            /*var comments = cqnzService.getCommentsOfSequenceWS({
              sequenceId: cqnzBasicData.sequenceId,
              start: 0,
              count: 2
            }).$promise;*/

            var commentsCounts = cqnzService.countSequenceCommentsByGroupWS({
              sequenceId: cqnzBasicData.sequenceId,
              groupId: $scope._groupHrefId
            }).$promise;

            var tagsList = SequenceService.obtainTagwithIdandTypev166({
              sequenceId: cqnzBasicData.sequenceId,
              notificationType: 7
            });

            //LuMa HashTags in sequence
            //var hashesList = SequenceService.getHashFromSequence(cqnzBasicData.sequenceId);
            var hashesList = SequenceService.findSequenceHashTagComment({
              sequenceId: cqnzBasicData.sequenceId,
              notificationType: 7,
              commentId: 0
            });
              

            Utils.$q.all({
              commentsCounts: commentsCounts,
              tagsList: tagsList,
              hashesList: hashesList
            }).then(function (myProfileCqnz) {
              myProfileCqnz.basicData = cqnzBasicData;
              myProfileCqnz.sequenceOwnerId = myUserId;
              myProfileCqnz.sequenceItems = cqnzService.getItemsToSequenceV165WS(myProfileCqnz.basicData.sequenceId);
              myProfileCqnz.likeActive = SequenceService.findSmileysCount({
                sequenceId: Utils.getLastUrlComponent(myProfileCqnz.basicData.sequence.href),
                userId: myUserId
              });
              myProfileCqnz.followEachOther = {result: {value: true}};
              myProfileCqnz.viewsCounter = myProfileCqnz.basicData.isAdvertisement && myProfileCqnz.sequenceOwnerId == myUserId ? adsService.getViewsCount(myProfileCqnz.basicData.sequenceId) : null;
              myProfileCqnz.clicksCounter = myProfileCqnz.basicData.isAdvertisement && myProfileCqnz.sequenceOwnerId == myUserId ? adsService.getClicksCount(myProfileCqnz.basicData.sequenceId) : null;
              myProfileCqnz.URLClicksCounter = myProfileCqnz.basicData.isAdvertisement && myProfileCqnz.sequenceOwnerId == myUserId ? adsService.getURLClicksCount(myProfileCqnz.basicData.sequenceId) : null;

              myProfileCqnz.basicData.sequenceCommentCount = myProfileCqnz.commentsCounts.result.value;

              var commentsPromises = {};
              if (myProfileCqnz.basicData.sequenceCommentCount) {
                //console.log("getting comments of (" + cqnzId + ", " + groupId + ")");
                commentsPromises[$scope._groupHrefId] = cqnzService.getCommentsOfSequenceWS({
                  sequenceId: cqnzBasicData.sequenceId,
                  start: 0,
                  count: 2,
                  groupId: $scope._groupHrefId
                }).$promise
              }

              myProfileCqnz.comments = [];
              Utils.$q.all(commentsPromises).then(function (resolvedComments) {
                Object.keys(resolvedComments).forEach(function (groupId) {
                  Utils.removeLastItemIfHasNoAttribute(resolvedComments[groupId], 'commentId');
                  if (resolvedComments[groupId].length) {
                    resolvedComments[groupId].groupId = groupId;
                    myProfileCqnz.comments = myProfileCqnz.comments.concat(resolvedComments[groupId]);
                  }
                });

                //$scope._sequenceList.push(cqnzService.configureSequence(myProfileCqnz));
                $scope._sequenceList.push(SequenceFactory.buildSequenceObject(myProfileCqnz));

                $scope.isRefreshing = false;
                $scope.isLoadingMyContent = false;

                $scope.$broadcast('scroll.infiniteScrollComplete');
                setTimeout(function () {
                  Utils.$ionicScrollDelegate.resize();
                }, 800);
              }, function (error) {
                console.log("all(commentsPromises)", error);
                //$scope._sequenceList.push(cqnzService.configureSequence(myProfileCqnz));
                $scope._sequenceList.push(SequenceFactory.buildSequenceObject(myProfileCqnz));

                $scope.isRefreshing = false;
                $scope.isLoadingMyContent = false;

                $scope.$broadcast('scroll.infiniteScrollComplete');
                setTimeout(function () {
                  Utils.$ionicScrollDelegate.resize();
                }, 800);
              })
            }, function (errors) {
              console.error("Comments-Tags-Hashes error", errors);
              $scope.errorLoading = true;
              $scope.canGetMoreItems = false;
              $scope.blockSearch = false;
              $scope.isRefreshing = false;
              $scope.isLoadingMyContent = false;

              $scope.$broadcast('scroll.infiniteScrollComplete');
              setTimeout(function () {
                Utils.$ionicScrollDelegate.resize();
              }, 800);
            })
          });
        }, function (error) {
          console.log("findLatestSequencesBelongingToAUser", error);
          $scope.errorLoading = true;
          $scope.canGetMoreItems = false;
          $scope.blockSearch = false;
          $scope.isRefreshing = false;
          $scope.isLoadingMyContent = false;

          $scope.$broadcast('scroll.infiniteScrollComplete');
          setTimeout(function () {
            Utils.$ionicScrollDelegate.resize();
          }, 800);
        });
      };

      $scope.findMySequences();

      $scope.refreshMyProfileTimeline = function () {
        if ($scope.isRefreshing) {
          return;
        }

        $scope._sequenceList = [];
        $scope.isLoadingMyContent = false;
        $scope.errorLoading = false;
        $scope.isRefreshing = true;
        pagination.reset();


        setTimeout(function () {
          Utils.$ionicScrollDelegate.resize();
          $scope.findMySequences();
        }, 800);

        notificationsService.countPendingRegularNotifications(UserService.get_USER_INSTANCE_HREF());
        notificationsService.countPendingFollowersNotifications(UserService.get_USER_INSTANCE_HREF());
      };

      if ($scope.MyProfileSharedCtrl) {
        $scope.MyProfileSharedCtrl.refreshMyProfilePosts = $scope.refreshMyProfileTimeline;
        $scope.MyProfileSharedCtrl.SequenceOnPostDeleted = onPostDeleted;
        $scope.MyProfileSharedCtrl.SequenceOnTitleEdited = onTitleEdited;
        $scope.MyProfileSharedCtrl.SequenceOnContentEdited = $scope.refreshMyProfileTimeline;
        $scope.MyProfileSharedCtrl.SequenceOnShareableUpdated = onShareableUpdated;
        $scope.MyProfileSharedCtrl.SequenceOnCountersUpdated = onCountersUpdated;
        $scope.MyProfileSharedCtrl.commentOnEnabledUpdated = commentOnEnabledUpdated;
        $scope.MyProfileSharedCtrl.commentOnCreate = commentOnCreate;
        $scope.MyProfileSharedCtrl.commentOnUpdate = commentOnUpdate;
        $scope.MyProfileSharedCtrl.commentOnDelete = commentOnDelete;
        $scope.MyProfileSharedCtrl.commentOnLikeUpdated = commentOnLikeUpdated;
      }

      function onPostDeleted(data) {
        console.log("myProfileTimelineCtrl onPostDeleted", data);
        $scope._sequenceList.some(function (sequence, index) {
          if (+sequence.metadata.id === +data.sequenceMetadata.id) {
            $scope._sequenceList.splice(index, 1);
            return true;
          }
        });
      }

      function onTitleEdited(data) {
        $scope._sequenceList.some(function (sequence) {
          if (+sequence.metadata.id === +data.sequenceId) {
            data.updaterFn(sequence, data);
            return true;
          }
        })
      }

      function onShareableUpdated(data) {
        $scope._sequenceList.some(function (sequence) {
          if (+sequence.metadata.id === +data.sequenceMetadata.id) {
            sequence.share.enabled = data.enabled;
            return true;
          }
        });
      }

      function onCountersUpdated(data) {
        $scope._sequenceList.some(function (sequence) {
          if (+sequence.metadata.id === +data.sequenceMetadata.id) {
            data.updaterFn(sequence, data);
            return true;
          }
        })
      }

      function commentOnEnabledUpdated(data) {
        $scope._sequenceList.some(function (sequence) {
          if (+sequence.metadata.id === +data.sequenceMetadata.id) {
            sequence.comments.enabled = data.enabled;
            return true;
          }
        });
      }

      function commentOnCreate(data) {
        console.log("myProfileTimelineCtrl.events.comment.onCreate", data);
        $scope._sequenceList.some(function (sequence) {
          if (sequence.metadata.id != data.comment.sequenceMetadata.id) return false;//<- continue in this context

          console.log("sequence found");
          sequence.comments.counter++;
          if (!data.comment.isReply) {
            //show only 2 comments for each sequence
            if (sequence.comments.items.length > 1) return true;

            console.log("Inserting regular comment");
            var len = sequence.comments.items.push({});
            setTimeout(function () {
              sequence.comments.items[len - 1] = data.comment;
            }, 800);
          }
          else {//it's a reply comment
            sequence.comments.items.some(function (parentComment) {
              if (parentComment.metadata.id != data.comment.metadata.parentCommentId) return false;//<- continue in this context

              console.log("parent comment found");
              //if (parentComment.responses.length) return true;//show only 1 reply for each parent comment
              parentComment.isReplying = true;

              console.log("Inserting reply");
              parentComment.responses.push(data.comment);
              Utils.$timeout(function () {
                parentComment.isReplying = false;
              }, 800);
              return true;//stop searching parent comments
            })
          }
          return true;//stop searching sequences
        })
      }

      function commentOnUpdate (data) {
        console.log("myProfileTimelineCtrl.events.comment.onUpdate", data);
        $scope._sequenceList.some(function (sequence, sIdx) {
          if (+sequence.metadata.id !== +data.comment.sequenceMetadata.id) return false;//<- continue in this context

          //console.log("sequence found");
          var commentIdToFind = data.comment.isReply ? data.comment.metadata.parentCommentId : data.comment.metadata.id;
          sequence.comments.items.some(function (comment, cIdx) {
            if (+comment.metadata.id !== +commentIdToFind) return false;//<- continue in this context

            if (!data.comment.isReply) {
              //console.log("single comment found");
              sequence.comments.items[cIdx] = {};
              setTimeout(function () {
                sequence.comments.items[cIdx] = data.comment;
              }, 800);
            }
            else {
              //console.log("parent comment found");
              comment.responses.some(function (reply, rIdx) {
                if (reply.metadata.id != data.comment.metadata.id) return false;//<- continue in this context

                //console.log("child (reply) comment found");
                sequence.comments.items[cIdx].responses[rIdx] = data.comment;
                return true;//stop searching child (replies) comments
              });
            }
            return true;//stop searching single/parent comments
          });
          return true;//stop searching sequences
        });
      }

      function commentOnDelete (data) {
        console.log("myProfileTimelineCtrl.events.comment.onDelete", data);
        $scope._sequenceList.some(function (sequence) {
          if (sequence.metadata.id != data.comment.sequenceMetadata.id) return false;//<- continue in this context

          //console.log("sequence found");
          sequence.comments.counter--;

          var commentIdToFind = data.comment.isReply ? data.comment.metadata.parentCommentId : data.comment.metadata.id;
          sequence.comments.items.some(function (comment, cIdx) {
            if (comment.metadata.id != commentIdToFind) return false;//<- continue in this context

            if (!data.comment.isReply) {
              console.log("comment found");
              sequence.comments.items.splice(cIdx, 1);
              sequence.comments.counter -= data.childrenDeleted;
              console.log("Counter: " + sequence.comments.counter);
            }
            else {
              console.log("parent comment found");
              comment.responses.some(function (reply, rIdx) {
                if (+reply.metadata.id !== +data.comment.metadata.id) return false;//<- continue in this context

                console.log("reply found");
                comment.responses.splice(rIdx, 1);
                return true;//stop searching child (replies) comments
              });
            }
            return true;//stop searching single/parent comments
          });
          return true;//stop searching sequences
        });
      }

      function commentOnLikeUpdated (data) {
        console.log('myProfileTimelineCtrl.events.comment.onLikeUpdated', data);
        $scope._sequenceList.some(function (sequence) {
          if (+sequence.metadata.id !== +data.comment.sequenceMetadata.id) return false;//<- continue in this context

          //console.log("sequence found");
          var commentIdToFind = data.comment.isReply ? data.comment.metadata.parentCommentId : data.comment.metadata.id;
          sequence.comments.items.some(function (comment) {
            if (+comment.metadata.id !== +commentIdToFind) return false;//<- continue in this context

            if (!data.comment.isReply) {
              //console.log("single comment found");
              setTimeout(function () {
                comment.likeCounter = data.likeCounter;
                comment.likeActive = data.likeActive;
              }, 800);
            }
            else {
              //console.log("parent comment found");
              comment.responses.some(function (reply, rIdx) {
                if (+reply.metadata.id !== +data.comment.metadata.id) return false;//<- continue in this context

                //console.log("child (reply) comment found");
                setTimeout(function () {
                  comment.responses[rIdx].likeCounter = data.likeCounter;
                  comment.responses[rIdx].likeActive = data.likeActive;
                }, 800);
                return true;//stop searching child (replies) comments
              });
            }
            return true;//stop searching single/parent comments
          });
          return true;//stop searching sequences
        });
      }
    }])

  .controller('friendProfileTimelineCtrl', ['$rootScope', '$scope', '$state', 'TimeLineService', 'SequenceService', 'cqnzService', 'SequenceFactory', 'adsService', 'UserService', 'permissionValidationService', 'notificationsService', 'Utils',
    function ($rootScope, $scope, $state, TimeLineService, SequenceService, cqnzService, SequenceFactory, adsService, UserService, permissionValidationService, notificationsService, Utils) {
      var myUserId = UserService.get_USERSUBSCRIPTIONINSTANCE_ID();
      var friendUserId = $state.params.instanceId;
      //$scope.iAmAdvertiser = UserService.USER_IS_ADVERTISER();
      var permissions = permissionValidationService;
      $scope.iAmAdvertiser = permissions.canAdvertisementPermit();
      $scope._controllerName = "friendProfileTimelineCtrl";
      $scope._groupHrefId = 0;//Default timeline
      $scope.blockSearch = false;
      //------- CONFIG FOR SEQUENCE ITEMS ------
      $scope.isUserProfile = true;
      $scope.hideAvatar = true;
      $scope.hideUsername = true;
      //---- END CONFIG FOR SEQUENCE ITEMS -----

      var pagination = {
        start: 0,
        count: 3,
        reset: function () {
          this.start = 0;
          this.count = 3;
        },
        increaseCount: function (step) {
          this.count = 3
        }
      };

      $scope._sequenceList = [];

      $scope.contentLoaded = false;
      $scope.isRefreshing = false;
      $scope.isLoadingYourContent = false;
      $scope.canGetMoreItems = true;
      $scope.errorLoading = false;

      $scope.findFriendSequences = function () {
        if($scope.blockSearch) {
          return true;
        }
        $scope.blockSearch = true;
        $scope.contentLoaded = false;
        console.log("TRIGGER SEARCH START: "+pagination.start+" COUNT: "+pagination.count);
        if ($scope.isLoadingYourContent) return;

        $scope.isLoadingYourContent = true;

        TimeLineService.findLatestSequencesBelongingToAUser({
          userId: friendUserId,
          start: pagination.start,
          count: pagination.count
        }).then(function (sequencesMyProfile) {
          $scope.blockSearch = false;
          Utils.removeLastItemIfHasNoAttribute(sequencesMyProfile, 'sequence');

          //console.log(sequencesMyProfile);

          var fetchedCqnzsLength = sequencesMyProfile.length;

          $scope.canGetMoreItems = fetchedCqnzsLength >= pagination.count;

          if (!fetchedCqnzsLength) {
            $scope.isRefreshing = false;
            $scope.contentLoaded = true;
            $scope.isLoadingYourContent = false;
            $scope.$broadcast('scroll.infiniteScrollComplete');
            return;
          }

          pagination.start += sequencesMyProfile.length;
          pagination.increaseCount();

          sequencesMyProfile.forEach(function (cqnzBasicData) {
            var commentsCounts = cqnzService.countSequenceCommentsByGroupWS({
              sequenceId: cqnzBasicData.sequenceId,
              groupId: $scope._groupHrefId
            }).$promise;
            /*var comments = cqnzService.getCommentsOfSequenceWS({
              sequenceId: cqnzBasicData.sequenceId,
              start: 0,
              count: 2
            }).$promise;*/

            var tagsList = SequenceService.obtainTagwithIdandTypev166({
              sequenceId: cqnzBasicData.sequenceId,
              notificationType: 7
            });

            //LuMa HashTags in sequence
            //var hashesList = SequenceService.getHashFromSequence(cqnzBasicData.sequenceId);
            var hashesList = SequenceService.findSequenceHashTagComment({
              sequenceId: cqnzBasicData.sequenceId,
              notificationType: 7,
              commentId: 0
            });

            Utils.$q.all({
              commentsCounts: commentsCounts,
              tagsList: tagsList,
              hashesList: hashesList
            }).then(function (friendProfileCqnz) {
              friendProfileCqnz.basicData = cqnzBasicData;

              friendProfileCqnz.sequenceOwnerId = Utils.getLastUrlComponent(friendProfileCqnz.basicData.userSubscriptionId.href);
              friendProfileCqnz.sequenceItems = cqnzService.getItemsToSequenceV165WS(friendProfileCqnz.basicData.sequenceId);
              friendProfileCqnz.likeActive = SequenceService.findSmileysCount({
                sequenceId: Utils.getLastUrlComponent(friendProfileCqnz.basicData.sequence.href),
                userId: myUserId
              });
              friendProfileCqnz.followEachOther = myUserId == friendProfileCqnz.sequenceOwnerId ? {result: {value: true}} : SequenceService.followEachOther({
                userId: myUserId,
                friendId: friendProfileCqnz.sequenceOwnerId
              });
              friendProfileCqnz.viewsCounter = friendProfileCqnz.basicData.isAdvertisement && friendProfileCqnz.sequenceOwnerId == myUserId ? adsService.getViewsCount(friendProfileCqnz.basicData.sequenceId) : null;
              friendProfileCqnz.clicksCounter = friendProfileCqnz.basicData.isAdvertisement && friendProfileCqnz.sequenceOwnerId == myUserId ? adsService.getClicksCount(friendProfileCqnz.basicData.sequenceId) : null;
              friendProfileCqnz.URLClicksCounter = friendProfileCqnz.basicData.isAdvertisement && friendProfileCqnz.sequenceOwnerId == myUserId ? adsService.getURLClicksCount(friendProfileCqnz.basicData.sequenceId) : null;

              friendProfileCqnz.basicData.sequenceCommentCount = friendProfileCqnz.commentsCounts.result.value;

              var commentsPromises = {};
              if (friendProfileCqnz.basicData.sequenceCommentCount) {
                //console.log("getting comments of (" + cqnzId + ", " + groupId + ")");
                commentsPromises[$scope._groupHrefId] = cqnzService.getCommentsOfSequenceWS({
                  sequenceId: cqnzBasicData.sequenceId,
                  start: 0,
                  count: 2,
                  groupId: $scope._groupHrefId
                }).$promise
              }

              friendProfileCqnz.comments = [];
              Utils.$q.all(commentsPromises).then(function (resolvedComments) {
                Object.keys(resolvedComments).forEach(function (groupId) {
                  Utils.removeLastItemIfHasNoAttribute(resolvedComments[groupId], 'commentId');
                  if (resolvedComments[groupId].length) {
                    resolvedComments[groupId].groupId = groupId;
                    friendProfileCqnz.comments = friendProfileCqnz.comments.concat(resolvedComments[groupId]);
                  }
                });

                //$scope._sequenceList.push(cqnzService.configureSequence(friendProfileCqnz));
                $scope._sequenceList.push(SequenceFactory.buildSequenceObject(friendProfileCqnz));


                $scope.isRefreshing = false;
                $scope.contentLoaded = true;
                $scope.isLoadingYourContent = false;

                $scope.$broadcast('scroll.infiniteScrollComplete');

                setTimeout(function () {
                  Utils.$ionicScrollDelegate.resize();
                }, 800);
              }, function (error) {
                //$scope._sequenceList.push(cqnzService.configureSequence(friendProfileCqnz));
                $scope._sequenceList.push(SequenceFactory.buildSequenceObject(friendProfileCqnz));


                $scope.isRefreshing = false;
                $scope.contentLoaded = true;
                $scope.isLoadingYourContent = false;

                $scope.$broadcast('scroll.infiniteScrollComplete');

                setTimeout(function () {
                  Utils.$ionicScrollDelegate.resize();
                }, 800);
              })
            }, function (errors) {
              console.error("Comments-Tags-Hashes error", errors);
              $scope.errorLoading = true;
              $scope.canGetMoreItems = false;

              $scope.isRefreshing = false;
              $scope.contentLoaded = true;
              $scope.isLoadingYourContent = false;

              $scope.$broadcast('scroll.infiniteScrollComplete');
              setTimeout(function () {
                Utils.$ionicScrollDelegate.resize();
              }, 800);
            })
          });
        }, function (error) {
          console.log("findLatestSequencesBelongingToAUser", error);
          $scope.contentLoaded = true;
          $scope.errorLoading = true;
          $scope.canGetMoreItems = false;
          $scope.blockSearch = false;
          $scope.isRefreshing = false;
          $scope.isLoadingYourContent = false;

          $scope.$broadcast('scroll.infiniteScrollComplete');
          setTimeout(function () {
            Utils.$ionicScrollDelegate.resize();
          }, 800);
        });
      };

      $scope.refreshFriendProfileTimeline = function () {
        if ($scope.isRefreshing) {
          return;
        }

        pagination.reset();

        $scope._sequenceList = [];

        $scope.errorLoading = false;
        $scope.isRefreshing = true;
        $scope.isLoadingYourContent = false;

        $scope.findFriendSequences();

        setTimeout(function () {
          Utils.$ionicScrollDelegate.resize();
        }, 800);

        $scope.initFriendProfile();

        notificationsService.countPendingRegularNotifications(UserService.get_USER_INSTANCE_HREF());
        notificationsService.countPendingFollowersNotifications(UserService.get_USER_INSTANCE_HREF());
      };
    }])

  .controller('scheduledTimelineCtrl', ['$rootScope', '$scope', '$state', 'TimeLineService', 'SequenceService', 'cqnzService', 'SequenceFactory', 'adsService', 'UserService', 'permissionValidationService', 'notificationsService', 'Utils','userScheduledService', '$ionicScrollDelegate',
    function ($rootScope, $scope, $state, TimeLineService, SequenceService, cqnzService, SequenceFactory, adsService, UserService, permissionValidationService, notificationsService, Utils, userScheduledService, $ionicScrollDelegate) {

      var permissions = permissionValidationService;
      var myUserId = UserService.get_USERSUBSCRIPTIONINSTANCE_ID();

      //$scope.iAmAdvertiser = UserService.USER_IS_ADVERTISER();
      $scope.iAmAdvertiser = permissions.canAdvertisementPermit();
      
      var myUserId = UserService.get_USERSUBSCRIPTIONINSTANCE_ID();
      //$scope.iAmAdvertiser = UserService.USER_IS_ADVERTISER();
      var permissions = permissionValidationService;
      $scope.iAmAdvertiser = permissions.canAdvertisementPermit();
      $scope._controllerName = "scheduledTimelineCtrl";
      $scope._groupHrefId = 0;//Default timeline

      //------- CONFIG FOR SEQUENCE ITEMS -------
      $scope.isUserProfile = true;
      $scope.hideAvatar = true;
      $scope.hideUsername = true;
      //---- END CONFIG FOR SEQUENCE ITEMS -----
      $scope.goBack = function () {
        $state.go("menu.myProfile")
      }

      $scope.data = {};

      //////////////////////////
        var pagination = {
          start: 0,
          count: 3,
          reset: function () {
            this.start = 0;
            this.count = 3;
          },
          increaseCount: function (step) {
            this.count = 3
          }
        };
      //////////////////////////
      $scope._sequenceList = [];
      $scope.isFirstTime = true;
      $scope.isRefreshing = false;
      $scope.isLoadingMyContent = false;
      $scope.canGetMoreItems = true;
      $scope.errorLoading = false;
      $scope.data.activeTab = "general";

      $scope.refreshPage = function () {
        $scope._sequenceList = [];
        pagination.reset();
        $scope.findScheduledPosts(true);
      }

      $scope.findScheduledPosts = function (newRound) {
        
        if(newRound) {
          pagination.reset();
        }

        if ($scope.isLoadingMyContent) return;

        $scope.isLoadingMyContent = true;

        userScheduledService.findScheduledPosts({
          id: UserService.get_USERSUBSCRIPTION_ID(),
          start: pagination.start,
          count: pagination.count
        }).$promise.then( function (scheduledList) {

          Utils.removeLastItemIfHasNoAttribute(scheduledList, 'sequence');

          //console.log(scheduledList);

          var fetchedCqnzsLength = scheduledList.length;

          $scope.canGetMoreItems = fetchedCqnzsLength >= pagination.count;

          if (!fetchedCqnzsLength) {
            $scope.isRefreshing = false;
            $scope.isLoadingMyContent = false;
            $scope.$broadcast('scroll.infiniteScrollComplete');
            return;
          }

          pagination.start += scheduledList.length;
          pagination.increaseCount();

          scheduledList.forEach(function (cqnzBasicData) {

            var commentsCounts = cqnzService.countSequenceCommentsByGroupWS({
              sequenceId: cqnzBasicData.sequenceId,
              groupId: $scope._groupHrefId
            }).$promise;

            var tagsList = SequenceService.obtainTagwithIdandTypev166({
              sequenceId: cqnzBasicData.sequenceId,
              notificationType: 7
            });

            //LuMa HashTags in sequence
            //var hashesList = SequenceService.getHashFromSequence(cqnzBasicData.sequenceId);
            var hashesList = SequenceService.findSequenceHashTagComment({
              sequenceId: cqnzBasicData.sequenceId,
              notificationType: 7,
              commentId: 0
            });

            Utils.$q.all({
              commentsCounts: commentsCounts,
              tagsList: tagsList,
              hashesList: hashesList
            }).then(function (myProfileCqnz) {
              myProfileCqnz.basicData = cqnzBasicData;

              myProfileCqnz.sequenceOwnerId = myUserId;
              myProfileCqnz.sequenceItems = cqnzService.getItemsToSequenceV165WS(myProfileCqnz.basicData.sequenceId);
              myProfileCqnz.likeActive = SequenceService.findSmileysCount({
                sequenceId: Utils.getLastUrlComponent(myProfileCqnz.basicData.sequence.href),
                userId: myUserId
              });
              myProfileCqnz.followEachOther = {result: {value: true}};
              myProfileCqnz.viewsCounter = myProfileCqnz.basicData.isAdvertisement && myProfileCqnz.sequenceOwnerId == myUserId ? adsService.getViewsCount(myProfileCqnz.basicData.sequenceId) : null;
              myProfileCqnz.clicksCounter = myProfileCqnz.basicData.isAdvertisement && myProfileCqnz.sequenceOwnerId == myUserId ? adsService.getClicksCount(myProfileCqnz.basicData.sequenceId) : null;
              myProfileCqnz.URLClicksCounter = myProfileCqnz.basicData.isAdvertisement && myProfileCqnz.sequenceOwnerId == myUserId ? adsService.getURLClicksCount(myProfileCqnz.basicData.sequenceId) : null;

              myProfileCqnz.basicData.sequenceCommentCount = myProfileCqnz.commentsCounts.result.value;

              var commentsPromises = {};
              if (myProfileCqnz.basicData.sequenceCommentCount) {
                //console.log("getting comments of (" + cqnzId + ", " + groupId + ")");
                commentsPromises[$scope._groupHrefId] = cqnzService.getCommentsOfSequenceWS({
                  sequenceId: cqnzBasicData.sequenceId,
                  start: 0,
                  count: 2,
                  groupId: $scope._groupHrefId
                }).$promise
              }

              if(myProfileCqnz.basicData.groupId != 0) {
                console.log("For groups");
                myProfileCqnz.isLoadingGroups = true;
                myProfileCqnz.groupsOwned = userScheduledService.getGroupInfoFromScheduledPost({
                  sequenceId: cqnzBasicData.sequenceId,
                  start: 0,
                  count: 0
                });
              } else {
                console.log("Not for groups");
                myProfileCqnz.isLoadingGroups = false;
                myProfileCqnz.groupsOwned = [];
              }

              myProfileCqnz.comments = [];
              Utils.$q.all(commentsPromises).then(function (resolvedComments) {
                Object.keys(resolvedComments).forEach(function (groupId) {
                  Utils.removeLastItemIfHasNoAttribute(resolvedComments[groupId], 'commentId');
                  if (resolvedComments[groupId].length) {
                    resolvedComments[groupId].groupId = groupId;
                    myProfileCqnz.comments = myProfileCqnz.comments.concat(resolvedComments[groupId]);
                  }
                });

                //$scope._sequenceList.push(cqnzService.configureSequence(myProfileCqnz));
                $scope._sequenceList.push(SequenceFactory.buildSequenceObject(myProfileCqnz));

                $scope.isRefreshing = false;
                $scope.isLoadingMyContent = false;

                $scope.$broadcast('scroll.infiniteScrollComplete');
                setTimeout(function () {
                  Utils.$ionicScrollDelegate.resize();
                }, 800);
              }, function (error) {
                console.log("all(commentsPromises)", error);
                //$scope._sequenceList.push(cqnzService.configureSequence(myProfileCqnz));
                $scope._sequenceList.push(SequenceFactory.buildSequenceObject(myProfileCqnz));

                $scope.isRefreshing = false;
                $scope.isLoadingMyContent = false;

                $scope.$broadcast('scroll.infiniteScrollComplete');
                setTimeout(function () {
                  Utils.$ionicScrollDelegate.resize();
                }, 800);
              })
            }, function (errors) {
              console.error("Comments-Tags-Hashes error", errors);
              $scope.errorLoading = true;
              $scope.canGetMoreItems = false;

              $scope.isRefreshing = false;
              $scope.isLoadingMyContent = false;

              $scope.$broadcast('scroll.infiniteScrollComplete');
              setTimeout(function () {
                Utils.$ionicScrollDelegate.resize();
              }, 800);
            })
          });
        }, function (scheduledError) {
          console.log("findLatestScheduledPostBelongingToAUser", scheduledError);
          $scope.errorLoading = true;
          $scope.canGetMoreItems = false;

          $scope.isRefreshing = false;
          $scope.isLoadingMyContent = false;

          $scope.$broadcast('scroll.infiniteScrollComplete');
          setTimeout(function () {
            Utils.$ionicScrollDelegate.resize();
          }, 800);
        })
      }
      $scope.findScheduledPosts(true);

    }])

;

/**
 * @typedef {Object} GroupWithErrors
 * @property {string} groupName
 * @property {{status:number, statusText:string, message:string}} error
 */

//4805 lines

//que aparezca la palomita en cuentas verificadas, en todas partes donde aparece el nombre del user
//fotos en comments
//respuestas a comments (respuestas agrupadas/truncadas)

