"use strict";

appControllers
  //Partials controllers...
  //Controller para alert, confirm, prompt
  .controller("DialogController", ["$scope", "$mdDialog", "displayOption",
    function($scope, $mdDialog, displayOption) {
      $scope.displayOption = displayOption;

      $scope.cancel = function() {
        $mdDialog.cancel()
      };

      $scope.ok = function() {
        $mdDialog.hide()
      };
    }
  ])

  .controller('ModalController', ["$scope", "$mdDialog", 'locals', function($scope, $mdDialog, locals) {
    $scope.locals = locals;
    //console.log(locals);

    $scope.ok = function() {
      $mdDialog.hide($scope.locals);
    };

    $scope.cancel = function() {
      $mdDialog.cancel();
    };
  }])

  .controller('GroupListBottomSheetCtrl', ["$scope", "$mdBottomSheet", function($scope, $mdBottomSheet) {
    $scope.listItemClick = function(btnId) {
      $mdBottomSheet.hide(btnId);
    };
  }])

  //LuMa 10-09-19 se agregaron StreamingService, UserService , AntMediaServer al controler
  .controller('footerCtrl', ["$rootScope", "$scope", '$state', 'permissionValidationService', 'notificationsService', 'ChatFactory2', 'GroupFactory', 'Utils', 'StreamingService', 'UserService', 'AntMediaServer', '$window', '$location',
    function($rootScope, $scope, $state, permissionValidationService, notificationsService, ChatFactory2, GroupFactory, Utils, StreamingService, UserService, AntMediaServer, $window, $location, $anchorScroll) {
      console.log("---- footerCtrl created!");
      Utils.clearCache();

      var permissions = permissionValidationService;
      $scope.isIOS = ionic.Platform.isIOS();
      var buttonsStateName = [
        { state: 'menu.timeline', name: 'board' },
        { state: 'menu.groupsTabs.myGroups', name: 'group' },
        { state: 'menu.discover', name: 'discovery' },
        { state: 'upload', name: 'upload' },
        { state: 'uploadVideo', name: 'upload' },
        { state: 'menu.messagesInbox', name: 'messages' },
        { state: 'menu.notificationTabs', name: 'notifications' }
      ];

      checkStateAndActivateButton($state.current.name);

      function checkStateAndActivateButton(stateName) {
        var activeButton;
        buttonsStateName.some(function(item) {
          if (stateName.indexOf(item.state) > -1) {
            return activeButton = item;
          }
        });

        activateButton(activeButton ? activeButton.name : 'none');
      }

      function activateButton(buttonName) {
        $scope.botonHomeOn = false;
        $scope.botonGroupOn = false;
        $scope.botonSearchOn = false;
        $scope.botonUploadOn = false;
        $scope.botonMessageOn = false;
        $scope.botonNotificationOn = false;

        switch (buttonName) {
          case 'board':
            $scope.botonHomeOn = true;
            break;
          case 'group':
            $scope.botonGroupOn = true;
            break;
          case 'discovery':
            $scope.botonSearchOn = true;
            break;
          case 'upload':
            $scope.botonUploadOn = true;
            break;
          case 'messages':
            $scope.botonMessageOn = true;
            break;
          case 'notifications':
            $scope.botonNotificationOn = true;
            break;
          case 'none':
            break;
          default:
            Utils.toast.error("Footer Option " + buttonName + " is not valid");
        }
      }

      function chkBtnHome() {
        var groupIndexIn = getGroupIndex();
        console.log("ESTAMOS EN ", $state.current.name);
        console.log("GRUPO NO", groupIndexIn)
        if($state.current.name === 'menu.timeline' && groupIndexIn===0) {
          $scope.botonHomeOn = true;
          $scope.botonGroupOn = false;
        } else if ($state.current.name === 'menu.timeline' && groupIndexIn>0) {
          $scope.botonHomeOn = false;
          $scope.botonGroupOn = true;
        }
      }
      chkBtnHome();

      /*var eventButtonColor = $rootScope.$on("changeToTL", function(evt, data) {
        console.log("TRIGGER ENTER TIMELINE")
        if($state.current.name === 'menu.timeline') {
          if(data.inGroup) {
            $scope.botonHomeOn = false;
            $scope.botonGroupOn = true;
          } else {
            $scope.botonHomeOn = true;
            $scope.botonGroupOn = false;
          }
        } else {
          //NOHING
          $scope.botonHomeOn = false;
          $scope.botonGroupOn = false;
        }
        console.log("HOME", $scope.botonHomeOn);
        console.log("GROUPS", $scope.botonGroupOn);
      })*/

      $scope.showButtonsArea = false;
      $scope.canShowStatementBtn = false;
      $scope.canShowPhotoBtn = false;
      $scope.canShowVideoBtn = false;
      $scope.waitingShowStatement = false;
      $scope.canShowStreamingBtn = false; //LuMa Live Streaming

      //when leaving this controller...
      $rootScope.$on('$stateChangeStart', function(event, toState, toParams, fromState, fromParams, options) {
        //console.log("********* FooterCtrl: $stateChangeStart")
        $scope.showButtonsArea = false;
        //eventButtonColor();
        checkStateAndActivateButton(toState.name);
        $scope.totalUnreadMessages = ChatFactory2.getTotalUnreadMsgs();
        Utils.$timeout(function() {
          //console.log("unread messages: %d", $scope.totalUnreadMessages);
          $rootScope.$apply();
        }, 10);
      });

      $scope.totalNotifications =
        notificationsService.badges.unreadRegularNotifications +
        notificationsService.badges.unreadFollowersNotifications;

      $rootScope.$on("notifications.new", function(event, data) {
        $scope.totalNotifications = data.unreadRegularNotifications + data.unreadFollowersNotifications;
      });

      $scope.totalUnreadMessages = ChatFactory2.getTotalUnreadMsgs();

      $rootScope.$on("chat.messages.unread", function(event, data) {
        console.log("------ $rootScope.$on: chat.messages.unread", data.total);
        $scope.totalUnreadMessages = data.total;
        Utils.$timeout(function() {
          $rootScope.$apply();
        }, 10);
      });

      $scope.showUploadButton =
        permissions.canCreateStatementPostInGralTimeline() || permissions.canCreateStatementPostInGroupTimeline() ||
        permissions.canCreatePhotoPostInGralTimeline() || permissions.canCreatePhotoPostInGroupTimeline() ||
        permissions.canCreateVideoPostInGralTimeline() || permissions.canCreateVideoPostInGroupTimeline() ||
        permissions.canStream(); //LuMa Live Streaming;

      function getGroupIndex() {
        return GroupFactory.getCurrentGroupIndex();
      }

      $scope.onBoardBtnClickedOld = function(forceDefaultTimeline) {
        Utils.clearHistory();
        if (forceDefaultTimeline || getGroupIndex() > 0) {
          var groupIndexIn = getGroupIndex();
          Utils.clearCache();
          GroupFactory.setCurrentGroupIndex(groupIndexIn);

          $state.go("menu.timeline", {}, { reload: true });
          $rootScope.$broadcast("gotoSlide", { slide: groupIndexIn });
          /*Utils.$timeout(function () {
            $rootScope.$broadcast("gotoSlide", {slide: 0});
          }, 150);*/
        } else {
          if ($state.current.name === 'menu.timeline') {
            Utils.$timeout(function() {
              Utils.$ionicScrollDelegate.$getByHandle('mainScroll').scrollTop();
              /*var anchorF = document.getElementById("TimeLineCtrl_seq_0");
              anchorF.scrollIntoView({block: "start", behavior: "auto"});*/
              //$window.scrollTo(0, 0);
            },);
          } else {
            //Utils.setNextViewAsRoot();
            $state.go("menu.timeline", {});
          }
        }
      };

      $scope.onBoardBtnClicked = function (openStatement) {
        var groupIndexIn = getGroupIndex();
        if(openStatement) {
          Utils.clearCache();
          GroupFactory.setCurrentGroupIndex(0);
          $state.go("menu.timeline", {}, { reload: true });
          $rootScope.$broadcast("gotoSlide", { slide: 0 });
        } else {
          if(groupIndexIn>0 && $state.current.name === 'menu.timeline') {
            Utils.clearCache();
            GroupFactory.setCurrentGroupIndex(0);
            $state.go("menu.timeline", {groupIndex: 0}, { reload: true });
          } else if(groupIndexIn===0 && $state.current.name === 'menu.timeline') {
            Utils.$timeout(function() {
              Utils.$ionicScrollDelegate.$getByHandle('mainScroll').scrollTop();
            },);
          } else {
            Utils.clearCache();
            GroupFactory.setCurrentGroupIndex(0);
            $state.go("menu.timeline", {groupIndex: 0}, { reload: true });
          }
        }
      }

      $scope.onGroupBtnClicked = function (openStatement) {
        var groupIndexIn = getGroupIndex();
        if(groupIndexIn>0 && $state.current.name === 'menu.timeline') {
          Utils.$timeout(function() {
            Utils.$ionicScrollDelegate.$getByHandle('mainScroll').scrollTop();
          },);
        } else {
          Utils.clearCache();
          $state.go("menu.groupsTabs.myGroups", {}, { reload: true });
        }
      }

      $scope.onDiscoveryBtnClicked = function() {
        Utils.clearHistory();
        //Utils.setNextViewAsRoot();
        $state.go("menu.discovery");
      };

      $scope.showUploadOptionsPopup = function() {
        if ($scope.showButtonsArea) {
          $scope.showButtonsArea = false;
        } else {
          $scope.showButtonsArea = true;

          var currStateName = $state.current.name;

          var noPermissions = true;

          //var ImInTimelines = currStateName === 'menu.timeline';
          $scope.canShowStatementBtn = permissions.canCreateStatementPostInGralTimeline() ||
            permissions.canCreateStatementPostInGroupTimeline();
          $scope.canShowPhotoBtn = currStateName !== 'upload' &&
            (getGroupIndex() === 0 && permissions.canCreatePhotoPostInGralTimeline() ||
              getGroupIndex() > 0 && permissions.canCreatePhotoPostInGroupTimeline());
          $scope.canShowVideoBtn = currStateName !== 'uploadVideo' &&
            (getGroupIndex() === 0 && permissions.canCreateVideoPostInGralTimeline() ||
              getGroupIndex() > 0 && permissions.canCreateVideoPostInGroupTimeline());
          //LuMa Live Streaming mostrar en el footer
          if (permissions.canStream()) {
            $scope.canShowStreamingBtn = currStateName !== 'streamingOnLive' && permissions.canStream();
          }
          if (getGroupIndex() === 0) {
            noPermissions = !permissions.canCreateStatementPostInGralTimeline() &&
              !$scope.canShowPhotoBtn && !$scope.canShowVideoBtn;

            if (noPermissions) {
              Utils.toast.warning(Utils.translate('PERMISSIONS.CANNOT.GRAL_TLINE_CQNZ_CREATE'));
              return;
            }
            //if user is in default timeline and only statements are enabled, just open the composer screen directly
            /*if (ImInTimelines && !$scope.canShowPhotoBtn && !$scope.canShowVideoBtn) {
              $rootScope.$broadcast("openStatementForm");
              return;
            }*/
          } //user wants to post in group timeline...
          else {
            noPermissions = !permissions.canCreateStatementPostInGroupTimeline() &&
              !$scope.canShowPhotoBtn && !$scope.canShowVideoBtn;

            if (noPermissions) {
              Utils.toast.warning(Utils.translate('PERMISSIONS.CANNOT.GROUP_TLINE_CQNZ_CREATE'));
              return;
            }

            var groupsList = GroupFactory.getCurrentAvailableUserGroupsList();
            if (groupsList[getGroupIndex() - 1].imLocked) {
              //"You can't upload content in this group because you are temporarily locked from it"
              Utils.toast.warning(Utils.translate('GROUPS.TIMELINE_WRAPPER.DIALOG.UPLOAD_LOCKED_ERR'));
              return;
            }
            //if user is in group timeline and only statements are enabled, just open the composer screen directly
            /*if (ImInTimelines && !$scope.canShowPhotoBtn && !$scope.canShowVideoBtn) {
              $rootScope.$broadcast("openStatementForm");
              return;
            }*/
          }

          $scope.showButtonsArea = true;
        }
      };

      $scope.onMessagesBtnClicked = function() {
        Utils.clearHistory();
        //Utils.setNextViewAsRoot();
        $state.go('menu.messagesInbox', {}, { reload: true });
      };

      $scope.onNotificationsBtnClicked = function() {
        Utils.clearHistory();
        //Utils.setNextViewAsRoot();
        $state.go('menu.notificationTabs.regular', {}, { reload: true });
      };

      $scope.onStatementUploadBtnClicked = function() {
        console.log("trigger statement");
        if ($scope.waitingShowStatement) {
          return true;
        }
        $scope.waitingShowStatement = true;
        if ($state.current.name === 'menu.myProfile') {
          $scope.onBoardBtnClicked(0);
        } else {
          Utils.clearHistory();
          //Utils.setNextViewAsRoot();
          $state.go("menu.timeline");
        }

        Utils.$timeout(function() {
          $scope.waitingShowStatement = false;
          $rootScope.$broadcast("openStatementForm");
        }, 800);
      };

      $scope.onUploadPhotoBtnClicked = function() {
        if ($state.current.name === 'menu.myProfile') {
          GroupFactory.setCurrentGroupIndex(0);
        }

        $state.go('upload');
      };

      $scope.onUploadVideoBtnClicked = function() {
        if ($state.current.name === 'menu.myProfile') {
          GroupFactory.setCurrentGroupIndex(0);
        }

        $state.go('uploadVideo');
      };

      //LuMa Live Streaming
      $scope.onLiveStreamingBtnClicked = function() {
        $state.go('streamingOnLive');
      }

      //to execute the next function from parent controller
      if ($scope.MyProfileSharedCtrl)
        $scope.MyProfileSharedCtrl.openUploadAreaFromParent = $scope.showUploadOptionsPopup;

      $scope.closeButtonsArea = function() {
        $scope.showButtonsArea = false;
      };

      $scope.$on('$destroy', function() {
        
      });

    }
  ])

  .controller('tagsModalCtrl', ['$rootScope', '$scope', 'UserService', 'cqnzService', 'TagsService', 'FileService3', 'ImageService3', 'Utils', 'locals', 'ImageService2', 'FileService2', '$ionicActionSheet', '$jrCrop', '$timeout',
    function($rootScope, $scope, UserService, cqnzService, TagsService, FileService3, ImageService3, Utils, locals, ImageService2, FileService2, $ionicActionSheet, $jrCrop, $timeout) {
      var lastSearch,
        pendingSearch,
        pendingSearchH,
        cancelSearch = angular.noop;

      var TAG = "Tag";
      var HASH = "Hash";
      var NONE = "none";

      $scope.showAddimageButton = locals.showAddimageButton;
      $scope.editMode = locals.editMode;

      //search results go here
      $scope.tagList = [];
      $scope.hashList = [];

      var tagsSelected = [];
      var hashtagsSelected = [];

      $scope.form = {
        description: locals.description || '',
        savedTags: locals.tagsList || [],
        savedTagsClone: locals.tagsList || [],
        savedHashes: locals.hash || [],
        savedHashesClone: locals.hash || [],
        imagePath: locals.imagePath || '',
        searchTerm: '',
        bigText: locals.plusLength || false,
        maxCharacters: locals.isTitle ? 90 : (locals.plusLength ? 3000 : 500),
        showSearch: locals.needSearch
      };

      var tagPagination = {
        start: 0,
        count: 10,
        reset: function() {
          this.start = 0;
          this.count = 10;
        },
        increaseCount: function(step) {
          this.count = step || 5
        }
      }

      var hashPagination = {
        start: 0,
        count: 10,
        reset: function() {
          this.start = 0;
          this.count = 10;
        },
        increaseCount: function(step) {
          this.count = step || 2
        }
      };

      console.log("$scope.form", $scope.form);

      var description = "";
      var previousText = "";
      var textForSearch = "";
      var taskDoing = NONE;
      var textLength = 0;
      var deleting = false;
      $scope.isIOS = Utils.platformName() === 'ios';
      var temporalyText = "";
      var isIOS = ionic.Platform.isIOS();
      var textArea;
      $scope.canSearchMoreUsers = true;
      $scope.userPastedSomething = false;
      function focusTextArea() {
        setTimeout(function() {
          if (!textArea)
            textArea = document.querySelector('#main-textarea');

          if (textArea) {
            textArea.selectionStart = $scope.form.description.length;
            textArea.selectionEnd = $scope.form.description.length;
            textArea.focus();

            autosize();
          }
        }, 900);
      }

      focusTextArea();

      var searchInput;

      function focusSearchInput() {
        setTimeout(function() {
          if (!searchInput)
            searchInput = document.getElementsByClassName('mySearchableInput');

          if (searchInput) {
            searchInput = searchInput[searchInput.length - 1];
            searchInput.selectionStart = $scope.form.description.length;
            searchInput.selectionEnd = $scope.form.description.length;
            searchInput.focus();
          } else
            console.log("can't find search input")
        }, 900);
      }

      $scope.areaIsExpanded = false;
      $scope.fromScroll = false;
      $scope.chkWhatSearch = function(fromInfinite) {
        /*if (!$scope.form.showSearch)
          return;*/

        $scope.fromScroll = fromInfinite;
        if ($scope.areaIsExpanded) {
          if (taskDoing == TAG)
            searchTags($scope.form.searchTerm);
          else if (taskDoing == HASH)
            searchHashTags($scope.form.searchTerm);
        } else {
          $scope.lookUp();
        }
      }

      $scope.expandSearchArea = function(expand) {
        $scope.areaIsExpanded = expand;

        if (expand)
          focusSearchInput();
        else
          focusTextArea();
      };

      /*$scope.fullLookUp = function() {
        if (taskDoing == TAG)
          searchTags($scope.form.searchTerm);
        else if (taskDoing == HASH)
          searchHashTags($scope.form.searchTerm);
      };*/

      $scope.countCharsTexted = 0;

      $scope.mentions = {
        description: "",
        oldDescription: "",
        mode: "NONE",
        position_start: 0,
        position_end: 0,
        deleting: false,
        lastChar: "",
        textForSearch: ""
      }

      function resetMentionsData() {
        $scope.mentions = {
          description: "",
          oldDescription: "",
          mode: "NONE",
          position_start: 0,
          position_end: 0,
          deleting: false,
          lastChar: "",
          textForSearch: ""
        }
      }

      $scope.taghashData = {
        positionStart_Prev: 0,
        positionEnd_Prev: 0,
        positionStart_Current: 0,
        positionEnd_Current: 0,
        description: "",
        description_old: "",
        mode: null,
        delete: null,
        lastChar: "",
        textForSearch: "",
      }

      $scope.lookTextWrited = function() {
        // get area of work
        var area = document.getElementById('main-textarea');
        //check cursor for new text
        $scope.taghashData.positionStart_Current = area.selectionStart;
        $scope.taghashData.positionEnd_Current = area.selectionEnd;

        //check first if the text is empty or with space
        var charForSearch = null;
        if ($scope.taghashData.textForSearch === "" || $scope.taghashData.textForSearch === " ") {
          charForSearch = "";
        } else {
          charForSearch = $scope.taghashData.textForSearch;
        }

      }

      $scope.lookUp = function() {
        autosize();
        //check cursor index
        var areaUsed = document.getElementById('main-textarea');
        $scope.mentions.position_start = areaUsed.selectionStart;
        $scope.mentions.position_end = areaUsed.selectionEnd;
        //

        var charForSearch = "";
        if ($scope.mentions.textForSearch === "" || $scope.mentions.textForSearch === " ") {
          charForSearch = '';
        } else {
          charForSearch = $scope.mentions.textForSearch;
        }

        if ($scope.mentions.mode === "HASH") {
          console.log("text for search", charForSearch);
          taskDoing = HASH;
          searchHashTags(charForSearch);
        } else if ($scope.mentions.mode === "TAG") {
          console.log("text for search", charForSearch);
          taskDoing = TAG;
          searchTags(charForSearch, false);
        } else if ($scope.mentions.mode === "SELECT_UNIQUE_USER") {
          console.log("select unique tag in list");
          taskDoing = NONE;
          $scope.mentions.textForSearch = "";
          selectTag();
        } else if ($scope.mentions.mode === "SELECT_UNIQUE_HASH") {
          console.log("select unique hash in list");
          taskDoing = NONE;
          $scope.mentions.textForSearch = "";
          compareAddHash(charForSearch, $scope.hashList);
        } else if ($scope.mentions.mode === "CLEAR_TAG_SEARCH") {
          console.log("cleaning search in tag");
          taskDoing = NONE;
          $scope.mentions.textForSearch = "";
          clearSearch();
        } else {
          console.log("after time nothing to do");
        }
      }

      function selectTag() {
        var idx = -1;
        var symbolAt;
        var found = $scope.form.savedTags.some(function(tag, i) {
          if (tag.id == $scope.tagList[0].id) {
            idx = i;
            return true;
          }
        });
        symbolAt = $scope.mentions.position_end;

        if (!found) {
          $scope.form.savedTags.push($scope.tagList[0]);
        }
        $scope.tagList.isSelected = true;
        var exactPos = $scope.countCharsTexted + 1;
        $scope.form.description = $scope.form.description.slice(0, symbolAt - exactPos) +
          $scope.tagList[0].name + ' ' +
          $scope.form.description.slice(symbolAt, $scope.form.description.length);
        resetMentionsData();
        clearSearch();
        focusTextArea();
      }

      $scope.convertMode = function(event) {
        console.log("evento tecleado", event);
        if (event.keyCode === 16) {
          console.log("cambio teclado");
          return;
        }
        //console.log("trigger convertMode");
        //check cursor index
        var areaUsed = document.getElementById('main-textarea');
        $scope.mentions.position_start = areaUsed.selectionStart;
        $scope.mentions.position_end = areaUsed.selectionEnd;
        //

        //CHECK THE TEXT
        $scope.mentions.description = areaUsed.value;
        $scope.mentions.deleting = $scope.mentions.description.length < $scope.mentions.oldDescription.length;
        $scope.mentions.oldDescription = $scope.mentions.description;
        $scope.mentions.lastChar = $scope.mentions.description.charAt($scope.mentions.position_end - 1);
        console.log("ultimo escrito: ", $scope.mentions.lastChar);
        //
        //ASSIGN MODE
        if ($scope.mentions.deleting) {
          //if user is deleting we check the last mode
          var isTag = false;
          var isHash = false;
          var phrase = '';
          var phraseLength = 0;

          if ($scope.mentions.mode === "") {
            console.log("nothing to do");
          } else {
            //if any mode is active and the user is deleting we must check all text in reverse
            var exactChar = 0;
            for (var a = $scope.mentions.position_end; a >= 0; a--) {
              if (a != 0)
                exactChar = a - 1;
              else
                exactChar = a;
              if ($scope.mentions.description.charAt(exactChar) === ' ') {
                break;
              } else if ($scope.mentions.description.charAt(exactChar) === '#') {
                phraseLength - 1;
                isHash = true;
                break;
              } else if ($scope.mentions.description.charAt(exactChar) === '@') {
                isTag = true;
                phraseLength - 1;
                break;
              } else {
                //if nothing found, continue with the search
                phraseLength++;
                continue;
              }
            }
            if (isHash === true || isTag === true) {
              $scope.mentions.textForSearch = $scope.mentions.description.slice($scope.mentions.position_end - phraseLength, $scope.mentions.position_end);
              console.log('phrase rescued', $scope.mentions.textForSearch);
              if (isHash) {
                $scope.countCharsTexted = phraseLength;
                $scope.mentions.mode = "HASH";
                return;
              } else if (isTag) {
                $scope.countCharsTexted = phraseLength;
                $scope.mentions.mode = "TAG";
                return;
              }
            }
          }
        } else if ($scope.mentions.mode === 'NONE') {
          //IF we are in mode none and detect # or @ we check condictions
          if ($scope.mentions.description.substring($scope.mentions.position_end - 2, $scope.mentions.position_end - 1) === ' ' ||
            $scope.mentions.description.substring($scope.mentions.position_end - 2, $scope.mentions.position_end - 1) === '') {
            if ($scope.mentions.lastChar === '#') {
              $scope.mentions.mode = "HASH";
              $scope.mentions.textForSearch = '';
              return;
            } else if ($scope.mentions.lastChar === '@') {
              $scope.mentions.mode = "TAG";
              $scope.mentions.textForSearch = '';
              return;
            } else {
              console.log("normal mode");
              return;
            }
          }
        } else if ($scope.mentions.lastChar === " ") {
          if ($scope.mentions.mode === "TAG") {
            if ($scope.tagList.length > 1) {
              //the list of users is more than 1
              //we cannot select one, yet
              $scope.mentions.textForSearch = $scope.mentions.textForSearch + $scope.mentions.lastChar;
              return;
            } else if ($scope.tagList.length === 1) {
              //select the user
              $scope.mentions.textForSearch = $scope.mentions.textForSearch;
              $scope.mentions.mode = "SELECT_UNIQUE_USER";
              return;
            } else {
              $scope.mentions.mode = "CLEAR_TAG_SEARCH";
              return;
            }
          } else if ($scope.mentions.mode === "HASH") {
            console.log("space, need to compare with the list")
            $scope.mentions.textForSearch = $scope.mentions.textForSearch;
            $scope.mentions.mode = "SELECT_UNIQUE_HASH";
            return;
          }
        } else {
          $scope.mentions.textForSearch = $scope.mentions.textForSearch + $scope.mentions.lastChar;
          $scope.countCharsTexted = $scope.mentions.textForSearch.length;
        }
      }

      $scope.pasteSomething = function($event) {
        console.log("pasted!!");
        $scope.userPastedSomething = true;
        /*if(typeof $event.clipboardData !== "undefined") {
          $scope.handlePastedData($event.clipboardData.getData('text/plain'));
        } else {
          $timeout(function(){
            $scope.handlePastedData(angular.element($event.currentTarget).val());
          });
        }*/
      }

      $scope.handlePastedData = function(text) {
        var anyTags = text.split("@").length > 0 ? true : false;
        var listFind = text.split("@");
        var promises = [];
        listFind.forEach( function (data){
          console.log("data", data);
          UserService.searchUsersByPartialNameOrIncludingSpaces({
            term: data,
            start: 0,
            count: 10
          }).then(function(tagsList) {
            console.log("tagsList", tagsList);
            if(tagsList.length > 0) {

            } else {

            }
          }, function (errorTags) {

          })
        })
        /*Utils.$q.all(promises).then( function (good) {

        }, function (error) {

        })*/
      }

      function clearSearch() {
        taskDoing = NONE;
        textForSearch = "";
        $scope.tagList = [];
        $scope.hashList = [];
      }

      /**
       * Searches for users to @tag or topics to #hashtag
       * @param term {string} - term = search term without @ or # symbols
       */
      function searchTags(term) {
        if (!term || term.length < 3) {
          return;
        }

        if (!$scope.fromScroll) {
          tagPagination.reset();
          $scope.tagList = [];
        }

        var realterm = term.startsWith("@");
        if (realterm)
          term = term.substr(1);
        $scope.form.searchTerm = term;

        UserService.searchUsersByPartialNameOrIncludingSpaces({
          term: term,
          start: tagPagination.start,
          count: tagPagination.count
        }).then(function(tagList) {

          $scope.canSearchMoreUsers = tagList.length >= tagPagination.count;

          if (!tagList.length) {
            $scope.$broadcast('scroll.infiniteScrollComplete');
            return;
          }

          tagPagination.start += tagList.length;
          tagPagination.increaseCount();

          tagList.forEach(function(item, idx) {
            $scope.form.savedTags.some(function(tag) {
              if (tag.id == item.id)
                return tagList[idx].isSelected = true;
            })
          });

          if (!$scope.fromScroll) {
            $scope.tagList = tagList;
          } else {
            $scope.tagList.push.apply($scope.tagList, tagList);
          }
          $scope.$broadcast('scroll.infiniteScrollComplete');

        }, function(error) {
          console.error("couldn't get user tag list", error);
          reject(error);
          refreshDebounce();
        });
      }

      //todo: Add spinner in UI while searching
      function searchHashTags(term) {
        if (locals.disableHashSearching) {
          console.log("Disabled hashtags here");
          return pendingSearchH;
        }

        if (!term) {
          console.log("No search term");
          return pendingSearchH;
        }

        if (!pendingSearchH || !debounceSearch()) {
          cancelSearch();

          return pendingSearchH = Utils.$q(function(resolve, reject) {
            cancelSearch = reject;

            var realterm = term.startsWith("#");
            if (realterm)
              term = term.substr(1);
            //when we're not searching from the search box but from main text-area
            //we need to pass this value to be shown in search input when the UI is expanded
            $scope.form.searchTerm = term;
            //console.log("searching for: "+term);

            TagsService.searchHashtagsWS({
              term: term
            }).then(function(hashList) {
              $scope.canSearchMoreUsers = false;
              $scope.hashList = hashList;
              resolve(true);
              refreshDebounce();
            }, function(error) {
              console.error("couldn't get hashtag list", error);
            });
          })
        } else {
          console.warn("Pending Search for '" + term + "' or debouncing search");
          return pendingSearchH;
        }

        //if (!term || !debounceSearch()) return;
      }


      $scope.toggleSelectTag = function(item, type) {

        if (!$scope.areaIsExpanded) {
          var symbolAt;
          //position of cursor
          var areaUsed = document.getElementById('main-textarea');
          var startPos = areaUsed.selectionStart;
          var endPos = areaUsed.selectionEnd;
          console.log('Cursor at: ' + startPos + ',' + endPos);
          if (type == TAG) {

            var idx = -1;
            var found = $scope.form.savedTags.some(function(tag, i) {
              if (tag.id == item.id) {
                idx = i;
                return true;
              }
            });
            symbolAt = endPos;
            if (!found) { // if the user selected isn't in savedList we add it and complete the text
              $scope.form.savedTags.push(item);
              $scope.form.description = $scope.form.description.slice(0, symbolAt - $scope.countCharsTexted) +
                item.name + ' ' +
                $scope.form.description.slice(symbolAt, $scope.form.description.length);
            } else {
              //if the user click a user already in the list we clean the @**** and deselect that user
              var nameToCheck = "@" + item.name;
              var realPos = $scope.countCharsTexted + 1;
              $scope.form.description = $scope.form.description.slice(0, symbolAt - realPos) +
                $scope.form.description.slice(symbolAt, $scope.form.description.length);
              $scope.form.description = $scope.form.description.replace(nameToCheck, '');
              //$scope.form.description =  $scope.form.description.slice(0, $scope.form.description.length-1);
              $scope.form.savedTags.splice(idx, 1);
            }

            //console.log($scope.form.savedTags)
          } else if (type == HASH) {

            symbolAt = endPos;
            $scope.form.description = $scope.form.description.slice(0, symbolAt - $scope.countCharsTexted) +
              item.hash + ' ' +
              $scope.form.description.slice(symbolAt, $scope.form.description.length);

            //symbolAt = $scope.form.description.lastIndexOf('#');
            //$scope.form.description = $scope.form.description.slice(0, symbolAt + 1) + item.hash;
            item.new = false;
            var gotIt = false;
            for (var i = 0; i < $scope.form.savedHashes.length; i++) {
              var alreadyIn = item.hash.toUpperCase() === $scope.form.savedHashes[i].hash.toUpperCase() ? true : false;
              if (alreadyIn) {
                gotIt = true;
                console.log("The hashtag #" + item.hash + " is alredy in list")
                break;
              } else {
                gotIt = false;
                continue;
              }
            }
            if (!gotIt)
              $scope.form.savedHashes.push(item);
            /*if ($scope.form.savedHashes.indexOf(item) == -1)
              $scope.form.savedHashes.push(item);
            else
              console.log("The hashtag #" + item.hash + " is alredy in list")*/
          }

          taskDoing = NONE;
          textForSearch = "";
          $scope.tagList = [];
          $scope.hashList = [];
          resetMentionsData();
          focusTextArea();
          return;
        }

        item.isSelected = !item.isSelected;

        idx = -1;
        if (type == TAG) {
          idx = tagsSelected.indexOf(item);
          idx > -1 ? tagsSelected.splice(idx, 1) : tagsSelected.push(item);
        } else if (type == HASH) {
          idx = hashtagsSelected.indexOf(item);
          idx > -1 ? hashtagsSelected.splice(idx, 1) : hashtagsSelected.push(item);
        }
      };

      function compareAddHash(term, webServiceList) {
        if (webServiceList.length === 0) {
          //if at the moment when the user clicks space the list is empty
          //means the hash is new
          var item = {
            hash: term,
            id: null,
            new: true
          }
          var gotIt = false;
          //but before add it we must be sure that the item isn't in the final array already
          for (var i = 0; i < $scope.form.savedHashes.length; i++) {
            var alreadyIn = $scope.form.savedHashes[i].hash.toUpperCase() === term.toUpperCase() ? true : false;
            if (alreadyIn) {
              gotIt = true;
              break; //if the term is already in use we don't do anything
            } else {
              gotIt = false;
              continue;
            }
          }
          if (!gotIt) //if the term isn't found in the final array we add it
            $scope.form.savedHashes.push(item);
        } else {
          //if at the moment the user clicks space we have some items in the list
          //we compare the term with the list to check what hashtag was trying to get
          var inlist = false;
          var position = 0;
          for (var i = 0; i < webServiceList.length; i++) {
            var gotIt = webServiceList[i].hash.toUpperCase() === term.toUpperCase() ? true : false;
            if (gotIt) {
              inlist = true;
              position = i;
              console.log("writed term same as registered hash add it");
              break;
            } else {
              inlist = false;
              continue;
            }
          }
          //if after check all the list the writted term doesn't match with any from the WSList
          //we asume that the term is new but need to check if already have it in temporalList
          if (!inlist) {
            var item = {
              hash: term,
              id: null,
              new: true
            }

            var preList = false;
            for (var i = 0; i < $scope.form.savedHashes.length; i++) {
              var gotIt = $scope.form.savedHashes[i].hash.toUpperCase() === term.toUpperCase() ? true : false;
              if (gotIt) {
                preList = true;
                break;
              } else {
                preList = false;
                continue;
              }
            }
            if (!preList) {
              $scope.form.savedHashes.push(item);
            }
          } else {
            //if the writed term is equal to one registered we need to check if we have it
            //in temporal list before add it
            var preList = false;
            for (var i = 0; i < $scope.form.savedHashes.length; i++) {
              var gotIt = $scope.form.savedHashes[i].hash.toUpperCase() === webServiceList[position].hash.toUpperCase() ? true : false;
              if (gotIt) {
                preList = true;
                break;
              } else {
                preList = false;
                continue;
              }
            }
            if (!preList) {
              $scope.form.savedHashes.push(webServiceList[position]);
            }
          }
        }
        //after doing all the previous tasks we cancel the hashtag mode
        console.log("found writed hashtag, clear search");
        console.log("Space found, stopping search");
        resetMentionsData();
        clearSearch();
      };

      function compareAddTag(term, webServiceList) {
        //if()
      };

      function unselectAllItems() {
        $scope.tagList.forEach(function(item) {
          item.isSelected = false;
        });

        $scope.hashList.forEach(function(item) {
          item.isSelected = false;
        });
      }


      function refreshDebounce() {
        lastSearch = 0;
        pendingSearch = null;
        pendingSearchH = null;
        cancelSearch = angular.noop;
      }

      /**
       * Debounce if querying faster than 300ms
       */
      function debounceSearch() {
        var now = new Date().getMilliseconds();
        lastSearch = lastSearch || now;
        return ((now - lastSearch) < 300);
      }


      $scope.okClicked = async function() {
        if (!$scope.areaIsExpanded) {
          $scope.form.savedTags = TagsService.removeTagsNotFoundInText(
            $scope.form.description,
            $scope.form.savedTags
          );

          if (!locals.disableHashSearching) {
            $scope.form.savedHashes = TagsService.removeHashTagsNotFoundInText(
              $scope.form.description,
              $scope.form.savedHashes
            );

            $scope.form.savedHashes = await TagsService.addUncheckedTags(
              $scope.form.description,
              $scope.form.savedHashes
            );

            locals.dialog.hide({
              description: $scope.form.description,
              savedHashes: $scope.form.savedHashes,
              savedTags: $scope.form.savedTags,
              imagePath: $scope.form.imagePath[0]
            });
          } else {
            //console.log("tagsModalCtrl: Sendig the form", $scope.form);
            locals.dialog.hide({
              description: $scope.form.description,
              savedHashes: $scope.form.savedHashes,
              savedTags: $scope.form.savedTags,
              imagePath: $scope.form.imagePath[0]
            });
          }
        } else {
          if (!tagsSelected.length && !hashtagsSelected.length)
            return;

          console.log("Area is expanded, closing area");

          $scope.form.savedTags = $scope.form.savedTags.concat(tagsSelected);
          $scope.form.savedHashes = $scope.form.savedHashes.concat(hashtagsSelected);

          tagsSelected.forEach(function(tag, index) {
            if (index === 0) {
              var symbolAt = $scope.form.description.lastIndexOf('@');
              $scope.form.description = $scope.form.description.slice(0, symbolAt + 1) + tag.name;
            } else
              $scope.form.description += ' @' + tag.name;
          });

          hashtagsSelected.forEach(function(tag, index) {
            if (index === 0) {
              var symbolAt = $scope.form.description.lastIndexOf('#');
              $scope.form.description = $scope.form.description.slice(0, symbolAt + 1) + tag.hash;
            } else
              $scope.form.description += ' #' + tag.hash;
          });


          if ($scope.form.description.charAt($scope.form.description.length - 1) !== ' ')
            $scope.form.description += ' ';

          tagsSelected = [];
          hashtagsSelected = [];
          $scope.tagList = [];
          $scope.hashList = [];

          $scope.expandSearchArea(false);
        }

      };

      $scope.cancelClicked = function() {
        if (!$scope.areaIsExpanded) {
          locals.dialog.cancel();
        } else {
          unselectAllItems();
          tagsSelected = [];
          hashtagsSelected = [];
          $scope.expandSearchArea(false);
        }
      };

      var deregisterHardBack = Utils.$ionicPlatform.registerBackButtonAction(
        $scope.cancelClicked, 101
      );

      function autosize() {
        textArea.style.cssText = 'height:' + textArea.scrollHeight + 'px; width: 100%';
      }

      $scope.checkPermissionsBefore = function() {
        if (isIOS === true) {
          //getPermission(0);
          $scope.openImageOptions();
        } else {
          getMultiplePermissions();
        }
      }

      /**
       *function to get multiple permission for camera
       */
      function getMultiplePermissions() {
        cordova.plugins.diagnostic.getPermissionsAuthorizationStatus(function(statuses) {
          var havePerm = 0;
          var deniedPerm = false;
          for (var permission in statuses) {
            switch (statuses[permission]) {
              case cordova.plugins.diagnostic.permissionStatus.GRANTED:
                console.log("Permission granted to use " + permission);
                havePerm++;
                break;
              case cordova.plugins.diagnostic.permissionStatus.NOT_REQUESTED:
                console.log("Permission to use " + permission + " has not been requested yet");
                havePerm--;
                break;
              case cordova.plugins.diagnostic.permissionStatus.DENIED:
                console.log("Permission denied to use " + permission + " - ask again?");
                havePerm--;
                break;
              case cordova.plugins.diagnostic.permissionStatus.DENIED_ALWAYS:
                console.log("Permission permanently denied to use " + permission + " - guess we won't be using it then!");
                deniedPerm = true;
                break;
            }
          }
          if (!deniedPerm) {
            if (havePerm == 2) {
              //have both permissions granted
              $scope.openImageOptions();
            } else if (havePerm < 2) {
              //both or one permission hasn't granted
              askMultiplePermissions();
            }
          } else {
            Utils.toast.error(Utils.translate('PLUGINS.PERMISSIONS.DENIED_PERMISSION') +
              Utils.translate('PLUGINS.PERMISSIONS.TYPE.CAMERA') + ' ' +
              Utils.translate('PLUGINS.PERMISSIONS.AND') + ' ' +
              Utils.translate('PLUGINS.PERMISSIONS.TYPE.GALLERY') + '. \n' +
              Utils.translate('PLUGINS.PERMISSIONS.ALWAYS_DENIED_PERMISSION'));
          }
        }, function(error) {
          console.error("The following error occurred: " + error);
        }, [
          cordova.plugins.diagnostic.permission.CAMERA,
          cordova.plugins.diagnostic.permission.READ_EXTERNAL_STORAGE
        ])
      }

      /**
       *function to get multiple permission for camera
       */
      function askMultiplePermissions() {
        cordova.plugins.diagnostic.requestRuntimePermissions(function(statuses) {
          var havePerm = 0;
          var deniedPerm = false;
          for (var permission in statuses) {
            switch (statuses[permission]) {
              case cordova.plugins.diagnostic.permissionStatus.GRANTED:
                console.log("Permission granted to use " + permission);
                havePerm++;
                break;
              case cordova.plugins.diagnostic.permissionStatus.NOT_REQUESTED:
                console.log("Permission to use " + permission + " has not been requested yet");
                havePerm--;
                break;
              case cordova.plugins.diagnostic.permissionStatus.DENIED:
                console.log("Permission denied to use " + permission + " - ask again?");
                havePerm--;
                break;
              case cordova.plugins.diagnostic.permissionStatus.DENIED_ALWAYS:
                console.log("Permission permanently denied to use " + permission + " - guess we won't be using it then!");
                deniedPerm = true;
                break;
            }
          }
          if (!deniedPerm) {
            if (havePerm == 2) {
              //have both permissions granted
              $scope.openImageOptions();
            } else if (havePerm < 2) {
              //both or one permission hasn't granted
              Utils.toast.error(Utils.translate('PLUGINS.PERMISSIONS.DENIED_PERMISSION') +
                Utils.translate('PLUGINS.PERMISSIONS.TYPE.CAMERA') + ' ' +
                Utils.translate('PLUGINS.PERMISSIONS.AND') + ' ' +
                Utils.translate('PLUGINS.PERMISSIONS.TYPE.GALLERY') + '.');
            }
          } else {
            Utils.toast.error(Utils.translate('PLUGINS.PERMISSIONS.DENIED_PERMISSION') +
              Utils.translate('PLUGINS.PERMISSIONS.TYPE.CAMERA') + ' ' +
              Utils.translate('PLUGINS.PERMISSIONS.AND') + ' ' +
              Utils.translate('PLUGINS.PERMISSIONS.TYPE.GALLERY') + '. \n' +
              Utils.translate('PLUGINS.PERMISSIONS.ALWAYS_DENIED_PERMISSION'));
          }
        }, function(error) {
          console.error("The following error occurred: " + error);
        }, [
          cordova.plugins.diagnostic.permission.CAMERA,
          cordova.plugins.diagnostic.permission.READ_EXTERNAL_STORAGE
        ])
      }

      $scope.openImageOptions = function() {
        $scope.hideSheet = $ionicActionSheet.show({
          buttons: [
            { text: 'Take photo' },
            { text: 'Photo from library' }
          ],
          titleText: 'Add images',
          cancelText: 'Cancel',
          buttonClicked: function(index) {
            $scope.getMessageImage(index);
          }
        });

        /*ImageService3.showImageSelectionOptions().then(function (index) {
          if (index === -1) return;
          FileService3.cleanImages();

          //if index >=0 && index < 3
          ImageService3.openCameraOrAlbumOrGallery({sourceType: index}).then(function (imageURI) {
            FileService3.storeImage(imageURI);
            $scope.form.imagePath = imageURI;
          }, function (error) {
            if (error !== "No Image Selected") {
              console.error("openCameraOrLibrary(" + index + ")", error);
              Utils.toast.error(Utils.translate("ERROR.UNKNOWN"));
            }
          });
        });*/
      };

      FileService2.cleanImages();
      $scope.form.imagePath = FileService2.images();
      $scope.getMessageImage = function(index) {
        $scope.hideSheet();
        $scope.form.imagePath = [];
        if (index === 0) { // camera
          ImageService2.saveCameraMediaMessagePhoto(index).then(function() {});
        } else { // library
          ImageService2.saveAlbumMediaMessagePhoto(index).then(function() {});
        }
      }

      $rootScope.$on("addedImageMsg", function() { // LISTENER FOR IMAGE LOADED
        console.log("finally");
        showImageUser();
      });

      function showImageUser() {
        //begin the image functions
        var img = FileService2.images();
        var exifTemp = FileService2.exifImage();
        if (img.length === 0) { //ask again in 1 sec
          $timeout(function() {
            showImageUser();
          }, 1000);
        } else {
          if ($scope.form.imagePath === null || $scope.form.imagePath === undefined || $scope.form.imagePath.length === 0) {
            var opt = {};
            if (isIOS === true) {
              //prepare IOS
              $scope.form.imagePath = img;
              $timeout(function() {
                $scope.apply();
              }, 0);
            } else {
              $scope.form.imagePath = img;
              $timeout(function() {
                $scope.apply();
              }, 0);
            }
          } else {
            $scope.openCrop = false;
            console.log("finish loading");
          }
        }
      }

      // cancel custom back behaviour
      $scope.$on('$destroy', function() {
        //console.log("deregistering back button");
        deregisterHardBack();
      });
    }
  ])

  .controller('onBoardingCtrl', ['$rootScope', '$scope', 'Utils', 'locals', '$ionicSlideBoxDelegate',
    function($rootScope, $scope, Utils, locals, $ionicSlideBoxDelegate) {
      //background-image: url(img/LogoHeader.png);
      //Utils.translate('GROUPS.TIMELINE_WRAPPER.DIALOG.UPLOAD_LOCKED_ERR')                           
      $scope.prepareImages = function() {
        var lang = navigator.language || navigator.userLanguage;
        //var whatLang = Utils.translate('ONBOARDING.LANGUAJE');
        var whatLang = "";
        if (lang.split("-")[0] === 'es' || lang.split("-")[0] === 'en')
          whatLang = lang.split("-")[0];
        else
          whatLang = "en";
        $scope.onBoardingList = [
          { "imageUrl": "img/1" + whatLang + ".jpg", "position": 1 },
          { "imageUrl": "img/2" + whatLang + ".jpg", "position": 2 },
          { "imageUrl": "img/3" + whatLang + ".jpg", "position": 3 },
          { "imageUrl": "img/4" + whatLang + ".jpg", "position": 4 },
          { "imageUrl": "img/5" + whatLang + ".jpg", "position": 5 },
          { "imageUrl": "img/6" + whatLang + ".jpg", "position": 6 },
          { "imageUrl": "img/7" + whatLang + ".jpg", "position": 7 }
        ];
      };
      $scope.prepareImages();


      $scope.closeModal = function() {
        window.localStorage.setItem("onboardingComplete", "yes");
        locals.dialog.cancel();
      }

      $scope.updateSlideStatus = function(panel) {
        console.log("it's", panel);
        if (panel == 7) {
          $scope.closeModal();
        } else {
          console.log("still onboard");
        }
      }

      $scope.moveSlide = function(panel) {
        console.log("it's", panel);
        if (panel == 7) {
          $scope.closeModal();
        } else {
          $ionicSlideBoxDelegate.next();
        }

      }
      /*$scope.doubleTapped = function(panel) {
       console.log("it's", panel);
       }*/

    }
  ])

  .controller('adConfigEditionCtrl', ['$rootScope', '$scope', 'locals', 'UserService', 'TimeLineService', 'adsService', '$ionicPickerI18n', 'permissionValidationService', 'Utils', 'legalURl',
    function($rootScope, $scope, locals, UserService, TimeLineService, adsService, $ionicPickerI18n, permissionValidationService, Utils, legalURl) {
      $scope.sequence = {
        advertisement: {
          header: {
            bgColor: locals.sequence.advertisement.header.bgColor, //<-- editable field
            color: locals.sequence.advertisement.header.color //<-- editable field
          }
        },
        content: {
          type: locals.sequence.content.type,
          templateId: locals.sequence.content.templateId,
          templateIdBackup: locals.sequence.content.templateIdBackup,
          items: locals.sequence.content.items
        },
        comments: {
          enabled: locals.sequence.comments.enabled //<-- editable field
        },
        description: {
          title: locals.sequence.description.title
        },
        metadata: {
          dateTime: locals.sequence.metadata.dateTime,
          finalDate: /*locals.sequence.metadata.finalDate || */ new Date(locals.sequence.metadata.finalDate) //<-- editable field
        },
        share: {
          enabled: locals.sequence.share.enabled //<-- editable field
        },
        ownerMetadata: {
          avatar: locals.sequence.ownerMetadata.avatar,
          name: locals.sequence.ownerMetadata.name
        }
      };

      //console.log("sequence", $scope.sequence);

      $scope.customColors = adsService.customColors;

      $scope.dateTimePickerTitle = Utils.translate("UPLOAD.DATETIME_PICKER.TITLE");

      $ionicPickerI18n.weekdays = adsService.getWeekdaysLocalized();
      $ionicPickerI18n.months = adsService.getMonthsLocalized();

      $ionicPickerI18n.ok = Utils.translate("GLOBAL.OK");
      $ionicPickerI18n.cancel = Utils.translate("GLOBAL.CANCEL");

      $scope.okClicked = function() {
        locals.dialog.hide($scope.sequence); //the new values
        var promises = [];
        promises.push(updateHeaderBgColor());
        promises.push(updateHeaderFontColor());
        promises.push(updateExpirationDate());
        promises.push(updateCommentsEnabled());
        promises.push(updateShareability());

        Utils.loading.show();
        Utils.$q.all(promises).then(function(responses) {
          Utils.loading.hide();
          Utils.toast.success(Utils.translate('SEQUENCE.DIALOG.AD_SETTINGS_UPDATE_OK'));
          $rootScope.$broadcast('advertisement.settings.updated', { sequence: locals.sequence });
        }, function(errors) {
          Utils.loading.hide();
          Utils.toast.warning(Utils.translate('SEQUENCE.DIALOG.AD_SETTINGS_UPDATE_ERROR'));
          console.log("couldn't update ad settings", errors);
        })
      };

      $scope.cancelModal = function() {
        locals.dialog.cancel();
      };

      var deregisterHardBack = Utils.$ionicPlatform.registerBackButtonAction(
        $scope.cancelModal, 101
      );

      // cancel custom back behaviour
      $scope.$on('$destroy', function() {
        deregisterHardBack();
      });

      $scope.trustAsHtml = function(text) {
        return Utils.$sce.trustAsHtml(text);
      };

      //hack to get the picker on top
      var mdBackdrop, statementContainer;
      $scope.hideStatementFormAndBackdrop = function() {
        mdBackdrop = document.getElementsByTagName('md-backdrop');
        statementContainer = document.getElementsByClassName('md-dialog-container');
        if (mdBackdrop) mdBackdrop[0].style.opacity = 0;
        if (statementContainer && statementContainer[0]) statementContainer[0].style.display = 'none';

        setTimeout(function() {
          $ionicPickerI18n.popup.then(function() {
            restoreStatementVisibility();
          });
        }, 800)

      };

      function restoreStatementVisibility() {
        if (mdBackdrop) mdBackdrop[0].style.opacity = .48;
        if (statementContainer && statementContainer[0]) statementContainer[0].style.display = 'flex';
      }

      /**
       * @return Promise {boolean|*}
       */
      function updateHeaderBgColor() {
        return Utils.$q(function(resolve, reject) {
          if ($scope.sequence.advertisement.header.bgColor === locals.sequence.advertisement.header.bgColor)
            return resolve(false);

          adsService.changeHeaderBgColor(
            locals.sequence.metadata.instanceId,
            $scope.sequence.advertisement.header.bgColor
          ).$promise.then(function(resp) {
            locals.sequence.advertisement.header.bgColor = $scope.sequence.advertisement.header.bgColor;
            resolve(true);
          }, function(error) {
            reject(error);
          })
        })
      }

      /**
       * @return Promise {boolean|*}
       */
      function updateHeaderFontColor() {
        return Utils.$q(function(resolve, reject) {
          if ($scope.sequence.advertisement.header.color === locals.sequence.advertisement.header.color)
            return resolve(false);

          adsService.changeHeaderFontColor(
            locals.sequence.metadata.instanceId,
            $scope.sequence.advertisement.header.color
          ).$promise.then(function(resp) {
            locals.sequence.advertisement.header.color = $scope.sequence.advertisement.header.color;
            resolve(true);
          }, function(error) {
            reject(error);
          })
        })
      }

      /**
       * @return Promise {boolean|*}
       */
      function updateCommentsEnabled() {
        return Utils.$q(function(resolve, reject) {
          if ($scope.sequence.comments.enabled === locals.sequence.comments.enabled)
            return resolve(false);

          cqnzService.toggleEnableSequenceCommentsWS(
            locals.sequence.metadata.instanceId,
            $scope.sequence.comments.enabled
          ).then(function(resp) {
            locals.sequence.comments.enabled = $scope.sequence.comments.enabled;
            resolve(true);
          }, function(error) {
            reject(error);
          })
        })
      }

      /**
       * @return Promise {boolean|*}
       */
      function updateExpirationDate() {
        return Utils.$q(function(resolve, reject) {
          if ($scope.sequence.metadata.finalDate === locals.sequence.metadata.finalDate)
            return resolve(false);

          adsService.changeExpirationDate(
            locals.sequence.metadata.instanceId,
            $scope.sequence.metadata.finalDate
          ).$promise.then(function(resp) {
            locals.sequence.metadata.finalDate = $scope.sequence.metadata.finalDate;
            resolve(true);
          }, function(error) {
            reject(error);
          })
        })
      }

      /**
       * todo: use real ws call
       * @return Promise {boolean|*}
       */
      function updateShareability() {
        return Utils.$q(function(resolve, reject) {
          if ($scope.sequence.share.enabled === locals.sequence.share.enabled)
            return resolve(false);
        })
      }

      //------------------ PERMISSIONS SECTION --------------------
      if (!$scope.groupData || !$scope.groupData.hrefId)
        $scope.canToggleCommentsEnabled = UserService.USER_IS_SUPERADMIN() || permissionValidationService.canEnableDisableCommentsInGralTimeline();
      else
        $scope.canToggleCommentsEnabled = UserService.USER_IS_SUPERADMIN() || permissionValidationService.canEnableDisableCommentsInGroupTimeline();
    }
  ])

  .controller('legalsCttrl', ['$rootScope', '$scope', '$window', 'Utils', 'legalURl',
    function($rootScope, $scope, $window, Utils, legalURl) {
      //var lang = $window.navigator.language || $window.navigator.userLanguage;
      var lang = $window.navigator.languages ?
        $window.navigator.languages[0] :
        ($window.navigator.language || $window.navigator.userLanguage);

      //Politics
      $scope.redirectPolitics = function() {
        var isIOS = ionic.Platform.isIOS();
        var zone = '_blank';
        var opt = '';
        if(isIOS){
          zone = '_blank';
          opt = 'clearsessioncache=yes,usewkwebview=yes,toolbar=yes,presentationstyle=fullscreen,hidespinner=yes,closebuttoncaption=Close,closebuttoncolor=#ffffff4,navigationbuttoncolor=#ffffff,lefttoright=yes,location=no';
        }
        else{
          zone ='_blank';
          opt = 'clearsessioncache=yes,usewkwebview=yes,toolbar=yes,presentationstyle=fullscreen,hidespinner=yes,closebuttoncaptionSet=Close,closeButtonColorSet=#ffffff4,navigationbuttoncolorSet=#ffffff,lefttoright=yes,location=no';
        }
        if (lang.includes("es")) {
          var ref = cordova.InAppBrowser.open( 'https://niido.cloud/'+ legalURl.app +'/politicaprivacidad.html', zone, opt);
        } else if (lang.includes("en")) {
          var ref = cordova.InAppBrowser.open( 'https://niido.cloud/'+ legalURl.app +'/privacypolicy.html', zone, opt);
        }
      }
      //Terms of use
      $scope.redirectTerms = function() {
        var isIOS = ionic.Platform.isIOS();
        var zone = '_blank';
        var opt = '';
        if(isIOS){
          zone = '_blank';
          opt = 'clearsessioncache=yes,usewkwebview=yes,toolbar=yes,presentationstyle=fullscreen,hidespinner=yes,closebuttoncaption=Close,closebuttoncolor=#ffffff4,navigationbuttoncolor=#ffffff,lefttoright=yes,location=no';
        }
        else{
          zone ='_blank';
          opt = 'clearsessioncache=yes,usewkwebview=yes,toolbar=yes,presentationstyle=fullscreen,hidespinner=yes,closebuttoncaptionSet=Close,closeButtonColorSet=#ffffff4,navigationbuttoncolorSet=#ffffff,lefttoright=yes,location=no';
        }
        if (lang.includes("es")) {
          var ref = cordova.InAppBrowser.open( 'https://niido.cloud/'+ legalURl.app +'/terminosycondiciones.html', zone, opt);
        } else if (lang.includes("en")) {
          var ref = cordova.InAppBrowser.open( 'https://niido.cloud/'+ legalURl.app +'/termsandconditions.html', zone, opt);
        }
      }

      //Info

    }
  ])

  .controller('updateSceduledCtrl', ['$rootScope', '$scope', 'UserService', 'cqnzService', 'TagsService', 'FileService3', 'ImageService3', 'Utils', 'locals', 'ImageService2', 'FileService2', '$ionicActionSheet', 'userScheduledService',
    function($rootScope, $scope, UserService, cqnzService, TagsService, FileService3, ImageService3, Utils, locals, ImageService2, FileService2, $ionicActionSheet, userScheduledService) {

      //get locals
      $scope.data = {};
      $scope.data.updateDate = locals.whatChange === 'DATE' ? true : false;
      $scope.data.updateTime = locals.whatChange === 'TIME' ? true : false;
      $scope.date = {};
      $scope.date.monthList = [];
      $scope.date.dayList = [];
      $scope.date.yearList = [];

      $scope.prepareData = function() {
        if ($scope.data.updateDate) {
          $scope.date.previousDate = locals.dataforChange;
          //prepare date
          $scope.data.scheduledDate = new Date();
          var origin_Month = $scope.data.scheduledDate.getMonth();
          var origin_Day = $scope.data.scheduledDate.getDate();
          var origin_Year = $scope.data.scheduledDate.getFullYear();

          //fill years (only one ahead)
          $scope.date.yearList.push({
            id: 0,
            text: origin_Year + ""
          });
          $scope.date.yearList.push({
            id: 1,
            text: origin_Year + 1 + ""
          });
          $scope.data.scheduledDate_Year = $scope.date.yearList[0];

          //fill month list
          for (var i = 1; i <= 12; i++) {
            var realMonth = origin_Month + i;
            var text = "BIRTHDAY_INFO.MONTH_LIST.0" + realMonth;
            if (realMonth <= 12) {
              $scope.date.monthList.push({
                id: realMonth,
                text: Utils.translate(text)
              })
            }
          }
          $scope.data.scheduledDate_Month = $scope.date.monthList[0];

          //fill days of current month
          var numDays = 0;
          if (origin_Month === 2) {
            numDays = 28;
          } else if (origin_Month === 1 || origin_Month === 3 || origin_Month === 5 || origin_Month === 7 || origin_Month === 8 || origin_Month === 10 || origin_Month === 12) {
            numDays = 31;
          } else {
            numDays = 30;
          }
          for (var i = origin_Day; i <= numDays; i++) {
            var realDay = i + "";
            if (i < 10)
              realDay = "0" + realDay;

            $scope.date.dayList.push({
              id: i,
              text: realDay
            });
          }
          $scope.data.scheduledDate_Day = $scope.date.dayList[0];
          Utils.$timeout(function() {
            document.getElementById("dater").focus();
          }, 10);
        } else {
          $scope.date.previousTime = locals.dataforChange;
          var tempTime = new Date();
          $scope.data.scheduledTime = tempTime;
          Utils.$timeout(function() {
            document.getElementById("timer").focus();
          }, 10);
        }
      }
      $scope.prepareData();

      //when click in year we need to update month and days
      $scope.selectYear = function(year) {
        //clean phase
        $scope.date.monthList = [];
        $scope.date.dayList = [];

        var origin_Month = $scope.data.scheduledDate.getMonth();
        var origin_Day = $scope.data.scheduledDate.getDate();
        var chkToday = false;
        if (year.id === 0) {
          //actual year
          $scope.date.monthList = [];
          //fill month list
          for (var i = 1; i <= 12; i++) {
            var realMonth = origin_Month + i;
            var text = "BIRTHDAY_INFO.MONTH_LIST.0" + realMonth;
            if (realMonth <= 12) {
              $scope.date.monthList.push({
                id: realMonth,
                text: Utils.translate(text)
              })
            }
          }
          $scope.data.scheduledDate_Month = $scope.date.monthList[0];
          chkToday = true;
        } else {
          //next year
          $scope.date.monthList = [];
          //fill month list
          for (var i = 1; i <= 12; i++) {
            var text = "BIRTHDAY_INFO.MONTH_LIST.0" + i;
            $scope.date.monthList.push({
              id: i,
              text: Utils.translate(text)
            })
          }
          $scope.data.scheduledDate_Month = $scope.date.monthList[0];
          chkToday = false;
        }
        //fill days
        var numDays = 0;
        if ($scope.data.scheduledDate_Month.id === 2) {
          numDays = 28;
        } else if ($scope.data.scheduledDate_Month.id === 1 ||
          $scope.data.scheduledDate_Month.id === 3 ||
          $scope.data.scheduledDate_Month.id === 5 ||
          $scope.data.scheduledDate_Month.id === 7 ||
          $scope.data.scheduledDate_Month.id === 8 ||
          $scope.data.scheduledDate_Month.id === 10 ||
          $scope.data.scheduledDate_Month.id === 12) {
          numDays = 31;
        } else {
          numDays = 30;
        }
        var initDay = 1;
        if (chkToday)
          initDay = origin_Day;
        else
          initDay = 1;

        for (var i = initDay; i <= numDays; i++) {
          var realDay = i + "";
          if (i < 10)
            realDay = "0" + realDay;

          $scope.date.dayList.push({
            id: i,
            text: realDay
          });
        }
        $scope.data.scheduledDate_Day = $scope.date.dayList[0];
      }

      //when click in date we need to update days
      $scope.selectMonth = function(month) {
        //clean phase
        $scope.date.dayList = [];

        var origin_Month = $scope.data.scheduledDate.getMonth();
        var origin_Day = $scope.data.scheduledDate.getDate();
        var sameMonthYear = false;
        if ($scope.data.scheduledDate_Year.id === 0) {
          //current year need to check also month
          var actualMonth = Utils.translate("BIRTHDAY_INFO.MONTH_LIST.0" + origin_Month);
          if (month.text === actualMonth) {
            //its same year and month of the day
            sameMonthYear = true;
          } else
            sameMonthYear = false
        } else
          sameMonthYear = false;

        //prepare days
        var numDays = 0;
        if (month.id === 2) {
          numDays = 28;
        } else if (month.id === 1 ||
          month.id === 3 ||
          month.id === 5 ||
          month.id === 7 ||
          month.id === 8 ||
          month.id === 10 ||
          month.id === 12) {
          numDays = 31;
        } else {
          numDays = 30;
        }
        var initDayList = 0;
        if (sameMonthYear)
          initDayList = origin_Day;
        else
          initDayList = 1;
        for (var i = initDayList; i <= numDays; i++) {
          var realDay = i + "";
          if (i < 10)
            realDay = "0" + realDay;

          $scope.date.dayList.push({
            id: i,
            text: realDay
          });
        }
        $scope.data.scheduledDate_Day = $scope.date.dayList[0];
      }

      //When click OK
      $scope.okClicked = function() {
        var fDate = null;
        var fTime = null;
        if ($scope.data.updateDate) {
          //SAVE DATE
          var fYear = $scope.data.scheduledDate_Year ? $scope.data.scheduledDate_Year.text : null;
          var fMonth = $scope.data.scheduledDate_Month ? $scope.data.scheduledDate_Month.id : null;
          if (fMonth < 10)
            fMonth = "0" + fMonth;
          var fDay = $scope.data.scheduledDate_Day ? $scope.data.scheduledDate_Day.text : null;
          fDate = fYear + "-" + fMonth + "-" + fDay;
          //call WS to update DATE
          userScheduledService.changeInitialDate({
            sequenceId: locals.fromWhatPost.metadata.href.split('/')[6],
            date: fDate
          }).$promise.then(function(passWs) {
            locals.dialog.hide({
              newDate: fDate,
              oldDate: $scope.date.previousDate
            });
          }, function(errWs) {
            console.log("Something is wrong", errWs);
          })
        } else if ($scope.data.updateTime) {
          //SAVE TIME
          var fHour = $scope.data.scheduledTime.getHours();
          var fMin = $scope.data.scheduledTime.getMinutes();
          if (fHour < 10)
            fHour = "0" + fHour;
          else
            fHour = "" + fHour;
          if (fMin < 10)
            fMin = "0" + fMin;
          else
            fMin = "" + fMin;
          fTime = fHour + ":" + fMin + ":00";
          //call WS to update TIME
          userScheduledService.changeInitialTime({
            sequenceId: locals.fromWhatPost.metadata.href.split('/')[6],
            date: fTime
          }).$promise.then(function(passWs) {
            locals.dialog.hide({
              newDate: fTime,
              oldDate: $scope.date.previousTime
            });
          }, function(errWs) {
            console.log("Something is wrong", errWs);
          })
        }
      }

      $scope.cancelClicked = function() {
        locals.dialog.cancel();
      };

      var deregisterHardBack = Utils.$ionicPlatform.registerBackButtonAction(
        $scope.cancelClicked, 101
      );
      /*function focusTextArea() {
        setTimeout(function () {
          if (!textArea)
            textArea = document.querySelector('#main-textarea');

          if (textArea) {
            textArea.selectionStart = $scope.form.description.length;
            textArea.selectionEnd = $scope.form.description.length;
            textArea.focus();

            autosize();
          }
        }, 900);
      }*/

      // cancel custom back behaviour
      $scope.$on('$destroy', function() {
        //console.log("deregistering back button");
        deregisterHardBack();
      });
    }
  ])

  //Control Streaming  LuMa && OmRo
  .controller('StreamingOnLiveCtrl', ['$rootScope', '$scope', '$window', 'Utils', 'UserService', 'StreamingService', 'AntMediaServer', 'notificationsService', 'AntMediaServerService', 'ImageServiceStreaming', 'FileServiceStreaming', 'permissionValidationService', 'adsService', 's3', 'SequenceService', '$mdDialog', '$timeout', '$state', 'cqnzService',
    function($rootScope, $scope, $window, Utils, UserService, StreamingService, AntMediaServer, notificationsService, AntMediaServerService, ImageServiceStreaming, FileServiceStreaming, permissionValidationService, adsService, s3, SequenceService, $mdDialog, $timeout, $state, cqnzService) {

      console.log('StreamingOnLiveCtrl');

      ///////////////////////// OmRo
      var userId = UserService.get_USERSUBSCRIPTIONINSTANCE_ID();
      var permissions = permissionValidationService;
      var userIDAds = UserService.get_USERSUBSCRIPTION_ID();
      $scope.haveTitlePermit = permissions.canUpdateCqnzTitleInGralTimeline();
      $scope.haveDescriptionPermit = permissions.canUpdateCqnzDescriptionInGralTimeline();
      $scope.haveAdvPermit = permissions.canAdvertisementPermit();
      $scope.iAmAdvertiser = false;
      $scope.customColors = adsService.customColors;
      $scope.isIOS = ionic.Platform.isIOS();
      $rootScope.infoForPost = [];
      $scope.seqData = {};
      $scope.seqData.selectedBgColor = $scope.customColors[$scope.iAmAdvertiser ? 10 : 1];
      $scope.seqData.selectedFontColor = $scope.customColors[$scope.iAmAdvertiser ? 1 : 0];
      $rootScope.instPluginStream = null;
      $scope.viewersInTotal = 0;
      $scope.stepBanners = 0;
      /////////////////////////

      $rootScope.data = {
        userStreamingId: null,
        streamId: null,
        rtmpUrl: null,
        hlsUrl: null,
        mp4Url: null,
        working: false,
        seqItemId: null
      };

      $scope.dataImg = {
        pictures: [],
        thumbPictures: []
      };

      var s3Service = new AWS.S3({
        apiVersion: '2006-03-01',
        params: {
          Bucket: s3.bucket
        }
      });

      $scope.galleryIsOpen = false;
      $scope.uploading = false;
      $scope.isIOS = ionic.Platform.isIOS();
      $scope.isAndroid = ionic.Platform.isAndroid();
      $scope.uploadButtonText = Utils.translate('UPLOAD.UPLOAD');
      $rootScope.askForThumbnail = false;
      var defaultThumbnail = AntMediaServer.s3Bucket + '/splash.png';

      FileServiceStreaming.cleanImages();

      //LuMa Live Streaming
      $scope.createHlsUrl = function() {
        return 'http://' + AntMediaServer.ip + ':' + AntMediaServer.hlsPort + '/LiveApp/streams/' + $rootScope.data.streamId + '.m3u8';
      }

      //LuMa Live Streaming
      $scope.createMp4Url = function() {
        return AntMediaServer.s3Bucket + '/streams/' + $rootScope.data.streamId + '.mp4';
      }

      //LuMa Live Streaming
      $scope.createRtmpUrl = function() {
        return 'rtmp://' + AntMediaServer.ip + '/LiveApp/' + $rootScope.data.streamId;
      }

      //LuMa Live Streaming
      $scope.addUserStreaming = function() {
        StreamingService.addUserStreaming({
          userSubscriptionId: UserService.get_USERSUBSCRIPTION_ID(),
          rtmpUrl: $rootScope.data.hlsUrl,
          mp4Url: $rootScope.data.mp4Url
        }).$promise.then(function(response) {
          console.log('addUserStreaming()');
          $rootScope.data.userStreamingId = response.result.instanceId;
          $rootScope.askForThumbnail = true;
          //IN APP STREAM NOTIF
            StreamingService.addUserStreamingNotification({
              UserStreaming: $rootScope.data.userStreamingId
            }).$promise.then(function (dataR) {
              console.log("Good!! R");
            }, function(errorR) {
              console.log('addUserStreaming() ', errorR);
              if (errorR && (errorR.status === 504 || errorR.status === -1)) {
                console.log("We don't care E$");
              } else {
                console.log("fallo R");
              }
            })
          //IN APP STREAM NOTIF END
          //PUSH NOTIF
            //$scope.sendLiveStreamingPushNotification();
          //PUSH NOTIF END
          //CREATE POST LIVE
            $scope.addSequence();
          //CREATE POST LIVE END
          //BEGIN FUNCTION TO CHECK VIEWERS
            $scope.updateViewers();
          //BEGIN FUNCTION TO CHECK VIEWERS END
          //BEGIN FUNCTION TO SHOW BANNERS
            //$scope.shwBanners();
          //BEGIN FUNCTION TO SHOW BANNERS END
        }, function(error) {
          console.log('addUserStreaming() ', error);
          if (error && (error.status === 504 || error.status === -1)) {
            console.log("We don't care");
          } else {
            console.log("fallo");
          }
        });
      }

      //LuMa Live Streaming
      $scope.finishStreaming = function() {
        StreamingService.finish($rootScope.data.userStreamingId).$promise.then(function(response) {
          console.log('finishStreaming()');
          $rootScope.data.userStreamingId = null;
          $rootScope.data.working = false;
          //$scope.addSequence();
          $scope.updateUrlStream();
        }, function(error) {
          console.log('finishStreaming() ', error);
          $rootScope.data.working = false;
        });
      }
      
      $scope.finishStreamingIOS = function(){
          console.log('finishStreaming()');
          $rootScope.data.userStreamingId = null;
          $rootScope.data.working = false;
          //$scope.addSequence();
          $scope.updateUrlStream();
      }

      //LuMa Live Streaming
      $scope.sendLiveStreamingPushNotification = function(postData) {
        notificationsService.sendDeepNotificationToFollowersDevices(UserService.get_USERSUBSCRIPTION_ID(), '20', UserService.get_USER_NAME() + Utils.translate('LIVE_STREAMING.NEW_STREAMING'), 'STREAMINGPOST', $rootScope.data.userStreamingId, postData.result.instanceId).then(function() {}, function(error) {
          console.log('sendLiveStreamingPushNotification() ', error);
        });
      }

      $scope.createBroadcastForStreaming = function() {
        //return AntMediaServerService.createBroadcast(AntMediaServer.prefix + UserService.get_USERSUBSCRIPTIONINSTANCE_ID());
      }

      $scope.deleteBroadcastForStreaming = function() {
        // MAKE NULL PLUGIN INSTANCE
          $rootScope.instPluginStream = null;
        // MAKE NULL PLUGIN INSTANCE END
        //PREPARE FIRST CALL FOR ANTMEDIA
          var url = AntMediaServer.apiEndPoint + '/v2/broadcasts/'+$rootScope.data.streamId; //DELETE BROADCAST FROM DATA STORE AND STOP
          var params = {"rtmpUrl": $rootScope.data.rtmpUrl};
          var headers = { };
          cordova.plugin.http.setDataSerializer("json");
          cordova.plugin.http.setHeader("Accept", "application/json");
          cordova.plugin.http.setHeader("Content-type", "application/json");
        //PREPARE FIRST CALL FOR ANTMEDIA END
        //MAKE FIRST CALL FOR ANTMEDIA
          cordova.plugin.http.delete(url, params, headers, function (response) {
            console.log("RESPONSE BREADCASTS ", response);
            console.log("URL TO DELETE", $rootScope.data.rtmpUrl)
            $rootScope.data.streamId = null;
            //PREPARE SECOND CALL FOR ANTMEDIA
              /*var url = AntMediaServer.apiEndPoint + '/v2/broadcasts/' + $rootScope.data.streamId + '/endpoint'; //REMOVE THIRD PARTY RTMP END POINT FOR THE STREAM THAT IS BROADCASTING IT WILL STOP INMEDIATELY
              var params = { };
              var headers = { };
              cordova.plugin.http.setDataSerializer("json");
              cordova.plugin.http.setHeader("Accept", "application/json");
              cordova.plugin.http.setHeader("Content-type", "application/json");*/
            //PREPARE SECOND CALL FOR ANTMEDIA END
            //MAKE SECOND CALL FOR ANTMEDIA
              /*cordova.plugin.http.delete(url, params, headers, function (response2){
                console.log("DELETE STREAM SUCCESS: ", response2);
                $rootScope.data.streamId = null;
              }, function (error2){
                    console.error("DELETE STREAM ERROR: ", error2);
              })*/
            //MAKE SECOND CALL FOR ANTMEDIA END
          }, function (error) {
              console.error("ERROR BROADCASTS DELETE ", error)
          });
        //MAKE FIRST CALL FOR ANTMEDIA END    
      }

      //LuMa Live Streaming
      $scope.liveStreamingAndroid = function() {
        //MAKE SURE THE PLUGIN INSTANCE IS NULL
          if($rootScope.instPluginStream != null) {
              $rootScope.instPluginStream = null;
          }
        //MAKE SURE THE PLUGIN INSTANCE IS NULL END
        //PREPARE URL CALL
          var url = AntMediaServer.apiEndPoint + '/v2/broadcasts/create';
          var rndID = Math.floor(Math.random() * 1000 );
          var params = {"name": AntMediaServer.prefix + rndID }; //UserService.get_USERSUBSCRIPTIONINSTANCE_ID()
          var headers = { };
          cordova.plugin.http.setDataSerializer("json");
          cordova.plugin.http.setHeader("Accept", "application/json");
          cordova.plugin.http.setHeader("Content-type", "application/json");
        //PREPARE URL CALL END
        //AFTER CREATE BROADCAST CALL THE PLUGIN
          cordova.plugin.http.post(url, params, headers, function (response) {
            var responseClear = JSON.parse(response.data);
            $rootScope.data.streamId = responseClear.streamId;
            $rootScope.data.rtmpUrl = $scope.createRtmpUrl();
            $rootScope.data.hlsUrl = $scope.createHlsUrl();
            $rootScope.data.mp4Url = $scope.createMp4Url();
            //var streamer = window.videoStreamer;
            $rootScope.instPluginStream = window.videoStreamer;

            $rootScope.instPluginStream.streamRTMP($rootScope.data.rtmpUrl,
              function(response) {
                console.log('LiveStreaming{Event_Name:' + response.event_name + ', Data:' + response.data);
                if (response.event_name == 'onConnectionSuccess') {
                  $scope.addUserStreaming();
                } else if (response.event_name == 'onStopStream') {
                  if ($rootScope.data.userStreamingId && $rootScope.data.userStreamingId != null && !$rootScope.data.working) {
                    $rootScope.data.working = true;
                    $scope.finishStreaming();
                  }
                  if ($rootScope.data.streamId && $rootScope.data.streamId != null) {
                    $scope.deleteBroadcastForStreaming();
                  }
                }
              },
              function(error) {
                console.log("Live Streaming Error:");
                console.log(error);
              }
            );
          }, function (error) {
            console.error("ERROR SEE: ", error);
          })
        //AFTER CREATE BROADCAST CALL THE PLUGIN END
      }

      //LuMa Live Streaming
      $scope.liveStreamingIOS = function() {
        //MAKE SURE THE PLUGIN INSTANCE IS NULL
          if($rootScope.instPluginStream != null) {
              $rootScope.instPluginStream = null;
          }
        //MAKE SURE THE PLUGIN INSTANCE IS NULL END
        //PREPARE URL CALL
          var url = AntMediaServer.apiEndPoint + '/v2/broadcasts/create';
          var rndID = Math.floor(Math.random() * 1000 );
          var params = {"name": AntMediaServer.prefix + rndID }; //UserService.get_USERSUBSCRIPTIONINSTANCE_ID()
          var headers = { };
          cordova.plugin.http.setDataSerializer("json");
          cordova.plugin.http.setHeader("Accept", "application/json");
          cordova.plugin.http.setHeader("Content-type", "application/json");
        //PREPARE URL CALL END
        //AFTER CREATE BROADCAST CALL THE PLUGIN
          cordova.plugin.http.post(url, params, headers, function (response) {
              console.log("POST SUCCESS: ", response);
              var responseClear = JSON.parse(response.data);
              $rootScope.data.streamId = responseClear.streamId;
              $rootScope.data.rtmpUrl = $scope.createRtmpUrl();
              $rootScope.data.hlsUrl = $scope.createHlsUrl();
              $rootScope.data.mp4Url = $scope.createMp4Url();
              
              var options = {
                videoWidth: "480",
                videoHeight: "800",
                videoBitRate: "819200", //(800 * 1024)
                videoMaxBitRate: "1024000", //(1000 * 1024)
                videoMinBitRate: "512000", //(500 * 1024)
                videoFrameRate: "24",
                videoMaxKeyframeInterval: "48",
                videoOrientation: "1", //1 = portrait, 2 = landscape
                rtmpServerURL: $rootScope.data.rtmpUrl,
                labelLive: "Live",
                labelViewers: " ",
                labelNoQuestions: " ",
                alertStopSessionTitle: "Alert",
                alertStopSessionYes: "Yes",
                alertStopSessionNo: "No",
                alertStopSessionMessage: "Are you sure you want to exit from this session?",
                alertStartSessionTitle: "Alert",
                alertStartSessionOK: "OK",
                alertStartSessionMessage: "Press red button to start streaming",
                videoTitleStart: "Start",
                videoTitlePaused: "Paused",
                videoTitleEnd: "End"
              };
              
              $scope.addUserStreaming();
              //var streamer = window.rtmpLiveStreamer;
              $rootScope.instPluginStream = window.rtmpLiveStreamer;

              $rootScope.instPluginStream.start(
                (results) => {
                  console.log("STREAM get results");
                  if (results == 'Connected') {
                    console.log("get connected");
                    $scope.addUserStreaming();
                  }  else if (results == "CLOSE"){
                    if ($rootScope.data.userStreamingId && $rootScope.data.userStreamingId != null) {
                        $scope.chkMp4Url();
                    }
                    if ($rootScope.data.streamId && $rootScope.data.streamId != null) {
                      $scope.deleteBroadcastForStreaming();
                    }
                  }
                },
                (error) => {
                  console.log('Error start: ' + error);
                },
                options
              );
          }, function(error){
              console.error("ERROR SEE: ", error);
          })
        //AFTER CREATE BROADCAST CALL THE PLUGIN END
      }

      $scope.$on("$ionicView.beforeLeave", function() {
        $rootScope.infoForPost = [];
        $rootScope.instPluginStream = null;
        $scope.viewersInTotal = 0;
        $scope.messagesList = [];
        /*if ($rootScope.data.userStreamingId && $rootScope.data.userStreamingId != null) {
            //$scope.finishStreaming();
            //$scope.chkMp4Url();
        }
        if ($rootScope.data.streamId && $rootScope.data.streamId != null) {
          $scope.deleteBroadcastForStreaming();
        }*/
      });

      //ANBA ADD POST INFO BEFORE STREAM
        $scope.askTitleAndDescription = function () {
          var userName = UserService.get_USER_NAME();
          var showTitle = $scope.haveTitlePermit;
          var showDescr = $scope.haveDescriptionPermit;
          var dialog = Utils.modal.getCtrl();
          dialog.show({
            controller: "addStreamInfoCtrl",
            templateUrl: 'templates/partials/StreamPostInfo.html',
            clickOutsideToClose: false,
            fullscreen: true, // Only for -xs, -sm breakpoints.
            locals: { userName: userName, showTitle: showTitle, showDescr: showDescr, dialog: dialog},
            openFrom: '#right',
            multiple: true,
          }).then(function (data) {
            console.log("done", data);
            if(data) {
              $rootScope.infoForPost = data;
              $scope.onLiveStreamingBtnCli();
            } else {
              $state.go("menu.timeline", {}, { reload: true });
            }
          }, function() {
            console.log("CLOSED");
            $state.go("menu.timeline", {}, { reload: true });
          })
        }
        $scope.askTitleAndDescription();
      //ANBA ADD POST INFO BEFORE STREAM FINAL

      ///BEGIN STREAM
        $scope.onLiveStreamingBtnCli = function() {
          if (ionic.Platform.isAndroid()) {
            if (!window.videoStreamer) {
              console.log('Live Streaming en Android: Plugin no instalado.');
            } else {
              $scope.liveStreamingAndroid();
            }
          } else if (ionic.Platform.isIOS()) {
            if (!window.rtmpLiveStreamer) {
              console.log('Live Streaming en IOS: Plugin no instalado.');
            } else {
              $scope.liveStreamingIOS();
            }
          } else {
            console.log('Error: Live Streaming');
          }
        }
        //$scope.onLiveStreamingBtnCli();
      //BEGIN STREAM END

      //FUNCTION TO CHECK VIEWERS COUNT
        $scope.updateViewers = function() {
          if($rootScope.instPluginStream) {
            if($rootScope.data.streamId) {
              //PREPARE URL CALL
                var url = AntMediaServer.apiEndPoint + '/v2/broadcasts/' + $rootScope.data.streamId + '/broadcast-statistics';
                var params = { };
                var headers = { };
                cordova.plugin.http.setDataSerializer("json");
                cordova.plugin.http.setHeader("Accept", "application/json");
                cordova.plugin.http.setHeader("Content-type", "application/json");
              //PREPARE URL CALL END
              //AFTER CREATE BROADCAST CALL THE PLUGIN
                cordova.plugin.http.get(url, params, headers, function (response) {
                  console.log("RESPONSE", response);
                  var vwT = JSON.parse(response.data).totalHLSWatchersCount + JSON.parse(response.data).totalRTMPWatchersCount;
                  if(vwT <= 0)
                    vwT="0";
                  if($scope.isIOS) {
                    vwT = "Viewers: " + vwT;
                    var optionsViewers = {
                      viewersLabel: vwT
                    }
                    $rootScope.instPluginStream.updateViewerCount(
                      (results) => {
                        console.log('Success updateViewerCount: ' + results);
                      },
                      (error) => {
                        console.log('Error updateViewerCount: ' + error);
                      },
                      optionsViewers
                    )
                  } else {
                    vwT = "V: " + vwT;
                    $rootScope.instPluginStream.drawViewers(vwT,function(response) {},function(error) {});
                  }
                  $timeout(function() {
                    $scope.updateViewers();
                  }, 5000);
                }, function(error) {
                  $timeout(function() {
                    $scope.updateViewers();
                  }, 5000);
                })
              //AFTER CREATE BROADCAST CALL THE PLUGIN END
            } else {
              return true;
            }
          } else {
            return true;
          }
        }
      //

      //FUNCTION TO UPDATE BANNERS
        $scope.shwBanners = function () {
          if($rootScope.instPluginStream) {
            if($rootScope.data.streamId) {
              var banToShow = $scope.bannerList[$scope.stepBanners];
              //PREPARE PLUGIN CALL
                $rootScope.instPluginStream.drawBanners(banToShow,function(response) {},function(error) {});
              //
              if($scope.stepBanners === $scope.bannerList.length) {
                $scope.stepBanners=0;
              } else {
                $scope.stepBanners++;
              }
              $timeout(function() {
                $scope.shwBanners();
              }, 5000);
            } else {
              return true;
            }
          } else {
            return true;
          }
        }
      //
      
      $scope.chkMp4Url = function () {
        //$rootScope.data.mp4Url
        var xhr = new XMLHttpRequest();
        //process to bypass cache Math.floor(Math.random() * 1000);
        var newUrl = $rootScope.data.mp4Url;
        xhr.open('GET', newUrl, true);
        xhr.responseType = 'json';
        xhr.onload = function() {
          var status = xhr.status;
          console.log("XHR", xhr)
          if (status = 200) {
            // continue proccess
            $scope.finishStreamingIOS();
          } else {
            //go out without doing anything
          }
        };

        xhr.send();
      }

      $scope.deleteSequence = function(seqId) {
        SequenceService.deleteSequence({
          objectId: seqId
        }).post().$promise.then(function(onDeleteOk) {}, function(onDeleteError) {
          console.error("Wasn't able to delete sequence");
        });
      }

      $scope.addSeqToPendingLog = function(addSeqResponse) {
        SequenceService.addPostToPendingLogv200({
          sequenceId: addSeqResponse.result.links["0"].href.split('/')[6],
          userSubs: userId
        }).$promise.then(function(responseAddPending) {
          console.log("Added to PENDING LOG");
        }, function(error) {
          if (error && (error.status === 504 || error.status === -1)) {
            console.log("We don't care");
          } else {
            console.log("fallo");
            $scope.deleteSequence(Utils.getLastUrlComponent(addSeqResponse.result.links["0"].href));
          }
        });
      }

      $scope.addSequenceItem = function(addSeqResponse) {
        //NEW METHOD 
          var photoProfile = photoProfile = window.localStorage.getItem("photoProfileBlob") !== null ? window.localStorage.getItem("photoProfileBlob") : defaultThumbnail;
           //$rootScope.infoForPost.pictures ? $rootScope.infoForPost.pictures : ();
          $scope.sequenceIdForUpdate = addSeqResponse.result.links["0"].href.split('/')[6];
          if($rootScope.infoForPost.pictures) {
            var userSubscriptionInstanceId = Utils.md5.createHash(userId.toString());
            var sequenceInstanceId = Utils.md5.createHash(Utils.getLastUrlComponent(addSeqResponse.result.links["0"].href));
            var photoThumbKey = s3.prefix + '/' + userSubscriptionInstanceId + '/sequence/' + sequenceInstanceId + '/thumb/1.jpg';
            var fileThumb = Utils.dataURLtoBlob($rootScope.infoForPost.pictures);
            if (fileThumb.mediaType) {
              fileThumb.file = fileThumb.mediaType;
            }
            var uploadPromises = [];
            uploadPromises[0] = Utils.$q(function(resolve, reject) {
              s3Service.upload({
                Key: photoThumbKey,
                Body: fileThumb,
                ACL: 'public-read',
                ContentType: fileThumb.type ? fileThumb.type : fileThumb.mediaType
              }, function(err, data) {
                if (err) {
                  console.log('There was an error uploading the image: ', err);
                  reject(err)
                } else
                  resolve(data)
              });
            });
            Utils.$q.all(uploadPromises).then(function(resolvedUploads) {
              Object.keys(uploadPromises).forEach( function (it) {
                if (resolvedUploads[0]){
                  if (resolvedUploads[0].Location){
                    var haveValid = resolvedUploads[0].Location.indexOf(".jpg");
                    if (haveValid === -1) {
                      $scope.addItemVideo(addSeqResponse, photoProfile);
                    } else {
                      photoProfile = resolvedUploads[0].Location
                      $scope.addItemVideo(addSeqResponse, photoProfile);
                    }
                  } else {
                    $scope.addItemVideo(addSeqResponse, photoProfile);
                  }
                }else{
                  $scope.addItemVideo(addSeqResponse, photoProfile);
                }
              })
            })
          } else {
            $scope.addItemVideo(addSeqResponse, photoProfile);
          }
      }

      $scope.addItemVideo = function (addSeqResponse, imageUrl) {
        SequenceService.addItemToSequencev181().save({
          "sequence": { "value": { "href": addSeqResponse.result.links["0"].href } },
          //"uRLPicture": { "value": $rootScope.data.mp4Url },
          "uRLPicture": { "value": $rootScope.data.hlsUrl },
          "itemId": { "value": 1 },
          "uRLThumbPicture": { "value": imageUrl }
        }).$promise.then(function(addItemResp) {
          $rootScope.data.seqItemId = Utils.getLastUrlComponent(addItemResp.result.links["0"].href);
          $scope.addSeqToPendingLog(addSeqResponse);
          $scope.markAsStreamingSequence(Utils.getLastUrlComponent(addSeqResponse.result.links["0"].href));
        }, function(error) {
          console.log('Error ', error);
          $scope.deleteSequence(Utils.getLastUrlComponent(addSeqResponse.result.links["0"].href));
        });
      }

      $scope.addSequence = function() {
        SequenceService.addSequenceV202({
          userId: userIDAds,
          description: $rootScope.infoForPost.commentValue === "" ? " " : $rootScope.infoForPost.commentValue,
          templateId: 'templateVideo',
          itemCount: 1,
          sequenceType: 3, //Video
          commentsEnabled: true,
          temporary: 0,
          shareable: true,
          sharelife: 0,
          isAdvertisement: $scope.iAmAdvertiser,
          headerBgColor: $scope.seqData.selectedBgColor,
          headerFontColor: $scope.seqData.selectedFontColor,
          finalDate: new Date(),
          title: $rootScope.infoForPost.sequenceTitle === "" ? " " : $rootScope.infoForPost.sequenceTitle,
          url: ' '
        }).$promise.then(function uploadSequenceVideo(addSeqResponse) {
          //$scope.sendPushNotifStream();
          $scope.beginShowMessagesPrev(addSeqResponse);
          $scope.addSequenceItem(addSeqResponse);
          //PUSH NOTIF
            $scope.sendLiveStreamingPushNotification(addSeqResponse);
          //PUSH NOTIF END
        }, function errorCreate(error) {
          console.log('Error', error);
        });
      }

      $scope.markAsStreamingSequence = function(seqId) {
        StreamingService.updateStraeaming(seqId).$promise.then(function(response) {
          console.log('Marked as Streaming Sequence');
        }, function(error) {
          console.log('Mark As Streaming Sequence Error: ', error);
        });
      }

      $scope.makeVideoAsPublic = function(videoKey) {
        s3Service.putObjectAcl({
          Key: videoKey,
          ACL: 'public-read'
        }, function(err, data) {
          if (err)
            console.log('There was an error: ', err);
          else{
            console.log('Public Video');
            $scope.makeVideoAsPublic(videoKey);
          }
        });
      }

      $scope.updateUrlStream = function () {
        var videoKey = 'streams/' + $rootScope.data.streamId + '.mp4';
        StreamingService.updateVideoPostStream({
          sequenceId: $scope.sequenceIdForUpdate,
          url: $rootScope.data.mp4Url
        }).$promise.then(function (response) {

        }, function(error){
          console.log('Error ', error);
        })
      }

      $scope.messagesSavedNo = 0;
      $scope.messagesCount = 5;
      $scope.messagesList = [];
      $scope.beginShowMessagesPrev = function (postInfo) {
        if($scope.isAndroid = ionic.Platform.isAndroid()) {
          $rootScope.instPluginStream.commentListShow(true,function(response) {},function(error) {});
          $scope.beginShowMessages(postInfo);  
        } else {
          $scope.beginShowIosMessages(postInfo);
        }
      }

      $scope.beginShowMessages = function (postInfo) {
        var pivot = JSON.parse(window.localStorage.getItem('AppsPerzonalized'));
        var pivotNum = +pivot.timerRefreshMsgStream;
        if($rootScope.instPluginStream) {
          if($rootScope.data.streamId) {
            //CALL TO WS BALA
              cqnzService.getCommentsOfSequenceWS({
                sequenceId: postInfo.result.instanceId,
                start: $scope.messagesSavedNo,
                count: $scope.messagesCount,
                groupId: "0" //$scope._groupHrefId
              }).$promise.then(function (comments) {
                Utils.removeLastItemIfHasNoAttribute(comments, 'sequenceComments');
                var totalParentsFetched = comments.length;
                if(!totalParentsFetched) {
                  /*var username = "Yo"+Math.floor(Math.random() * 1000 );
                  var content = ""+Math.floor(Math.random() * 1000 ); 
                  var data = {
                    "avatar": "http://s3-us-west-2.amazonaws.com/media.dev.niido.cloud/d/c4ca4238a0b923820dcc509a6f75849b/04f551d920dc4ba9ae045a0f3248c456/small643.jpg",
                    "username": username,
                    "content": content
                  }
                  $scope.messagesList.push(data);
                  $rootScope.instPluginStream.commentList(
                    $scope.messagesList,
                    function(response) {
                      console.log("message added");
                    },
                    function(error) {
                      console.error("message failed")
                    }
                  );*/
                  $timeout(function() {
                    $scope.beginShowMessages(postInfo);
                  }, pivotNum);
                } else {
                  var totalChildResolved = 0;
                  comments.forEach(function (comment) {
                    var parentComment = {
                      "avatar": comment.profilePictureUrl,
                      "username": comment.name,
                      "content": comment.comment
                    }
                    parentComment.responses = [];
                    $scope.messagesList.push(parentComment);
                    totalChildResolved++;
                    //PREPARE PLUGIN CALL
                      $rootScope.instPluginStream.commentList(
                        $scope.messagesList,
                        function(response) {
                          console.log("message added");
                        },
                        function(error) {
                          console.error("message failed")
                        }
                      );
                    //
                    if (totalParentsFetched === totalChildResolved) {
                      $scope.messagesSavedNo = $scope.messagesList.length;
                      $timeout(function() {
                        $scope.beginShowMessages(postInfo);
                      }, pivotNum);
                      //PREPARE PLUGIN CALL
                        //$rootScope.instPluginStream.getMsgs(parentComment,function(response) {},function(error) {});
                      //
                    }
                  });
                }
              })
            //CALL TO WS END 
          } else {
            return true;
          }
        } else {
          return true;
        }
      }

      $scope.questionsIOS = {};
      $scope.indexIOS = 0;
      $scope.beginShowIosMessages = function (postInfo) {
        var pivot = JSON.parse(window.localStorage.getItem('AppsPerzonalized'));
        var pivotNum = +pivot.timerRefreshMsgStream;
        if($rootScope.instPluginStream) {
          if($rootScope.data.streamId) {
            //CALL TO WS BALA
            cqnzService.getCommentsOfSequenceWS({
              sequenceId: postInfo.result.instanceId,
                start: $scope.messagesSavedNo,
                count: $scope.messagesCount,
                groupId: "0" //$scope._groupHrefId
              }).$promise.then(function (comments) {
                Utils.removeLastItemIfHasNoAttribute(comments, 'sequenceComments');
                var totalParentsFetched = comments.length;
                if(!totalParentsFetched) {
                  /*var username = "Yo"+Math.floor(Math.random() * 10000000000 );
                  var content = ""+Math.floor(Math.random() * 10000000000000000000 );
                  var finalPackage = null;
                  var msgToSend = null;
                  msgToSend = {
                    questions:[{
                      image_url: "http://s3-us-west-2.amazonaws.com/media.dev.niido.cloud/d/c4ca4238a0b923820dcc509a6f75849b/04f551d920dc4ba9ae045a0f3248c456/small643.jpg",
                      from: username,
                      question: content
                    }]
                  };
                  $rootScope.instPluginStream.addQuestionsToList(
                    (results) => {
                      console.log('Success addQuestionsToList: ' + results);
                    },
                    (error) => {
                      console.log('Error addQuestionsToList: ' + error);
                    },
                    msgToSend
                  )*/
                  $timeout(function() {
                    $scope.beginShowIosMessages(postInfo);
                  }, pivotNum);
                } else {
                  var totalChildResolved = 0;
                  comments.forEach(function (comment) {
                    var finalPackage = null;
                    var msgToSend = null;
                    msgToSend = {
                      questions:[{
                        image_url: comment.profilePictureUrl,
                        from: comment.name,
                        question: comment.comment
                      }]
                    };
                    $scope.messagesList.push(msgToSend);
                    totalChildResolved++;
                    $rootScope.instPluginStream.addQuestionsToList(
                      (results) => {
                        console.log('Success addQuestionsToList: ' + results);
                      },
                      (error) => {
                        console.log('Error addQuestionsToList: ' + error);
                      },
                      msgToSend
                    )
                    if (totalParentsFetched === totalChildResolved) {
                      $scope.messagesSavedNo = $scope.messagesList.length;
                      $timeout(function() {
                        $scope.beginShowIosMessages(postInfo);
                      }, pivotNum);
                      //PREPARE PLUGIN CALL
                        //$rootScope.instPluginStream.getMsgs(parentComment,function(response) {},function(error) {});
                      //
                    }
                  })
                }
              })
            //CALL TO WS END
          }
        } else {
          return true;
        }
      }
    }
  ])

  .controller('addStreamInfoCtrl', ['$rootScope', '$scope', '$timeout', 'UserService', 'SequenceService', 'cqnzService', 'notificationsService', 'ApiEndPoint', '$q', '$state', 'ionicService', 'locals', 'adsService', '$ionicPickerI18n', 'permissionValidationService', 'TagsService', 'Utils', 'ImageService2', 'FileService2',
    function($rootScope, $scope, $timeout, UserService, SequenceService, cqnzService, notificationsService, ApiEndPoint, $q, $state, ionicService, locals, adsService, $ionicPickerI18n, permissionValidationService, TagsService, Utils, ImageService2, FileService2) {

      //////////////////////////////////////////////
        $scope.data = {};
        $scope.data.streamData = {
          sequenceTitle: "",
          mentionsTitleList: [],
          compareMTL: [],
          hashTitleList: [],
          compareHTL: [],
          commentValue: "",
          mentionsCommList: [],
          compareMCL: [],
          hashCommList: [],
          compareHCL: [],
          userName: locals.userName,
          pictures: null,
          deleteList: [],
          showTitle: locals.showTitle,
          showDescr: locals.showDescr
        }
        $scope.isIOS = ionic.Platform.isIOS();
        $scope.isAndroid = ionic.Platform.isAndroid();
        $scope.galleryIsOpen = false;
        $scope.processImg = false;
      //////////////////////////////////////////////

      $scope.closeDialog = function() {
        locals.dialog.hide(null);
      };

      $scope.openTitleEdit = function() {
        var dialogTE = Utils.alert.getCtrl();
        dialogTE.show({
          templateUrl: 'templates/partials/tags-modal.html',
          controller: 'tagsModalCtrl',
          locals: {
            description: $scope.data.streamData.sequenceTitle,
            tagsList: $scope.data.streamData.mentionsTitleList,
            hash: $scope.data.streamData.hashTitleList,
            plusLength: true,
            isTitle: true,
            dialog: dialogTE,
            needSearch: false
          },
          clickOutsideToClose: false,
          multiple: true,
          fullscreen: true // Only for -xs, -sm breakpoints.
        }).then(function(resp) {
          $scope.data.streamData.sequenceTitle = resp.description;
          $scope.data.streamData.mentionsTitleList = resp.savedTags;
          $scope.data.streamData.hashTitleList = resp.savedHashes;
        });
      }

      $scope.openDescrEdit = function() {
        var dialogDE = Utils.alert.getCtrl();
        dialogDE.show({
          templateUrl: 'templates/partials/tags-modal.html',
          controller: 'tagsModalCtrl',
          locals: {
            description: $scope.data.streamData.commentValue,
            tagsList: $scope.data.streamData.mentionsCommList,
            hash: $scope.data.streamData.hashCommList,
            plusLength: true,
            isTitle: true,
            dialog: dialogDE,
            needSearch: false
          },
          clickOutsideToClose: false,
          multiple: true,
          fullscreen: true // Only for -xs, -sm breakpoints.
        }).then(function(resp) {
          $scope.data.streamData.commentValue = resp.description;
          $scope.data.streamData.mentionsCommList = resp.savedTags;
          $scope.data.streamData.hashCommList = resp.savedHashes;
        });
      }

      $scope.checkPermissions = function() {
        if ($scope.isIOS === true) {
          $scope.addMedia();
        } else {
          getMultiplePermissions();
        }
      }

      function getMultiplePermissions() {
        cordova.plugins.diagnostic.getPermissionsAuthorizationStatus(function(statuses) {
          var havePerm = 0;
          var deniedPerm = false;
          for (var permission in statuses) {
            switch (statuses[permission]) {
              case cordova.plugins.diagnostic.permissionStatus.GRANTED:
                console.log("Permission granted to use " + permission);
                havePerm++;
                break;
              case cordova.plugins.diagnostic.permissionStatus.NOT_REQUESTED:
                console.log("Permission to use " + permission + " has not been requested yet");
                havePerm--;
                break;
              case cordova.plugins.diagnostic.permissionStatus.DENIED:
                console.log("Permission denied to use " + permission + " - ask again?");
                havePerm--;
                break;
              case cordova.plugins.diagnostic.permissionStatus.DENIED_ALWAYS:
                console.log("Permission permanently denied to use " + permission + " - guess we won't be using it then!");
                deniedPerm = true;
                break;
            }
          }
          if (!deniedPerm) {
            if (havePerm == 2) {
              //have both permissions granted
              $scope.addMedia();

            } else if (havePerm < 2) {
              //both or one permission hasn't granted
              askMultiplePermissions();
            }
          } else {
            Utils.toast.error(Utils.translate('PLUGINS.PERMISSIONS.DENIED_PERMISSION') +
              Utils.translate('PLUGINS.PERMISSIONS.TYPE.CAMERA') + ' ' +
              Utils.translate('PLUGINS.PERMISSIONS.AND') + ' ' +
              Utils.translate('PLUGINS.PERMISSIONS.TYPE.GALLERY') + '. \n' +
              Utils.translate('PLUGINS.PERMISSIONS.ALWAYS_DENIED_PERMISSION'));
          }
        }, function(error) {
          console.error("The following error occurred: " + error);
        }, [
          cordova.plugins.diagnostic.permission.CAMERA,
          cordova.plugins.diagnostic.permission.READ_EXTERNAL_STORAGE
        ])
      }

      function askMultiplePermissions() {
        cordova.plugins.diagnostic.requestRuntimePermissions(function(statuses) {
          var havePerm = 0;
          var deniedPerm = false;
          for (var permission in statuses) {
            switch (statuses[permission]) {
              case cordova.plugins.diagnostic.permissionStatus.GRANTED:
                console.log("Permission granted to use " + permission);
                havePerm++;
                break;
              case cordova.plugins.diagnostic.permissionStatus.NOT_REQUESTED:
                console.log("Permission to use " + permission + " has not been requested yet");
                havePerm--;
                break;
              case cordova.plugins.diagnostic.permissionStatus.DENIED:
                console.log("Permission denied to use " + permission + " - ask again?");
                havePerm--;
                break;
              case cordova.plugins.diagnostic.permissionStatus.DENIED_ALWAYS:
                console.log("Permission permanently denied to use " + permission + " - guess we won't be using it then!");
                deniedPerm = true;
                break;
            }
          }
          if (!deniedPerm) {
            if (havePerm == 2) {
              //have both permissions granted
              $scope.addMedia();
            } else if (havePerm < 2) {
              //both or one permission hasn't granted
              Utils.toast.error(Utils.translate('PLUGINS.PERMISSIONS.DENIED_PERMISSION') +
                Utils.translate('PLUGINS.PERMISSIONS.TYPE.CAMERA') + ' ' +
                Utils.translate('PLUGINS.PERMISSIONS.AND') + ' ' +
                Utils.translate('PLUGINS.PERMISSIONS.TYPE.GALLERY') + '.');
            }
          } else {
            Utils.toast.error(Utils.translate('PLUGINS.PERMISSIONS.DENIED_PERMISSION') +
              Utils.translate('PLUGINS.PERMISSIONS.TYPE.CAMERA') + ' ' +
              Utils.translate('PLUGINS.PERMISSIONS.AND') + ' ' +
              Utils.translate('PLUGINS.PERMISSIONS.TYPE.GALLERY') + '. \n' +
              Utils.translate('PLUGINS.PERMISSIONS.ALWAYS_DENIED_PERMISSION'));
          }
        }, function(error) {
          console.error("The following error occurred: " + error);
        }, [
          cordova.plugins.diagnostic.permission.CAMERA,
          cordova.plugins.diagnostic.permission.READ_EXTERNAL_STORAGE
        ])
      }

      $scope.addMedia = function() {
        $scope.galleryIsOpen = true;
        $scope.data.streamData.pictures = null;
        ImageService2.saveAlbumMediaStreamPhoto(1).then(function() {
          $scope.galleryIsOpen = false;
          $scope.processImg = true;
        });
      };

      $rootScope.$on("addedImageStream", function() {
        console.log("finally");
        showImagePost();
      })

      function showImagePost() {
        //begin the image functions
        var img = FileService2.images();
        var exifTemp = FileService2.exifImage();
        if (img.length === 0) { //ask again in 1 sec
          $timeout(function() {
            showImagePost();
          }, 1000);
        } else {
          if ($scope.isIOS === true) {
            Utils.loading.show();
            var photosProcessed = 0;
            img.forEach(function(oneImage, index, photoPck) {
              $scope.data.streamData.pictures = oneImage;
              $scope.data.streamData.deleteList =true;
              photosProcessed++;
              console.log(photosProcessed + " from " + photoPck.length);
              if (photosProcessed === photoPck.length) {
                Utils.loading.hide();
              }
            })
            $timeout(function() {
              $scope.apply();
              $scope.processImg = false;
            }, 0)
          } else {
            Utils.loading.show();
            var photosProcessed = 0;
            img.forEach(function(oneImage, index, photoPck) {
              photosProcessed++;
              if (oneImage.uri) {
                loadingPhotos(oneImage.uri, photosProcessed, photoPck.length);
              } else {
                loadingPhotos(oneImage, photosProcessed, photoPck.length);
              }
            })
          }
        }
      }

      function loadingPhotos(paths, step, end) {
        var canvas;
        var ctx;
        var dataURL;
        var num = 0;
        var img = new Image();
        img.crossOrigin = 'Anonymous';
        img.onload = function() {
          canvas = document.createElement('CANVAS');
          ctx = canvas.getContext('2d');
          canvas.height = this.height;
          canvas.width = this.width;
          ctx.drawImage(this, 0, 0);
          dataURL = canvas.toDataURL("image/jpeg", 1.0);
          $scope.data.streamData.pictures = dataURL;
          $scope.data.streamData.deleteList =true;
          $scope.$apply();
          console.log(step + " from " + end);
          if (step === end) {
            Utils.loading.hide();
        $scope.processImg = false;
          }
        };
        img.src = paths;
      }

      $scope.addStatement = function () {
        locals.dialog.hide($scope.data.streamData);
      }

    }
  ])
;

/**
 * @typedef {Object} messageComposerFormType
 * @property {string} description
 * @property {{name:string, id:number}} savedTags
 * @property {{hash:string, id:number}} savedHashes
 * @property {string} imagePath
 */
