"use strict";

appControllers
	.controller("inReviewCtrl", ['$rootScope', '$scope', '$state', 'Utils', 'SequenceService','UserService','cqnzService','SequenceFactory','permissionValidationService','notificationsService',
		function ($rootScope, $scope, $state, Utils, SequenceService, UserService,cqnzService,SequenceFactory,permissionValidationService,notificationsService) {

			//-----------BASIC DATA------------------
			var myUserId = UserService.get_USERSUBSCRIPTIONINSTANCE_ID();
			$scope.allowedManageInReview = permissionValidationService.canManageInReviewPosts();
			//-- All scope variables are shared with SequenceCtrl but these are the more relevant ones--------
			$scope._controllerName = "inReviewCtrl";
		    $scope._groupHrefId = 0;//Default timeline
		    $scope._sequenceList = [];

		    var pagination = {
		    	start: 0,
		        count: 5
		    };
		    $scope.canGetMoreItems = true;
		    $scope.isRefreshing = false;
		    $scope.isLoadingContent = false;
		    $scope.errorLoading = false;
		    $scope.titlePage = "InReview Post";

		    $scope.$on("$ionicView.enter", function () {
        		$scope.canGetMoreItems = true;
    		});

    		$scope.$on("$ionicView.beforeLeave", function () {
    			$scope.canGetMoreItems = false;
    		});

    		$scope.getmoreInReviewPosts = function () {
    			$scope.isFirstTime = false;

    			if ($scope.isLoadingContent) return;

    			$scope.isLoadingContent = true;

    			SequenceService.findPostsWithInReviewStatus({
    				start: pagination.start,
    				count: pagination.count
    			}).$promise.then(function(inReviewList) {
    				Utils.removeLastItemIfHasNoAttribute(inReviewList, 'sequence');

    				$scope.canGetMoreItems = inReviewList.length > 0;

    				if (!inReviewList.length) {
		              $scope.isRefreshing = false;
		              $scope.isLoadingContent = false;

		              $scope.$broadcast('scroll.refreshComplete');
		              $scope.$broadcast('scroll.infiniteScrollComplete');
		              return;
		            }

		            pagination.start += inReviewList.length;
            		pagination.count += 3;

            		/*var cqnzIdsList = inReviewList.map(function (data) {
            			return data.sequence.title;
            		});*/
            		inReviewList.forEach(function (sequenceInfo) {
            			complementHashtagCqnzData(sequenceInfo);
          			});

            		setTimeout(function () {
		              $scope.isRefreshing = false;
		              $scope.isLoadingContent = false;

		              $scope.$broadcast('scroll.refreshComplete');
		              $scope.$broadcast('scroll.infiniteScrollComplete');
		            }, 1500);
    			}, function (error){
    				console.log("getPostsInReviewStatus", error);
		            $scope.canGetMoreItems = false;
		            $scope.errorLoading = true;

		            $scope.isRefreshing = false;
		            $scope.isLoadingContent = false;

		            $scope.$broadcast('scroll.refreshComplete');
		            $scope.$broadcast('scroll.infiniteScrollComplete');
    			})
    		};

    		function complementHashtagCqnzData(sequenceIdAndGroups) {
    			var data = SequenceService.findSequenceBySequenceIdV181(sequenceIdAndGroups.sequenceId).$promise;
    			//Ws called to check if the sequence have any tags in title
    			var listTags = SequenceService.obtainTagwithIdandTypev166({
		          sequenceId: sequenceIdAndGroups.sequenceId,
		          notificationType: 7
		        });
    			//Ws called to check if the sequence have any hashtags in title
            //LuMa HashTags in sequence
		        //var hashesList = SequenceService.getHashFromSequence(sequenceIdAndGroups.sequenceId);
            var hashesList = SequenceService.findSequenceHashTagComment({
              sequenceId: sequenceIdAndGroups.sequenceId,
              notificationType: 7,
              commentId: 0
            });

		        Utils.$q.all({
		        	basicData: data,
		        	tagsList: listTags,
		          	hashesList: hashesList
		        }).then(function(inReviewPost){
		        	Utils.removeLastItemIfHasNoAttribute(inReviewPost.basicData, 'sequence');
		        	inReviewPost.basicData = inReviewPost.basicData[0];
		        	inReviewPost.sequenceOwnerId = Utils.getLastUrlComponent(inReviewPost.basicData.userSubscriptionId.href);
		          	inReviewPost.sequenceItems = cqnzService.getItemsToSequenceV165WS(inReviewPost.basicData.sequenceId);
		          	inReviewPost.followEachOther = myUserId == inReviewPost.sequenceOwnerId ? {result: {value: true}} : SequenceService.followEachOther({
			        	userId: myUserId,
			            friendId: inReviewPost.sequenceOwnerId
			        });
			        inReviewPost.viewsCounter = inReviewPost.basicData.isAdvertisement && inReviewPost.sequenceOwnerId == myUserId ? adsService.getViewsCount(inReviewPost.basicData.sequenceId) : null;
		          	inReviewPost.clicksCounter = inReviewPost.basicData.isAdvertisement && inReviewPost.sequenceOwnerId == myUserId ? adsService.getClicksCount(inReviewPost.basicData.sequenceId) : null;
                inReviewPost.URLClicksCounter = inReviewPost.basicData.isAdvertisement && inReviewPost.sequenceOwnerId == myUserId ? adsService.getURLClicksCount(inReviewPost.basicData.sequenceId) : null;
		          	inReviewPost.basicData.sequenceCommentCount = 0;

		          	var cqnz = SequenceFactory.buildSequenceObject(inReviewPost);
		          	$scope._sequenceList.push(cqnz);
		        })
      		};

		    $scope.refreshHashtagTimeline = function () {
        		$scope.errorLoading = false;
        		$scope.isRefreshing = true;
        		pagination.start = 0;
        		pagination.count = 2;
        		$scope._sequenceList = [];
        		$scope.$broadcast('scroll.refreshComplete');
        		$scope.$broadcast('scroll.infiniteScrollComplete');
        		Utils.$ionicScrollDelegate.resize();
        		$scope.canGetMoreItems = true;

        		notificationsService.countPendingRegularNotifications(UserService.get_USER_INSTANCE_HREF());
        		notificationsService.countPendingFollowersNotifications(UserService.get_USER_INSTANCE_HREF());
      		};



      		$scope.deletePost = function (sequence) {
      			if(!$scope.allowedManageInReview)
      				return;

      			Utils.confirm.show(Utils.translate('SEQUENCE.DIALOG.DELETE_CQNZ_CONF')).then(function (boolResp) {
      				if (!boolResp) return;

      				Utils.loading.show();
      				sequence.deleteMe().then(function () {
                  $scope.refreshHashtagTimeline();
            			Utils.loading.hide();
          			}, function (error) {
            			Utils.loading.hide();
          			})
      			})
      		};

      		$scope.allowPost = function (sequence) {
      			if(!$scope.allowedManageInReview)
      				return false;
      			Utils.confirm.show(Utils.translate('INREVIEW.ACCEPT_DIALOG')).then(function (boolResp) {
      				if (!boolResp) return;

      				Utils.loading.show();
      				SequenceService.changePostStatusToActive(sequence.metadata.instanceId).then(function(){
      					console.log("done it!!");
      					$scope.refreshHashtagTimeline();
      					Utils.loading.hide();
      				}, function (error){
      					console.log("Failed");
      					Utils.loading.hide();
      				});
      			})
      		};
		}]);
